<?php

include( $_SERVER['DOCUMENT_ROOT'] . "/include/inc.php" );

$page = isset($_GET['page']) ? $_GET['page'] - 1 : 0;
$count = isset($_GET['count']) ? $_GET['count'] : 10;

header('Content-Type: application/json');


/*
	
	id : 0,
	about : "",
	num_serial : "",
	is_ok : 0,
	type : new IMETER_TYPE(),
	meter : new METER(),

*/

$fields = isset($_GET['get_pages']) ? " count(*) as count " :"meter.id,
meter.about,
meter.num_serial,
meter.is_ok,
meter.meter_extra_type_id,
meter.timezone_id,
meter_real.id as meter_id,
meterparameter.meter_id as mtp_meter_id,
meterparameter.parameter_id as mtp_parameter_id,
meterparameter.virtual_parameter_id as mtp_v_parameter_id
";

$sql = Utils::Strip("
select {$fields} from meter 
left join converter on converter.id = meter.converter_id 
right join meterparameter on meterparameter.virtual_meter_id = meter.id 
left join meter as meter_real on meter_real.id = meterparameter.meter_id 
left join meter_extra_type  on meter_extra_type.id = meter.meter_extra_type_id 
where meter.interprise = " . Self()->Interprise->Id . " 
and meter.converter_id > 0 ");


if( !empty($_GET['types']) ){
	$sql .= " and meter.meter_extra_type_id in(" . implode(",",$_GET['types']) .")" ;
}

if( !empty($_GET['is_ok']) ){
	$sql .= " and meter.is_ok in(" . implode(",",$_GET['is_ok']) .")" ;
}


if( !isset($_GET['get_pages']) ){
	$sql .= " LIMIT ".($page*$count).",{$count}";
}


$res = DB::Select($sql );

if( isset($_GET['get_pages']) ){
	$row = DB::Fetch($res);
	echo ceil( $row['count'] / $_GET['get_pages'] );
	die();
}

$ret = array();

while( $row = DB::Fetch($res) ){
	$ret[] = array(
		'id' 									=> (int) $row['id'],
		'about' 							=> $row['about'],
		'is_ok' 							=> (int) $row['is_ok'],
		'meter_extra_type_id' => (int) $row['meter_extra_type_id'],
		'meter' 							=> (int) $row['meter_id'],
		'num_serial' 					=> $row['id'],
		"timezone" 						=> (int) $row['timezone_id'],
		"date_first_verification" 		=> meter::Id( $row['id'] )->GetFirstVerification(),
		"date_verification_interval" 	=> meter::Id( $row['id'] )->GetVerificationInterval(),
		"number_plomb" 								=> meter::Id( $row['id'] )->GetNumberPlomb(),
		'meterparameter' => array(
			'id' => (int) $row['mtp_meter_id'],
			'parameter' => array(
				'id' => (int) $row['mtp_parameter_id'],
				'title' => parameter::Id($row['mtp_parameter_id'])->Title,
				'ident' => parameter::Id($row['mtp_parameter_id'])->Ident,
			),
			'vparameter' => array(
				'id' => (int) $row['mtp_v_parameter_id'],
				'title' => parameter::Id($row['mtp_v_parameter_id'])->Title,
				'ident' => parameter::Id($row['mtp_v_parameter_id'])->Ident,
			),
		)
	);
}

// var_dump(count($ret) );

if( count($ret) == 0 && $_GET['page'] != 0 ){
	$_GET['page'] = $_GET['page']-1;
	include(__FILE__);
}else{
	echo json_encode( $ret , JSON_UNESCAPED_UNICODE );
}
