<?php

include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

if( !Self()->Is ){
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    Site()->GoToAuth();
  }else{
    echo "404"; 
    return false;
  }
}

header('Content-Type: application/json; charset=utf-8');

$start_year = 0;
$start_month = 0;
$start_day = 0;

$stop_year = 0;
$stop_month = 0;
$stop_day = 0;

$parameter = 0;

$range = "hours";

foreach( explode( ";" , $_GET['filter'] ) as $block ){
  $r = explode(':',$block);
  switch( $r[0] ){
    case 'meter' :
      $oMeter = meter::Id($r[1]);
      break;
    case 'start_year' :
      $start_year = $r[1];
      break;
    case 'start_month' :
      $start_month = $r[1];
      break;
    case 'start_day' :
      $start_day = $r[1];
      break;
    case 'stop_year' :
      $stop_year = $r[1];
      break;
    case 'stop_month' :
      $stop_month = $r[1];
      break;
    case 'stop_day' :
      $stop_day = $r[1];
      break;
    case 'parameter' :
      $parameter = $r[1];
      break;
    case 'range' :
      $range = $r[1];
      break;
  }
}

if( !$start_year ){

}else{
  $_POST['date_start'] = $start_year."-".str_pad( $start_month , 2 , "0",STR_PAD_LEFT)."-".str_pad( $start_day , 2 , "0",STR_PAD_LEFT);
  $_GET['start'] = $start_year.str_pad( $start_month , 2 , "0",STR_PAD_LEFT).str_pad( $start_day , 2 , "0",STR_PAD_LEFT);


  $_POST['date_stop'] = $stop_year."-".str_pad( $stop_month , 2 , "0",STR_PAD_LEFT)."-".str_pad( $stop_day , 2 , "0",STR_PAD_LEFT);
  $_GET['stop'] = $stop_year.str_pad( $stop_month , 2 , "0",STR_PAD_LEFT).str_pad( $stop_day , 2 , "0",STR_PAD_LEFT);

  $_POST['range_data'] = $range;
}

function GetToJSON( &$oObject , $callback_even = null ){
  
  $fields = array();
  if( isset( $oObject->FieldsToJSON ) ){
    $fields = $oObject->FieldsToJSON;
  }  
  
  $res = array();
  
  foreach( $fields as $F => $f ){
    if( is_object( $oObject->$F ) ){
      $res[ $f ] = (int) $oObject->$F->Id;
      continue;
    }
    
    $v = $oObject->$F;
    
    if( isset( $oObject::$FInit[$F] ) ){
      switch( $oObject::$FInit[$F]['type'] ){
        case 'id':
        case 'int' :
           $v = (int) $v;
        break;
      }
    }
    $res[ $f ] = $v;
  }
  
  if($callback_even) $res = $callback_even( $oObject , $res );
  
  return $res;
}

$res = array();
if( $range == "hours" ){
  $oMeter->PreSetCacheArchiveHoursSource();
  while( $Row = DB::Fetch( $oMeter->CacheArchiveHoursSource ) ){
    $MDH = meterdatahour::SetFieldsFromObject( $Row );
    $res[] = GetToJSON( $MDH );
  }
}else{
  $oMeter->PreSetCacheArchive();
  while( $Row = DB::Fetch( $oMeter->CacheArchiveSource ) ){
    $MDH = meterdatahour::SetFieldsFromObject( $Row );
    $res[] = GetToJSON( $MDH );
  }
}

echo json_encode($res);