<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

if( !Self()->Is ){
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    Site()->GoToAuth();
  }else{
    echo "404"; 
    return false;
  }
}

header('Content-Type: application/json; charset=utf-8');


$oMeter = meter::Id((int) $_GET['id']);


if( !$oMeter->Is && isset( $_POST['_method'] ) ){

  switch( $_POST['_method'] ){
    case "PUT" :
      $model = json_decode($_POST['model']);

      $type = metertype::Id(0);

      if( property_exists($model, 'type_string') ){
        $meter_type_filter = array(
          'Filter' => array(
            'Title' => $model->type_string
          )
        );
        $typeRes = metertype::Filter( $meter_type_filter );
        if( $typeRes->Count ){
          $type = $typeRes->First;
        }
      }


      $oMeter = meter::AddByArray(array(
        'ConverterId' => $model->converter_id,
        'NumSerial' => $model->num_serial,
        'TypeId' => $type->Id,
        'IsOk' => true,
        'About' => $model->about,
        'InterpriseId' => Self()->Interprise->Id,
      ));
    break;
  }

}elseif( $oMeter->Is && isset( $_POST['_method'] ) ){
  switch( $_POST['_method'] ){
    case "DELETE" :
      $oMeter->DeleteFull();
      TObject2::CleanAllObjects();
      $oMeter = meter::Id((int) $_GET['id']);
    break;
    case "PUT" :
      $model = json_decode($_POST['model']);

      $type = metertype::Id(0);

      if( property_exists($model, 'meter_type_title') ){
        $meter_type_filter = array(
          'Filter' => array(
            'Title' => $model->meter_type_title
          )
        );
        $typeRes = metertype::Filter( $meter_type_filter );
        if( $typeRes->Count ){
          $type = $typeRes->First;
        }
      }

      $oMeter->UpdateByArray(array(
        'ConverterId' => $model->converter_id,
        'NumSerial' => $model->num_serial,
        'TypeId' => $type->Id,
        'IsOk' => true,
        'About' => $model->about,
        'InterpriseId' => Self()->Interprise->Id,
      ));
    break;
  }
}


if( isset( $_GET['jstree'] ) ){
  $row_class = $oMeter->IsOk
                ? 'text-success'
                : 'text-danger';

  if( $oMeter->IsExcluded ){
    $row_class = "text-muted";
  }

  $res = array(
      'id'          => (int) $oMeter->Id,
      'text'        => htmlspecialchars($oMeter->Title,ENT_QUOTES),
      'parent'      => "converter_tree_".$oMeter->Converter->Id,
      'icon'        => Site()->Config('icon.meter') . " {$row_class}"
  );
}else{
  $res = array(
      'id'          => (int) $oMeter->Id,
      'about'       => $oMeter->About,
      'converter'   => (int) $oMeter->Converter->Id,
      'type'        => (int) $oMeter->Type->Id,
      'num485'      => $oMeter->Num485,
      'num_serial'  => $oMeter->NumSerial,
      'password'    => $oMeter->Password,
      'coef'        => (int) $oMeter->Coef,
      'timezone'    => (int) $oMeter->Timezone->Id,
      'is_excluded' => (int) $oMeter->IsExcluded,
      'in_use'      => (bool) $oMeter->Inuse,
      'is_ok'       => (bool) $oMeter->IsOk
  );
}
echo json_encode( $res , JSON_UNESCAPED_UNICODE );