<?php

ini_set('display_errors','1');
    error_reporting( E_ALL );

if( empty( $_SERVER['DOCUMENT_ROOT'] ) ){
  $_SERVER['DOCUMENT_ROOT'] = __DIR__ ."/../";
}
$GLOBALS['FullRules'] = true;
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );


$oArchive = archive::Id( $_GET['id'] );
header('Content-Encoding: UTF-8');
ignore_user_abort(true);
//~ header('Transfer-Encoding:chunked');

if( !$oArchive->Id ){
  Site()->Error404();
}
ob_start();
echo "ok";
flush();


set_time_limit(0);

$time_start = microtime(true); 


$delimiter = ";";
$enclosure = "\"";

file_put_contents( $_GET['id'].".debug.log" , "start_log\n" );

function dolog( $msg ){
  file_put_contents( $_GET['id'].".debug.log" , $msg , FILE_APPEND );
}




function mem(){
  return memory_get_usage() / 1024 / 1024;
}


/*
  Карта соответсвия
  вместо id пишем строку в которой лежит
*/
$map = array();



$oArchive->Status = 1;
$oArchive->Procent = 0;


if( !$oArchive->ArchiveMeters->Count ){
  dolog( "empty_meter" );
  die(11);
}

if( $oArchive->YearSt == 0 || $oArchive->YearSp == 0 ){
  dolog( "year_invalid" );
  die("year_invalid");
}
if( $oArchive->MonthSt == 0 || $oArchive->MonthSp == 0 ){
  dolog( "month_invalid" );
  die("month_invalid");
}
if( $oArchive->DaySt == 0 || $oArchive->DaySp == 0 ){
  dolog( "day_invalid" );
  die("day_invalid");
}

//~ echo "start mem:".mem()."\n";


$zip = new ZipArchive();
$filename = "./" . $oArchive->TransName . ".zip";

if ($zip->open($filename, ZipArchive::CREATE)!==TRUE) {
    dolog( "open zip result failed" );
    exit("Невозможно открыть <$filename>\n");
}


//~ echo "init_zip mem:".mem()."\n";



$shema_orm = Site()->ShemaArchive();



/*
  Создаем уникальый ключ по которому будем искать файлы
*/
//~ $Uid =  (microtime(true) * 10000 ) . rand(11111,99999);
$Uid =  $oArchive->Id;

foreach( $shema_orm as $_class => $attrs ){
  
  
  $line = 0;
  
  
  $file = $Uid."." . $_class . ".csv";

  $fp = fopen( $file , 'w');
  
  $Filter = array('Filter' => array());
  
  switch( $_class ){
    case 'parameter' :
    case 'metertype' :
    case 'loginfo' :
    case 'convertertype' :
      $Filter['Filter']['Interprise'] = 0;
      $Filter['Filter']['Enterprise'] = 0;
    break;
  }  
  
  if( empty($Filter['Filter']) ) continue;

  foreach( $_class::Filter( $Filter )->Elements as $iElem ){
    
    dolog(
      sprintf( 
        "[mem:%20s]  [class:%20s]  [id:%20s]  [time_run:%20s]\n", 
        mem(),
        get_class( $iElem ),
        $iElem->Id,
        (microtime(true)  - $time_start)
      )
    );
    
    $row = array();
    foreach( $attrs as $Prop ){
      $Value = $iElem->$Prop;
      
      if( is_object( $Value ) ){
        $row[] =$Value->Id;
      }else{
        $row[] = $Value;
      }
    }
    
    dolog(
      sprintf( 
        "[mem:%20s]  [values: %s]  [time_run:%20s]\n", 
        mem(),
        implode(',',$row),
        (microtime(true)  - $time_start)
      )
    );
    
    if( fputcsv($fp, $row , $delimiter , $enclosure) ){
      $map[ $_class ][ $iElem->Id ] = ++$line;
    }
  }

  fclose($fp);
  
  $zip->addFile( "./".$file , "{$_class}.csv" );
  
}


//~ echo "first_write mem:".mem()."\n";




$arConverters = array();

$file = $Uid.".meter.csv";
$fp = fopen( $file , 'w');

$line = 0;

foreach( $oArchive->ArchiveMeters->Elements as $iElem ){
  
  dolog(
    sprintf( 
      "[mem:%20s]  [class:%20s]  [id:%20s]  [time_run:%20s]\n", 
      mem(),
      get_class( $iElem ),
      $iElem->Id,
      (microtime(true)  - $time_start)
    )
  );
  
  $row = array();
  foreach( $shema_orm['meter'] as $Prop ){
    
    $Value = $iElem->Meter->$Prop;
    
    if( $Prop == "Type" ){
      $row[] = $map['metertype'][$Value->Id];
      continue;
    }
    
    $prefix = $Prop == "NumSerial" ? "'" : "";
    
    if( is_object( $Value ) ){
      $row[] =$prefix.$Value->Id;
    }else{
      $row[] = $prefix.$Value;
    }
  }
  
  dolog(
    sprintf( 
      "[mem:%20s]  [values: %s]\n", 
      mem(),
      implode(',',$row)
    )
  );
  
  if( fputcsv($fp, $row , $delimiter , $enclosure) ){
    $map['meter'][ $iElem->Meter->Id ] = ++$line;
  }
  
  TObject2::CleanAllObjectsByClass( 'meter' );
  
  $arConverters[ $iElem->Meter->Converter->Id ] = $iElem->Meter->Converter->Id;
  
}

fclose($fp);
$zip->addFile( "./".$file , "meter.csv" );


//~ echo "meter_write mem:".mem()."\n";





$file = $Uid.".converter.csv";
$fp = fopen( $file , 'w');

$line = 0;

$Filter = array( 
  'Filter' => array( 
    'Id' =>  $arConverters
));

foreach( converter::Filter($Filter)->Elements as $iElem ){
  
  dolog(
    sprintf( 
      "[mem:%20s]  [class:%20s]  [id:%20s]  [time_run:%20s]\n", 
      mem(),
      get_class( $iElem ),
      $iElem->Id,
      (microtime(true)  - $time_start)
    )
  );
  
  $row = array();
  foreach( $shema_orm['converter'] as $Prop ){
    
    $Value = $iElem->$Prop;
    
    if( is_object( $Value ) ){
      $row[] =$Value->Id;
    }else{
      $row[] = $Value;
    }
  }
  
  dolog(
    sprintf( 
      "[mem:%20s]  [values: %s]  [time_run:%20s]\n", 
      mem(),
      implode(',',$row),
      (microtime(true)  - $time_start)
    )
  );
  
  if( fputcsv($fp, $row , $delimiter , $enclosure) ){
    $map['converter'][ $iElem->Id ] = ++$line;
  }
}

fclose($fp);
$zip->addFile( "./".$file , "converter.csv" );

//~ echo "converter_write mem:".mem()."\n";



$file = $Uid.".meterdatahour.csv";
$fp = fopen( $file , 'w');


$MonthSt  = str_pad($oArchive->MonthSt,2,"0",STR_PAD_LEFT);
$DaySt    = str_pad($oArchive->DaySt,2,"0",STR_PAD_LEFT);
$MonthSp  = str_pad($oArchive->MonthSp,2,"0",STR_PAD_LEFT);
$DaySp    = str_pad($oArchive->DaySp,2,"0",STR_PAD_LEFT);

$_GET['start']  = "{$oArchive->YearSt}{$MonthSt}{$DaySt}";
$_GET['stop']   = "{$oArchive->YearSp}{$MonthSp}{$DaySp}";


$datetime1 = $oArchive->ArchiveMeters->First->Meter->MinDate();
$datetime2 = $oArchive->ArchiveMeters->First->Meter->MaxDate();
$interval = $datetime1->diff($datetime2);


$all_count = (ceil($interval->format('%a') )+1) * $oArchive->ArchiveMeters->Count;
if( !$all_count ){
  $all_count++;
}

$iteration = 0;
$mdh_iteration = 0;

foreach( $oArchive->ArchiveMeters->Elements as $iMeter ){
  
  dolog(
    sprintf( 
      "[mem:%20s]  [meter: %s]  [time_run:%20s]\n", 
      mem(),
      $iMeter->Meter->Id,
      (microtime(true)  - $time_start)
    )
  );
  
  
  //~ echo "ArchiveMeters_cicle mem:".mem()."\n";
  
  $MinDate = $iMeter->Meter->MinDate();
  
  
  $ArParameters = array();
  foreach( $iMeter->Meter->AllParameters->Elements as $iParameter ){
    if( !$iParameter->Is ) continue;
    $ArParameters[ $iParameter->Id ] = 1;
  }
  
  dolog(
    sprintf( 
      "[mem:%20s]  [min_data: %s]  [max_data: %s]  [time_run:%20s]\n", 
      mem(),
      $MinDate->format("Y-m-d"),
      $iMeter->Meter->MaxDate()->format("Y-m-d"),
      (microtime(true)  - $time_start)
    )
  );
  
  while( $MinDate->getTimestamp() <= $iMeter->Meter->MaxDate()->getTimestamp() ){
    
    $this_proc = 100 / $all_count * $iteration;
    
    
    dolog(
      sprintf( 
        "[mem:%20s]  [this_time: %s]  [all: %s]  [point: %s]  [%% : %s]  [time_run:%20s]\n", 
        mem(),
        $MinDate->format("Y-m-d"),
        $all_count,
        $iteration,
        $this_proc,
        (microtime(true)  - $time_start)
      )
    );
    
    
    /*
      Если пользователь попросил принудительно остановить
    */
    $SQL = Utils::Strip("select is_force_exit from archive where id = {$oArchive->Id}");
    list($is_force_exit) = DB::FetchArraySelect($SQL);
    if( $is_force_exit == 1 ) {
      
      $oArchive->UpdateByArray(array(
        'Procent' => 0,
        'Status' => 0,
        'IsForceExit' => 0
      ));
      
      dolog( "FORCE QUIT" );
      
      break 2;
    }



    
    $limit = count( $ArParameters ) * 24;
    
    $SQL = Utils::Strip("
      select * from meterdatahour 
      where 
      meter_id = {$iMeter->Meter->Id} and
      year = {$MinDate->format('Y')} and
      month = ". ( $MinDate->format('m')) ." and
      day = {$MinDate->format('d')} and
      parameter_id IN(" . implode(",",array_keys($ArParameters)) . ") and
      hour IN(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24)
    ");
    
    
    $MDH_struct = array();
    foreach( meterdatahour::$FInit as $Ident => $attrs ){
      if( isset( $attrs['sql'] ) && array_search( $Ident , $shema_orm['meterdatahour']) !== false ){
        $MDH_struct[ $attrs['sql'] ] = $Ident;
      }
    }
    
    if( count($ArParameters) ){
      $Res = DB::UBSelect( $SQL );
      while( $val = DB::Fetch($Res) ){
        $mdh_iteration++;
        
        foreach( $val as $_ident => $v ){
          if( !isset( $MDH_struct[$_ident] ) ){
            unset($val[ $_ident ]);
          }
        }
        
        
        $val['meter_id'] = $map['meter'][$val['meter_id']];
        $val['loginfo_id'] = $map['loginfo'][$val['loginfo_id']];
        
        $val['parameter_id'] = $map['parameter'][$val['parameter_id']];
        
        
        dolog(
          sprintf( 
            "[mem:%20s]  [mdh: %s]\n", 
            mem(),
            json_encode($val)
          )
        );
        
        fputcsv($fp, $val , $delimiter , $enclosure);
      }
      
      // С удалением данных
      if( $oArchive->IsDrop ){
        $SQL = Utils::Strip("
          delete from meterdatahour 
          where 
          meter_id = {$iMeter->Meter->Id} and
          year = {$MinDate->format('Y')} and
          month = ". ( $MinDate->format('m') ) ." and
          day = {$MinDate->format('d')} and
          parameter_id IN(" . implode(",",array_keys($ArParameters)) . ") and
          hour IN(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24)
        ");
        DB::Query( $SQL );
      }
    }
    
    $iteration++;
    
    
    $oArchive->UpdateByArray(array(
      'Procent' => $this_proc
    ));
    
    
    $MinDate->modify( "+1 day" );
  }
  
  $iMeter->Desctruct();
  
}



/*
  Создаем схему
  {
    info : {
      year_start  :
      month_start :
      day_start   :
      uear_stop   :
      month_stop  :
      day_stop    :
      origin_name :
      description :
      user_login  :
      interprise  :
      date_create :
      count_mdh   :
    },
    schema : {
      file : {
        field
        field
      }
    }
  }
*/

$Array_shema = array();

foreach( Site()->ShemaStruct() as $type => $artts ) {
  foreach( $artts as $field ){
    $value = "";
    switch( $field ){
      case 'year_start' :
        $value = $oArchive->YearSt;
      break;
      case 'month_start' :
        $value = $oArchive->MonthSt;
      break;
      case 'day_start' :
        $value = $oArchive->DaySt;
      break;
      case 'year_stop' :
        $value = $oArchive->YearSp;
      break;
      case 'month_stop' :
        $value = $oArchive->MonthSp;
      break;
      case 'day_stop' :
        $value = $oArchive->DaySp;
      break;
      case 'origin_name' :
        $value = $oArchive->Title;
      break;
      case 'description' :
        $value = $oArchive->Text;
      break;
      case 'user_login' :
        $value = $oArchive->User->Title;
      break;
      case 'interprise' :
        $value = $oArchive->User->Interprise->Title;
      break;
      case 'date_create' :
        $value = time();
      break;
      case 'count_mdh' :
        $value = $mdh_iteration;
      break;
      case 'delimiter' :
        $value = $delimiter;
      break;
      case 'enclosure' :
        $value = $enclosure;
      break;
    }
    $Array_shema[ $type ][ $field ] = $value;
  }
}


foreach( $shema_orm as $name => $attrs ){
  $Array_shema['shema'][$name] = $attrs;
}


file_put_contents( $Uid.".shema.json" , json_encode($Array_shema) );
$zip->addFile( "./".$Uid.".shema.json" , "shema.json" );

dolog(
  sprintf( 
    "[mem:%20s]  dump_stop\n", 
    mem()
  )
);

$zip->addFile( "./".$file , "meterdatahour.csv" );

$oArchive->UpdateByArray(array(
  'Procent' => 0,
  'Status' => 0
));

$zip->close();

dolog(
  sprintf( 
    "[mem:%20s]  zip_close\n", 
    mem()
  )
);



foreach( $shema_orm as $_class => $attrs ){
  $file = $Uid."." . $_class . ".csv";
  unlink( $file );
}
//~ unlink($_GET['id'].".debug.log");
unlink( $Uid.".shema.json");





if( $oArchive->IsDrop ){
  $oArchive->Delete();
}

die();