<?php
$GLOBALS['FullRules'] = true;
include_once($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');

$error = array();

if( !Site()->Config('is_forgot',0) ){
  Site()->Error404;
  exit();
}


if( isset( $_GET['hash'] ) ){

  $Filter = array(
    'Filter' => array(
      'Hash' => $_GET['hash']
    )
  );
  
  //~ echo forgot::Filter($Filter)->Sql;die();

  if( !forgot::Filter($Filter)->Count ){
    
    if( !defined( '__PHPUNIT_PHAR__' ) ) {
      Site()->Error404;
      exit();
    }else{
      echo "forgot not found";
    }
  }else{
    $oForgot= forgot::Filter($Filter)->First;
    $Date = new Datetime('now');
    $Date->setTimestamp($oForgot->Create);
    $Date->modify("+1 hour");
    if( $Date->getTimestamp() < time() ){
      if( !defined( '__PHPUNIT_PHAR__' ) ) {
        Site()->Error404;
        exit();
      }else{
        echo "timeout";
      }
    }else{
    
      $error = array();
    
      if( isset( $_POST['savepass'] ) ){
        if( !isset( $_POST['Pass'] ) ){
          $error['Pass'] = "Вы не ввели пароль";
        }
        if( !isset( $_POST['Pass2'] ) ){
          $error['Pass2'] = "Вы не ввели подтверждение пароля";
        }
        if( isset( $_POST['Pass'] ) && isset( $_POST['Pass2'] ) && $_POST['Pass'] != $_POST['Pass2'] ){
          $error['Pass'] = "Пароли не совпадают";
        }
        if( empty($_POST['Pass']) ){
          $error['Pass'] = "Пароль пустой.";
        }
        if( empty( $error ) ){
          $oForgot->User->Pass = user::GenPass($_POST['Pass']);
          $oForgot->User->Save();
          TObject2::CleanAllObjects();
          $oForgot->Delete();
          if( !defined( '__PHPUNIT_PHAR__' ) ) {
            header("Location: /");
          }else{
            echo "Success";
          }
        }
      }
      smarty()->assign('error' , $error);
      smarty()->assign('Self' , $oForgot->User);
      smarty()->display('auth/forgot/new_pass.tpl');
    }
  }
  
}else{

  if( isset( $_POST['forgot'] ) ){
    
    
    if( empty( $_POST['Email'] ) ){
      $error[] = "Вы не ввели email.";
    }
    
    $Filter = array(
      'Filter' => array(
        'Login' => $_POST['Email']
      )
    );
    
    if( !$error ){
      
      if( !user::Filter($Filter)->Count ){
        $error[] = "Такого пользователя не существует";
      }else{
        
        $oUser = user::Filter($Filter)->First;
      
        $Filter = array(
          'Filter' => array(
            'User' => $oUser->Id
          )
        );
        if( !forgot::Filter($Filter)->Count ){
          $oForgot = forgot::Id(0);
          $oForgot = forgot::AddByArray(array(
            'UserId' => $oUser->Id,
            'Hash' => $oForgot->GetHashByPass($_POST['Email'])
          ));
        }else{
          $oForgot = forgot::Filter($Filter)->First;
          //~ $oForgot->Hash = $oForgot->GetHashByPass($_POST['Email']);
          $oForgot->UpdateByArray(array(
            'Create' => time(),
            'Hash'  => $oForgot->GetHashByPass($_POST['Email'])
          ));
          $oForgot->Save();
        }
        if( Utils::EmailValid($oForgot->User->Login) ){
          
          include( $_SERVER['DOCUMENT_ROOT'] . '/include/SwiftMailer/swift_required.php' );
          
          $url       = defined( "__PHPUNIT_PHAR__" ) ? "localhost" : "epn.nag.ru";
          $transport = Swift_SmtpTransport::newInstance($url, 25);
          $mailer    = Swift_Mailer::newInstance($transport);
          
          smarty()->assign('oForgot' , $oForgot);
          
          $message = (new Swift_Message('Восстановление пароля'))
            ->setContentType("text/html")
            ->setFrom(['nagruzka@nag.ru' => 'Nagruzka'])
            ->setTo([ $oUser->EMail ])
            ->setBody( smarty()->fetch('auth/forgot/message.tpl') )
            ;

          $result = $mailer->send($message);

          smarty()->display('auth/forgot/success.tpl');
          die();
        }
      }
    }
    
    
  }
  smarty()->assign('error' , $error);
  smarty()->display('auth/forgot/index.tpl');
}

