<?php
ini_set( 'date.timezone', 'UTC' );
ini_set( 'date.timezone', 'Asia/Yekaterinburg' );
header("Content-type: text/html; charset=utf-8");

include ('meterce301m.inc.php');


$oConverter = new converter();
$oMeter     = new MeterCE301M();
$oMeter->Converter = $oConverter;

$oMeter->SetNumber( 2 );

$oConverter->ip    = '192.168.1.190';
$oConverter->ip    = '92.248.203.242';
$oConverter->port  = 50023;

$oConverter->Connect();
if( $oConverter->IsConnected() )
{

/*
  unsigned int Baudrate;
  unsigned char CharacterBits;
  enum ParityBits PT;
  unsigned char StopBit;
*/

  $oConverter->Setup( $aUartSetup = Array( 'Baudrate' => 2400, 'Bits' => 8 , 'Parity' => 'None', 'StopBits'=>'2' ) );
//  $oConverter->Setup( $aUartSetup = Array( 'Baudrate' => 9600, 'Bits' => 5 , 'Parity' => 'None', 'StopBits'=>'1' ) );
  if( $arType = $oMeter->GetSubType() )
  {
//    echo "Тип прибора  : CE102 S6 AKV, R5 AK(v1-4)<br />";
    echo "Счетчик: ";
    if( $arType[0]==3 and $arType[1] ==1 ){
      echo "CE301M R33<br />";
    }elseif( $arType[0]==3 and $arType[1] ==2 ){
      echo "CE301M S31<br />";
    }elseif( $arType[0]==3 and $arType[1] ==3 ){
      echo "CE102 S7J<br />";
    }else{
      echo "Неизвестен<br />";
      goto NoConf;
    }
    echo "Версия ядра  : $arType[0]<br />";
    echo "Тип прошивки : $arType[1]<br />";
    echo "Версия прошивки : v.$arType[2](".BCDfrom($arType[3]).".".BCDfrom($arType[4]).".20".BCDfrom($arType[5]).")<br />";
    if( $Serial = $oMeter->GetSerialNumber() )
    {
      echo "Серийный номер : $Serial";
    };
//    goto NoConf;
    if( $arConfig = $oMeter->GetConfigInfo() )
    {
      echo " = Config<br />";
      echo "Положение точки :";
      switch( $arConfig[0] & 0x03 )
      {
        case 0x00: echo "00000000";
          break;
        case 0x01: echo "0000000.0";
          break;
        case 0x02: echo "000000.00";
          break;
        case 0x03: echo "00000.000";
          break;
      }
      echo "<br />\n";
      echo "Состояние пломбы: ".
      (
        ( $arConfig[0] & 0x10 )
          ? "не нарушена"
          : "вскрыта"
      ). "<br />\n";
      echo "Внешняя тарификация: ";
      switch( $arConfig[1]>>2 & 0x01  )
      {
        case 0: echo "по тарифной программе<br />";
          break;
        case 1: echo "внешняя<br />";
          break;
      }
      echo "Интервал усреднения энергии :";
      switch( $arConfig[1] & 0x03 )
      {
        case 0x00: echo "1 час";
          break;
        case 0x01: echo "30 мин";
          break;
        case 0x02: echo "15 мин";
        case 0x03: echo "Ошибка";
          break;
      }
      echo "<br />\n";
      
      echo "Автоматический переход на зимнее/летнее время: ";
      switch( ($arConfig[1]>>3  & 0x04) )
      {
        case 0: echo "отключен<br />";
          break;
        case 1: echo "включен<br />";
          break;
      }
      echo "Тарификация выходных и праздничных дней: ";
      switch( ($arConfig[1] & 0x08) >> 4 )
      {
        case 0: echo "отключен<br />";
          break;
        case 1: echo "включен<br />";
          break;
      }
//      echo ($arConfig[0] & 0x03)." ";
    }
    if( $date = $oMeter->GetDatetime() )
    {
      echo date_format($date, 'Y-m-d H:i:s') . "\n";
    }
    for( $n=1; $n<5; $n++ )
    {
      $TarifValue = $oMeter->GetTarifNumValue( $n );
      if( $TarifValue !== false )
      {
        echo "Тариф {$n}: ".$TarifValue . "\n";
      }
    }
    $PowerValue = $oMeter->GetPower( mktime( 9, 0, 0, 7, 24, 2013 ) );
    if( $PowerValue >= 0 )
    {
      echo $PowerValue;
    }
    else
    {
      echo "Профиль мощности не поддерживается";
    }
    
  }
  NoConf:
  $oConverter->Disconnect();
}

die();












function CulcKS( $arPacket, $ltrim, $rtrim )
{
  $ks = 0;
  for( $i=$ltrim; $i<count($arPacket)-1-$rtrim; $i++ )
  {
    $ks = ($ks+$arPacket[$i])&0xff;
    //echo "$ks <br />";
  }
  return $ks;
}

function PacketCreate( $can_num, $PARAM_TYPE, $can_num_by )
{
  $arPacket = Array(
    FORMAT_FT1_2,
    CONTROL_MASK_BIT_PRM,
    $can_num_by,
    CMD_READ_SLAVE_TKON,
    $can_num,
    L($PARAM_TYPE),
    H($PARAM_TYPE),
    0x00,
    FORMAT_FT1_2_END,
  );
  $arPacket[ count($arPacket)-2 ] = CulcKS( $arPacket, 1, 1 );
  $packet = implode( '', array_map( 'chr', $arPacket ) );
  return $packet;
}

// 
// 10 49 01 01 00 F0 00 3B 16
// 10 40 00 11 01 00 F0 42 16  was

$packet_num = rand(0,3);
//$packet_num = 3;
function PacketCreateMaster( $can_num, $PARAM_TYPE, $can_num_by )
{
  global $packet_num;
  $arPacket = Array(
    FORMAT_FT1_2,
    CONTROL_MASK_BIT_PRM+$packet_num,
    $can_num,
    CMD_READ_MASTER_TKON,
    L($PARAM_TYPE),
    H($PARAM_TYPE),
    0x00,
    0x00,
    FORMAT_FT1_2_END,
  );
  $arPacket[ count($arPacket)-2 ] = CulcKS( $arPacket, 1, 1 );
  $packet = implode( '', array_map( 'chr', $arPacket ) );
  return $packet;
}

function PacketCreateLong( $can_num, $PARAM_TYPE, $can_num_by, $Length, $STAT_INDEX = 0 )
{
  $PktLen = 9;
  $arPacket = Array(
    FORMAT_FT1_2_LONG,
    $PktLen,
    $PktLen,
    FORMAT_FT1_2_LONG,
    CONTROL_MASK_BIT_PRM,
    $can_num_by,
    CMD_READ_SLAVE_TKON_INDEX,
    $can_num,
    L($PARAM_TYPE),
    H($PARAM_TYPE),
    L($STAT_INDEX),
    H($STAT_INDEX),
    $Length,
    0x00,
    FORMAT_FT1_2_END,
  );
  $arPacket[ count($arPacket)-2 ] = CulcKS( $arPacket, 4, 1 );
  $packet = implode( '', array_map( 'chr', $arPacket ) );
  return $packet;
}

  
define( 'CMD_READ_MASTER_TKON',  0x01 );

define( 'CMD_READ_SLAVE_TKON',  0x11 );
define( 'CMD_READ_SLAVE_TKON_INDEX',  0x19 );


define( 'FORMAT_FT1_1',         0x04 );
define( 'FORMAT_FT1_2',         0x10 );
define( 'FORMAT_FT1_2_LONG',    0x68 );
define( 'FORMAT_FT1_2_END',     0x16 );

define( 'CONTROL_MASK_BIT_PRM', 0x40);


define( 'PARAM_TYPE',           0xF000 );
define( 'PARAM_SERIAL',         0xF001 );
define( 'PARAM_REZHIM',         0xF01A );
define( 'PARAM_F01D',           0xF01D );
define( 'PARAM_NAME',           0xF034 );
define( 'PARAM_QUERY',          0xF004 );
define( 'PARAM_QUERY_PARAM',    0xF00A );
define( 'PARAM_QUERY_PARAM_DESCR',0xF00B );

define( 'PARAM_QUERY_NAMES',    0xF029 );

$Algorutms = Array(
  0x01 => Array( 'IN' => 2, 'OUT' => 1,   'CODE' => '0030', 'NAME' => 'X1+X2 -> Y' ),
  0x10 => Array( 'IN' => 4, 'OUT' => 2,   'CODE' => '0190', 'NAME' => 'Расчет температуры с ТСМ\ТСП' ),
  0x11 => Array( 'IN' => 5, 'OUT' => 2,   'CODE' => '0191', 'NAME' => 'Токовый линейный датчик' ),
  0x16 => Array( 'IN' => 5, 'OUT' => 3,   'CODE' => '0194', 'NAME' => 'Ограничение параметра X' ),
  0x17 => Array( 'IN' => 3, 'OUT' => 1,   'CODE' => '0195', 'NAME' => 'Перевод давления в авс МПА' ),
  0x1C => Array( 'IN' => 2, 'OUT' => 1,   'CODE' => '019C', 'NAME' => 'Расчет энтальпии горячей воды' ),
  0x1F => Array( 'IN' => 3, 'OUT' => 3,   'CODE' => '0290', 'NAME' => 'Ввод параметра с плавающей запятой' ),
  0x28 => Array( 'IN' => 5, 'OUT' => 5,   'CODE' => '0218', 'NAME' => 'Расчет расхода воды' ),
  0x2F => Array( 'IN' => 4, 'OUT' => 3,   'CODE' => '0220', 'NAME' => 'Количество тепла в трубопроводе' ),
  0x30 => Array( 'IN' => 7, 'OUT' => 5,   'CODE' => '0221', 'NAME' => 'Тепло в закрытлй водяной системе' ),
  0x31 => Array( 'IN' => 8, 'OUT' => 11,  'CODE' => '0222', 'NAME' => 'Тепло в открытой водяной системе' ),
  0x32 => Array( 'IN' => 1, 'OUT' => 5,   'CODE' => '0200', 'NAME' => 'Время исправной/неиспавной работы' ),
  0x34 => Array( 'IN' => 1, 'OUT' => 11,  'CODE' => '0223', 'NAME' => 'Накопление расхода' ),
  0x35 => Array( 'IN' => 1, 'OUT' => 8+1, 'CODE' => '0224', 'NAME' => 'Усреднение параметра' ),
  0x36 => Array( 'IN' => 1, 'OUT' => 2,   'CODE' => '028A', 'NAME' => 'Интегрирование' ),
  0x37 => Array( 'IN' => 1, 'OUT' => 1,   'CODE' => '0225', 'NAME' => 'Архив месяцем, на 12 месяцев' ),
  0x38 => Array( 'IN' => 1, 'OUT' => 1,   'CODE' => '0226', 'NAME' => 'Архив суток, на 365/6 дней' ),
  0x39 => Array( 'IN' => 1, 'OUT' => 1, '  CODE' => '0227', 'NAME' => 'Ввод параметра с плавающей запятой' ),
  0x42 => Array( 'IN' => 6, 'OUT' => 10,  'CODE' => '02B2', 'NAME' => 'Тепло ГВС сумарной с утечками' ),
  0x67 => Array( 'IN' => 33,'OUT' => 2,   'CODE' => '0299', 'NAME' => 'Объединение 32 бит с сигнализацией' ),

);

function L( $V )
{
  return ( $V & 0xff );
}

function H( $V )
{
  return $V >> 8;
}

function WaitForAnswer( $socket, &$buf )
{
  $ms = 100*1; // wait timeout
  while( $ms-- )
  {
    if( $len = @socket_recvfrom( $socket, $buf, 1500, MSG_DONTWAIT, $from, $port) )
    {
      return $len;
    }
    if( -1 == $len )
    {
      return 0;
    }
    else
    {
//      echo ".";
      usleep(10*1000);
    }
  }
  return 0;
}

function NetBytesDebug( $buf, $len, $ltrim=0 )
{
//  echo $len." ] ";
  for( $i=$ltrim; $i<$len; $i++ )
  {
    echo sprintf("%02X", ord($buf[$i]) )." ";
  }
  echo "<br />";
}


/*
  $socket = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP );
  socket_set_option( $socket, SOL_SOCKET, SO_BROADCAST, 1 );
  socket_set_option( $socket, SOL_SOCKET, SO_KEEPALIVE, 1 );
  socket_bind( $socket, $address, $port );
//  $buf=socket_read($socket,100,PHP_BINARY_READ);
  file_put_contents("logs/cstrike.log","$buf\n",FILE_APPEND);
*/

$def_address = "192.168.5.56";
$def_port=50;
$address = isset($_REQUEST['ip'])
           ? $_REQUEST['ip']
           : $def_address;

$port    = isset($_REQUEST['port'])
           ? $_REQUEST['port']
           : $def_port;

$act = isset( $_REQUEST['act'] ) ? trim($_REQUEST['act']) : '';

echo "<pre>";
if( $act == 'do' )
{
echo date( "r" )."<br>";

$n = 1;



$can_num    = 0x02;
$can_num_by = 0x05;

$can_num    = 0x01;
$can_num_by = 0x00;

// 
// 10 49 01 01 00 F0 00 3B 16

// 04 04 68 08 01 01 0b 15 16
//  

$use_tcp=1;

function echodone()
{
  echo "Готово\r";
}

function echoneterror()
{
  $errorcode = socket_last_error();
  $errormsg = socket_strerror($errorcode);
  die("Ошибка: [$errorcode] $errormsg");  
}

$ok = false;

if( $use_tcp )
{
  echo "Создание сокета... ";
  $socket = socket_create( AF_INET, SOCK_STREAM, SOL_TCP );
  
  if ($socket === false)
    echoneterror();
  else
    echodone();
  
  
  socket_set_nonblock( $socket );
  
  echo "Содение c {$address}:{$port} ..";
  $rez = @socket_connect( $socket, $address, $port );
  //socket_set_block( $socket );
  $sockets_all = array( $socket );
  $sockets = $sockets_all;
  switch( socket_select( $r = $sockets, $w = $sockets, $f = $sockets, $time_out_sec = 5  ) )
  {
    case 2:
      echo "Отказ\n";
      break;
    case 1:
      echodone();
      $ok = true;
      break;
    case 0:
      echo "Таймаут\n";
      break;
  }
  if( !$ok )
  {
    socket_close($socket);
  }
}else{
  $socket = socket_create( AF_INET, SOCK_DGRAM, SOL_UDP );
  socket_bind( $socket, '0.0.0.0', $port );
}


$len = 0;
echo "Запрос типа прибора по адресу CAN {$can_num},через $can_num_by<br />";
$packet = PacketCreateMaster( $can_num, PARAM_TYPE, $can_num_by );

  NetBytesDebug( $packet, strlen($packet) );    
if( $use_tcp )
{
  $rez = socket_write( $socket, $packet, strlen($packet) );
  if( $rez > 0 )
    echo "Отправлено $rez байт\r" ;
  else
    echoneterror();
  $lastAccess = time();
  
  $sockets = $sockets_all;
  $r = $sockets;
  $w = $sockets;
  $f = $sockets;
  $packet = '';
  $len = 0;
  while( socket_select( $r,$w, $f , $time_out_sec = 3  ) !== FALSE )
  {
  
//    if( in_array( $socket, $sockets) )
//    {
      while ( $l = socket_recv($socket, $data, 8192, 0) )
      {
        $packet .= $data;
        $len += $l;
        //echo $len.": ".$data;
        
      }
      //$lastAccess = time();
      //echo " lastAccess update\n";
//    } else {
//      if (time()-$lastAccess > 3) {
//        break;
//      }
//    }  
  
  
  
    //echo time()-$lastAccess;
      if( (time()-$lastAccess > 1) or ( $len >= 9 ) ) 
        break;
//    $len = socket_recv( $socket, c, 1024, 0 );
   //die();
  }  
  
  if( $len> 0 )
  {
    echo "Принято $len байт\r" ;
    NetBytesDebug( $packet, $len );
    if( ord($packet[0]) == 0x68 && ord($packet[3]) == 0x68 && $packet[1] == $packet[2] )
    {
      echo "Протокол FT1.2\n";
      if( ord($packet[1])>2 )
      {
        $p_data_size = ord($packet[1])-2;
        echo "Размер данных в пакете: ".$p_data_size."\n";
        echo "Номер пакета ответа:".( ord($packet[4]) )."\n";
        if( $packet_num != ord($packet[4]) )
        {
          echo "Не совпадает был ". $packet_num . "\n";
        }
        else
        {
          echo "\n";
        }
        echo "Ответ от прибора с номером: ".( ord($packet[5]) )."\n";
        
        echo "Ответ: ";
        for( $i=$p_data_size-1; $i>=0; $i-- )
        {
          echo sprintf("%02X", ord($packet[6+$i]) );
        }
        echo "\n";
      }
    }
  }
  else
  {
    echoneterror();
  }
  die();
//  var_dump( $len );
}
else
{
  socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
  $len = WaitForAnswer( $socket, $buf );
}
  if( $len)
    NetBytesDebug( $buf, $len-2, 6 );
die('test done');

echo "Запрос серийного номера<br />";

$packet = PacketCreate( $can_num, PARAM_SERIAL, $can_num_by );
socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
if( $len = WaitForAnswer( $socket, $buf ) )
  NetBytesDebug( $buf, $len-2,6 );



    

echo "Стандартное имя очереди<br />";
$packet = PacketCreateLong( $can_num, PARAM_NAME, $can_num_by, 6 );
//NetBytesDebug( $packet, strlen($packet) );
socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
if( $len = WaitForAnswer( $socket, $buf ) )
{
  $name1251 = substr( $buf, 6, $len-6-2 );
//  NetBytesDebug( $buf, $len );
  echo "<b>";
  echo mb_convert_encoding( $name1251, 'UTF-8', 'cp1251' );
  echo "</b><br />";
}

echo "Очередь загружаемых задач<br />";
$paramsstart = 0;
for( $i=0; $i<10; $i++ )
{



  $packet = PacketCreateLong( $can_num, PARAM_QUERY, $can_num_by, 1, $i );
  //NetBytesDebug( $packet, strlen($packet) );
  socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
  if( $len = WaitForAnswer( $socket, $buf ) )
  {
//    NetBytesDebug( $buf, $len-2,6 );
    $numold = $paramsstart;
    $algoritm = ord($buf[6])+256*ord($buf[7]);
    $paramsstart = ord($buf[8])+256*ord($buf[9]);
    if( 0xFFFF == $algoritm )
      break;

    $packet = PacketCreateLong( $can_num, PARAM_QUERY_NAMES, $can_num_by, 8, $i*8 );
    //NetBytesDebug( $packet, strlen($packet) );
    socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
    if( $len = WaitForAnswer( $socket, $buf ) )
    {
  //    NetBytesDebug( $buf, $len-2,6 );
      $name1251 = substr( $buf, 6, $len-6-2 );
      echo "<br /><b>".sprintf( "%02X: ", $i );
      echo mb_convert_encoding( $name1251, 'UTF-8', 'cp1251' );
      echo "</b><br />";
    }
    echo "Алгоритм ".sprintf( "%02X", $algoritm ).", адрес начала параметров +$paramsstart <br />";
    //echo "= <b>".($paramsstart-$numold)."</b><br />" ;
  }
  if( isset($Algorutms[$algoritm]) )
  {
    $Alg = $Algorutms[$algoritm];
    echo $Alg['NAME']."<br />";
    $paramlen = ($Alg['IN']+$Alg['OUT'])/2;
    $packet = PacketCreateLong( $can_num, PARAM_QUERY_PARAM, $can_num_by, $paramlen, $paramsstart/4 );
    //NetBytesDebug( $packet, strlen($packet) );
    socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
    if( $len = WaitForAnswer( $socket, $buf ) )
    {
      NetBytesDebug( $buf, $len-2,6 );
      for( $pn=0; $pn<$Alg['IN']*2; $pn += 2 )
      {
        echo sprintf( "Вх %02X%02X<br />", ord($buf[7+$pn]), ord($buf[6+$pn]) );
      }
      for( $pn=$Alg['IN']*2; $pn<$Alg['OUT']*2+$Alg['IN']*2; $pn += 2 )
      {
        echo sprintf( "Вых %02X%02X<br />", ord($buf[7+$pn]), ord($buf[6+$pn]) );
      }
    }
  }
  else
  {
    echo "no info<br />";
  }



}

for( $i=0; $i<102; $i++ )
{
  $packet = PacketCreateLong( $can_num, PARAM_QUERY_PARAM_DESCR, $can_num_by, 10, $i );
  //NetBytesDebug( $packet, strlen($packet) );
  socket_sendto( $socket, $packet, strlen($packet), 0, $address, $port);
  if( $len = WaitForAnswer( $socket, $buf ) )
  {
//  echo "PARAM_QUERY_PARAM_DESCR ";
    NetBytesDebug( $buf, $len-2,6 );
  }
}
//$address = ?

}
?>
</pre>
<form name="mf" action="" method="get">
  <input type="hidden" name="act" value="do" />
  IP: <br />
  <input type="text" name="ip" value="<?php echo $address; ?>" /><br />
  Port:<br />
  <input type="text" name="port" value="<?php echo $port; ?>" /><br />
  <input type="submit"/>
</form>
