<?php

function getmicrotime()
{
	list($usec, $sec) = explode(" ", microtime());
	return ((float)$usec + (float)$sec);
}
function test_query( $arBytes, $arLook )
{
	if( $arLook == array_intersect_assoc($arBytes, $arLook ) )
		return true;
	else
		return false;
}

function generate_answer( $B )
{
	$H = array_map( 'ord', str_split( $B ) );
	;
	// 0150 3002 2833 2903   09
	if( test_query( $H, array( 0x2F, 0x3f, 0x34, 0x21, 0x0d, 0x0a ) ) )
	{
		return "/EKT5CE301v7\r\n";
	}
	elseif( test_query( $H, array( 0x06, 0x30, 0x35, 0x31, 0x0D, 0x0A ) ) )
	{
		return array( 0x01, 0x50, 0x30, 0x02, 0x28, 0x34, 0x29, 0x03, 0x0A ); 
	}
	elseif( test_query( $H, array( 0x01, 0x52, 0x31, 0x02, 0x53, 0x4E, 0x55, 0x4D, 0x42, 0x28, 0x29, 0x03, 0x5E ) ) )
	{
		static $Meter = 0;
		if( $Meter++ == 0 )
		{
			return array( 0x02, 0x53, 0x4E, 0x55, 0x4D, 0x42, 0x28, 0x30, 0x30, 0x38, 0x38, 0x34, 0x32, 0x30, 0x35, 0x36, 0x30, 0x30, 0x32, 0x33, 0x35, 0x33, 0x29, 0x0D, 0x0A, 0x03, 0x6E );
		}
		else
		{
			return array( 0x15, 0x15, 0x15, 0x15, 0x15 );
		}
	}
	// DATE_()
	elseif( test_query( $H, array( 0x01, 0x52, 0x31, 0x02, 0x44, 0x41, 0x54, 0x45, 0x5F, 0x28, 0x29, 0x03, 0x56 ) ) )
	{
		return array( 0x02, 0x44, 0x41, 0x54, 0x45, 0x5F, 0x28, 0x30, 0x35, 0x2E, 0x32, 0x36, 0x2E, 0x31, 0x32, 0x2E, 0x31, 0x34, 0x29, 0x0D, 0x0A, 0x03, 0x07 );
	}
	// TIME_()
	elseif( test_query( $H, array( 0x01, 0x52, 0x31, 0x02, 0x54, 0x49, 0x4D, 0x45, 0x5F, 0x28, 0x29, 0x03, 0x67 ) ) )
	{
		return array( 0x02, 0x54, 0x49, 0x4D, 0x45, 0x5F, 0x28, 0x30, 0x39, 0x3A, 0x32, 0x30, 0x3A, 0x35, 0x31, 0x29, 0x0D, 0x0A, 0x03, 0x1E );
	}
	// STAT _()
	elseif( test_query( $H, array( 0x01, 0x52, 0x31, 0x02, 0x53, 0x54, 0x41, 0x54, 0x5F, 0x28, 0x29, 0x03, 0x74 ) ) )
	{
		return array( 0x02, 0x53, 0x54, 0x41, 0x54, 0x5F, 0x28, 0x30, 0x2C, 0x30, 0x29, 0x0D, 0x0A, 0x03, 0x12 );
	}
	// ET0P E()
	elseif( test_query( $H, array( 0x01, 0x52, 0x31, 0x02, 0x45, 0x54, 0x30, 0x50, 0x45, 0x28, 0x29, 0x03, 0x37 ) ) )
	{
		return chr( 0x02 )."ET0PE(60337.4928964)\r\nET0PE(31709.4245439)\r\nET0PE(28628.068352)\r\nET0PE(0,0)\r\nET0PE(0,0)\r\nET0PE(0,0)\r\n".chr(0x03).chr(0x34);
	}
	// .B0.u
	elseif( test_query( $H, array( 0x01, 0x42, 0x30, 0x03, 0x75 ) ) )
	{
		return "";
	}
	// 2F3F33210D0A   /?3!..
	elseif( test_query( $H, array( 0x2F, 0x3F, 0x33, 0x21, 0x0D, 0x0A ) ) )
	{
		return "/EKT5CE301v7\r\n";
		return array( 0x15, 0x15, 0x15, 0x15, 0x15 );
	}
	return $B;
}
	error_reporting( E_ALL );
   $address = "0.0.0.0";
   $port = 4544;
  
/* Включает скрытое очищение вывода так что мы получаем данные
 * как только они появляются. */
	ob_implicit_flush();

  $socket = socket_create(AF_INET, SOCK_STREAM, SOL_TCP);
   
	if (!socket_set_option($socket, SOL_SOCKET, SO_REUSEADDR, 1)) { 
		 echo socket_strerror(socket_last_error($socket)); 
		 exit; 
	} 

  if( !$socket ) exit( socket_strerror( socket_last_error() ) );
  else echo 'Socket_created!'."\r\n";
   
  if( !socket_bind($socket, $address, $port) ) exit( socket_strerror( socket_last_error() ) );
  else echo 'Socket_binded!'."\r\n";
   
  if( !socket_listen($socket, 10) ) exit( socket_strerror( socket_last_error() ) );
  else echo 'Socket_listen!'."\r\n";
  
  
  $connect = socket_accept($socket);
   echo 'Socket_accept!'."\r\n";
  socket_set_nonblock($socket);
  socket_set_option( $socket, SOL_SOCKET, SO_RCVTIMEO, array('sec'=>1,'usec'=>10000) );
  $result = '';
  $num = 0;
	// Засечь время начала передач
	$start = getmicrotime();

  while( trim($result) != "exit" and $num++ < 20 and (getmicrotime()-$start < 6)  )
  {
	   $result = @socket_read( $connect, 1024 );
		if( $result === false )
			break;
		$hex = '';
		$len = strlen($result);
	   echo "[$num: $len] read:".$hex."\r\n";
		for( $N=0; $N<$len; $N++ )
		{
		  printf( "%02X ", ord($result[$N]) );
		}
		echo PHP_EOL;
		//break;
		$answer = 'You sending me: '.$result."\r\n";
		$answer = generate_answer( $result );
		if( is_array( $answer ) )
		{
			$answer = implode( array_map( 'chr', $answer ) );
		}
	  socket_write( $connect, $answer);
  }
  @socket_shutdown($connect);
  @socket_close($socket);
  echo "Done".PHP_EOL;
   
