<?php
rrd_info();
die();
echo "<meta http-equiv='refresh' content='5'>";
 printf( "%04X <br />", mt_rand(1,0xffff) );
flush();
define( 'MODE_OFF',  0 );
define( 'MODE_ON',   1 );
define( 'MODE_AUTO', 2 );
define( 'LEVEL_ON', '70' );
define( 'LEVEL_OFF', '90' );
define( 'LEVEL_ONOFF', '70' );
define( 'LIGHT_OFF',  1 );
define( 'LIGHT_ON',   0 );
define( 'LIGHT_UNDEFINED', -1 );

$mode = MODE_OFF;
//$mode = MODE_ON;
$mode = MODE_AUTO;

$value_new = LIGHT_UNDEFINED;

$oid_light = "1.3.6.1.4.1.40418.2.4.4.3"; //Освещенность
$oid_ctrl  = "1.3.6.1.4.1.40418.2.4.2.3"; // Управление 

//	$session_light = new SNMP(SNMP::VERSION_1, "172.16.0.2", "public");
	$session_light = new SNMP(SNMP::VERSION_1, "192.168.5.56", "public");
	$session_ctrls = array();
	$session_ctrls[] = new SNMP(SNMP::VERSION_1, "192.168.5.56", "public");
//	$session_ctrls[] = new SNMP(SNMP::VERSION_1, "172.16.0.2", "public");
//	$session = new SNMP(SNMP::VERSION_1, "172.16.0.2", "public");
	
	printf ( "Режим работы: %s<br />", (MODE_AUTO == $mode) ? 'Автоматический' : 'Ручной' );
	if( $mode < MODE_AUTO )
	{
		if( MODE_ON == $mode )
		{
			$value_new = LIGHT_ON;
			printf ( "Ручной: Включено<br />" );
		}
		else if( MODE_OFF == $mode )
		{
			$value_new = LIGHT_OFF;
			printf ( "Ручной: Выключено<br />" );
		}
		
	}
	else
	{
		$arTimer = array(
			'0000' => MODE_AUTO,
			'0100' => MODE_OFF,
			'0500' => MODE_AUTO,
			'1655' => MODE_AUTO,
		);
		ksort($arTimer);
		ini_set( 'date.timezone','Asia/Yekaterinburg' );
		$DT = new DateTime();
		$NowHM = $DT->format('Hi');
		echo $NowHM.': <br />';
		$HMPrev = false;
		foreach( $arTimer as $iHM => $TimerMode )
		{
			if( $HMPrev === false )
			{
				$HMPrev = $iHM;
			}
			echo "$iHM => $TimerMode <br />";
			if( $NowHM < $iHM )
			{
				echo "F";
				break;
			}
			$HMPrev = $iHM;
		}
		$ModeTimer = $arTimer[$HMPrev];
		$mode = $arTimer[$HMPrev];
		echo "++++ $arTimer[$HMPrev] +++ <br />";

		if( MODE_ON == $mode )
		{
			$value_new = LIGHT_ON;
			printf ( "Таймер: Включено<br />" );
		}
		else if( MODE_OFF == $mode )
		{
			$value_new = LIGHT_OFF;
			printf ( "Таймер: Выключено<br />" );
		}
		else
		{
			printf ( "Таймер: Датчик осчещенности<br />" );
		}

	}
	
	
	
	$rez_light = @$session_light->get( $oid_light  );
//	var_dump($rez_light);
	if( $rez_light and preg_match( '/^[A-Z]+: (\d+)/', $rez_light, $match ) )
	{
		$value_light = $match[1];
		$light100 = min( 100, $value_light/5);
		printf( "Уровень освещения: %d%%<br />", $light100 );
	}
	else
	{
		$light100 = false;
		printf( "Уровень освещения: нет данных<br />" );
	}
//		$value_new = $value_cur == 0 
//			? '1' : '0';
	foreach( $session_ctrls as $K => $session_ctrl ) 
	{
		$rez_ctrl  = $session_ctrl->get( $oid_ctrl );
	//	var_dump($rez_ctrl);
		if( $rez_ctrl and preg_match( '/^[A-Z]+: (\d+)/', $rez_ctrl, $match ) )
		{
			$value_ctrl = $match[1];
			printf( "Состояние освещения [%s]: %s<br />", $K, ( LIGHT_OFF == $value_ctrl ) ? 'Выключено' : 'Включено' );
			if( LIGHT_OFF == $value_ctrl && MODE_AUTO == $mode && $light100 !== false )
			{
				$value_new = ( $light100 < LEVEL_ON ) ? LIGHT_ON : LIGHT_OFF;
				printf( "Состояние 1: l:%d < off:%d<br />", $light100 , LEVEL_ON, $K );
			}
			elseif( LIGHT_ON  == $value_ctrl && MODE_AUTO == $mode && $light100 !== false )
			{
				$value_new = ( $light100 > LEVEL_OFF ) ? LIGHT_OFF : LIGHT_ON;
				printf( "Состояние 2: l:%d  > off:%d<br />", $light100 , LEVEL_OFF, $K );
			}
		}
		else
		{
			printf( "Состояние освещения [%s]: нет данных<br />", $K );
		}

		if( $value_new != LIGHT_UNDEFINED and $value_ctrl != $value_new )
		{
			$session_ctrl->set( $oid_ctrl, 'i', $value_new );
			printf ( "Состояние Изменено [%s]: %s<br />", $K, (LIGHT_OFF ==$value_new) ? 'Выключено' : 'Включено' );
			$value_new = LIGHT_UNDEFINED;
		}
	}
?>
