<?php


$EqualConversions = array(
    "кВт*ч" => array(
        'Title'         => "кВт*ч",
        "Divider"       => "1000",
        "Round"         => "3",
        "InterpriseId"  => 0
    ),
    "кВар" => array(
        'Title'         => "кВар",
        "Divider"       => "1000",
        "Round"         => "3",
        "InterpriseId"  => 0
    ),
    "Ватт" => array(
        'Title'         => "Ватт",
        "Divider"       => "100",
        "Round"         => "2",
        "InterpriseId"  => 0
    ),
    "Вольт" => array(
        'Title'         => "Вольт",
        "Divider"       => "1000",
        "Round"         => "3",
        "InterpriseId"  => 0
    ),
    "куб" => array(
        'Title'         => "куб",
        "Divider"       => "1000",
        "Round"         => "2",
        "InterpriseId"  => 0
    ),
    "мм3 -> m3" => array(
        'Title'         => "мм3 -> m3",
        "Divider"       => "100",
        "Round"         => "2",
        "InterpriseId"  => 0
    ),
    "Вт*ч -> кВт*ч" => array(
        'Title'         => "Вт*ч -> кВт*ч",
        "Divider"       => "1000",
        "Round"         => "2",
        "InterpriseId"  => 0
    ),
    "кВт 0,0000" => array(
        'Title'         => "кВт 0,0000",
        "Divider"       => "1000",
        "Round"         => "4",
        "InterpriseId"  => 0
    ),
    "Ток Фаза(А)" => array(
        'Title'         => "Ток Фаза(А)",
        "Divider"       => "1000",
        "Round"         => "3",
        "InterpriseId"  => 0
    ),
    "Вт" => array(
        'Title'         => "Вт",
        "Divider"       => "1000",
        "Round"         => "3",
        "InterpriseId"  => 0
    ),
    "ВАр" => array(
        'Title'         => "ВАр",
        "Divider"       => "100",
        "Round"         => "2",
        "InterpriseId"  => 0
    )
);

foreach ( $EqualConversions as $title => $attrs ){
  $Filter = array(
      'Filter' => array(
          'Title'       => $title,
          'Interprise'  => $attrs['InterpriseId']
      )
  );
  $Res = conversion::Filter( $Filter );
  if( $Res->Count ){
    $Res->First->UpdateByArray( $attrs );
    $result[ 'Конвертации' ][] = array(
        'type' => 'warning',
        'msg' => "<b>[upgrade]</b> " . $title
    );
    continue;
  }
  $result[ 'Конвертации' ][] = array(
      'type' => 'success',
      'msg' => "<b>[add] </b>" . $title
  );
  conversion::AddByArray( $attrs );
}