<?php


$EqualConverterType = array(
    array(
        'Title' => 'SNR-CVT-SERIAL',
        'DllId' => 'SNR-CVT-SERIAL'
    ),
    array(
        'Title' => 'SNR-CVT-SERIAL-M1',
        'DllId' => 'SNR-CVT-SERIAL-M1'
    ),
    array(
        'Title' => 'SNR-GSM-SERIAL',
        'DllId' => 'SNR-CVT-SERIAL-M1'
    ),
    array(
        'Title' => 'SNR-ETH-SERIAL',
        'DllId' => 'SNR-CVT-SERIAL-M1'
    ),
    array(
        'Title' => 'SNR-Mbus',
        'DllId' => 'SNR-CVT-SERIAL-M1'
    ),
    array(
        'Title' => 'Простой TCP порт',
        'DllId' => 'SIMPLE_TCP'
    ),
    array(
        'Title' => 'Простой UDP порт',
        'DllId' => 'SIMPLE_UDP'
    ),
    array(
        'Title' => 'VIRTUAL',
        'DllId' => 'VIRTUAL'
    ),
    array(
        'Title' => 'CALC',
        'DllId' => 'CALC'
    ),
    array(
        'Title' => 'Базовая станция Вега Абсолют',
        'DllId' => 'VegaLora'
    )
);

foreach( $EqualConverterType as $EConverterType ){
  $Filter = array(
      'Filter' => $EConverterType
  );
  if( convertertype::Filter( $Filter )->Count ){
    $result[ 'Типы конвертеров' ][] = array(
        'type' => 'warning',
        'msg' => "<b>[upgrade]</b> " . $EConverterType['Title'].":".$EConverterType['DllId']
    );
    continue;
  }
  $result[ 'Типы конвертеров' ][] = array(
      'type' => 'success',
      'msg' => "<b>[add] </b>" . $EConverterType['Title'].":".$EConverterType['DllId']
  );
  convertertype::AddByArray( $EConverterType );
}