<?php


if( !loginfo::ByIdent( 'TIME_OUT' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Нет ответа',
    'Logtext' => 'TIME_OUT',
    'About' => 'Связь с точной опроса установлена верно, но с прибором связь установить не удалось',
  ));
}
if( !loginfo::ByIdent( 'OK' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Выполнено',
    'Logtext' => 'OK',
    'About' => 'Стандартные данные в системе, все в полном порядке',
  ));
}
if( !loginfo::ByIdent( 'ERROR' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Ошибка',
    'Logtext' => 'ERROR',
    'About' => 'Ошибка опроса, а так же любая другая ошибка значение которой не описано. Возможно проблемы с каналом связи, получена часть данных получена, получены в неверном формате',
  ));
}
if( !loginfo::ByIdent( 'NO_CONNECTION' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Нет связи',
    'Logtext' => 'NO_CONNECTION',
    'About' => 'Нет связи до точки опроса(конвертера) - может быть вызвано неисправностью самого устройства или канала связи',
  ));
}
if( !loginfo::ByIdent( 'OK_NOTFULL' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Не полное',
    'Logtext' => 'OK_NOTFULL',
    'About' => 'Применяется только для расчета группированных значений. Может возникать когда часть значений отсутствует. И не может быть восстановлена\nНапример за сутках присутствует менее 24 часовых значения.',
  ));
}
if( !loginfo::ByIdent( 'NOT_SUPPORTED' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Не поддерживается',
    'Logtext' => 'NOT_SUPPORTED',
    'About' => 'Прибор опрос данного параметра не поддерживает, из-за особенностей данной модификации прибора',
  ));
}
if( !loginfo::ByIdent( 'WRONG_SERIAL' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Несовпадение Серийного Номера',
    'Logtext' => 'WRONG_SERIAL',
    'About' => 'Опрос прибора выполнен, но на этапе сверки серийного номера обнаружилось несовпадение.<br>\nВозможные причины:<br>\n* Прибор занесен в базу неверное, или прибор поменяли.<br>\n* У прибора есть двойник по опросному номеру, и происходит конфликт запросов/ответов<br>',
  ));
}
if( !loginfo::ByIdent( 'OK_CULC' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Вычисляется',
    'Logtext' => 'OK_CULC',
    'About' => 'Появились новые данные на прибора. Значение поставлено в очередь на пересчет и будет обновлено в ближайшее время. т.е. скорее всего будет изменено',
  ));
}
if( !loginfo::ByIdent( 'NODATA' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Нет',
    'Logtext' => 'NODATA',
    'About' => 'Данные за запрашиваемую дату отсутствуют на приборе. Возможные причины:<br>\n* Прибор не работал в данный промежуток времени.<br>\n* Данные уже затерты новыми<br>',
  ));
}
if( !loginfo::ByIdent( 'UNKNOWN(0) need update' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'UNKNOWN(0) need update',
    'Logtext' => 'UNKNOWN(0) need update',
    'About' => '',
  ));
}
if( !loginfo::ByIdent( 'CONVERTER_SETUP_ERROR' )->Is ){
  loginfo::AddByArray(array(
    'Title' => 'Ошибка параметров связи',
    'Logtext' => 'CONVERTER_SETUP_ERROR',
    'About' => '',
  ));
}

