<?php



metertypeparameter::All()->DeleteAll();



$CacheParameters = array();
$FilterParameters = array(
	'Filter' => array(
		'Ident' => array('PRORILE_POWER_R_PLUS','PRORILE_POWER_R_MINUS','PRORILE_POWER_A_PLUS','PRORILE_POWER_A_MINUS' )
	)
);
foreach( parameter::Filter($FilterParameters)->Elements as $iParameter ){
	$CacheParameters[] = $iParameter;
}


$Filter = array(
	'Filter' => array(
		'DllId' => array("PSCH-4TM.05M.10")
	)
);
foreach( metertype::Filter($Filter)->Elements as $iMetertype ){
	foreach( $CacheParameters as $iParameter ){
		$FilterMeterTypeParameters = array(
			'Filter' => array(
				'Parameter' => $iParameter->Id,
				'Metertype' => $iMetertype->Id
			)
		);
		if( metertypeparameter::Filter( $FilterMeterTypeParameters )->Count ){
			continue;
		}
		metertypeparameter::AddByArray(array(
			'ParameterId' => $iParameter->Id,
			'MetertypeId' => $iMetertype->Id,
			'IsUse' => 1
		));
	}

}


$Filter = array(
	'Filter' => array(
		'DllId'=>'SANEXT_5704_MBUS'
	)
);
$SANEXT_5704_MBUS_Res = metertype::Filter($Filter);
if( $SANEXT_5704_MBUS_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_WATER',
				'SCOPE_M3',
				'POWER_W',
				'CONSUMPTION_M3H',
				'TEMP_POD',
				'TEMP_OBR',
				'TEMP_DIFF'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $SANEXT_5704_MBUS_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $SANEXT_5704_MBUS_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}






$Filter = array(
	'Filter' => array(
		'DllId'=>'SEB-2A.07.212'
	)
);
$SANEXT_5704_MBUS_Res = metertype::Filter($Filter);
if( $SANEXT_5704_MBUS_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'ENERGY_MAX',
				'PHASE1_CURRENT',
				'PHASE2_CURRENT',
				'PHASE3_CURRENT',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $SANEXT_5704_MBUS_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $SANEXT_5704_MBUS_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}









$Filter = array(
	'Filter' => array(
		'DllId'=>'SONOSAFE10'
	)
);
$SANEXT_5704_MBUS_Res = metertype::Filter($Filter);
if( $SANEXT_5704_MBUS_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'POWER_W',
				'SCOPE_M3',
				'SCOPE_M3_FLOW',
				'TEMP_POD',
				'TEMP_OBR',
				'TEMP_DIFF',
				'TEMP_EXTERNAL',
				'ENERGY_WATER'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $SANEXT_5704_MBUS_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $SANEXT_5704_MBUS_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}






$Filter = array(
	'Filter' => array(
		'DllId'=>'SPT_943'
	)
);
$SANEXT_5704_MBUS_Res = metertype::Filter($Filter);
if( $SANEXT_5704_MBUS_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'TOTAL_IN1_V1',
				'TOTAL_IN1_V2',
				'TOTAL_IN1_V3',
				'TOTAL_IN1_M1',
				'TOTAL_IN1_M2',
				'TOTAL_IN1_M3',
				'TOTAL_IN1_Q',
				'TOTAL_IN1_Ti',
				'TOTAL_IN1_Qg',
				'TOTAL_IN2_V1',
				'TOTAL_IN2_V2',
				'TOTAL_IN2_V3',
				'TOTAL_IN2_M1',
				'TOTAL_IN2_M2',
				'TOTAL_IN2_M3',
				'TOTAL_IN2_Q',
				'TOTAL_IN2_Ti',
				'TOTAL_IN2_Qg',
				'CUR_IN1_G1',
				'CUR_IN1_G2',
				'CUR_IN1_G3',
				'CUR_IN1_P1',
				'CUR_IN1_P2',
				'CUR_IN1_T1',
				'CUR_IN1_T2',
				'CUR_IN1_DT',
				'CUR_IN1_T3',
				'CUR_IN1_TH',
				'CUR_IN1_TV',
				'CUR_IN2_G1',
				'CUR_IN2_G2',
				'CUR_IN2_G3',
				'CUR_IN2_P1',
				'CUR_IN2_P2',
				'CUR_IN2_T1',
				'CUR_IN2_T2',
				'CUR_IN2_DT',
				'CUR_IN2_T3',
				'CUR_IN2_TH',
				'CUR_IN2_TV'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $SANEXT_5704_MBUS_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $SANEXT_5704_MBUS_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}



$Filter = array(
	'Filter' => array(
		'DllId'=>'PSCH-4TM.05M.10'
	)
);
$PSCH_4TM_05M_10_Res = metertype::Filter($Filter);
if( $PSCH_4TM_05M_10_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
				'ENERGY_TARIF_SUM',
				'PHASE1_CURRENT',
				'PHASE2_CURRENT',
				'PHASE3_CURRENT',
				'ENERGY_TARIF3',
				'ENERGY_TARIF4',
				'TEMP',
				'ENERGY_TARIF_LOST',
				'PRORILE_POWER_R_PLUS',
				'PRORILE_POWER_R_MINUS',
				'PRORILE_POWER_A_PLUS',
				'PRORILE_POWER_A_MINUS'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $PSCH_4TM_05M_10_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $PSCH_4TM_05M_10_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'CE102M'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_VOLTAGE',
				'PHASE1_CURRENT',
				'INSTANT_POWER',
				'CURRENT_FREQUENCY',
				'COEF_POWER'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'CE102'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'CARAT_213'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_WATER',
				'TEMP_POD',
				'TEMP_OBR',
				'TEMP_DIFF',
				'SCOPE_M3_FLOW',
				'SCOPE_CONS_IMP1',
				'SCOPE_CONS_IMP2',
				'SCOPE_CONS_IMP3'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_CI_11'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'COUNT_2',
				'COUNT_3',
				'COUNT_4',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}



$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_CI_13_MER'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'COUNT_2',
				'COUNT_3',
				'COUNT_4',
				'COUNT_5',
				'COUNT_6',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}





$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_CI_12'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'COUNT_2',
				'COUNT_3',
				'COUNT_4',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_CI_21'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'COUNT_2',
				'COUNT_3',
				'COUNT_4',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_TD_11'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_TP_11'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}





$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_MC_0101'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}





$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_AS_0101'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}






$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_MS_0101'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}






$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_CBE1'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}








$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_SS_0101'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}








$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_Electro'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}








$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_GM_2'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}









$Filter = array(
	'Filter' => array(
		'DllId'=>'LORA_LM_1'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'COUNT_1',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}


$Filter = array(
	'Filter' => array(
		'DllId'=>'CE301M'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}


$Filter = array(
	'Filter' => array(
		'DllId'=>'CE301'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
				'PHASE1_CURRENT',
				'PHASE2_CURRENT',
				'PHASE3_CURRENT',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}


$Filter = array(
	'Filter' => array(
		'DllId'=>'CE6822'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}











$Filter = array(
	'Filter' => array(
		'DllId'=>'MIRT1'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_VOLTAGE',
				'PHASE1_CURRENT',
				'PHASE1_POWER',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}









$Filter = array(
	'Filter' => array(
		'DllId'=>'MAYAK_101_AT'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}





$Filter = array(
	'Filter' => array(
		'DllId'=>'MERCURY_225_1'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}







$Filter = array(
	'Filter' => array(
		'DllId'=>'MERCURY_206'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_LOST',
				'PHASE1_VOLTAGE',
				'PHASE1_POWER',
				'PHASE1_CURRENT',
				'BATTARY_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}












$Filter = array(
	'Filter' => array(
		'DllId'=>'MILUR104'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_VOLTAGE',
				'PHASE1_CURRENT',
				'PHASE1_POWER',
				'BATTARY_VOLTAGE'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}

















$Filter = array(
	'Filter' => array(
		'DllId'=>'MILUR305.32R'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'ENERGY',
					'ENERGY_TARIF1',
					'ENERGY_TARIF2',
					'ENERGY_TARIF_SUM',
					'PHASE1_POWER',
					'PHASE2_POWER',
					'PHASE3_POWER',
					'PHASE1_VOLTAGE',
					'PHASE2_VOLTAGE',
					'PHASE3_VOLTAGE',
					'PHASE1_CURRENT',
					'PHASE2_CURRENT',
					'PHASE3_CURRENT',
					'BATTARY_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}



$Filter = array(
	'Filter' => array(
		'DllId'=>'MILUR304'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'ENERGY',
					'ENERGY_TARIF1',
					'ENERGY_TARIF2',
					'ENERGY_TARIF_SUM',
					'ENERGY_TARIF1_REACTIVE_P',
					'ENERGY_TARIF2_REACTIVE_P',
					'ENERGY_TARIF_SUM_REACTIVE_P',
					'PHASE1_POWER',
					'PHASE2_POWER',
					'PHASE3_POWER',
					'PHASE_POWER_SUM',
					'PHASE1_POWER_R',
					'PHASE2_POWER_R',
					'PHASE3_POWER_R',
					'PHASE_POWER_R_SUM',
					'PHASE1_POWER_F',
					'PHASE2_POWER_F',
					'PHASE3_POWER_F',
					'PHASE_POWER_F_SUM',
					'PHASE1_VOLTAGE',
					'PHASE2_VOLTAGE',
					'PHASE3_VOLTAGE',
					'PHASE1_CURRENT',
					'PHASE2_CURRENT',
					'PHASE3_CURRENT',
					'PARAMETER_BATTARY_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}











$Filter = array(
	'Filter' => array(
		'DllId'=>'MIRT3_CLASS1'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'ENERGY',
					'ENERGY_TARIF1',
					'ENERGY_TARIF2',
					'ENERGY_TARIF_SUM',
					'PHASE1_POWER',
					'PHASE2_POWER',
					'PHASE3_POWER',
					'PHASE1_VOLTAGE',
					'PHASE2_VOLTAGE',
					'PHASE3_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}


















$Filter = array(
	'Filter' => array(
		'DllId'=>'SNR_RS_COUNTER_8I'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'COUNT_1',
					'COUNT_2',
					'COUNT_3',
					'COUNT_4',
					'COUNT_5',
					'COUNT_6',
					'COUNT_7',
					'COUNT_8'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}











$Filter = array(
	'Filter' => array(
		'DllId'=>'NEVA_MT123'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_POWER',
				'PHASE1_CURRENT',
				'PHASE1_VOLTAGE',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}










$Filter = array(
	'Filter' => array(
		'DllId'=>'NEVA_MT324'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(

				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'ENERGY_TARIF1_REACTIVE_P',
				'ENERGY_TARIF2_REACTIVE_P',
				'ENERGY_TARIF1_REACTIVE_M',
				'ENERGY_TARIF2_REACTIVE_M',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
				'PHASE1_CURRENT',
				'PHASE2_CURRENT',
				'PHASE3_CURRENT',
				'PHASE1_POWER_ACTIVE',
				'PHASE2_POWER_ACTIVE',
				'PHASE3_POWER_ACTIVE',
				'PHASE1_POWER_FACTOR',
				'PHASE2_POWER_FACTOR',
				'PHASE3_POWER_FACTOR',
				'SUPPLY',
				'TEMP'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}







$Filter = array(
	'Filter' => array(
		'DllId'=> array('PSCH-3TA.07.112.2','PSCH-3ART')
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_MAX',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_CURRENT',
				'PHASE2_CURRENT',
				'PHASE3_CURRENT',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}








$Filter = array(
	'Filter' => array(
		'DllId'=> 'PSCH-4TM.05M.10'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'ENERGY_TARIF_LOST',
				'PHASE1_CURRENT',
				'PHASE2_CURRENT',
				'PHASE3_CURRENT',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
				'TEMP',
				'PRORILE_POWER_R_PLUS',
				'PRORILE_POWER_R_MINUS',
				'PRORILE_POWER_A_PLUS',
				'PRORILE_POWER_A_MINUS'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}

	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_MAX',
				'ENERGY_TARIF3',
				'ENERGY_TARIF4'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::Filter($FilterMTP)->DeleteAll();
		}
	}
}











$Filter = array(
	'Filter' => array(
		'DllId'=>'MERCURY_230_ART_03_CN'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'ENERGY_TARIF1',
					'ENERGY_TARIF2',
					'ENERGY_TARIF_SUM',
					'ENERGY_TARIF_LOST',
					'ENERGY_TARIF1_REACTIVE_P',
					'ENERGY_TARIF2_REACTIVE_P',
					'ENERGY_TARIF1_REACTIVE_M',
					'ENERGY_TARIF2_REACTIVE_M',
					'ENERGY_TARIF1_ACTIVE_M',
					'ENERGY_TARIF2_ACTIVE_M',
					'ENERGY_TARIF_SUM_ACTIVE_M',
					'ENERGY_TARIF_SUM_REACTIVE_P',
					'ENERGY_TARIF_SUM_REACTIVE_M',
					'PHASE1_VOLTAGE',
					'PHASE2_VOLTAGE',
					'PHASE3_VOLTAGE',
					'PHASE1_CURRENT',
					'PHASE2_CURRENT',
					'PHASE3_CURRENT',
					'PHASE1_POWER',
					'PHASE2_POWER',
					'PHASE3_POWER',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}








$Filter = array(
	'Filter' => array(
		'DllId'=>'MERCURY_230'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'ENERGY',
					'ENERGY_TARIF1',
					'ENERGY_TARIF2',
					'ENERGY_TARIF_SUM',
					'ENERGY_TARIF_LOST',
					'ENERGY_TARIF1_REACTIVE_P',
					'ENERGY_TARIF2_REACTIVE_P',
					'ENERGY_TARIF1_REACTIVE_M',
					'ENERGY_TARIF2_REACTIVE_M',
					'ENERGY_TARIF1_ACTIVE_M',
					'ENERGY_TARIF2_ACTIVE_M',
					'ENERGY_TARIF_SUM_ACTIVE_M',
					'ENERGY_TARIF_SUM_REACTIVE_P',
					'ENERGY_TARIF_SUM_REACTIVE_M',
					'PHASE1_VOLTAGE',
					'PHASE2_VOLTAGE',
					'PHASE3_VOLTAGE',
					'PHASE1_CURRENT',
					'PHASE2_CURRENT',
					'PHASE3_CURRENT',
					'PHASE1_POWER',
					'PHASE2_POWER',
					'PHASE3_POWER',
					'PRORILE_POWER_R_PLUS',
					'PRORILE_POWER_R_MINUS',
					'PRORILE_POWER_A_PLUS',
					'PRORILE_POWER_A_MINUS',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}







$Filter = array(
	'Filter' => array(
		'DllId'=>'STE_561_MC'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
					'ENERGY_TARIF1',
					'ENERGY_TARIF2',
					'ENERGY_TARIF_SUM',
					'PHASE1_VOLTAGE'
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}






$Filter = array(
	'Filter' => array(
		'DllId'=>'SET_4TM_02M'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_VOLTAGE',
				'PHASE2_VOLTAGE',
				'PHASE3_VOLTAGE',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'SEB-1TM.02D'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'PHASE1_VOLTAGE',
				'PHASE1_CURRENT',
				'PHASE1_POWER',
				'TEMP',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}




$Filter = array(
	'Filter' => array(
		'DllId'=>'STE_561_RS'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}





$Filter = array(
	'Filter' => array(
		'DllId'=>'MERCURY_234'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
				'ENERGY_TARIF_LOST',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}



$Filter = array(
	'Filter' => array(
		'DllId'=>'SKAT_105'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
				'ENERGY_TARIF_SUM',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}



$Filter = array(
	'Filter' => array(
		'DllId'=>'SPT_941'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'TOTAL_IN1_V1',
				'TOTAL_IN1_V2',
				'TOTAL_IN1_V3',
				'TOTAL_IN1_M1',
				'TOTAL_IN1_M2',
				'TOTAL_IN1_M3',
				'TOTAL_IN1_Q',
				'TOTAL_IN1_Ti',
				'TOTAL_IN1_Qg',
				'TOTAL_IN2_V1',
				'TOTAL_IN2_V2',
				'TOTAL_IN2_V3',
				'TOTAL_IN2_M1',
				'TOTAL_IN2_M2',
				'TOTAL_IN2_M3',
				'TOTAL_IN2_Q',
				'TOTAL_IN2_Ti',
				'TOTAL_IN2_Qg',
				'CUR_IN1_G1',
				'CUR_IN1_G2',
				'CUR_IN1_G3',
				'CUR_IN1_P1',
				'CUR_IN1_P2',
				'CUR_IN1_T1',
				'CUR_IN1_T2',
				'CUR_IN1_DT',
				'CUR_IN1_T3',
				'CUR_IN1_TH',
				'CUR_IN1_TV',
				'CUR_IN2_G1',
				'CUR_IN2_G2',
				'CUR_IN2_G3',
				'CUR_IN2_P1',
				'CUR_IN2_P2',
				'CUR_IN2_T1',
				'CUR_IN2_T2',
				'CUR_IN2_DT',
				'CUR_IN2_T3',
				'CUR_IN2_TH',
				'CUR_IN2_TV',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}


$Filter = array(
	'Filter' => array(
		'DllId'=>'BARS_1_211'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}


$Filter = array(
	'Filter' => array(
		'DllId'=>'PSCH-3TA.07.112.2'
	)
);
$CE102M_Res = metertype::Filter($Filter);
if( $CE102M_Res->Count ){
	$Parameters = array(
		'Filter' => array(
			'Ident' => array(
				'ENERGY',
				'ENERGY_MAX',
				'ENERGY_TARIF1',
				'ENERGY_TARIF2',
			)
		)
	);
	foreach( parameter::Filter($Parameters)->Elements as $iParameter ){

		$FilterMTP = array(
			'Filter'=>array(
				'Metertype' => $CE102M_Res->First->Id,
				'Parameter' => $iParameter->Id
			)
		);
		if( !metertypeparameter::Filter($FilterMTP)->Count ){
			metertypeparameter::AddByArray(array(
				'MetertypeId' => $CE102M_Res->First->Id,
				'ParameterId' => $iParameter->Id,
				'IsUse' =>1
			));
		}
	}
}
