<?php

$EqualsTimezone = array(
    array(
      'Ident' => 'Europe/London',
      'Title' => 'UTC+00:00',
      'Diff'  => '0',
    ),
    array(
      'Ident' => '',
      'Title' => 'UTC+01:00',
      'Diff'  => '60',
    ),
    array(
      'Ident' => 'Europe/Kaliningrad',
      'Title' => 'UTC+02:00',
      'Diff'  => '120',
    ),
    array(
      'Ident' => 'Europe/Moscow',
      'Title' => 'UTC+03:00',
      'Diff'  => '180',
    ),
    array(
      'Ident' => 'Europe/Samara',
      'Title' => 'UTC+04:00',
      'Diff'  => '240',
    ),
    array(
      'Ident' => 'Asia/Yekaterinburg',
      'Title' => 'UTC+05:00',
      'Diff'  => '300',
    ),
    array(
      'Ident' => 'Asia/Omsk',
      'Title' => 'UTC+06:00',
      'Diff'  => '360',
    ),
    array(
      'Ident' => 'Asia/Krasnoyarsk',
      'Title' => 'UTC+07:00',
      'Diff'  => '420',
    ),
    array(
      'Ident' => 'Asia/Krasnoyarsk',
      'Title' => 'UTC+07:00',
      'Diff'  => '420',
    ),
    array(
      'Ident' => 'Asia/Irkutsk',
      'Title' => 'UTC+08:00',
      'Diff'  => '480',
    ),
    array(
      'Ident' => 'Asia/Vladivostok',
      'Title' => 'UTC+10:00',
      'Diff'  => '600',
    ),
    array(
      'Ident' => 'Asia/Kamchatka',
      'Title' => 'UTC+11:00',
      'Diff'  => '660',
    ),
    array(
      'Ident' => 'Asia/Kamchatka',
      'Title' => 'UTC+11:00',
      'Diff'  => '720',
    ),
    array(
      'Ident' => 'Asia/Yakutsk',
      'Title' => 'UTC+12:00',
      'Diff'  => '540',
    )
);

foreach( $EqualsTimezone as $iTimezone ){
  $Filter = array(
      'Filter' => array(
          'Diff' => $iTimezone['Diff']
      )
  );
  if( timezone::Filter( $Filter )->Count ){
    timezone::Filter( $Filter )->First->UpdateByArray( $iTimezone );
    $result[ 'Временные зоны' ][] = array(
        'type' => 'warning',
        'msg' => "<b>[upgrade] </b>" .timezone::Filter( $Filter )->First->Ident
    );
  }else{
    $oTimezone = timezone::AddByArray( $iTimezone );
    $result[ 'Временные зоны' ][] = array(
        'type' => 'success',
        'msg' => "<b>[add] </b>" .$oTimezone->Ident
    );
  }
}