<?php
// ver 0.1.1
// md5=
class TListGroup extends TObject2
{
	static public $Debug = false;
  protected $FElements = null;
  protected $FCount = 0;

  protected $FSqlQuery;
  protected $FFrom = 0;
//  protected $FMax = 0;
  protected $FObj = null;
  protected $FGroupBy = array();

  /* äëÿ ñîâìåñòèìîñòè */
  protected $_F = Array();
  protected $_ID = 'Id';

  public function GetClassName(){
    return 'TListGroup'; //get_class($this);
  }

  static function Init(){
    return new TListGroup();
  }

  static function &Prepare(&$Sql, $obj=null) {
    $list = new TListGroup();
    $list->FObj = $obj;
    preg_match('/(.+)(?: limit (?:(\d*),)?(\d+))?$/Uium',$Sql,$aMatches);
    if( !isset($aMatches[3]) )
    {
    	//$sql_count  = preg_replace( '/SELECT (.*) FROM/Ui', 'SELECT COUNT(*) FROM', $Sql, 1 );
      //$sql_count  = preg_replace( '/SELECT (.*) FROM/Ui', 'SELECT SQL_CALC_FOUND_ROWS COUNT(*) FROM', $Sql, 1 );
      $sql_count = "SELECT COUNT(*) as `COUNT` FROM ( {$Sql} ) Q";
      $res = DB::FetchArraySelect($sql_count);
      if( count($res) ){
      	list($count) = $res;
      }else{
      	$count = 0;
      }
      $list->FCount = intval($count);
    }
    else
    {
      $list->FCount = intval($aMatches[3]);
    }
    $list->FFrom = isset($aMatches[2]) ? intval($aMatches[2]) : 0;
    $list->FSqlQuery = $aMatches[1];
    return $list;
  }
  
  public function GetSqlOnlyId()
  {
		$t = $this->FObj;
    return preg_replace( '/SELECT (.*) FROM/Ui', 'SELECT `'.$t->_Id['sql'].'` FROM', $this->FSqlQuery, 1 );
  }
  
  public function GetSqlOnlyFields()
  {
		$t = $this->FObj;
    return preg_replace( '/SELECT (.*) FROM/Ui', 'SELECT `'.$t->Finit['Whyid']['sql'].'` FROM', $this->FSqlQuery, 1 );
  }
  
  public function GetSqlTmeterFconverter()
  {
		$t = $this->FObj;
    return preg_replace( '/SELECT (.*) FROM/Ui', 'SELECT `'.$t->Finit['Converter']['sql'].'` FROM', $this->FSqlQuery, 1 );
  }
  
  public function GroupBy( $count ) {
    if( self::$Debug ) {
    	echo var_dump( "{$this->FFrom}->({$this->FFrom}+{$this->FCount}) GroupBy( $count )  " );

    }
  
    $count = max( intval($count) ,1 );
    if( !isset( $this->FGroupBy[$count] ) ) {
//      if($this->FMax>0 and $this->FMax<$count) $count = $this->FMax;
      $this->FGroupBy[$count] = new TListGroup();
      for( $g=0; $g < ceil( $this->FCount/$count ); $g++ ){
        $from = $count*$g + $this->FFrom;
        $lim = min( $this->FFrom+$this->FCount-$from, $count );
        $sql = $this->FSqlQuery." LIMIT {$from},{$lim}";
        $this->FGroupBy[$count]->Add(
          TListGroup::Prepare($sql,$this->FObj)
        );
      }
    }
    return $this->FGroupBy[$count];
  }

  public function AddFirst($el) {
    array_unshift($this->FElements, $el);
    $this->FCount++;
  }
  
  public function SortConverter(){
    //~ usort( $this->FElements , function( $a , $b ){
      //~ return strnatcasecmp( $a->Title , $b->Title );
    //~ });
  }
  
  /**
   * @brief Сортировка пользователей
   * @returns null
   */
  public function SortUser(){
    //~ usort( $this->FElements , function( $a , $b ){
      //~ $l1 = $a->Fio == "" ? $a->Login : $a->Fio;
      //~ $l2 = $b->Fio == "" ? $b->Login : $b->Fio;
      //~ return strnatcasecmp( $l1 , $l2 );
    //~ });
  }
  
  public function SortRule(){
    //~ usort( $this->FElements , function( $a , $b ){
      //~ return strnatcasecmp( $a->Name , $b->Name );
    //~ });
  }
  
  public function Add($el) {
    $this->FElements[$this->FCount++] = $el;
  }

  public function SetLimit($el) {
    $this->FCount = $el;
  }

  protected function GetCount(){
    return $this->FCount;
  }

  protected function GetSqlQuery(){
		$B = $this->FSqlQuery!='' ? "{$this->FSqlQuery} LIMIT {$this->FFrom},{$this->Count}" : '';
    return $this->FSqlQuery!='' ? "{$this->FSqlQuery} LIMIT {$this->FFrom},{$this->Count}" : '';
  }

  function DeleteAll() {
    $this->LoadElements();
    foreach( $this->FElements as $iElement ) $iElement->Delete();
    $this->FElements = Array();
    $this->FCount=0;

  }

  protected function &GetElements() {
    $this->LoadElements();
    return $this->FElements;
  }
  
  protected function GetFirst()
  {
		if( isset($this->FElements[0]) ) {
			return $this->FElements[0];
		}
		
		$obj = get_class($this->FObj);
		
    if ($this->Count == 0 ) {
      if( in_array( $obj, Array('TListGroup') ) )
        return false;
      return $obj::Id(0);
    }
    $ArFirst = TObject2::DataLoadSqlToArray( $this->FObj, $this->FSqlQuery." LIMIT 1 /*First*/" );
    
    if( isset( $ArFirst[0] ) ){
			return $ArFirst[0];
		}
    if( in_array( $obj, Array('TListGroup') ) )
        return false;
      return $obj::Id(0);
  }
  
  
  protected function GetElementsFreeMem()
  {
  	if(isset($GLOBALS['AUTOTEST']) && $GLOBALS['AUTOTEST']){
  		return false;
  	}
  	
    if( isset( $this->FElements ) )
    {
      for( $i=count($this->FElements)-1; $i>=0 ; $i-- )
      {
        if( isset($this->FElements[$i]) && is_object($this->FElements[$i]) )
              if( property_exists( $this->FElements[$i] , 'Desctruct') ){
                $this->FElements[$i]->Desctruct(); 
              }elseif( property_exists( $this->FElements[$i] , '__destruct') ){
                $this->FElements[$i]->__destruct();
              }
      }
      $this->FElements = null;
    }
  }
  
  function SetFElements( $ar ){
    $this->FElements = $ar;
  }

  function __destruct()
  {
    $this->GetElementsFreeMem();
    parent::__destruct();
  }
  
  protected function GetSql()
  {
    return $this->SqlQuery;
  }
  
  public function LoadElements()
  {
    if($this->FElements === null)
    {
      $this->FElements = Array();
      if($this->FCount>0)
      {
        $sql = $this->SqlQuery;
        if( $this->FObj != NULL )
        {
          $this->FElements = TObject2::DataLoadSqlToArray( $this->FObj, $sql );
        }
        else
        {
          $rez = DB::Select( $this->SqlQuery );
          while( $Arr = DB::FetchArray( $rez ) )
          {
            $this->FElements[] = $Arr;
          } 
        }
      }
    }
  }

  public function __get($p) {
    if(preg_match("/^GroupBy(\d+)$/",$p,$m)) return $this->GroupBy($m[1]);
    else return parent::_get($this,$p);
  }
}
?>
