<?php




/*
  Все необходимое для дебага
  К функционированию класса не относится.
  
  доступно по адресу /include/MYSQL_LOG/
  
*/
define( "ERROR_FILE_LOG"    , __DIR__."/../MYSQL_LOG.log" ); // файл куда пишем
define( "ERROR_REP_TMYSQL"  , 0                           ); // пишем или нет
define( "ERROR_REW_TMYSQL"  , 0                           ); // перезаписывать старый лог

// Если перезаписываем
if( ERROR_REW_TMYSQL ){
  file_put_contents( ERROR_FILE_LOG , "// Запись стека выполнения функций класса TMysql " . __FILE__ . "\n\n"  ); // Очистка лога . Раскомментировать для очистки
}

// если пишем лог
if( ERROR_REP_TMYSQL ){
  file_put_contents( ERROR_FILE_LOG , "\n----------------{$_SERVER['REQUEST_URI']}---------------\n\n" , FILE_APPEND );
  $str = sprintf("%15s%12s%10s%15s%36s\n" , "TIME","LINE","FUNCTION","MESSAGE" , "STAT CONNECT");
  file_put_contents( ERROR_FILE_LOG , $str , FILE_APPEND );
}



/*
  Запись лога в файл
  @param String строка из которой вызвали 
  @param String функция из которой вызвали 
  @param String сообщение лога 
*/
function LOG_SERGEY( $l = "0" , $f = "--" , $m = "--" ){
  if( !ERROR_REP_TMYSQL ){
    return true;
  }
  $t = new DateTime("now" , new DateTimeZone('Asia/Yekaterinburg'));
  $str = sprintf("[%20s] %-5u %-15s %-30s %-15s\n", 
                  $t->format("Y-m-d H:i:s"), $l ,            $f ,            $m , TMysql::StatusConnect() );
  file_put_contents( ERROR_FILE_LOG , $str , FILE_APPEND );
} 








/**
 * Соединения нет
 */
define('NO_CONNECTION'  , 0);

/**
 * Соединение с ошибкой
 */
define('UNDEFINDED'     , 1);

/**
 * Соединение успешно
 */
define('CONNECTED'      , 2);



// ver 1.2.38
// md5=bb2dc09e7dbf13836b10aa9ed1619df9
class TMysql extends TObject2{
  
  
  
  /*
    Получение статуса подключения
    @return String Статус подключения к серверу
  */
  static function StatusConnect(){
    if( !is_object( self::$FLink ) ){
      return NO_CONNECTION;
    }
    if( !self::$FLink->client_info ){
      return UNDEFINDED;
    }
    return CONNECTED;
  }
  
  
  
  
	static private $FObject = null;
	static protected $FLink = null;
	static protected $FQuerys;
	static private $FQuerysTime;
	static private $FQuerysTimeMax;
	static private $FResult;
	static private $FLastTimestamp = null;
	static private $FExecCount = 0;
	const  EXEC_PHP_CODE = 'EXEC PHP CODE';
	
	const DRIVER_MYSQL = 1;
	const DRIVER_MYSQLI = 2;
	
	static $DB_DRIVER = 1;
	
	static $Taskcron = false;
	static $ResultCron = array(
		'UpDB' => array(
			'Count' => 0,
			'Time'  => 0
		),
		'SelDB' => array(
			'Count' => 0,
			'Time'  => 0
		)
	);

  private $NoError = true;

	/*
  static public function ListFields($Table) {
    $Table = str_replace('`','',$Table);
    $R = self::Select("SELECT * FROM {$Table} LIMIT 0");
		return mysqli_fetch_fields($R);
  }
  */

  static function Init() {
    
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    if(self::$FObject === null){
      self::$FObject = new self();
    }
    return self::$FObject;
  }

  protected function __construct() {
    
    LOG_SERGEY( __LINE__ , __FUNCTION__ , " Sterted" );
    
		if( extension_loaded('mysqli') ){
			self::$DB_DRIVER = self::DRIVER_MYSQLI;
		}else{
			self::$DB_DRIVER = self::DRIVER_MYSQL;
		}
    
    LOG_SERGEY( __LINE__ , __FUNCTION__ , " Driver: " . self::$DB_DRIVER );
    
  }
  
  function __destruct(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    //~ if( isset($this->_Update) and $this->_Update){
      //~ TObject2::_SqlUpdate($this);
    //~ }
    if( TObject2::Desctruct() ){
      //~ TObject2::SaveAllObjects();
      if( 
        is_object(self::$FLink) && 
        property_exists(self::$FLink , 'client_info') && 
        self::$FLink->client_info 
      ) mysqli_close(self::$FLink);
      self::$FLink = null;
    }
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
  }

  //~ function __destruct() {
    //~ TObject2::SaveAllObjects();
    //~ LOG_SERGEY( __LINE__ , __FUNCTION__ );
    //~ mysqli_close(self::$FLink);
    //~ self::$FLink = null;
  //~ }
  
  
  
  //~ static function Close(){
    //~ LOG_SERGEY( __LINE__ , __FUNCTION__ );
    //~ mysqli_close(self::$FLink);
    //~ self::$FLink = null;
  //~ }
  
  
  
  
  
  
  
  
  
  

  function IsReady(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
  	return (self::$FLink!==null);
  }
  
  
  
  
  
  static $reconect_counter = 0;
  
  
  
  

  private function Connect(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    if( is_resource(self::$FLink) or is_object(self::$FLink) ){
      LOG_SERGEY( __LINE__ , __FUNCTION__ , "Connection object valid" );
      return true;
    }
    
    LOG_SERGEY( __LINE__ , __FUNCTION__ , "FIRST INIT" );
    
    if( !isset($GLOBALS['CONFIG'],$GLOBALS['CONFIG']['SQL'])
      or $CFG = &$GLOBALS['CONFIG']['SQL'] and !isset($CFG['SERVER'],$CFG['USER'],$CFG['PASSWORD'])
    )
      throw new Exception ('Нет настроек связи с сервером базы данных');
    if(
    	isset( $GLOBALS['CronRun'], $GLOBALS['CONFIG']['CRON_SQL'] )
    	and $GLOBALS['CronRun']
    	and isset(
    		$GLOBALS['CONFIG']['CRON_SQL']['SERVER'],
    		$GLOBALS['CONFIG']['CRON_SQL']['USER'],
    		$GLOBALS['CONFIG']['CRON_SQL']['PASSWORD'],
    		$GLOBALS['CONFIG']['CRON_SQL']['DATABASE']
    	)
   	){
    	$CFG = &$GLOBALS['CONFIG']['CRON_SQL'];
    }
    
    $error = "";

    if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			$connect = mysql_connect($CFG['SERVER'], $CFG['USER'], $CFG['PASSWORD'], $CFG['DATABASE']);
			$error = mysql_error();
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
      if( $GLOBALS['CONFIG']['DEBUG'] ){
        $connect = new mysqli($CFG['SERVER'], $CFG['USER'], $CFG['PASSWORD']);
      }else{
        $connect = new mysqli($CFG['SERVER'], $CFG['USER'], $CFG['PASSWORD']);
      }
			$error = $connect->connect_error;
		}
    
    if( $error ){
      
        smarty()->assign('error' , $error);
      
        if( preg_match('/^Access denied/' , $error) ){
          smarty()->display('error/access.tpl');
        }elseif( preg_match('/max_user_connections/' , $error) ){
          smarty()->display('error/max_user_connections.tpl');
        }elseif( preg_match('/Connection refused/' , $error) ){
          smarty()->display('error/connection_refused.tpl');
        }elseif( preg_match('/php_network_getaddresses/' , $error) ){
          smarty()->display('error/connection_host.tpl');
        }elseif( preg_match('/Operation timed out/' , $error) ){
          smarty()->display('error/timeout.tpl');
        }
        
      die();
    }
    
    if( !$connect ){
      smarty()->display('error/not_connect.tpl');
      die();
    }
		
    self::$FLink = $connect or die("= Ошибка связи с сервером: " . $error);
    
    /*
    $res = self::$FLink->query("SHOW STATUS");
    while( $a = $res->fetch_assoc() ){
    	var_dump($a);
    }
    array(2) {
			["Variable_name"]=>
			string(15) "Aborted_clients"
			["Value"]=>
			string(1) "9"
		}
    */
    
	  if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			if( !mysql_select_db($CFG['DATABASE'], self::$FLink) ){
        throw new Exception ("Ошибка выбора базы данных: ".$CFG['DATABASE']);
      }
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
      if( !self::$FLink->select_db($CFG['DATABASE'] ) ){
        self::$FLink->query( "CREATE SCHEMA `{$CFG['DATABASE']}` DEFAULT CHARACTER SET utf8" );
        self::$FLink = null;
        $this->Connect();
      }
		}
    
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			if( !mysql_query("SET NAMES utf8",self::$FLink) ) throw new Exception ("Ошибка установки русской кодировки.");
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			if( !self::$FLink->set_charset("utf8") ) throw new Exception ("Ошибка установки русской кодировки.");
		}
    
//    if( !mysql_query("SET CHARACTER SET utf8",self::$FLink) ) throw new Exception ("Ошибка установки русской кодировки.");
    if( $dolog=1 ){
      self::$FQuerys = TListGroup::Init();
      self::$FQuerysTime = 0;
      self::$FQuerysTimeMax = 0;
    }
    
    LOG_SERGEY( __LINE__ , __FUNCTION__ , "START PROFILING" );
    
    $SQL1 = "SELECT @@profiling";
    $res = DB::MMQ($SQL1);
    DB::Log($SQL1);
    
    $SQL1 = "set profiling_history_size=100";
    $res = DB::MMQ($SQL1);
    DB::Log($SQL1);
    
    $SQL2 = "SET profiling = 1";
    $res = DB::MMQ($SQL2);
    DB::Log($SQL2 );
    
  }
  private function ConnectError(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    throw new Exception ("Ошибка связи с базой данных.");
  }
  
  # Массив для стека вызовов умерших блокировок, во избежание зацикленности
  static $DeadlockArray = array();
  
  static function QueryError($query)
  {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			$error = mysql_error(self::$FLink);
			$errno = mysql_errno(self::$FLink);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			$error = self::$FLink->error;
			$errno = self::$FLink->errno;
		}
		
    if( preg_match( '/(.*)\-\-read\-only(.*)/' , $error )  or preg_match('/(.*)command denied(.*)/' , $error)){
      $GLOBALS['ReadDataBases'] = true;
      return true;
    }elseif( preg_match( '/Deadlock found when trying to get lock(.*)/' , $error ) || preg_match( '/Lock wait timeout exceeded(.*)/' , $error ) ){
			$key = md5($query);
			if( isset( self::$DeadlockArray[$key] ) ){
				throw new Exception ($error."<br>$query",$errno);
			}
			self::$DeadlockArray[$key] = $query;
			DB::Query($query);
			return true;
		}
		if( preg_match( '/(.*)\.user_session\'\ doesn\'t\ exist/' , self::$FLink->error ) ){
		  $sql_session = "CREATE TABLE IF NOT EXISTS `user_session` (
        `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
        `user_id` int(11) NOT NULL,
        `timestamp` int(11) NOT NULL,
        `ipint` int(11) NOT NULL,
        `sid` varchar(255) NOT NULL,
        `url` varchar(255) NOT NULL,
        `agent` varchar(255) NOT NULL,
        PRIMARY KEY (`id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";
      
      $sql_session = str_replace(array("\n","\t","\r")," " , $sql_session);
      self::Select($sql_session);
      
      
      $sql_session = "CREATE TABLE IF NOT EXISTS `user_session_data` (
        `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
        `user_session_id` int(11) NOT NULL,
        `var` varchar(255) NOT NULL,
        `value` text NOT NULL,
        PRIMARY KEY (`id`)
      ) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1";
      
      $sql_session = str_replace(array("\n","\t","\r")," " , $sql_session);
      self::Select($sql_session);
      return;
		}
   //~ if( !defined( '__PHPUNIT_PHAR__' ) && !$GLOBALS['CONFIG']['DEBUG'] ){
      //~ smarty()->assign("error" , "Сервис временно не доступен. Приносим свои извинения. Попробуйте повторить через некоторое время.");
      //~ smarty()->display('error/mysql.tpl');
      //~ die();
    //~ }
    throw new Exception ($error."<br>$query",$errno);
  }
  
	static public function ShowCreate( $TableName )
	{
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		$sql = "SHOW CREATE TABLE $TableName";
		try
		{
			$row = DB::FetchArraySelect( $sql );
			if( $row and isset( $row[1] ) )
			{
				return "DROP TABLE IF EXISTS $TableName;\n{$row[1]};\n";
			}
		}
		catch (Exception $e)
		{
		}
		return false;
	}
   
  static public function Query($Query,$DoLog = true){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		
    if( self::StatusConnect() === NO_CONNECTION ){
      self::Init();
    }
    $res = self::$FObject->Connect();
    if(self::$FLastTimestamp !== null){
      $Time = getmicrotime()-self::$FLastTimestamp;
      self::$FQuerys->Add( Array( self::EXEC_PHP_CODE, $Time) );
      self::$FQuerysTimeMax = max( self::$FQuerysTimeMax, $Time );
    }
    $TimeStart = getmicrotime();
    
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			mysql_query( DB::GetPreComment() . $Query, self::$FLink) or self::QueryError($Query);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			self::$FLink->query( DB::GetPreComment() .  $Query ) or self::QueryError($Query);
		}
		
    $Time = getmicrotime()-$TimeStart;
    self::$FQuerys->Add( Array($Query, $Time) );
    self::$FExecCount++;
    self::$FQuerysTime += $Time;
    self::$FQuerysTimeMax = max( self::$FQuerysTimeMax, $Time );
  	//if($DoLog) Log::Write ("{$Query}",'SQL');
    self::$FLastTimestamp = getmicrotime();
    
    if(self::$Taskcron){
    	self::$ResultCron['UpDB']['Count']++;
    	self::$ResultCron['UpDB']['Time'] = self::$ResultCron['UpDB']['Time'] + $Time;
    }
    
    return true;
  }

  static public function Log($l,$t=0){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    if( $dolog=1 ){
      if( self::$FQuerys ) self::$FQuerys->Add( Array($l, $t) );
    }
    LOG_SERGEY( __LINE__ , __FUNCTION__ , "END LOG" );
  }
  
  static function MQ( $sql = '' ){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		return self::Select( $sql );
	}
	
	static function MMQ($sql){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_query($sql);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			$R = self::$FLink->query($sql);
			//$num_rows = $R->num_rows;
			//if( !isset($GLOBALS['NotAddToFile']) or !$GLOBALS['NotAddToFile'] ) {
				//if( $num_rows > DB::WARNING_COUNT_MAX ) {
					//trigger_error( "SQL RESULT too big in SQL: $num_rows rows (SQL: $sql)", E_USER_WARNING ); 
				//}
			//}
			return $R;
		}
	}
	
	static function Fetch( $res = null ){
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_fetch_array($res);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			if( !is_object( $res ) ){
				return array();
			}
			return $res->fetch_assoc();
		}
	}
	
	static function FetchNum( $res = null ){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_fetch_array($res,MYSQLI_NUM);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			if( !is_object( $res ) ){
				return array();
			}
			return $res->fetch_array(MYSQLI_NUM);
		}
	}
	
	static function WhyError( $t = null ){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		$method = 'FixError' . self::$FLink->errno;
    
		if( method_exists( 'DB' , $method ) ){
      $table  = property_exists( $t , 'SqlTable') ? $t::$SqlTable : '';
      $prop   = property_exists( $t , 'FInit') ? $t::$FInit : '';
      
			DB::$method( $table , $prop , "Id" );
		}
	}
	
	#unduffered query
	static function UBSelect($sql){
    if(self::$FLastTimestamp !== null){
      $Time = getmicrotime()-self::$FLastTimestamp;
      self::$FQuerys->Add( Array( self::EXEC_PHP_CODE, $Time) );
      self::$FQuerysTimeMax = max( self::$FQuerysTimeMax, $Time );
    }
    $TimeStart = getmicrotime();
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
      $res = mysql_unbuffered_query($sql);
      $Time = getmicrotime()-$TimeStart;
      self::$FQuerys->Add( Array($sql, $Time) );
			return $res;
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return self::$FLink->query($sql, MYSQLI_USE_RESULT);
		}
	}
	
	static function DataSeek($res , $pos){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			mysql_data_seek($res,$pos );
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			mysqli_data_seek($res,$pos);
		}
	}
	
	static public function GetPreComment() {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		return isset( $GLOBALS['CronJob'] )
			? '/'.'*' . $GLOBALS['CronJob'] . '*'.'/ '
			: '';
	}
  
  
  
  
  
  
  static function CleanCache(){
    self::$CacheRes = array();
  }
  
  static $CacheRes = array();
  
  
  static $IsCachingSelect = true;
  
  
  
  
  
	/**
   * Выполнение запроса с возвращением ссылки на ресурс результата
   * 
   * @param string $Query
   * @return reqource_mysqli
   */
  static public function &Select($Query){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if($Query == '' ){
			die();
		}
    
    $key = md5( $Query );
		
    /**
     * Проверка на соединение
     */
    if( self::StatusConnect() === NO_CONNECTION ){
      self::Init();
    }
    self::$FObject->Connect();
    
    
    //~ if( isset( $CacheRes[$key] ) && self::$IsCachingSelect ){
      //~ return $CacheRes[$key];
    //~ }
    
    if(self::$FLastTimestamp !== null){
      $Time = getmicrotime()-self::$FLastTimestamp;
      
      self::$FQuerys->Add( Array( self::EXEC_PHP_CODE, $Time) );
      self::$FQuerysTimeMax = max( self::$FQuerysTimeMax, $Time );
      //~ if( self::$FQuerysTimeMax > 0.5 ){
        
        //~ echo self::$FQuerysTimeMax . "---------START";
        
        //~ foreach( debug_backtrace() as $step => $attrs ){
          //~ echo "\n
            //~ file : {$attrs['file']}\n
            //~ line : {$attrs['line']}\n
            //~ function : {$attrs['function']}\n
            //~ class : {$attrs['class']}\n
          //~ ";
        //~ }
        //~ echo "------------STEP-----------";
      //~ }
    }
    $TimeStart = getmicrotime();
    
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			self::$FResult = mysql_query( DB::GetPreComment() . $Query, self::$FLink ) or self::QueryError($Query);
			$num_rows = mysql_num_rows( self::$FResult );
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			self::$FResult = self::$FLink->query( DB::GetPreComment() . $Query );
			$num_rows = is_object(self::$FResult) && property_exists( self::$FResult , 'num_rows' ) ? self::$FResult->num_rows : 0;
		}
		if( !isset($GLOBALS['NotAddToFile']) or !$GLOBALS['NotAddToFile'] ) {
			if( $num_rows > DB::WARNING_COUNT_MAX && isset($GLOBALS['DEBUG']) && $GLOBALS['DEBUG'] ) {
		   	trigger_error( "SQL RESULT too big in SQL: $num_rows rows (SQL: $Query)", E_USER_WARNING ); 
			}
		}
    
    //~ if( self::$IsCachingSelect ){
      //~ self::$CacheRes[ $key ] = self::$FResult;
    //~ }

    $Time = getmicrotime()-$TimeStart;
    self::$FExecCount++;
    if( $dolog=1 ){
      self::$FQuerys->Add( Array($Query, $Time) );
      self::$FQuerysTime += $Time;
      self::$FQuerysTimeMax = max( self::$FQuerysTimeMax, $Time );
      if( 0 )
      {
      	$R = array();
      	foreach( debug_backtrace() as $obj ) {
      		if( isset($obj['file']) )
      		{
      			$file = substr( $obj['file'], strlen($_SERVER['DOCUMENT_ROOT']) );
	      		$R[] = $obj['function']." :{$file}:{$obj['line']}";
	      		$args = "";
	      		foreach( $obj['args'] as $a ){
				      if (!empty($args)) {
				          $args .= ', ';
				      }
				      switch (gettype($a)) {
				      case 'integer':
				      case 'double':
				          $args .= $a;
				          break;
				      case 'string':
				          $a = htmlspecialchars(substr($a, 0, 64)).((strlen($a) > 64) ? '...' : '');
				          $args .= "\"$a\"";
				          break;
				      case 'array':
				          $args .= 'Array('.count($a).')';
				          break;
				      case 'object':
				      	 if( in_array( get_class($a), array('meter') ) ) {
//				      	 	var_dump($a); die();
								$_id = 0;
						   	 if( method_exists( $a, 'GetId' ) ){
							   	 $_id = $a->Id;
					      	 }
					          $args .= 'Object('.get_class($a).':'.$_id.')';
				          } else {
					          $args .= 'Object('.get_class($a).')';
				          }
				          break;
				      case 'resource':
				          $args .= 'Resource('.strstr($a, '#').')';
				          break;
				      case 'boolean':
				          $args .= $a ? 'True' : 'False';
				          break;
				      case 'NULL':
				          $args .= 'Null';
				          break;
				      default:
				          $args .= 'Unknown';
				      }
				  }
	      		DB::Log( 'TRACE:' . $obj['function']." :{$file}:{$obj['line']} (". $args. ")" );
      		}
      	}
      	//DB::Log( 'TRACE:'.implode( ' < ', $R ) );
      }
    }
  	//Log::Write ("{$Query}",'SQL');
    self::$FLastTimestamp = getmicrotime();
    
    if(self::$Taskcron){
    	self::$ResultCron['SelDB']['Count']++;
    	self::$ResultCron['SelDB']['Time'] = self::$ResultCron['SelDB']['Time'] + $Time;
    }
    
    return self::$FResult;
  }

  static public function FetchArraySelect($Query) {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
  	return DB::FetchNum(DB::Select($Query));
  }

  static public function RowCount($result = null){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return is_resource(self::$FResult) ? mysql_num_rows(is_resource($result) ? $result : self::$FResult) : 0;
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return is_object($result) ? $result->num_rows : 0;
		}
  }
  
  static function ListProgress(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_list_processes(self::$FLink);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return self::$FLink->thread_id;
		}
	}
	
	static function Free($result){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_free_result($result);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return $result->free();
		}
	}
  
  static public function InsertId($result = null){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
  	if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_insert_id(self::$FLink);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return self::$FLink->insert_id;
		}
  }

  static public function FetchArray($result = null) {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		return self::Fetch($result);
  }

  static public function FetchArrayA($result = null) {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_fetch_array(is_resource($result) ? $result : self::$FResult,MYSQL_ASSOC);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return DB::Fetch($result);
		}
  }

  static public function AffectedRows() {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			return mysql_affected_rows(self::$FLink);
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			return self::$FLink->affected_rows;
		}
  }

  public function GetQuerys(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
  	return self::$FQuerys;
  }

  public function GetPageTime(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
  	return getmicrotime()-$GLOBALS['PageCreateStart'];
  }

	static public function QuerysCount() {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		return self::$FExecCount;
	}
  static public function Status(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    $rez = "\r\n<!--Запросов к базе данных: ".self::$FQuerys->Count."-->\r\n";
    $i = 0;
    foreach(self::$FQuerys->Elements as $iQuery){
    	$i++;
      $rez .= "<!--(".sprintf("%01.5f",$iQuery[1]).")[".$i."] {$iQuery[0]} -->\r\n";
    }

    $all_time = getmicrotime()-$GLOBALS['PageCreateStart'];
    $rez .= '<!--('.round($all_time,5).") - общее время работы страницы -->\r\n";
    $rez .= '<!--('.round(self::$FQuerysTime,5).') - общее время запросов('.sprintf("%01.5f", self::$FQuerysTime/$all_time*100)."%)-->\r\n";
    return $rez;
  }
  
   static public function StatusHtml(){
     LOG_SERGEY( __LINE__ , __FUNCTION__ );
     
    $SQL3 = "SHOW PROFILES";
    $res = DB::MMQ($SQL3);
    DB::Log($SQL3);
    
    $table_res = array();
    
    while( $row = DB::Fetch( $res ) ){
      $key = md5($row['Query']);
      $table_res[$key] = array();
      $table_res[$key]['all_res'] = $row['Duration'];
      
      $SQL4 = "SHOW PROFILE FOR QUERY {$row['Query_ID']}";
      $res2 = DB::MMQ($SQL4);
      DB::Log($SQL4);
      $i = 0;
      while( $row2 = DB::Fetch( $res2) ){
        $table_res[$key]['more'][$row2['Status']] = $row2['Duration'];
        $i++;
      }
    }
    
    $ar_res = array();
    $sto    = 100 / self::$FQuerysTimeMax;
    
    foreach(self::$FQuerys->Elements as $i => $iQuery) {
      
      $SQl  = $iQuery[0];
      $Time = $iQuery[1];
      
      $key = md5($SQl);
      
      $class = array();
      
      $class[] = $SQl == self::EXEC_PHP_CODE ? "php" : "sql";
      
      $h = ceil( $Time * $sto ) ;
      if( $h == 0 ) continue;
      if( $h < 10 ){
        $h = 10;
      }
      
      if( $Time < 0.002 ){
				$class[] = 'g_d'; // good debug
			}elseif( $Time >= 0.002 && $Time < 0.02  ){
				$class[] = 'w_d'; // warning debug
			}else{
				$class[] = 'e_d';   // error debug
			}
      
      $ar_res[$i] = array(
        'key_sql'     => $key,
        'class'       => implode(' ' , $class),
        'description' => $SQl,
        'time'        => $Time,
        'height'      => $h,
        'more'        => isset($table_res[$key]['more']) ? $table_res[$key]['more'] : array()
      );
      
    }
    
    
    smarty()->assign('ar_res' , $ar_res);
    return smarty()->fetch('debug/sql_debug.tpl');
  }
  
  static public function statusTxt(){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    $rez = "\r\nЗапросов к базе данных: ".self::$FQuerys->Count."\r\n";
    $i = 0;
    foreach(self::$FQuerys->Elements as $iQuery){
    	$i++;
      $rez .= "(".sprintf("%01.5f",$iQuery[1]).")[".$i."] {$iQuery[0]} \r\n";
    }

    $all_time = getmicrotime()-$GLOBALS['PageCreateStart'];
    $rez .= '('.round($all_time,5).") - общее время работы страницы \r\n";
    $rez .= '('.round(self::$FQuerysTime,5).') - общее время запросов('.sprintf("%01.5f", self::$FQuerysTime/$all_time*100)."%)\r\n";
    return $rez;
  }
  
  static public function StatusJS()
  {
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    echo <<<JSCODE
<script>
//jQuery('body').prepend('<p>Test</p>');;
</script>
JSCODE;
  }

  public function fetch_array($rez){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
    return mysql_fetch_array($rez);
  }
  public function Error1054($table,$fields = array()){
    LOG_SERGEY( __LINE__ , __FUNCTION__ );
		#$db_fields = mysql_list_fields($GLOBALS['config']['Sql']['Base'], $table, self::$FLink);
		
		$aFields = array();
    $Res = DB::Select("DESCRIBE {$table}");
    while( $_f = DB::Fetch($Res)){
			$aFields[$_f['Field']] = $_f['Field'];
		}
		
		/*
    for ($i = 0; $i < $Count_f; $i++) {
        $aFields[mysql_field_name($db_fields, $i)] = 1;
    }
    */
		$sql = "";
		foreach($fields as $iFieldName => $iFieldType){
			if(!isset($aFields[$iFieldName])){
  			if($sql!='') $sql .= ", ";
  			if($iFieldType=='text') $sql .= "ADD `{$iFieldName}` TEXT NOT NULL";
  			elseif($iFieldType=='object') $sql .= "ADD `{$iFieldName}` INT UNSIGNED NOT NULL";
  			elseif($iFieldType=='int') $sql .= "ADD `{$iFieldName}` INT NOT NULL";
  			elseif($iFieldType=='key') $sql .= "ADD `{$iFieldName}` INT UNSIGNED NOT NULL";
  			elseif($iFieldType=='float') $sql .= "ADD `{$iFieldName}` FLOAT NOT NULL";
  			else $sql .= "ADD `{$iFieldName}` TEXT NOT NULL";
			}
	  }
		$sql = "ALTER TABLE `{$table}` ".$sql;
		if( self::$DB_DRIVER == self::DRIVER_MYSQL ){
			mysql_query( $sql, self::$FLink );
		}elseif( self::$DB_DRIVER == self::DRIVER_MYSQLI ){
			self::Select($sql);
		}
		return true;
  }
}
?>
