<?php
/*
Имя класса archive
Имя файла archive.class.php ( archivecustom.class.php )
Поля класса:
Id : id
Name : string
User : object
Interprise : object
Its : its
*/
class archive extends archivecustom{
  
  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Name'              => 'name',
    'YearSt'            => 'year_st',
    'MonthSt'           => 'month_st',
    'DaySt'             => 'day_st',
    'YearSp'            => 'year_sp',
    'MonthSp'           => 'month_sp',
    'DaySp'             => 'day_sp',
    'Status'            => 'status',
    'Procent'           => 'procent',
    'Text'              => 'text',
    'IsDrop'            => 'is_drop',
    'IsForceExit'       => 'is_force_exit',
  );  
  
  
  
  static public function AddByArray($A){
    
    $A['InterpriseId'] = Self()->Interprise->Id;
    $A['UserId'] = Self()->Id;
    
    $t = new archive();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }
  
  
  
  function GetTransName(){
    return  Utils::rus2eng( $this->Title );
  }
  
  
  
  
  
  function GetArchiveMeters(){
    $Filter = array( 
      'Filter' => array( 
        'Archive' => $this->Id
    ));
    return archivemeter::Filter($Filter);
  }
  
  
  
  function GetTitle(){
    return $this->Name;
  }
  
  
  
  
  function GetIsReady(){
    return file_exists( $_SERVER['DOCUMENT_ROOT'] . "/archive/{$this->Title}.zip");
  }

}
