<?php
// md5=00000000000000000000000000000000
class archivecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`archive`';
  static public $SqlFields = '`archive`.`id`,`archive`.`name`,`archive`.`year_st`,`archive`.`month_st`,`archive`.`day_st`,`archive`.`year_sp`,`archive`.`month_sp`,`archive`.`day_sp`,`archive`.`user_id`,`archive`.`interprise_id`,`archive`.`its`,`archive`.`status`,`archive`.`procent`,`archive`.`is_drop`,`archive`.`text`,`archive`.`is_force_exit`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Name'=>array('type'=>'string','ready'=>false,'sql'=>'name','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>53),
    'YearSt'=>array('type'=>'int','ready'=>false,'sql'=>'year_st','value'=>0,'notnull'=>1, 'rus'=>'Год начала', 'enter'=>53),
    'MonthSt'=>array('type'=>'int','ready'=>false,'sql'=>'month_st','value'=>0,'notnull'=>1, 'rus'=>'Месяц начала', 'enter'=>53),
    'DaySt'=>array('type'=>'int','ready'=>false,'sql'=>'day_st','value'=>0,'notnull'=>1, 'rus'=>'День начала', 'enter'=>53),
    'YearSp'=>array('type'=>'int','ready'=>false,'sql'=>'year_sp','value'=>0,'notnull'=>1, 'rus'=>'Год конца', 'enter'=>53),
    'MonthSp'=>array('type'=>'int','ready'=>false,'sql'=>'month_sp','value'=>0,'notnull'=>1, 'rus'=>'Месяц конца', 'enter'=>53),
    'DaySp'=>array('type'=>'int','ready'=>false,'sql'=>'day_sp','value'=>0,'notnull'=>1, 'rus'=>'День конца', 'enter'=>53),
    'User'=>array('type'=>'object','object'=>'user','ready'=>false,'sql'=>'user_id','value'=>null, 'rus'=>'Пользователь'),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании'),
    'Its'=>array('type'=>'its','ready'=>false,'sql'=>'its','value'=>'', 'rus'=>'Дата добавления', 'enter'=>26),
    'Status'=>array('type'=>'int','ready'=>false,'sql'=>'status','value'=>0, 'rus'=>'Статус'),
    'Procent'=>array('type'=>'int','ready'=>false,'sql'=>'procent','value'=>0, 'rus'=>'Процент выполнения'),
    'IsDrop'=>array('type'=>'int','ready'=>false,'sql'=>'is_drop','value'=>0,'notnull'=>1, 'rus'=>'Удалить данные', 'enter'=>55),
    'Text'=>array('type'=>'text','ready'=>false,'sql'=>'text','value'=>'', 'rus'=>'Текст', 'enter'=>3),
    'IsForceExit'=>array('type'=>'int','ready'=>false,'sql'=>'is_force_exit','value'=>0, 'rus'=>'Принудительная остановка'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      archive::$_R['All']
    ))
      archive::$_R['All'] 
      = TObject2::Filter( new archive());
    return archive::$_R['All'];
  }


  public function GetFInit() {
    return archive::$FInit;
  }

  public function GetClassName(){
    return 'archive'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Archive';
  }
  public function GetNameRus(){
    return 'Архивы';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(archive::$_O[$id]) ){
      archive::$_O[$id] = archive::Id($id);
      TObject2::_DataSetAll(archive::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(archive::$_O[$id]) ){
      archive::$_O[$id] = new archive();
      TObject2::_PreInit( archive::$_O[$id], $id);
    }
    return archive::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = archive::$SqlTable;
    $arField = Array();
    foreach( archive::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return archive::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = archive::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = archive::$FInit[$this->_ID]['sql'];
    foreach( archive::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new archive();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new archive();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new archive();
    return TObject2::Filter($t,$aParams);
  }
}
?>
