<?php
// md5=00000000000000000000000000000000
class connectstatuscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`connectstatus`';
  static public $SqlFields = '`connectstatus`.`id`,`connectstatus`.`converter_id`,`connectstatus`.`ts`,`connectstatus`.`ms`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Converter'=>array('type'=>'object','object'=>'converter','ready'=>false,'sql'=>'converter_id','value'=>null,'notnull'=>1, 'rus'=>'Точки опроса'),
    'Ts'=>array('type'=>'ts','ready'=>false,'sql'=>'ts','value'=>'', 'rus'=>'Дата опроса', 'enter'=>26),
    'Ms'=>array('type'=>'int','ready'=>false,'sql'=>'ms','value'=>0, 'rus'=>'Милисекунд'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      connectstatus::$_R['All']
    ))
      connectstatus::$_R['All'] 
      = TObject2::Filter( new connectstatus());
    return connectstatus::$_R['All'];
  }


  public function GetFInit() {
    return connectstatus::$FInit;
  }

  public function GetClassName(){
    return 'connectstatus'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Connectstatus';
  }
  public function GetNameRus(){
    return 'Статус соединения';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(connectstatus::$_O[$id]) ){
      connectstatus::$_O[$id] = connectstatus::Id($id);
      TObject2::_DataSetAll(connectstatus::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(connectstatus::$_O[$id]) ){
      connectstatus::$_O[$id] = new connectstatus();
      TObject2::_PreInit( connectstatus::$_O[$id], $id);
    }
    return connectstatus::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = connectstatus::$SqlTable;
    $arField = Array();
    foreach( connectstatus::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return connectstatus::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = connectstatus::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = connectstatus::$FInit[$this->_ID]['sql'];
    foreach( connectstatus::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new connectstatus();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new connectstatus();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new connectstatus();
    return TObject2::Filter($t,$aParams);
  }
}
?>
