<?php
// md5=00000000000000000000000000000000
class converter_appointmentcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`converter_appointment`';
  static public $SqlFields = '`converter_appointment`.`id`,`converter_appointment`.`description`,`converter_appointment`.`ident`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Description'=>array('type'=>'string','ready'=>false,'sql'=>'description','value'=>'', 'rus'=>'Описание назначения', 'enter'=>2),
    'Ident'=>array('type'=>'string','ready'=>false,'sql'=>'ident','value'=>'', 'rus'=>'Идентификатор', 'enter'=>2),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      converter_appointment::$_R['All']
    ))
      converter_appointment::$_R['All'] 
      = TObject2::Filter( new converter_appointment());
    return converter_appointment::$_R['All'];
  }


  public function GetFInit() {
    return converter_appointment::$FInit;
  }

  public function GetClassName(){
    return 'converter_appointment'; //get_class($this);
  }
  public function GetNameBig(){
    return 'ConverterAppointment';
  }
  public function GetNameRus(){
    return 'Тип конвертора по его назначению';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(converter_appointment::$_O[$id]) ){
      converter_appointment::$_O[$id] = converter_appointment::Id($id);
      TObject2::_DataSetAll(converter_appointment::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(converter_appointment::$_O[$id]) ){
      converter_appointment::$_O[$id] = new converter_appointment();
      TObject2::_PreInit( converter_appointment::$_O[$id], $id);
    }
    return converter_appointment::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = converter_appointment::$SqlTable;
    $arField = Array();
    foreach( converter_appointment::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return converter_appointment::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = converter_appointment::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = converter_appointment::$FInit[$this->_ID]['sql'];
    foreach( converter_appointment::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new converter_appointment();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new converter_appointment();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new converter_appointment();
    return TObject2::Filter($t,$aParams);
  }
}
?>
