<?php
// md5=00000000000000000000000000000000
class convertercustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`converter`';
  static public $SqlFields = '`converter`.`id`,`converter`.`type_id`,`converter`.`ip`,`converter`.`port`,`converter`.`login`,`converter`.`password`,`converter`.`about`,`converter`.`is_excluded`,`converter`.`in_use`,`converter`.`meter_ok`,`converter`.`interprise`,`converter`.`timeout_connect`,`converter`.`timeout_receive`,`converter`.`portcontrol`,`converter`.`meters_count`,`converter`.`onlines_count`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Type'=>array('type'=>'object','object'=>'convertertype','ready'=>false,'sql'=>'type_id','value'=>null,'notnull'=>1, 'rus'=>'Тип точки опроса', 'enter'=>4),
    'Ip'=>array('type'=>'string','ready'=>false,'sql'=>'ip','value'=>'','notnull'=>1, 'rus'=>'IP-адрес', 'enter'=>2),
    'Port'=>array('type'=>'int','ready'=>false,'sql'=>'port','value'=>0,'notnull'=>1, 'rus'=>'Порт соединения', 'enter'=>2),
    'Login'=>array('type'=>'string','ready'=>false,'sql'=>'login','value'=>'', 'rus'=>'Имя пользователя для доступа', 'enter'=>2),
    'Password'=>array('type'=>'string','ready'=>false,'sql'=>'password','value'=>'', 'rus'=>'Пароль для доступа', 'enter'=>2),
    'About'=>array('type'=>'string','ready'=>false,'sql'=>'about','value'=>'', 'rus'=>'Название', 'enter'=>2),
    'IsExcluded'=>array('type'=>'bool','ready'=>false,'sql'=>'is_excluded','value'=>'', 'rus'=>'Исключено из опроса', 'enter'=>7),
    'InUse'=>array('type'=>'ts','ready'=>false,'sql'=>'in_use','value'=>'', 'rus'=>'Используется'),
    'MeterOk'=>array('type'=>'int','ready'=>false,'sql'=>'meter_ok','value'=>0, 'rus'=>'Статус приборов'),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise','value'=>null, 'rus'=>'Предприятие'),
    'Timeoutconnect'=>array('type'=>'int','ready'=>false,'sql'=>'timeout_connect','value'=>0, 'rus'=>'Время ожидания установки соединения в миллисекундах', 'enter'=>2),
    'Timeoutreceive'=>array('type'=>'int','ready'=>false,'sql'=>'timeout_receive','value'=>0, 'rus'=>'Время ожидания ответа от прибора в миллисекундах', 'enter'=>2),
    'Portcontrol'=>array('type'=>'int','ready'=>false,'sql'=>'portcontrol','value'=>0, 'rus'=>'Порт для Web интерфейса', 'enter'=>2),
    'Meters' => array('type'=>'fltcnt','ready'=>false,'sql'=>'meters_count','value'=>-1),
    'onlines' => array('type'=>'fltcnt','ready'=>false,'sql'=>'onlines_count','value'=>-1),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      converter::$_R['All']
    ))
      converter::$_R['All'] 
      = TObject2::Filter( new converter(), Array(  
        'Order'=>Array('About'=>'ASC')
      ));
    return converter::$_R['All'];
  }


  public function GetFInit() {
    return converter::$FInit;
  }

  public function GetClassName(){
    return 'converter'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Converter';
  }
  public function GetNameRus(){
    return 'Точки опроса';
  }
  

  function GetMeters(){
    if($this->Is){
      if( !isset(converter::$_R['Meters'][$this->_F[$this->_ID]['value']])){
        converter::$_R['Meters'][$this->_F[$this->_ID]['value']] = meter::ByConverter($this->_F[$this->_ID]['value'],-1);
        //$this->SetMetersCount(converter::$_R['Meters'][$this->_F[$this->_ID]['value']]->Count);
      }
      return converter::$_R['Meters'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function Getonlines(){
    if($this->Is){
      if( !isset(converter::$_R['onlines'][$this->_F[$this->_ID]['value']])){
        converter::$_R['onlines'][$this->_F[$this->_ID]['value']] = converteronline::ByConverter($this->_F[$this->_ID]['value'],-1);
        //$this->SetonlinesCount(converter::$_R['onlines'][$this->_F[$this->_ID]['value']]->Count);
      }
      return converter::$_R['onlines'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(converter::$_O[$id]) ){
      converter::$_O[$id] = converter::Id($id);
      TObject2::_DataSetAll(converter::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(converter::$_O[$id]) ){
      converter::$_O[$id] = new converter();
      TObject2::_PreInit( converter::$_O[$id], $id);
    }
    return converter::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = converter::$SqlTable;
    $arField = Array();
    foreach( converter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return converter::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = converter::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = converter::$FInit[$this->_ID]['sql'];
    foreach( converter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new converter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new converter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new converter();
    return TObject2::Filter($t,$aParams);
  }
}
?>
