<?php
// md5=00000000000000000000000000000000
class converteronlinecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`converteronline`';
  static public $SqlFields = '`converteronline`.`id`,`converteronline`.`converter_id`,`converteronline`.`is_online`,`converteronline`.`ts_start`,`converteronline`.`ts_end`,`converteronline`.`retry`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Converter'=>array('type'=>'object','object'=>'converter','ready'=>false,'sql'=>'converter_id','value'=>null,'notnull'=>1, 'rus'=>'Точки опроса'),
    'IsOnline'=>array('type'=>'bool','ready'=>false,'sql'=>'is_online','value'=>'', 'rus'=>'Доступность', 'enter'=>7),
    'TsStart'=>array('type'=>'its','ready'=>false,'sql'=>'ts_start','value'=>'', 'rus'=>'Дата начала', 'enter'=>26),
    'TsEnd'=>array('type'=>'ts','ready'=>false,'sql'=>'ts_end','value'=>'', 'rus'=>'Дата окончания', 'enter'=>26),
    'Retry'=>array('type'=>'int','ready'=>false,'sql'=>'retry','value'=>0, 'rus'=>'Попыток'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      converteronline::$_R['All']
    ))
      converteronline::$_R['All'] 
      = TObject2::Filter( new converteronline());
    return converteronline::$_R['All'];
  }

  static public function ByConverter( $Converter, $c=-1 )
  {
    if( !isset( 
      converteronline::$_R['ByConverter']
      ,converteronline::$_R['ByConverter']['_'.$Converter]

    ))
      converteronline::$_R['ByConverter']['_'.$Converter] 
      = TObject2::Filter( new converteronline(), Array( 
        'Filter' => Array(
            'Converter'=>$Converter
        ), 
        'Order'=>Array('TsStart'=>'DESC'),
        'Limit'=>$c
      ));
    return converteronline::$_R['ByConverter']['_'.$Converter];
  }


  public function GetFInit() {
    return converteronline::$FInit;
  }

  public function GetClassName(){
    return 'converteronline'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Converteronline';
  }
  public function GetNameRus(){
    return 'Доступность точки опроса';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(converteronline::$_O[$id]) ){
      converteronline::$_O[$id] = converteronline::Id($id);
      TObject2::_DataSetAll(converteronline::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(converteronline::$_O[$id]) ){
      converteronline::$_O[$id] = new converteronline();
      TObject2::_PreInit( converteronline::$_O[$id], $id);
    }
    return converteronline::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = converteronline::$SqlTable;
    $arField = Array();
    foreach( converteronline::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return converteronline::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = converteronline::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = converteronline::$FInit[$this->_ID]['sql'];
    foreach( converteronline::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new converteronline();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new converteronline();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new converteronline();
    return TObject2::Filter($t,$aParams);
  }
}
?>
