<?php
// md5=00000000000000000000000000000000
class crontasklogcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`crontasklog`';
  static public $SqlFields = '`crontasklog`.`id`,`crontasklog`.`crontask_id`,`crontasklog`.`text`,`crontasklog`.`date_start`,`crontasklog`.`date_end`,`crontasklog`.`statuscrontasklog_id`,`crontasklog`.`iteration`,`crontasklog`.`updb`,`crontasklog`.`timeupdb`,`crontasklog`.`seldb`,`crontasklog`.`timeseldb`,`crontasklog`.`timerun`,`crontasklog`.`memorypeak`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Crontask'=>array('type'=>'object','object'=>'crontask','ready'=>false,'sql'=>'crontask_id','value'=>null,'notnull'=>1, 'rus'=>'Задания по расписанию'),
    'Text'=>array('type'=>'text','ready'=>false,'sql'=>'text','value'=>'', 'rus'=>'Текст', 'enter'=>3),
    'DateStart'=>array('type'=>'string','ready'=>false,'sql'=>'date_start','value'=>'', 'rus'=>'Дата Начала', 'enter'=>26),
    'DateEnd'=>array('type'=>'string','ready'=>false,'sql'=>'date_end','value'=>'', 'rus'=>'Дата Окончания'),
    'Statuscrontasklog'=>array('type'=>'object','object'=>'statuscrontasklog','ready'=>false,'sql'=>'statuscrontasklog_id','value'=>null, 'rus'=>'Статус завершения задачи', 'enter'=>4),
    'Iteration'=>array('type'=>'int','ready'=>false,'sql'=>'iteration','value'=>0, 'rus'=>'Итерации', 'enter'=>2),
    'Updb'=>array('type'=>'int','ready'=>false,'sql'=>'updb','value'=>0, 'rus'=>'Воздействие на БД', 'enter'=>2),
    'Timeupdb'=>array('type'=>'float','ready'=>false,'sql'=>'timeupdb','value'=>'', 'rus'=>'Время UpDB', 'enter'=>2),
    'Seldb'=>array('type'=>'int','ready'=>false,'sql'=>'seldb','value'=>0, 'rus'=>'Просмотр БД', 'enter'=>2),
    'Timeseldb'=>array('type'=>'float','ready'=>false,'sql'=>'timeseldb','value'=>'', 'rus'=>'Время просмотра БД', 'enter'=>2),
    'Timerun'=>array('type'=>'float','ready'=>false,'sql'=>'timerun','value'=>'', 'rus'=>'Ворея выполнения', 'enter'=>2),
    'Memorypeak'=>array('type'=>'int','ready'=>false,'sql'=>'memorypeak','value'=>0, 'rus'=>'Пиковая память', 'enter'=>2),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      crontasklog::$_R['All']
    ))
      crontasklog::$_R['All'] 
      = TObject2::Filter( new crontasklog());
    return crontasklog::$_R['All'];
  }


  public function GetFInit() {
    return crontasklog::$FInit;
  }

  public function GetClassName(){
    return 'crontasklog'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Crontasklog';
  }
  public function GetNameRus(){
    return 'Лог задач';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(crontasklog::$_O[$id]) ){
      crontasklog::$_O[$id] = crontasklog::Id($id);
      TObject2::_DataSetAll(crontasklog::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(crontasklog::$_O[$id]) ){
      crontasklog::$_O[$id] = new crontasklog();
      TObject2::_PreInit( crontasklog::$_O[$id], $id);
    }
    return crontasklog::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = crontasklog::$SqlTable;
    $arField = Array();
    foreach( crontasklog::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return crontasklog::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = crontasklog::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = crontasklog::$FInit[$this->_ID]['sql'];
    foreach( crontasklog::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new crontasklog();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new crontasklog();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new crontasklog();
    return TObject2::Filter($t,$aParams);
  }
}
?>
