<?php
// md5=00000000000000000000000000000000
class crontasktracecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`crontasktrace`';
  static public $SqlFields = '`crontasktrace`.`id`,`crontasktrace`.`crontask_id`,`crontasktrace`.`object`,`crontasktrace`.`idobject`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Crontask'=>array('type'=>'object','object'=>'crontask','ready'=>false,'sql'=>'crontask_id','value'=>null, 'rus'=>'Задания по расписанию'),
    'Object'=>array('type'=>'string','ready'=>false,'sql'=>'object','value'=>'', 'rus'=>'Объект'),
    'Idobject'=>array('type'=>'int','ready'=>false,'sql'=>'idobject','value'=>0, 'rus'=>'Id'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      crontasktrace::$_R['All']
    ))
      crontasktrace::$_R['All'] 
      = TObject2::Filter( new crontasktrace());
    return crontasktrace::$_R['All'];
  }


  public function GetFInit() {
    return crontasktrace::$FInit;
  }

  public function GetClassName(){
    return 'crontasktrace'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Crontasktrace';
  }
  public function GetNameRus(){
    return 'Трасировка crontask';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(crontasktrace::$_O[$id]) ){
      crontasktrace::$_O[$id] = crontasktrace::Id($id);
      TObject2::_DataSetAll(crontasktrace::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(crontasktrace::$_O[$id]) ){
      crontasktrace::$_O[$id] = new crontasktrace();
      TObject2::_PreInit( crontasktrace::$_O[$id], $id);
    }
    return crontasktrace::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = crontasktrace::$SqlTable;
    $arField = Array();
    foreach( crontasktrace::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return crontasktrace::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = crontasktrace::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = crontasktrace::$FInit[$this->_ID]['sql'];
    foreach( crontasktrace::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new crontasktrace();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new crontasktrace();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new crontasktrace();
    return TObject2::Filter($t,$aParams);
  }
}
?>
