<?php
// md5=00000000000000000000000000000000
class fieldscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`fields`';
  static public $SqlFields = '`fields`.`id`,`fields`.`name`,`fields`.`typefields_id`,`fields`.`public`,`fields`.`options`,`fields`.`ident`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Name'=>array('type'=>'string','ready'=>false,'sql'=>'name','value'=>'', 'rus'=>'Название'),
    'Typefields'=>array('type'=>'object','object'=>'typefields','ready'=>false,'sql'=>'typefields_id','value'=>null, 'rus'=>'Типы полей'),
    'Public'=>array('type'=>'bool','ready'=>false,'sql'=>'public','value'=>'', 'rus'=>'Публичное', 'enter'=>7),
    'Options'=>array('type'=>'text','ready'=>false,'sql'=>'options','value'=>'', 'rus'=>'Опции'),
    'Ident'=>array('type'=>'string','ready'=>false,'sql'=>'ident','value'=>'', 'rus'=>'Идентификатор'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      fields::$_R['All']
    ))
      fields::$_R['All'] 
      = TObject2::Filter( new fields());
    return fields::$_R['All'];
  }


  public function GetFInit() {
    return fields::$FInit;
  }

  public function GetClassName(){
    return 'fields'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Fields';
  }
  public function GetNameRus(){
    return 'Дополнительные поля';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(fields::$_O[$id]) ){
      fields::$_O[$id] = fields::Id($id);
      TObject2::_DataSetAll(fields::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(fields::$_O[$id]) ){
      fields::$_O[$id] = new fields();
      TObject2::_PreInit( fields::$_O[$id], $id);
    }
    return fields::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = fields::$SqlTable;
    $arField = Array();
    foreach( fields::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return fields::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = fields::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = fields::$FInit[$this->_ID]['sql'];
    foreach( fields::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new fields();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new fields();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new fields();
    return TObject2::Filter($t,$aParams);
  }
}
?>
