<?php
/*
Имя класса fieldsvalue
Имя файла fieldsvalue.class.php ( fieldsvaluecustom.class.php )
Поля класса:
Id : id
Objectid : int
Object : string
Value : string
Fields : object
*/
class fieldsvalue extends fieldsvaluecustom{

  
  
  
  /**
   * Установка поля на объект
   * 
   * @param class $t Экземпляр объекта на который хотим добавить поле
   * @param string $ident Идентификатор поля, которое хотим установить
   * @return fieldsvalue
   */
  static function AddFromObjectByIdent( $t , $ident ){
    
    // Нужно найти поле с таким идентификатором
    
    $Filter = array(
        'Filter' => array(
            'Ident' => $ident
        )
    );
    
    $ResFields = fields::Filter( $Filter );
    
    if( !$ResFields->Count ){
      return fieldsvalue::Id(0);
    }
    
    return fieldsvalue::AddByArray( array(
        'Objectid'  => $t->Id,
        'Object'    => get_class( $t ),
        'Value'     => '',
        'Fields'    => $ResFields->First->Id
    ));
  }
  
  
}