<?php
/*
Имя класса filterparamis
Имя файла filterparamis.class.php ( filterparamiscustom.class.php )
Поля класса:
Id : id
Filter : object
Parameter : object
Num : int
*/
class filterparamis extends filterparamiscustom{
  
  
  
  /*
    Флаг логирования
  */
  public $NeedDoUserLog = true;
  
  

  
  /*
    Создание TListGroup объекта из параметров
    которые указали как активными
    @param Int идентификатор фильтра
    @return TListGroup
  */
  static function ParametersByIdFilter( $id = 0 ){
    $Filter = array( 
      'Filter' => array( 
        'Filter' => $id
      ),
      'Order' => array(
        'Num' => 'ASC'
      )
    );
    $Parameters = array();
    foreach( self::Filter( $Filter )->Elements as $iParameter ){
      if($iParameter->Is ){
        $Parameters[ $iParameter->Id ] = $iParameter;
      }
    }
    
    $T = TListGroup::Init();
    $T->SetFElements( array_values( $Parameters ) );
    return $T;
  }


}
