<?php
// md5=00000000000000000000000000000000
class graphicscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`graphics`';
  static public $SqlFields = '`graphics`.`id`,`graphics`.`interprise_id`,`graphics`.`metertype_id`,`graphics`.`graphicstype_id`,`graphics`.`parameter_id`,`graphics`.`number`,`graphics`.`meter_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании', 'enter'=>4),
    'Metertype'=>array('type'=>'object','object'=>'metertype','ready'=>false,'sql'=>'metertype_id','value'=>null, 'rus'=>'Тип прибора опроса', 'enter'=>4),
    'Graphicstype'=>array('type'=>'object','object'=>'graphicstype','ready'=>false,'sql'=>'graphicstype_id','value'=>null, 'rus'=>'Тип графиков', 'enter'=>4),
    'Parameter'=>array('type'=>'object','object'=>'parameter','ready'=>false,'sql'=>'parameter_id','value'=>null, 'rus'=>'Параметр', 'enter'=>4),
    'Number'=>array('type'=>'int','ready'=>false,'sql'=>'number','value'=>0, 'rus'=>'Номер графика', 'enter'=>2),
    'Meter'=>array('type'=>'object','object'=>'meter','ready'=>false,'sql'=>'meter_id','value'=>null, 'rus'=>'Прибор учета'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      graphics::$_R['All']
    ))
      graphics::$_R['All'] 
      = TObject2::Filter( new graphics());
    return graphics::$_R['All'];
  }


  public function GetFInit() {
    return graphics::$FInit;
  }

  public function GetClassName(){
    return 'graphics'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Graphics';
  }
  public function GetNameRus(){
    return 'Графики';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(graphics::$_O[$id]) ){
      graphics::$_O[$id] = graphics::Id($id);
      TObject2::_DataSetAll(graphics::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(graphics::$_O[$id]) ){
      graphics::$_O[$id] = new graphics();
      TObject2::_PreInit( graphics::$_O[$id], $id);
    }
    return graphics::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = graphics::$SqlTable;
    $arField = Array();
    foreach( graphics::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return graphics::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = graphics::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = graphics::$FInit[$this->_ID]['sql'];
    foreach( graphics::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new graphics();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new graphics();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new graphics();
    return TObject2::Filter($t,$aParams);
  }
}
?>