<?php
// md5=00000000000000000000000000000000
class linkcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`link`';
  static public $SqlFields = '`link`.`id`,`link`.`user_id`,`link`.`interprise_id`,`link`.`rule_id`,`link`.`objectrule_id`,`link`.`whyid`,`link`.`auto`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'User'=>array('type'=>'object','object'=>'user','ready'=>false,'sql'=>'user_id','value'=>null, 'rus'=>'Пользователь', 'enter'=>4),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании', 'enter'=>4),
    'Rule'=>array('type'=>'object','object'=>'rule','ready'=>false,'sql'=>'rule_id','value'=>null, 'rus'=>'Права', 'enter'=>4),
    'Objectrule'=>array('type'=>'object','object'=>'objectrule','ready'=>false,'sql'=>'objectrule_id','value'=>null, 'rus'=>'Обьекты', 'enter'=>4),
    'Whyid'=>array('type'=>'int','ready'=>false,'sql'=>'whyid','value'=>0, 'enter'=>2),
    'Auto'=>array('type'=>'bool','ready'=>false,'sql'=>'auto','value'=>'', 'rus'=>'Автоматически', 'enter'=>7),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      link::$_R['All']
    ))
      link::$_R['All'] 
      = TObject2::Filter( new link());
    return link::$_R['All'];
  }

  static public function ByUser( $User, $c=-1 )
  {
    if( !isset( 
      link::$_R['ByUser']
      ,link::$_R['ByUser']['_'.$User]

    ))
      link::$_R['ByUser']['_'.$User] 
      = TObject2::Filter( new link(), Array( 
        'Filter' => Array(
            'User'=>$User
        ),
        'Limit'=>$c
      ));
    return link::$_R['ByUser']['_'.$User];
  }

  static public function ByInterprise( $Interprise, $c=-1 )
  {
    if( !isset( 
      link::$_R['ByInterprise']
      ,link::$_R['ByInterprise']['_'.$Interprise]

    ))
      link::$_R['ByInterprise']['_'.$Interprise] 
      = TObject2::Filter( new link(), Array( 
        'Filter' => Array(
            'Interprise'=>$Interprise
        ),
        'Limit'=>$c
      ));
    return link::$_R['ByInterprise']['_'.$Interprise];
  }

  static public function ByRule( $Rule, $c=-1 )
  {
    if( !isset( 
      link::$_R['ByRule']
      ,link::$_R['ByRule']['_'.$Rule]

    ))
      link::$_R['ByRule']['_'.$Rule] 
      = TObject2::Filter( new link(), Array( 
        'Filter' => Array(
            'Rule'=>$Rule
        ),
        'Limit'=>$c
      ));
    return link::$_R['ByRule']['_'.$Rule];
  }


  public function GetFInit() {
    return link::$FInit;
  }

  public function GetClassName(){
    return 'link'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Link';
  }
  public function GetNameRus(){
    return 'Связи пользователей с правами';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(link::$_O[$id]) ){
      link::$_O[$id] = link::Id($id);
      TObject2::_DataSetAll(link::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(link::$_O[$id]) ){
      link::$_O[$id] = new link();
      TObject2::_PreInit( link::$_O[$id], $id);
    }
    return link::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = link::$SqlTable;
    $arField = Array();
    foreach( link::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return link::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = link::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = link::$FInit[$this->_ID]['sql'];
    foreach( link::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new link();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new link();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new link();
    return TObject2::Filter($t,$aParams);
  }
}
?>
