<?php

final class meter_archive {

  
  private $DateStart;
  private $DateStop;
  private $Meters;
  
  function __construct( DateTime $DateStart , DateTime $DateStop , Array $Meters ){
    $this->DateStart = $DateStart;
    $this->DateStop = $DateStop;
    $this->Meters = $Meters;
    
    sort( $this->Meters );
    
    $file_archive_name = "file_" . 
                          $this->DateStart->getTimestamp() . "_" .
                          $this->DateStop->getTimestamp() . "_" .
                          md5( implode( '#' , $this->Meters ) );
                          
    Site()->UserFileCreate('/meter/export/'.$file_archive_name.".json");
    
  }

  
}