<?php
// md5=00000000000000000000000000000000
class meterdatacustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`meter_data`';
  static public $SqlFields = '`meter_data`.`id`,`meter_data`.`readwave_id`,`meter_data`.`meter_id`,`meter_data`.`get_date`,`meter_data`.`tarif_1`,`meter_data`.`tarif_2`,`meter_data`.`power`,`meter_data`.`tarif_1_log`,`meter_data`.`tarif_2_log`,`meter_data`.`power_log`,`meter_data`.`add_time`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Readwave'=>array('type'=>'object','object'=>'readwave','ready'=>false,'sql'=>'readwave_id','value'=>null,'notnull'=>1, 'rus'=>'Опрос'),
    'Meter'=>array('type'=>'object','object'=>'meter','ready'=>false,'sql'=>'meter_id','value'=>null,'notnull'=>1, 'rus'=>'Прибор учета'),
    'GetDate'=>array('type'=>'text','ready'=>false,'sql'=>'get_date','value'=>'', 'rus'=>'Дата опроса', 'enter'=>2),
    'Tarif1'=>array('type'=>'int','ready'=>false,'sql'=>'tarif_1','value'=>0, 'rus'=>'Показания тарифа 1', 'enter'=>2),
    'Tarif2'=>array('type'=>'int','ready'=>false,'sql'=>'tarif_2','value'=>0, 'rus'=>'Показания тарифа 2'),
    'Power'=>array('type'=>'string','ready'=>false,'sql'=>'power','value'=>'', 'rus'=>'Показания потребления'),
    'Tarif1Log'=>array('type'=>'object','object'=>'loginfo','ready'=>false,'sql'=>'tarif_1_log','value'=>null, 'rus'=>'Статус тарифа 1'),
    'Tarif2Log'=>array('type'=>'object','object'=>'loginfo','ready'=>false,'sql'=>'tarif_2_log','value'=>null, 'rus'=>'Статус тарифа 2'),
    'PowerLog'=>array('type'=>'object','object'=>'loginfo','ready'=>false,'sql'=>'power_log','value'=>null, 'rus'=>'Статус мощности'),
    'AddTime'=>array('type'=>'its','ready'=>false,'sql'=>'add_time','value'=>'', 'rus'=>'Дата добавления', 'enter'=>26),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      meterdata::$_R['All']
    ))
      meterdata::$_R['All'] 
      = TObject2::Filter( new meterdata());
    return meterdata::$_R['All'];
  }

  static public function ByMeter( $Meter, $c=-1 )
  {
    if( !isset( 
      meterdata::$_R['ByMeter']
      ,meterdata::$_R['ByMeter']['_'.$Meter]

    ))
      meterdata::$_R['ByMeter']['_'.$Meter] 
      = TObject2::Filter( new meterdata(), Array( 
        'Filter' => Array(
            'Meter'=>$Meter
        ),
        'Limit'=>$c
      ));
    return meterdata::$_R['ByMeter']['_'.$Meter];
  }


  public function GetFInit() {
    return meterdata::$FInit;
  }

  public function GetClassName(){
    return 'meterdata'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Meterdata';
  }
  public function GetNameRus(){
    return 'Данные опроса';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(meterdata::$_O[$id]) ){
      meterdata::$_O[$id] = meterdata::Id($id);
      TObject2::_DataSetAll(meterdata::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(meterdata::$_O[$id]) ){
      meterdata::$_O[$id] = new meterdata();
      TObject2::_PreInit( meterdata::$_O[$id], $id);
    }
    return meterdata::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = meterdata::$SqlTable;
    $arField = Array();
    foreach( meterdata::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return meterdata::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = meterdata::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = meterdata::$FInit[$this->_ID]['sql'];
    foreach( meterdata::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new meterdata();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new meterdata();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new meterdata();
    return TObject2::Filter($t,$aParams);
  }
}
?>
