<?php
// md5=00000000000000000000000000000000
class meterdatadaycustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`meterdataday`';
  static public $SqlFields = '`meterdataday`.`id`,`meterdataday`.`meter_id`,`meterdataday`.`parameter_id`,`meterdataday`.`year`,`meterdataday`.`month`,`meterdataday`.`day`,`meterdataday`.`value`,`meterdataday`.`loginfo_id`,`meterdataday`.`typesvalues_id`,`meterdataday`.`add_time`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Meter'=>array('type'=>'object','object'=>'meter','ready'=>false,'sql'=>'meter_id','value'=>null,'notnull'=>1, 'rus'=>'Прибор учета', 'enter'=>4),
    'Parameter'=>array('type'=>'object','object'=>'parameter','ready'=>false,'sql'=>'parameter_id','value'=>null,'notnull'=>1, 'rus'=>'Параметр'),
    'Year'=>array('type'=>'int','ready'=>false,'sql'=>'year','value'=>0, 'rus'=>'Год'),
    'Month'=>array('type'=>'int','ready'=>false,'sql'=>'month','value'=>0, 'rus'=>'Месяц'),
    'Day'=>array('type'=>'int','ready'=>false,'sql'=>'day','value'=>0, 'rus'=>'День'),
    'Value'=>array('type'=>'int','ready'=>false,'sql'=>'value','value'=>0, 'rus'=>'Значение'),
    'Loginfo'=>array('type'=>'object','object'=>'loginfo','ready'=>false,'sql'=>'loginfo_id','value'=>null, 'rus'=>'Статус'),
    'Typesvalues'=>array('type'=>'object','object'=>'typesvalues','ready'=>false,'sql'=>'typesvalues_id','value'=>null, 'rus'=>'Типы данных', 'enter'=>4),
    'AddTime'=>array('type'=>'string','ready'=>false,'sql'=>'add_time','value'=>'', 'rus'=>'Дата добавления', 'enter'=>2),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      meterdataday::$_R['All']
    ))
      meterdataday::$_R['All'] 
      = TObject2::Filter( new meterdataday());
    return meterdataday::$_R['All'];
  }


  public function GetFInit() {
    return meterdataday::$FInit;
  }

  public function GetClassName(){
    return 'meterdataday'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Meterdataday';
  }
  public function GetNameRus(){
    return 'Суточные данные';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(meterdataday::$_O[$id]) ){
      meterdataday::$_O[$id] = meterdataday::Id($id);
      TObject2::_DataSetAll(meterdataday::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(meterdataday::$_O[$id]) ){
      meterdataday::$_O[$id] = new meterdataday();
      TObject2::_PreInit( meterdataday::$_O[$id], $id);
    }
    return meterdataday::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = meterdataday::$SqlTable;
    $arField = Array();
    foreach( meterdataday::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return meterdataday::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = meterdataday::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = meterdataday::$FInit[$this->_ID]['sql'];
    foreach( meterdataday::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new meterdataday();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new meterdataday();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new meterdataday();
    return TObject2::Filter($t,$aParams);
  }
}
?>
