<?php
// md5=00000000000000000000000000000000
class metertypecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`meter_type`';
  static public $SqlFields = '`meter_type`.`id`,`meter_type`.`title`,`meter_type`.`dll_id`,`meter_type`.`interprise_id`,`meter_type`.`configuration`,`meter_type`.`meter_extra_type_id`,`meter_type`.`meters_count`,`meter_type`.`parameters_count`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'DllId'=>array('type'=>'string','ready'=>false,'sql'=>'dll_id','value'=>'','notnull'=>1, 'rus'=>'Идентификатор Библиотеки', 'enter'=>2),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании'),
    'Configuration'=>array('type'=>'string','ready'=>false,'sql'=>'configuration','value'=>'', 'rus'=>'Конфигурация'),
    'Meter_extra_type'=>array('type'=>'object','object'=>'meter_extra_type','ready'=>false,'sql'=>'meter_extra_type_id','value'=>null, 'rus'=>'Дополнительные типы приборов'),
    'Meters' => array('type'=>'fltcnt','ready'=>false,'sql'=>'meters_count','value'=>-1),
    'Parameters' => array('type'=>'fltcnt','ready'=>false,'sql'=>'parameters_count','value'=>-1),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      metertype::$_R['All']
    ))
      metertype::$_R['All'] 
      = TObject2::Filter( new metertype(), Array(  
        'Order'=>Array('Title'=>'ASC')
      ));
    return metertype::$_R['All'];
  }


  public function GetFInit() {
    return metertype::$FInit;
  }

  public function GetClassName(){
    return 'metertype'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Metertype';
  }
  public function GetNameRus(){
    return 'Тип прибора опроса';
  }
  

  protected function GetMeters(){
    if($this->Is){
      if( !isset(metertype::$_R['Meters'][$this->_F[$this->_ID]['value']])){
        metertype::$_R['Meters'][$this->_F[$this->_ID]['value']] = meter::ByType($this->_F[$this->_ID]['value'],-1);
        //$this->SetMetersCount(metertype::$_R['Meters'][$this->_F[$this->_ID]['value']]->Count);
      }
      return metertype::$_R['Meters'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function GetParameters(){
    if($this->Is){
      if( !isset(metertype::$_R['Parameters'][$this->_F[$this->_ID]['value']])){
        metertype::$_R['Parameters'][$this->_F[$this->_ID]['value']] = metertypeparameter::ByMetertype($this->_F[$this->_ID]['value'],-1);
        //$this->SetParametersCount(metertype::$_R['Parameters'][$this->_F[$this->_ID]['value']]->Count);
      }
      return metertype::$_R['Parameters'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(metertype::$_O[$id]) ){
      metertype::$_O[$id] = metertype::Id($id);
      TObject2::_DataSetAll(metertype::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(metertype::$_O[$id]) ){
      metertype::$_O[$id] = new metertype();
      TObject2::_PreInit( metertype::$_O[$id], $id);
    }
    return metertype::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = metertype::$SqlTable;
    $arField = Array();
    foreach( metertype::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return metertype::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = metertype::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = metertype::$FInit[$this->_ID]['sql'];
    foreach( metertype::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new metertype();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new metertype();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new metertype();
    return TObject2::Filter($t,$aParams);
  }
}
?>