<?php
// md5=00000000000000000000000000000000
class metertypeparametercustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`metertypeparameter`';
  static public $SqlFields = '`metertypeparameter`.`id`,`metertypeparameter`.`metertype_id`,`metertypeparameter`.`parameter_id`,`metertypeparameter`.`is_use`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Metertype'=>array('type'=>'object','object'=>'metertype','ready'=>false,'sql'=>'metertype_id','value'=>null,'notnull'=>1, 'rus'=>'Тип прибора опроса', 'enter'=>4),
    'Parameter'=>array('type'=>'object','object'=>'parameter','ready'=>false,'sql'=>'parameter_id','value'=>null,'notnull'=>1, 'rus'=>'Параметр', 'enter'=>4),
    'IsUse'=>array('type'=>'bool','ready'=>false,'sql'=>'is_use','value'=>'', 'rus'=>'Использовать', 'enter'=>7),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      metertypeparameter::$_R['All']
    ))
      metertypeparameter::$_R['All'] 
      = TObject2::Filter( new metertypeparameter(), Array( 
        'Filter' => Array(
            'IsUse'=>'1'
        ),
        'Limit'=>$c
      ));
    return metertypeparameter::$_R['All'];
  }

  static public function ByMetertype( $Metertype, $c=-1 )
  {
    if( !isset( 
      metertypeparameter::$_R['ByMetertype']
      ,metertypeparameter::$_R['ByMetertype']['_'.$Metertype]

    ))
      metertypeparameter::$_R['ByMetertype']['_'.$Metertype] 
      = TObject2::Filter( new metertypeparameter(), Array( 
        'Filter' => Array(
            'Metertype'=>$Metertype
        ), 
        'Order'=>Array('Parameter'=>'ASC'),
        'Limit'=>$c
      ));
    return metertypeparameter::$_R['ByMetertype']['_'.$Metertype];
  }

  static public function ByParameter( $Parameter, $c=-1 )
  {
    if( !isset( 
      metertypeparameter::$_R['ByParameter']
      ,metertypeparameter::$_R['ByParameter']['_'.$Parameter]

    ))
      metertypeparameter::$_R['ByParameter']['_'.$Parameter] 
      = TObject2::Filter( new metertypeparameter(), Array( 
        'Filter' => Array(
            'Parameter'=>$Parameter
        ),
        'Limit'=>$c
      ));
    return metertypeparameter::$_R['ByParameter']['_'.$Parameter];
  }


  public function GetFInit() {
    return metertypeparameter::$FInit;
  }

  public function GetClassName(){
    return 'metertypeparameter'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Metertypeparameter';
  }
  public function GetNameRus(){
    return 'Допустимые параметры для учета';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(metertypeparameter::$_O[$id]) ){
      metertypeparameter::$_O[$id] = metertypeparameter::Id($id);
      TObject2::_DataSetAll(metertypeparameter::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(metertypeparameter::$_O[$id]) ){
      metertypeparameter::$_O[$id] = new metertypeparameter();
      TObject2::_PreInit( metertypeparameter::$_O[$id], $id);
    }
    return metertypeparameter::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = metertypeparameter::$SqlTable;
    $arField = Array();
    foreach( metertypeparameter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return metertypeparameter::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = metertypeparameter::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = metertypeparameter::$FInit[$this->_ID]['sql'];
    foreach( metertypeparameter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new metertypeparameter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new metertypeparameter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new metertypeparameter();
    return TObject2::Filter($t,$aParams);
  }
}
?>
