<?php
// md5=00000000000000000000000000000000
class parametercustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`parameter`';
  static public $SqlFields = '`parameter`.`id`,`parameter`.`title`,`parameter`.`ident`,`parameter`.`parameterdatatype_id`,`parameter`.`tarif_id`,`parameter`.`lvl1`,`parameter`.`lvl2`,`parameter`.`lvl3`,`parameter`.`lvl4`,`parameter`.`conversion_id`,`parameter`.`enterprise_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'', 'rus'=>'Название', 'enter'=>2),
    'Ident'=>array('type'=>'string','ready'=>false,'sql'=>'ident','value'=>'','notnull'=>1, 'rus'=>'Идентификатор', 'enter'=>2),
    'Parameterdatatype'=>array('type'=>'object','object'=>'parameterdatatype','ready'=>false,'sql'=>'parameterdatatype_id','value'=>null,'notnull'=>1, 'rus'=>'Тип данных параметра', 'enter'=>4),
    'Tarif'=>array('type'=>'object','object'=>'tarif','ready'=>false,'sql'=>'tarif_id','value'=>null, 'rus'=>'Тариф', 'enter'=>4),
    'Lvl1'=>array('type'=>'string','ready'=>false,'sql'=>'lvl1','value'=>'', 'rus'=>'Строка объединения 1', 'enter'=>2),
    'Lvl2'=>array('type'=>'string','ready'=>false,'sql'=>'lvl2','value'=>'', 'rus'=>'Строка объединения 2', 'enter'=>2),
    'Lvl3'=>array('type'=>'string','ready'=>false,'sql'=>'lvl3','value'=>'', 'rus'=>'Строка объединения 3', 'enter'=>2),
    'Lvl4'=>array('type'=>'string','ready'=>false,'sql'=>'lvl4','value'=>'', 'rus'=>'Строка объединения 4', 'enter'=>2),
    'Conversion'=>array('type'=>'object','object'=>'conversion','ready'=>false,'sql'=>'conversion_id','value'=>null, 'rus'=>'Конвертация', 'enter'=>4),
    'Enterprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'enterprise_id','value'=>null, 'rus'=>'Компании'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      parameter::$_R['All']
    ))
      parameter::$_R['All'] 
      = TObject2::Filter( new parameter());
    return parameter::$_R['All'];
  }


  public function GetFInit() {
    return parameter::$FInit;
  }

  public function GetClassName(){
    return 'parameter'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Parameter';
  }
  public function GetNameRus(){
    return 'Параметр';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(parameter::$_O[$id]) ){
      parameter::$_O[$id] = parameter::Id($id);
      TObject2::_DataSetAll(parameter::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(parameter::$_O[$id]) ){
      parameter::$_O[$id] = new parameter();
      TObject2::_PreInit( parameter::$_O[$id], $id);
    }
    return parameter::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = parameter::$SqlTable;
    $arField = Array();
    foreach( parameter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return parameter::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = parameter::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = parameter::$FInit[$this->_ID]['sql'];
    foreach( parameter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new parameter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new parameter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new parameter();
    return TObject2::Filter($t,$aParams);
  }
}
?>
