<?php
// md5=00000000000000000000000000000000
class scheduleprogramlightcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`scheduleprogramlight`';
  static public $SqlFields = '`scheduleprogramlight`.`id`,`scheduleprogramlight`.`hour`,`scheduleprogramlight`.`minuts`,`scheduleprogramlight`.`typesschedulelight_id`,`scheduleprogramlight`.`programlight_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Hour'=>array('type'=>'int','ready'=>false,'sql'=>'hour','value'=>0, 'rus'=>'Час', 'enter'=>2),
    'Minuts'=>array('type'=>'int','ready'=>false,'sql'=>'minuts','value'=>0, 'rus'=>'Минуты', 'enter'=>2),
    'Typesschedulelight'=>array('type'=>'object','object'=>'typesschedulelight','ready'=>false,'sql'=>'typesschedulelight_id','value'=>null, 'rus'=>'Типы полей расписания освещения', 'enter'=>4),
    'Programlight'=>array('type'=>'object','object'=>'programlight','ready'=>false,'sql'=>'programlight_id','value'=>null, 'rus'=>'Программы освещения', 'enter'=>4),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      scheduleprogramlight::$_R['All']
    ))
      scheduleprogramlight::$_R['All'] 
      = TObject2::Filter( new scheduleprogramlight());
    return scheduleprogramlight::$_R['All'];
  }


  public function GetFInit() {
    return scheduleprogramlight::$FInit;
  }

  public function GetClassName(){
    return 'scheduleprogramlight'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Scheduleprogramlight';
  }
  public function GetNameRus(){
    return 'Расписание освещения';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(scheduleprogramlight::$_O[$id]) ){
      scheduleprogramlight::$_O[$id] = scheduleprogramlight::Id($id);
      TObject2::_DataSetAll(scheduleprogramlight::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(scheduleprogramlight::$_O[$id]) ){
      scheduleprogramlight::$_O[$id] = new scheduleprogramlight();
      TObject2::_PreInit( scheduleprogramlight::$_O[$id], $id);
    }
    return scheduleprogramlight::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = scheduleprogramlight::$SqlTable;
    $arField = Array();
    foreach( scheduleprogramlight::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return scheduleprogramlight::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = scheduleprogramlight::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = scheduleprogramlight::$FInit[$this->_ID]['sql'];
    foreach( scheduleprogramlight::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new scheduleprogramlight();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new scheduleprogramlight();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new scheduleprogramlight();
    return TObject2::Filter($t,$aParams);
  }
}
?>
