<?php
// md5=00000000000000000000000000000000
class smallimagecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`smallimage`';
  static public $SqlFields = '`smallimage`.`id`,`smallimage`.`name`,`smallimage`.`extension`,`smallimage`.`filesize`,`smallimage`.`about`,`smallimage`.`img_width`,`smallimage`.`img_height`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Name'=>array('type'=>'string','ready'=>false,'sql'=>'name','value'=>'', 'rus'=>'Имя файла'),
    'Extension'=>array('type'=>'string','ready'=>false,'sql'=>'extension','value'=>'', 'rus'=>'Расширение файла'),
    'Filesize'=>array('type'=>'int','ready'=>false,'sql'=>'filesize','value'=>0, 'rus'=>'Размер файла'),
    'About'=>array('type'=>'string','ready'=>false,'sql'=>'about','value'=>'', 'rus'=>'Описание'),
    'ImgWidth'=>array('type'=>'int','ready'=>false,'sql'=>'img_width','value'=>0,'notnull'=>1, 'rus'=>'Ширина изображения'),
    'ImgHeight'=>array('type'=>'int','ready'=>false,'sql'=>'img_height','value'=>0,'notnull'=>1, 'rus'=>'Высота изображения'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      smallimage::$_R['All']
    ))
      smallimage::$_R['All'] 
      = TObject2::Filter( new smallimage());
    return smallimage::$_R['All'];
  }


  public function GetFInit() {
    return smallimage::$FInit;
  }

  public function GetClassName(){
    return 'smallimage'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Smallimage';
  }
  public function GetNameRus(){
    return 'Изображение';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(smallimage::$_O[$id]) ){
      smallimage::$_O[$id] = smallimage::Id($id);
      TObject2::_DataSetAll(smallimage::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(smallimage::$_O[$id]) ){
      smallimage::$_O[$id] = new smallimage();
      TObject2::_PreInit( smallimage::$_O[$id], $id);
    }
    return smallimage::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = smallimage::$SqlTable;
    $arField = Array();
    foreach( smallimage::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return smallimage::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = smallimage::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = smallimage::$FInit[$this->_ID]['sql'];
    foreach( smallimage::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new smallimage();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new smallimage();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new smallimage();
    return TObject2::Filter($t,$aParams);
  }
}
?>
