<?php

function smarty_function_placehtmltable($params, &$smarty){
  if( !isset( $params['oPlace'] ) ) return '';
  
  
  $SSSS = microtime(true);
  
  $oPlace = $params['oPlace'];
  
  $export = false;
  
  if( isset( $params['export'] ) ){
    $export = $params['export'];
  }
  
  $LastPlace  = -1;
  $classTR    = 'lightbluehard';
  $classTRM   = 'lightblue';
  
  $str = "";
  
  if( !isset( $_GET['page'] ) ){
    $_GET['page'] = 1;
  }
  
  if( !isset($_GET['view']) ){
    $_GET['view'] = 50;
  }
  
  $page = $_GET['page'];
  $count = $_GET['view'];
  
  if( $page == 0 ){
	  $page = 1;
	}
	$start = ($page - 1 ) * $count;
	
	
	if( $start > $oPlace->MetersAll->Count ){
	  header("Location: ".$oPlace->LinkReq.'page'.ceil($oPlace->MetersAll->Count / $_GET['view']).'/view'.$_GET['view'].'/');
	}
	
	$LIMIT = " LIMIT {$start},{$count}";
	
	if( !$count or $export ){
	  $LIMIT = '';
	}
	
	$oPlace->CreateTemporary( $LIMIT/*" LIMIT 20"*/ );

	$arrF = array();
	
	$prefix = 'place__';
	
	
	foreach( place::$FInit as $ident => $des ){
	  if(isset($des['sql'])) $arrF[$ident] = place::$SqlTable . ".".$des['sql'] . " as ".$prefix . $des['sql'];
	}
	
	
	$sql = str_replace( array("\t" , "\n" , "\r") , '' ,"
	  SELECT meter.*," . implode( ', ', $arrF) . " FROM meterTemp 
	  LEFT JOIN meter ON meterTemp.id = meter.id
	  LEFT JOIN place ON place.lft = meterTemp.lft
	  group by meter.id,meterTemp.lft
	  ORDER BY meterTemp.osort
	");
	
	
	$resource = DB::Select($sql);
	
	if( $export == 'xls' ){
	  $result = XLSplacehtmltableHEAD($oPlace);
	  $Worksheet = $result['Worksheet'];
	  $objPHPExcel = $result['objPHPExcel'];
	  $ColumnNum = 0;
	  $WorksheetLine = 2;
	}elseif( $export == 'csv' ){
	  $str .= "Название;Серийный номер;Коэффициент;";
    foreach($oPlace->ActiveParameters as $iParameter){
      $str .= "\"".$iParameter->Title."\";";
    }
	}elseif( $export == 'xml' ){
	  $str .= XMLplacehtmltableHEAD($oPlace);
	}
	
	$pathtoPlace = array();
	
	meterdatahour::$IsNumberFormat = false;
	
	$i = 0;
	while( $row = DB::Fetch($resource) ){
	
	  $i++;
	
	  set_time_limit(30);
	
	  $iMeter = meter::SetFieldsFromObject($row);
	  $iPlace = $iMeter->GetPlaceOtherData($prefix);
	  
	  $iMeter->IsReport = true;
	
	  switch( $export ){
	    case 'xls' : 
	        $str .= XLSplacehtmltable($oPlace,$iMeter,$Worksheet,$ColumnNum,$WorksheetLine,$iPlace);
	      break;
      case 'csv':
          $str .= CSVplacehtmltable($oPlace,$iMeter);
        break;
      case 'xml':
          $str .= XMLplacehtmltable($oPlace,$iMeter,$iPlace);
        break;
	    case 'html':
      case false:
          meterdatahour::$IsNumberFormat = true;
          flush();
	        $str .= HTMLplacehtmltable($LastPlace,$iPlace,$classTR,$classTRM,$pathtoPlace,$export,$oPlace,$iMeter);
	      break;
	  }
	  
	}
	
	if( $export == 'xls' ){
	  XLSplacehtmltableFOOTER($objPHPExcel);
	}elseif( $export == 'xml' ){
	  $str .= XMLplacehtmltableFOOTER();
	}
	
	
	if( !$export && !$i ){
	  $str .= "<tr><td colspan='100'>Нет приборов</td></tr>";
	}
	
	$end_time = microtime(true);
	return $str;
  #return $str."[memory:".( memory_get_usage() /1024/1024)."][time:".round(($end_time-$SSSS),5)." сек]";
  
}

















function CSVplacehtmltable($oPlace,$iMeter){
  $str = "\n";
  
  $str .= "=\"{$iMeter->Title}\";";
  $str .= "=\"{$iMeter->NumSerial}\";";
  $str .= "=\"{$iMeter->Coef}\";";
  foreach($oPlace->ActiveParameters as $iParameter){
	  $MDH = $oPlace->GetRowResource($iMeter,$iParameter);
      if( $iParameter->UseCoef ){
        $str .= "=\"".$MDH->GetHtmlValue(true)."\";";
      }else{
	   $str .= "=\"".$MDH->HtmlValue."\";";
      }
	  $MDH->__destruct();
	}
  return $str;
}

function HTMLplacehtmltable(&$LastPlace,$iPlace,&$classTR,&$classTRM,&$pathtoPlace,$export,$oPlace,$iMeter){
  $str = '';
  if( $LastPlace != $iPlace->Id ){
	  
    if( $classTR == 'lightbluehard' ){
      $classTR = 'whitehard';
      $classTRM   = 'white';
    }else{
      $classTR = 'lightbluehard';
      $classTRM   = 'lightblue';
    }
  
  
    echo "<tr class=\"{$classTR}\">".
              "<td colspan=\"" . ( count($oPlace->ActiveParameters) + 3 ) . "\">";
   
    echo $iPlace->BreadcrumbsParentToThis;
	
	  echo "</tr>";
		$LastPlace = $iPlace->Id;
	}
	
	  echo "<tr class=\"{$classTRM}\">";
    if( !$export ){
      $Class = " class=\"m_list m-_{$iMeter->Id}\"";
    }else{
      $Class = '';
    }
	  echo "<td{$Class}>";
	  if( !$export ){
	    echo "<a href=\"{$iMeter->Link}\">";
	  }
	  echo $iMeter->Title;
	  if( !$export ){
	    echo "</a>";
	  }
	  echo "</td><td>";
	  if( !$export ){
	    echo "<a href=\"{$iMeter->Link}\">";
	  }
	  echo $iMeter->ShowNumSerial;
	  if( !$export ){
	    echo "</a>";
	  }
	  echo "</td>";
	  
	  foreach($oPlace->ActiveParameters as $iParameter){
	    $MDH = $oPlace->GetRowResource($iMeter,$iParameter);
	    if( !$export ){
	      $Title = $MDH->PropertyHtmlTd;
	    }else{
	      $Title = '';
	    }
        if( $iParameter->UseCoef ){
          echo "<td {$Title}>".
                    "{$MDH->GetHtmlValue(true)}".
                  "</td>";
        }else{
	      echo "<td {$Title}>".
	              "{$MDH->HtmlValue}".
	            "</td>";
        }
	    flush();
	    $MDH->__destruct();
	  }
	    
	  echo "</tr>";
  
  $iMeter->Des;
  
  //return $str;
}

function XLSplacehtmltableHEAD($oPlace){
  require_once( $_SERVER['DOCUMENT_ROOT'].'/include/PHPExcel.php' );
  
  
  
#  $cacheMethod = PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp;
#  $cacheMethod = PHPExcel_CachedObjectStorageFactory::cache_to_memcache;
  #$m = new Memcached();

  #$cacheSettings = array( 'memcacheServer' => 'saup.sergey.dev.nag.ru', 'memcachePort' => 11211, 'cacheTime' => 600 );

  $cacheSettings = array( 'memoryCacheSize' => "1024M");

#  PHPExcel_Settings::setCacheStorageMethod($cacheMethod, $cacheSettings);
  
  PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp,$cacheSettings);
#  PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_in_memory_gzip);

  $objPHPExcel = new PHPExcel();
	
	$Worksheet = $objPHPExcel->getActiveSheet();
	$WorksheetLine = 1;
	$ColumnNum = 0;
	
	$Size = array(
	  ( 12 * 1.3),
	  ( 10 * 1.3),
	  ( 8  * 1.3),
	  ( 18 * 1.3),
	);
	
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('meter_tree_point') );
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('meter_title') );
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('meter_NumSerial') );
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('meter_Coef') );
	
  
  foreach($oPlace->ActiveParameters as $iParam){
		$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iParam->Title );
		$Size[] = strlen($iParam->Title);
		
		if($iParam->Ident == "ENERGY"){
			$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('meter_ENERGY_c') );
			$Size[] = strlen( smarty()->get_config_vars('meter_ENERGY_c') );
		}
		$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('date') );
		$Size[] = strlen( smarty()->get_config_vars('date') );
	}
	$WorksheetLine++;
	return array(
	  'Worksheet' => $Worksheet,
	  'objPHPExcel' => $objPHPExcel
	);
}

function XLSplacehtmltable($oPlace,$iMeter,&$Worksheet,&$ColumnNum,&$WorksheetLine,$iPlace){

  $ColumnNum = 0;
  
  $constSTRING = PHPExcel_Cell_DataType::TYPE_STRING;
  
  $path = $iPlace->BreadcrumbsParentToThisReports;

  if( $path == '' ){return 0;}
  $pathToPlace = $path ;
  
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $pathToPlace );
	
	$Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->Title , $constSTRING );
	
	$Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->NumSerial , $constSTRING );
	
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->Coef );
	
	
  foreach($oPlace->ActiveParameters as $iParameter){
  
    $start2 = microtime(true) ;
  
    $MDH = $oPlace->GetRowResource($iMeter,$iParameter);
    
    $Value = $MDH->HtmlValue;
	  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $Value );
	  
	  if( $iParameter->UseCoef ){
	    $Value = $MDH->GetHtmlValue(true);
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $Value );
    }
    
    $Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, $MDH->AddTime , $constSTRING );
    
    $MDH->__destruct();
    
	}
	
	$WorksheetLine++;
}

function XLSplacehtmltableFOOTER($objPHPExcel){
  $objPHPExcel->getDefaultStyle()->getBorders()->getTop()   ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getBorders()->getBottom()->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getBorders()->getLeft()  ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getBorders()->getRight() ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getFont()->setName( 'Arial' );
	$objPHPExcel->getDefaultStyle()->getFont()->setSize( 8 ); 
	
	foreach (range('A', 'Z') as $char) {
      $objPHPExcel->getActiveSheet()->getColumnDimension($char)->setAutoSize(true);
  }
  
  foreach (range('A', 'Z') as $char) {
    foreach (range('A', 'Z') as $char2) {
        $objPHPExcel->getActiveSheet()->getColumnDimension($char.$char2)->setAutoSize(true);
    }
  }
	
	
#	echo DB::Status();
  
	if( ( isset($_GET['Type']) && $_GET['Type'] == "CSV" )){
	  $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'CSV' );
	}else{
	  @header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
	  @header( 'Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT' );
	  @header( "Cache-Control: no-store, no-cache, must-revalidate" );
	  @header( 'Pragma: public' );
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5' );
  }
  
  $objWriter->save('php://output');
}

function XMLplacehtmltableHEAD($oPlace){
  $str = "";
  $str .= "\t<export type=\"place\" title=\"{$oPlace->Title}\" date=\"".date("Y-m-d")."\">\n\t<parameters>\n";
  foreach( $oPlace->ActiveParameters as $iParameter ){
    $str .= "\t\t<{$iParameter->Ident} title=\"{$iParameter->Title}\"/>\n";
  }
  return $str."\t</parameters>\n\t<values type=\"meter\">\n";
}

function XMLplacehtmltable($oPlace,$iMeter,$iPlace){
  $str = '';
  
  $path = $iPlace->BreadcrumbsParentToThisReports;
  if( $path == '' ){return '';}
  $str .= "<meter ".
            "serial=\"{$iMeter->NumSerial}\" ".
            "coef=\"{$iMeter->Coef}\" ".
            "title=\"{$path} {$iMeter->About}\">\n";
  foreach($oPlace->ActiveParameters as $iParameter){
	  $MDH = $oPlace->GetRowResource($iMeter,$iParameter);
	  $value = $MDH->HtmlValue;
      if( $iParameter->UseCoef ){
        $value = $MDH->GetHtmlValue(true);
        $str .= "<{$iParameter->Ident} value=\"{$value}\" code=\"{$MDH->Loginfo->Logtext}\" addtime=\"{$MDH->AddTime}\"/>\n";
      }else{
        $str .= "<{$iParameter->Ident} value=\"{$value}\" code=\"{$MDH->Loginfo->Logtext}\" addtime=\"{$MDH->AddTime}\"/>\n";
      }
	  $MDH->__destruct();
	}
	$str .= "</meter>\n";
  return $str;
}

function XMLplacehtmltableFOOTER(){
  return "\t</values>
</export>";
}


