<?php
/*
Имя класса timezone
Имя файла timezone.class.php ( timezonecustom.class.php )
Поля класса:
Id : id
Ident : string
Title : string
Diff : int
*/
class timezone extends timezonecustom{
  
  
  /*
    Таблица соответствия для работы с JSON
  */
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Title'             => 'title',
    'Ident'             => 'ident',
  );
  
  /*
    Флаг логирования
  */
  public $NeedDoUserLog = true;
  
  
  
  
  
  
  
  
  /**
   * Переопределение метода для устранения добавления дубликатов
   * 
   * @param array $A
   * @return \timezone
   */
  static public function AddByArray($A){
    $t = new timezone();
    
    if( isset( $A['Diff'] ) ){
      $Filter = array(
          'Filter' => array(
              'Diff' => $A['Diff']
          )
      );
      $Res = timezone::Filter($Filter);
      if( $Res->Count ){
        return $Res->First;
      }
    }
    
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

}
