<?php
// md5=00000000000000000000000000000000
class timezonecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`timezone`';
  static public $SqlFields = '`timezone`.`id`,`timezone`.`ident`,`timezone`.`title`,`timezone`.`diff`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Ident'=>array('type'=>'string','ready'=>false,'sql'=>'ident','value'=>'','notnull'=>1, 'rus'=>'Идентификатор', 'enter'=>2),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'Diff'=>array('type'=>'int','ready'=>false,'sql'=>'diff','value'=>0, 'rus'=>'Смещение от UTC в минутах', 'enter'=>2),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      timezone::$_R['All']
    ))
      timezone::$_R['All'] 
      = TObject2::Filter( new timezone(), Array(  
        'Order'=>Array('Title'=>'ASC')
      ));
    return timezone::$_R['All'];
  }


  public function GetFInit() {
    return timezone::$FInit;
  }

  public function GetClassName(){
    return 'timezone'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Timezone';
  }
  public function GetNameRus(){
    return 'Часовой пояс';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(timezone::$_O[$id]) ){
      timezone::$_O[$id] = timezone::Id($id);
      TObject2::_DataSetAll(timezone::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(timezone::$_O[$id]) ){
      timezone::$_O[$id] = new timezone();
      TObject2::_PreInit( timezone::$_O[$id], $id);
    }
    return timezone::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = timezone::$SqlTable;
    $arField = Array();
    foreach( timezone::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return timezone::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = timezone::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = timezone::$FInit[$this->_ID]['sql'];
    foreach( timezone::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new timezone();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new timezone();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new timezone();
    return TObject2::Filter($t,$aParams);
  }
}
?>
