<?php
// md5=00000000000000000000000000000000
class userlogcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`userlog`';
  static public $SqlFields = '`userlog`.`id`,`userlog`.`user_id`,`userlog`.`object`,`userlog`.`property`,`userlog`.`object_id`,`userlog`.`action`,`userlog`.`its`,`userlog`.`iip`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'User'=>array('type'=>'object','object'=>'user','ready'=>false,'sql'=>'user_id','value'=>null, 'rus'=>'Пользователь'),
    'Object'=>array('type'=>'string','ready'=>false,'sql'=>'object','value'=>'', 'rus'=>'Объект', 'enter'=>2),
    'Property'=>array('type'=>'string','ready'=>false,'sql'=>'property','value'=>'', 'rus'=>'Свойство', 'enter'=>2),
    'ObjectId'=>array('type'=>'int','ready'=>false,'sql'=>'object_id','value'=>0, 'rus'=>'ИД Объекта'),
    'Action'=>array('type'=>'text','ready'=>false,'sql'=>'action','value'=>'', 'rus'=>'Событие'),
    'Its'=>array('type'=>'its','ready'=>false,'sql'=>'its','value'=>'', 'rus'=>'Дата добавления', 'enter'=>26),
    'Iip'=>array('type'=>'int','ready'=>false,'sql'=>'iip','value'=>'', 'rus'=>'IP Адрес'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      userlog::$_R['All']
    ))
      userlog::$_R['All'] 
      = TObject2::Filter( new userlog());
    return userlog::$_R['All'];
  }


  public function GetFInit() {
    return userlog::$FInit;
  }

  public function GetClassName(){
    return 'userlog'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Userlog';
  }
  public function GetNameRus(){
    return 'Лог пользователя';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(userlog::$_O[$id]) ){
      userlog::$_O[$id] = userlog::Id($id);
      TObject2::_DataSetAll(userlog::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(userlog::$_O[$id]) ){
      userlog::$_O[$id] = new userlog();
      TObject2::_PreInit( userlog::$_O[$id], $id);
    }
    return userlog::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = userlog::$SqlTable;
    $arField = Array();
    foreach( userlog::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return userlog::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = userlog::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = userlog::$FInit[$this->_ID]['sql'];
    foreach( userlog::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new userlog();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new userlog();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new userlog();
    return TObject2::Filter($t,$aParams);
  }
}
?>
