<?php

include($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');

ini_set('display_errors','1');
error_reporting( E_ALL );


$dirbin = "/home/sergey/saup";
$dir = "{$dirbin}/plugins/";


$error  = array();
$res_output    = array();


if( !function_exists( 'success' ) ){
  function success( $msg , &$output ){
    $output[] = array( 'type' => "success" , 'msg' => $msg );
  }
}
if( !function_exists( 'danger' ) ){
  function danger( $msg , &$output ){
    $output[] = array( 'type' => "danger" , 'msg' => $msg );
  }
}
if( !function_exists( 'info' ) ){
  function info( $msg , &$output ){
    $output[] = array( 'type' => "active" , 'msg' => $msg );
  }
}


if( is_dir($dir) and $dh = opendir($dir) ){
  
  $i = 0;
  
  while (($file = readdir($dh)) !== false){
  
    if( filetype( "{$dir}{$file}" ) =='file' and preg_match( '|\.so$|', $file ) ){
      
      
      if( !preg_match( '/mtr-(.*)so/' , $file ) ) continue;
      
      $res = shell_exec( $cmd = "{$dirbin}/lsauplibinfo2 -file {$dir}{$file}" );

      preg_match_all( '/(\t*)([^\t]*)(\t*)([^\t]*)(\n?)/m' , $res , $m );
      
      /*
        0 - origin string
        1 - first tab
        2 - ident
        3 - not-word
        4 - value
        5 - any
      */
      
      $Metertype = metertype::Id(0);
      $LastDllId = "";
      
      $res_item = array();
      
      foreach( $m[0] as $i => $string ){
        
        if( !trim($m[2][$i]) ) continue;
        
        switch( trim($m[2][$i]) ){
          case "Identify" : 
            //~ ...
          break;
          
          // Идентификатор библиотеки
          case "IdentifyDevice" : 
            
            $LastDllId = trim( $m[4][$i] );
            
            $Filter = array( 
              'Filter' => array( 
                'DllId' => trim( $m[4][$i] )
              )
            );
            if( metertype::Filter( $Filter )->Count ){
              $Metertype = metertype::Filter( $Filter )->First;
              info( "Есть тип {$Metertype->DllId}" , $res_item );
            }else{
              danger( "Нет типа " . trim( $m[4][$i] ) , $res_item );
            }
            
          break;
          case "Version" : 
            //~ ...
          break;
          case "DeviceName" : 
            if( !$Metertype->Is && $LastDllId ){
              $Metertype = metertype::AddByArray(array(
                'DllId' => $LastDllId,
                'Title' => trim( $m[4][$i] )
              ));
              
              success( "Добавлен тип {$Metertype->DllId}" , $res_item );
            }
          break;
          case "MeterParameterCount" : 
            //~ ...
          break;
          
          // Параметры
          default : 
          
            if( trim($m[4][$i]) == "STRING" ) continue;
            
            
              info( trim($m[2][$i]) , $res_item );
              
              $Filter = array( 
                'Filter' => array( 
                  'Ident' => trim($m[2][$i]),
                  'Enterprise' => 0
                )
              );
              
              $oParameter = parameter::Id(0);
              
              $resParameter = parameter::Filter( $Filter );
              
              if( $resParameter->Count ){
                $oParameter = $resParameter->First;
                success( "&nbsp;&nbsp;&nbsp;&nbsp;Параметр существует " , $res_item );
              }else{
                danger( "&nbsp;&nbsp;&nbsp;&nbsp;Параметра не существует ", $res_item );
                $oParameter = parameter::AddByArray(array(
                  'Ident' => trim($m[2][$i]),
                  'EnterpriseId' => 0
                ));
                if( $oParameter ){
                  success( "&nbsp;&nbsp;&nbsp;&nbsp;Параметр добавлен", $res_item );
                }else{
                  danger( "&nbsp;&nbsp;&nbsp;&nbsp;Параметр не был добавлен", $res_item );
                }
              }
              
              if( !$oParameter ) continue;
              
              $Filter = array( 
                'Filter' => array( 
                  'Metertype' => $Metertype->Id,
                  'Parameter' => $oParameter->Id
                )
              );
              
              if( !metertypeparameter::Filter( $Filter )->Count ){
                $oMetertypeparameter = metertypeparameter::AddByArray(array(
                  'MetertypeId' => $Metertype->Id,
                  'ParameterId' => $oParameter->Id,
                  'IsUse' => 1
                ));
                
                if( $oMetertypeparameter->Is ){
                  success( "&nbsp;&nbsp;&nbsp;&nbsp;Связь добавлена", $res_item );
                }else{
                  danger( "&nbsp;&nbsp;&nbsp;&nbsp;Связь не добавлена", $res_item );
                }
              }else{
                success( "&nbsp;&nbsp;&nbsp;&nbsp;Связь существует", $res_item );
              }
            
        }
      }
      
      $res_output[$LastDllId] = $res_item;
      
    }
    
  }

}
