<?php


$arMeterTypeValues = array(
	'STE_561_MC'        => array( 'Title' => 'Счетчик электроэнергии СТЭ 561', 'DllId' => 'STE_561_MC' ),
	'PSCH-3ART'         => array( 'Title' => 'Счетчик электроэнергии ПСЧ-3АРТ', 'DllId' => 'PSCH-3ART' ),
	'CE6822'            => array( 'Title' => 'Счетчик электроэнергии ЦЭ6822', 'DllId' => 'CE6822' ),
	'PSCH-4TM.05M.10'   => array( 'Title' => 'Счетчик электроэнергии ПСЧ-4ТM.05M', 'DllId' => 'PSCH-4TM.05M.10' ),
	'SNR-GSM-TEMP'      => array( 'Title' => 'Ethernet Remote Device', 'DllId' => 'SNR-GSM-TEMP' ),
	'CE102'             => array( 'Title' => 'Счетчик электроэнергии CE102', 'DllId' => 'CE102' ),
	'CE301M'            => array( 'Title' => 'Счетчик электроэнергии CE301M', 'DllId' => 'CE301M' ),
	'SEB-2A.07.212'     => array( 'Title' => 'Счетчик электроэнергии СЭБ-2А.07', 'DllId' => 'SEB-2A.07.212' ),
	'SPT_943'           => array( 'Title' => 'Тепловычислитель СПТ943', 'DllId' => 'SPT_943' ),
	'NEVA_MT123'        => array( 'Title' => 'Счетчик электроэнергии Нева МТ123 AS', 'DllId' => 'NEVA_MT123' ),
	'NEVA_MT324'        => array( 'Title' => 'Счетчик электроэнергии Нева МТ324 AS', 'DllId' => 'NEVA_MT324' ),
	'MILUR104'          => array( 'Title' => 'Счетчик электроэнергии МИЛУР 104', 'DllId' => 'MILUR104' ),
	'CE102M'            => array( 'Title' => 'Счетчик электроэнергии CE102M', 'DllId' => 'CE102M' ),
	'PSCH-3TA.07.112.2' => array( 'Title' => 'Счетчик электроэнергии ПСЧ-3ТА.07', 'DllId' => 'PSCH-3TA.07.112.2' ),
	'BARS_1_211'        => array( 'Title' => 'Счетчик электроэнергии БАРС-1.211', 'DllId' => 'BARS_1_211' ),
	'SPT_941'           => array( 'Title' => 'Тепловычислитель СПТ941', 'DllId' => 'SPT_941' ),
	'CE301'             => array( 'Title' => 'Счетчик электроэнергии CE301', 'DllId' => 'CE301' ),
	'MERCURY_230'       => array( 'Title' => 'Счетчик электроэнергии Меркурий 230', 'DllId' => 'MERCURY_230' ),
	'TEKON'             => array( 'Title' => 'ТЭКОН', 'DllId' => 'TEKON' ),
	'TYEKON'            => array( 'Title' => 'ТЕКОН', 'DllId' => 'TYEKON' ),
	'VIRTMETER'         => array( 'Title' => 'Виртуальный прибор учета', 'DllId' => 'VIRTMETER'  , 'InterpriseId' => 0 ),
  'CALCMETER'         => array( 'Title' => 'Математический прибор учета', 'DllId' => 'CALCMETER' , 'InterpriseId' => 0 ),
);


$result = array();

$arraIssetsTypes = array();

//Проверяем есть ли такие типы
foreach( metertype::All()->Elements as $iMetertype ) {
	$TypeUnique[$iMetertype->DllId] = true;
	if( !isset( $arraIssetsTypes[$iMetertype->DllId] ) ){
		$arraIssetsTypes[ $iMetertype->DllId ] = 0;
	}
  if($iMetertype->Interprise->Id == 0){
    $arraIssetsTypes[ $iMetertype->DllId ] = $arraIssetsTypes[ $iMetertype->DllId ] + 1;
  }
	
	if( isset( $arMeterTypeValues[ $iMetertype->DllId ] ) ){
		
		$EqualType = $arMeterTypeValues[ $iMetertype->DllId ];
		
		//Если полностью совпадает то удаляем из очереди добавления
		if(
				$EqualType['DllId'] 				== $iMetertype->DllId &&
				$iMetertype->Interprise->Id == 0 
			){
			unset ($arMeterTypeValues[$iMetertype->DllId]);
		}
	}
	
}

foreach( $arMeterTypeValues as $iKey => $iValue ) {
	$iValue['DllId'] = $iKey;
	$Add = metertype::AddByArray( $iValue );
	if( $Add->Is )	{
		$result[] = "Добавлен {$Add->Title}[{$Add->DllId}:{$Add->Id}]";
	}
	
	if( $Add->Interprise->Id != 0 ){
		$Add->UpdateByArray(array(
			'InterpriseId' => 0
		));
		$Add->Save();
	}
}

$res = DB::MMQ( "select id from meter_type where id not in ( select type_id from meter group by type_id ) and interprise_id = 0" );

$arType = array();

while( $row = DB::Fetch( $res ) ){
  
  $Ukey = "{$oMetertype->Title}###{$oMetertype->DllId}";
  
	$oMetertype = metertype::Id( $row['id'] );
	if( !isset( $arType[ $Ukey ] ) ){
		$arType[ $Ukey ] = true;
		continue;
	}
	$result[] = "Удален тип {$oMetertype->Id} Title:{$oMetertype->Title} DllId:{$oMetertype->DllId}";
	$oMetertype->Delete();
}


TObject2::CleanAllObjects();

foreach( $arraIssetsTypes as $Ident => $Count ){
	if( $Count <= 1 ) continue;
	$result[] = "{$Ident} <b style='color:red'>{$Count} штук!</b>";
}

smarty()->append('install_blocks' , array( 'meter_type' => "Типы приборов" ) , true );
smarty()->assign('resultMetertype' , $result);

