<?php

$result = array();

DB::Select("CREATE TEMPORARY TABLE `ConverterStatus` ( `converter_id` INT(11) , `meter_count` INT(11) , `meter_ok` INT(11))");
    
# FIRST INSERT
DB::Select("INSERT INTO `ConverterStatus` ( converter_id ) SELECT id FROM `converter`");

$res = DB::Select("SELECT * FROM ConverterStatus");

if( DB::RowCount($res) ){

    # NEXT INSERT FIELDS
    DB::Select(" UPDATE ConverterStatus  SET  meter_count = (SELECT COUNT(id) FROM meter WHERE converter_id = ConverterStatus.converter_id)  ");
    DB::Select(" UPDATE ConverterStatus  SET  meter_ok    = (SELECT COUNT(id) FROM meter WHERE converter_id = ConverterStatus.converter_id AND meter.is_ok = 1)  ");
    
    # UPDATE STATUS CONVERTER

    DB::Select("
    UPDATE 
          ConverterStatus , 
          converter 
      SET 
          converter.meter_ok = 0 
      WHERE 
          ConverterStatus.converter_id = converter.id
      AND 
          ConverterStatus.meter_ok = 0
          ");
          
    DB::Select("
    UPDATE 
          ConverterStatus , 
          converter 
      SET 
          converter.meter_ok = 2 
      WHERE 
          ConverterStatus.converter_id = converter.id
      AND 
          ConverterStatus.meter_ok != ConverterStatus.meter_count
      AND 
          ConverterStatus.meter_ok != 0
          ");
          
    DB::Select("
    UPDATE 
          ConverterStatus , 
          converter 
      SET 
          converter.meter_ok = 1 
      WHERE 
          ConverterStatus.converter_id = converter.id
      AND 
          ConverterStatus.meter_ok = ConverterStatus.meter_count
          ");
          
}else{
    $result[] = "Нет конверторов в БД.";
}

DB::Select("DROP TEMPORARY TABLE IF EXISTS `ConverterStatus`");

smarty()->append('install_blocks' , array( 'replace_status_converter' => "Актуализация статусов конверторов" ) , true );
smarty()->assign('resultReplaceStatusConverter' , $result);