<?php

$arTimezoneTypeValues = array(
	'0' 	=> array( 'Title' => 'UTC+00:00',  'Diff' =>   0  ,'Ident' => 'Europe/London'),
	'60' 	=> array( 'Title' => 'UTC+01:00',  'Diff' =>  60  ,'Ident' => ''),
	'120' => array( 'Title' => 'UTC+02:00',  'Diff' =>  120 , 'Ident' => 'Europe/Kaliningrad'),
	'180' => array( 'Title' => 'UTC+03:00',  'Diff' =>  180 , 'Ident' => 'Europe/Moscow' ),
	'240' => array( 'Title' => 'UTC+04:00',  'Diff' =>  240 , 'Ident' => 'Europe/Samara'),
	'300' => array( 'Title' => 'UTC+05:00',  'Diff' =>  300 , 'Ident' => 'Asia/Yekaterinburg'),
	'360' => array( 'Title' => 'UTC+06:00',  'Diff' =>  360 , 'Ident' => 'Asia/Omsk'),
	'420' => array( 'Title' => 'UTC+07:00',  'Diff' =>  420 , 'Ident' => 'Asia/Krasnoyarsk'),
	'480' => array( 'Title' => 'UTC+08:00',  'Diff' =>  480 , 'Ident' => 'Asia/Irkutsk'),
	'540' => array( 'Title' => 'UTC+09:00',  'Diff' =>  540 , 'Ident' => 'Asia/Yakutsk'),
	'600' => array( 'Title' => 'UTC+10:00',  'Diff' =>  600 , 'Ident' => 'Asia/Vladivostok'),
	'660' => array( 'Title' => 'UTC+11:00',  'Diff' =>  660 , 'Ident' => 'Asia/Kamchatka'), # not fount TODO UPDATE http://www.worldtimezone.com/dst_news/dst_news_russia-map-2016-03.html
	'720' => array( 'Title' => 'UTC+12:00',  'Diff' =>  720 , 'Ident' => 'Asia/Kamchatka'),
);

$result = array();

foreach( timezone::All()->Elements as $iTimezone ) {
  if( empty( $iTimezone->Ident ) ){
    $iTimezone->Ident = $arTimezoneTypeValues[$iTimezone->Diff]['Ident'];
    $iTimezone->Save();
  }
	# Удаление дубликатов
	if( !isset( $arTimezoneTypeValues[$iTimezone->Diff] ) ){
	  $iTimezone->Delete();
	  $result[] = "Удален дубликат {$iTimezone->Title}[{$iTimezone->Id}]";
	  continue;
	}
	unset ($arTimezoneTypeValues[$iTimezone->Diff]);
}
foreach( $arTimezoneTypeValues as $iValue ) {
	$Add = timezone::AddByArray( $iValue );
	if( $Add->Is )	{
		$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
	}
}

smarty()->append('install_blocks' , array( 'timezone' => "Временные зоны" ) , true );
smarty()->assign('resultTimezone' , $result);