$(document).ready(function(){
  
  require([
    "backbone"
  ],function(
    Backbone
  ){
    var config = Backbone.Model.extend({
      defaults : {
        Value : "",
        About : "",
        id : 0,
      },
      url : function(){
        return '/api/?object=config&filter=id:' + this.id
      }
    })
    
    $(document).on('click' , '.is_demo, .is_forgot' , function(){
    
      var id = $(this).attr('id').replace('config_','')
      
      var conf = new config({
        id : id,
        Value : Number( Boolean( $(this).hasClass('btn-success') ) )
      })
      
      var self = this
      
      conf.save().then(function(){
        if( conf.get('Value') == 0 ){
          $(self).removeClass('btn-danger').addClass('btn-success').text('Вкл.')
        }else{
          $(self).addClass('btn-danger').removeClass('btn-success').text('Выкл.')
        }
      })
      
    }).on('click' , '#admin_mask' , function(){
      
      
      $.get(
        '/tpl/?tpl=user_mask_list',
        {data : [0]},
        function( tpl ){
          
          var tpl = $(tpl)
          
          $(tpl).modal('show').on('click' , 'a',function( e ){
            
            var id = $(e.target).attr('id').replace(/^config_([0-9]*)_user_([0-9]*)$/,function(_,id){
              return id
            })
            
            var user = $(e.target).attr('id').replace(/^config_([0-9]*)_user_([0-9]*)$/,function(_,id,uid){
              return uid
            })
            
            var conf = new config({
              id : id,
              Value : user
            })
            
            conf.save().then(function(){
              $( tpl ).modal('hide')
            })
            
            return false;
          })
          
        }
      )
      
      return false;
    }).on('click' , '#admin_mask_disable' , function( e ){
      
      var conf = new config({
        id : $(e.target).attr('data-config-id'),
        Value : ""
      })
      
      conf.save()
    })
    
    
    
  })
  
})
