define([
  "backbone",
  "vconverter"
] , function(
  Backbone,
  vconverter
){
  if( typeof Backbone.collection_vconverter == 'undefined'  ){
    Backbone.collection_vconverter = Backbone.Collection.extend({
      model : vconverter,
      url : function(){
        
        var count = getParameterByName('count') || 10
        var page  = getParameterByName('page') || 1
        
        let a = count * page - count
        let b = count
        
        return '/api/?object=vconverter&type=virtual&limit[]='+a+'&limit[]='+b+''
      }
    })
    Backbone.collection_vconverter = new Backbone.collection_vconverter();
  }
  return Backbone.collection_vconverter;
})
