define([
  "backbone"
] , function(
  Backbone
){
  
  return Backbone.Model.extend({
    defaults : {
      id              : 0,
      about           : "",
      coef            : 1,
      converter       : 0,
      in_use          : false,
      is_excluded     : true,
      is_ok           : false,
      num485          : "",
      num_serial      : "",
      password        : "",
      timezone        : 0,
      type            : 0
    },
    url: function(){
      return '/api/?object=meter&filter=id:' + this.get('id')
    },
    parse : function( a ){
      a.type = Number( a.type )
      a.converter = Number( a.converter )
      a.coef = Number( a.coef )
      a.id = Number( a.id )
      return a;
    },
  })
  
})