define([
  "backbone"
],function(
  Backbone
){
  
  return Backbone.Model.extend({
    defaults : {
      id              : 0,
      about           : "",
      converter       : 0,
      is_ok           : false,
      num_serial      : "",
      type            : 0,
      title           : "",
      timezone        : 0,
      extra_type      : 0,
    },
    url: function(){
      return '/api/?object=vmeter&filter=id:' + this.get('id')
    },
    parse : function( a ){
      a.type = Number( a.type )
      a.converter = Number( a.converter )
      a.id = Number( a.id )
      a.timezone = Number( a.timezone )
      return a;
    },
  })
  
});