var BigInt, CHANEL, CHANELS, CONNECT_VIEW, COUNTER, DoLog, ERROR, ISSUE, ISSUES, LOG, LOGS, MODAL_CHANEL, MODAL_DATE, MODAL_PASS, RUNNING, SEND, SETTINS_VIEW, SLEEP, SUCCESS, TEXT_VIEW, WAITING, counter, get_format_value, intFixLength, issues, set_hex, str_to_hex, validator_hex_fields;

jQuery.fn.paste_simbol_hex = function(e) {
  var i, j, new_val, ref, v;
  if ((e == null) || (e.keyCode == null) || typeof e.keyCode !== 'undefined') {
    false;
  }
  switch (e.keyCode) {
    case 46:
    case 8:
      $(this).val($(this).val().replace(/:$/g, ''));
      break;
    default:
      v = $(this).val().replace(/\:/g, '');
      new_val = "";
      for (i = j = 0, ref = v.length; 0 <= ref ? j < ref : j > ref; i = 0 <= ref ? ++j : --j) {
        new_val += v[i].toUpperCase();
        if (i && i % 2 && (v.length - 1) !== i) {
          new_val += ":";
        }
      }
      $(this).val(new_val);
  }
  return null;
};

validator_hex_fields = function(str, min_len, max_len, separator) {
  var valid;
  if (separator == null) {
    separator = ":";
  }
  valid = true;
  if (!str) {
    return false;
  }
  if (min_len && str.split(":").length < min_len) {
    return false;
  }
  if (max_len && str.split(":").length > max_len) {
    return false;
  }
  str.split(":").map(function(block) {
    if (!valid) {
      return valid;
    }
    if (block.length !== 2) {
      valid = false;
      return true;
    }
    if (!block.match(/^([A-F|0-9|\:]*)$/)) {
      valid = false;
      return true;
    }
  });
  return valid;
};

str_to_hex = function(str) {
  var x;
  if (typeof str === "number") {
    x = Object(str).toString(16).toUpperCase();
    if (x.length === 1) {
      return "0" + x;
    } else {
      return x;
    }
  }
  return String(str).split('').reduce(function(res, item) {
    res.push(("0" + (item.charCodeAt(item).toString(16))).slice(-2).toUpperCase());
    return res;
  }, []).join(':');
};

BigInt = function(x) {
  if (x > 0x7FFFFFFF) {
    x = x - 0xFFFFFFFF;
  }
  return x;
};

intFixLength = function(int, needLength) {
  var n;
  if (int < 0) {
    return GetTo32(int);
  }
  n = Number(int).toString(16);
  needLength = needLength || 2;
  n = String(n);
  while (n.length < needLength) {
    n = "0" + n;
  }
  return n;
};

function GetTo32(value){
    
    var y = 32;
    CurrentValue = parseInt(value);
    var yourNumber = CurrentValue.toString(10);
    if (isNaN(yourNumber)) {
        alert("The inserted number is not a valid signed integer number. \n Please try another number.");
    }
    var bin = CurrentValue.toString(2);
    var newbin;
    //used for negative numbers to hold the first zeros and first 1 from the left
    var i = 0;
    var j = 0;
    var digit = 0;
    var temp = 0;
    var decm = 0;
    var inputlength = bin.length;
        if (inputlength > y){
            if ((inputlength - 1 <= y) && (bin.charAt(0) == "-") && (bin.charAt(1) == 1)) {
                for (i = (inputlength - 1); i >= 2; i--) {
                    if (bin.charAt(i) == 1) {
                        temp = 1
                    }
                }
                ;if (temp == 0) {
                    bin = bin.slice(1)
                    for (i = bin.length - 1; i >= 0; i -= 1) {
                        decm += eval(bin.charAt(i)) * Math.pow(2, bin.length - i - 1);
                    }
                    Result = decm.toString(16).toUpperCase();
                    return Result;
                } else {
                    alert("Overflow - not enough binary digits to display the number" + CurrentValue);
                }
            } else {
                alert("Overflow - not enough binary digits to display the number " + CurrentValue);
            }
        } else if ((inputlength == y) && (bin.charAt(0) == 1)) {
            alert("Overflow - not enough binary digits to display the number " + x);
        } else if ((inputlength < y) && (bin.charAt(0) != "-")) {
            for (i = 0; i < (y - inputlength); i++) {
                bin = "0" + bin;
            }
            //adds 0's for positive numbers
            for (i = bin.length - 1; i >= 0; i -= 1) {
                decm += eval(bin.charAt(i)) * Math.pow(2, bin.length - i - 1);
            }
            Result = decm.toString(16).toUpperCase();
            return Result;
        }
        ;if ((inputlength <= y) && (bin.charAt(0) == "-")) {
            bin = bin.slice(1);
            //slice the "-" from the neg number
            while (digit == 0) //counts the # of 0's until the first "1",starting with LSB
            {
                digit = bin.charAt((inputlength - 2 - i));
                i++;
            }
            ;newbin = bin.slice(inputlength - 1 - i);
            //storage for the LSB's: 10...0   
            for (j = (inputlength - 2 - i); j >= 0; j--) //flips all other 1's and 0's
            {
                if (bin.charAt(j) == "0") {
                    newbin = "1" + newbin;
                } else {
                    newbin = "0" + newbin;
                }
            }
            for (i = 0; i < (y - inputlength + 1); i++) {
                newbin = "1" + newbin;
            }
            ;//adds 1's for negative numbers 
            bin = newbin;
            for (i = bin.length - 1; i >= 0; i -= 1) {
                decm += eval(bin.charAt(i)) * Math.pow(2, bin.length - i - 1);
            }
            Result = decm.toString(16).toUpperCase();
            return Result;
        }
        ;

}  
;

get_format_value = function(value) {
  if (value === Number.POSITIVE_INFINITY || value === Number.NEGATIVE_INFINITY || isNaN(value)) {
    value = '';
  }
  if (value !== '' && value % parseInt(value) !== 0) {
    value = value.toFixed(0);
  }
  if (isNaN(value)) {
    return 0;
  }
  return value;
};

SEND = Backbone.View.extend({
  defaults: {
    status: null,
    act: null,
    ip: null,
    port: null,
    mac: null,
    tpu: null,
    cmd_1: null,
    cmd_2: null,
    tpu: null,
    ta: null
  }
});

RUNNING = 'RUNNING';

WAITING = 'WAITING';

ERROR = 'ERROR';

SUCCESS = 'SUCCESS';

SLEEP = 'SLEEP';

CHANEL = Backbone.Model.extend({
  defaults: {
    data_counter: null,
    delta_counter: null,
    delta_imp: null,
    delta_user_v: null,
    divider: null,
    is_edit: null,
    math: null,
    price_imp: null,
    res_imp: null,
    res_user_v: null,
    section_imp: null,
    section_user_v: null,
    value_now: null
  },
  is_error: function() {
    var error;
    error = false;
    counter.get('issues').where({
      ident: "get_values_chanel",
      chanel: (this.collection.indexOf(this)) + 1
    }).map(function(issue) {
      if (issue.get('status') === ERROR) {
        return error = true;
      }
    }, this);
    return error;
  },
  is_waiting: function() {
    var wait;
    wait = false;
    counter.get('issues').where({
      ident: "get_values_chanel",
      chanel: (this.collection.indexOf(this)) + 1
    }).map(function(issue) {
      if (issue.get('status') === WAITING) {
        return wait = true;
      }
    }, this);
    return wait;
  },
  is_running: function() {
    var run;
    run = false;
    counter.get('issues').where({
      ident: "get_values_chanel",
      chanel: (this.collection.indexOf(this)) + 1
    }).map(function(issue) {
      if (issue.get('status') === RUNNING) {
        return run = true;
      }
    }, this);
    return run;
  },
  __set_res_user_v: function() {
    var v;
    v = (Number(this.get('value_now')) - Number(this.get('delta_counter') * this.get('price_imp'))) + Number(this.get('delta_user_v'));
    this.set({
      "res_user_v": get_format_value(v)
    });
    return true;
  },
  __set_price_imp: function() {
    var p_i;
    p_i = Number(this.get("math")) / Number(this.get('divider'));
    this.set("price_imp", get_format_value(p_i));
    return true;
  },
  __set_delta_imp: function() {
    var v;
    v = this.get('delta_user_v') / this.get('price_imp');
    this.set("delta_imp", get_format_value(v));
    return true;
  },
  __set_res_imp: function() {
    var v;
    v = this.get('res_user_v') / this.get('price_imp');
    this.set({
      "res_imp": get_format_value(v)
    });
    return true;
  },
  __set_section_user_v: function() {
    var v;
    v = this.get('price_imp') * this.get('section_imp');
    this.set("section_user_v", get_format_value(v));
    return true;
  },
  __set_delta_user_v: function() {
    var v;
    v = this.get('data_counter') - this.get('section_user_v');
    this.set("delta_user_v", get_format_value(v));
    return true;
  }
});

CHANELS = Backbone.Collection.extend({
  model: CHANEL
});

ISSUE = Backbone.Model.extend({
  defaults: {
    ident: null,
    cmd_1: null,
    cmd_2: null,
    ta: null,
    tp: null,
    tpu: null,
    use_pass: null,
    chanel: null,
    status: null,
    data: null,
    name: ""
  },
  run: function(callback) {
    var data, path_to_sript;
    if (callback == null) {
      callback = function() {};
    }
    this.set({
      'status': RUNNING
    });
    if (window.location.hostname === "rsconfig.nagruzka.net") {
      path_to_sript = "./send.php";
    } else {
      path_to_sript = '/rsconfig/send/';
    }
    data = {
      act: 'do',
      ip: counter.get('ip'),
      port: counter.get('port'),
      mac: counter.get('mac'),
      cmd_1: this.get('cmd_1'),
      cmd_2: this.get('cmd_2')
    };
    if (this.get("use_pass")) {
      data["tpu"] = 1;
      data["tp"] = counter.get("pass");
    }
    if (this.get("ta") !== this.defaults.ta) {
      data["ta"] = this.get("ta");
    }
    return $.ajax({
      url: path_to_sript,
      dataType: 'script',
      contentType: 'application/javascript',
      data: data,
      cache: false,
      async: true,
      success: function(response) {
        if (callback) {
          return callback(response);
        }
      }
    }).fail(function(a, b, c) {
      if (callback) {
        callback(a, b, c);
        return DoLog("ERROR");
      }
    });
  }
});

ISSUES = Backbone.Collection.extend({
  model: ISSUE
});

issues = new ISSUES([
  {
    ident: "get_values_chanel",
    cmd_1: 28,
    cmd_2: 10,
    name: "Получение данных с канала"
  }, {
    ident: "set_values_chanel",
    cmd_1: 28,
    cmd_2: 11,
    use_pass: true,
    name: "Запись данных на канал"
  }, {
    ident: "get_values",
    cmd_1: 21,
    cmd_2: 1,
    name: "Получение текущих значений"
  }, {
    ident: "get_slice",
    cmd_1: 21,
    cmd_2: 10,
    name: "Получение срезов"
  }, {
    ident: "get_ident",
    cmd_1: 20,
    cmd_2: 2,
    name: "Получение идентификатора устройства"
  }, {
    ident: "get_version",
    cmd_1: 20,
    cmd_2: 3,
    name: "Получение версии устройства"
  }, {
    ident: "get_time",
    cmd_1: 20,
    cmd_2: 20,
    name: "Получение времени с устройства"
  }, {
    ident: "set_time",
    cmd_1: 20,
    cmd_2: 21,
    use_pass: true,
    name: "Установка времени на устройство"
  }, {
    ident: "set_pass",
    cmd_1: 20,
    cmd_2: 10,
    use_pass: true,
    name: "Установка пароля на устройство"
  }
]);

LOG = Backbone.Model.extend({
  defaults: {
    msg: null,
    type: null,
    time: null,
    is_in: null,
    reason: "",
    chanel: null,
    issue_cid: null
  }
});

set_hex = function(int) {
  return intFixLength(int, 8).replace(/(\w{2})/g, function(_, a, b) {
    return a + (b !== 6 ? ":" : "");
  });
};

LOGS = Backbone.Collection.extend({
  model: LOG,
  _sort_by_issues: function() {
    return _.sortBy(this.toArray(), 'time').reduce(function(res, log) {
      if (typeof res[log.get("issue_cid")] === "undefined") {
        res[log.get("issue_cid")] = [];
      }
      res[log.get("issue_cid")].push(log);
      return res;
    }, {});
  }
});

DoLog = function(type, msg, chan) {
  var chanel, d, date_str, issue, number, run_issue;
  d = new Date();
  date_str = d.getFullYear() + "-" + (d.getMonth() + 1) + "-" + d.getDate() + " " + d.getHours() + ":" + d.getMinutes() + ":" + d.getSeconds();
  switch (type) {
    case "SUCCESS_WRITE":
      issue = counter.get('issues').findWhere({
        "status": RUNNING
      });
      if (issue) {
        issue.set({
          "status": SUCCESS
        });
        return counter.get('log').add({
          msg: msg,
          type: "success",
          time: date_str
        });
      }
      break;
    case "ERROR":
      counter.get('issues').toArray().map(function(issue) {
        var pass;
        if (issue.get('status') === SUCCESS) {
          return false;
        }
        if (issue.get("ident") === "set_pass") {
          pass = counter.previous("pass");
          counter.set({
            "pass": pass
          });
          counter._previousAttributes.pass = pass;
        }
        return issue.set({
          'status': ERROR
        });
      });
      if (!counter.get("is_connect")) {
        return counter.get('log').add({
          msg: msg,
          type: "main",
          time: date_str
        });
      }
      break;
    case "VERSION":
      counter._set_version(msg);
      issue = counter.get('issues').findWhere({
        ident: "get_version"
      });
      if (issue) {
        return issue.set({
          "status": "SUCCESS"
        });
      }
      break;
    case "VALUE_NOW":
      counter._set_time_device(msg);
      issue = counter.get('issues').findWhere({
        ident: "get_time"
      });
      if (issue) {
        return issue.set({
          "status": "SUCCESS"
        });
      }
      break;
    case "VALUE_DATETIME":
      counter._set_time_server(msg);
      issue = counter.get('issues').findWhere({
        ident: "get_time"
      });
      if (issue) {
        return issue.set({
          "status": "SUCCESS"
        });
      }
      break;
    case "VALUE":
      number = Number(chan.replace("DI", ""));
      issue = counter.get('issues').findWhere({
        ident: "get_values"
      });
      if (issue) {
        issue.set({
          "status": "SUCCESS"
        });
      }
      chanel = counter._get_chanel_by_number(number);
      if (!chanel) {
        return false;
      }
      return chanel.set({
        'value_now': BigInt(Number(msg))
      });
    case "VALUE_IDENT":
      counter._set_ident(msg);
      issue = counter.get('issues').findWhere({
        ident: "get_ident"
      });
      if (issue) {
        return issue.set({
          "status": "SUCCESS"
        });
      }
      break;
    case 'VALUE_MDOG':
      number = Number(chan.replace("DI", ""));
      issue = counter.get('issues').findWhere({
        ident: "get_values_chanel",
        chanel: number
      });
      if (issue) {
        issue.set({
          "status": "SUCCESS"
        });
      }
      chanel = counter._get_chanel_by_number(number);
      if (!chanel) {
        return false;
      }
      return chanel.set({
        'math': BigInt(Number(msg))
      });
    case 'VALUE_DELIM':
      number = Number(chan.replace("DI", ""));
      issue = counter.get('issues').findWhere({
        ident: "get_values_chanel",
        chanel: number
      });
      if (issue) {
        issue.set({
          "status": "SUCCESS"
        });
      }
      chanel = counter._get_chanel_by_number(number);
      if (!chanel) {
        return false;
      }
      return chanel.set({
        'divider': BigInt(Number(msg))
      });
    case 'VALUE_DELTA':
      number = Number(chan.replace("DI", ""));
      issue = counter.get('issues').findWhere({
        ident: "get_values_chanel",
        chanel: number
      });
      if (issue) {
        issue.set({
          "status": "SUCCESS"
        });
      }
      chanel = counter._get_chanel_by_number(number);
      if (!chanel) {
        return false;
      }
      return chanel.set({
        'delta_counter': BigInt(Number(msg))
      });
    case 'VALUE_SREZ':
      number = Number(chan.replace("DI", ""));
      issue = counter.get('issues').findWhere({
        ident: "get_slice"
      });
      if (issue) {
        issue.set({
          "status": "SUCCESS"
        });
      } else {
        console.error("Нет задачи");
      }
      chanel = counter._get_chanel_by_number(number);
      if (!chanel) {
        console.error("Нет канала в списке каналов");
        return false;
      }
      return chanel.set({
        'section_imp': BigInt(Number(msg))
      });
    default:
      if (type !== "PROGRESS" && type !== "DEBUG" && type !== "INFO") {
        run_issue = counter.get("issues").findWhere({
          "status": RUNNING
        });
        if (run_issue) {
          return counter.get('log').add({
            msg: msg,
            type: "all",
            is_in: chan === "IN",
            chanel: run_issue.get("chanel"),
            time: date_str,
            issue_cid: run_issue.cid,
            reason: run_issue.get('name')
          });
        }
      }
  }
};

COUNTER = Backbone.Model.extend({
  defaults: {
    ip: null,
    port: null,
    mac: null,
    pass: null,
    serial: null,
    version: null,
    time_server: null,
    time_device: null,
    advanced_mode: false,
    is_connect: null,
    issues: new ISSUES(),
    chanels: new CHANELS([{}, {}, {}, {}, {}, {}, {}, {}]),
    log: new LOGS(),
    is_edit: true,
    is_view_log: false
  },
  is_valid_from_connect: function() {
    return this.get('ip') && this.get('port') && this.get('mac') && this.get('pass');
  },
  start_clear_pull: function() {
    var issue, issue_for_run;
    issue_for_run = counter.get('issues').where({
      status: WAITING
    });
    if (issue_for_run.length === 0) {
      return false;
    }
    issue = issue_for_run.splice(0, 1);
    return issue[0].run(counter.start_clear_pull);
  },
  clear_issues: function() {
    return counter.get('issues').reset();
  },
  get_issues_run_w: function() {
    return this.get('issues').toArray().reduce(function(res, issue) {
      if (issue.get('status') === WAITING || issue.get('status') === RUNNING) {
        res++;
      }
      return res;
    }, 0);
  },
  _get_chanel_by_number: function(number) {
    if (this.get('chanels')) {
      if (this.get('chanels').at(number - 1)) {
        return this.get('chanels').at(number - 1);
      } else {
        return false;
      }
    } else {
      return false;
    }
  },
  _set_version: function(v) {
    this.set({
      'version': v
    });
    return this._set_is_connect();
  },
  _set_time_device: function(v) {
    this.set({
      'time_device': v
    });
    return this._set_is_connect();
  },
  _set_time_server: function(v) {
    this.set({
      'time_server': v
    });
    return this._set_is_connect();
  },
  _set_ident: function(v) {
    this.set({
      'ident': v
    });
    return this._set_is_connect();
  },
  _set_is_connect: function() {
    return false;
  }
});

counter = new COUNTER();

counter.get('chanels').on('change:math', function(model) {
  return model.__set_price_imp();
}).on('change:divider', function(model) {
  return model.__set_price_imp();
}).on('change:data_counter', function(model) {
  return model.__set_delta_user_v();
}).on('change:section_user_v', function(model) {
  return model.__set_delta_user_v();
}).on('change:delta_user_v', function(model) {
  return model.__set_delta_imp();
}).on('change:price_imp', function(model) {
  return model.__set_delta_imp();
}).on('change:res_user_v', function(model) {
  return model.__set_res_imp();
}).on('change:price_imp', function(model) {
  return model.__set_res_imp();
}).on("change:value_now", function(model) {
  return model.__set_res_user_v();
}).on("change:delta_counter", function(model) {
  return model.__set_res_user_v();
}).on("change:price_imp", function(model) {
  return model.__set_res_user_v();
}).on("change:delta_user_v", function(model) {
  return model.__set_res_user_v();
}).on('change:price_imp', function(model) {
  return model.__set_section_user_v();
}).on('change:section_imp', function(model) {
  return model.__set_section_user_v();
});

$(document).ready(function() {
  var reg, res;
  reg = new RegExp(/^#do\/([0-9|\.]*)\/([0-9]*)\/([0-9|A-F|\:]*)\/([0-9|A-F||\:]*)/);
  if (reg.test(window.location.hash)) {
    res = reg.exec(window.location.hash);
    return counter.set({
      ip: res[1],
      port: res[2],
      mac: res[3],
      pass: res[4]
    });
  } else {
    return counter.set({
      ip: "172.31.74.21",
      port: 50,
      mac: "F8:F0:82:02:59:E8:00:00",
      pass: "01:02:03:04:05:06:07:08:09:10"
    });
  }
});

SETTINS_VIEW = Backbone.View.extend({
  el: "#connect",
  template: "#configurator_tpl",
  model: counter,
  initialize: function() {
    return this.render();
  },
  render: function() {
    return console.log(111);
  }
});

MODAL_CHANEL = Backbone.View.extend({
  template: "#modal_tpl",
  el: '#app',
  initialize: function(chanel) {
    this.model = chanel;
    return this.render();
  },
  render: function() {
    var modal, self, tpl_c;
    tpl_c = _.template($(this.template).html());
    modal = tpl_c({
      chanel: this.model
    });
    self = this;
    modal = $(modal).modal("show");
    $(modal).on("keyup", ".data_counter", function(e) {
      return self.model.set({
        "data_counter": Number($(e.target).val())
      });
    }).on("keyup", ".math", function(e) {
      return self.model.set({
        "math": Number($(e.target).val())
      });
    }).on("keyup", ".divider", function(e) {
      return self.model.set({
        "divider": Number($(e.target).val())
      });
    }).on("hidden.bs.modal", function() {
      return $(modal).remove();
    }).on("shown.bs.modal", function() {
      return Object.keys(self.model.attributes).map(function(attr) {
        if (attr === 'math' || attr === 'divider' || attr === 'data_counter') {
          return false;
        }
        new TEXT_VIEW(this.model, "#t_cid" + this.model.cid + "_" + attr, attr);
        return new TEXT_VIEW(this.model, "#cid" + this.model.cid + "_" + attr, attr);
      }, self);
    }).on("click", "#save", function() {
      var _index, index, issue, issue_parent;
      issue_parent = issues.findWhere({
        ident: "set_values_chanel"
      });
      if (issue_parent) {
        issue = new ISSUE(issue_parent.toJSON());
        _index = self.model.collection.indexOf(self.model);
        index = intFixLength(_index + 1, 2);
        issue.set({
          status: WAITING,
          ta: [index, set_hex(self.model.get('math')), set_hex(self.model.get('divider')), set_hex(Number(self.model.get('delta_imp')))].join(":")
        });
        counter.get('issues').add(issue);
        $(modal).modal('hide');
        return counter.start_clear_pull();
      }
    });
    return this;
  }
});

TEXT_VIEW = Backbone.View.extend({
  el: "div",

  /*
    * Инифиализация текстовой ячейки
    * @param  {Backbone.Model} model Модель с которой работаем
    * @param  {Object} el    Объект DOM с которым будем работать
    * @param  {String} prop  Свойство которое будем отслеживать
    * @return {undefined}       undefined
   */
  initialize: function(model, el, prop) {
    this.model = model;
    this.prop = prop;
    this.el = el;
    this.listenTo(this.model, 'change', this.render);
    return this.render();
  },
  render: function() {
    if (!$(this.el).length) {
      console.error("Нет шаблона " + this.el);
      false;
    }
    return $(this.el).text(this.model.get(this.prop));
  }
});

MODAL_PASS = Backbone.View.extend({
  template: "#modal_pass_tpl",
  initialize: function() {
    return this.render();
  },
  model: counter,
  validate: function() {
    var valid;
    valid = true;
    if ($("#new_pass").val().length) {
      if (!validator_hex_fields($('#new_pass').val(), 10, 10)) {
        $("#new_pass").closest('.form-group').addClass('has-error');
        valid = false;
      } else {
        $("#new_pass").closest('.form-group').removeClass('has-error');
      }
    } else {
      valid = false;
    }
    $('#save_new_pass').prop("disabled", valid ? null : true);
    return valid;
  },
  render: function() {
    var modal, self, tpl_c;
    tpl_c = _.template($(this.template).html());
    modal = $(tpl_c()).modal("show");
    self = this;
    return $(modal).on("keyup", "#new_pass", function(e) {
      $(e.target).paste_simbol_hex(e);
      return self.validate();
    }).on("shown.bs.modal", function() {
      return self.validate();
    }).on("hidden.bs.modal", function() {
      return $(modal).remove();
    }).on("click", "#save_new_pass", function(e) {
      var issue, issue_parent;
      if ($(e.target).hasClass("btn-disabled")) {
        return false;
      }
      issue_parent = issues.findWhere({
        ident: "set_pass"
      });
      if (issue_parent) {
        issue = new ISSUE(issue_parent.toJSON());
        issue.set({
          status: WAITING,
          ta: $("#new_pass").val()
        });
        self.model.get('issues').add(issue);
        self.model.start_clear_pull();
        return $(modal).modal("hide");
      }
    });
  }
});

MODAL_DATE = Backbone.View.extend({
  template: "#set_date_tpl",
  initialize: function() {
    return this.render();
  },
  model: counter,
  render: function() {
    var day, day_sys, hour, hour_sys, is_my_time, minutes, minutes_sys, modal, month, month_sys, n, now, ref, regexp_date, regexp_device_time, regexp_time, res_d_t, self, tpl_c, year;
    tpl_c = _.template($(this.template).html());
    self = this;
    regexp_date = new RegExp(/(\d{4})-(\d{2})-(\d{2})/);
    regexp_time = new RegExp(/(\d{2}):(\d{2})/);
    regexp_device_time = new RegExp(/(\d{4}).(\d{2}).(\d{2}) (\d{2}):(\d{2}):(\d{2})/);
    is_my_time = !regexp_device_time.test(counter.get('device_time'));
    if (is_my_time) {
      now = new Date();
      ref = [now.getDate(), now.getMonth(), now.getHours(), now.getMinutes(), now.getFullYear()], day_sys = ref[0], month_sys = ref[1], hour_sys = ref[2], minutes_sys = ref[3], year = ref[4];
      day = day_sys < 10 ? "0" + day_sys : day_sys;
      month = month_sys < 10 ? "0" + month_sys : month_sys;
      hour = hour_sys < 10 ? "0" + hour_sys : hour_sys;
      minutes = minutes_sys < 10 ? "0" + minutes_sys : minutes_sys;
    } else {
      res_d_t = regexp_device_time.exec(connect_model.get('device_time'));
      n = res_d_t[0], year = res_d_t[1], month = res_d_t[2], day = res_d_t[3], hour = res_d_t[4], minutes = res_d_t[5];
    }
    modal = $(tpl_c({
      date: year + "-" + month + "-" + day,
      time: hour + ":" + minutes
    })).modal("show");
    return $(modal).on("hidden.bs.modal", function() {
      return $(modal).remove();
    }).on("click", "#save_new_date", function() {
      var d, issue, issue_parent, res_date, res_time;
      if (!regexp_date.test($('#input_date').val())) {
        return false;
      }
      if (!regexp_time.test($('#input_time').val())) {
        return false;
      }
      res_date = regexp_date.exec($('#input_date').val());
      res_time = regexp_time.exec($("#input_time").val());
      n = res_date[0], year = res_date[1], month = res_date[2], day = res_date[3];
      n = res_time[0], hour = res_time[1], minutes = res_time[2];
      d = new Date();
      issue_parent = issues.findWhere({
        ident: "set_time"
      });
      if (issue_parent) {
        issue = new ISSUE(issue_parent.toJSON());
        issue.set({
          "status": WAITING,
          "ta": str_to_hex(Number(d.getYear(d.setYear(year)))) + ':' + str_to_hex(Number(month)) + ':' + str_to_hex(Number(day)) + ':' + str_to_hex(Number(hour)) + ':' + str_to_hex(Number(minutes)) + ':' + str_to_hex(Number(d.getSeconds()))
        });
        self.model.get('issues').add(issue);
      }
      issue_parent = issues.findWhere({
        ident: "get_time"
      });
      if (issue_parent) {
        issue = new ISSUE(issue_parent.toJSON());
        issue.set({
          "status": WAITING
        });
        self.model.get('issues').add(issue);
      }
      self.model.start_clear_pull();
      return $(modal).modal("hide");
    });
  }
});

CONNECT_VIEW = Backbone.View.extend({
  el: "#app",
  template: "#counter",
  model: counter,
  initialize: function() {
    this.render();
    this.listenTo(this.model, '_change', this.btn_class);
    this.listenTo(this.model, 'change', this.render);
    this.listenTo(this.model, 'change:is_edit', this.render);
    this.listenTo(this.model.get('issues'), 'change', this.render);
    this.listenTo(this.model.get('chanels'), 'change', this.render);
    this.listenTo(this.model.get('log'), 'add', this.render);
    return this;
  },
  render: function() {
    var tpl_c;
    tpl_c = _.template($(this.template).html());
    $(this.$el).empty().append(tpl_c({
      model: this.model
    }));
    return this.validation_form();
  },
  set_ip: function(e) {
    this.model.set({
      ip: $(e.target).val()
    }, {
      silent: true
    });
    return this.model.trigger("_change");
  },
  set_mac: function(e) {
    this.model.set({
      mac: $(e.target).val()
    }, {
      silent: true
    });
    return this.model.trigger("_change");
  },
  set_port: function(e) {
    this.model.set({
      port: $(e.target).val()
    }, {
      silent: true
    });
    return this.model.trigger("_change");
  },
  set_pass: function(e) {
    this.model.set({
      pass: $(e.target).val()
    }, {
      silent: true
    });
    return this.model.trigger("_change");
  },
  validation_form: function() {
    var method, method_rev, valid;
    valid = true;
    if (!validator_hex_fields($('#mac').val(), 8, 8)) {
      $("#mac").closest('.form-group').addClass('has-error');
      valid = false;
    } else {
      $("#mac").closest('.form-group').removeClass('has-error');
    }
    if (!validator_hex_fields($('#pass').val(), 10, 10)) {
      $("#pass").closest('.form-group').addClass('has-error');
      valid = false;
    } else {
      $("#pass").closest('.form-group').removeClass('has-error');
    }
    if ($('#ip').val() === "") {
      valid = false;
    }
    if ($('#port').val() === "") {
      valid = false;
    }
    if (valid) {
      method = 'addClass';
      method_rev = 'removeClass';
    } else {
      method = 'removeClass';
      method_rev = 'addClass';
    }
    $('#send')[method]('btn-success')[method_rev]('btn-disabled');
    return valid;
  },
  hide_main_error: function(callback) {
    if (callback == null) {
      callback = function() {};
    }
    return $.when($('.alert-danger').slideUp(200)).then(function() {
      counter.get('log').where({
        type: "main"
      }).map(function(log) {
        return this.remove(log);
      }, counter.get('log'));
      return callback();
    });
  },
  events: {
    "keyup #ip": function(e) {
      this.set_ip(e);
      return this.validation_form();
    },
    "keyup #mac": function(e) {
      this.set_mac(e);
      $(e.target).paste_simbol_hex(e);
      return this.validation_form();
    },
    "keyup #port": function(e) {
      this.set_port(e);
      return this.validation_form();
    },
    "keyup #pass": function(e) {
      this.set_pass(e);
      $(e.target).paste_simbol_hex(e);
      return this.validation_form();
    },
    "click #set_pass": function() {
      this.model.clear_issues();
      return this.hide_main_error(function() {
        return new MODAL_PASS();
      });
    },
    "click #set_time": function() {
      this.model.clear_issues();
      return this.hide_main_error(function() {
        return new MODAL_DATE();
      });
    },
    "click #advanced_mode": function() {
      return this.model.set({
        "advanced_mode": !this.model.get("advanced_mode")
      });
    },
    "click #reset_value": function() {
      var self;
      this.model.clear_issues();
      self = this;
      this.hide_main_error(function() {
        var issue, issue_parent;
        issue_parent = issues.findWhere({
          ident: "get_values"
        });
        if (issue_parent) {
          issue = new ISSUE(issue_parent.toJSON());
          issue.set({
            status: WAITING
          });
          self.model.get('issues').add(issue);
          return self.model.start_clear_pull();
        }
      });
      return $.when(this.hide_main_error()).then(function() {
        return counter.get('log').where({
          type: "main"
        }).map(function(log) {
          return this.remove(log);
        }, counter.get('log'));
      });
    },
    'click #view_log': function() {
      return this.model.set("is_view_log", !this.model.get("is_view_log"));
    },
    "click .edit_chan": function(e) {
      var chanel, cid;
      cid = $(e.target).closest('th').attr('data-chanel');
      chanel = this.model.get('chanels').get(cid);
      return new MODAL_CHANEL(chanel);
    },
    "click #send": function(e) {
      var hash;
      if (!this.validation_form()) {
        return false;
      }
      this.model.get('chanels').reset();
      this.model.get('issues').reset();
      this.model.get('log').reset();
      this.model.get('chanels').add([{}, {}, {}, {}, {}, {}, {}, {}]);
      this.model.set({
        serial: this.model.defaults.serial,
        version: this.model.defaults.version,
        time_server: this.model.defaults.time_server,
        time_device: this.model.defaults.time_device,
        advanced_mode: this.model.defaults.advanced_mode,
        is_view_log: this.model.defaults.is_view_log
      });
      this.model.set('is_edit', false);
      ["get_version", "get_time", "get_ident", "get_slice", "get_values"].map(function(ident) {
        var issue, issue_parent;
        issue_parent = issues.findWhere({
          ident: ident
        });
        if (issue_parent) {
          issue = new ISSUE(issue_parent.toJSON());
          issue.set({
            status: WAITING
          });
          return this.add(issue);
        }
      }, this.model.get("issues"));
      this.model.get('chanels').toArray().map(function(chanel) {
        var issue, issue_parent, num_chan;
        issue_parent = issues.findWhere({
          ident: 'get_values_chanel'
        });
        issue = new ISSUE(issue_parent.toJSON());
        if (issue) {
          num_chan = this.get('chanels').indexOf(chanel) + 1;
          issue.set({
            status: WAITING,
            chanel: num_chan,
            ta: intFixLength(num_chan, 2)
          });
          return this.get('issues').add(issue);
        }
      }, this.model);
      hash = ["do", this.model.get("ip"), this.model.get("port"), this.model.get("mac"), this.model.get("pass")];
      location.hash = hash.join("/");
      return this.model.start_clear_pull();
    },
    "click #edit": function(e) {
      return this.model.set('is_edit', true);
    }
  }
});

$(document).ready(function() {
  return new CONNECT_VIEW();
});
