TEXT_VIEW = Backbone.View.extend

  el : "div"

  ###
   # Инифиализация текстовой ячейки
   # @param  {Backbone.Model} model Модель с которой работаем
   # @param  {Object} el    Объект DOM с которым будем работать
   # @param  {String} prop  Свойство которое будем отслеживать
   # @return {undefined}       undefined
  ###
  initialize : ( model , el , prop )->
  
    @.model = model
    @.prop = prop
    @.el = el
    @.listenTo    @.model , 'change' , @.render
    @.render()

  
  render : ()->
    if !$(@.el).length
      console.error "Нет шаблона " + @.el
      false
    $(@.el).text( @.model.get(@.prop) )
