define([
  "backbone",
  "archives"
],function(
  Backbone,
  archives
){
  
  
  return Backbone.View.extend({
    
    
    tagName : 'div',
    
    initialize :function( id ){
      
      var id = id || 0
      
      var data = { data : [ id ] }
      
      var self = this
      
      $.get(
        '/tpl/?tpl=archive_delete_modal',
        data,
        function( tpl ){
          
          var tpl = $(tpl)
          
          $(tpl).find('[type="submit"]').remove()
          
          $( tpl ).modal('show').on('click' , '#drop_archive' , function(){
            var archive = new archives.model({
              id : id
            })
            archive.destroy({
              dataType : "text",
              success : function( model , res ){
                if( res == "droped" ){
                  $(tpl).modal('hide')
                  archives.trigger( 'drop_model' , model)
                }
              }
            })
          }).on('hidden.bs.modal' , function(){
            $(tpl).remove()
          })
          
        }
      )
    }
    
  })
  
})