define([
  'backbone',
  "cconverters"
],function(
  Backbone,
  cconverters
){
  
  return Backbone.View.extend({
    
    
    el : '#block_converter_item_info',
    
    
    initialize : function( model ){
      this.model = model
      this.listenTo( cconverters , 'change_model' , function(){
        
        var data = { data : [ this.model.get('id') ] }
        
        $.get(
          '/tpl/?tpl=cconverter_info',
          data,
          function( data ){
            $('#' + $(data).attr('id')).replaceWith( $(data) )
          }
        )
        
        
      })
    },

  })
  
  
})