define([
  "backbone",
  "cconverters",
  "validator"
],function(
  Backbone,
  cconverters
){

  return Backbone.View.extend({
  
  
    initialize : function( target ){
      
      this.$el = $(target)
      
      var data = { data : [ 0 ] }
      
      $.get(
        '/tpl/?tpl=cconverter_modal_add',
        data,
        function( data ){
          var data = $(data)
          
          $( target ).closest('td').removeClass( DIS_DIV )
          
          $(data).find('[type="submit"]').remove()
          
          $(data).modal('show').on('click','#add_cconverter',function(){
            if( $(data).isValid() ){
              var cconverter = new cconverters.model({
                about : $(data).find('[name="About"]').val()
              })
              
              cconverter.save().then(function(){
                cconverters.trigger('add_model' , cconverter)
                $(data).modal('hide')
              })
            }
          }).on('hidden.bs.modal' , function(){
            $(data).remove()
          })
          
          $.validate()
          
        }
      )
       
    },
  
  
    el : 'div',
  
  
  });

});