define([
  "backbone",
  "cconverters"
],function(
  Backbone,
  cconverters
){

  return Backbone.View.extend({
  
  
    initialize : function( target ){
      var id = $(target).closest( 'tr' ).attr('id').replace('cconverter_item_','')
      
      var data = { data : [ id ] }
      
      $.get(
        "/tpl/?tpl=cconverter_modal_delete",
        data,
        function( data ){
          
          $(target).closest('td').removeClass( DIS_DIV )
          
          var data = $(data)
          
          $(data).modal('show').on('click' ,'#drop_cconverter' , function(){
            
            var model = new cconverters.model({
              id : id
            })
            
            model.destroy({
              dataType : "text",
              success : function( model , res ){
                if( res == "droped" ){
                  cconverters.trigger('drop_model' , model)
                  $(data).modal('hide')
                }
              }
            })
          }).on('hidden.bs.modal' , function(){
            $(data).remove()
          })
        }
      )
    },
  
  
    el : 'div',
  
  
  
  });

});