define([
  "backbone",
  "cconverters",
  "validator"
],function(
  Backbone,
  cconverters
){

  return Backbone.View.extend({
  
  
    initialize : function( target , callback ){
      
      var callback = callback
      
      var id = $(target).closest( 'tr' ).attr('id').replace('cconverter_item_','')
      
      var data = { data : [ id ] }
      
      cconverters.fetch({
        data: { filter : "id:" + id },
        success : function( _data ){
          var model = _data.first()
          
          $.get(
            '/tpl/?tpl=cconverter_modal_edit',
            data,
            function( data ){
              
              var data = $(data)
              
              $(data).find('[type="submit"]').remove()
              
              if( callback ) callback()
              
              $(data).modal('show').on('click' , '#edit_cconverter' , function(){
                
                if( $(data).isValid() ){
                  var cconverter = new cconverters.model({
                    id : Number(id),
                    about : $('[name="About"]').val()
                  })
                  cconverter.save().then(function(){
                    cconverters.trigger('change_model' , cconverter)
                    $(data).modal('hide')
                  })
                }
              }).on('hidden.bs.modal' , function(){
                $(data).remove()
              })
              
              
              $.validate()
              
            }
          )
          
        }
      })
      
      
    },
  
  
    tagName : '',
  
    el : 'div',
  
  
  });

});