define([
  "backbone",
  "cmeter_formula_modal"
],function(
  Backbone,
  cmeter_formula_modal
){


  /*
    Вид который отвечает за один блок из формулы
  */
  return Backbone.View.extend({
  
  
    initialize : function( el ){
      this.$el = $(el)
    },
  
    events : {
      
      
      'click .edit_block_formula' : function( e ){
        
        
        
        let data = { data : [ 0 ] }
        
        
        $(e.target).closest('.row').addClass( DIS_DIV )
        
        //~ this.$el = $(e.target).closest('.row')
        
        var self = this
        
        
        var data_model = Backbone.Model.extend({
          defaults : {
            object : "",
            id : 0,
            pid : 0
          },
          initialize : function( data_var ){
            var self = this
            data_var.split(":").reduce(function(res,item , i){
              if( item == "undefined" ) return res;
              switch(i){
                case 0 : 
                  self.set('object' , item )
                break;
                case 1 : 
                  self.set('id' , item )
                break;
                case 2 : 
                  self.set('pid' , item )
                break;
              }
              return res;
            },{})
          },
          to_string : function(){
            var res = []
            res.push( this.get('object') )
            res.push( this.get('id') )
            res.push( this.get('pid') )
            return res.join(":")
          }
        });
        
        this.model = new data_model( $(this.$el).attr('data-var') )
        
        
        this.model.on('change' , function(){
          let data = {
            data : [0],
            res :  this.to_string()
          }
          
          $.get(
            '/tpl/?tpl=cmeter_formula_block',
            data,
            function( data ){
              var  data = "<span>" +data + "</span>"
              $(self.$el).find('.object_container').empty().append( $(data) )
          })

          $(self.$el).attr( 'data-var' , this.to_string() )
          
          
          $(document).trigger('formula_changed' , $(self.$el))
          
        })
        
        if( $('#content_formula').length ){
          var s = $('#content_formula').closest('.modal')
          new cmeter_formula_modal( s , self.model ) 
          $(e.target).closest('.row').removeClass( DIS_DIV )
          return false;
        }
        $.get(
          '/tpl/?tpl=cmeter_formula_block_edit&res=',
          data,
          function(data){
            
            var data = $(data)
            
            new cmeter_formula_modal( data , self.model ) 
            
            $(e.target).closest('.row').removeClass( DIS_DIV )
            
          }
        )
        
        return false;
      },
      
      
      
      
      
      'click .delete_block_formula' : function(){
        this.remove()
        return false;
      },
      
      
      
      'change .edit_znak' : function(e){
        $(this.$el).attr('data-znak' , $(e.target).val())
        return false;
      },
      
      
      
      
    },
  
  });

});