define([
  "backbone"
],function(
  Backbone
){
  
  return Backbone.View.extend({
    
    
    el : '.breadcrumb',
    
    /*
      Назначение модели на вид
      @param model converter
    */
    setmodel : function( model ){
      this.model = model
      $(this.$el).removeClass( DIS_DIV )
      
      this.listenTo( this.model , 'change:title' , function(){
        $(this.$el).find('.active').text(
          this.model.get('title')
        )
      })
      
    },
    
    
    initialize : function( id ){
      $(this.$el).addClass( DIS_DIV )
    },
    
    
  })
  
})