define([
  "backbone",
  "conversions"
],function(
  Backbone,
  conversions
){
  
  return Backbone.View.extend({
  
  
    initialize : function( model , callback ){
      this.model = model
      this.render( callback )
    },
  
  
  
    render : function( callback ){
      
      let self = this
      
      var data = { data : [ self.model.get('id') ] }
      
      $.get(
        '/tpl/?tpl=conversion_delete',
        data,
        function( data ){
          
          if( callback ) callback()
          
          var data = $(data)
          
          $(data).modal('show').on('click' , '#delete_conversion' , function(){
            self.model.destroy({dataType : 'text' , success : function(model , res){
              if( res == 'droped' ){
                conversions.trigger('remove' , model)
                $(data).modal('hide')
              }
            }})
          }).on('hidden.bs.modal' , function(){
          $(data).remove()
        })
          
        }
      )
    },
  
    el : 'div',
  
  
  
  });
  
});