define([
  "backbone",
  "converter"
],function(
  Backbone,
  converter
){
  
  
  
  return Backbone.View.extend({
  
    tagName  : 'div',
    
    initialize : function( _converter , callback ){
      this.model = _converter
      
      let self = this
      
      let data = {data : [ this.model.get('id') ] }
      
      $.get(
      '/tpl/?tpl=converter_delete_form' , 
      data , 
      function(data){
        
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).appendTo('body')
        
        $('#myModal').modal('show').on('hidden.bs.modal', function () {
          $('#myModal').remove()
        })
        
        if( callback ) callback()
        
        $('#save_vconverter').click(function(){
          self.model.destroy({
            dataType : "text" , 
            success : function(){
              $('#myModal').modal('hide')
            }
          })
        })
        
      })
      
    }

    
  })
})