define([
  "backbone",
  "groups"
],function(
  Backbone,
  groups
){

  return Backbone.View.extend({
  
  
    initialize : function( model , callback ){
      this.model = model
      let data = {data : [ this.model.get('id') ] } 
      
      let self = this
      
      $.get(
        '/tpl/?tpl=group_edit_form' , 
        data, 
        function(data){
          
          
          var data = $(data)
          
          $(data).find('[type="submit"]').remove()
          
          $(data).modal('show').on('click' , '#save_user' , function(){
            if( $(data).isValid() ){
                
                self.model.set({
                  fio : $('[name="Fio"]').val(),
                  active : $('[name="Active"]').prop('checked'),
                })
                
                self.model.save().then(function(){
                  
                  let method = self.model.get('id') ? 'add_model' : 'change_model'
                  
                  groups.trigger( method , self.model)
                  $(data).modal('hide')
                })
                
                
              }
          }).on('hidden.bs.modal', function() {
              $(data).remove()
          })
          
          if( callback )  callback(this)
          
        
        $.validate()
        
      })
    },
  
  
    tagName : 'div',
  
  });

});