define([
  "backbone",
  "mails"
],function(
  Backbone,
  mails
){

  return Backbone.View.extend({
  
  
    initialize : function( id , callback ){
  
      var data = { data : [ id ] }
      
      var id = id
    
      $.get(
        '/tpl/?tpl=mail_delete_modal',
        data,
        function( data ){
          
          var data = $(data)
          
          $(data).modal('show').on('click' , '#delete_mail' , function(){
            var model = new mails.model({ id : id })
            
            model.destroy({
              dataType : "text",
              success : function( m , res ){
                if( res == "droped" ){
                  $(data).modal('hide')
                  mails.trigger('drop_model' , model)
                }
              }
            })
            
          }).on('hidden.bs.modal', function () {
            $(data).remove()
          })
          
          if( callback ) callback()
        }
      )
  
    },
  
  
  
    events : {
  
    },
  
    el : 'div',
  
  
  
  });

});