define([
    "backbone"
], function(
    Backbone
) {


    return Backbone.View.extend({


        initialize: function() {

        },

        events: {
            'click #force_data': function(e) {
                $(e.target).closest('.btn').addClass(DIS_DIV);


                $('#force_data_success_tpl').remove()
                $('#force_data_value_tpl').remove()
                $('#force_data_error_send_tpl').remove()
                $('#force_data_get_result_tpl').remove()
                $('#not_lib_tpl').remove()
                $('#please_wait_tpl').remove()
                $('#force_data_success_tpl').remove()
                $('#force_data_value_tpl').remove()
                $('#force_data_error_send_tpl').remove()
                $('#force_data_values_not_success_tpl').remove()

                $.get(
                    '/tpl/?tpl=meter_force_data', { data: [this.model.get('id')], cache: false },
                    function(data) {

                        data = $(data)

                        $('body').append($(data).find('script'))

                        var a = null

                        $(data).modal('show').on('shown.bs.modal', function() {
                            var tpl = _.template($('#force_data_success_tpl').html())
                            $('#force_data_modal').find('.modal-body').empty().append(tpl())

                            var last_len = 0

                            a = $.ajax(window.location.pathname.replace(
                                /\/meter\/([0-9]*)\/(.*)/g,
                                function(_, id) {
                                    return "/meter/" + id + "/"
                                }
                            ) + 'force_data.js', {
                                xhrFields: {
                                    onprogress: function(e) {

                                        if( !$(data).hasClass('in') ){
                                            a.abort()
                                            $('#force_data').removeClass(DIS_DIV);
                                            return
                                        }

                                        var thisres, res = e.currentTarget.response;

                                        // Выполнение только последнего пришедшего куска кода
                                        eval(res.substr(last_len));
                                        last_len = res.length
                                    }
                                },
                                success: function(data) {
                                  $('#force_data').removeClass(DIS_DIV);
                                }
                            })
                        }).on('hidden.bs.modal', function() {
                            $(data).remove();
                            window.force_data.stop();
                        })

                    })
                return false;
            },



            'click #meter_on_off': function(e) {


                var self = this


                $('#meter_on_off').addClass(DIS_DIV)


                var url = window.location.pathname.replace(
                    /\/meter\/([0-9]*)\/(.*)/g,
                    function(_, id) {
                        return "/meter/" + id + "/"
                    }
                ) + "action/"

                var d = {
                    onoff: Number(!$(e.target).hasClass('btn-danger'))
                }

                var e = e

                $.get(url, d,
                    function(data) {

                        var is_danger = true

                        $('#meter_on_off').removeClass(DIS_DIV)

                        var span = $('<span/>');

                        if (typeof data['Execute error'] != 'undefined') {
                            $(span).text('Ошибка выполнения')
                            $(e.target).effect('bounce', 500)
                        } else if (typeof data['TIMEOUT'] != 'undefined') {
                            $(span).text('Слишком долгий ответ. Операция прервана.')
                            $(e.target).effect('bounce', 500)
                        } else if (typeof data['ERROR'] != 'undefined') {

                            var text = '';
                            if (data['ERROR'] == 'empty_output') {
                                text = "Пустой ответ. Завершено с ошибкой."
                            }

                            $(span).text(text)
                            $(e.target).effect('bounce', 500)
                        } else if (typeof data['ACTION'] != 'undefined') {
                            if (!data['ACTION']) {
                                $(span).text('Причина отклонения запроса не ясна.')
                                $(e.target).effect('bounce', 500)
                            } else {

                                $(span).text('Удачно')
                                $(e.target).effect('bounce', 500)

                                is_danger = false

                                var e_darta = { data: [self.model.get('id')] }

                                $.get(
                                    "/tpl/?tpl=meter_action",
                                    e_darta,
                                    function(data) {
                                        $.when($(self.$el).find('.panel-body')
                                            .replaceWith($(data).find('.panel-body'))).then(function() {
                                            $(span).attr('class', 'pull-right small').addClass(is_danger ? 'text-danger' : 'text-success')
                                            $('#meter_on_off').after($(span))
                                        })
                                    }
                                )
                            }
                        }
                    }, "JSON")

                return false;
            }
        },

        el: '#action_meter',



        setmodel: function(model) {
            this.model = model
            $('#force_data').removeClass(DIS_DIV).removeClass('btn-disabled').addClass('btn-info')
        }


    });

});