define([
  "backbone",
  "meters",
  "meter_modal_edit",
  "force_data",
  "underscore"
],function(
  Backbone,
  meters,
  meter_modal_edit,
  _
){

  
  return Backbone.View.extend({
    
    
    el : '#container_meter_info',
    
    /*
      Назначение модели на вид
      @param model converter
    */
    setmodel : function( model ){
      
      this.model = model

      let self = this
      
      this.listenTo( this.model , 'change' , function(){
        $.get(
          '/tpl/?tpl=meter_info' , 
          {data : [ this.model.get('id') ] } , function(data){
          $(self.$el).find('tbody').replaceWith( $(data).find('tbody') )
        })
      })
      
    },
    
    
    initialize : function(){},
    
    
    
    events : {

      'click .block_meter_edit' : function( e ){
        
        $( e.target ).closest('th').addClass( DIS_DIV )
        
        new meter_modal_edit( this.model , function(){
          $( e.target ).closest('th').removeClass( DIS_DIV )
        })
        return false;
      }
      
    }
    
    
  })
})