define([
  "backbone",
  "places"
],function(
  Backbone,
  places
){
  
  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
      
      var self = this
      
      this.listenTo( places , 'change_model' , function(change_model){
        
        if( change_model.get('id') != self.model.get('id') ) return false
        
        self.render(change_model)
        
      })
      
    },
  
  
    render : function(change_model){
      
      let data = { data : [change_model.get('id')] }
      
      $.get( '/tpl/?tpl=place_one_info' , 
        data , 
        function(data){
          
          $('#place_item_info').find('tbody').replaceWith(
            $(data).find('tbody')
          )
          
        }
      )
    },
  
    el : '#place_item_info',
  
  
  
  });

});