define([
  "backbone",
  "places"
],function(
  Backbone,
  places
){
  
  return Backbone.View.extend({
    el : '.page-header',

    initialize : function( model ){
      
      var self = this
      
      this.model = model
      
      this.listenTo( places , 'change_model' , function(change_model){
        
        if( change_model.get('id') != self.model.get('id') ) return false
        
        $(self.$el).find('.container_h1_place').text(
          change_model.get('title')
        )
        
      })
      
    },
    
  })
  
})