define([
  "backbone",
  "places",
  "tmpl"
],function(
  Backbone,
  places
){
  return Backbone.View.extend({
    initialize : function( id , target ){
      if( target ){
        $( target ).addClass('disable_div_mini')
      }
      
      
      var self = this
      
      places.fetch({
        data : {
          filter : "id:"+id
        },
        success : function(a){
          
          self.model = a.last()
          
          $( target ).removeClass('disable_div_mini')
          
          $('<div/>').dialogYesNo({
            title : 'Удалить ' + self.model.get('title') +'?',
            isOk : function(t){
              self.model.destroy({ dataType: "text", success: function(model, response) {
                if( response == 'droped' ){
                  $(target).parent().remove()
                  
                  
                  places.fetch({
                    data : {
                      filter : "id:" + model.get('place')
                    },
                    success : function(a){
                      if( !a.last().get('places_count') ){
                        $('[data-place_id="' + model.get('place') +'"]').prepend(
                          $('#link_drop_tpl').tmpl()
                        ).find('.delete_place').removeAttr('href')
                      }
                    }
                  })
                }
              }})
              
              $(t).dialog('destroy')
            }
          })
        }
      })
    }
  })
})