define([
  "backbone",
  "places",
  "tmpl",
  "validator"
],function(
  Backbone,
  places
){
  return Backbone.View.extend({
    //~ tagName : 'div',
    //~ template : '#short_add_place_tpl',

    
    /*
      @param int Идентификатор того плейса на котором мы сейчас находимся
      @param int Идентификатор плейса куда мы хотим добавлять
      @param Backbone.Model
    */
    initialize : function( model ){
      
      this.model = model
      this.render()
    },
    
    /*
      @param int Идентификатор того плейса на котором мы сейчас находимся
      @param int Идентификатор плейса куда мы хотим добавлять
    */
    render : function(){
      
      let data = { data : [ this.model.get('id') ] }
      
      var self = this

      $.get(
      '/tpl/?tpl=place_edit_form' , 
      data , 
      function(tpl){
        
        var tpl = $(tpl)
        
        $(tpl).find('[type="submit"]').remove()
        
        $(tpl).modal('show').on('click' , '#edit_place',function(  ){
          
          if( $(tpl).isValid() ){
            self.model.set({
              title : $('[name="Title"]').val(),
              bankbook : $('[name="BankBook"]').val()
            })
            
            self.model.save().then(function(){
              $(tpl).modal('hide')
              places.trigger('change_model',self.model)
            })
          }
        })
        
        $.validate()
        
      })
      
      
    }
  })
})