define([
  "backbone",
  "rules"
],function(
  Backbone,
  rules
){

  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
      
      var self = this
      
      let data = { data : [ this.model.get('id') ] }
      
      $.get(
        '/tpl/?tpl=rule_modal_delete',
        data,
        function( data ){
          
          var data = $(data)
          
          $(data).modal('show').on('click' , '#delete_rule' , function(){

            self.model.destroy({ dataType : "text" , success : function( model , res){
              if( res == 'droped' ){
                rules.trigger('drop_model' , model)
              }
            }})
            $(data).modal('hide')
            

          }).on('hidden.bs.modal' , function(){
            $(data).remove()
          })
          
        }
      )
      
    },
  
  
  });

});