define([
  "backbone",
  "vmeters",
  "vmeter_modal_edit"
],function(
  Backbone,
  vmeters,
  vmeter_modal_edit
){
  return Backbone.View.extend({
    
    
    el : '#container_meter_info',
    
    /*
      Назначение модели на вид
      @param model converter
    */
    setmodel : function( model ){

      if( typeof model == "undefined" ){
        return false;
      }
      
      this.model = model
      let self = this
      
      this.listenTo( this.model , 'sync' , function(){
        $.get(
          '/tpl/?tpl=vmeter_info' , 
          {data : [ this.model.get('id') ] } , function(data){
          $(self.$el).find('tbody').replaceWith( $(data).find( 'tbody' ) )
        })
      })
      
    },
    
    
    events : {

      'click .block_meter_edit' : function( e ){
        
        var self = this;

        new vmeter_modal_edit( this.model.get('id') ,function( data ){
          self.model.set( data ).save();
        })
        return false;
      }

    }
    
    
  })
})