CONVERTER_COUNTERS = Backbone.View.extend
  
  el : "#converter_counters"
  
  template : "#counters_tpl"
  
  initialize : ( collection )->
    @.collection = collection
    @.render()
    @.listenTo @.collection , 'change' , @.render
    
  render : ()->
    tpl_c = _.template $(@.template).html()

    $(@.$el).empty().append( tpl_c(
      by_count : @.collection.__get_count(),
      counters : @.collection._counters()
    ))
    
    
  events : 
    "click a" : (e)->
      @.collection.__set_count $(e.target).attr('data-count')
      @.collection.trigger('change')
      false