CONVERTER_PAGES = Backbone.View.extend
  
  el : "#pagination"
  
  collection : converters
  
  initialize : ( collection )->
    @.collection = collection
    @.listenTo @.collection , 'reconstruct' , @.render
    @.listenTo @.collection , 'lock' , @.lock
    @.render()
  
  
  render : ()->

    self = @

    @.lock()

    data =  {
      page : self.collection.__get_page()
      data : [0]
      tpl : 'converter_list_pages'
      count : self.collection.__get_count_ajax()
    }

    $.get('/tpl/' , data ,(tpl)->
      $(self.el).empty().append(tpl)
    )

  lock :()->
    # после нажатия должна быть перерисовка. Поэтому заворачиваем с блок ожидания

    $(@.el).prepend(
      $('#converter_list_sample_tpl').html()
    )

    
    
  events : 
  
    "click a" : (e)->

      return false if $(e.target).closest('li').hasClass('active')

      text = $(e.target).closest('a').text().trim()
      if text != "Все"
        return false if isNaN $(e.target).closest('a').text().trim()
      else
        text = Number.POSITIVE_INFINITY

      @.collection.trigger('lock')

      if $(e.target).closest('ul').hasClass('paginator_pages')
        # Выставляем номер страницы
        @.collection.__set_page Number( text )
      else
        # Выставляем номер страницы
        @.collection.__set_count Number( text )

      c = @.collection.clone().reset()

      self = @

      c.fetch
        success : ()->
          self.collection.reset().add( c.toArray() )
          self.collection.trigger('reconstruct')
          c = null
        async : true
        data :
          page : $.cookie('convertrer_page')
          sort : @.collection.sort_ad
          field : @.collection.sort_field
          count : @.collection.__get_count_ajax()
      false