/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


/* global Backbone */

var USER = Backbone.Model.extend({
  
  defaults : {
    id    : 0,
    login : "",
    title : "",
    
    /**
     * Группы в которых находяится пользователь
     */
    group : [],
    rule : []
  },
  
  
  url : function(){
    return "/api/user/" + this.get('id') + "/";
  },
  
  
  /**
   * Проверка есть ли пользователь в группе
   * 
   * @param {GROUP} group
   * @returns {Boolean}
   */
  is_isset_in_group : function( group ){
    return this.get('group').indexOf( Number( group.get('id') ) ) !== -1;
  },
  
  
  
  /**
   * Проверка есть ли пользователь в группе
   * 
   * @param {RULE} group
   * @returns {Boolean}
   */
  is_isset_in_rule : function( group ){
    return this.get('rule').indexOf( Number( group.get('id') ) ) !== -1;
  }
  
});