/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


/* global GROUPUSER, GROUP_LIST_USER_NOT_GROUP, group, Backbone */

var GROUP_INDEX = Backbone.View.extend({
  
  model : group,
  
  el : "#group_container" , 
  
  
  initialize : function(){
    this.listenTo( this.model , 'change' , this.render);
    return this;
  },
  
  
  render : function(){
    
    var data = { data : [ this.model.get('id') ] };
    
    $.get('/tpl/?tpl=group_user_list' , data , function( res ){
      $('#list_users_table').replaceWith( $(res) );
    });
    return this;
  },
  
  
  
  events : {
    
    
    /**
     * Добавление пользователя в группу
     * 
     * @returns {Boolean}
     */
    "click #add_to_group" : function(){
      if( typeof GROUP_LIST_USER_NOT_GROUP !== 'undefined' ){
        new GROUP_LIST_USER_NOT_GROUP( this.model );
      }
      return false;
    },
    
    
    /**
     * Удаление пользователя из группы
     * 
     * @param {Event} e
     * @returns {Boolean}
     */
    "click .delete_link" : function( e ){
      
      var id = $( e.target ).closest('tr').attr('id').replace('groupuser_' , '');
      
      if( typeof GROUPUSER === 'undefined' ){
        return false;
      }
      
      if( typeof MODAL_DELETE_USER_GROUP !== 'undefined' ){
        new MODAL_DELETE_USER_GROUP( new GROUPUSER({ id : Number( id ) }) , this.model );
        return false;
      }
      
    }
    
    
    
  }
  
});


$(document).ready(function(){
  new GROUP_INDEX();
});