/* global Backbone, _ */



/**
 * Модальное окно с ошибкой
 * 
 * @type Backbone.View
 */
var MODAL_ERROR = Backbone.View.extend({
  
  
  /**
   * 
   * @param {String} msg
   * @returns {MODAL_ERROR}
   */
  initialize : function( msg ){
    this.render( msg );
    return this;
  },
  
  
  
  /**
   * @param {String} msg
   * 
   * @returns {MODAL_ERROR}
   */
  render : function( msg ){
    swal({
      title: msg,
      text: "",
      timer: 800,
      type: "error",
      showConfirmButton: false
    });
    
    return this;
  }
  
});