/* global _, Backbone */

/**
 * Модальное окно с сообщением о удачном выполнении действия
 * 
 * @type Backbone.View
 */

var MODAL_SUCCESS = Backbone.View.extend({
  
  
  template : '#modal_success_tpl',
  
  /**
   * @param {string} msg
   * @returns {Backbone.Model}
   */
  initialize : function( msg ){
    this.render( msg );
    return this;
  },
  
  render : function( msg ){
    
    swal({
      title: msg,
      text: "",
      timer: 800,
      type: "success",
      showConfirmButton: false
    });
    
  }
  
  
});