$(document).ready(function(){
  $("#view_to_tree").on("click" , function(){
    var self;
    self = this;
    $.get('/tpl/?tpl=place_modal_to_tree_empty', {
      data: [place.get('id')]
    }, function(data) {
      data = data;
      return $(data).modal("show").on("shown.bs.modal", function() {
        return $(this).find('.modal-body').empty().jstree({
          "core": {
            "check_callback": function() {
              return true;
            },
            "themes": {
              'name': 'proton',
              'responsive': true
            },
            "data": {
              "url": function(node) {
                var u;
                u = "/api/place/?jstree&all";
                if (node.id !== "#") {
                  return u + "&place=" + node.id;
                } else {
                  return u;
                }
              }
            },
            "checkbox": {
              "three_state": false
            },
            "plugins": ["json", "types"]
          }
        }).bind('load_node.jstree', function(e, core) {
          
          // Загрузили главное дерево
          // Идем получать все родительские у этого места
          // Затем открываем все
          if( place.get('id') ){
            $.get("/api/place/?id=" + place.get('id') + "&parents=true" , function( data ){
              _.each( data , function( _place ){
                core.instance.open_node(_place.id);
              })
            })
          }

          if( place.get('id') ){
            core.instance.deselect_all()
          }

          if( Number(core.node.id) == Number(place.get("id")) ){
            core.instance.deselect_all()
            core.instance.select_node(core.node.id)
          }

          _.each( core.node.children , function( id ){
            if( Number(id) == Number(place.get("id")) ){
              core.instance.deselect_all()
              core.instance.select_node(id)
            }

          })

        }).bind("select_node.jstree" , function(e, core,cc){
          if( typeof core.event != "undefined" ){
            $("#CAPNAG_back").appendTo(".modal-body").show().css("opacity" , "0.5")
            $("#CAPNAG_back").remove()
            $("#CAPNAG").appendTo(".modal-body").show()
            $("#CAPNAG").remove()
            window.location.pathname = "/place/" + core.node.id + "/"
          }
        })
      });
    });
    return false;
  })
})