/* global Backbone, _ */

var ADD_USER = Backbone.View.extend({
  
  el : "#list_user_in_rule",
  
  collection : new USERS(),
  
  
  template : "#modal_user_list_tpl",
  
  
  initialize : function(){
    
    var self = this;
    
    this.collection.fetch({
      success : function(){
        self.render();
      }
    })
    
    return this;
  },
  
  
  render : function(){
    
    if( !$(this.template).length ){
      console.error("undefined template " + this.template);
      return false;
    } 
    
    var tpl_c = _.template( $(this.template).html() );
    
    var modal = $(tpl_c({
      users : this.collection.toArray()
    })).modal('show');
    
    return this;
  },
  
  
  events : {
    
    "click #append_user"  :function(){
      console.log(1111);
      return false;
    }
    
  }
  
});

$(document).ready(function(){
  new ADD_USER();
});