<?php

// ob_start();
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

ob_implicit_flush(true);
ob_end_flush();
$oMeter = meter::Id(isset($_GET['id']) ? (int)$_GET['id'] :0);

if( !$oMeter->Is ){
  echo "force_data.not_meter();";
  echo "force_data.end();";
  die();
}

$GLOBALS['parameters'] = array();
$parameters_ready = &$GLOBALS['parameters'];


function disable_excluded_converter( $meter = null , $state_excluded_converter = 0 ){

  if( !count($GLOBALS['parameters']) ){
    echo "top.force_data.error('NO DATA');";
  }

  $meter->Converter->UpdateByArray(array(
    'IsExcluded' => $state_excluded_converter
  ));
  echo "console.log('shutdown');";
  echo "top.force_data.end();";
}

register_shutdown_function('disable_excluded_converter' , $oMeter , $oMeter->Converter->IsExcluded );



// Исключаем конвертер из опроса и пытаемся к нему подключится
if( !$oMeter->Converter->IsExcluded ){
  $oMeter->Converter->UpdateByArray(array(
    'IsExcluded' => 1
  ));
}


//////////////////////////////////////////////
// Проверка свободного порта
//////////////////////////////////////////////


// Время когда стартовало ожидание
$start_wait_disabled_on_background = time();

// Смогли в итоге подключится или нет
$connected = false;

while( true ){
  if( $start_wait_disabled_on_background + 30 < time()  ){
      break;
  }
  $fp_test = @fsockopen("tcp://{$oMeter->Converter->Ip}:{$oMeter->Converter->Port}", -1, $errno, $errstr);
  if( false == $fp_test ){
    echo "console.log('wait connected');";
    sleep(1);
    continue;
  }

  $connected = true;

  echo "console.log('connected');";
  break;
}

// Не смогли подключится? Экстренный выход
if( !$connected ){
  exit();
}

fclose($fp_test);

// На всякий случай ждем, когда освободится приложение
sleep(1);




//////////////////////////////////////////////
// Чтение из приложения
//////////////////////////////////////////////

$fp = @fsockopen("tcp://127.0.0.1:8001", -1, $errno, $errstr);
if (!$fp) {
   echo "force_data.app_undefined();";
   die();
} else {

  $j = array(
    'host'    => $oMeter->Converter->Ip,
    'port'    => (int) $oMeter->Converter->Port,
    'cdev'    => $oMeter->Converter->Type->DllId,
    'clogin'  => $oMeter->Converter->Login,
    'cpass'   => $oMeter->Converter->Password,
    'mdev'    => $oMeter->Type->DllId,
    'serial'  => $oMeter->NumSerial,
    'mnum'    => (int) $oMeter->Num485,
    'mpass'   => $oMeter->Password,
    'command' => "force_data"
  );

  $v = json_encode($j);

  if( false == fwrite($fp, "{$v}") ){
    echo "force_data.app_refused(1);";
    echo "force_data.end();";
    fclose($fp);
    die();
  }

}


$buffer = "";
$start_connected = time();

while( !feof($fp) ){

    if( $start_connected + 30 < time()  ){
        break;
    }

    $out2 = fread($fp, 1);

    set_time_limit(1);

    $value = "";

    $byte = array_shift((unpack('C*', $out2)));

    if( $byte == 0x00 ){
      continue;
    }

    if( $byte == 0x0A ){
      $value = $buffer;
      $buffer = "";
    }else{
      $buffer .= $out2;
      continue;
    }

    if( preg_match('/^PARAMETER ([^\ ]*) VALUE ([^\ ]*)/', $value, $m) ){

      $Filter = array(
        'Filter' => array(
          'Ident' => $m[1]
        )
      );
      $p = parameter::Filter($Filter)->First;

      $Filter = array(
        'Filter' => array(
          'Logtext' => 'OK'
        )
      );
      $l = loginfo::Filter($Filter)->First;

      if( $p->Is ){
        $round = $p->Conversion->Round;

        $divider = $p->Conversion->Divider;
        if( !$divider ){
          $divider = 1;
        }

        $value = $m[2] / $divider;
        $value = number_format($value ,$round,"."," ");
        
      }else{
        $value=$m[2];
      }

      $title = $p->Title;


      if( !$p->Is ){
        $title = $m[1];
      }

      if( isset( $parameters_ready[$title] ) ){
        continue;
      }
      $parameters_ready[$title] = true;

      $msg = "force_data.values('{$title}','{$value}','OK','');";
    // CHANEL %04X TIME %s PARAMETER %s VALUE %d
    }elseif( preg_match('/^CHANEL ([0-9]{4}) TIME ([0-9|\-|\:|\ ]*) PARAMETER ([^\ ]*) VALUE ([^\ ]*)/', $value, $m) ){

      $Filter = array(
        'Filter' => array(
          'Ident' => $m[3]
        )
      );
      $p = parameter::Filter($Filter)->First;

      $Filter = array(
        'Filter' => array(
          'Logtext' => 'OK'
        )
      );
      $l = loginfo::Filter($Filter)->First;

      if( $p->Is ){
        $round = $p->Conversion->Round;

        $divider = $p->Conversion->Divider;
        if( !$divider ){
          $divider = 1;
        }

        $value = $m[4] / $divider;
        $value = number_format($value ,$round,"."," ");
        
      }else{
        $value=$m[4];
      }

      $title = $p->Title;

      if( !$p->Is ){
        $title = $m[2];
      }

      $parameters_ready[] = true;

      $msg = "force_data.values('chanel:{$m[1]} time:{$m[2]} {$title}','{$value}','OK','');";
    }elseif( preg_match('/^PARAMETER_ERROR (.*)/', $value, $m) ){

      $Filter = array(
        'Filter' => array(
          'Ident' => $m[1]
        )
      );
      $p = parameter::Filter($Filter)->First;

      $title = $p->Title;


      if( !$p->Is ){
        $title = $m[1];
      }

      if( isset( $parameters_ready[$title] ) ){
        continue;
      }
      $parameters_ready[$title] = true;

      $msg = "force_data.values('{$title}','','ERROR','');";
    }elseif( preg_match('/^TIME_RUN (.*)/', $value, $m) ){
      $msg = "force_data.timer({$m[1]});";
    }elseif( preg_match('/^ERROR (.*)/', $value, $m) ){
      $msg = "force_data.error('{$m[1]}');";
    }elseif( preg_match('/^PROGRESS (.*)/', $value, $m) ){
      $msg = "force_data.progress({$m[1]});";
   }else{

      switch ($value) {
        case 'START':
          $msg = "top.force_data.start();";
          break;
        case 'ADDED_TO_SCENARIO':
          $msg = "top.force_data.add_to_scenario();";
          break;
        case 'CONNECT':
          $msg = "top.force_data.connect();";
          break;
        case 'END':
          $msg = "top.force_data.end();";
          exit();
        default:
          $msg = "console.log('$value');";
          break;
      }

    }
    flush();
    echo $msg."\n";
}

fclose($fp);