<?php
  include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );


  $_GET['page'] = 1;
  $_GET['count'] = 999999999;
  ini_set('memory_limit', Site()->Config('memmory_reports' , 1024) . 'M');


  if( !defined( '__PHPUNIT_PHAR__' ) ) {
    @header( $oReport->Mime->Name );
    @header( 'Content-Disposition: attachment;filename="export.'.$oReport->Extension->Name.'"' );
  }



  $class = "meter";

  if( isset($_GET['vmeter']) ){
   $class = "vmeter"; 
  }elseif( isset($_GET['cmeter']) ){
   $class = "cmeter"; 
  }


  $oMeter = $class::Id( isset( $_GET['id'] ) ? (int) $_GET['id'] : 0 );
    


  require_once( $_SERVER['DOCUMENT_ROOT'].'/include/PHPExcel.php' );
  $cacheSettings = array( 'memoryCacheSize' => "1024M");


  PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp,$cacheSettings);

  $objPHPExcel = new PHPExcel();

  $Worksheet = $objPHPExcel->getActiveSheet();
  $WorksheetLine = 1;
  $ColumnNum = 0;

  $Size = array(
    ( 12 * 1.3),
    ( 10 * 1.3),
    ( 8  * 1.3),
    ( 18 * 1.3),
  );

  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, Site()->Config('ru.sys.date','Дата') );


  foreach($oMeter->ActiveParametersData->Elements as $iParam){
    $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iParam->Title );
    $Size[] = strlen($iParam->Title);
    $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, Site()->Config('ru.sys.date','Дата') );
    $Size[] = strlen( Site()->Config('ru.sys.date') );
  }
  $WorksheetLine++;


  $ColumnNum = 0;

  $constSTRING = PHPExcel_Cell_DataType::TYPE_STRING;
  
  require_once(smarty()->plugins_dir[0]."modifier.date_format.php");

  foreach( $oMeter->GetDateHoursList() as $iDate ){
    $ColumnNum = 0;
    
    if( $iDate->format('H') == "00" ){
      $f = smarty_modifier_date_format($iDate , $oMeter->FormatSmarty);
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $f );
      $ColumnNum = 0;
      $WorksheetLine++;
    }
    
    
    $f = smarty_modifier_date_format($iDate , "%custom_hour");
    
    $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $f );
    
    foreach( $oMeter->ActiveMeterparametersData->Elements as $iParameter ){
      $MDH = $oMeter->GetMDHHours($iParameter,$iDate);
      
      smarty()->assign('oMDH' , $MDH);
      smarty()->assign('usingCoef' , false);
      
      if( $iParameter->UseCoef ){
        smarty()->assign('usingCoef' , true);
        $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, trim( smarty()->fetch('meterdatahour/helpers/meter_report.tpl') ) );
      }else{
        $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, trim( smarty()->fetch('meterdatahour/helpers/meter_report.tpl') ) );
      }
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $MDH->AddTime );
      $MDH->__destruct();
    }
    $WorksheetLine++;
  }


  $objPHPExcel->getDefaultStyle()->getBorders()->getTop()   ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getBorders()->getBottom()->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getBorders()->getLeft()  ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getBorders()->getRight() ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getFont()->setName( 'Arial' );
  $objPHPExcel->getDefaultStyle()->getFont()->setSize( 8 ); 

  foreach (range('A', 'Z') as $char) {
      $objPHPExcel->getActiveSheet()->getColumnDimension($char)->setAutoSize(true);
  }

  foreach (range('A', 'Z') as $char) {
    foreach (range('A', 'Z') as $char2) {
        $objPHPExcel->getActiveSheet()->getColumnDimension($char.$char2)->setAutoSize(true);
    }
  }


  if( ( isset($_GET['Type']) && $_GET['Type'] == "CSV" )){
	  $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'CSV' );
    $objWriter->setDelimiter(";"); 
	}else{
	  @header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
	  @header( 'Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT' );
	  @header( "Cache-Control: no-store, no-cache, must-revalidate" );
	  @header( 'Pragma: public' );
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5' );
  }

  $objWriter->save('php://output');


