<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

if( !Self()->Is ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->GoToAuth();
  }else{
    echo "user not auth\n";
  }
}

if( empty($_GET['a']) ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "not atcion in get request param:[a]\n";
  }
}

if( empty($_GET['pid']) ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "empty parameter in request param:[pid]\n";
  }
}

if( empty($_GET['id']) ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "not found id place param:[id]\n";
  }
}

if( !isset($_GET['i']) ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "not isset sortable number param:[i]\n";
  }
}

if( !isset($_GET['s']) ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "not isset sufix param:[s]\n"; 
  }
}

$oPlace = place::Id( (int) $_GET['id'] );

if( !$oPlace->Is ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "place not found\n"; 
  }
}


$oParameter = parameter::Id( (int) $_GET['pid'] );

if( !$oParameter->Is ){
  if( !defined( '__PHPUNIT_PHAR__' ) ){
    Site()->Error404();
  }else{
    echo "parameter not found\n";
  }
}


// change_filter_ht



$Filter = array( 
  'Filter' => array( 
    'Sufix'       => $_GET['s'],
    'Object'      => 'place',
    'ObjectId'    => $oPlace->Id,
    'Interprise'  => Self()->Interprise->Id,
  )
);

$Res = filterparamname::Filter( $Filter );

$action = $_GET['a'];


//~ Если существует фильтр
if( $Res->Count ){
  
  if( isset( $_GET['n'] ) ){
    $Res->First->UpdateByArray(array(
      'Name' => $_GET['n']
    ));
  }
  
  $FilterParam = $Res->First;
  
  $Filter = array( 
    'Filter' => array( 
      'Filter'    => $FilterParam->Id,
      'Parameter' => $oParameter->Id
    )
  );
  $Res_FP_is = filterparamis::Filter( $Filter );
  
  //~ Если такого параметра нету
  if( !$Res_FP_is->Count && $action == 'e' ){
    filterparamis::AddByArray(array(
      'FilterId' => $Res->First->Id,
      'ParameterId' => $oParameter->Id,
      'Num' => $_GET['i']
    ));
    echo "param_add";
  
  //~ Параметр уже есть в фильтре
  }else{
    if( $_GET['a'] == 'd' ){
      $Res_FP_is->First->Delete();
      echo "param_delete";
    }else{
      $Res_FP_is->First->Num = $_GET['i'];
      echo "param_edit_num";
    }
  }


//~ Если фильтра не существует
}else{

  /*
  
    На указанный тип приборов сохраняем все переданные параметры.
    На остальные оставляем все как есть

  */
  $oFilter = filterparamname::AddByArray(array(
    'Name'          => isset($_GET['n']) ? $_GET['n'] : "",
    'Sufix'         => $_GET['s'],
    'Object'        => 'place',
    'ObjectId'      => $oPlace->Id,
    'InterpriseId'  => Self()->Interprise->Id,
  ));

  foreach( meter_extra_type::All()->Elements as $MT ){
    $SQL = Utils::Strip("SELECT parameter.* 
    FROM meterplace 
    LEFT JOIN place on place.id = meterplace.place_id
    LEFT JOIN meter on meter.id = meterplace.meter_id
    LEFT JOIN metertypeparameter ON metertypeparameter.metertype_id = meter.type_id
    LEFT JOIN parameter on parameter.id = metertypeparameter.parameter_id
    LEFT JOIN meter_type on meter_type.id = meter.type_id
    WHERE place.lft >= {$oPlace->Lft} 
    and rgt <= {$oPlace->Rgt}
    and parameter.id IS NOT NULL
    and metertypeparameter.is_use = 1
    and ( meter.meter_extra_type_id = {$MT->Id} OR meter_type.meter_extra_type_id = {$MT->Id} )
    GROUP BY parameter.id");

    $t = parameter::Id(0);



    foreach( TListGroup::Prepare( $SQL , $t )->Elements as $iParameter ){
      // Тут сохраняем только то что передали
      if( isset( $_REQUEST['change_filter_ht'] ) && $_REQUEST['change_filter_ht'] == $MT->Ident ){
        if( isset( $_REQUEST['pid'] ) && $_REQUEST['pid'] == $iParameter->Id ){
          filterparamis::AddByArray(array(
            'FilterId' => $oFilter->Id,
            'ParameterId' => $iParameter->Id,
            'Num' => $_GET['i']
          ));
          
        }
      // У остальных сохраняем все
      }else{
        filterparamis::AddByArray(array(
          'FilterId' => $oFilter->Id,
          'ParameterId' => $iParameter->Id,
          'Num' => $_GET['i']
        ));
      }
    }

  }




}
