<?php

include( $_SERVER['DOCUMENT_ROOT'] . "/include/inc.php");



require_once( $_SERVER['DOCUMENT_ROOT'].'/include/PHPExcel.php' );
require_once( $_SERVER['DOCUMENT_ROOT'].'/include/classes/smarty/Config_File.class.php' );
$cacheSettings = array( 'memoryCacheSize' => Site()->Config('memmory_reports')."M");
PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp,$cacheSettings);


$conf_loaded = array();

$path_to_conf_dir = $_SERVER['DOCUMENT_ROOT']. "/configs";

$config = new Config_File();

foreach (scandir( $path_to_conf_dir ) as $name_conf_file) {
  if( !preg_match('/([a-z]*)_lang.conf/' , $name_conf_file , $match )){
    continue;
  }
  $conf_loaded[ $match[1] ] = $config->parse_contents( file_get_contents( $path_to_conf_dir . "/" . $name_conf_file ));
}

// Уникальные индексы 
$uniq_index = array();


// Вынесем все конфиги локали на один уровень
$locale_indexes = array();

foreach( $conf_loaded as $locale => $lang_conf ){
  foreach ($lang_conf['sections'] as $section_name => $conf) {
    foreach( $conf['vars'] as $index => $var ){
      $uniq_index[ $index ] = array();
      $locale_indexes[$locale][$index] = $var;
    }
  }
  foreach( $conf['vars'] as $index => $var ){
    $uniq_index[ $index ] = array();
    $locale_indexes[$locale][$index] = $var;
  }
}


$output = array();

$head = array("INDEX");
foreach (array_keys( $locale_indexes ) as $locale ) {
  $head[] = strtoupper($locale);
}
$output[] = $head;

foreach( array_keys( $uniq_index ) as $index ){
  $row = array( $index );
  foreach ($locale_indexes as $locale => $confs) {
    $str = "";
    if( isset( $confs[$index] ) ){
      $str = $confs[$index];
    }
    $row[] = $str;
  }
  $output[] = $row;
}


$objPHPExcel = new PHPExcel();

$objPHPExcel->getActiveSheet()->fromArray( $output, null, 'A1');
foreach(range('A','Z') as $columnID) {
    $objPHPExcel->getActiveSheet()->getColumnDimension($columnID)
        ->setAutoSize(true);
}

@header( "Content-Type: application/vnd.ms-excel" );
@header( 'Content-Disposition: attachment;filename="'. "nagruzka_i18n.xls" .'"' );
@header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
@header( 'Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT' );
@header( "Cache-Control: no-store, no-cache, must-revalidate" );
@header( 'Pragma: public' );
$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5' );

$objWriter->save('php://output');
