<?php

class job_deleteoldtask extends Jobs
{
	function getStatus()
	{
		return array(
			'run' => 'auto'
		);
	}

	function getTitle()
	{
		return "Удаление выполненных заданий";
	}
	
	function getDescription()
	{
		return "Удаление выполненных заданий";
	}
	
	function GetTasksCount() {
		$arFilter = array(
			'Filter' => array(
				'Taskstatus' => 3,
			),
		);
		return task::Filter( $arFilter )->Count;
	}

	function Start()
	{
		$arFilter = array(
			'Filter' => array(
				'Taskstatus' => taskstatus::Id(3)->Id,
#				'TsStart' => time() - (60*60*3)
			),
		);
		$AllCount = task::Filter( $arFilter )->Count;
		
		echo "Количество старых заданий : {$AllCount}\n";
		
		//$arFilter['Limit'] = Site()->Config( 'count.delete.task', 2000 );
		$Tasks = task::Filter( $arFilter );
		
		
		
		if( $Tasks->Count && !$this->GetMemoryRun() && !$this->GetTimeRun() )
		{
			echo "Удалено {$Tasks->Count} старых заданий из {$AllCount}";
			//DB::Select( 'START TRANSACTION' );
			foreach($Tasks->GroupBy(100)->Elements as $iTaskG){
			  foreach($iTaskG->Elements as $iTask){
				  $iTask->Delete();
				  echo ".";
				
				
				
				  flush();
				  if( $this->GetMemoryRun() ) {
					  break;
				  }
				  if( $this->GetTimeRun() ) {
					  break;
				  }
				
			  }
			  $iTaskG->ElementsFreeMem;
			}
			//DB::Select("COMMIT");
		}
		
		
		
		
		$Filter = array(
			'Filter' => array(
				'Meter' => 0
			)
		);
		$ArTask = task::Filter($Filter);
		echo "Количество заданий с несуществующими счетчиками : {$ArTask->Count}\n";
		if( $ArTask->Count && !$this->GetMemoryRun() && !$this->GetTimeRun())
		{
		  //DB::Select( 'START TRANSACTION' );
		  foreach($ArTask->GroupBy(100)->Elements as $iTaskG){
			  foreach($iTaskG->Elements as $iTask){
			
				  $this->AddIteration();
				  $iTask->Delete();
				
				  flush();
				  if( $this->GetMemoryRun() ) {
					  break;
				  }
				  if( $this->GetTimeRun() ) {
					  break;
				  }
			
			  }
			  $iTaskG->ElementsFreeMem;
			}
		  //DB::Select("COMMIT");
		}
		
		
		
		$Filter = array(
			'Filter' => array(
				'Parameter' => 0
			)
		);
		$ArTask = task::Filter($Filter);
		echo "Количество заданий с несуществующими параметрами : {$ArTask->Count}\n";
		if( $ArTask->Count && !$this->GetMemoryRun() && !$this->GetTimeRun() )
		{
		  //DB::Select( 'START TRANSACTION' );
			foreach($ArTask->GroupBy(100)->Elements as $iTaskG){
			  foreach($iTaskG->Elements as $iTask){
			
				  $this->AddIteration();
				
				  $iTask->Delete();
				
				  flush();
				  if( $this->GetMemoryRun() ) {
					  break;
				  }
				  if( $this->GetTimeRun() ) {
					  break;
				  }
			
			  }
			  $iTaskG->ElementsFreeMem;
			}
			//DB::Select("COMMIT");
	  	
		}
		
		
		return true;
	}
}
