<?php

class job_group_months extends Jobs
{
  function getTitle()
  {
    return "Группировка данных месяц";
  }
  
  function getDescription()
  {
    return "Подсчет месячных данных по приборам учета";
  }

	function GetTasksCount() {
    $arLook = array(
      'Filter' => array(
      	'Year >'  => 0,
      	'Month >' => 0,
        'Day'     => 0,
        'Hour'    => 0,
        'Loginfo' => loginfo::ByIdent('OK_CULC')->Id,
      )
    );
		return  meterdatahour::Filter( $arLook )->Count;
	}

  function Start()
  {
  
  	
  
    $arLog = array();
    foreach( loginfo::All()->Elements as $iLog )
    {
      $arLog[$iLog->Logtext] = $iLog;
    }
    echo "Значения статусов в системе:\n";
    foreach($arLog as $key=>$iLog )
    {
      echo " - [{$iLog->Id}]{$key}\t| {$iLog->Title}\n";
    }
    $arLook = array(
      'Filter' => array(
      	'Year >'  => 0,
      	'Month >' => 0,
        'Day'     => 0,
        'Loginfo' => $arLog['OK_CULC']->Id,
      ),
      /*'Order' => array(
        'Year'  => 'DESC',
        'Month' => 'DESC',
      ),*/
    );
    echo "\n";
    $AllCount = meterdatahour::Filter( $arLook )->Count;
    $arLook['Limit'] = 2000;
    $MDHs = meterdatahour::Filter( $arLook );
//    echo  "SQL: {$MDHs->Sql}\n";
    echo "Месячные параметры, которые необходимо обновить: {$MDHs->Count} из {$AllCount} шт\n";
    $max_start = 2000;
    $max = $max_start;
    
    
    
    foreach( $MDHs->Elements as $iMDH )
    {
      echo "  [meter:{$iMDH->Meter->Id}]{$iMDH->Meter->Title}\t{$iMDH->Day}.{$iMDH->Month}.{$iMDH->Year}\t"
        ."{$iMDH->Parameter->Title}={$iMDH->Value}[{$iMDH->Loginfo->Title}]\n";
		if( !$iMDH->Parameter->UseGrouping )
      {
        echo "Параметр {$iMDH->Parameter->Ident} не поддерживает обработку, удален {$iMDH->Id}\n";
        echo $iMDH->Delete();
        
        
        
        continue;
      }
      $arDataLook = array(
        'Filter' => array(
          'Meter'     => $iMDH->Meter->Id,
          'Parameter' => $iMDH->Parameter->Id,
          'Year'      => $iMDH->Year,
          'Month'     => $iMDH->Month,
          'Day >'     => 0,
          'Hour'      => 0,
          'Loginfo'   => array(
          	$arLog['OK']->Id,
	        $arLog['NODATA']->Id,
          	$arLog['OK_NOTFULL']->Id,
          	$arLog['OK_CULC']->Id,
					),
        ),
        'Order' => array(
          'Day'  => 'ASC',
        ),
      );
      $DayMDHs = meterdatahour::Filter( $arDataLook );
      //echo $DayMDHs->Sql;
      $arCulc = array(
      	'DAYS' => array(),
      	'SUM'     => 0,
      	'MIN'     => false,
      	'MAX'     => false,
      	'AVG'     => false,
      	'NODATA'  => 0,
      	'NOTFULL' => 0,
      	'OK_CULC' => 0,
      );
      //echo $iMDH->Parameter->Parameterdatatype->Ident;
      // Перебираем все значения
      echo "    Найдено {$DayMDHs->Count} значений:\n";
      foreach( $DayMDHs->Elements as $iDayMDH )
      {
      	$this->AddIteration();
//      	echo "      {$iDayMDH->Day} = {$iDayMDH->Value}[{$iDayMDH->Loginfo->Title}]\n";
      	if( isset( $arCulc['DAYS'][$iDayMDH->Day] ) ){
      		echo "!!!! Дубль {$iDayMDH->Id}\n";
      		
      		$iDayMDH->Delete();
      		continue;
      	}
      	$MonthDays = date( 't', mktime( 0, 0, 0, $iDayMDH->Month, $iDayMDH->Day, $iDayMDH->Year ) );
      	
      	
      	if( $iDayMDH->Day<1 or $iDayMDH->Day>$MonthDays ){
      		echo "!!!! Значение дня за рамками допустимых {$iDayMDH->Id}";
      		
      		$iDayMDH->Delete();
      		continue;
      	}
      	if( $iDayMDH->Loginfo->Id == $arLog['NODATA']->Id ){
      		$arCulc['NODATA']++;
      		continue;
      	}
      	if( $iDayMDH->Loginfo->Id == $arLog['OK_NOTFULL']->Id ){
      		$arCulc['NOTFULL']++;
//      		continue;
      	}
      	if( $iDayMDH->Loginfo->Id == $arLog['OK_CULC']->Id ){
      		$arCulc['OK_CULC']++;
				}
      	$arCulc['DAYS'][$iDayMDH->Day] = $iDayMDH->Day;
      	$arCulc['SUM'] += $iDayMDH->Value;
      	$arCulc['MIN'] = $arCulc['MIN']
      		? min( $iDayMDH->Value, $arCulc['MIN'] )
      		: $iDayMDH->Value;
      	$arCulc['MAX'] = $arCulc['MAX']
      		? max( $iDayMDH->Value, $arCulc['MAX'] )
      		: $iDayMDH->Value;
      		
      	flush();
				if( $this->GetMemoryRun() ) {
					return true;
				}
				if( $this->GetTimeRun() ) {
					return true;
				}
				
				

			}
			
			
			if( count( $arCulc['DAYS'] ) ){
				$arCulc['AVG'] = round( $arCulc['SUM'] / count($arCulc['DAYS']) );
			}
			// Если есть какие-то данные
			if( count( $arCulc['DAYS'] ) ){
				if( $iMDH->Parameter->UseSum ){
//					$iMDH->Value;
					echo "    SUM: {$iMDH->Value}->{$arCulc['SUM']}\n";
					$iMDH->Value = $arCulc['SUM'];
					if( count( $arCulc['DAYS'] )==$MonthDays ){
						echo "    OK_FULL\n";
						$iMDH->Loginfo = $arLog['OK'];
					}else{
						echo "    OK_NOTFULL\n";
						$iMDH->Loginfo = $arLog['OK_NOTFULL'];
					}
				}elseif( $iMDH->Parameter->UseMin ){
					if( $arCulc['MIN']!== false ){
						echo "    MIN: {$iMDH->Value}->{$arCulc['MIN']}\n";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['MIN'];
						$iMDH->Loginfo = $arLog['OK'];
					}
//					continue;
				}elseif( $iMDH->Parameter->UseMax ){
					if( $arCulc['MAX']!== false ){
						echo "    MAX: {$iMDH->Value}->{$arCulc['MAX']}\n";
						echo "    OK\n";
						$iMDH->Value = $arCulc['MAX'];
						$iMDH->Loginfo = $arLog['OK'];
					}
				}elseif( $iMDH->Parameter->UseAverage ){
					if( $arCulc['AVG']!== false ){
						echo "    AVG: {$iMDH->Value}->{$arCulc['AVG']}\n";
						echo "    AVG: {$iMDH->Value}->{$arCulc['AVG']}\n";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['AVG'];
						$iMDH->Loginfo = $arLog['OK'];
					}
				}
				$iMDH->save();
				
			}
			
			
			flush();
		  if( $this->GetMemoryRun() ) {
	  		return true;
		  }
	  	if( $this->GetTimeRun() ) {
	  		return true;
	  	}
	  	
  	}
  	
  	
  	return true;
  	
  }
}

