<?php

class job_light extends Jobs
{
  
  function getTitle(){
    return "Управление светом";
  }
  
  function getDescription(){
    return "Управление светом";
  }

	function getStatus()
	{
		return array(
			'run' => 'auto'
		);
	}
	
	public $status = false;

	function Start( $test = false , $_class = null )
	{
	
		
	
	  # to null !
		$MODE_OFF         = 0;
	  $MODE_ON          = 1;
	  $MODE_AUTO        = 2;
	  $LEVEL_OFF        = null;
	  $LEVEL_ON         = null;
	  $LIGHT_OFF        = 1;
	  $LIGHT_ON         = 0;
	  $LIGHT_UNDEFINED  = -1;
	  
	  $value_new =   $LIGHT_UNDEFINED;
	  
	  echo "----DEFAULT----\n";
	  echo "\$MODE_OFF        = {$MODE_OFF}\n";
	  echo "\$MODE_ON         = {$MODE_ON}\n";
	  echo "\$MODE_AUTO       = {$MODE_AUTO}\n";
	  echo "\$LEVEL_OFF       = {$LEVEL_OFF}\n";
	  echo "\$LIGHT_OFF       = {$LIGHT_OFF}\n";
	  echo "\$LIGHT_ON        = {$LIGHT_ON}\n";
	  echo "\$LIGHT_UNDEFINED = {$LIGHT_UNDEFINED}\n";
    echo "--------------\n";
	
		
		echo "start\n";
		
		echo "time : " . date("H:m") . "\n";
		
		$SQL = preg_replace( '/[\r\n\t]+/', ' ', "
		
      
      
      SELECT 
       `meter`.`num_485` AS `device_ip`,
       `mm`.`id` AS `id`,
       `meter`.`num_serial` AS `snmp_addr`,
       `mm`.`num_485` AS `light_ip`, 
       `scheduleprogramlight`.`typesschedulelight_id` ,
       `programlimits`.`start`, 
       `programlimits`.`stop` ,
       `converter`.`ip` as `lightsnmp_ip` ,
       `scheduleprogramlight`.`hour` as hour, 
       `scheduleprogramlight`.`minuts` as min, 
       `converter`.`login` as `lightsnmp_login` ,
       `cc`.`ip` as `devicesnmp_ip`, 
       `cc`.`login` as `devicesnmp_login`, 
       `programlight`.`programstatus_id` as `program_status`
        FROM ( SELECT * FROM scheduleprogramlight ORDER BY  `scheduleprogramlight`.`minuts` DESC) as scheduleprogramlight LEFT JOIN
       `programdevicelight` ON
      `programdevicelight`.`programlight_id` =`scheduleprogramlight`.`programlight_id`LEFT JOIN
       `meter` ON
      `meter`.`id` =`programdevicelight`.`device_id`LEFT JOIN
       `meter` AS
       `mm` ON
       `mm`.`id` =`programdevicelight`.`meter_id`LEFT JOIN
       `programlimits` ON
       `programlimits`.`id` = `scheduleprogramlight`.`programlight_id`LEFT JOIN
       `converter` ON
       `converter`.`id` = `meter`.`converter_id` LEFT JOIN
       `converter` AS
       `cc` ON
       `cc`.`id` = `mm`.`converter_id` LEFT JOIN
       `programlight` ON
       `programdevicelight`.`programlight_id` = `programlight`.`id` 
       WHERE STR_TO_DATE( concat(`scheduleprogramlight`.`hour`, '/', `scheduleprogramlight`.`minuts` ),'%k/%i' ) <= STR_TO_DATE( '". date("H") ."/". date("i") ."','%k/%i' ) 
		    GROUP BY hour ORDER BY hour DESC
      " );
      
      
      
      
#      echo str_replace( array( "  " , "AS" , "ON" , "JOIN" ) ,array( "" , "AS\n" , "ON\n" , "JOIN\n" ) ,$SQL);
      
      $SQL = DB::Select($SQL);
      
      $arrayDevice = array();
      
      if($SQL){
      
		    while( $res = DB::Fetch($SQL)){
		    
		    	$this->AddIteration();
		    
		      printf ( "{$res['device_ip']}\n" );
		      
		      /*
		        Чтобы избавится от дублирующихся заданий.
		      */
		      if(isset($arrayDevice[$res['light_ip']])) continue;
		      $arrayDevice[$res['light_ip']] = true;
		    
		    
		      $oid_light  = $res['light_ip'];
		      $oid_ctrl   = $res['device_ip'];
		      $mode       = $res['program_status'] - 1;
		      
		      echo "HOUR             = {$res['hour']}\n";
		      echo "MIN              = {$res['min']}\n";
		      echo "\$light_ip        = {$res['light_ip']}\n";
		      echo "\$oid_ctrl        = {$res['device_ip']}\n";
		      echo "\$value_new       = {$value_new}\n";
		      echo "\$mode            = {$mode}\n";
		      
				  $hour = $res['hour'] < 10  ? "0{$res['hour']}"  : $res['hour'];
				  $min  = $res['min']  < 10  ? "0{$res['min']}"   : $res['min'];
				  $key  = $hour.$min;
				  
				  $arTimer = array(
							$key =>   $res['typesschedulelight_id'] -1,
					);
					
				  
				  
				  /*
				    WHAT DEFAULT VALUE ????
				  */
				  $LEVEL_ON       = $res['start'];
				  $LEVEL_OFF      = $res['stop'];
				  
				  if( is_null($LEVEL_ON) ) continue;
				  if( is_null($LEVEL_OFF) ) continue;
				  
				  echo "\$LEVEL_ON        = {$LEVEL_ON}\n";
				  echo "\$LEVEL_OFF       = {$LEVEL_OFF}\n";
				  echo "\$ip_device       = {$res['devicesnmp_ip']}\n";
				  echo "\$login_device    = {$res['devicesnmp_login']}\n";
				  echo "\$lightsnmp_ip    = {$res['lightsnmp_ip']}\n";
				  echo "\$lightsnmp_login = {$res['lightsnmp_login']}\n";
				  
				  $ip_device      = $res['devicesnmp_ip'];
				  $login_device   = $res['devicesnmp_login'];
				  $ip_light       = $res['lightsnmp_ip'];
				  $login_light    = $res['lightsnmp_login'];
				  
				  if(is_null($res['devicesnmp_ip']) or is_null($res['lightsnmp_ip'])){
				    continue;
				  }
				  
				  if(!$test){
				    $session_light              = new SNMP(SNMP::VERSION_1, $ip_device, $login_device);
				    $session_ctrls[$ip_light]   = new SNMP(SNMP::VERSION_1, $ip_light, $login_light);
				  }else{
				    $session_light              = new $_class(SNMP::VERSION_1, $ip_device, $login_device);
				    $session_ctrls[$ip_light]   = new $_class(SNMP::VERSION_1, $ip_light, $login_light);
				  }
				  
				  
					printf ( "Режим работы: %s\n", ($MODE_AUTO == $mode) ? 'Автоматический' : 'Ручной' );
					if( $mode < $MODE_AUTO )
					{
						if( $MODE_ON == $mode )
						{
							$value_new = $LIGHT_ON;
							printf ( "Ручной: Включено\n" );
						}
						else if( $MODE_OFF == $mode )
						{
							$value_new = $LIGHT_OFF;
							printf ( "Ручной: Выключено\n" );
						}
		
					}
					else
					{
						ksort($arTimer);
						ini_set( 'date.timezone','Asia/Yekaterinburg' );
						$DT = new DateTime();
						$NowHM = $DT->format('Hi');
						unset($DT);
						echo $NowHM.': \n';
						$HMPrev = false;
						foreach( $arTimer as $iHM => $TimerMode )
						{
							if( $HMPrev === false )
							{
								$HMPrev = $iHM;
							}
							echo "$iHM => $TimerMode \n";
							if( $NowHM < $iHM )
							{
								echo "F";
								break;
							}
							$HMPrev = $iHM;
						}
						$ModeTimer = $arTimer[$HMPrev];
						$mode = $arTimer[$HMPrev];
						echo "++++ $arTimer[$HMPrev] +++ \n";

						if( $MODE_ON == $mode )
						{
							$value_new = $LIGHT_ON;
							printf ( "Таймер: Включено\n" );
						}
						else if( $MODE_OFF == $mode )
						{
							$value_new = $LIGHT_OFF;
							printf ( "Таймер: Выключено\n" );
						}
						else
						{
							printf ( "Таймер: Датчик осчещенности\n" );
						}

					}
	
			    if(!$test){
					  $rez_light = @$session_light->get( $res['snmp_addr']  );
					}else{
					  $rez_light = @$session_light->get( $res['snmp_addr'] , 1  );
					}
				//	var_dump($rez_light);
					if( $rez_light and preg_match( '/^[A-Z]+: (\d+)/', $rez_light, $match ) )
					{
						$value_light = $match[1];
						$light100 = $value_light;
						printf( "Уровень освещения: %d%%\n", $light100 );
					}
					else
					{
						$light100 = false;
						printf( "Уровень освещения: нет данных\n" );
					}
				//		$value_new = $value_cur == 0 
				//			? '1' : '0';
					foreach( $session_ctrls as $K => $session_ctrl ) 
					{
					  if(!$test){
						  $rez_ctrl  = $session_ctrl->get( $oid_ctrl );
						}else{
						  $rez_ctrl  = $session_ctrl->get( $oid_ctrl , 2 );
						}
					//	var_dump($rez_ctrl);
						if( $rez_ctrl and preg_match( '/^[A-Z]+: (\d+)/', $rez_ctrl, $match ) )
						{
							$value_ctrl = $match[1];
							printf( "Состояние освещения [%s]: %s\n", $K, ( $LIGHT_OFF == $value_ctrl ) ? 'Выключено' : 'Включено' );
							if( $LIGHT_OFF == $value_ctrl && $MODE_AUTO == $mode && $light100 !== false )
							{
								$value_new = ( $light100 < $LEVEL_ON ) ? $LIGHT_ON : $LIGHT_OFF;
								printf( "Состояние 1: l:%d < off:%d\n", $light100 , $LEVEL_ON, $K );
							}
							elseif( $LIGHT_ON  == $value_ctrl && $MODE_AUTO == $mode && $light100 !== false )
							{
								$value_new = ( $light100 > $LEVEL_OFF ) ? $LIGHT_OFF : $LIGHT_ON;
								printf( "Состояние 2: l:%d  > off:%d\n", $light100 , $LEVEL_OFF, $K );
							}
						}
						else
						{
							printf( "Состояние освещения [%s]: нет данных\n", $K );
						}

						if( $value_new != $LIGHT_UNDEFINED and $value_ctrl != $value_new )
						{
						  $oMeter = meter::Id($res['id']);
					    
					    if($oMeter->Is){
					    
							  $session_ctrl->set( $oid_ctrl, 'i', $value_new );
							  if($test){
					        $this->status = $value_new;
					      }
					      $status = $LIGHT_OFF ==$value_new ? 'Выключено' : 'Включено';
					    
					      userlog::AddByArray(
		          		array(
		          			'Object'   => 'meter',
		          			'ObjectId' => $oMeter->Id,
		          			'Property' => 'Light',
		          			'UserId'   => Self()->Id,
		          			'Action'   => "Освещение {$status}",
		          		)
		          	);
		          	
		          	
		          	
		          	
		          	$Filter = array(
		          	  'Filter' => array(
		          	    'Meter'   => $oMeter->Id,
		          	    'VarName' => 'SNMP_status'
		          	  )
		          	);
		          	$VarMeter = metervariable::Filter($Filter);
		          	if($VarMeter->Count){
		          	  $VarMeter->First->Data    = $value_new;
		          	  $VarMeter->First->AddTime = date("d-m-Y H-i-s");
		          	}else{
		          	  metervariable::AddByArray(
		          	    array(
		          	      'MeterId'   => $oMeter->Id,
		          	      'VarName' => 'SNMP_status',
		          	      'Data'    => $value_new,
		          	      'AddTime' => date("Y-m-d H-i-s")
		          	    )
		          	  );
		          	  
		          	}
		          	
		        	}else{
		        	  echo "Такого прибора не существует\n";
		        	}
							printf ( "Состояние Изменено [%s]: %s\n", $K, ($LIGHT_OFF ==$value_new) ? 'Выключено' : 'Включено' );
							$value_new = $LIGHT_UNDEFINED;
						}
					}
					
					unset($session_light,$session_ctrls[$ip_light]);
					
					flush();
					if( $this->GetMemoryRun() ) {
						return true;
					}
					if( $this->GetTimeRun() ) {
						return true;
					}
					
				}
			
			}
			
			
		return true;
	}
  
}

