<?php

class job_need_calc extends Jobs
{
	function getStatus()
	{
		return array(
			'run' => 'auto'
		);
	}

  function getTitle()
  {
    return "Нужен пересчет";
  }
  
  function getDescription()
  {
    return "Отслеживание всех результатов работы, и в случае нахождения удачных данных выставления статуса на пересчет группированных данных";
  }

	function GetTasksCount()
	{
		return 0;
    $MDHLastId = Site()->Config( 'MeterDataHour.LastUseId.group', 0 );
    $MDH = meterdatahour::Id( $MDHLastId );
    if( !$MDH->Is ) {
	    $arParams = array(
		    'Order' => array(
		      'Id'   => 'ASC',
	      ),
  	    'Limit' => 1,
  	  );
	    $MDH = meterdatahour::Filter( $arParams )->First;
    	if( !$MDH->Is ){
    		$MDHLastId = $MDH->Id;
    		//echo ".";
    	}
    }
    //$MDHLastId = 300000;
    $arParams = Array(
      'Filter' => Array(
        'Id >'   => $MDHLastId,
      ),
      'Order' => array(
        'Id'   => 'ASC'
      ),
//      'Limit'  => 1000,
    );
    $MDHs = meterdatahour::Filter( $arParams );
    return $MDHs->Count;
	}

	function meterdatahour__AddOrUpdateDay( array $Up, array $arLog )
	{
		static $Points = 0;
		// Поиск уже существующего значения
		$arLook = array(
			'Filter' => array(
				'Meter'     => $Up['Meter'],
				'Parameter' => $Up['Parameter'],
				'Year'      => $Up['Year'],
				'Month'     => $Up['Month'],
				'Day'       => $Up['Day'],
				'Hour'      => 0,
			)
		);
		$DMHs = meterdatahour::Filter( $arLook );
		if( $DMHs->Count == 0 )
		{
			// Не найдено нужно добавить
			$Add = false;
			echo "\n[meter:{$Up['Meter']}] параметр {$Up['Parameter']}, {$Up['Year']}-{$Up['Month']}-{$Up['Day']} ";

			//	DB::Select( '/* step 4.3 */' );
			$Add = meterdatahour::AddByArray(
				array(
					'MeterId'     => $Up['Meter'],
					'ParameterId' => $Up['Parameter'],
					'Year'        => $Up['Year'],
					'Month'       => $Up['Month'],
					'Day'         => $Up['Day'],
					'Hour'        => 0,
					'Value'       => 0,
					'LoginfoId'   => $arLog['OK_CULC']->Id,
				)
			);
			
			

			//  	DB::Select( '/* step 4.4 */' );
		   if( $Add and $Add->Is )
		   {
		   	echo "Добавлен:{$Add->Id}\n";
		   }
		   else
		   {
		   	echo "Недобавлен\n";
		   }
		}
		else
		{
		 	// Найдено одновляем на пересчет
		 	if( $DMHs->Count>1 )
		 	{
				echo "Найдено более 1 записи\n";
				//echo "SQL:{$DMHs->Sql}\n";
		 	}
		 	$FirstRecord = false;
			foreach( $DMHs->Elements as $iMDH )
			{
				if( !$FirstRecord )
				{
					$iMDH->Loginfo = $arLog['OK_CULC'];
					$FirstRecord = true;
					$PointsInLine = 100;
					if( $Points >= $PointsInLine )
					{
						echo "\n"; $Points=0;
					}
					echo ($Up['Day']==0)
						? "."
						: "*"; 
						
					$Points++;
				}
				else
				{
					$iMDH->Delete();
					
					
					echo "Удален дубликат\n";
				}
			}
		}
	}
	
	function Start()
	{
		echo "Old method. disabled.\n";
		return false;
		global $Manual;
#		$ExecTime = getmicrotime();
		$MaxExecTime = $this->Time_Run;
		$MAXDO = Site()->Config( "count.task.need_culc", 1000 );
		echo "Максимальное время работы {$MaxExecTime} сек.\n";
		echo "Максимальное количество обрабатываемых данных {$MAXDO}\n";
		if( isset($Manual) and $Manual )
			echo "Ручной запуск задачи.\n";
		else
			$Manual = false;
		
			
		$MDHLastId = Site()->Config( 'MeterDataHour.LastUseId.group', 0 );
		if( $Manual )
		{
			$MDHLastId -= 1000;
			$MDHLastId = 131093249-10;
			//$MAXDO = 1000000;
			echo "Присвоение \$MDHLastId={$MDHLastId}. line: ".__LINE__."\n";
		}
		$MDH = meterdatahour::Id( $MDHLastId );
		if( !$MDH->Is )
		{	
			echo "Указанный MDH не существует, исполуем следующий после указанного\n";
			$arParams = array
			(
				'Filter' => array(
					'Id >' => $MDHLastId,
				),
				'Order' => array
				(
					'Id'   => 'ASC',
				),
				'Limit' => 1,
			);
			$MDHs = meterdatahour::Filter( $arParams );
			$MDH = $MDHs->First;
			if( $Manual )
			{
				echo "SQL: {$MDHs->Sql}\n";
			}
			if( $MDH->Is )
			{
				$MDHLastId = $MDH->Id;
			}
		}
			echo "\$MDHLastId = $MDHLastId \n";
		if( 0 and $Manual )
		{
			echo "Выполение прервано. line: ".__LINE__."\n";
			return true;
		}
    //$MDHLastId = 300000;
		$arParams = array
		(
			'Filter' => array
			(
				'Id >'   => $MDHLastId,
			),
			'Order' => array
			(
				'Id'   => 'ASC'
			),
			//      'Limit'  => 1000,
		);
		$SqlExecCount = array( 'Month'=>0, 'Day'=>0, 'Meter'=>array() );
		$MDHs = meterdatahour::Filter( $arParams );
		//echo "{$MDHs->Sql}\n"; 
		flush();
// ini_set("memory_limit","1024M");
		$arMDHUpdate = array();
		if( !$MDHs->Count )
		{
			echo "Нет данных для обработки\n";
			return true;
		}
		echo "Данных для обработки максимум {$MAXDO} из {$MDHs->Count}\n";
		$Step = 0;
		$arLog = array();
		foreach( loginfo::All()->Elements as $iLog )
		{
			$arLog[$iLog->Logtext] = $iLog;
		}

		$MAXDO = min( $MDHs->Count, $MAXDO );
		$Elements = $MDHs->GroupBy($MAXDO)->First;
    	DB::Select( '/* start main */' );
		foreach( $Elements->GroupBy(500)->Elements as $ElementsBy100 )
		{
			//DB::Select( 'START TRANSACTION' );
			foreach( $ElementsBy100->Elements as $iMDH )
			{
				$this->AddIteration();
				flush();
				if( $iMDH->Hour == 0 ) {
					// Пропустить суточные данные
					echo "c";
					$MDHLastId = $iMDH->Id;
					continue;
				}
				$Step++;
				if( $iMDH->Loginfo->Logtext == 'OK' and !$iMDH->Parameter->IsEventLog )
				{
					if( !isset($SqlExecCount['Meter'][$iMDH->Meter->Id]) )
					{
						$SqlExecCount['Meter'][$iMDH->Meter->Id] = 0;
					}
					$IdentDay   = "{$iMDH->Meter->Id}-{$iMDH->Parameter->Id}-{$iMDH->Year}-{$iMDH->Month}-{$iMDH->Day}";
					$IdentMonth = "{$iMDH->Meter->Id}-{$iMDH->Parameter->Id}-{$iMDH->Year}-{$iMDH->Month}-0";
					if( !isset($arMDHUpdate[$IdentDay]) )
					{
						$arMDHUpdate[$IdentDay] = true;
						self::meterdatahour__AddOrUpdateDay(
							array(
								'Meter'     => $iMDH->Meter->Id,
								'Parameter' => $iMDH->Parameter->Id,
								'Year'      => $iMDH->Year,
								'Month'     => $iMDH->Month,
								'Day'       => $iMDH->Day, 
							), 
							$arLog 
						);
						$SqlExecCount['Meter'][$iMDH->Meter->Id]++;
						$SqlExecCount['Day']++;
					}
					if( !isset( $arMDHUpdate[$IdentMonth] ) )
					{
						$arMDHUpdate[$IdentMonth] = true;
						self::meterdatahour__AddOrUpdateDay(
							array(
								'Meter'     => $iMDH->Meter->Id,
								'Parameter' => $iMDH->Parameter->Id,
								'Year'      => $iMDH->Year,
								'Month'     => $iMDH->Month,
								'Day'       => 0, 
							), 
							$arLog
						);
						$SqlExecCount['Meter'][$iMDH->Meter->Id]++;
						$SqlExecCount['Month']++;
					}
				}
//				echo "-{$iMDH->Id}";
				$MDHLastId = $iMDH->Id;
				
				flush();
				if( $this->GetMemoryRun() ) {
					break 2; //return true;
				}
				if( $this->GetTimeRun() ) {
					//return true;
					break 2;
				}

			}
			$ElementsBy100->ElementsFreeMem;
			$sql = "update config set value={$MDHLastId} where parametr='MeterDataHour.LastUseId.group'\n";
			DB::Select($sql);
			DB::Select( "COMMIT" );
			echo "DB COMMIT\n";
		}
		echo "\n";
		echo "Обновлено суточных:{$SqlExecCount['Day']} месячных:{$SqlExecCount['Month']}\n";
		foreach( $SqlExecCount['Meter'] as $MeterId => $Count )
		{
			echo "[meter:{$MeterId}] Обновлено {$Count}\n";
/*			flush();
			if( $this->GetMemoryRun() ) {
				echo "\n\nПревышено ограничение по потреблению памяти. ( ".memory_get_usage()." )\n";
				$this->SetResult( 'MEMORY_LIMIT');
				// return true;
				break;
			}
			if( $this->GetTimeRun() ) {
				echo "\n\nПревышено ограничение по времени работы. ({$this->Time_Run} сек)\n";
				$this->SetResult( 'TIME_LIMIT' , $this->Time_Run);
				//return true;
				break;
			}
*/
		}
		echo "\$MDHLastId = $MDHLastId \n";
		if( 0 and $Manual )
		{
			echo "Выполение прервано. line: ".__LINE__."\n";
			return true;
		}
		Site()->SetConfig( 'MeterDataHour.LastUseId.group', $MDHLastId );
		$sql = "update config set value={$MDHLastId} where parametr='MeterDataHour.LastUseId.group'";
		DB::Select($sql);
		//DB::Select( "COMMIT" );
		echo "DB COMMIT\n";
//		echo DB::Status();
		
		
		
		return true;
		
	}
}

