<?php

class job_sergey extends Jobs
{
  function getTitle()
  {
    return "Удаление неактульных задач";
  }
  
  function getDescription()
  {
    return "Удаляются задачи, которые являются неактуальными, на которые уже есть результаты работы.";
  }
  
  function Start()
  {
  	
  	
    $DateNow = new DateTime();
    $DateNeed = $DateNow->sub( new DateInterval('P1D') );
    $format='Y-m-d H:i:s';
    $date = $DateNeed->format( $format );
    
    $sql_sel = "SELECT crontask_id,date_start,date_end FROM `crontasklog` WHERE `date_start`<'{$date}' LIMIT 500";
    $all = DB::MQ($sql_sel);
    
     echo "Будут удалены ".DB::RowCount($all)." записей\n";
      if(DB::RowCount($all) != 0){
        echo "crontask_id\t\tdata_start\t\tdata_old\n";
        echo "-------------------------------------------------------------\n";
        
          while($a = DB::Fetch($all)){
            echo $a['crontask_id']."\t\t".$a['date_start']."\t".$a['date_end']."\n";
          }
        
        echo "-------------------------------------------------------------\n\n";
        
      }
    
    $sql = "DELETE FROM `crontasklog` WHERE `date_start`<'{$date}' LIMIT 500";
    DB::Query($sql);
    
    $this->AddIteration();
    
    flush();
	  if( $this->GetMemoryRun() ) {
  		return array(
				"Iteration" => $this->Iteration,
				"Return"		=> $this->MEMORY_LIMIT
			);
	  }
  	if( $this->GetTimeRun() ) {
  		return array(
				"Iteration" => $this->Iteration,
				"Return"		=> $this->TIME_LIMIT . $this->Time_Run
			);
  	}
		  	
    echo "Удалено ".DB::AffectedRows()." записей";
    
    return true;
    
  }
}

