<?php

class job_sergey_day extends Jobs
{
  function getTitle()
  {
    return "Группировка данных";
  }
  
  function getDescription()
  {
    return "Подсчет суточных данных по приборам учета";
  }

  function Start()
  {
  
  	
  
    # Вывод статусов системы
  
    $arLog = array();
    foreach( loginfo::All()->Elements as $iLog )
    {
      
      $arLog[$iLog->Logtext] = $iLog;
    }
    
    echo "---------------------------------------------------------------\n";
    
    echo "\t\tЗначения статусов в системе:\n";
    
    echo "---------------------------------------------------------------\n";
    
    foreach($arLog as $key=>$iLog )
    {
    
    # Для красоты считаем сколько надо табуляций

    if( strlen($key) > 8 && strlen($key) < 15 ){ $T = "\t\t"; }
    elseif( strlen($key) > 16 && strlen($key) < 23 ){ $T = "\t"; }
    else{ $T = "\t\t\t"; }

    
      echo " - [{$iLog->Id}]{$key}$T| {$iLog->Title}\n";
    }
    
    echo "---------------------------------------------------------------\n";
    
    ###############################

    
    $arLook = array(
      'Filter' => array(
        'Day >' => 0,
        'Hour' => 0,
        'Loginfo' => $arLog['OK_CULC']->Id,
      ),
      'Order' => array(
        'Year'  => 'DESC',
        'Month' => 'DESC',
        'Day'   => 'DESC',
      ),
    );
    $MDHs = meterdatahour::Filter( $arLook );
    
        
    # SELECT
    #     `meterdatahour`.`id`,
    #     `meterdatahour`.`meter_id`,
    #     `meterdatahour`.`parameter_id`,
    #     `meterdatahour`.`tarif_id`,
    #     `meterdatahour`.`year`,
    #     `meterdatahour`.`month`,
    #     `meterdatahour`.`day`,
    #     `meterdatahour`.`hour`,
    #     `meterdatahour`.`value`,
    #     `meterdatahour`.`loginfo_id` 
    # FROM 
    #     `meterdatahour` 
    # WHERE 
    #     `day` > '0' AND
    #     `hour` = '0' AND
    #     `loginfo_id` = '8'
    # ORDER BY `year` DESC, `month` DESC, `day` DESC LIMIT 0,278
    
    
    
    echo  "SQL: {$MDHs->Sql}\n";
    echo "Параметров для обработки: {$MDHs->Count}\n";
    
    $max_start = 200;
    $max = $max_start;
    $real_i = 0;
    foreach( $MDHs->Elements as $iMDH )
    {
    
    # делаем через каждые 50 напоминание где какая колонка
    
    if( $real_i - ( 50 * ceil($real_i/50))   == 0 ){
        echo "---------------------------------------------------------------\n";
        echo "   id\t     №\t    Имя\t\t  Дата\n"; 
        echo "---------------------------------------------------------------\n";
    }
    
    
    $title = $iMDH->Meter->Title;

    if( strlen($iMDH->Meter->Title) > 8 && strlen($iMDH->Meter->Title) < 15 ){ $T = "\t\t\t"; }
    elseif( strlen($iMDH->Meter->Title) > 16 && strlen($iMDH->Meter->Title) < 24 ){ $T = "\t\t"; }
    elseif( strlen($iMDH->Meter->Title) > 23 && strlen($iMDH->Meter->Title) < 28 ){ $T = "\t\t"; }
    elseif( strlen($iMDH->Meter->Title) > 27 && strlen($iMDH->Meter->Title) < 41 ){ $T = ""; }
    else{ $T = ""; $title = substr($iMDH->Meter->Title ,0,-40 );}
    
    echo count($T);
    
      echo " {$iMDH->Id} : [{$iMDH->Meter->Id}]{$title}$T{$iMDH->Day}.{$iMDH->Month}.{$iMDH->Year}\t"
        ."{$iMDH->Parameter->Title}={$iMDH->Value}\n";
        
    $real_i++;
    
      $arDataLook = array(
        'Filter' => array(
          'Meter'     => $iMDH->Meter->Id,
          'Parameter' => $iMDH->Parameter->Id,
          'Year'      => $iMDH->Year,
          'Month'     => $iMDH->Month,
          'Day'       => $iMDH->Day,
          'Hour >'    => 0,
//          'Loginfo'   => array( $arLog['OK']->Id ),
        ),
        'Order' => array(
          'Hour'  => 'ASC',
        ),
      );
      $DayMDHs = meterdatahour::Filter( $arDataLook );
      $DataOk = true;
      $arNeedHours = array_fill( 1, 24, 0 );
      $SUM = 0; $NODATA = false;
      # echo $iMDH->Parameter->Parameterdatatype->Ident;
      unset( $MIN );
      
      # Разбираем все элементы.
      # Это элементы, которые не прошли проверку?
      
      foreach( $DayMDHs->Elements as $iDayMDH )
      {
        if( in_array( $iDayMDH->Loginfo->Id, array(
          $arLog['OK']->Id,
          $arLog['NODATA']->Id,
        ) ) )
        {
          if( $iMDH->Parameter->UseSum )
          {
            if( $iDayMDH->Loginfo->Id==$arLog['OK']->Id )
            {
              $SUM += $iDayMDH->Value;
            }
            if( $iDayMDH->Loginfo->Id==$arLog['NODATA']->Id )
            {
              $NODATA = true;
            }
          }
          elseif( $iMDH->Parameter->UseMin )
          {
            if( $iDayMDH->Loginfo->Id==$arLog['OK']->Id )
            {
              $SUM += $iDayMDH->Value;
              if( !isset( $MIN ) )
                $MIN = $iDayMDH->Value;
              $MIN = min( $MIN, $iDayMDH->Value);
//              echo "MIN\t\t\t\t\t\t$iDayMDH->Value \n";
            }
            if( $iDayMDH->Loginfo->Id==$arLog['NODATA']->Id )
            {
              $NODATA = true;
            }
          }

          // Убрать час с существующими данными.
          unset( $arNeedHours[$iDayMDH->Hour] );
        }
        //echo " {$iDayMDH->Id} : {$iDayMDH->Hour}:00 {$iDayMDH->Value}[{$iDayMDH->Loginfo->Title}]\n";
      }
      if( count( $arNeedHours ) )
      {
        if( !$iMDH->Meter->IsOk )
        {
          echo "Прибор имеет негативный статус.\n";
          continue;
        }
        if( $iMDH->Meter->IsExcluded )
        {
          echo "Прибор исключен из работы. {$iMDH->Meter->Title}\n";
          continue;
        }
        if( $iMDH->Meter->Converter->IsExcluded )
        {
          echo "Конвертер исключен из работы. {$iMDH->Meter->Converter->Title}\n";
          continue;
        }
        /*
        Неучитывается работа с временными зонами на счетчике
        Данные могу восстановить вперед.
        */
        /*
        $arNeedHoursDo = array();
        foreach( $arNeedHours as $Hour=>$info )
        {
          $do = task::RetryMeterParameter( $iMDH->Meter, $iMDH->Parameter, $iMDH->Year, $iMDH->Month, $iMDH->Day, $Hour);
          if( $do )
          {
            $arNeedHoursDo[$Hour] = $info;
          }
        }
        if( count($arNeedHoursDo) )
        echo "Запрошены данные за часы: ".implode( ', ', array_keys($arNeedHours) )."\n";
        */
      }
      if( $iMDH->Parameter->UseSum and count( $arNeedHours )==0 )
      {
        if( $NODATA )
        {
          echo "UPDATE !!! {$iMDH->Value}=>{$SUM} [{$NODATA}]\n";
          $iMDH->Value = $SUM;
          $iMDH->Loginfo = $arLog['OK_NOTFULL'];
        }
        else
        {
          echo "UPDATE !!! {$iMDH->Value}->{$SUM} [{$NODATA}]\n";
          $iMDH->Value = $SUM;
          $iMDH->Loginfo = $arLog['OK'];
        }
      }
      elseif( $iMDH->Parameter->UseSum )
      {
        $iMDH->Value = $SUM;
      }
      
      // min value
      if( $iMDH->Parameter->UseMin )
      {
        if( count( $arNeedHours )>0 or $NODATA )
        {
          echo "!!!! UPDATE !!! {$iMDH->Value}->{$SUM} [{$NODATA}]\n";
          $iMDH->Value = $MIN;
          $iMDH->Loginfo = $arLog['OK_NOTFULL'];
        }
        elseif( count( $arNeedHours )==0 )
        {
          $iMDH->Value = $MIN;
          $iMDH->Loginfo = $arLog['OK'];
          echo "!!!! UPDATE !!! {$iMDH->Value}->{$MIN} [{$NODATA}]\n";
        }
      }
//      echo "   SQL: {$DayMDHs->Sql}\n";
//      echo "   Параметров для обработки: {$DayMDHs->Count}\n";

			flush();
		  if( $this->GetMemoryRun() ) {
	  		break 2;
		  }
	  	if( $this->GetTimeRun() ) {
	  		break 2;
	  	}
      
      if( !$max-- )
      {
        echo "Достигнуто ограничение в {$max_start} шагов. ( Всего {$MDHs->Count} ) ";
        break;
      }
    }
    

    
    return true;
  }
}

