<?php

define( 'DRIVER_MYSQL' , 1 );
define( 'DRIVER_MYSQLI' , 2 );
define( 'DB_DRIVER' , DRIVER_MYSQLI );

class job_syslog extends Jobs
{
	function getTitle()
	{
		return "Прием данных из syslog";
	}
	
	function getDescription()
	{
	}
	
	function getStatus()
	{
		return array(
			'run' => 'auto'
		);
	}

	function Start()
	{
		$server   = '192.168.5.89:3306';
		$username = 'syslog';
		$password = 'sys10g56';
		$database = 'syslog';
		if( DB::$DB_DRIVER == DB::DRIVER_MYSQL ){
			$link = @mysql_connect($server, $username, $password);
		}elseif( DB::$DB_DRIVER == DB::DRIVER_MYSQLI ){
			$link = new mysqli($server, $username, $password);
		}
		
		if ( !$link )
		{
			echo 'Ошибка соединения с сервером';
			return true;
		}
		
		if( DB::$DB_DRIVER == DB::DRIVER_MYSQL ){
			mysql_select_db( $database, $link );
		}elseif( DB::$DB_DRIVER == DB::DRIVER_MYSQLI ){
			$link->select_db($database );
		}
		$FromID = Site()->Config( 'syslog.fromid', 0 );//-1;
		global $Manual;
		if( isset($Manual) and $Manual )
		{
			echo "\$Manual";
		}
		//$FromID = 220;
		echo "from $FromID\n";
		$sql = "SELECT `ID`, `Message`, `ReceivedAt`,`SysLogTag`, `FromHost` FROM `SystemEvents` WHERE `ID`>{$FromID} ORDER BY `ID` ASC ";
//		echo $sql;
		
		if( DB::$DB_DRIVER == DB::DRIVER_MYSQL ){
			$result = mysql_query( $sql, $link );
		}elseif( DB::$DB_DRIVER == DB::DRIVER_MYSQLI ){
			$link->query( $sql );
		}
		
		$arLook = array(
			'Filter' => array(
				'DllId' => array( /*'ERD_SENSOR',*/ 'SNR-GSM-TEMP' ), 
			),
		);
		$MetertypeForEvent = metertype::Filter( $arLook )->First;
		if( !$MetertypeForEvent->Is )
		{
			echo "Нет типа счетчика для событий\n";
			return true;
		}
		else
		{
			echo "Тип прибора учета для событий {$MetertypeForEvent->Id} {$MetertypeForEvent->Ident} {$MetertypeForEvent->Title}\n";
		}
		$arLook = array(
			'Filter' => array(
				'Ident' => array('EVENT_SENSOR' ),
			),
		);
		$ParameterForEvent = parameter::Filter( $arLook )->First;
		if( !$ParameterForEvent->Is )
		{
			echo "Нет параметра для событий\n";
			return true;
		}
		else
		{
			echo "Тип параметра для событий {$ParameterForEvent->Id} {$ParameterForEvent->Ident} {$ParameterForEvent->Title}\n";
		}
		
		if( DB::$DB_DRIVER == DB::DRIVER_MYSQL ){
			$count = mysql_num_rows( $result );
		}elseif( DB::$DB_DRIVER == DB::DRIVER_MYSQLI ){
			$count = $result->num_rows;
		}
		
		echo "Поступило новых событий: {$count}\n";
		while ( $row = $result->fetch_assoc )
		{
			list( $id, $mes, $date, $tag, $ip) = $row;
			Site()->SetConfig( 'syslog.fromid', $id );
			//printf( "%s %s ID: %s  Имя: %s\n", $row[3], $row[2],$row[0], $row[1],  );
			echo "[$id: $ip] $date $tag $mes\n";
			$arLook = array(
				'Filter' => array(
					'Ip' => $ip,
				),
			);
			$Converters = converter::Filter( $arLook );
			foreach( $Converters->Elements as $iConverter )
			{
				$arLook = array( 'Filter' => array(
					'Converter' => $iConverter->Id,
					'Type' => $MetertypeForEvent->Id,
				) );
//				var_dump( $arLook );// die();
				$Meters = meter::Filter( $arLook );
//				echo meter::Filter( $arLook )->Sql; die();
//				echo "[={$iConverter->Id}] {$Meters->Count} | $mes\n";
				if( preg_match( '/\d sense(\d)=(\d)/', $mes, $M ) )
				{
//					var_dump( $M );
					list( , $EventNum, $EventType, $EventCode ) = $M;
				}
				//die();
				foreach( $Meters->Elements as $iMeter )
				{
					$A = array(
						'MeterId'          => $iMeter->Id,
						'MetertypeId'      => $MetertypeForEvent->Id,
						'MetereventtypeId' => $EventType,
						'Datetime'         => $date,
						'EventCode'        => $EventCode,
						'ParameterId'      => $ParameterForEvent->Id,
					);
					#определение номера предыдущего события
					$EventNumLook = array(
						'Filter' => array(
							'Meter' => $iMeter->Id,
							'VarName' => 'EventNum',
						),
					);
					$MeterVar = metervariable::Filter( $EventNumLook )->First;
					if( $MeterVar->Is )
					{
						if( $EventNum > $MeterVar->Data )
						{
						}
					}
					else
					{
						metervariable::AddByArray( array(
							'MeterId' => $iMeter->Id,
							'VarName' => 'EventNum',
							'Data'    => $EventNum,
						) );
					}
					//var_dump( $A ); //die();
					
					meterevent::AddByArray(  $A );
					echo "Добавлено событие для [meter:{$iMeter->Id}]\n";
//					die();
				}
			}
			if( ! $Converters->Count )
			{
				echo "[NOT FOUND: $ip]\n";
			}
			
		}
		if( DB::$DB_DRIVER == DB::DRIVER_MYSQL ){
			mysql_close( $link );
		}elseif( DB::$DB_DRIVER == DB::DRIVER_MYSQLI ){
			$link->close();
		}
		return true;
	}



	function Settins()
	{
	return array( 'time' => 1 , 'mem' => '10M' );
	}
  
  
}

