<?php

class job_task_delete_old extends Jobs
{
  function getTitle()
  {
    return "Удаление неактульных задач";
  }
  
  function getDescription()
  {
    return "Удаляются задачи, которые являются неактуальными, на которые уже есть результаты работы.";
  }

    function GetSufixSQL(){
  return " from task left join meterdatahour as m 
on m.meter_id = task.meter_id
and m.parameter_id = task.parameter_id
and m.year = task.year
and m.month = task.month
and m.day = task.day
and m.hour = task.hour
left join log_info
on log_info.id = m.loginfo_id
where log_info.logtext = 'OK'
and m.meter_id = task.meter_id
and m.parameter_id = task.parameter_id
and m.year= task.year
and m.month = task.month
and m.day = task.day
and m.hour = task.hour
";
    }
  
  function GetTasksCount() {
    $sql = "SELECT COUNT(*) as count ". $this->GetSufixSQL();
    $res = DB::FetchArraySelect( $sql );
    return $res['count'];
  }
  
  function Start()
  {
    
    $sql = "SELECT `task`.* ". $this->GetSufixSQL();

    $t = task::Id(0);

foreach( TListGroup::Prepare($sql , $t)->Elements as $iTask){
    $iTask->Delete();echo ".";
flush();
}
    
    flush();
    if( $this->GetMemoryRun() ) {
      return true;
    }
    if( $this->GetTimeRun() ) {
      return true;
    }
    
    
    return true;
  }
}

