<?php
#ini_set('memory_limit', '256M' );
class job_task_retry_delete extends Jobs{
  
  
  
  function getTitle(){
    return "Удаление заданий с повторами";
  }

  function getDescription(){
    return "Удаляются задания, которые не могут быть выполнены в течении 10 попыток. А также восстановление зависших заданий";
  }
  
  function ad(){
    
  }

	function GetTasksCount() {
	$MaxRetry = Site()->Config( 'job.task_retry_delete.count', 3 );
    $arParams = Array(
      'Filter' => Array(
        'Taskstatus' => 1,
        'Retry >' => $MaxRetry ,

      ),
      'Order' => array(
        'Id'   => 'ASC'
      ),
      //'Limit' => 1000,
    );
    $arTasks = task::Filter( $arParams );
		return $arTasks->Count;
	}

  function Start(){

    $StatusStart = taskstatus::Id(1);
    $StatusWork  = taskstatus::Id(2);
    $StatusEnd   = taskstatus::Id(3);




/*
    Допускаем что у нас есть задания уже которые ждут больше N часов
*/
    $MaxRetryHour = Site()->Config( 'job.task_retry_delete_hour.count', 3 );
    $DateNow      = new DateTime('now -'.$MaxRetryHour.' hour');

    $Filter = array(
      'Filter' => array(
        'TsAdd <='  => $DateNow->getTimestamp(),
        'Taskstatus' => $StatusStart->Id
      )
    );

    $FilterTask = task::Filter( $Filter );

    echo $FilterTask->Sql."\n";

    echo "Найдено заданий превысивших лимит по времени назначения после {$MaxRetryHour} часов = {$FilterTask->Count}\n";

    foreach( $FilterTask->GroupBy500->Elements as $arTasksG ) {
      foreach( $arTasksG->Elements as $iTask ) {
      	$this->AddIteration();

        $oMeter = $iTask->Meter;

      	if($oMeter->IsOk){
		      $LogText = "{$iTask->Meter->Id} Задание висело больше {$MaxRetryHour} часов [TsAdd:".date("Y-m-d H:i:s",$iTask->TsAdd).";Param:{$iTask->Parameter->Title};ST:{$iTask->Taskstatus->Id}] -> Удаляем\n";
		      echo $LogText;
		      $iTask->Meter->IsOk = array( 0 , $LogText );
        }


        $iTask->Delete();
        $iTask->Save();
        echo "\n[TsAdd:".date("Y-m-d H:i:s",$iTask->TsAdd).";Param:{$iTask->Parameter->Title};YMDH:{$iTask->Year}-{$iTask->Month}-{$iTask->Day} {$iTask->Hour};ST:{$iTask->Taskstatus->Id}] -> Удаляем\n";
        echo "Удаляем таск, который добавлился " . date( "Y-m-d H:i:s" , $iTask->TsAdd ) . ", а сейчас {$DateNow->format('Y-m-d H:i:j')}\n";
        //TObject2::CleanAllObjects();
        flush();
				if( $this->GetMemoryRun() ) {
					return true;
				}
				if( $this->GetTimeRun() ) {
					return true;
				}


      }
    }







    $MaxRetry = Site()->Config( 'job.task_retry_delete.count', 3 );

    # task #10097

    $Filter = array(
      'Filter' => array(
        'Retrymax' => 0
      )
    );
    if( task::Filter($Filter)->Count ){
      $Sql = "UPDATE `task` SET `retry_max` = {$MaxRetry} WHERE `retry_max` != {$MaxRetry}";
      DB::Select($Sql);
      echo "Выставялем Максимальное Колво попыток в {$MaxRetry} у ". task::Filter($Filter)->Count ." приборов\n";
      echo $Sql . "\n";
    }else{
      echo "Выставялем у всех приборов выставлено верно\n";
    }


    /*
        Получаем такси которые превысили N кол-во попыток [ ОЖИДАЕТ ]
    */

    $arParams = Array(
      'Filter' => Array(
        'Taskstatus'  => $StatusStart->Id,
        'Retry >'     => $MaxRetry,
      ),
      'Order' => array(
        'Meter'       => 'ASC'
      ),
    );
    $arParams['Filter']['Limit'] = 3000;
    $arTasks = task::Filter( $arParams );
    echo "Задания опроса которые привысили {$MaxRetry} попыток выполнения: {$arTasks->Count} \n";
    $N = 0;

    foreach( $arTasks->GroupBy500->Elements as $arTasksG ){
      foreach( $arTasksG->Elements as $iTask ) {
      	$this->AddIteration();
          $iTask->Taskstatus = $StatusEnd;
          $iTask->Save();



        $N++;
          echo "{$N}. [M:{$iTask->Meter->Id}] Закрытие задачи{$iTask->Title} после {$iTask->Retry} попыток выполнения\n";
          if( $iTask->Meter->IsOk ) {
            echo "Статус прибора:{$iTask->Meter->Id} изменился на Есть проблемы\n";
            $LogText = "Есть ошибки, после {$iTask->Retry} попыток выполнения опроса {$iTask->Parameter->Title} за {$iTask->Year}-{$iTask->Month}-{$iTask->Day}:{$iTask->Hour}";
            echo "{$LogText}\n";
            $iTask->Meter->IsOk = array( false , $LogText );
          }

        flush();
				if( $this->GetMemoryRun() ) {
					return true;
				}
				if( $this->GetTimeRun() ) {
					return true;
				}

      }
    }









/*
    Получаем такси которые превысили N кол-во попыток со статусами  [ ВЫПОЛНЯЕТСЯ ] [ ВЫПОЛНЕНО ]
*/

		$MaxRetry = 25;
    $arParams = Array(
      'Filter' => Array(
        'Taskstatus' => array( $StatusStart->Id, $StatusWork->Id ),
        'Retry >' => $MaxRetry,

      ),
      'Order' => array(
        'Id'   => 'ASC'
      ),
    );
    $arTasks = task::Filter( $arParams );
    echo "Задачи которые числятся выполняющимися, более {$MaxRetry} попыток выполнения : {$arTasks->Count} \n";
    $arParams['Filter']['Limit'] = 1000;
    $arTasks = task::Filter( $arParams );
    foreach( $arTasks->GroupBy1000->Elements as $arTasksG ) {
      foreach( $arTasksG->Elements as $iTask )
      {
      	$this->AddIteration();
        $iTask->Taskstatus = $StatusEnd;
        $LogText = "Закрытие задачи[{$iTask->Id}] после {$iTask->Retry} попыток выполнения\n";
        echo $LogText;
        if( $iTask->Meter->IsOk )
        {
        	$LogText = "Статус прибора:{$iTask->Meter->Id} изменился на Есть проблемы\n";
          echo $LogText;
          $iTask->Meter->IsOk = array( false , $LogText );


        }

        flush();
				if( $this->GetMemoryRun() ) {
					return true;
				}
				if( $this->GetTimeRun() ) {
					return true;
				}

      }
    }







    // Удаление заданий, которые назначены на приборы исключенные для работы.
    $SQL = "SELECT `task`.* FROM `task`
    LEFT JOIN `meter` ON `task`.`meter_id`=`meter`.`id`
    LEFT JOIN `converter` ON `meter`.`converter_id`=`converter`.`id`
    WHERE (`meter`.`is_excluded`='1' OR `converter`.`is_excluded`='1') AND `task`.`taskstatus_id`=1";
    $Tasks = DB::Select( $SQL );

    echo "Задачи назначенные на приборы, которые исключены из опроса:";

    $StepExluded = 0;

 		while( $iTask = DB::FetchArray( $Tasks ) )
 		{
 			$this->AddIteration();
 			$StepExluded++;
      echo "\nИсключенное задание[{$iTask['id']}] ({$iTask['year']}-{$iTask['month']}-{$iTask['day']} {$iTask['hour']}:00) c {$iTask['retry']} попыток выполнения на приборе[{$iTask['meter_id']}]";
      DB::Query( "DELETE FROM `task` WHERE `id`='{$iTask['id']}'" );


// 			break;

			flush();
		  if( $this->GetMemoryRun() ) {
	  		return true;
		  }
	  	if( $this->GetTimeRun() ) {
	  		return true;
	  	}

 		}

 		if( !$StepExluded ){
 		  echo " 0 ";
 		}


    return true;
  }
}
