<?php

class job_taskduplicate extends Jobs
{
  function getTitle()
  {
    return "Дубликаты заданий";
  }
  
  function getDescription()
  {
    return "Удаление дубликатов заданий.";
  }

  function GetTasksCount() {
    $sql = "SELECT SQL_CALC_FOUND_ROWS `id` 
    FROM  `task` 
    GROUP BY  `meter_id` ,  `parameter_id` ,  `year` ,  `month` ,  `day` ,  `hour` 
    HAVING COUNT( * ) >1 LIMIT 1";
    DB::Query( $sql );
    $sql = "SELECT FOUND_ROWS() as count";
    $res = DB::FetchArraySelect( $sql );
    return $res['count'];
  	
	}

  function Start()
  {
  
  	
  	
    /* delete duplicate tasks */
    
    $sql = "SELECT  `id` 
    FROM  `task` 
    GROUP BY  `meter_id` ,  `parameter_id` ,  `year` ,  `month` ,  `day` ,  `hour` 
    HAVING COUNT( * ) >1 LIMIT 1000";

    $rez = DB::Select( $sql );
    $n = 0;
    $max = 1000;
    while( $row = DB::FetchArray( $rez ) )
    {
    	$this->AddIteration();
      $n++;
      $iTask = task::Id( $row['id'] );
      echo "Удалено Задание: {$iTask->Id} Прибор: {$iTask->Meter->Id}\n";
      $iTask->Delete();
      
      if( $n == $max )
      {
        return true;
        die( "Задание очень много, выполнено {$max}\n" );
      }
      
      flush();
		  if( $this->GetMemoryRun() ) {
	  		return true;
		  }
	  	if( $this->GetTimeRun() ) {
	  		return true;
	  	}
		  	
    }
    /* END: delete duplicate tasks */
    

    return true;
  }
}

