<div class="panel panel-{if $iArchive.info}default{else}danger{/if}" id="panel_archive_{$i}">
    <div class="panel-heading"
        style="cursor:pointer;" 
          data-toggle="collapse" 
          data-parent="#accordion" 
          href="#archive_file_{$i}">
      <span class="file_name">{$iArchive.name}</span>    
      
      <div class="pull-right">
        {if $iArchive.info}
          <button class="btn btn-success btn-xs run_dump">{$smarty.config.upload_button|default:"Загрузить"}</button>
        {/if}
        <button class="btn btn-danger btn-xs droped_files"><i class="fa fa-times"></i></button>
      </div>
      
    </div>
    
    <div id="archive_file_{$i}"" class="panel-collapse collapse" aria-expanded="false" style="height: 0px;">
        <div class="panel-body">
          
          {if $iArchive.info}
          
          <table class="table">
            <tbody><tr>
              <td>{$smarty.config.upload_period|default:"Выгрузка за период"}</td>
              <td>
                <i class="fa fa-calendar"></i> {$iArchive.info->day_start}-{$iArchive.info->month_start}-{$iArchive.info->year_start} &nbsp;&nbsp;&nbsp;
                <i class="fa fa-calendar"></i> {$iArchive.info->day_stop}-{$iArchive.info->month_stop}-{$iArchive.info->year_stop}
              </td>
            </tr>
            <tr>
              <td>{$smarty.config.user|default:"Пользователь"}</td>
              <td>
                <i class="text-primary fa fa-user"></i>
                <a href="">
                  {$iArchive.info->user_login}
                </a>
              </td>
            </tr>
            <tr>
              <td>{$smarty.config.creating_date|default:"Дата создания"}</td>
              <td>
                {$iArchive.info->date_create|date_format:"%Y-%m-%d %H:%I:%S (%A)"}
              </td>
            </tr>
            <tr>
              <td>{$smarty.config.description|default:"Описание"}</td>
              <td>
                <pre>{$iArchive.info->description|default:"--"}</pre>
              </td>
            </tr>
          </tbody></table>
          
          
          <div class="text-center">
            <a href="/archive/{$iArchive.name}">
              <button class="btn btn-primary">
                <i class="fa  fa-download"></i>{$smarty.config.download_button|default:"Скачать"}
              </button>
            </a>
          </div>
          
        {else}
        
          <div class="alert alert-danger">{$smarty.config.error_invalid_archive|default:"Неверный архив"} <b>
            {if $iArchive.error == 'invalid year_start'}
              {$smarty.config.error_invalid_start_year|default:"Неверно задан год начала"}
            {elseif $iArchive.error == 'invalid year_stop'}
              {$smarty.config.error_invalid_end_year|default:"Неверно задан год конца"}
            {elseif $iArchive.error == 'invalid month_start'}
              {$smarty.config.error_invalid_start_month|default:"Неверно задан месяц начала"}
            {elseif $iArchive.error == 'invalid month_stop'}
              {$smarty.config.error_invalid_end_month|default:"Неверно задан месяц конца"}
            {elseif $iArchive.error == 'invalid day_start'}
              {$smarty.config.error_invalid_start_day|default:"Неверно задан день начала"}
            {elseif $iArchive.error == 'invalid day_stop'}
              {$smarty.config.error_invalid_end_day|default:"Неверно задан день конца"}
            {elseif $iArchive.error == 'invalid origin_name'}
              {$smarty.config.error_invalid_title|default:"Нет строки с названием"}
            {elseif $iArchive.error == 'invalid description'}
              {$smarty.config.error_invalid_desc|default:"Нет строки с описанием"}
            {elseif $iArchive.error == 'invalid user_login'}
              {$smarty.config.error_invalid_no_archive_creator|default:"Не нашли пользователя, кто создал архив"}
            {elseif $iArchive.error == 'invalid interprise'}
              {$smarty.config.error_invalid_no_user_info|default:"Не нашли общую информацию о пользователе"}
            {elseif $iArchive.error == 'invalid date_create'}
              {$smarty.config.error_invalid_no_create_date|default:"Не нашли дату создания"}
            {elseif $iArchive.error == 'invalid count_mdh'}
              {$smarty.config.error_invalid_no_archive_date|default:"Не нашли данных в архиве"}
            {elseif $iArchive.error == 'invalid delimiter'}
              {$smarty.config.error_invalid_no_field_separator|default:"Не нашли данные о разделителе полей"}
            {elseif $iArchive.error == 'invalid enclosure'}
              {$smarty.config.error_invalid_no_string_separator|default:"Не нашли данные о разделителе строковых значений"}
            {/if}
          </b> </div>
          
        {/if}
          
          
        </div>
    </div>
    
</div>