{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Converter"}
{else}
  {config_load file="ru_lang.conf" section="Converter"}
{/if}
<table class="table table-striped table-hover" >
  <thead>
    <tr>
      <th>{$smarty.config.converter_table_property|default:"Свойство"}</th>
      <th>{$smarty.config.converter_table_value|default:"Значение"}</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>{$smarty.config.modal_title|default:"Название"}</td>
      <td>{$oConverter->Title|escape}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_type|default:"Тип"}</td>
      <td>{$oConverter->GetType()->Title|escape}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_ip|default:"Ip"}</td>
      <td>{$oConverter->Ip}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_port|default:"Port"}</td>
      <td>{$oConverter->Port}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_login|default:"Логин"}</td>
      <td>{$oConverter->Login}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_password|default:"Пароль"}</td>
      <td>{$oConverter->Password}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_timeout_connect|default:"Время ожидания установки соединения"}</td>
      <td>{$oConverter->Timeoutconnect}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_timeout_receive|default:"Время ожидания ответа от прибора"}</td>
      <td>{$oConverter->Timeoutreceive}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_web_port|default:"Порт для Web интерфейса"}</td>
      <td>{$oConverter->Portcontrol}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_exclude_button|default:"Исключен из опроса"}</td>
      <td>
        {if $oConverter->IsExcluded eq true}
          {$smarty.config.is_excluded|default:"Исключен"}
        {else}
          {$smarty.config.is_not_exlcuded|default:"Участвует"}
        {/if}
      </td>
    </tr>
  </tbody>
</table>
