{extends file="layout/errors.layout.tpl"}
{block name="content"}
  <div class="row">
    <div class="col-lg-12">
      
      <h1 class="page-header">
        {$smarty.config.errors|default:"Ошибки"}
      </h1>
      
      <ol class="breadcrumb">
        <li><a href="/">{$smarty.config.breadcrumbs_main}</a></li>
        <li class="active">{$smarty.config.errors|default:"Ошибки"}</li>
      </ol>
    </div>
      
  </div>
  
  <div class="row">
    <div class="col-lg-12">
      
      {assign var=ConverterError value=0}
      
      {if $Site->ConverterErrors->Count}
        <table class="table table-striped table-bordered table-hover">
          <thead>
            <tr>
              <th>{$smarty.config.table_title|default:"Название"}</th>
              <th>{$smarty.config.table_excluded|default:"Исключено из опроса"}</th>
              <th>{$smarty.config.table_metereng_devices|default:"Приборов учета"}</th>
              <th>{$smarty.config.table_devices_with_errors|default:"С ошибками"}</th>
            </tr>
          </thead>
          <tbody>
            {foreach from=$Site->ConverterErrors->Elements item="iConverter"}
            
              {assign var="Meters" value=$iConverter->Meters->Count}
              {assign var="MetersError" value=$iConverter->MetersError->Count}
              
              {if !$Meters || !$MetersError}
                {continue}
              {/if}
              
              {assign var=ConverterError value=$ConverterError+1}
            
              <tr>
                <td>
                  {include 
                      file="converter/helpers/block_name.tpl"
                      oConverter=$iConverter
                  }
                </td>
                <td>
                  {if $iConverter->IsExcludedTitle eq 'Усавствует'}
                    {$samrty.config.is_not_exlcuded|default:'Участвует'}
                  {else}
                    {$smarty.config.is_excluded|default:'Исключен'}
                  {/if}
                </td>
                <td>
                  {$Meters}
                </td>
                <td>
                  {$MetersError}
                </td>
              </tr>
            {/foreach}
            
            {if !$ConverterError}
              <tr>
                <td colspan="6">
                  {$smarty.config.table_no_items|default:"У вас есть конверторы, видимо на них нет приборов учета."}
                </td>
              </tr>
            {/if}
            
          </tbody>
        </table>
      {else}
        <div class="alert alert-success">
          {$smarty.config.no_errors|default:"В системе нет ошибок"}
        </div>
      {/if}
    </div>
  </div>
{/block}