{extends file="layout/excluded_meters.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          
          <h1 class="page-header">
            {$smarty.config.excluded_meters|default:"Исключенные приборы учета"}
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$smarty.config.excluded_meters|default:"Исключенные приборы учета"}</li>
          </ol>
          
      </div>
  </div>
  
  <div class="row">
    <div class="col-lg-12">

      {if $Site->MeterExcluded->Count}
      <table class="table table-striped table-bordered table-hover">
        <thead>
          <tr>
            <th>{$smarty.config.table_title|default:"Название"}</th>
          </tr>
        </thead>
        <tbody>
          {foreach from=$Site->MeterExcluded->Elements item="iMeter"}
          
            {assign var="prefix" value=""}
            {if $iMeter->IsVirtual}
              {assign var="prefix" value="v"}
            {elseif $iMeter->IsCalc}
              {assign var="prefix" value="c"}
            {/if}
            {assign var="file" value=$prefix|cat:"meter/helpers/block_name.tpl"}
          
            <tr>
              <td>
                {include file=$file oMeter=$iMeter}
              </td>
            </tr>
          {/foreach}
        </tbody>
      </table>
      {else}
        <div class="alert alert-success">
          {$smarty.config.no_excluded|default:"Все приборы работают"}
        </div>
      {/if}
    </div>
  </div>
{/block}