{*
    Какие пользователи входят в группу
*}

<table id="list_users_table" class="table table-striped table-bordered table-hover">
  {if $oGroup->Users->count}
  <thead>
    <tr>
      <th class="action"></th>
      <th>{$Site->Config('ru.group.name')}</th>
    </tr>
  </thead>
  {/if}
  <tbody>
    {foreach from=$oGroup->Users->Elements item="iGroupUsers"}
      <tr id="groupuser_{$iGroupUsers->Id}">
        <td class="action delete_link">
          <a href="{$iGroupUsers->LinkDel}">
            {include file="helpers/delete_icon_table.tpl"}
          </a>
        </td>
        <td>
          {include file="user/helpers/block_name.tpl" oUser=$iGroupUsers->User}
        </td>
      </tr>
    {foreachelse}
      <tr>
        <td colspan="3">
          {$Site->Config('ru.group.not_users')}
        </td>
      </tr>
    {/foreach}
    <tr>
      <td id="add_to_group">
        {include file="helpers/add_icon_table.tpl"}
      </td>
    </tr>
  </tbody>
</table>