{assign var="not_require" value=true}
{extends file="layout/imeter.layout.tpl"}
{block name="content"}


	<h1 class="page-header">
    {$smarty.config.vconverters|defaulr:'Счетчики импульсов'}
  </h1>

  <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:'Главная'}</a></li>
            <li class="active">{$smarty.config.meters|default:'Приборы учета'}</li>
          </ol>

 
	<div class="row">
			
		<div class="col-lg-9">

			<div class="panel panel-default">
	      <div class="panel-heading">
	        {$smarty.config.felter_header|default:'Фильтр'}
	      </div>
	      <div class="panel-body">

	      	<div class="row">
				      		<div class="col-lg-8">
							
												<div class="list-group">
								                {$smarty.config.filter_by_type|default:'По типу прибора'}
										            <div class="list-group" id="metertypes_change_container"></div>
										            <div class="panel-footer">
										                <select class="form-control" id="metertype_container">
										                	{foreach from=$Site->MeterExtraTypes->Elements item=iMetertype}
										                		<option value="{$iMetertype->Id}">{$iMetertype->Title}</option>
										                	{/foreach}
										                </select>
										            </div>
								        </div>

						      </div>
	      					<div class="col-lg-4">


								        <div class="list-group">
								            <div class="">
								                {$smarty.config.filter_by_status|default:'По статусу'}
								            </div>
								            <div class="list-group" id="is_ok_container">
								                <span class="list-group-item">
								                    {$smarty.config.filter_is_ok|default:'Исправен'}
								                    <input type="checkbox" value="1" class="pull-right" checked/>
								                </span>
								                <span class="list-group-item">
								                    {$smarty.config.filter_is_not_ok|default:'С проблемами'}
								                    <input type="checkbox" value="0" class="pull-right" checked/>
								                </span>
								            </div>

								    </div>

			 						</div>

						</div>
				</div>
			</div>

		</div>
		<div class="col-lg-3">
			<div class="panel panel-default">
	      <div class="panel-heading">
	        {$smarty.config.action_header|default:'Действия'}
	      </div>
	      <div class="list-group" id="actions_meters"></div>
			</div>
		</div>
	</div>

	<script type="text/template" id="actions_meters_tpl">
		<a href="#" id="delete_meters" class="list-group-item<% if( meters.length == 0 ){ %> disabled <% } %>">
        {$smarty.config.action_delete|default:'Удалить'}
    </a>
    <a href="#" id="excluded_meters" class="list-group-item<% if( meters.length == 0 ){ %> disabled <% } %>">
        {$smarty.config.action_exclude|default:'Исключить'}
    </a>
	</script>

	<div class="row">
			
			<div class="col-lg-12 table-responsive">
				
				<table class="table">
						<thead>
								<tr>
										<th><input type="checkbox" id="check_all"/></th>
										<th></th>
										<th></th>
										<th></th>
										<th>{$smarty.config.table_title|default:'Название'}</th>
										<th>{$smarty.config.table_type|default:'Тип прибора'}</th>
										<th>{$smarty.config.vconverter|default:'Счетчик импульсов'}</th>
										<th>{$smarty.config.table_serial_number|default:'Серийный номер'}</th>
										<th>{$smarty.config.table_status|default:'Состояние'}</th>
								</tr>
						</thead>
						<tbody id="meters">
						</tbody>
						<tfoot>
							<tr>
								<td class="action" colspan="100">
			            <a href="#" id="converter_add_meter" class="fa fa-plus-circle"></a>
			          </td>
							</tr>
						</tfoot>
				</table>
			</div>
	</div>

	<div class="row">
	    <div class="col-lg-12" id="pagination"></div>
	  </div>

	<script type="text/template" id="pagination_tpl">
		<% if( pages.length > 1 ){ %>
		<ul class="pagination paginator_pages">
			<% _.each( pages , function( page , i ){ %>
				<li <% if( active_page == page || i > pages.length - 1){ %>class="active"<%}%>><a href="#"><%= page %></a></li> 
			<% }) %>
    </ul>
    <% } %>
    <ul class="pagination paginator_counter pull-right">
      <li class="disabled">
        <a>{$smarty.config.pagginataon_view_by|default:'Показывать по'} :</a>
      </li>
      <!-- <li><a href="?page=1&amp;count=all">Все</a></li> -->
      <li <% if( active_count == "10" ){ %>class="active"<% } %>><a href="#">10</a></li>
	    <li <% if( active_count == "50" ){ %>class="active"<% } %>><a href="#">50</a></li>
	    <li <% if( active_count == "100" ){ %>class="active"<% } %>><a href="#">100</a></li>
	    <li <% if( active_count == "500" ){ %>class="active"<% } %>><a href="#">500</a></li>
	    <li <% if( active_count == "1000" ){ %>class="active"<% } %>><a href="#">1000</a></li>
	    <li <% if( active_count == "all" ){ %>class="active"<% } %>><a href="#">{$smarty.config.paggination_all|default:'Все'}</a></li>
    </ul>
	</script>

	<script type="text/template" id="metertypes_change_container_tpl">
		<% _.each( selected , function( s ){ %>
			<span class="list-group-item" data-id="<%= s.get('id') %>">
	        <%= s.get('title') %>
	        <a href="#" class="pull-right fa fa-times text-danger"></a>
	    </span>
		<% }) %>
	</script>

	<script type="text/template" id="metertype_container_tpl">
		<option>{$smarty.config.filter_add_to|default:"--Добавить в фильтр--"}</option>
		<% _.each( selected , function( s ){ %>
			<option value="<%= s.get('id') %>"><%= s.get('title') %></option>
		<% }) %>
	</script>



	<script type="text/template" id="meters_tpl">
		<% _.each( imeters , function( imeter ){ %>
			<tr id="<%= imeter.cid %>">

				<% 

					// Получаем привязанный прибор учета

					var real_meter = real_meters_collection.findWhere({ id : imeter.get('meter') });
					if( typeof real_meter == "undefined" ){
						var real_meter = new METER_MODEL()
					} 

				%>

				<td>
					<input type="checkbox">
				</td>
				<td>
					<i class="fa fa-copy pull-right" style="vertical-align:top;cursor:pointer;"></i>
				</td>
				<td>
					<i class="fa fa-times pull-right" style="vertical-align:top;cursor:pointer;"></i>
				</td>
				<td>
					<i class="fa fa-pencil pull-right" style="vertical-align:top;cursor:pointer;"></i>
				</td>
				<td>
					<a href="/meter/<%= imeter.get('id') %>/">
						<% 

							// Иконка 

							var icon = "fa fa-flash";

							if( typeof meter_extra_types != "undefined" ){

								var finded_e_type = meter_extra_types.findWhere( { id : imeter.get('type') } )

								if( typeof finded_e_type != "undefined" ){

									switch( finded_e_type.get('ident') ){
										case "AquaCounter" :
											icon = "fa fa-flash";
										break;
										case "HeatCounter" :
											icon = "fa fa-thermometer-full";
										break;
									}

								}

							}

							// Статус иконки
							var status_icon = "text-danger";
							if( imeter.get('is_ok') ){
								status_icon = "text-success"
							}

						%>
						<i class="<%= icon %> fa-fw <%= status_icon %>"></i>
						<%= imeter.escape('about') %>
					</a>
				</td>
				<td></td>
				<td>
					<a href="/meter/<%= real_meter.get('id') %>/">

						<% 

							// Статус иконки
							var status_icon = "text-danger";
							if( imeter.get('is_ok') ){
								status_icon = "text-success"
							}

						%>
						<i class="fa fa-sitemap fa-fw <%= status_icon %>"></i>

						<%= real_meter.get('about') %>
					</a>
				</td>
				<td><%= imeter.escape('num_serial') %></td>
				<td>

					<%

						status_title = "%>{$smarty.config.status_not_ok|default:'Есть проблемы'}<%"
						if( imeter.get('is_ok') ){
							status_title = "%>{$smarty.config.status_ok|default:'Исправен'}<%"
						}

					%>

					<%= status_title %>
				</td>
			</tr>
		<% }) %>
	</script>


	<script id="device_delete_modal" type="text/template">
	  <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	      <div class="modal-dialog danger">
	          <div class="modal-content">
	              <div class="modal-header" style="    background-color: #d9534f;
	    color: #fff;
	    border-radius: 5px 5px 0 0;">
	                  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
	                  <h4 class="modal-title">
	                   {$smarty.config.modal_delete_header|default:'Вы уверены, что хотите удалить'}
	                  </h4>
	              </div>
	              <div class="modal-footer">
	                  <button type="button" class="btn btn-default" data-dismiss="modal">
	                    {$smarty.config.modal_delete_close|default:'Закрыть'}
	                  </button>
	                  <button type="button" class="btn btn-danger" id="delete">
	                    {$smarty.config.modal_delete_accept|default:'Удалить'}
	                  </button>
	              </div>
	          </div>
	      </div>
	  </div>
	</script>

	<script type="text/template" id="meter_edit_add">
		<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
	    <div class="modal-dialog">
	        <div class="modal-content">
	            <div class="modal-header">
	                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
	                <h4 class="modal-title" id="myModalLabel">
	                  {$smarty.config.modal_head_edit|default:'Редактирование'} <i class="text-danger fa fa-flash"></i>
	                </h4>
	            </div>
	            <div class="modal-body">
	              <div class="row">
			  					<div class="col-lg-12" id="main_meter_set">
			  
								    <form name="mf" action="" method="post" enctype="multipart/form-data">

						          <div class="form-group ">
					              <label class="control-label">{$smarty.config.vconverter|default:'Счетчик импульсов'}</label>

					              <%

					              	var impuls_counter = meters_collection.findWhere({ id : meter.get('meter') })

					              	var real_meter = meters_collection.findWhere({ 
					              		id : meter.get('meter') 
					              	});
													if( typeof real_meter == "undefined" ){
														var real_meter = new METER_MODEL()
													}

					              %>


					              <% if( impuls_counter.get('id') ){ %>
					              	<br/>
					              	<a href="/meter/<%= real_meter.get('id') %>/">
					              		<i class="fa fa-flash fa-fw text-success"></i>
					              		<%= real_meter.escape('about') %>
					              	</a>
					              <% }else{ %>
					              	<select id="meter_parent" size="1" class="form-control" <% if( meter.get('id')){ %>disabled<% } %>>
							      				<option value="0">- Выбор -</option>
							      				{foreach from=$Site->MetersImpulses->Elements item=iMeter}
							      					<option value="{$iMeter->Id}" 
							      						{literal}<% if( Number(meter.get('meter_id')) == {/literal}{$iMeter->Id}{literal} ){%>selected<%}%>{/literal}
							      						data-count_input="{$iMeter->CountInputs}"
							      						>
							      						{$iMeter->Title}
							      					</option>
							      				{/foreach}
							    				</select>
					              <% } %>
						          </div>  
						          

						          <div class="form-group ">
					              <label class="control-label">Вход 
					              	<% if( impuls_counter.get('id') ){ %>
					              	<%=  meter.get('meterparameter')
				              					.vparameter.ident
				              					.replace(/COUNT_([0-9]*)/g , function(_ , c){
				              					return c
				              				}) 
				              		%>
					              	<% } %>
					              </label>
					              <% if( !impuls_counter.get('id') ){ %>
					              	<div id="count_chanels"></div>
					              <% } %>
						          </div>  

						          <div class="form-group ">
					              <label class="control-label">Тип прибора</label>
				              	<select  size="1" class="form-control" id="meter_type">
						      				<option value="0">- Выбор -</option>
						      				{foreach from=$Site->MeterExtraTypes->Elements item=iMeterExtraType}
						      					<option value="{$iMeterExtraType->Id}"
						      						{literal}<% if( Number(meter.get('meter_extra_type_id')) == {/literal}{$iMeterExtraType->Id}{literal} ){%>selected<%}%>{/literal}>
						      						{$iMeterExtraType->Title}
						      					</option>
						      				{/foreach}
						    				</select>
						          </div>  

			      
			          					                    
						          <div class=" form-group ">
						            <label class="control-label">{$smarty.config.modal_about|default:'Название'}<sup>*</sup></label>
						            <input 
						              class="form-control" 
						              type="text" 
						              value="<%= meter.get('about') %>" id="about_meter"/>
						          </div>  
						          <div class=" form-group ">
						            <label class="control-label">{$smarty.config.modal_serial|default:'Серийный номер устройства'}<sup>*</sup></label>
						            <input 
						              class="form-control" 
						              type="text" 
						              id="num_serial_form" 
						              value="<%= meter.get('num_serial') %>" />
						          </div>  
			          	
							          <div class=" form-group ">
							            <label class="control-label">{$smarty.config.modal_timezone|default:'Часовой пояс'}</label>
													<select  size="1" 
													id="timezone_id" 
													class="form-control">
							      				<option value="0">{$smarty.config.modal_select|default:'-Выбор-'}</option>
														{foreach from=$Site->Timezones->Elements item=iTimezone}
									          <option 
									          	value="{$iTimezone->Id}" 
									          	{literal}<% if( Number(real_meter.get('timezone')) == {/literal}{$iTimezone->Id}{literal} ){%>selected<%}%>{/literal}>{$iTimezone->Title}</option>
							      				{/foreach}
							    				</select>
							          </div>  

								        <label class="control-label">{$smarty.config.modal_first_check|default:'Дата первичной поверки'}</label>
								        <div class="form-group">
								            <input type="date" 
								            id="fate_first_verification" 
								            class="form-control" 
								            value="<%= meter.escape('first_date_verification') %>" 
								            >
								        </div>

								        <label class="control-label">{$smarty.config.modal_interval_check|default:'Интервал поверок (мес)'}</label>
								        <div class="form-group">
								          <input type="number" 
								          id="date_verification_interval" 
								          class="form-control" 
								          value="<%= meter.escape('interval_verification') %>" 
								          >
								        </div>


								        <label class="control-label">{$smarty.config.modal_plomb|default:'Номер пломбы'}</label>
								        <div class="form-group">
								          <input type="number" id="number_plomb" class="form-control" 
								          value="<%= meter.escape('number_plomb') %>" 
								          >
								        </div>

									  
			      					<p class="text-warning"></p>
			    					</form>
			    
			  					</div>
			  					<div class="col-lg-6" id="helper_add_meter" style="display:none;"></div>
								</div>
			        </div>
			        <div class="modal-footer">
	              <button type="button" class="btn btn-default" data-dismiss="modal">
	                {$smarty.config.modal_close_button|default:'Закрыть'}
	              </button>
	              <button type="button" class="btn btn-success" id="save_meter">
	                {$smarty.config.modal_save_button|default:'Сохранить'}
	              </button>
			        </div>
			      </div>
			    </div>
			</div>
	</script>


	<script type="text/template" id="count_chanels_tpl">
		<select  size="1" class="form-control" id="converter_select">
				<option value="0">{$smarty.config.modal_select|default:'-Выбор-'}</option>
				<% for( i = 0 ; i < count ; i++ ){ %>
					<option value="0"><%= i+1 %></option>
				<% } %>
		</select>
	</script>

	<script type="text/javascript" src="/js2/models/imeter_type.js"></script>
	<script type="text/javascript" src="/js2/models/meter_extra_type.js"></script>
	<script type="text/javascript" src="/js2/models/meter.js"></script>
	<script type="text/javascript" src="/js2/collections/meter.js"></script>
	<script type="text/javascript" src="/js2/collections/meter_extra_type.js"></script>
	<script type="text/javascript" src="/js2/models/imeter.js"></script>
	<script type="text/javascript" src="/js2/collections/imeter.js"></script>
	<script type="text/javascript" src="/js2/views/imeter/modal_edit_add.js"></script>
	<script type="text/javascript" src="/js2/views/imeter/list.js"></script>

{/block}
