{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Log"}
{else}
  {config_load file="ru_lang.conf" section="Log"}
{/if}
{if $new|count || $old|count}
  <table class="table">
    <thead>
      <tr>
        <th></th>
        <th>{$smarty.config.old_value|default:"Ст. значение"}</th>
        <th>{$smarty.config.new_value|default:"Нов. значение"}</th>
      </tr>
    </thead>

    {if $oObject->Is && $valid_object && $class == 'meter'}
    
      {assign var="Class" value=$class|ucfirst}
      {assign var="o"|cat:$Class value=$oObject}
      {if file_exists($class|cat:"/helpers/block_name.tpl") }
        Объект : {include file=$class|cat:"/helpers/block_name.tpl"}
      {/if}
    {/if}
    
    {foreach from=$new item=value key=Ident}
    
      <tr>
        <td><strong>{$Ident}</strong></td>
        <td>
          {if isset($old) && isset($old.$Ident)}
            {if $old.$Ident|is_object}
              {if $old.$Ident->Is }
                {$old.$Ident->Title|escape}
              {else}
                <i 
                class="fa fa-warning text-danger" 
                title="
По какой то причине мы не можем показать это поле.
Это не ошибка, но лучше сообщить администратору."
              ></i>
              {/if}
            {else}
              {$old.$Ident|escape}
            {/if}
          {/if}
        </td>
        <td>
          {if $value|is_object}
            {if !$valid_object}
              <i 
                class="fa fa-warning text-danger" 
                title="
По какой то причине мы не можем показать это поле.
Это не ошибка, но лучше сообщить администратору."
              ></i>
            {else}
              {$value->Title|escape}
            {/if}
          {else}
            {$value|escape}
          {/if}
        </td>
      </tr>
      
    {/foreach}
  </table>
{/if}