<p class="h4 text-info"> Adaptive data rate</p>

<div class="form-group">
    <div class="form-group input-def">
      <label class="control-label" for="enable_server_adr">Enable server ADR</label>
      <label class="label toggle">
        <input type="checkbox" class="toggle_input" id="enable_server_adr" <% if( lora_device.get('serverAdrEnable')){ %>checked<% } %> )>
        <div class="toggle-control"></div>
      </label>
    </div>
</div>
<div class="form-group">
    <label>Preferred data rate </label>
    <select class="form-control" id="preferred_data_rate">
        <% _.each( _.range( 0 , 5 , 1 ) , function( num ){ %>
            <option value="<%= num %>" <% if( lora_device.get('preferDr') == num ){ %>selected<% } %>>DR<%= num %></option>
        <% }) %>
    </select>
</div>

<div class="form-group">
    <label>Preferred transmit power</label>
    <select class="form-control "  id="preferred_transmit_power">
        <% _.each( [14, 11, 8, 5, 2] , function( num ){ %>
            <option value="<%= num %>" <% if( lora_device.get('preferPower') == num ){ %>selected<% } %>><%= num %> dBm</option>
        <% }) %>
    </select>
</div>