<div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title">
          {$smarty.config.modal_add|default:"Добавление базовой станции"}
        </h4>
      </div>
      <div class="modal-body">


        <div class="form-group">
          <div id="ip_label"></div>
          <input class="form-control" type="text" id="ip_lora" 
          value="<%= lora_model.escape('ip') %>"
          placeholder="15.16.150.32">
        </div>
        <div class="form-group">
          <div id="port_label"></div>
          <input class="form-control" type="text" id="port_lora" 
          value="<%= lora_model.escape('port') %>"
          placeholder="8081">
        </div>
        <div class="form-group ">
          <label class="control-label">{$smarty.config.modal_login|default:"Логин"}</label>
          <input class="form-control" type="text" value="<%= lora_model.escape('login') %>" id="login_lora"
          placeholder="admin">
        </div>  
        <div class="form-group ">
          <label class="control-label">{$smarty.config.modal_password|default:"Пароль"}</label>
          <input class="form-control" type="text" value="<%= lora_model.escape('pass') %>"  id="pass_lora"
          placeholder="admin"
          >
        </div>  
        <div class="form-group ">
          <label class="control-label">{$smarty.config.modal_title|default:"Название"}</label>
          <input class="form-control" type="text" value="<%= lora_model.escape('about') %>" id="about_lora"
          placeholder="{$smarty.config.modal_title_placeholder|default:"Базовая станция 1"}">
        </div> 







      </div>
      <div class="modal-footer">

        <!-- Контейнер для отчета теста соединения -->
        <div id="footer_modal_lora"></div>

        <!-- Контейнеры с результатами теста соединения -->
        <div id="lora_test_connect_success" class="hide">
          <div class="alert alert-success text-left">
            {$smarty.config.modal_test_connect_success|default:"Соединение успешно установлено"}
          </div>
        </div>
        <div id="lora_test_connect_error" class="hide">
          <div class="alert alert-danger text-left">
            {$smarty.config.modal_test_connect_error|default:"Ошибка установки соединения"}
          </div>
        </div>
        <div id="lora_test_auth_success" class="hide">
          <div class="alert alert-success text-left">
            {$smarty.config.modal_test_auth_success|default:"Авторизация прошла успешно"}
          </div>
        </div>
        <div id="lora_test_auth_error" class="hide">
          <div class="alert alert-danger text-left">
            {$smarty.config.modal_test_auth_error|default:"Ошибка авторизации"}
          </div>
        </div>
        <div id="lora_test_connect_wait" class="hide">
          <div class="alert alert-info text-left">
            {$smarty.config.modal_test_connect_wait|default:"Ожидание..."}
          </div>
        </div>

        <button type="button" class="btn btn-default" data-dismiss="modal">
          {$smarty.config.modal_button_close|default:"Закрыть"}
        </button>
        <button type="button" class="btn btn-disabled" id="test">
          {$smarty.config.modal_button_check_connect|default:"Проверить соединение"}
        </button>
        <button type="button" class="btn btn-disabled" id="test_auth">
          {$smarty.config.modal_button_check_auth|default:"Проверить авторизацию"}
        </button>
        <button type="button" class="btn btn-disabled" id="save">
          {$smarty.config.modal_button_save|default:"Сохранить"}
        </button>
      </div>
    </div>
  </div>
</div>