<div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title">
          {$smarty.config.gateway_modal_head|default:"Добавление базовой станции"}
        </h4>
      </div>
      <div class="modal-body">

        <div class="row">

          <div class="col-lg-7">
            <div class="form-group">
              <label id="Gateway_ID_label">{$smarty.config.gateway_modal_id|default:"Id Шлюза"}*</label>
              <input id="Gateway_ID_input" type="text" class="form-control" placeholder="{$smarty.config.gateway_modal_id|default:"Id Шлюза"}" title="{$smarty.config.gateway_modal_id|default:"Id Шлюза"}"  
              value="<%= gataway.get('gatewayId') %>" 
              maxlength="16">
            </div>
          </div>
          <div class="col-lg-5">

            <div class="form-group">
              <label>{$smarty.config.gateway_modal_tx|default:"TX Канал"}</label>
              <select id="downlinkChannel" class="form-control" placeholder="{$smarty.config.gateway_modal_tx|default:"TX Канал"}" title="{$smarty.config.gateway_modal_tx|default:"TX Канал"}">
                <% _.each( _.range( 0, 10 , 1 ) , function( num ){ %>
                <option value="<%= num %>"
                  <% if( gataway.get('downlinkChannel') == num ){ %>selected<% } %>
                  ><%= num %></option>
                  <% }) %>
                </select>
              </div>
            </div>

          </div>

          <div class="form-group">
            <label>{$smarty.config.gateway_modal_transmit_power|default:"Мощность передачи"}</label>
            <input type="text" id="maxPower" class="form-control" placeholder="{$smarty.config.gateway_modal_transmit_power|default:"Мощность передачи"}" title="{$smarty.config.gateway_modal_transmit_power|default:"Мощность передачи"}"  
            value="<%= gataway.get('maxPower') %>"
            maxlength="16">
          </div>


          <div class="row">

            <div class="col-lg-3">
              <div class="form-group ">
                <label class="control-label">{$smarty.config.gateway_modal_rx|default:"Только прием"}</label>
                <label class="label toggle">
                  <input type="checkbox" class="toggle_input" id="rxOnly"
                  <% if( gataway.get('rxOnly') ){ %> checked <% } %>
                  >
                  <div class="toggle-control"></div>
                </label>
              </div>
            </div>

            <div class="col-lg-9">
              <div class="form-group">
                <label>{$smarty.config.gateway_modal_companion_gateway|default:"Companion Gateway"}</label>
                <input type="text" id="companionGateway" class="form-control" placeholder="{$smarty.config.gateway_modal_companion_gateway|default:"Companion Gateway"}" title="{$smarty.config.gateway_modal_companion_gateway|default:"Companion Gateway"}" 
                <% if( !gataway.get('rxOnly') ){ %> disabled <% } %> 
                value="<%= gataway.get('companionGateway') %>"
                maxlength="16">
              </div>
            </div>

          </div>

          <div class="form-group">
            <label>{$smarty.config.gateway_modal_comment|default:"Комментарий"}</label>
            <textarea class="form-control" id="extraInfo" placeholder="{$smarty.config.gateway_modal_comment|default:"Комментарий"}" title="{$smarty.config.gateway_modal_comment|default:"Комментарий"}"
            value="<%= gataway.get('extraInfo') %>"
            ><%= gataway.get('extraInfo') %></textarea>
          </div>


          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">
              {$smarty.config.gateway_modal_close_button|default:"Закрыть"}
            </button>
            <button type="button" class="btn btn-disabled" id="save">
              {$smarty.config.gateway_modal_save_button|default:"Сохранить"}
            </button>
          </div>
        </div>
      </div>
    </div>