{*
    Для построения дерева надо иметь:
    Все связи vegametertype чтобы показывать кокой тип у прибора на данный момент
    Все типы vegatype чтобы показывать какие типы можно выбрать если не выбран
    Все нисинхронизированные приборы учета чтобы с ними выполнять какие то действия
    Модель БС чтобы на нее привязывать приборы + с нее выполняются все запросы
*}

<% _.each( devices , function( device ){ %>

  <% 
      var type_obj = device_types.findWhere({ devEui : device.get('devEui') });
  %>
  <tr id="<%= device.cid %>" class="success">
    <td>
      <% if( !device.get('sync_status') ){ %>
        <% if( type_obj.get('device_type') != "" ){ %>
          <input type="checkbox" <% if( typeof checked.get( device.cid ) != "undefined" ){ %>checked<% } %> />
        <% } %>
      <% }else{ %>
        Готово
      <% } %>
    </td>
    <td>
      <%= device.get('devName') %> 
    </td>
    <td>
      <%= device.get('devEui') %> 
    </td>
    <td <% if( typeof type_obj.get('device_type') ){ %>class="has-error"<% } %>>
      <% var type = types.findWhere({ id : Number( type_obj.get('device_type') ) })%>
      <% if( type_obj.get('device_type') == "" || typeof type == "undefined" ){ %>
        <select class="form-control">
          <option value="0">Нет</option>
          <% _.each( types.toArray() , function( deviceType ){ %>
          <option value="<%= deviceType.get('id') %>" 
            <% if( Number(type_obj.id) == deviceType.get('id') ){ %>
            selected
            <% } %>
            ><%= deviceType.get('name') %></option>
            <% }) %>
        </select>
      <% }else{ %>
          <%= type.get('name') %>
      <% } %>

    </td>
  </tr>
<% }) %>

<% _.each( rm_devices , function( device ){ %>
  <tr id="<%= device.cid %>"  class="danger">
    <td>
      <input type="checkbox" <% if( typeof checked.get( device.cid ) != "undefined" ){ %>checked<% } %> />
    </td>
    <td>
      <%= device.get('about') %> 
    </td>
    <td>
      <%= device.get('num_serial') %> 
    </td>

    <td></td>
    
  </tr>
<% }) %>