{extends file="layout/mail.layout.tpl"}
{block name="content"}
  
  <div id="mail_modal_edit">
        
        <br><br>
        <fieldset  >
          <legend>
            <button class="btn-circle btn-success btn">
              <i class="fa fa-check"></i>
            </button>
            {$smarty.config.modal_main_settings|default:'Основные настройки'}
            <button class="pull-right btn btn-default btn-xs">
              <i class="fa fa-caret-down"></i>
            </button>
          </legend>
          
          <div class="form-group">
              <label>{$smarty.config.modal_title|default:'Название'}</label>
              <input class="form-control">
          </div>
          
          <div class="form-group list-group">
              <label>{$smarty.config.modal_to_send|default:'Кому'}</label>
              <a href="#" class="list-group-item">
                  vip.karamba@bk.ru
                  <span class="pull-right text-muted small fa fa-times  ">
                  </span>
              </a>
              <a href="#" class="list-group-item">
                  vip.karamba@bk.ru
                  <span class="pull-right text-muted small fa fa-times  ">
                  </span>
              </a>
              <a href="/mail/add/" class=" list-group-item fa fa-plus-circle text-muted"></a>
          </div>
          
        </fieldset>
        
        
        
        <fieldset>
          <legend>
            {$smarty.config.modal_select_time|default:'Выбор времени'}
            <button class="pull-right btn btn-default btn-xs">
              <i class="fa fa-caret-up"></i>
            </button>
          </legend>
          
          <div class="form-group list-group">
              <a href="#" class="list-group-item">
                  {$smarty.config.modal_time_every_hour|default:'Каждый час'}
              </a>
              <a href="#" class="list-group-item">
                  {$smarty.config.modal_time_manual|default:'Выбрать вручную'}
                  
                  <div class="clockpicker" data-placement="left" data-align="top" data-autoclose="true">
                      <input type="text" class="form-control" value="13:14">
                      <span class="input-group-addon">
                          <span class="glyphicon glyphicon-time"></span>
                      </span>
                  </div>
                  <script src="/js/core/clockpicker.js"></script>
                  <script type="text/javascript">
                  {literal}
                    $('.clockpicker').clockpicker();
                  {/literal}
                  </script>
                  
              </a>
          </div>
          
        </fieldset>
        
        
        
        
        
        <fieldset>
          <legend>
            {$smarty.config.modal_select_date|default:'Выбор даты'}
            <button class="pull-right btn btn-default btn-xs">
              <i class="fa fa-caret-up"></i>
            </button>
          </legend>
          
          <div class="form-group list-group">
              <a href="#" class="list-group-item">
                  {$smarty.config.modal_days_every_day|default:'Каждый день'}
              </a>
              <a href="#" class="list-group-item">
                  {$smarty.config.modal_time_manual|default:'Выбрать вручную'}
                  <script src="/js/core/bootstrap-datepicker.min.js"></script>
                      <div id="sandbox-container">
                        <div></div>
                      </div>
                  <script type="text/javascript">
                  {literal}
                    $('#sandbox-container div').datepicker({
                        format: "dd/mm/yyyy",
                        maxViewMode: 0,
                        todayBtn: "linked",
                        language: "ru",
                        orientation: "bottom right",
                        multidate: true,
                        multidateSeparator: ",",
                        calendarWeeks: true,
                        autoclose: true,
                        todayHighlight: true
                    });
                  {/literal}
                  </script>
                  
              </a>
          </div>
          
        </fieldset>
        
        
        
        
        
        <fieldset>
          <legend>
            {$smarty.config.modal_select_place|default:'Выбор объектов'}
            <button class="pull-right btn btn-default btn-xs">
              <i class="fa fa-caret-up"></i>
            </button>
          </legend>
          
          <ul class="nav nav-tabs">
              <li class="active"><a href="#home" data-toggle="tab">{$smarty.config.tab_places|default:'Объекты'}</a>
              </li>
              <li><a href="#profile" data-toggle="tab">{$smarty.config.tab_converters|default:'Узлы учета'}</a>
              </li>
          </ul>
          
        </fieldset>
        
        <br><br>
        
        
        <button class="btn btn-success">{$smarty.config.modal_save_button|default:'Сохранить'}</button>
  
        
        
  </div>
  
{/block}