{assign var="not_require" value=true}
{extends file="layout/meter.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.meter|default:"Прибор учета"} {$oMeter->Title|escape} 
            {include file="helpers/log_btn.tpl" oObject=$oMeter}
          </h1>
          
          
          <ol class="breadcrumb">
            <li><a href="/">
                {$smarty.config.breadcrumbs_main|default:"Главная"}
            </a></li>
            <li>
              {include file="converter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
            </li>
            <li class="active">{$oMeter->Title|escape}</li>
          </ol>
          
          
      </div>
  </div>
  
  {include file="meter/helpers/main_info.tpl"}
  
  {include file="meter/helpers/tabs.tpl" Active_tab="graphs"}
  
  <br>
  
  <div class="row" id="main_block_graphs">
    <div class="col-lg-8">
      {include file="meter/helpers/graph_container.tpl"}
    </div>
    <div class="col-lg-4">
      {include file="meter/helpers/graph_list.tpl"}
    </div>
  </div>


  <script type="text/javascript" src="/js/force_data.js"></script>
  <script type="text/javascript" src="/js2/models/meter.js"></script>
  <script>
    var meter = new METER_MODEL({ id : {$oMeter->Id} });
  </script>
  <script type="text/javascript" src="/js2/views/meter/action.js"></script>
  <!-- Включаем график -->
  <script>
    var graph_data = "{$smarty.config.graph_data|default:'График потребления энергии за '}"
    var no_graph_data = "{$smarty.config.no_graph_data|default:'Нет данных для построения графика'}"
    var graph_in = "{$smarty.config.graph_in|default:'За'}"
    var graph_hour = "{$smarty.config.graph_hour|default:'час'}"
  </script>
  <script type="text/javascript" src="/js/core/hightstock.js"></script>
  <script type="text/javascript" src="/js2/models/meterdatahour.js"></script>
  <script type="text/javascript" src="/js2/collections/meterdatahour.js"></script>
  <script type="text/javascript" src="/js2/views/meter/graphs.js"></script>
  <script>
    $(document).ready(function(){
      $('#force_data').removeClass('btn-disabled disable_div_mini').addClass('btn-info')
    })
  </script>

  <script id="change_graph_meter_body_tpl" type="text/template">
    <% _.each(all_parameters.toArray() , function( parameter ){ %>
      <a href="#" class="list-group-item
      <% if( active_parameters.findWhere({ id : parameter.get('id') }) ){ %>active<% } %>
      " id="<%= parameter.cid %>">
        <span class="fa fa-sliders"></span> <%= parameter.escape('title') %>
      </a>
    <% }) %>
  </script>

  <script id="change_graph_meter" type="text/template">
      <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
          <div class="modal-dialog danger">
              <div class="modal-content">
                  <div class="modal-header">
                    {$smarty.config.modal_graphics_settings|default:"Настройка отображения параметров"}
                  </div>
                  <div class="modal-body list-group" id="change_graph_meter_body"></div>
                  <div class="modal-footer">
                      <button type="button" class="btn btn-default" data-dismiss="modal">
                        {$smarty.config.modal_tabs_close_button|default:"Закрыть"}
                      </button>
                      <button type="button" class="btn btn-primary" id="save">
                        {$smarty.config.modal_tabs_save_button|default:"Сохранить"}
                      </button>
                  </div>
              </div>
          </div>
      </div>
    </script>


{/block}
