{if $oMeter->ActiveParametersData->Elements|@count}

  <div class="table-responsive">
    <table class="table table-striped table-bordered table-hover" id="tablesorter">

      <thead>
        {include file="parameter/head.tpl" HeadRows=$ParameterHead}
      </thead>
      <tbody>
        {foreach from=$oMeter->DateList item=iDate}

          <tr>

            <td style="white-space:nowrap;">
              {$iDate->getTimestamp()|date_format:$oMeter->FormatSmarty}
            </td>

            {foreach from=$oMeter->ActiveParametersData->Elements item="iParameter"}
                {assign var=oMDH value=$oMeter->GetMDH($iParameter,$iDate)}
              {if $iParameter->UseCoef && $oMeter->Coef > 1}
                <td>
                  {if is_object($oMDH)}
                    {include file="meterdatahour/helpers/meter_format.tpl" oMDH=$oMDH usingCoef=true}
                  {else}
                    {$oMDH}
                  {/if}
                </td>
              {else}
                <td style="white-space:nowrap;">
                  {if is_object($oMDH)}
                    {include file="meterdatahour/helpers/meter_format.tpl" oMDH=$oMDH}
                  {else}
                    {$oMDH}
                  {/if}
                </td>
              {/if}
            {/foreach}
          </tr>
        {/foreach}

        <tfoot>
          <tr>
            <th>{$smarty.config.meter_tabs_group|default:"Группировка"}</th>
          {foreach from=$oMeter->ActiveParametersData->Elements item="iParameter"}
            {assign var=oMDH value=$oMeter->GetGroupMDH($iParameter)}
            {if $iParameter->UseCoef && $oMeter->Coef > 1}
              <th>
                {include file="meterdatahour/helpers/meter_format.tpl" oMDH=$oMDH usingCoef=true}
              </th>
            {else}
              <th>
                {include file="meterdatahour/helpers/meter_format.tpl" oMDH=$oMDH}
              </th>
            {/if}
          {/foreach}
          </tr>
        </tfoot>
      </tbody>
    </table>
    </div>
  {else}
    <div class="alert alert-warning">{$smarty.config.meter_tabs_no_params|default:"Нет параметров"}</div>
    <button class="btn btn-info container_data_table_edit_parameters">{$smarty.config.meter_tabs_settings|default:"Настроить"}</dutton>
  {/if}
{if $oMeter->CountRetry}
  <button type="submit" name="getUndefinedData" class="btn btn-info">{$smarty.config.meter_tabs_request_data|default:"Запросить данные"}</button>
{/if}
