{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Meter"}
{else}
  {config_load file="ru_lang.conf" section="Meter"}
{/if}
<table class="table table-striped table-hover">
  <thead>
    <tr>
      <th>{$smarty.config.meter_table_property|default:"Свойство"}</th>
      <th>{$smarty.config.meter_table_value|default:"Значение"}</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <td>{$smarty.config.table_title|default:"Название"}</td>
      <td>{$oMeter->Title|escape}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_serial_number|default:"Серийный номер"}</td>
      <td>{$oMeter->NumSerial}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_bus_number|default:"Опросный номер"}</td>
      <td>{$oMeter->Num485}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_converter|default:"Точка опроса"}</td>
      <td>
        {include file="converter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
      </td>
    </tr>
    <tr>
      <td>{$smarty.config.table_tasks_waiting|default:"Заданий ожидает"}</td>
      <td>{$oMeter->_CountTaskWaiting}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_task_performed|default:"Заданий выполняется"}</td>
      <td>{$oMeter->_CountTaskRunning}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_timezone|default:"Часовой пояс"}</td>
      <td>{$oMeter->Timezone->Title|escape}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_time_on_device|default:"Время на приборе"}</td>
      <td>{$oMeter->DateTitle}</td>
    </tr>
    {*<tr>
      <td>Статус</td>
      <td>{$oMeter->IsOkTitle}</td>
    </tr>
    <tr>
      <td>Исключен</td>
      <td>{$oMeter->IsExcludedTitle}</td>
    </tr>*}
    <tr>
      <td>{$smarty.config.table_time_diff|default:"Разница времени"}</td>
      <td>{$oMeter->TimeDiff}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_model|default:"Модель"}</td>
      <td>{$oMeter->Model->Title}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_mark|default:"Марка"}</td>
      <td>{$oMeter->Model->Mark->Title}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_manufacturer|default:"Производитель"}</td>
      <td>{$oMeter->Model->Mark->Manufacturer->Title}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_first_check|default:"Дата первичной поверки"}</td>
      <td>{$oMeter->FirstVerification}</td>
    </tr>
    <tr>
      <td>{$smarty.config.table_next_check|default:"Следующая поверка"}</td>
      <td>{$oMeter->NextVerification}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_interval_check|default:"Интервал поверок (мес)"}</td>
      <td>{$oMeter->VerificationInterval}</td>
    </tr>
    <tr>
      <td>{$smarty.config.modal_plomb|default:"Номер пломбы"}</td>
      <td>{$oMeter->NumberPlomb->Data}</td>
    </tr>
  </tbody>
</table>
