{assign var=not_require value=1}
{extends file="layout/meter.layout.tpl"}
{block name="content"}

  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.meter|default:"Прибор учета"} <span class="container_h1_meter">{$oMeter->Title|escape}</span> 
            {include file="helpers/log_btn.tpl" oObject=$oMeter}
          </h1>
          
          
          <ol class="breadcrumb">
            <li><a href="/">
              {$smarty.config.breadcrumbs_main|default:"Главная"}
              </a></li>
            <li>
              {include file="converter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
            </li>
            <li class="active">{$oMeter->Title|escape}</li>
          </ol>
          
      </div>
  </div>
  
  <div class="row">
    <div class="col-lg-6 table-responsive" id="container_meter_info"></div>
    <div class="col-lg-6 table-responsive">
        <div class="row">
        <div class="col-lg-12">
            {include file="meter/helpers/sys_info.tpl"}
        </div>
        </div>
    </div>
    </div>
  
  {* {include file="meter/helpers/tabs.tpl" Active_tab="values"} *}
  
  <br>
  <div class="row">
    <div class="col-lg-12">
      {include file="meter/helpers/navigation_date.tpl"}
      <div class="panel panel-default">
        <div class="panel-heading">
          Данные
          {if $Self->isAdmin}
            {include file="meter/helpers/edit_table_data_parameters.tpl"}
          {/if}
        </div>
        <div class="panel-body" id="meter_data">
          {include file="meter/helpers/data.tpl"}
        </div>
      </div>
    </div>
  </div>


  
<script type="text/template" id="lora_add_tpl">
  {include file="lorawan/helper/edit_add_form.tpl"}
</script>

<script type="text/template" id="lora_meters_tpl">
  {include file="lorawan/helper/lora_children.tpl"}
</script>

<script type="text/template" id="lora_counter_add_edit">
  {include file="lorawan/helper/lora_add_edit_counter.tpl"}
</script>

<script type="text/template" id="activation_by_pers_tpl">
  {include file="lorawan/helper/activation_by_pers.tpl"}
</script>

<script type="text/template" id="over_the_air_tpl">
  {include file="lorawan/helper/over_the_air.tpl"}
</script>

<script type="text/template" id="main_settings_tpl">
  {include file="lorawan/helper/main_settings.tpl"}
</script>

<script type="text/template" id="regional_settings_tpl">
  {include file="lorawan/helper/regional_settings.tpl"}
</script>

<script type="text/template" id="class_c_settings_tpl">
  {include file="lorawan/helper/class_c_settings.tpl"}
</script>

<script type="text/template" id="device_rx_settings_tpl">
  {include file="lorawan/helper/device_rx_settings.tpl"}
</script>

<script type="text/template" id="meter_main_info_tpl">
  {include file="meter/helpers/main_info_js.tpl"}
</script>

<script type="text/template" id="adaptive_settings_tpl">
  {include file="lorawan/helper/adaptive_data_rate.tpl"}
</script>


<script type="text/javascript" src="/ts/models/meter.js"></script>
<script type="text/javascript" src="/ts/models/lora_converter.js"></script>
<script type="text/javascript" src="/ts/models/lora_device.js"></script>
<script type="text/javascript" src="/ts/models/meter_type.js"></script>
<script type="text/javascript" src="/ts/collections/meter_types.js"></script>
<script type="text/javascript" src="/ts/models/lora_type.js"></script>
<script type="text/javascript" src="/ts/models/lora_device_type.js"></script>
<script type="text/javascript" src="/ts/collections/lora_device_types.js"></script>
<script type="text/javascript" src="/ts/collections/lora_types.js"></script>
<script type="text/javascript" src="/ts/views/lora/meter_modal_edit.js"></script>


<script>
    var meter = new METER_MODEL({
        id : {$oMeter->Id},
        num_serial : {$oMeter->NumSerial},
    });
    var base_station = new LORA_CONVERTER({ id: 
    {$oMeter->Converter->Id},
    about: "{$oMeter->Converter->About}",
    ip: "{$oMeter->Converter->Ip}",
    port: {$oMeter->Converter->Port},
    type: {$oMeter->Converter->Type->Id},
    login: "{$oMeter->Converter->Login}",
    pass: "{$oMeter->Converter->Password}" 
    })
</script>


<script type="text/javascript" src="/ts/views/lora/meter.js"></script>




{/block}
