{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Meter"}
{else}
  {config_load file="ru_lang.conf" section="Meter"}
{/if}
<div class="modal fade" id="force_data_modal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="myModalLabel">
                  {$smarty.config.force_data|default:"Горячий опрос"}
                  {include file="meter/helpers/block_name.tpl"}
                  <div class="progress">
                    <div class="progress-bar progress-bar-striped active" role="progressbar"
                    aria-valuenow="100" aria-valuemin="0" aria-valuemax="100" style="width:100%">
                    </div>
                  </div>
                </h4>
            </div>
            <div class="modal-body" style="max-height: 500px;
    overflow-y: auto;">
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">
                  {$smarty.config.modal_close_button|default:"Закрыть"}
                </button>
            </div>
        </div>
        <!-- /.modal-content -->
        
        
        <script type="text/template" id="force_data_success_tpl">
          <div class="table-responsive">
            <table class="table table-striped table-bordered table-hover disable_div_mini" id="CurData">
              <thead>
                <tr>
                  <th>{$smarty.config.forve_data_parameter|default:"Параметр"}</th>
                  <th>{$smarty.config.forve_data_value|default:"forve_data_value"}</th>
                  <th>{$smarty.config.forve_data_status|default:"Статус"}</th>
                </tr>
              </thead>
              <tbody>
              </tbody>
            </table>
          </div>
        </script>

        <script type="text/template" id="force_data_value_tpl">
          <tr>
            <td><i class="{$Site->Config('icon.parameter')}"></i> <%= row.param %></td>
            <td><%= row.value %></td>
            <td><%= row.status %></td>
          </tr>
        </script>
        
        
        <script type="text/template" id="force_data_error_send_tpl">
          <tr class="danger"><td colspan="100">
          {$smarty.config.forve_data_error_request|default:"Ошибка выполнения запроса"}
          </td></tr>
        </script>
        
        
        <script type="text/template" id="force_data_values_not_success_tpl">
          <tr class="danger"><td colspan="100">
          {$smarty.config.forve_data_error_no_data|default:"Данные от приложения не получены"}
          </td></tr>
        </script>
        
        <script type="text/template" id="force_data_get_result_tpl">
          <tr class="danger"><td colspan="100"><%= result %></td></tr>
        </script>
        
        <script type="text/template" id="not_lib_tpl">
          <tr class="danger"><td colspan="100">
          {$smarty.config.forve_data_error_no_lib|default:"Нет библиотеки для обработки"}
          </td></tr>
        </script>
        
        
        
        <script type="text/template" id="please_wait_tpl">
          <tr class="danger"><td colspan="100">
          {$smarty.config.forve_data_error_later|default:"Уже идет опрос. Попробуйте позже."}
          </td></tr>
        </script>
        
    </div>
    <!-- /.modal-dialog -->
</div>

