<div class="modal fade" id="place_modal_children" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title" id="myModalLabel">
          <% if( place.get('id') ){ %>
          {$smarty.config.edit_item|default:"Редактирование"}
          <% }else{ %>
          {$smarty.config.add_item|default:"Добавление дочернего элемента в"} <b><%= place_parent.escape('title') %></b>
          <% } %>
        </h4>
      </div>
      <div class="modal-body">

        <div class="progress hide">
          <div class="progress-bar progress-bar-striped active" role="progressbar"
          aria-valuenow="40" aria-valuemin="0" aria-valuemax="100">
          </div>
        </div>

        <form>


          <div class="form-group ">
            <label class="control-label">
              {$smarty.config.place_type|default:"Тип объекта"}<sup>*</sup>
            </label>

            <select size="1" id="place_change_type" class="form-control">
              {foreach from=$Site->Placetypes->Elements item=iType}
                <option value="{$iType->Id}" <% if( place.get('type') == {$iType->Id}){literal}{{/literal}%>selected<% {literal}}{/literal} %>>
                        {$iType->Title}
                </option>
              {/foreach}
            </select>
          </div>


          <div class="form-group " id="place_form_title">
            <label class="control-label">
              {$smarty.config.place_name|default:"Назвaние"}<sup>*</sup>
            </label>

            <input 
              class="form-control" 
              type="text" 
              name="Title" 
              value="<%= place.escape('title') %>"
              placeholder="Название объекта">
          </div>  
            
          <div class="form-group" id="place_bankbook" <% if( place.get('type') != 2 ){ %>style="display:none;"<% } %> >
            <label class="control-label">
              {$smarty.config.bank_book|default:"Номер лицевого счета"}<sup>*</sup>
            </label>

            <input 
            class="form-control" 
            type="text" 
            name="BankBook" 
            value="<%= place.escape('bankbook') %>"
            placeholder="{$smarty.config.bank_book|default:"Номер лицевого счета"}">
          </div>

          <div id="place_kvartira_fields" style="display:none;">
            <div class="form-group">
              <label class="control-label">
                {$smarty.config.name_template|default:"Шаблон названий"}
              </label>

              <input 
              class="form-control" 
              type="text" 
              name="template" 
              value="Квартира №"
              placeholder="Шаблон префикса">
            </div>

            <div class="form-group">
              <label class="control-label">
                Кол-во объектов
              </label>

              <input 
              class="form-control" 
              type="number" 
              name="count_places" 
              value="0"
              placeholder="">
            </div>

            <div id="template_place_view"></div>

          </div>

        </form>

    </div>
    <div class="modal-footer">
      <div class="main_buttons">
        <button type="button" class="btn btn-default" data-dismiss="modal">
          {$smarty.config.close_button|default:"Закрыть"}
        </button>
        <button 
          type="button" 
          class="btn btn-success" 
          id="add_children">
          {literal}<% if( !place.get('id') ){ %>{/literal}
          {$smarty.config.add_button|default:"Добавить"}
          {literal}<% }else{ %>{/literal}
          {$smarty.config.edit_button|default:"Редактировать"}
          {literal}<% } %>{/literal}
        </button>
      </div>
      <div class="preloader" style="text-align: center;display:none;">
        <img src="/img/loader.gif" style="height: 10px;">
      </div>
    </div>
  </div>
</div>
</div>