{if $user_lang eq 'ru'}
  {config_load file="ru_lang.conf" section="Meter"}
{else}
  {config_load file="en_lang.conf" section="Meter"}
{/if}
<div>
  <div class="modal fade" id="filterParameterData" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
      <div class="modal-dialog">
          <div class="modal-content">
              <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                  <h4 class="modal-title" id="myModalLabel">{$smarty.config.modal_tabs_head|default:"Фильтры параметров данных"}</h4>
              </div>
              <div class="modal-body list-group">
                
                <button class="btn btn-warning" id="deselect_all">
                  {$smarty.config.modal_tabs_remove_all|default:"Снять все"}
                </button>
                <button class="btn btn-info" id="select_all">
                  {$smarty.config.modal_tabs_select_all|default:"Выделить все"}
                </button>
                
                <br><br>
                
                <div class="hide progress"><div class="progress-bar progress-bar-success"></div></div>
                {assign var=ActiveFilter value=$oPlace->FilterParameter}
                <div id="sortable">
                  {assign var=ParametersInFilter value=$ActiveFilter->GetParameters()}
                  {foreach from=$ParametersInFilter->Elements item=iParameterIn}
                    {assign var=iParameter value=$iParameterIn->Parameter}
                    <a 
                      id="parameter_filter_{$iParameter->Id}"
                      class="list-group-item active">
                      {include file="parameter/helpers/block_name.tpl" oParameter=$iParameter}
                      <i class="fa fa-database pull-right"></i>
                    </a>
                  {/foreach}
                  {foreach from=$oPlace->AllParameters->Elements item=iParameter}
                    {assign var=isset_parameter value=false}
                    {foreach from=$ParametersInFilter->Elements item=iParameterIn}
                      {if $iParameterIn->Parameter->Id == $iParameter->Id}
                        {assign var=isset_parameter value=true}
                      {/if}
                    {/foreach}
                    {if $isset_parameter}
                      {continue}
                    {/if}
                    <a 
                      id="parameter_filter_{$iParameter->Id}"
                      class="list-group-item">
                      {include file="parameter/helpers/block_name.tpl" oParameter=$iParameter}
                      <i class="hide fa fa-check pull-right"></i>
                    </a>
                  {/foreach}
                </div>
              </div>
              <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">
                    {$smarty.config.modal_tabs_close_button|default:"Закрыть"}
                  </button>
                  <button type="button" class="btn btn-success" id="save_filter">
                    {$smarty.config.modal_tabs_save_button|default:"Сохранить"}
                  </button>
              </div>
          </div>
          <!-- /.modal-content -->
      </div>
      <!-- /.modal-dialog -->
  </div>
</div>

