<?xml version="1.0" encoding='UTF-8' ?>
<!DOCTYPE place>
	<export type="place" title="{$oPlace->PathToUpString(' / ')}" date="{$oPlace->Date->format("Y-m-d")}">
	<parameters>
    {foreach from=$oPlace->ActiveParametersData->Elements item=iParameter}
		<{$iParameter->Ident} title="{$iParameter->Title|escape}"/>
    {/foreach}
	</parameters>
	<values type="meter">
    {foreach from=$oPlace->MeterPlaceByPage->Elements item=iMeterPlace key=i}
      {assign var="iMeter" value=$iMeterPlace.Meter}
      {assign var="iPlace" value=$iMeterPlace.Place}
    <meter serial="{$iMeter->NumSerial}" coef="{$iMeter->Coef}" title="{$iPlace->PathToUpString(' / ')}{$iMeter->Title|escape}">
      {foreach from=$oPlace->ActiveParametersData->Elements item=iParameter}
        {assign var=MDH value=$oPlace->GetArchive($iParameter,$iMeterPlace.Meter)}
        {assign var=useCoef value=($MDH->Meter->Coef > 1 && $MDH->Parameter->UseCoef)}
      <{$iParameter->Ident} value="{include file="meterdatahour/helpers/report_html.tpl" oMDH=$MDH usingCoef=$useCoef}" code="{$MDH->Loginfo->Logtext}" addtime="{$MDH->AddTime}"/>
      {/foreach}
    </meter>
    {/foreach}
	</values>
</export>