{extends file="layout/place.layout.tpl"}
{block name='content'}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.place|default:"Объект"} : {$oPlace->Title|escape}
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li><a href="/place/">{$smarty.config.places|default:"Объекты"}</a></li>
            {foreach from=$oPlace->ParentAll->Elements item=iPlace}
              <li>
                {include file="place/helpers/block_name.tpl" oPlace=$iPlace}
              </li>
            {/foreach}
            <li class="active">{$oPlace->Title|escape}</li>
          </ol>
          
      </div>
  </div>
  
  
  
  
  <div class="btn-group">
    <a href="{$oPlace->Link}" title="{$smarty.config.view_to_list|default:"Посмотреть в виде списка"}">
      <button type="button" class="btn btn-default">
        <span class="fa fa-align-justify"></span>
      </button>
    </a>
  </div>
  
  
  {include file="place/helpers/children_tree.tpl" oPlace=$oPlace}
{/block}
