<?xml version="1.0" encoding='UTF-8' ?>
<export date="{$Site->GetDateServer()->format("Y-m-d")}">
  <parameters>
    {foreach from=$Parameters->Elements item=Parameter}
      <{$Parameter->Ident} title="{$Parameter->Title}"/>
    {/foreach}
  </parameters>
  <values>
    {foreach from=$Meters->Elements item=iMeter}
    <meter serial="{$iMeter->NumSerial}" coef="{$iMeter->Coef}" title="{$iMeter->Title}">
      {foreach from=$Parameters->Elements item=Parameter}
        
        {assign var=oMDH value=$iMeter->GetMDHGroupByParameterRangeDate($Parameter,$start_date,$stop_date)}
        {assign var=Value value=$oMDH->Value}
        {assign var=divider value=$Parameter->Conversion->Divider|default:1}
        {assign var=Value value=$Value/$divider}
        {assign var=value value=$Value|number_format:{$Parameter->Conversion->Round}:".":""}
        
        {assign var=pid value=$Parameter->Id}
        {append var=Groups index=$pid value=$Groups.$pid+$value}
        <{$Parameter->Ident} value="{$value}"/>
      {/foreach}
    </meter>
    {/foreach}
  </values>
  <groups>
    {foreach from=$Parameters->Elements item=Parameter}{assign var=idParameter value=$Parameter->Id}
      {if isset($Groups.$idParameter)}
        <group parameter="{$Parameter->Ident}">{$Groups.$idParameter}</group>
      {/if}
    {/foreach}
  </groups>
</export>