<export date="{$Site->GetDateServer()->format("Y-m-d")}">
  <parameters>
    {foreach from=$Parameters->Elements item=Parameter}
      <{$Parameter->Ident} title="{$Parameter->Title}"/>
    {/foreach}
  </parameters>
  <values>
    {foreach from=$Places->Elements item=iPlace}
    <meter title="{$iPlace->GetBreadcrumbsParentToThisReports()}{$iPlace->Title|escape}">
      {foreach from=$Parameters->Elements item=Parameter}
        {assign var=oMDH value=$iPlace->GetMDHGroupByParameterRangeDate($Parameter,$start_date,$stop_date)}
        {assign var=Value value=$oMDH->Value}
        {assign var=divider value=$Parameter->Conversion->Divider|default:1}
        {assign var=Value value=$Value/$divider}
        {assign var=value value=$Value|number_format:{$Parameter->Conversion->Round}:".":""}
        <{$Parameter->Ident} value="{$value}"/>
        {assign var=pid value=$Parameter->Id}
        {append var=Groups index=$pid value=$Groups.$pid+$value}
      {/foreach}
    </meter>
    {/foreach}
  </values>
  <groups>
    {foreach from=$Parameters->Elements item=Parameter}{assign var=idParameter value=$Parameter->Id}
      {if isset($Groups.$idParameter)}
        <group parameter="{$Parameter->Ident}">{$Groups.$idParameter}</group>
      {/if}
    {/foreach}
  </groups>
</export>