<div id="res_table"></div>

<script type='text/template' id='table_changed_tpl'>
  <table class="table table-striped table-bordered table-hover">
    <thead>
      <th style="white-space:nowrap;">
        Объект /
        Действие
      </th>
      
      {*
        Группируем все действия по их действию
      *}
      
      <% Object.keys( _.groupBy( actions.where({ property : "" }) , function( item ){ return item.get('ident');  }) ).map(function( key ){ %>
        <th>
          <%= key %>
        </th>
      <% }) %> 
    </thead>
    <tbody>


    {*
      Группируем все действия по объектам
    *}
    
    <% Object.keys( _.groupBy( actions.where({ property : "" }) , function( item ){ return item.get('name');  }) ).map(function( object ){ %>
      <tr>
        <td>
          <% if( object === "Converter" ){ %>
            {$Site->Config("ru.converter")}
          <% }else if( object === "Place" ){ %>
            {$Site->Config("ru.place")}
          <% }else if( object === "Meter" ){ %>
            {$Site->Config("ru.meter")}
          <% }else if( object === "Rule" ){ %>
            {$Site->Config("ru.rule")}
          <% }else if( object === "User" ){ %>
            {$Site->Config("ru.user")}
          <% }else if( object === "Group" ){ %>
            {$Site->Config("ru.group")}
          <% } %>
        </td>
        
        <% Object.keys( _.groupBy( actions.where({ property : "" }) , function( item ){ return item.get('ident');  }) ).map(function( action ){ %>
        
          <% var action = actions.findWhere({ ident : action , name : object , property : "" }); %>
        
          <td class="text-center clicable">
            <% if( action ){ %>
              <% var patern = paterns.findWhere({ id : action.id }); %>
              <div class="btn-group" id="<%= action.cid %>" >
                <button type="button" class="yes btn btn-<% if( patern ){ %>success<% }else{ %>default<% } %>">Да</button>
                <button type="button" class="no btn btn-<% if( !patern ){ %>danger<% }else{ %>default<% } %>">Нет</button>
              </div>
            <% }else{ %>
              --
            <% } %>
          </td>
        <% }) %> 
        
      </tr>
    <% }) %> 


    </tbody>
  </table>
  
  <% if( is_btn ){ %>
    <button class="btn btn-primary" id="save_rule">{$Site->Config('ru.sys.save')}</button>
  <% } %>
  
</script>
