{extends file="layout/vconverter.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$Site->Config('ru.meter')} <span class="container_h1_meter">
              {$oMeter->Title|escape}</span> 
            {include file="helpers/log_btn.tpl" oObject=$oMeter}
          </h1>
          
          
          <ol class="breadcrumb">
            <li><a href="/">Главная</a></li>
            <li>
              {include file="vconverter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
            </li>
            <li class="active">{$oMeter->Title|escape}</li>
          </ol>
          
          
      </div>
  </div>
  
  
  <div class="row">
    <div class="col-lg-6">
    <div class="panel panel-default table-responsive"  id="container_meter_info">
      <div class="panel-heading">
        Свойства
        {if $Self->IsAdmin}
          <i class=" pull-right fa fa-pencil block_meter_edit" style="cursor:pointer;"></i>
        {/if}
      </div>
      <div class="panel-body">
        <div class="table-responsive">
          {include file="vmeter/helpers/info.tpl"}
        </div>
      </div>
    </div>
  </div>
  <div class="col-lg-6 table-responsive" id="container_meter_info">
      {include file="vmeter/parameter/list.tpl"}
    </div>
  </div>
  
  
  {* include file="vmeter/helpers/tabs.tpl" *}
  
  <br>
  <div class="row">
    <div class="col-lg-12">
      {include file="vmeter/helpers/data.tpl"}
    </div>
  </div>
  
  <div class="row">
    <div class="col-lg-6">
      {include file="parameter/helpers/list.tpl"} 
    </div>
    <div class="col-lg-6">
        {include file="conversion/helpers/list.tpl"}
    </div>
  </div>
  
{/block}