#!/bin/sh

while read line ; do

    K=`echo $line | cut -d"=" -f1 | cut -d" " -f1`
    V=`echo $line | cut -d"=" -f2 | cut -d'"' -f2 | cut -d'"' -f1`

    case $K in
      "Ip" | "Dbhost")
        USER_CNF_HOST=$V
      ;;
      "Port" | "Dbport")
        USER_CNF_PORT=$V
      ;;
      "DBUser" | "Dblogin")
        USER_CNF_LOGIN=$V
      ;;
      "DBPass" | "Dbpass")
        USER_CNF_PASSWORD=$V
      ;;
      "DBName" | "Dbname")
        USER_CNF_DATABASE=$V
      ;;
    esac

done < $1
