<?php

include($_SERVER['DOCUMENT_ROOT']."/include/inc.php");
include(__DIR__ . "/to_json.php");


if( empty( $_POST ) ){
  $res = array();
  $Filter = array(
    'Filter' => array(
      'Id' => Self()->GetConvertersByRulePlaceIds()
    )
  );
  if( empty( $Filter['Filter']['Id'] ) ){
    unset($Filter['Filter']['Id']);
  }

  $Filter['Filter']['Type NOT IN'] = array(
    convertertype::FindByIdent('VIRTUAL')->Id , 
    convertertype::FindByIdent('CALC')->Id,
    convertertype::FindByIdent('VegaLora')->Id
  );

  if( isset( $_GET['field'] ) && isset( $_GET['sort'] ) ){

    $valid_vector_sort = true;

    switch( $_GET['sort'] ){
      case 'asc' :
        $sort = "ASC";
      break;
      case 'desc' :
        $sort = 'DESC';
      break;
      default :
        $valid_vector_sort = false;
      break;
    }

    if( $valid_vector_sort ){

      $valid_field_sort = true;

      switch( $_GET['field'] ){
        case "about" :
          $field_sort = "About";
        break;
        case "ip" :
          $field_sort = "Ip";
        break;
        case "port" :
          $field_sort = "Port";
        break;
        case "type" :
          $field_sort = "Type";
        break;
        default :
          $valid_field_sort = false;
        break;
      }

      if( $valid_field_sort ){
        $Filter['Order'] = array( $field_sort => $sort);
      }
    }
  }

  $Converters = converter::Filter( $Filter );


  if( isset( $_GET['page'] ) && isset($_GET['count']) ){
    $ConvertserList = $Converters->GroupBy((int)$_GET['count']);

    $page   = (int)$_GET['page'] - 1;
    $count  = (int)$_GET['count'];
    if( !$count ){
      $Converters = $Converters->Elements;
    }else{
      if( count( $Converters->GroupBy( $count )->Elements ) <= $page ){
        $page = count($ConvertserList->Elements) - 1;
      }
      if( !isset( $Converters->GroupBy( $count )->Elements[ $page ] ) ){
        $Converters = array();
      }else{
        $Converters = $Converters->GroupBy( $count )->Elements[ $page ]->Elements;
      }
    }
  }else{
    $Converters = $Converters->Elements;
  }

  foreach( $Converters as $iConverter ){
    $res[] = get_to_json( $iConverter , $iConverter->Type );
  }
  echo json_encode($res);
}elseif( isset($_POST['model']) ){
  $model = json_decode( $_POST['model'] );

  # добавление
  if( !$model->id ){
    
    $type = convertertype::Id( $model->type );
    
    if( !$type->Id ){
      echo "invalid type";
      die();
    }
    
    if( !$model->ip ){
      echo "invalid ip";
      die();
    }
    
    if( !$model->port ){
      echo "invalid port";
      die();
    }
    
    $A = array(
        'TypeId'          => $type->Id,
        'Ip'              => $model->ip,
        'Port'            => $model->port,
        'Login'           => $model->login,
        'Password'        => $model->pass,
        'About'           => $model->about,
        'IsExcluded'      => $model->excluded,
        'InUse'           => 1,
        'MeterOk'         => 0,
        'Timeoutconnect'  => $model->timeoutconnect,
        'Timeoutreceive'  => $model->timeoutreceive,
        'Portcontrol'     => $model->portcontrol
    );

    $converter = converter::AddByArray($A);
    
    echo json_encode( get_to_json( $converter , $converter->Type ) );
  }
}