<?php 

include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

header('Content-Type: application/json; charset=utf-8');

function to_json( &$oObject , $callback_even = null ){
  
  $fields = array();
  if( isset( $oObject->FieldsToJSON ) ){
    $fields = $oObject->FieldsToJSON;
  }  
  
  $res = array();

  foreach( $fields as $F => $f ){

    switch( $f ){
        case 'conversion' :
        case 'lvl1' :
        case 'lvl2' :
        case 'lvl3' :
        case 'lvl4' :
            continue 2;
        break;
    }

    if( is_object( $oObject->$F ) ){
      $res[ $f ] = (int) $oObject->$F->Id;
      continue;
    }
    
    $v = $oObject->$F;
    
    if( isset( $oObject::$FInit[$F] ) ){
      switch( $oObject::$FInit[$F]['type'] ){
        case 'id':
        case 'int' :
           $v = (int) $v;
        break;
      }
    }
    $res[ $f ] = $v;
  }
  
  if($callback_even) $res = $callback_even( $oObject , $res );
  
  return $res;
}

if( !Self()->Is ){
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    Site()->GoToAuth();
  }else{
    echo "404"; 
    return false;
  }
}

$oMeter = meter::Id( isset($_GET['id']) ? (int) $_GET['id'] : 0 );

$active = isset($_GET['active']) ? (bool) $_GET['active'] : false;

$active_parameters = array();
$res = array();

$Filter = array(
    'Filter' => array(
        'Metertype' => $oMeter->Type->Id
    )
);
foreach( graphics::Filter($Filter)->Elements as $iParameter_Filter ){
    $active_parameters[$iParameter_Filter->Parameter->Id] = to_json($iParameter_Filter->Parameter);    
}

if( $active ){
    $res = $active_parameters;
}else{
    $Filter = array(
        'Filter' => array(
            'Metertype' => $oMeter->Type->Id
        )
    );
    foreach (metertypeparameter::Filter($Filter)->Elements as $iMetertypeparameter) {
        $res[$iMetertypeparameter->Parameter->Id] = to_json($iMetertypeparameter->Parameter);
    }
}


echo json_encode(array_values($res));