<?php

include( $_SERVER['DOCUMENT_ROOT'] . "/include/inc.php" );

if( !isset( $_GET['page'] ) ){
	$_GET['page'] = 1;
}

$page = isset($_GET['page']) ? $_GET['page'] - 1 : 0;
$count = isset($_GET['count']) ? $_GET['count'] : 10;

header('Content-Type: application/json');


if( $page < 0 ){
	$page = 0;
}

$fields = isset($_GET['get_pages']) ? " count(*) as count " :"meter.id,
meter.about,
meter.num_serial,
meter.password,
meter.coef,
meter.timezone_id,
meter.num_485,
meter_type.id as meter_type_id,
meter_type.title as meter_type_title,
meter.converter_id as converter,
meter.is_ok,
meter.is_excluded,
meter.model_id as model,
model.title as model_title,
verification_meter.start as first_date_verification,
verification_meter.interval as interval_verification,
meter.type_id as type,
converter.about as converter_about,
converter.meter_ok";

$sql = Utils::Strip("
select 
{$fields}
from meter 
left join converter on converter.id = meter.converter_id 
left join meter_type on meter_type.id = meter.type_id 
left join model on meter.model_id = model.id 
left outer join verification_meter on verification_meter.meter_id = meter.id 
where meter.interprise = " . Self()->Interprise->Id) . " 
and meter.converter_id > 0 
and meter_type.dll_id not like '%CALC%'
and meter_type.dll_id not like '%CALCMETER%'
and meter_type.dll_id not like '%FILTER%'
and meter_type.dll_id not like '%VIRT%'";

if( !empty($_GET['types']) ){
	$sql .= " and meter.type_id in(" . implode(",",$_GET['types']) .")" ;
}

if( !empty($_GET['is_ok']) ){
	$sql .= " and meter.is_ok in(" . implode(",",$_GET['is_ok']) .")" ;
}

if( !empty($_GET['is_excluded']) ){
	$sql .= " and meter.is_excluded in(" . implode(",",$_GET['is_excluded']) .")" ;
}

if( count( Self()->GetConvertersByRulePlaceIds() ) ){
	$sql .= " and meter.converter_id in (".implode(",",Self()->GetConvertersByRulePlaceIds()).")";
}

if( !isset($_GET['get_pages']) && $_GET['count'] != "all" ){
	$sql .= " LIMIT ".($page*$count).",{$count}";
}

// echo $sql;

$res = DB::Select($sql );

if( isset($_GET['get_pages']) ){
if( $_GET['get_pages'] == "all" ){
	echo  1;die();
}
	$row = DB::Fetch($res);
	echo ceil( $row['count'] / $_GET['get_pages'] );
	die();
}

$ret = array();

while( $row = DB::Fetch($res) ){
  if(Self()->Lang != 'ru'){
    $row['model_title'] = Utils::cirilic_file_name($row['model_title']);
  }
	if( $row['model'] == 0 ){
		$row['model'] = metertype::Id($row['meter_type_id'])->Model->Id;
		$row['link'] = meter::Id($row['id'])->GetLink();
	}
	$row['number_plomb'] = meter::Id($row['id'])->NumberPlomb->Data;
	$ret[] = $row;
}

// var_dump(count($ret) );

if( count($ret) == 0 && $_GET['page'] != 0 ){
	$_GET['page'] = $_GET['page']-1;
	include(__FILE__);
}else{
	echo json_encode( $ret , JSON_UNESCAPED_UNICODE );
}
