<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

if( !Self()->Is ){
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    Site()->GoToAuth();
  }else{
    echo "404"; 
    return false;
  }
}

header('Content-Type: application/json; charset=utf-8');

$res = array();

  // var_dump(Self()->GetRulePlacesArray());
if( Self()->GetIsUser() && count(Self()->GetRulePlacesArray()) ){
}


$oPlace = place::Id( isset( $_GET['place'] ) ? (int) $_GET['place'] : 0 );

$Children = isset( $_GET['all'] ) ? $oPlace->GetChildren() : $oPlace->GetChildrenByPage();

if( !$oPlace->Is && isset( $_GET['jstree'] ) ){
  $res[] = array(
      "id"        => 0,
      "text"      => Self()->Interprise->Title,
      "children"  => (bool) $oPlace->Places->Count,
      "icon"      => Site()->Config('icon.place'),
      "parent"    => "#",
      "state"     => array(
          "opened"    => true,
          "selected"  => true
      )
  );
}


/**
 * Получение родителей
 */
if( isset( $_GET['id'] ) && isset( $_GET['parents'] ) ){
  $Children = place::Id( $_GET['id'] )->GetParentAll();
}

foreach( $Children->Elements as $iPlace ){
  if( isset( $_GET['jstree'] ) ){
    $res[] = array(
        "id"        => (int) $iPlace->Id,
        "text"      => $iPlace->Title,
        "children"  => (bool) $iPlace->GetChildren()->Count,
        "icon"      => Site()->Config('icon.place'),
        "parent"    => $iPlace->Place->Id,
        "a_attr"    => array( 
            "href" => $iPlace->GetLink(),
            "name" => "anchor_" . $iPlace->Id,
        )
    );
  }else{
    $res[] = array(
        "id"       => $iPlace->Id,
        "title"    => $iPlace->Title,
        "place"    => $iPlace->Place->Id,
        "type"     => $iPlace->Placetype->Id,
        "bankbook" => "",
        "meter_all"       => (int) $iPlace->GetMetersAll()->Count,
        "meter_error"     => (int) $iPlace->GetMetersErrorAll()->Count,
        "meter_excluded"  => (int) $iPlace->GetMetersExcludedAll()->Count,
        "places"          => (int) $iPlace->GetPlaceChildrenAll()->Count
    );
  }
}

echo json_encode( $res , JSON_UNESCAPED_UNICODE );