<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );

if( !Self()->Is ){
  if( !defined( "__PHPUNIT_PHAR__" ) ){
    Site()->GoToAuth();
  }else{
    echo "404"; 
    return false;
  }
}

header('Content-Type: application/json; charset=utf-8');

$oPlace = place::Id( (int) $_GET['id'] );

$a = array();

switch( Site()->API_Type() ){
  case "DELETE" :
    $oPlace->Delete();
    $oPlace = place::Id(0);
    break;
  case "POST":
    if( isset( $_POST['model'] ) ){
      $data = json_decode($_POST['model']);
      if( method_exists($data, 'id') ){
        if( !$data->id ){
          $oPlace = place::Id(0);
          if( !$data->place ){
            $Filter = array(
                'Filter' => array(
                    'Place' => 0
                )
            );
            $oPlace = place::Filter($Filter)->First;
          }
          
          $oPlace = place::AddByArray(array(
              'PlaceId' => $oPlace->Id,
              'Title' => $data->title,
              'TypeId' => $data->type,
              'BankBook' => $data->bankbook,
          ));
        }
      }else{
        // up
      }
    }
  case "PUT" :
    if( $oPlace->Is ){
      $oPlace->UpdateByArray( $oPlace->ReplaceByAPI() );
    }else{
      $oPlace = place::AddByArray( $oPlace->ReplaceByAPI() );
    }
    break;
}

if( isset( $_GET['jstree'] ) ){
  $res = array(
      "id"        => (int) $oPlace->Id,
      "text"      => $oPlace->Title,
      "children"  => (bool) $oPlace->GetChildren()->Count,
      "icon"      => Site()->Config('icon.place'),
      "parent"    => (int) $oPlace->Place->Id
  );
}else{
  $res = array(
      "id"       => $oPlace->Id,
      "title"    => $oPlace->Title,
      "place"    => $oPlace->Place->Id,
      "type"     => $oPlace->Placetype->Id,
      "bankbook" => $oPlace->GetBankBook()
  );
}

echo json_encode( $res , JSON_UNESCAPED_UNICODE );