<?php

if( empty( $_SERVER['DOCUMENT_ROOT'] ) ){
  $_SERVER['DOCUMENT_ROOT'] = __DIR__ ."/../";
}

ignore_user_abort(true);
header('Transfer-Encoding:chunked');
ob_flush();
flush();

set_time_limit(0);

$time_start = microtime(true); 


$delimiter = ";";
$enclosure = "\"";


header('Content-Encoding: UTF-8');
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );


if( !isset( $argv[1] ) ) die(11);
if( !isset( $argv[2] ) ) die(11);


$GLOBALS['FullRules'] = true;
$GLOBALS['Self'] = user::Id( $argv[2] );


$oArchive = archive::Id( $argv[1] );


if( !$oArchive->Id ) die(11);



function mem(){
  return memory_get_usage() / 1024 / 1024;
}



$oArchive->Status = 1;
$oArchive->Procent = 0;


if( !$oArchive->ArchiveMeters->Count ) die(11);

if( $oArchive->YearSt == 0 || $oArchive->YearSp == 0 ) die("year_invalid");
if( $oArchive->MonthSt == 0 || $oArchive->MonthSp == 0 ) die("month_invalid");
if( $oArchive->DaySt == 0 || $oArchive->DaySp == 0 ) die("day_invalid");


//~ echo "start mem:".mem()."\n";


$zip = new ZipArchive();
$filename = "./{$oArchive->Title}.zip";

if ($zip->open($filename, ZipArchive::CREATE)!==TRUE) {
    exit("Невозможно открыть <$filename>\n");
}


//~ echo "init_zip mem:".mem()."\n";



$shema_orm = array(
  'loginfo' => array(
    'Title' , 
    'Logtext'
  ),
  'metertype' => array(
    'Title',
    'DllId'
  ),
  'convertertype' => array(
    'Title',
    'DllId'
  ),
  'parameter' => array(
    'Title',
    'Ident'
  ),
  'meter' => array(
    'Converter',
    'Type',
    'Num485',
    'NumSerial',
    'Password',
    'Coef'
  ),
  'converter' => array(
    'Ip',
    'Port',
    'Login',
    'Password',
    'About'
  ),
  'meterdatahour' => array(
    'Meter',
    'Parameter',
    'Year',
    'Day',
    'Hour',
    'Value',
    'Loginfo',
    'AddTime',
  )
);



/*
  Создаем уникальый ключ по которому будем искать файлы
*/
$Uid =  (microtime(true) * 10000 ) . rand(11111,99999);


foreach( $shema_orm as $_class => $attrs ){
  
  if( $_class == 'meterdatahour' ) continue;
  
  
  $file = $Uid."." . $_class . ".csv";

  $fp = fopen( $file , 'w');
  
  $Filter = array('Filter' => array());
  
  switch( $_class ){
    case 'parameter' :
    case 'metertype' :
    case 'convertertype' :
      $Filter['Filter']['Interprise'] = 0;
      $Filter['Filter']['Enterprise'] = 0;
    break;
  }  

  foreach( $_class::All()->Elements as $iElem ){
    $row = array();
    foreach( $attrs as $Prop ){
      $Value = $iElem->$Prop;
      
      if( is_object( $Value ) ){
        $row[] =$Value->Id;
      }else{
        $row[] = $Value;
      }
    }
    
    fputcsv($fp, $row , $delimiter , $enclosure);
  }

  fclose($fp);
  
  $zip->addFile( "./".$file , "{$_class}.csv" );
  
}


//~ echo "first_write mem:".mem()."\n";




$arConverters = array();

$file = $Uid.".meter.csv";
$fp = fopen( $file , 'w');

foreach( $oArchive->ArchiveMeters->Elements as $iElem ){
  $row = array();
  foreach( $shema_orm['meter'] as $Prop ){
    
    $Value = $iElem->Meter->$Prop;
    
    $prefix = $Prop == "NumSerial" ? "'" : "";
    
    if( is_object( $Value ) ){
      $row[] =$prefix.$Value->Id;
    }else{
      $row[] = $prefix.$Value;
    }
  }
  fputcsv($fp, $row , $delimiter , $enclosure);;
  
  TObject2::CleanAllObjectsByClass( 'meter' );
  
  $arConverters[ $iElem->Meter->Converter->Id ] = $iElem->Meter->Converter->Id;
  
}

fclose($fp);
$zip->addFile( "./".$file , "meter.csv" );


//~ echo "meter_write mem:".mem()."\n";





$file = $Uid.".converter.csv";
$fp = fopen( $file , 'w');

$Filter = array( 
  'Filter' => array( 
    'Id' =>  $arConverters
));

foreach( converter::Filter($Filter)->Elements as $iElem ){
  $row = array();
  foreach( $shema_orm['converter'] as $Prop ){
    
    $Value = $iElem->$Prop;
    
    if( is_object( $Value ) ){
      $row[] =$Value->Id;
    }else{
      $row[] = $Value;
    }
  }
  
  fputcsv($fp, $row , $delimiter , $enclosure);
}

fclose($fp);
$zip->addFile( "./".$file , "converter.csv" );

//~ echo "converter_write mem:".mem()."\n";





$file = $Uid.".meterdatahour.csv";
$fp = fopen( $file , 'w');


$file_mem = $Uid.".meterdatahour_mem.csv";
$fp_mem = fopen( $file_mem , 'w');

$MonthSt  = str_pad($oArchive->MonthSt,2,"0",STR_PAD_LEFT);
$DaySt    = str_pad($oArchive->DaySt,2,"0",STR_PAD_LEFT);
$MonthSp  = str_pad($oArchive->MonthSp,2,"0",STR_PAD_LEFT);
$DaySp    = str_pad($oArchive->DaySp,2,"0",STR_PAD_LEFT);

$_GET['start']  = "{$oArchive->YearSt}{$MonthSt}{$DaySt}";
$_GET['stop']   = "{$oArchive->YearSp}{$MonthSp}{$DaySp}";


$datetime1 = new DateTime("{$oArchive->YearSt}-{$oArchive->MonthSt}-{$oArchive->DaySt}");
$datetime2 = new DateTime("{$oArchive->YearSp}-{$oArchive->MonthSp}-{$oArchive->DaySp}");
$interval = $datetime1->diff($datetime2);


$all_count = ceil($interval->format('%a') ) * $oArchive->ArchiveMeters->Count;
if( !$all_count ){
  $all_count = 1;
}

$iteration = 0;

foreach( $oArchive->ArchiveMeters->Elements as $iMeter ){
  
  
  //~ echo "ArchiveMeters_cicle mem:".mem()."\n";
  
  $MinDate = $iMeter->Meter->MinDate();
  
  
  $ArParameters = array();
  foreach( $iMeter->Meter->AllParameters->Elements as $iParameter ){
    if( !$iParameter->Id ) continue;
    $ArParameters[ $iParameter->Id ] = 1;
  }
  
  if( !count($ArParameters) ){
    //~ echo "empty parameters mem:".mem()."\n";
    continue;
  }
  
  
  while( $MinDate->getTimestamp() <= $iMeter->Meter->MaxDate()->getTimestamp() ){
    
    $limit = count( $ArParameters ) * 24;
    
    $SQL = Utils::Strip("
      select * from meterdatahour 
      where 
      meter_id = {$iMeter->Meter->Id} and
      year = {$MinDate->format('Y')} and
      month = ". ( $MinDate->format('m') +1 ) ." and
      day = {$MinDate->format('d')} and
      parameter_id IN(" . implode(",",array_keys($ArParameters)) . ") and
      hour IN(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22,23,24)
      limit {$limit}
    ");
    
    
    //~ $oArchive->__destruct();
    //~ $oArchive = archive::Id( $argv[1] );
    
    //~ if( !$oArchive->Status ) break 3;
    
    $Res = DB::UBSelect( $SQL );
    while( $val = DB::Fetch($Res) ){
      fputcsv($fp, $val , $delimiter , $enclosure);
    }
    
    fputcsv($fp_mem, array(
      mem(),
      $MinDate->format('Y-m-d'),
      $iMeter->Meter->Id,
      $all_count,
      $iteration,
      100 / $all_count * $iteration,
      (microtime(true)  - $time_start),
      connection_status()
    ) , $delimiter , $enclosure);
    
    $iteration++;
    
    
    $oArchive->UpdateByArray(array(
      'Procent' => 100 / $all_count * $iteration
    ));
    
    
    
    $MinDate->modify( "+1 day" );
  }
  
  $iMeter->Desctruct();
  
}

$zip->addFile( "./".$file , "meterdatahour.csv" );

$oArchive->UpdateByArray(array(
  'Procent' => 0,
  'Status' => 0
));

$zip->close();




foreach( $shema_orm as $_class => $attrs ){
  $file = $Uid."." . $_class . ".csv";
  unlink( $file );
}
die();