<?php
include($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');

$is_not_test = !defined( '__PHPUNIT_PHAR__' );

if( !Site()->Config('is_demo',0) ){
  if( $is_not_test ) {
    Site()->Error404;
    exit();
  }else{
    echo "Config Var `is_demo` disabled"; return false;
  }
}

$_SESSION['data'] = 1;

if( isset($_GET['verification'])){
  $oVerification = verification::FindByHash($_GET['verification']);
  
  if( !$oVerification->Is ){
    if( $is_not_test ) {
      Site()->Error404;
    }else{
      echo "verification not added"; return false;
    }
    exit();
  }else{
    if( !$oVerification->IsActual ){
      if( $is_not_test ) {
        if( !defined( '__PHPUNIT_PHAR__' ) ){
          Site()->Error404;
        }
      }else{
        echo "verification not actual"; return false;
      }
      $oVerification->Delete();
      exit();
    }else{
        
      $GLOBALS['FullRules'] = true;
      
      $oUser = $oVerification->SaveToDataBase();
      
      if( $oUser->Is ){
        $_REQUEST['login']    = $oUser->Login;
        $_REQUEST['password'] = $oUser->Pass;
        
        $oVerification->Delete();
        session_destroy();
        
        user::$SelfId = $oUser->Id;
        $GLOBALS['Self'] = $oUser;
        
        session_start();
        
      }
      
      if( $is_not_test ) {
        header("Location: /");
        exit();
      }else{
        echo "verification worked"; return false;
      }  
    }
  }
}


smarty()->assign('oVerification' , verification::Id(0));


if( isset($_GET['success']) ){
  smarty()->display('auth/demo/success.tpl');
}else{
  smarty()->display('auth/demo/index.tpl');
}
