<?php
include($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');

$sql = <<<SQL
SELECT 
`interprise`.`id` as `Eid`,
`interprise`.`name` as `EName`, 
IFNULL(`converter`.`is_excluded`,0)*10 +IFNULL(`meter`.`is_excluded`,0) as `exclude`,
`meter`.`is_ok`,
COUNT(*) as `meters`,
GROUP_CONCAT(`meter`.`id`) as `meters_id`  
FROM `meter` 
LEFT JOIN `converter` ON `meter`.`converter_id` = `converter`.`id` 
LEFT JOIN `interprise` ON `meter`.`interprise`=`interprise`.`id` 
GROUP BY `interprise`.`id`, `exclude`,`meter`.`is_ok`
SQL;

$rez = DB::Select($sql);
function FromExclude( $Status ) {
	$R = array(
		0 => '<b>В работе</b>',
		1 => 'Исключен',
		10 => 'Исключена точка опроса',
		11 => 'Исключена точка опроса',
	);
	return $R[$Status];
}
function FromIsOk($Status) {
	$R = array(
		0 => '<b>Есть проблемы</b>',
		1 => 'Исправен',
	);
	return $R[$Status];
}
function CountShow( $count, $is_ok, $exclude )
{
	if( $is_ok == 0 and $exclude==0 ){
		return "<b>{$count}</b>";
	}
	return $count;
}
echo "<table>";
	echo "<thead><tr><th>Предприятие</th><th>Исключено</th><th>С ошибками</th><th>Количество</th></tr></thead>";
while( $row = DB::FetchArrayA( $rez ) ){
	echo "<tr><td>{$row['EName']}</td>";
	echo "<td>".FromExclude($row['exclude'])."</td>";
	echo "<td>".FromIsOk($row['is_ok'])."</td>";
	echo "<td>".CountShow( $row['meters'], $row['is_ok'], $row['exclude'])." [{$row['meters_id']}]</td>";
	
	echo "</tr>";
}
echo "</table>";
