<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<style>
td {
padding: 10px;
border: 1px solid #DFDFDF;
}
.b{
color:#2F6FAC;
}
.g{
color: #32AF37;
font-weight: bold;
}
.str {
color: rgb(190, 186, 69);
font-weight: bold;
}
</style>
<table>
<tr>
	<td>Проверка значения массива</td>
	<td>assert<span class="g">array</span>HasKey</td>
	<td><span class="b"><span class="b">$this-></span></span>assertarrayHasKey(<span class="str">'foo'</span>, <span class="g">array</span>(<span class="str">'bar'</span> => <span class="str">'baz'</span>));</td>
</tr>
<tr>
	<td>Проверка все ли данные строки</td>
	<td>assertContainsOnly</td>
	<td><span class="b"><span class="b">$this-></span></span>assertContainsOnly('string', <span class="g">array</span>(<span class="str">'1'</span>, <span class="str">'2'</span>, <span class="str">'3'</span>));</td>
</tr>
<tr>
	<td>Проверка кол-ва в массиве</td>
	<td>assertCount</td>
	<td><span class="b">$this-></span>assertCount(1, <span class="g">array</span>('foo'));</td>
</tr>
<tr>
	<td>Проверка на пустое значение</td>
	<td>assertEmpty</td>
	<td><span class="b">$this-></span>assertEmpty(<span class="g">array</span>());</br>$a=''; <span class="b">$this-></span>assertEmpty( $a );</td>
</tr>

<tr>
<td></td>
<td></td>
<td>
<table>
<tr><td>@assert (...) == X assertEquals(X, method(...))</td></tr>
<tr><td>@assert (...) != X assertNotEquals(X, method(...))</td></tr>
<tr><td>@assert (...) === X assertSame(X, method(...))</td></tr>
<tr><td>@assert (...) !== X assertNotSame(X, method(...))</td></tr>
<tr><td>@assert (...) > X assertGreaterThan(X,method(...))</td></tr>
<tr><td>@assert (...) >= X assertGreaterThanOrEqual(X,method(...))</td></tr>
<tr><td>@assert (...) < X assertLessThan(X, method(...))</td></tr>
<tr><td>@assert (...) <= X assertLessThanOrEqual(X,method(...))</td></tr>
<tr><td>@assert (...) throws X @expectedException X</td></tr>
</table>
</td>
</tr>
<tr>
	<td>Проверка на соответствие</td>
	<td>assertEquals</td>
	<td><span class="b">$this-></span>assertEquals('bar', 'bar');</td>
</tr>
<tr>
	<td>Проверка на ложь</td>
	<td>assertFalse</td>
	<td><span class="b">$this-></span>assertFalse(false);</td>
</tr>
<tr>
	<td>Проверка на правду</td>
	<td>assertFalse</td>
	<td><span class="b">$this-></span>assertTrue(True);</td>
</tr>
<tr>
	<td>Проверка на существование файла и соответствие</td>
	<td>assertFileEquals</td>
	<td><span class="b">$this-></span>assertFileEquals(dirname(__FILE__) . '/_files/init.sql', dirname(__FILE__) . '/_files/init.sql');</td>
</tr>
<tr>
	<td>Проверка на существование файла</td>
	<td>assertFileExists</td>
	<td><span class="b">$this-></span>assertFileExists(dirname(__FILE__) . '/_files/inыit.sql');</td>
</tr>
<tr>
	<td>Проверка что первое число больше правого</td>
	<td>assertGreaterThan</td>
	<td><span class="b">$this-></span>assertGreaterThan(10, 10);</br><span class="b">$this-></span>assertLessThanOrEqual(3, 2);</td>
</tr>
<tr>
	<td>Проверка что первое число меньше правого</td>
	<td>assertGreaterThanOrEqual</td>
	<td><span class="b">$this-></span>assertGreaterThanOrEqual(0, 1);</br><span class="b">$this-></span>assertLessThan(1, 1);</td>
</tr>
<tr>
	<td>Проверка на тип</td>
	<td>assertInternalType</td>
	<td><span class="b">$this-></span>assertInternalType('string', '42');</td>
</tr>
<tr>
	<td>Проверка на json файлы(проверка названий + существование ? )</td>
	<td>assertJsonFileEqualsJsonFile</td>
	<td><span class="b">$this-></span>assertJsonFileEqualsJsonFile('path/to/fixture/file', 'path/to/fixture/file');</td>
</tr>
<tr>
	<td>Проверка на соответствие массивов</td>
	<td>assertJsonStringEqualsJsonString</td>
	<td><span class="b">$this-></span>assertJsonStringEqualsJsonString(json_encode(<span class="g">array</span>("Mascott" => "Tux")), json_encode(<span class="g">array</span>("Mascott" => "Tux")));</td>
</tr>
<tr>
	<td>Проверка на NULL</td>
	<td>assertNull</td>
	<td>$a=NULL;</br><span class="b">$this-></span>assertNull( $a );</td>
</tr>
<tr>
	<td>Проверка регуклярные выражения</td>
	<td>assertRegExp</td>
	<td><span class="b">$this-></span>assertRegExp('/^[a-z0-9]/', 'sdwtsv1234');</td>
</tr>
<tr>
	<td>Вывод на экран</td>
	<td>fwrite</td>
	<td>fwrite(STDOUT, 'asasas' . "\n");</td>
</tr>
<tr>
	<td>Чтение XML</td>
	<td>createFlatXmlDataSet</td>
	<td>return <span class="b">$this-></span>createFlatXmlDataSet(dirname(__FILE__) . '/_files/test.xml');
	</br>
	<pre>
	 &lt;?xml version="1.0" ?>
	 &lt;dataset>
	 content XML
	 &lt;/dataset>
	</pre>
	</td>
</tr>
<tr>
	<td>Сброс выполнения теста(желтый)</td>
	<td>markTestIncomplete</td>
	<td>$this->markTestIncomplete();</td>
</tr>
<tr>
	<td>Сброс выполнения теста(синий)</td>
	<td>markTestSkipped</td>
	<td>$this->markTestSkipped();</td>
</tr>
</table>

