<?php
header("Content-type: text/html; charset=utf-8");
//header("Content-type: text/html; charset=windows-1251");

ini_set( 'date.timezone', 'UTC' );
ini_set( 'date.timezone', 'Asia/Yekaterinburg' );

include ('tkon.inc.php');

$oConverter = new converter();
$oMeter     = new MeterTkon();


$oConverter->ip = '192.168.5.56';
$oConverter->port = 50;
$oConverter->debug = true;

$oMeter->Converter = $oConverter;

$oConverter->Connect();
$NoError = true;
if( $oConverter->IsConnected() )
{
  $oConverter->Setup( null );
  
  for( $iter=0; $iter<1; $iter++)
  {
    echo "Шаг опроса: {$iter}<br />";
    if( $Type = $oMeter->GetSubType() )
    {
      
      switch( $Type )
      {
        case 0x0B01 : echo "ТЭКОН-19Б Исполнение 1";
          break;
        default:
          echo "Тип прибора: ".sprintf( "%04X", $Type )." <br />";
      }
    }else
      $NoError = false;
    if( $NoError and $Serial = $oMeter->GetSerialNumber() )
    {
      echo "Серийный номер прибора: ".sprintf( "%04X", $Serial )." <br />";
    }else
      $NoError = false;

    if( $NoError and  $date = $oMeter->GetDatetime() )
    {
      echo date_format($date, 'Y-m-d H:i:s') . "\n";
    }else
      $NoError = false;

    if( $NoError and $QueryInfo = $oMeter->GetQueryInfo() )
    {
      echo var_dump($QueryInfo) . "\n";
    }else
      $NoError = false;

    
    echo "<br />";
  }
  $oConverter->Disconnect();
  echo "OK";
}
else
{
  echo "Ошибка : ".$oConverter->LastError;
}


die();

