<?php


/*

	https://docs.google.com/spreadsheets/d/1dNZMKGVwunZdSQbN0dLmZI6slj702yGkqH_5jf95BJs/edit#gid=0

	Производитель
		Модель
			Модификация

*/


foreach( array(
	'Энергомера' => array(
		'CE102'=>array(
			'CE102' => 'CE102',
			'CE102 R5.1 145-JAN' => 'CE102'
		),
		'CE102 М' => array(
			'CE102M' 	=> 'CE102M',
			'CE102M S7 145-AV' 	=> 'CE102M',
			'CE102M S7 148-AV' 	=> 'CE102M',
			'CE102M R5 145-A' 	=> 'CE102M',
			'CE102M R5 148-A' 	=> 'CE102M'
		),
		'CE301' => array(
			'CE301'				=> 'CE301',
			'CE301 R33 043 JAZ'				=> 'CE301',
			'CE301 R33 043 JAQZ'			=> 'CE301',
			'CE301 R33 145 JAZ'				=> 'CE301',
			'CE301 R33 145 JAQZ'			=> 'CE301',
			'CE301 R33 146 JAZ'				=> 'CE301',
			'CE301 R33 146 JAQZ'			=> 'CE301',
			'CE301 S31 146 JAVZ'			=> 'CE301',
			'CE301 S31 146 JAVZ(12)'	=> 'CE301'
		),
		'СЕ 301 М' => array(
			'СЕ301М' 	=> 'CE301M',
			'СЕ301М S31 145 JAVZ' 	=> 'CE301M',
			'СЕ301М S31 148 JAVZ' 	=> 'CE301M',
			'СЕ301М S31 145 JASVZ' => 'CE301M',
			'СЕ301М S31 148 JASVZ' => 'CE301M',
			'CE301М R33 145 JAZ' 	=> 'CE301M',
			'СЕ301М R33 148 JAZ' 	=> 'CE301M',
			'CE301М R33 145 JASZ' 	=> 'CE301M',
			'CE301М R33 148 JASZ' 	=> 'CE301M'
		),
		'ЦЭ6822'=>array(
			'ЦЭ6822'		=> 'CE6822',
			'ЦЭ6822 1,0 220В 5А EIA485'		=> 'CE6822',
			'ЦЭ6822 1,0 220В 10А EIA485'	=> 'CE6822',
			'ЦЭ6822 2,0 220В 5А EIA485'		=> 'CE6822',
			'ЦЭ6822 2,0 220В 10А EIA485'	=> 'CE6822'
		)
	),
	'АО "ННПО имени М.В. Фрунзе"' => array(
		'ПСЧ-4ТМ.05МН' => array(
			'ПСЧ-4ТМ.05МН' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МН.00' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МН.01' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МН.02' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МН.03' => 'PSCH-4TM.05M.10'
		),
		'ПСЧ-4ТМ.05МК' => array(
			'ПСЧ-4ТМ.05МК' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.00' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.01' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.02' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.03' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.04' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.05' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.06' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.07' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.08' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.09' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.10' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.11' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.12' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.13' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.14' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.15' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.16' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.17' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.18' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.19' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.20' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.21' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.22' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.23' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.24' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МК.25' => 'PSCH-4TM.05M.10'
		),
		'ПСЧ-4ТМ.05МД' => array(
			'ПСЧ-4ТМ.05МД' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.01' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.03' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.05' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.07' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.09' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.11' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.13' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.15' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.17' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.19' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.21' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.23' => 'PSCH-4TM.05M.10',
			'ПСЧ-4ТМ.05МД.25' => 'PSCH-4TM.05M.10'
		),
		'СЭБ-2А.07' => array(
			'СЭБ-2А.07' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.111' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.112' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.211' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.212' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.311' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.312' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.411' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.412' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.111.1' => 'SEB-2A.07.212',
			'СЭБ-2А.07.112.1' => 'SEB-2A.07.212',
			'СЭБ-2А.07.211.1' => 'SEB-2A.07.212',
			'СЭБ-2А.07.212.1' => 'SEB-2A.07.212',
			'СЭБ-2А.07.611' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.612' 	=> 'SEB-2A.07.212',
			'СЭБ-2А.07.611.1' => 'SEB-2A.07.212',
			'СЭБ-2А.07.612.1' => 'SEB-2A.07.212'
		),
		'МАЯК 101АТ' => array(
			'МАЯК 101АТ' => 'MAYAK_101_AT',
			'МАЯК 101АТ.121Ш.2ИП2Б' => 'MAYAK_101_AT',
			'МАЯК 101АТ.121Ш.2ИП1Б' => 'MAYAK_101_AT'
		),
		'ПСЧ-3АРТ.07'=>array(
			'ПСЧ-3АРТ.07' 	=> 'PSCH-3ART',
			'ПСЧ-3АРТ.07.132' 	=> 'PSCH-3ART',
			'ПСЧ-3АРТ.07.132.1' => 'PSCH-3ART',
			'ПСЧ-3АРТ.07.632' 	=> 'PSCH-3ART',
			'ПСЧ-3АРТ.07.632.1' => 'PSCH-3ART',
			'ПСЧ-3АРТ.07.132.2' => 'PSCH-3ART',
			'ПСЧ-3АРТ.07.132.4' => 'PSCH-3ART',
			'ПСЧ-3АРТ.07.132.3' => 'PSCH-3ART'
		),
		'ПСЧ-3ТА.07' => array(
			'ПСЧ-3ТА.07' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.112' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.112.1' 	=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.112.2' 	=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.312' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.312.1' 	=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.512' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.512.1' 	=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.612' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТА.07.612.1' 	=> 'PSCH-3TA.07.112.2'
		),
		'ПСЧ-3ТМ.05Д' => array(
			'ПСЧ-3ТМ.05Д.01' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТМ.05Д.03' 		=> 'PSCH-3TA.07.112.2',
			'ПСЧ-3ТМ.05Д.05' 		=> 'PSCH-3TA.07.112.2'
		),
		'СЭБ-1ТМ.02Д' => array(
			'СЭБ-1ТМ.02Д' => 'SEB-1TM.02D',
			'СЭБ-1ТМ.02Д.02' => 'SEB-1TM.02D',
			'СЭБ-1ТМ.02Д.03' => 'SEB-1TM.02D'
		),
		'Счетчик электроэнергии СЭТ-4ТM.02М' => array(
			'Счетчик электроэнергии СЭТ-4ТM.02М' => 'SET_4TM_02M',
		)
	),
	'Милур' =>array(
		'Милур 104' => array(
			'Милур 104' => 'MILUR104',
		),
		'Милур 107' => array(
			'Милур 107' 			=> 'MILUR104',
			'Милур 107.22R-1L' 		=> 'MILUR104',
			'Милур 107.22R-1L-D' 	=> 'MILUR104',
			'Милур 107.22R-1L-DT' 	=> 'MILUR104',
			'Милур 107.22R-1L-T' 	=> 'MILUR104',
		),
		'Милур 105' => array(
			'Милур 105' 		=> 'MILUR104',
			'Милур 105.22R' 		=> 'MILUR104',
			'Милур 105 22RE' 		=> 'MILUR104',
			'Милур 105.22RD' 		=> 'MILUR104',
			'Милур 105.22RED' 	=> 'MILUR104',
			'Милур 105.22RT' 		=> 'MILUR104',
			'Милур 105.22RET' 	=> 'MILUR104',
			'Милур 105.22RDT' 	=> 'MILUR104',
			'Милур 105.22REDT' 	=> 'MILUR104'
		),
		'Милур 305' => array(
			'Милур 305' 	=> 'MILUR304',
			'Милур 305.11R' 	=> 'MILUR304',
			'Милур 305.11RE' 	=> 'MILUR304',
			'Милур 305.12R' 	=> 'MILUR304',
			'Милур 305.12RE' 	=> 'MILUR304',
			'Милур 305.32R' 	=> 'MILUR304',
			'Милур 305.32RE' 	=> 'MILUR304'
		),
		'Милур 307' => array( 
			'Милур 307' 		=> 'MILUR304',
			'Милур 307.11R1' 		=> 'MILUR304',
			'Милур 307.21R1' 		=> 'MILUR304',
			'Милур 307.11R1L' 	=> 'MILUR304',
			'Милур 307.21R1L' 	=> 'MILUR304',
			'Милур 307.11R1i' 	=> 'MILUR304',
			'Милур 307.21R1i' 	=> 'MILUR304',
			'Милур 307.11R1Li' 	=> 'MILUR304',
			'Милур 307.21R1Li' 	=> 'MILUR304',
			'Милур 307.12R1' 		=> 'MILUR304',
			'Милур 307.22R1' 		=> 'MILUR304',
			'Милур 307.12R1L' 	=> 'MILUR304',
			'Милур 307.22R1L' 	=> 'MILUR304',
			'Милур 307.12R1i' 	=> 'MILUR304',
			'Милур 307.22R1i' 	=> 'MILUR304',
			'Милур 307.12R1Li' 	=> 'MILUR304',
			'Милур 307.22R1Li' 	=> 'MILUR304',
			'Милур 307.42R1' 		=> 'MILUR304',
			'Милур 307.42RL' 		=> 'MILUR304',
			'Милур 307.42R1i' 	=> 'MILUR304',
			'Милур 307.42R1Li' 	=> 'MILUR304'
		),
		'МИЛУР 305.32' => array(
			'МИЛУР 305.32' => 'MILUR305.32R'
		)
	),
	'ООО НАГ' => array(
		'Ethernet Remote Device' => array(
			'Ethernet Remote Device' => 'SNR-GSM-TEMP'
		),
		'Датчики' => array(
			'Датчики' => 'ERD_SENSOR'
		),
		'Радио Счетчик Импульсов' => array(
			'Радио Счетчик Импульсов' => 'SNR_RADIO_COUNTER'
		),
		'Счетчик Импульсов SNR-RScounter-8I' => array(
			'Счетчик Импульсов SNR-RScounter-8I' => 'SNR_RS_COUNTER_8I'
		),
	),
	'ООО "Инкотекс-СК"'=> array(
		'Меркурий 206' => array(
			'Меркурий 206' 	=> 'MERCURY_206',
			'Меркурий 206 RN' 	=> 'MERCURY_206',
			'Меркурий 206 PRNO' => 'MERCURY_206'
		),
		'Меркурий 234 ART' => array(
			'Меркурий 234' 	=> 'MERCURY_234',
			'Меркурий 234 ART-00 P' 	=> 'MERCURY_234',
			'Меркурий 234 ART-01 P' 	=> 'MERCURY_234',
			'Меркурий 234 ART-01 PO'  => 'MERCURY_234',
			'Меркурий 234 ART-02 P' 	=> 'MERCURY_234',
			'Меркурий 234 ART-03 P' 	=> 'MERCURY_234',
			'Меркурий 234 ART2-00 P' 	=> 'MERCURY_234',
			'Меркурий 234 ART2-03 P' 	=> 'MERCURY_234',
			'Меркурий 234 ART-01 OL1' => 'MERCURY_234',
			'Меркурий 234 ART-02 L1' 	=> 'MERCURY_234',
			'Меркурий 234 ART-03 L1' 	=> 'MERCURY_234'
		),
		'Счетчик электроэнергии Меркурий 230' => array(
			'Меркурий 230' => 'MERCURY_230',
			'Меркурий 230 ART-03 CN' => 'MERCURY_230_ART_03_CN',
			'Меркурий 230 АR-00 R' => 'MERCURY_230',
			'Меркурий 230 АR-01 R' => 'MERCURY_230',
			'Меркурий 230 АR-02 R' => 'MERCURY_230',
			'Меркурий 230 АR-03 R' => 'MERCURY_230'
		),
		'Меркурий 225.1' => array(
			'Меркурий 225.1' => 'MERCURY_225_1'
		),
	),
	'Текон' => array(
		'КРЕЙТ ТЭКОН-19' => array(
			'КРЕЙТ ТЭКОН-19' => 'TEKON19'
		),
	),
	'Счетчик электроэнергии СТЭ561 МС' => array(
		'Счетчик электроэнергии СТЭ561 МС' => array(
			'СТЭ 561' 	=> 'STE_561_MC',
			'СТЭ 561/П5-Т-4-2-К1' 	=> 'STE_561_MC',
			'СТЭ 561/П50-Т-4-2-К1' 	=> 'STE_561_MC',
			'СТЭ 561/П100-Т-4-2-К1' => 'STE_561_MC',
			'СТЭ 561/П5-Т-4-5-К1' 	=> 'STE_561_MC',
			'СТЭ 561/П50-Т-4-5-К1' 	=> 'STE_561_MC',
			'СТЭ 561/П100-Т-4-5-К1' => 'STE_561_MC',
			'СТЭ 561/П5-1-4М-К1' 		=> 'STE_561_MC',
			'СТЭ 561/П50-1-4М-К1' 	=> 'STE_561_MC',
			'СТЭ 561/П100-1-4М-К1' 	=> 'STE_561_MC',
			'СТЭ 561/П60-1-4М-К3' 	=> 'STE_561_MC',
			'СТЭ 561/П5-1-4М-К4' 		=> 'STE_561_MC',
			'СТЭ 561/П60-1-4М-К4' 	=> 'STE_561_MC',
			'СТЭ 561/5-1-3Р' 				=> 'STE_561_MC',
			'СТЭ 561/5-1-4Р-К1'	 		=> 'STE_561_MC',
			'СТЭ 561/П5-4Р-5 -К1' 	=> 'STE_561_MC',
		)
	),
	'Тепловычислитель СПТ943' => array(
		'Тепловычислитель СПТ943' => array(
			'Тепловычислитель СПТ943' => 'SPT_943'
		),
		'Тепловычислитель СПТ941' => array(
			'Тепловычислитель СПТ941' => 'SPT_941'
		)
	),
	'Нева MT123' => array(
		'Нева MT123' => array(
			'Нева MT123' => 'NEVA_MT123',
		),
		'Нева MT324' => array(
			'Нева MT324' => 'NEVA_MT324'
		)
	),
	'Счетчик электроэнергии БАРС-1.211' => array(
		'Счетчик электроэнергии БАРС-1.211' => array(
			'Счетчик электроэнергии БАРС-1.211' => 'BARS_1_211'
		)
	),
	'SNMPGETv1' => array(
		'SNMPGETv1' => array(
			'SNMPGETv1' => 'SNMPGETv1'
		)
	),
	'SNMPSETv1' => array(
		'SNMPSETv1' => array(
			'SNMPSETv1' => 'SNMPSETv1'
		)
	),
	'Счетчик электроэнергии СКАТ 105' => array(
		'Счетчик электроэнергии СКАТ 105' => array(
			'Счетчик электроэнергии СКАТ 105' => 'SKAT_105'
		)
	),
	'МИРТЕК-1-РУ-D1' => array(
		'МИРТЕК-1-РУ-D1' => array(
			'МИРТЕК-1-РУ-D1' => 'MIRT1'
		)
	),
	'SNR_COUNTER' => array(
		'SNR_COUNTER' => array(
			'SNR_COUNTER' => 'SNR_COUNTER'
		)
	),
	'Счетчик электроэнергии СТЕ-561 RS' => array(
		'Счетчик электроэнергии СТЕ-561 RS' => array(
			'Счетчик электроэнергии СТЕ-561 RS' => 'STE_561_RS'
		)
	),
	'Счетчик электроэнергии МИРТЕК-3' => array(
		'Счетчик электроэнергии МИРТЕК-3' => array(
			'Счетчик электроэнергии МИРТЕК-3' => 'MIRT3_CLASS1'
		)
	),
	'Sanext 5704' => array(
		'Sanext 5704' => array(
			'Sanext 5704' => 'SANEXT_5704_MBUS'
		)
	),
	'SONOSAFE10' => array(
		'SONOSAFE10' => array(
			'SONOSAFE10' => 'SONOSAFE10'
		)
	),
	'НПО КАРАТ' => array(
		'КАРАТ-Компакт' => array(
			'КАРАТ-Компакт 2-213' => 'CARAT_213'
		)
	),
	'Вега Абсолют' => array(
		'Вега Абсолют' => array(
			'СИ-11' => 'LORA_CI_11',
			'СИ-12' => 'LORA_CI_12',
			'СИ-13-485' => 'LORA_CI_13_MER',
			'СИ-21' => 'LORA_CI_21',
			'ТД-11' => 'LORA_TD_11',
			'ТП-11' => 'LORA_TP_11',
			'Smart-MC0101' => 'LORA_MC_0101',
			'Smart-AS010' => 'LORA_AS_0101',
			'Smart-MS0101' => 'LORA_MS_0101',
			'Smart-SS0101' => 'LORA_SS_0101',
			'GM-2' => 'LORA_GM_2',
			'LM-1' => 'LORA_LM_1',
		)
	),

) as $manufacturer_title => $marks){


	# MANUFACTURER
	$FilterMan = array(
		'Filter' => array(
			'Title' => $manufacturer_title
		)
	);

	$ResMan = manufacturer::Filter( $FilterMan );

	$Man = manufacturer::Id(0);
	if( !$ResMan->Count ){
		$Man = manufacturer::AddByArray(
			array(
				'Title' => $manufacturer_title
			)
		);
		$result[ 'Производители' ][] = array(
        'type' => 'sucess',
        'msg' => "<b>[add][manufacturer] </b>" . $manufacturer_title
    );
	}else{
		$Man = $ResMan->First;
	}






	# MARK
	foreach( $marks as $mark_title => $models ){
		$FilterMark = array(
			'Filter' => array(
				'Title' => $mark_title
			)
		);

		$ResMark = mark::Filter( $FilterMark );

		$Mark = mark::Id(0);
		if( !$ResMark->Count ){
			$Mark = mark::AddByArray(
				array(
					'Title' => $mark_title,
					'ManufacturerId' => $Man->Id
				)
			);
			$result[ 'Производители' ][] = array(
	        'type' => 'sucess',
	        'msg' => "<b>[add][mark] </b>" . $mark_title
	    );
		}else{
			$Mark = $ResMark->First;
		}





		# MODEL
		# Если нет ни одного то добавляем самого себя
		if( !count( $models ) ){
			$models[] = array($mark_title);
		}
		foreach( $models as $model_title => $dll_id ){
			$FilterModel = array(
				'Filter' => array(
					'Title' => $model_title
				)
			);

			$ResModel = model::Filter( $FilterModel );



			# METERTYPE
			$FilterType = array(
				'Filter' => array(
					'DllId' => $dll_id
				)
			);
			$DllId = 0;
			if( metertype::Filter( $FilterType )->Count ){
				$DllId = metertype::Filter( $FilterType )->First->Id;
			}
			# END METERTYPE



			if( !$ResModel->Count ){
				model::AddByArray(
					array(
						'Title' => $model_title,
						'MarkId' => $Mark->Id,
						'TypeId' => $DllId
					)
				);
				$result[ 'Производители' ][] = array(
		        'type' => 'sucess',
		        'msg' => "<b>[add][model] </b>" . $model_title
		    );
			}else{
				$ResModel->First->UpdateByArray(array(
					'Title' => $model_title,
					'MarkId' => $Mark->Id,
					'TypeId' => $DllId
				));
				$ResModel->Save();
			}
		}
		# END MODEL




	}
	# END MARK




}

// Чистим от 0
$Filter = array(
	'Filter' => array(
		'Type' => 0
	)
);
model::Filter( $Filter )->DeleteAll();



$Filter = array(
	'Filter' => array(
		'Title LIKE' => "%LORA%"
	)
);
mark::Filter( $Filter )->DeleteAll();
// Чистим от 0
$Filter = array(
	'Filter' => array(
		'Title' => array(
			"Счетчик электроэнергии МИЛУР 305.32",
			"МИЛУР 305.32",
			"FILTER",
			"SNR_COUNTER",
			"SNMPSETv1",
			"Ethernet Remote Device",
			"Датчики",
			"Радио Счетчик Импульсов",
			"TEST_EMULATOR",
			"SPT_943",
			"BARS_1_211",
			"SNR-GSM-TEMP",
			"NEVA_MT123",
			"SPT_943",
			"SET_4TM_02M",
			"SPT_941",
			"STE_561_MC",
			"NEVA_MT324",
			"SKAT_105",
			"MERCURY_230",
			"MIRT1",
			"SNMPGETv1",
			"MIRT3_CLASS1",
			"TEKON",
			"VIRTMETER",
			"SNR_RADIO_COUNTER",
			"SNR_RS_COUNTER_8I",
			"CALCMETER",
			"MILUR305.32R",
			"STE_561_RS",
			"FILE_VALUE",
			"TEKON19",
			"MERCURY_225_1",
			"ERD_SENSOR",
			"SANEXT_5704_MBUS"
		)
	)
);
mark::Filter( $Filter )->DeleteAll();
