<?php
class DB extends TMysql
{
  static function FixError1054( $T, $F, $KeyF ){ 

    $aFields = array();
    $Res = DB::Select("DESCRIBE {$T}");
    while( $_f = DB::Fetch($Res)){
			$aFields[$_f['Field']] = $_f['Field'];
		}
		
    $sql = "";
    foreach($F as $kF=>$iF){
      if( !isset($iF['sql'], $aFields[$iF['sql']]) ){
        if($iF['type'] != 'multy'){
          if($sql!='') $sql .= ", ";
          $sql .= "ADD `{$iF['sql']}` ".DB::FixErrorFieldType( $iF['type'] );
        }
      }
    }
    $sql = "ALTER TABLE {$T} ".$sql;
    DB::Query( $sql );
    return true;
  }

  static function FixErrorFieldType($FType) {
    switch ($FType) {
      case 'id':
          return "INT UNSIGNED NOT NULL AUTO_INCREMENT";
        break;
      case 'bool':
          return "TINYINT( 1 ) DEFAULT 0 NOT NULL";
        break;
      case 'float':
          return "FLOAT DEFAULT 0 NOT NULL";
        break;
      case 'int':
      case 'ts':
      case 'its':
      case 'uts':
      case 'ip':
	  case 'iip':
	  case 'uip':
          return "INT( 255 ) DEFAULT 0 NOT NULL";
        break;
      case 'int_abs':
      case 'fltcnt':
      case 'object':
          return "INT UNSIGNED DEFAULT 0 NOT NULL";
        break;
      case 'text':
          return "TEXT NOT NULL";
        break;
      case 'string':
          return "VARCHAR( 255 ) DEFAULT '' NOT NULL";
        break;
      default:
      echo "no sql fix error info[{$FType}]";
      die();
    }
  }

  static function FixError1146($T = '',$F = array(),$KeyF = '') { // SQL Error : Table doesn't exist
    $sql = "CREATE TABLE $T ( ";
    foreach($F as $kF=>$iF){
      if($iF['type'] != 'multy'){
      $sql .= " `{$iF['sql']}` ";
      $sql .= DB::FixErrorFieldType( $iF['type'] );
      $sql .= ",";
      }
    }
    $sql .= " PRIMARY KEY (`{$F[$KeyF]['sql']}`) )";
    try{
      DB::Query($sql);
    } catch (Exception $e) {
      return false;
    }
    return true;
  }
}
