<?php

class HeadTableParameters{
  
  
  public $Parameters = array();
  
  public $Before = array();
  
  public $After = array();
  
  public $UseCoef = false;
  
  function __construct( $before = array() , $after = array() , $Parameters , $useCoef = false ){
    $this->Parameters = $Parameters;
    $this->Before = $before;
    $this->After  = $after;
    $this->UseCoef = $useCoef;
  } 
  
  function RowCol(){
    
    
    $output = array(
      //~ [ row ]
      //~   [col]
    );
    
    $total_cols = 0;
    
    
    for( $row_i = 1 ; $row_i <= 4 ; $row_i++ ){
      
      $col_i = 0;
      
      foreach( $this->Parameters->Elements as $iParameter ){
        $prop = "Lvl{$row_i}";
        
        if( !isset( $output[ $row_i ] ) ){
          $output[ $row_i ] = array();
        }
        
        if( 
          isset( $output[ $row_i ][ $col_i - 1 ] ) && 
          $output[ $row_i ][ $col_i - 1 ]['title'] == $iParameter->$prop
        ){
          $output[ $row_i ][ $col_i - 1 ]['col'] = $output[ $row_i ][ $col_i - 1 ]['col']+1;
          $output[ $row_i ][ $col_i ] = &$output[ $row_i ][ $col_i - 1 ];
        }else{
          $output[ $row_i ][ $col_i ] = array(
            'col_i' => $col_i,
            'row' => 1,
            'col' => 1,
            'title' => $iParameter->$prop,
            'source' => $iParameter
          );
        }
        
        if( $row_i == 4 ) $total_cols++;
                
        $col_i++;
      }
    }
    
    //~ var_dump($output);die();
    
    
    /*
      Очищаем полностью пустые строки
    */
    foreach( $output as $o => $row ){
      if( $row[key($row)]['col'] == $total_cols && !$row[key($row)]['title'] ) {
        unset($output[$o]);
      };
      foreach( $row as $i => $col ){
        if( $col['col_i'] != $i ){
          unset($output[$o][$i]);
        }
      }
    }

    $o = $output;
    reset($o);
    
     //~ var_dump(key($o));

    /*
      Добавляем то что надо отобразить ДО
    */
    foreach( $this->Before as $c ){
      if( is_array($output) && isset($output[key($o)]) ){
        array_unshift( $output[key($o)] , array(
          'col' => 1,
          'row' => count( $output ),
          'title' => $c
        ));
      }
    }
    
    /*
      Добавляем то что надо отобразить ПОСЛЕ
    */
    foreach( $this->After as $c ){
      array_push( $output[key($o)] , array(
        'col' => 1,
        'row' => count( $o ),
        'title' => $c
      ));
    }
    
    //~ var_dump($output);die();
    
    return $output;
    
  }
  
}
