<?php
// ver 1.3.41
// md5=592a8abe797d89611295a7604905d8ba
define('OBJECT_NO',0);
define('OBJECT_INITED',1);
define('OBJECT_PRELOAD',2);
define('OBJECT_LOADED',3);
define('ER_OBJECT',1);
define('ER_PROPERTY',2);
define('ER_SQL',3);
class TObject2{
  static protected $_UseObjects = array();
  
	static $Debug = false;
	
	static $IterationJobTest = 0;
	static $TaskAction = true;

	const WARNING_COUNT_MAX = 500;

	static function ActionJob(){
		return self::$TaskAction;
	}

	static public function SaveAllObjects(){
		foreach( TObject2::$_UseObjects as $Class ) {
			if( isset($Class::$_O) ) {
				foreach( $Class::$_O as $iObject )
				$iObject->Save();
			}
		}
	}
	
	# показ какие поля доступны для этого объекта
	# доступно для тех классов которые указаны в fieldsobject::GetObjects
  function GetMoreFields(){
    if( !fieldsobject::IsAssignedMoreFields( get_class( $this ) ) ){
      return new TListGroup;
    }
    return fieldsobject::GetFieldsForObject($this);
  }
  
  
  # вывод значений всех дополнительных полей для объекта
  function GetMoreFieldsValue(){
    if( !fieldsobject::IsAssignedMoreFields( get_class( $this ) ) ){
      return new TListGroup;
    }
    $Filter = array(
      'Filter' => array(
        'Objectid' => $this->Id,
        'Object' => get_class($this),
      ),
      'Order' => array(
        'Fields' => 'ASC'
      )
    );
    return fieldsvalue::Filter($Filter);
  }
  
  static public function _get(&$t,&$p) {
    
    if(method_exists($t,$f="Get".$p)){
    	return $t->$f();
    }
    elseif( isset($t::$FInit) && !isset($t::$FInit[$p]) && strpos( $p , 'Can') === 0 ) {
  		$p = str_replace('Can','',$p);
  		return Self()->Rules( get_class($t) , $t->_F['Id']['value'] , $p );
  	}
    elseif(method_exists('TObject2',$f="_get__".$p)){
    	return TObject2::$f($t);
    }
    elseif( isset($t->_F[$p], $t->_F[$p]['type']) and method_exists('TObject2',$f="_get_".$t->_F[$p]['type'])) return TObject2::$f($t,$t->_F[$p],$p);
    elseif(method_exists('TObject2',$f="_get_".$p)) return TObject2::$f($t,$t->_F[$p]);
    else return TObject2::_Error($t,ER_PROPERTY,Array('property'=>$p));
  }
  
  
  static function _call($t,$n,$args){
    if( method_exists($t,$n) ){
      return $t->$n($args);
    }
    if( preg_match('/^Get(.*)$/' , $n ) ){
      $method = str_replace('Get','',$n);
      return $t->$method;
    }
  }
  
  
  function ReturnGroupUser()
  {
  	$Filter = array(
  		'Filter' => array(
  			'User' => Self()->Id
  		)
  	);
  	$_a = array();
  	foreach(groupusers::Filter($Filter)->Elements as $_g) $_a[$_g->Group->Id] = $_g->Group->Fio;
  	return $_a;
  }

  function ReturnRuleUser()
  {
  	$Filter = array(
  		'Filter' => array(
  			'User' => Self()->Id
  		)
  	);
  	$_a = array();
  	foreach(link::Filter($Filter)->Elements as $_g) $_a[$_g->Rule->Id] = $_g->Rule->Name;
  	return $_a;
  }

  static public function _set(&$t,&$p,&$v) {
    
    if( is_array( $v ) ){
      if( isset($v[1]) ){
        $t->_F[$p]['changeReason'] = $v[1];
      }
      $v = $v[0];
    }
  
    if( $t->_State===OBJECT_NO ) {
    	// Объект несуществует
    	TObject2::_Error( $t, ER_OBJECT, array( 'property'=>$p ) );
    } elseif( method_exists( $t, $f="Set".$p ) ) {
    	$t->$f( $v );
    } elseif( method_exists( 'TObject2', $f="_set_".$p ) ) {
    	TObject2::$f($t,$t->_F[$p],$v, $p );
    } elseif( isset( $t->_F[$p],$t->_F[$p]['type'] ) and method_exists( 'TObject2', $f="_set_".$t->_F[$p]['type'] ) ) {
    	TObject2::$f( $t, $t->_F[$p], $v , $p );
      if( isset( $t->_F[$p] ) && isset( $t->_F[$p]['changeReason'] ) && $t->_F[$p]['changeReason'] ) $t->Save();
    } else {
    	return TObject2::_Error( $t, ER_PROPERTY, array( 'property' => $p ) );
    }
  }

	static public function CleanAllObjects(){
		foreach( TObject2::$_UseObjects as $Class ) {
			if( isset($Class::$_O) ) {
				$Class::$_O = array();
			}
			if( isset($Class::$_R) ) {
				$Class::$_R = array();
			}
		}
    TMysql::CleanCache();
		TSite::CleanConfig();
	}
  
    
  /*
    Очищение кеша по классу
  */
  static public function CleanAllObjectsByClass( $Class ){
    if( isset($Class::$_O) ) {
      $Class::$_O = array();
    }
    if( isset($Class::$_R) ) {
      $Class::$_R = array();
    }
	}
  
  
  static public function CleanCacheById( $Class , $id ){
    if( isset( $Class::$_R[$id] ) ){
      $Object = $Class::$_R[$id];
      $Object->__destruct();
    }
  }
	
	static public function SqlParseNew( $Sql ){

		#$Sql = preg_match( '/(\s*)(AND*)(.*)(IN*)(\(.\)*)(.*)(\s*)/' , $Sql , $postSql );

		$RegExr = '/^(SELECT+)(.*)(FROM+)([^\(]*?)(WHERE*)(.*)/sim';
		$RegExrJoin = '/^(SELECT+)(.*)(FROM+)\ \`(.*)\`\ (LEFT|RIGHT|INNER|OUTER*)\ JOIN (.*)([^JOIN*?])(WHERE*)(.*)$/sim';
		$RegExrCount = '/^(SELECT+)\ COUNT\((.*)\)\ (FROM+)([^\(]*?)(WHERE*)(.*)/sim';


		if( preg_match( $RegExrJoin , $Sql, $Match ) ){
			return array(
				'Operator'	=> trim($Match[1]),
				'Fields'		=> trim($Match[2]),
				'From'			=> trim($Match[3]),
				'Table'			=> preg_replace( '/(\`[a-z]*\`+)(.*)/' , '\\1' , "`" . trim($Match[4]) ) . "`",
				'Where'			=> trim($Match[5]) . " JOIN  " . trim($Match[6]) . " " . trim($Match[7]) . " " . trim($Match[8]) . "  " .  trim($Match[9]),
				'Limit'			=> "",
				'JOIN'			=> true
			);
		}

		if( preg_match( $RegExrCount , $Sql, $Match ) ){
			return array(
				'Operator'	=> trim($Match[1]),
				'Fields'		=> "COUNT(" . trim($Match[2]) . ")",
				'From'			=> trim($Match[3]),
				'Table'			=> trim($Match[4]) ,
				'Where'			=> isset( $Match[6] ) ? trim($Match[6]) : '',
				'Limit'			=> "",
			);
		}

		if( preg_match( $RegExr , $Sql, $Match ) ) {

			if(isset( $Match[7] )) {
				$LIMIT = $Match[7] . $Match[8] . $Match[9] . $Match[10];
			} else {
				$LIMIT = "";
			}

			return array(
				'Operator'	=> trim($Match[1]),
				'Fields'		=> trim($Match[2]),
				'From'			=> trim($Match[3]),
				'Table'			=> preg_replace( '/(\`[a-z]*\`+)(.*)/' , '\\1' , trim($Match[4]) ),
				'Where'			=> isset( $Match[6] ) ? trim($Match[6]) : '',
				'Limit'			=> trim($LIMIT),
			);
		}
	}

	static public function SqlParse( $Sql ){

		$RegExr = '/(SELECT)\s+(.*)\s+(FROM)\s+(`[^`]+`)\s*(?:WHERE\s+(.+))?(?:\s*LIMIT\s+(.*))?/sim';

		if( preg_match( $RegExr , $Sql, $Match ) ) {
			return array(
				'Operator' => $Match[1],
				'Fields'   => $Match[2],
				'From'     => $Match[3],
				'Table'    => $Match[4],
				'Where'    => isset( $Match[5] ) ? $Match[5] : '',
				'Limit'    => isset( $Match[6] ) ? $Match[6] : '',
			);
		}else{
			return false;
		}
	}

	static public function DBUseExport() {
		
		$Result = '';
		$arSqlLookData = array();
		$tableFullDump = array( 'link', 'rule', 'objectrule', 'patern' , 'action');
    
    // Формат записи
    // Таблица => строка для записи
    $InsertData = array();
    
    
    // Получим отношение класса к таблице
    // Вида КЛАСС => ТАБЛИЦА
    $TablesClasses = array();
    foreach( get_declared_classes() as $class ){
      if( property_exists( $class , 'SqlTable' ) && !preg_match( '/^(.*)custom$/' , $class ) ){
        $T = str_replace( '`' , '' ,$class::$SqlTable );
        $TablesClasses[$T] = $class;
      }
    }
    
    // Массив для того чтобы создать все таблицы
    $AllTables = array();

    // Ищем все запросы и перестраиваем их так чтобы получить все строки из всех таблиц
		foreach( TMysql::$FQuerys->Elements as $iQuery ) {
			$Sql = $iQuery[0];
      $Sql = str_replace( array("\r","\n","\t" , "  ") , " " , $Sql );
      
      $RegValid = false;
      $M = false;
      
      if( preg_match( '/SELECT COUNT\(\*\) as \`COUNT\` FROM \(SELECT(.*)FROM(.*)\)\ \Q$/' , $Sql , $M ) || preg_match( '/SELECT(.*)FROM(.*)/i' , $Sql , $M ) ){
        $RegValid = true;
      }
      
      
      $DataTables = array();
      
      if( $RegValid ){
        $Res = DB::Select( "EXPLAIN " . $Sql );
        $Tables = array();
        while( $row = DB::Fetch($Res) ){
          if( $row['table'] ){
            if( !isset( $TablesClasses[$row['table']] ) ) {
              continue;
            }
            $Class = $TablesClasses[$row['table']];
            $F = array();
            foreach( $Class::$FInit as $Ident => $attrs ){
              if( isset( $attrs['sql'] ) ){
                $F[] = "`".$row['table']."`." . $attrs['sql'] . " as DATA".$row['table']."TAB_".$attrs['sql'];
              }
            }
            $Tables[] = implode(',',$F);
            $AllTables[$row['table']] = $row['table'];
          }
        }
        if( $Tables ){
          $M[2] = str_replace( ") Q" , "" , $M[2] );
          $Res = DB::Select( "SELECT ".implode(',',$Tables)." FROM " . $M[2] );
          $arValues = array();
          while( $Row = DB::Fetch($Res) ) {
            $fields = array();
            foreach( $Row as $Field => $Value ) {
              if( preg_match( '/DATA([a-z|\_]*)TAB\_(.*)/' , $Field , $m ) ){
                if( isset( $m[1] ) && isset( $m[2] ) ){
                  $Value = addslashes($Value);
                  $fields[$m[1]][$m[2]] = "'".$Value."'";
                }
              }
            }
            foreach( $fields as $table => $values ){
              $values_a = array_values($values);
              $InsertData[ $table ][(isset($values['id']) ? $values['id'] : md5(serialize($values)) )] = "( " . implode( ',' , $values_a ) . ")";
            }
          }
        }
      }
		}
    
    
    foreach( $AllTables as $table ){
      echo DB::ShowCreate( $table );
    }
    
    
    foreach( $InsertData as $table => $ar_str ){
      $Class = $TablesClasses[$table];
      $arFields = array();
      foreach( $Class::$FInit as $Ident => $attrs ){
        if( isset( $attrs['sql'] ) ){
          $arFields[$Ident] = $attrs['sql'];
        }
      }
      echo  "\n\nINSERT INTO $table ( ".implode( ", ", $arFields )." ) VALUES \n";
      echo implode(",\n" , $ar_str) . ";";
      echo "\n";
    }
    
    return true;
	}

	protected static $ArrayInterpriseClasses = array( 'rule' , 'converter' , 'place' , 'user' , 'meter' );

	/*
		Проверяем надо ли добавлять приписку с интерпрайзом или нет
	*/
	static function ReturnFilter($t,$param,$field = 'Interprise' )
	{
		//~ if( !Site()->FullRules and in_array( $t->ClassName, self::$ArrayInterpriseClasses ) ) {
			//~ $param[$field] = Self()->Interprise->Id;
		//~ }
		return $param;
	}

	static function ReturnFilterOld($t,$param,$field = 'Interprise' )
	{
    return $param;
		/*
    if(isset($param[$field])) return $param;

		if(in_array( get_class($t) , self::$ArrayInterpriseClasses ))
    {
  		if( (!isset($GLOBALS['FullRules']) or !$GLOBALS['FullRules']) )
  		{
  			$Filter = array(
					'Filter' => array(
						'Ident' => ucfirst($t->ClassName)
					)
				);
				$preOb = objectrule::Filter($Filter)->First;

				if($preOb->Is)
				{
					$Filter = array(
						'Filter' => array(
							'User' => Self()->Id,
							'Interprise' => 0 ,
							'Object' => array( 0 , $preOb->Id )
						)
					);
					if( !link::Filter($Filter)->Count ) $param[$field] = Self()->Interprise->Id;
  			}
  		}
    }
    */
	}

	static function RuleFilterObject($t,$aParams)
	{
    return $aParams;
    
    
		if(Self()->FullRules) return $aParams;

		/*
		 * Если фильтр вызван из All то не надо вставлять Id
		 * */
		foreach(debug_backtrace() as $i) {
			if($i['function'] == "All" && $i['class'] == $t->ClassName) return $aParams;
		}

		$IdObject = array();
		if(isset(Self()->_Rules[$t->ClassName]['View'])) {
			foreach(Self()->_Rules[$t->ClassName]['View'] as $key => $value) {
				if(is_int($key)) {
					foreach($value as $v) $IdObject[$v] = $v;
				}
			}
		}

		if(!isset($aParams['Filter'][$t->_ID]) && !isset($aParams['AddWhere'])){
			/*
			 * Если есть какие то конкретные
			 * */
			if(count($IdObject) > 1) {
				$IdObject = array_diff($IdObject,array('0'));
				if(!empty($IdObject)) {
					if(count($IdObject) > 1) {
						$aParams['Filter'][$t->_ID] = $IdObject;
					} else {
						$aParams['Filter'][$t->_ID] = end($IdObject);
					}
				}
			} elseif(empty($IdObject)) {
				$aParams['Filter'][$t->_ID] = 0;

				/*
				 * Проверяем запрос идет о пользователе? Да - себя надо вставить.
				 * */
				if($t->ClassName == get_class(Self())) {
					$aParams['Filter'][$t->_ID] = Self()->Id;
				}

			} elseif (count($IdObject) == 1 && end($IdObject) != 0) {
				$aParams['Filter'][$t->_ID] = end($IdObject);
			}
		}
		if(!Self()->IsUser) {
			$aParams['Filter'][$t->_ID] = 0;
		}
		return $aParams;
	}

	static function RuleInitObject( $t , $id = 0 )
	{
    return $id;
		if(Self()->FullRules) return $id;

		/*
		 * Если не нулевой объект
		 * */
		if($id != 0) {
			/*
				Получаем Id всех объектов для того чтобы выбрать нужный
			*/
			if(is_array(Self()->_Rules)){
				$IdObject = array();
				if(isset(Self()->_Rules[$t->ClassName]['View'])) {
					foreach(Self()->_Rules[$t->ClassName]['View'] as $key => $value) {
						if(is_int($key)) {
							foreach($value as $v) $IdObject[$v] = $v;
						}
					}
				}
			} else {
				$IdObject = array($id);
			}

			if(count($IdObject) > 1) {
				/*
				 *Если не нашли данный Id в списке прав то возвращаем 0
				 * */
				if(!in_array($id,$IdObject)) {
					return 0;
				}
				/*
				 * Если всего один объект в массиве
				 * */
			} else {
				/*
				 * Если есть в списке
				 * */
				if(in_array($id,$IdObject)) return $id;
				/*
				 * Если есть в списке 0
				 * */
				elseif(in_array(0,$IdObject)) return $id;
				else {
					return 0;
				}
			}
		}
		return intval($id);
	}

	static function ReturnDelete($t)
	{
		if(in_array( get_class($t) , self::$ArrayInterpriseClasses ))
    {
    	return ' AND '.$t->Finit['Interprise']['sql'].'='.Self()->Interprise->Id;
    }
    return '';
	}

  
  
  
  /**
   * Фильтр объектов
   * 
   * @param array $vals
   * @return TListGroup
   */
  static public function Filter( $t = null , $Params = array() ){

    // if( !func_num_args() ){
    //   return TListGroup::Init();
    // }
    // $t = func_get_arg(0);
    // if( func_num_args()>1 )
    //   $Params = func_get_arg( 1 );
    // else
    //   $Params = Array();
    if( !isset( $Params['Cache'] ) ){
    	$Params['Cache'] = !Site()->FullRules;
    }


    $ParamsKey = $Params;
    unset($ParamsKey['Cache']);
    $FilterKey = md5( serialize( $ParamsKey ) );
    $ClassName = $t->ClassName;
    if( isset( $ClassName::$_R['Filter'][$FilterKey] ) )
    {
    	return $ClassName::$_R['Filter'][$FilterKey];
    }
    $aFilterPre 		= isset($Params['Filter']) 			? $Params['Filter'] 		: Array();
    $aOrder 				= isset($Params['Order']) 			? $Params['Order'] 			: Array();
    $count 					= isset($Params['Limit']) 			? $Params['Limit'] 			: -1;
    $GrBy 					= isset($Params['GroupBy']) 		? $Params['GroupBy'] 		: '';
    $AddWhere 			= isset($Params['AddWhere']) 		? $Params['AddWhere'] 	: '';
    $NormalOrder 		= isset($Params['NormalOrder']) ? $Params['NormalOrder']: array() ;
	 if( !is_array($NormalOrder) ) {
	 	$NormalOrder = array( $NormalOrder );
	 }
#    if(empty($AddWhere)) $aFilterPre = self::ReturnFilter($t,$aFilterPre);

    $aWhere = Array();
    $aOrderBy = Array();
    $aFilter = array();
    $GroupBy = array();
    foreach( $aFilterPre as $iField=>$iValue ){
      $znak = explode( ' ', $iField, 2 );
      if( count($znak)>1 ){
        list( $nField, $nZnak ) = $znak;
        if( in_array( $nZnak, Array( '=','>','>=','<','<=','!=','LIKE', 'IS NULL', 'NOT IN', 'IN' ) )){
          $aFilter[$nField][$nZnak] = $iValue;
        }
        $iField = $nField;
      } else {
      	if( is_array($iValue) ) {
      		$aFilter[$iField]['IN'] = $iValue;
      	} else {
      		$aFilter[$iField]['='] = $iValue;
      	}
      }
    }
    foreach( $t->FInit as $kField => $iField ) {
      if( isset($aFilter[$kField]) )
      {
			$arZnak = $aFilter[$kField];
          foreach( $arZnak as $Znak => $values ) {
          	if( in_array( $Znak, array( 'IS NULL', 'IS NOT NULL' ) ) ){
          		$values = '';
          	}
       		if( is_array($values) ) {
		         $values = "'".implode( "','", array_map( "Utils::addslashes", $values ) )."'";
			      $aWhere[] = "`{$iField['sql']}` {$Znak} ({$values})";
       		} else {
		      	$values = "'".Utils::addslashes( $values )."'";
			      $aWhere[] = "`{$iField['sql']}` {$Znak} {$values}";
	      	}
				if( in_array( $kField, $NormalOrder ) ) {
					$aOrderBy[] = "FIELD( `{$iField['sql']}` , {$values})";
				}
          }
      }
      if(!empty($GrBy) && in_array($kField,$GrBy)) $GroupBy[] = "{$t->SqlTable}." . $iField['sql'];
    }
    foreach( $aOrder as $kOrder => $vOrder ) {
    	if( isset($t->FInit[$kOrder]) ) {
    		$iField = $t->FInit[$kOrder];
        $aOrderBy[] = "`{$iField['sql']}` ". ( $vOrder=='DESC' ? 'DESC':'ASC' );
    	}
    }
    $Where = ( count($aWhere)>0 ) ? ' WHERE '.implode(' AND ',$aWhere) : '';
    $OrderBy = ( count($aOrderBy)>0 ) ? ' ORDER BY '.implode(', ',$aOrderBy) : '';
    
    $GB = '';

    if(count($GroupBy) > 0){
	    $GB .= " GROUP BY ".implode(',',$GroupBy);
	    $Count = "COUNT( DISTINCT ".implode(',',$GroupBy).")";
    }else{
    	$Count = "COUNT(*)";
    }
		$NOCACHE = '';
    if($count<0) {
    	//$NOCACHE= 'SQL_NO_CACHE';
    	if( $t->SqlTable == '`meterdatahour`' ){
    		$NOCACHE= 'SQL_NO_CACHE';
      }
      $sql_count = "SELECT {$NOCACHE} {$Count} as count FROM {$t->SqlTable}{$Where}{$AddWhere}";
      $resource = DB::Select($sql_count);
      if( !$resource ){
				$count = 0;
			}else{
				try{ $sql_rez = DB::FetchNum($resource); }
				catch (Exception $e) {
					$sql_rez = DB::Fetch(TObject2::_Error($t,ER_SQL,Array('e'=>$e, 'sql'=>$sql_count)));
				}
				list($count) = $sql_rez;
			}

      DB::Log("COUNT={$count}");
      if( !isset($GLOBALS['NotAddToFile']) or !$GLOBALS['NotAddToFile'] ) {
        /*
		   if( $count > DB::WARNING_COUNT_MAX ) {
		   	trigger_error( error_reporting()." SQL RESULT too big in Filter: $count rows (SQL: FROM {$t->SqlTable}{$Where}{$AddWhere})", E_USER_WARNING ); 
				
		   }
       */
		}
    }
    else {
    	if(!is_array($count)){
    		DB::Log("count={$count}");
			}
    }
    $CountGroup = isset($Params['CountGroup']) ? ',COUNT(*) as CountGroup ' : '';
    $TrueNormalOrder = (isset($TrueNormalOrder)) ? $TrueNormalOrder : '';
    if($count == '') $count = 0;

    if( is_array($count) ){
    	$startL = (int) $count[0];
    	$stopL = (int) $count[1];
    	$LIMIT = " LIMIT " . $startL . "," . $stopL ;
    }else{
    	$LIMIT = " LIMIT 0," . $count ;
    }
    
    # task 15661
    if( isset($Params['Fields']) ){
      $Fields = '';
      $FArray = array();
      foreach($Params['Fields'] as $Field){
        if( isset( $t::$FInit[$Field]) ){
          $FArray[$Field] = "`".$t::$FInit[$Field]['sql']."`";
        }
      }
      $Fields = implode(',',$FArray);
      if( $Fields == '' ) $Fields = $t->SqlFields;
    }else{
      $Fields = $t->SqlFields;
    }

    $sql = "SELECT {$NOCACHE} {$Fields}{$CountGroup} FROM {$t->SqlTable}{$Where}{$AddWhere}{$GB}{$OrderBy}{$TrueNormalOrder} {$LIMIT}";
    if( !$Params['Cache'] ){
    	return TListGroup::Prepare( $sql, $t );
    }
    $ClassName::$_R['Filter'][$FilterKey] = TListGroup::Prepare( $sql, $t);
    return $ClassName::$_R['Filter'][$FilterKey];
  }

  static function SqlLoad($sql , $t)
	{
		$sql = preg_replace("/^(.*)WHERE(.*)WHERE(.*)$/" , "\\1WHERE\\2AND\\3" ,$sql);
		return $sql;
	}
  
  
  
  
  
  
  
  
  
  /**
   * Проверяет можно ли пользователю показывать этот объект
   * 
   * @param object $t
   * @param array $aValues
   * @return boolean
   */
  static function IsObjectInMyEnterprise( $t , $aValues ){
    
    
    /*
     * Не показывать если
     * 
     * Если это не пользователь под которым авторизовались
     * Если у этого объекта есть привязка к предприятию
     * Если это предприятие больше нуля
     * Если предприятия пользователя и объекта не совпадают
     * Если пользователь уже авторизован user::$SelfId !== null
     */
    
    
    // Если полные права - можно все
    if( Site()->GetFullRules() ){
      return true;
    }
    
    
    
    
    // По умолчанию ставим строке привязку к кабинету 0. Как общедоступную
    $InterpriseId = 0;
    
    // Проеряем есть ли привязка на самом деле. Если да, получаем идентификатор кабинета
    $aliasesEnterprise = array( 'Interprise' , 'Enterprise' );
    
    foreach( $aliasesEnterprise as $alias ){
      if( !isset( $t->_F[ $alias ] ) ){
        continue;
      }
      $key =  $t->_F[ $alias ]['sql'];
      if( isset( $aValues[ $key ] ) && $aValues[ $key ] != 0 ){
        $InterpriseId = $aValues[ $key ];
      }
    }
    
    // Если строка привзана к предприятию
    if( $InterpriseId !== 0 ){
      
      // Если у пользователя уже проверили авторизацию
      if( user::$SelfId !== null ){
        
        // Если запрашиваем пользователя, но это не тот от которого авторизовались
        // И не в предприятии в котором авторизовались
        if( get_class( $t ) === 'user' ){
          if(
              $InterpriseId &&
              $InterpriseId === Self()->Interprise->Id
            ){
            return true;
          }
          return Site()->FullRules;
        }elseif( get_class( $t ) === 'parameter' ){
          
          // У паремтров можно смотреть с предприятием 0
          // Поэтому если у параметра принудительно выставлен кабинет и он не совпадает
          if( $InterpriseId && $InterpriseId !== Self()->Interprise->Id  ){
            return false;
          }
          
        // У всех других объектов проверяем прямуцю зависимость от предприятия
        }elseif( $InterpriseId !== Self()->Interprise->Id  ){
          return Site()->FullRules;
        }
      }
    }
    return true;
  }
  
  
  
  
  
  
  
  
  
  
  
  
  
  

  
  /**
   * Наполнение объекта значениями
   * 
   * @param object $t
   * @param array $aValues
   * @return boolean
   */
  static protected function _DataSetAll(&$t,$aValues) {
    
    // Проверка на доступность объекта
    if( !self::IsObjectInMyEnterprise( $t , $aValues ) ){
      return false;
    }
    
    $allFileds = true;
    foreach( $t->_F as $k=>$i ){
      if( isset($t->_F[$k]['sql'],$aValues[$t->_F[$k]['sql']]) ){
        if( !$t->_F[$k]['ready'] ){
          $t->_F[$k]['value'] = Utils::stripslashes( $aValues[$t->_F[$k]['sql']] );
          $t->_F[$k]['ready'] = true;
        }
      }
      if( !$t->_F[$k]['ready'] and !in_array($t->_F[$k]['type'],Array('multy')) ) {
        $allFileds = false;
      }
      if( isset($t->_F[$k]['sql']) and array_key_exists( $t->_F[$k]['sql'], $aValues) ) {
			 unset( $aValues[$t->_F[$k]['sql']] );
      }
    }
    if( $allFileds ) {
      $t->_State = OBJECT_LOADED;
    }
      if( count($aValues) ) {
		    if(property_exists($t , '_OtherData')) $t->_OtherData = $aValues;
    	}
    return $allFileds;
    	if( TObject2::$Debug ){
		    $class = get_class( $this );
	    	echo "DataSET [{$class}:{$this->Id}] \n";
    	}
  }


  protected function __construct() {
    $this->_State = OBJECT_NO;
    $class = get_class( $this );
  	if( TObject2::$Debug ){
      echo memory_get_usage()." SET [{$class}][{$this->Id}] \n";
  	}
    TObject2::$_UseObjects[$class] = $class;
  }

  function Save()
  {
    if( isset($this->_Update) and $this->_Update){
      TObject2::_SqlUpdate($this);
    }
  }
  
  public function Desctruct(){
    foreach( get_declared_classes() as $class ) {
      if ( is_subclass_of($class, 'TObject2') ){
        if( property_exists( $class, "_O" ) ){
          foreach( $class::$_O as $id => $iClass ){
            if(self::$Debug)  echo memory_get_usage()." UNSET [{$class}][{$id}] \n";
            if( isset($iClass->_Update) and $iClass->_Update ){
              TObject2::_SqlUpdate($iClass);
            }
            if(isset($class::$_O[$id]) ) {
              if(method_exists($class::$_O[$id] , '__destruct')){
                $class::$_O[$id]->__destruct();
              }
              unset( $class::$_O[$id] );
            }
          }
        }
      }
    }
    return true;
  }
  
  function __destruct(){
  }
  
  static function SqlFromObject( $t = null )
  {
  	$FirstUp = ucfirst($t->ClassName);

  	/* objects */
  	$oAction 			= action::Id(0);
  	$oPatern 			= patern::Id(0);
  	$oLink 				= link::Id(0);
  	$oObjectrule 	= objectrule::Id(0);
  	# SqlTable
  	$SQL = preg_replace( '/[\r\n\t]+/', ' ', "
			SELECT    {$t->SqlTable}.`{$t::$FInit['Id']['sql']}`
			FROM      {$t->SqlTable}
			LEFT JOIN {$oAction->SqlTable}
			ON        {$oAction->SqlTable}.`{$oAction::$FInit['Name']['sql']}`='{$FirstUp}'
			LEFT JOIN {$oPatern->SqlTable}
			ON        {$oAction->SqlTable}.`{$oAction::$FInit['Id']['sql']}` = {$oPatern->SqlTable}.`{$oPatern::$FInit['Action']['sql']}`
			LEFT JOIN {$oLink->SqlTable}
			ON        {$oPatern->SqlTable}.`{$oPatern::$FInit['Rule']['sql']}` = {$oLink->SqlTable}.`{$oLink::$FInit['Rule']['sql']}`
			AND       {$oLink->SqlTable}.`{$oLink::$FInit['User']['sql']}`=".(Self()->Id)."
			AND       {$oLink->SqlTable}.`{$oLink::$FInit['Interprise']['sql']}`=".(Self()->Interprise->Id)."
			LEFT JOIN {$oObjectrule->SqlTable}
			ON        {$oLink->SqlTable}.{$oLink::$FInit['Objectrule']['sql']}={$oObjectrule->SqlTable}.`{$oObjectrule::$FInit['Id']['sql']}`
			AND       {$oObjectrule->SqlTable}.`{$oObjectrule::$FInit['Ident']['sql']}`='{$FirstUp}'
			WHERE (   {$t->SqlTable}.`{$t::$FInit['Id']['sql']}` = {$oLink->SqlTable}.`{$oLink::$FInit['Whyid']['sql']}`
			OR        {$oLink->SqlTable}.`{$oLink::$FInit['Whyid']['sql']}`=0)
			AND       {$oLink->SqlTable}.`{$oLink::$FInit['Id']['sql']}` IS NOT NULL " );
		return $SQL;
  }

  static function _PreInit(&$t,$id) {
    $id=intval($id);
    if($id<0) die;
    $t->_F = $t->FInit;
    $t->_F[$t->_ID]['value'] = $id;
    $t->_State = OBJECT_INITED;
  }

  static public function &DataLoadSqlToArray(&$t,$sql) {
    $FilterKey = md5( serialize( $sql ) );
    $ClassName = $t->ClassName;
    if( isset($ClassName::$_R['Filter'][$FilterKey]) ){
      return $ClassName::$_R['Filter'][$FilterKey];
    }
    $aRez = Array();
  	if($sql!=''){
      try{ $sql_rez = DB::Select($sql); }
      catch (Exception $e) {
        $sql_rez = TObject2::_Error($t,ER_SQL,Array('e'=>$e, 'sql'=>$sql));
      }
      while($aValues = DB::Fetch($sql_rez)) {
				$aRez[] = $t->Init($t,$aValues);
			}
    }
    
    # Если ошибка запроса 
    if( !$sql_rez ){
			DB::WhyError( $t );
			$sql_rez = DB::Select($sql);
			while($aValues = DB::Fetch($sql_rez)) {
				$aRez[] = $t->Init($t,$aValues);
			}
		}
		
		$ClassName::$_R['Filter'][$FilterKey] = $aRez;
    
    return $aRez;
  }

  static protected function _DataLoadSql(&$t) {
		if( OBJECT_LOADED == $t->_State ) {
      return true;
    }
    if( $t->_F[$t->_ID]['value'] == 0 ){
      return false;
    } 
    $sql = "SELECT {$t->SqlFields} FROM {$t->SqlTable} WHERE `{$t->_F[$t->_ID]['sql']}`={$t->_F[$t->_ID]['value']} LIMIT 1";
    try{
      $sql_rez = DB::Select($sql);
    }
    catch (Exception $e) {
      $sql_rez = TObject2::_Error($t,ER_SQL,Array('e'=>$e, 'sql'=>$sql));
    }
    
    # Если ошибка запроса 
    if( !$sql_rez ){
			DB::WhyError( $t );
      $sql_rez = DB::Select($sql);
    }

    if($aValues = DB::Fetch($sql_rez) and TObject2::_DataSetAll($t,$aValues) ) {
      return true;
    }else{
      $t->_F[$t->_ID]['value'] = 0;
      return false;
    }
  }

  static public function _Error(&$t, $e, array $Info = Array() ){
    switch ($e) {
     case ER_SQL:
       if( method_exists("DB",$ErFunc = "FixError".$Info['e']->getCode()) ){
         if( DB::$ErFunc(
             isset($Info['SqlTable']) ? $Info['SqlTable'] : $t->SqlTable,
             isset($Info['FInit']) ? $Info['FInit'] : $t->FInit,
             isset($Info['_ID']) ? $Info['_ID'] : $t->_ID) ) {
           return isset($Info['sql']) ? DB::Select($Info['sql']) : '';
         }else return '';
       }
       echo "<br />ОШИБКА SQL: {$Info['sql']}<br />\r\n";
       echo $Info['e']->getCode().": ".$Info['e']->getMessage()."<br />\r\n";
       echo $Info['e']->getLine().": ".$Info['e']->getFile()."<br />\r\n";
       echo nl2br($Info['e']->getTraceAsString())."<br />\r\n";
       break;
     case ER_OBJECT:
       echo "<br />ОШИБКА объекта: {$t->ClassName}->{$Info['property']}";
       break;
     case ER_PROPERTY:
       if( defined( '__PHPUNIT_PHAR__' ) )
       {
       	throw new PHPUnit_Framework_ComparisonFailure(
       		'1', '2', '', '', FALSE,
            "Ошибка свойства объекта {$t->ClassName}[".(isset($t->_F[$t->_ID]['value'])?$t->_F[$t->_ID]['value']:0)."]->{$Info['property']}\n" );
       	return false;
       }
       echo "<br />ОШИБКА свойства: {$t->ClassName}[".(isset($t->_F[$t->_ID]['value'])?$t->_F[$t->_ID]['value']:0)."]->{$Info['property']}\r\n".TObject2::_getProps($t);
       echo "<pre>Included files:\n";
       $cutlen = strlen(realpath($_SERVER['DOCUMENT_ROOT']));
       foreach( get_included_files() as $N=>$iFileName )
       {
         $iFileName = substr( $iFileName, $cutlen );
         echo  $N.": ".$iFileName."\n";
       }
       debug_print_backtrace();
       echo "</pre>";
       break;
     default:
       echo "<br />Неизвестная ошибка: ".print_r($Info,true);
    }
    die();
  }
  
  static function TSetLog(&$t){
    //~ if( property_exists( $t, 'NeedDoUserLog' ) && $t->NeedDoUserLog ){
      
      //~ $class = get_class( $t );
      
      //~ $Filter = array( 
        //~ 'Filter' => array( 
          //~ 'Id' => $t->Id
        //~ )
      //~ );
      
      //~ $old_value = DB::Fetch( DB::Select( $class::Filter( $Filter )->Sql ) );
    //~ }
  }

  
  
  
  
  /**
   * Обновление модели в БД
   * 
   * @param any_class $t
   * @return boolean
   */
  static protected function _SqlUpdate(&$t) {

    $ar = array();
    
    foreach( $t->_F as $kField => $iField){
      if( in_array( $iField['type'] , array( 'fltcnt' , 'multy' ) ) ){
        continue;
      }
      
      if( isset($iField['oldvalue']) && $iField['type'] != 'fltcnt' ){
        $ar[ $kField . ( $iField['type'] == 'object' ? 'Id' : "" ) ] = $iField['value'];
        unset( $iField['oldvalue'] );
      }else{
        if( $iField['type'] == 'object' ){
          $ar[ $kField . "Id" ] = $t->$kField->Id;
        }else{
          $ar[ $kField ] = $t->$kField;
        }
      }
    }
    $t->_Update = false;
    self::StaticUpdateByArray( $t , $ar );
    return true;
  }
  
  
  

  static public function StaticDelete(&$t) {
    
    if( !Self()->FullRules && !Self()->IsAdmin ){
      return false;
    }

		$sql = "DELETE FROM {$t->SqlTable} WHERE `{$t->_F[$t->_ID]['sql']}`={$t->_F[$t->_ID]['value']} LIMIT 1";
	  try{
      if( property_exists( $t, 'NeedDoUserLog' ) && $t->NeedDoUserLog ){
        $class = get_class( $t );
        $Filter = array( 
          'Filter' => array( 
            'Id' => $t->Id
          )
        );
        $old_value = DB::Fetch( DB::Select( $class::Filter( $Filter )->Sql ) );
        $new_value = array();
        $new_diff = array();
        $old_diff = array();

        if( !is_array( $new_value ) ){
          $new_value = array();
        }
        
        if( !is_array( $old_value ) ){
          $old_value = array();
        }
        
        foreach( array_diff_assoc( $new_value , $old_value ) as $key =>$val ){
          
          foreach( $class::Id(0)->_F as $Ident => $attrs ){
            if( in_array( $attrs['type'] , array( 'multy' , 'fltcnt') ) ) continue;
            if( $Ident == 'FieldsToJSON' ) continue;
            if( isset( $attrs['sql'] ) && $attrs['sql'] == $key && $attrs['type'] != "fltcnt"  ){
              $new_diff[ $Ident ] = $new_value[ $key ];
              $old_diff[ $Ident ] = $old_value[ $key ];
            }
          }
        }
        userlog::AddByArray(array(
          'UserId' => Self()->Id,
          'Object' => $class,
          'ObjectId' => $t->Id,
          'Property' => "Delete",
          'Action' => json_encode( array('new' => $new_diff , 'old' => $old_diff) )
        ));
        
      }
	  	DB::Query($sql);
	  }
	  catch (Exception $e) {
	    TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
	  }
	  
	  if(DB::AffectedRows()==0); //TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
	  if( is_callable( array($t,'OnAfterDelete') ) )
	    $t->OnAfterDelete();
  }

  static public function StaticUpdateByRequest(&$t) {
    TObject2::StaticUpdateByArray($t,$_REQUEST);
  }

  
  /**
   * Перезапись массива если это запрос пришел через API
   * 
   * Все что не содержится в $FInit у объекта отправляется в поле [__invalid]
   * 
   * @return array
   */
  function ReplaceByAPI(){
    
    $A = array();

    if( !defined( "__PHPUNIT_PHAR__" ) ){
      if( Site()->API_Type() === "GET" ){
        return $A;
      }
    }
    
    if( !property_exists( $this , 'FieldsToJSON') ){
      return $A;
    }
  
    if( defined( "__PHPUNIT_PHAR__" ) ){
      $data = $_POST;
    }else{
      $data = (array) json_decode( file_get_contents("php://input") );
    }

    if( isset( $_REQUEST["model"]  ) ){
      $data = (array) json_decode( $_REQUEST["model"] );
    }

    
    $flip_A = array_flip($this->FieldsToJSON);
    
    foreach( $data as $js_ident => $value ){
      
      if( !isset( $flip_A[ $js_ident ] ) ){
        continue;
      }

      $key_obj = $flip_A[ $js_ident ];
      
      if( !isset( $this::$FInit[ $key_obj ] ) || !isset( $this::$FInit[ $key_obj ]['sql'] ) ){
        $A['__invalid'][ $key_obj ] = $value;
        continue;
      }
      
      $prop_obj = $this::$FInit[ $key_obj ];
      
      $key = $prop_obj['type'] === 'object' ? $key_obj . "Id" : $key_obj;

      $A[ $key ] = $value;
    }
    
    return $A;
  }
  
  
  
  
  
  
  
  /**
   * Обновление модели в БД
   * 
   * @param any_class $t
   * @param array $A
   * @return boolean
   */
  static public function StaticUpdateByArray(&$t,&$A) {
    
    // Если это и не администратор и не рут
    if( !Self()->FullRules && !Self()->IsAdmin ){
      return false;
    }
    
    // Запрет на редактирование не в своем предприятии
    foreach( array( 'Enterprise' , 'Interprise' ) as $alias ){
      // Если есть полные права то предприятие игнорируется
      if( Self()->FullRules ){
        continue;
      }
      if( isset( $t->_F[ $alias ] ) && $t->$alias->Id != Self()->Interprise->Id ){
        return false;
      }
    }
    
    
    $A['AUser'] = Self()->Id;
    $sqlupdates = Array();
    
    // Перебираем все поля
    foreach( $t->FInit as $kField=>$iField ) {
      if( (isset($A[$kField]) and !in_array($iField['type'],Array('id','object')) )
      or(isset($A[$kField.'Id']) and in_array($iField['type'], Array('object','multy')) )
      or(isset($A[$kField]) and in_array($iField['type'],Array('ts','multy','float','float_abs','int','int_abs')) )
      or in_array($iField['type'],Array('uts','uip','bool')) ) {

      	$new_value = null;
        
        if( in_array($iField['type'], Array('string','text')) ){
        	$new_value = Utils::addslashes($A[$kField]);
          $sqlupdates[]="`{$iField['sql']}`='".$new_value."'";
        }
        elseif($iField['type']=='float'){
        	$new_value = floatval(str_replace(',','.',$A[$kField]));
          $sqlupdates[]="`{$iField['sql']}`='".$new_value."'";
        }
        elseif($iField['type']=='float_abs'){
        	$new_value = abs(floatval(str_replace(',','.',$A[$kField])));
          $sqlupdates[]="`{$iField['sql']}`='".$new_value."'";
        }
        elseif($iField['type']=='int'){
        	$new_value = intval($A[$kField]);
          $sqlupdates[]="`{$iField['sql']}`='".$new_value."'";
        }
        elseif($iField['type']=='int_abs'){
        	$new_value = abs(intval($A[$kField]));
          $sqlupdates[]="`{$iField['sql']}`='".$new_value."'";
        }
        elseif($iField['type']=='object'){
        	$new_value = $A[$kField.'Id'];
          if( isset($A[$kField.'Id']) ) $sqlupdates[]="`{$iField['sql']}`=".$new_value;
        }
        elseif($iField['type']=='bool'){
        	$new_value = isset($A[$kField]) && (int)$A[$kField] !=0?1:0;
          $sqlupdates[]="`{$iField['sql']}`=".$new_value;
        }
        elseif($iField['type']=='uts'){
        	$new_value = time();
          $sqlupdates[]="`{$iField['sql']}`=".$new_value;
        }
        elseif($iField['type']=='ip'){
        	$new_value = ip2long($A[$kField]);
          $sqlupdates[]="`{$iField['sql']}`=".$new_value;
        }
        elseif($iField['type']=='uip'){
        	$new_value = ip2long($_SERVER['REMOTE_ADDR']);
          $sqlupdates[]="`{$iField['sql']}`=".$new_value;
        }
        elseif($iField['type']=='ts'){
          if( is_array($A[$kField] )){
          $new_value = TObject2::_arrtots($A[$kField]);
          $sqlupdates[]="`{$iField['sql']}`=".$new_value;
          }elseif(preg_match('|(\d{4}).(\d{2}).(\d{2})|',$A[$kField],$M)){
          	$new_value = mktime(0,0,0,$M[2],$M[3],$M[1]);
            $sqlupdates[]="`{$iField['sql']}`=".$new_value;
          }elseif(preg_match('|(\d{2}).(\d{2}).(\d{4})|',$A[$kField],$M)){
          	$new_value = mktime(0,0,0,$M[2],$M[1],$M[3]);
            $sqlupdates[]="`{$iField['sql']}`=".$new_value;
          }else{
          	$new_value = $A[$kField];
            $sqlupdates[]="`{$iField['sql']}`='".$new_value."'";
          }
          
        }elseif($iField['type']=='multy'){
          eval("\$FInit = {$iField['multy']}::\$FInit;");
          foreach( $FInit as $kF => $iF)
            if( $iF['type']=='object' and $iF['object']==$t->ClassName ){
              $LF = $kF;
              $M[$kF.'Id'] = $t->_F[$t->_ID]['value'];
            }
          $P = Array('Filter'=>Array($LF=>$t->_F[$t->_ID]['value']));
          eval("\$L = {$iField['multy']}::Filter(\$P);");
          $L->DeleteAll();
          if( isset($A[$kField.'Id']) )foreach($A[$kField.'Id'] as $id){
            if( $id > 0 ){
              $M[$iField['multylink']]=$id;
              eval("{$iField['multy']}::AddByArray(\$M);");
            }
          }
        }else{
          if( isset( $A[$kField] ) && !is_object( $A[$kField]) ){
            $new_value = $A[$kField];
            $sqlupdates[]="`{$iField['sql']}`='{$new_value}'";
          }
        }
        

        if( $new_value !== null ){
		      if( $t->_F[$kField]['value'] != $new_value ) {
			      $t->_F[$kField]['oldvalue'] = $t->_F[$kField]['value'];
			      $t->_F[$kField]['value'] = $new_value;
			      //~ TObject2::TSetLog($t,$kField);
		      }
        }

      }
    }
    if( is_callable( array( $t, 'OnBeforeSqlUpdate' ) ) ) {
    	$t->OnBeforeSqlUpdate($A);
    }
    if( count($sqlupdates)>0 ){
      $sql = "UPDATE {$t->SqlTable} SET ".implode(',', $sqlupdates)." WHERE `{$t->_F[$t->_ID]['sql']}`={$t->_F[$t->_ID]['value']} LIMIT 1";
      try{
        $class = get_class( $t );
        $Filter = array( 
          'Filter' => array( 
            'Id' => $t->Id
          )
        );


        if( property_exists( $t, 'NeedDoUserLog' ) && $t->NeedDoUserLog ){
          $old_value = DB::Fetch( DB::Select( TObject2::Filter( $t , $Filter )->Sql ) );
        }
        DB::Query($sql);
        if( property_exists( $t, 'NeedDoUserLog' ) && $t->NeedDoUserLog ){
          
          
          $new_value = DB::Fetch( DB::Select( TObject2::Filter( $t , $Filter )->Sql ) );
          $new_diff = array();
          $old_diff = array();
          
          
          if( $new_value && $old_diff ){
            foreach( array_diff_assoc( $new_value , $old_value ) as $key =>$val ){

              foreach( $class::$FInit as $Ident => $attrs ){
                if( isset( $attrs['sql'] ) && $attrs['sql'] == $key && $attrs['type'] != "fltcnt"  ){
                  if( property_exists( $t, 'IgnoreDoUserLog' ) ){
                    if( array_search( $Ident , $t->IgnoreDoUserLog) === false ){
                      $new_diff[ $Ident ] = $new_value[ $key ];
                      $old_diff[ $Ident ] = $old_value[ $key ];
                    }
                  }else{
                    $new_diff[ $Ident ] = $new_value[ $key ];
                    $old_diff[ $Ident ] = $old_value[ $key ];
                  }
                }
              }
            }
          }
          if( $new_diff || $old_diff ){
            userlog::AddByArray(array(
              'UserId' => Self()->Id,
              'Object' => $class,
              'ObjectId' => $t->Id,
              'Property' => "Update",
              'Action' => json_encode( array('new' => $new_diff , 'old' => $old_diff) )
            ));
          }
        }
      }
      catch (Exception $e) {
        TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
      }
      
      # добавление дополнительных полей для объектов
      if( isset( $A['MoreFields'] ) ){
        self::ActionForMoreFields($t,$A);
      }
      
      if(DB::AffectedRows()==0); //TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
    }
    if( is_callable( array($t,'OnAfterSqlUpdate') ) ){
      $t->OnAfterSqlUpdate( $A );
    }
  }

  static function _arrtots(array $a){
    if(!isset($a['Second'])) $a['Second']=0;
    return mktime($a['Hour'],$a['Minute'],$a['Second'],$a['Month'],$a['Day'],$a['Year']);
  }

  static public function StaticAddByRequest(&$t) {
    return TObject2::StaticAddByArray($t,$_REQUEST);
  }
  
  # Добавление и редактивраоние дополнительных полей у объектов
  static function ActionForMoreFields($t,$A){
    # TODO не правильно составлена форма. Нет фозможности передать id поля в которое надо загружать.
    # Возможно полем будет
    $IdFields = array();
    $sql = "select fields.id,typefields.ident from fields left join typefields on typefields.id = fields.typefields_id left join fieldsobject on fieldsobject.fields_id = fields.id WHERE typefields.ident IN('img','file') and fieldsobject.object = '".get_class($t)."'";
    $res = DB::Select($sql);
    while($row = DB::Fetch($res)){
      $IdFields[$row['ident']] = $row['id'];
    }
    
    $Utils = new Utils;
    
    $ExtYes = array(
      'image/gif',
      'image/jpeg',
      'image/pjpeg',
      'image/png',
      'image/svg+xml',
      'image/tiff',
      'image/vnd.wap.wbmp',
      'image/webp',
      'application/vnd.oasis.opendocument.text',
      'application/vnd.oasis.opendocument.spreadsheet',
      'application/vnd.oasis.opendocument.presentation',
      'application/vnd.oasis.opendocument.graphics',
      'application/vnd.ms-excel',
      'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet',
      'application/vnd.ms-powerpoint',
      'application/vnd.openxmlformats-officedocument.presentationml.presentation',
      'application/msword',
      'application/vnd.openxmlformats-officedocument.wordprocessingml.document',
    );
    
    if( !in_array( $_FILES['MoreFields_file']['type'] , $ExtYes)) {
      if( Site()->IsAjax() ){
        echo "invalid format data";
      }
      return false;
    }
    
    
    # Файлы
    if( isset($_FILES['MoreFields_file']) ){
      $loadFile = $Utils->LoadFile($_FILES['MoreFields_file'],$t);
    }
    # Изображения
    if( isset($_FILES['MoreFields_img']) ){
      $loadFile = $Utils->UploadImageSave($_FILES['MoreFields_img']);
      if( $loadFile->Id ){
        $A['MoreFields'][$IdFields['img']] = $loadFile->Id;
      }
    }
  
    # Если на объекте есть это поле
    if( fieldsobject::IsAssignedMoreFields(get_class($t))){
      $Filter = array(
        'Filter' => array(
          'Objectid'  => $t->Id,
  	      'Object'    => get_class($t)
        )
      );
      $ArValue = array();
      foreach( fieldsvalue::Filter($Filter)->Elements as $iValue ){
        $ArValue[$iValue->Fields->Id] = $iValue;
      }
  	  foreach( $A['MoreFields'] as $id => $value ){
  	    # Если в БД уже есть значение
  	    
  	    if( isset( $ArValue[$id] ) && $ArValue[$id]->Value ){
  	      # Если они совпадают с текущим то ничего не делаем.
  	      if( $ArValue[$id]->Value == $value ){
    	      unset($ArValue[$id]);
    	      continue;
    	    # Если они не совпадают то у текущего значения выставляем значения нового
  	      }elseif( $ArValue[$id]->Value != $value ){
  	        $ArValue[$id]->Value = $value;
  	        unset($ArValue[$id]);
  	        continue;
  	      }
  	    }
  	    
  	    DB::Log("NOT VALUE");
  	    # Если такого поля в БД нет то его надо добавить
  	    fieldsvalue::AddByArray(array(
  	      'Objectid'  => $t->Id,
  	      'Object'    => get_class($t),
  	      'Value'     => $value,
  	      'FieldsId'  => $id
  	    ));
  	  }
  	  # Это остались лишние поля которые надо удалить
  	  foreach( $ArValue as $id => $iValue ){
  	    if( $id == $IdFields['file'] || $id == $IdFields['img'] ){
  	      continue;
  	    }else{
  	      # Ищем объекты которые надо отвязать
  	      $iValue->Delete();
  	    }
  	  }
	  }
    if( isset($_FILES['MoreFields_file']) ){
      echo $_FILES['MoreFields_file']['name'];
    }
  }
  
  # получение списка пользователей, имеющих права на этот объект
  static function ListUserPermForObject($t){
    $sql = str_replace( array("\n","\r","\t") , "" , "SELECT link.* FROM link 
    LEFT JOIN objectrule ON objectrule.id = link.objectrule_id
    LEFT JOIN rule ON rule.id = link.rule_id 
    LEFT JOIN user ON user.id = link.user_id
    WHERE objectrule.id = {$t->MyTypeObject} 
    and link.whyid ={$t->Id} 
    and link.user_id > 101
    and user.type = 0
    and link.interprise_id = {$t->Interprise->Id}
    GROUP BY user_id , rule_id, whyid,objectrule_id
    ORDER BY user.fio ASC");
    $t = link::Id(0);
    return TListGroup::Prepare( $sql , $t );
  }
  
  public function GetDirForUploadsFile_2(){
    return get_class($this)."/";
  }
  
  public function GetDirForUploadsFile_1(){
    return "images/";
  }
  
  public function GetDirForUploadsFile(){
    return $_SERVER['DOCUMENT_ROOT'].$this->DirForUploadsFilePub."/";
  }
  
  public function GetDirForUploadsFilePub(){
    return "/".$this->DirForUploadsFile_1.$this->DirForUploadsFile_2."{$this->Id}";
  }
  
  function GetReadDirFiles(){
    $dir = $this->DirForUploadsFile;
    $F = array();
    if ($handle = @opendir($dir)) {
        while (false !== ($entry = readdir($handle))) {
          if( $entry == "." || $entry == ".." ) continue;
          $F[] = $entry;
        }
        closedir($handle);
    }
    return $F;
  }

  static public function StaticAddByArray(&$t,&$A) {
    
    if( !Self()->IsAdmin && !Self()->FullRules ) return false;
    
    $A['AUserId'] = Self()->Id;
    $sqlupdates = Array('f'=>Array(),'v'=>Array());
    $multy_add = Array();
    foreach( $t->FInit as $kField=>$iField) {
      if( (isset($A[$kField]) and !in_array($iField['type'],Array('id','object')) )
      or(isset($A[$kField.'Id']) and in_array($iField['type'],Array('object','multy')) )
      or in_array($iField['type'],Array('its','ts','bool','float','float_abs','int','iip','uip','ip','int_abs')) ) {
        
        if( !isset( $A[$kField] ) ){
          $A[$kField] = in_array( $iField['type'] , array('string' , 'text') ) ? "" : 0;
        }

        if( !in_array($iField['type'], Array('multy'))){
          $U = $iField['sql'];
          $sqlupdates['f'][$U]="`{$iField['sql']}`";
        }
        if( in_array($iField['type'], Array('string','text')) ){
          $sqlupdates['v'][$U]=Utils::addslashes($A[$kField]);
        }
        elseif($iField['type']=='float'){
          $sqlupdates['v'][$U]=floatval(str_replace(',','.',$A[$kField]));
        }
        elseif($iField['type']=='float_abs'){
          $sqlupdates['v'][$U]=abs(floatval(str_replace(',','.',$A[$kField])));
        }
        elseif($iField['type']=='int'){
          $sqlupdates['v'][$U]= isset($A[$kField]) ? intval($A[$kField]) : 0;
        }
        elseif($iField['type']=='int_abs'){
          $sqlupdates['v'][$U]= isset($A[$kField]) ? abs(intval($A[$kField])) : 0 ;
        }
        elseif($iField['type']=='object'){
          $sqlupdates['v'][$U]=$A[$kField.'Id'];
        }
        elseif($iField['type']=='bool'){
          $sqlupdates['v'][$U]= (isset( $A[$kField] ) and $A[$kField] )?1:0;
        }
        elseif($iField['type']=='its'){
          $sqlupdates['v'][$U]=time();
        }
        elseif($iField['type']=='ip'){
          $sqlupdates['v'][$U]=ip2long($A[$kField]);
        }
        elseif(in_array($iField['type'],Array('uip','iip'))){
        	if( !isset( $_SERVER['REMOTE_ADDR'] ) ) {
        		$_SERVER['REMOTE_ADDR'] = '127.0.0.1';
          }
          $sqlupdates['v'][$U] = ip2long( $_SERVER['REMOTE_ADDR'] );
        
          if( $sqlupdates['v'][$U] === false ){
            $sqlupdates['v'][$U] = ip2long('127.0.0.1');
          }
        }
        elseif($iField['type']=='ts')
        {
          if( !isset($A[$kField]) ){
          	$sqlupdates['v'][$U] = 0;
          }elseif( is_array($A[$kField] )){
            $sqlupdates['v'][$U] = TObject2::_arrtots($A[$kField]);
          }elseif(preg_match('|(\d{4})\.(\d{2})\.(\d{2})|',$A[$kField],$M)){
            $sqlupdates['v'][$U] = mktime(0,0,0,$M[2],$M[3],$M[1]);
          }elseif(preg_match('|(\d{2})\.(\d{2})\.(\d{4})|',$A[$kField],$M)){
            $sqlupdates['v'][$U] = mktime(0,0,0,$M[2],$M[1],$M[3]);
          }else{
            $sqlupdates['v'][$U] = $A[$kField];
          }
        }
        elseif($iField['type']=='multy'){
          $multy_add[] = Array('iField'=>$iField, 'kField'=>$kField);
        }
        else{
          $sqlupdates['v'][$U]=$A[$kField];
        }
      }else{
        if( isset($iField['sql']) && $iField['sql'] ){
          
          if( $iField['type'] === 'id' ){
            continue;
          }
          
          $U = $iField['sql'];
          
          $def_value_str = isset( $A[$kField] ) ? $A[$kField] : "";
          $def_value_int = isset( $A[$kField] ) ? (int) $A[$kField] : 0;
                  
          $sqlupdates['f'][$U]="`{$iField['sql']}`";
          $sqlupdates['v'][$U]= in_array( $iField['type'] , array('string' , 'text') ) ? $def_value_str : $def_value_int ;
        }
      }
    }
    if( count($sqlupdates['f'])>0 ){
      $sql = "INSERT INTO {$t->SqlTable}(".implode(",", $sqlupdates['f']).") VALUES ('".implode("','", $sqlupdates['v'])."')";
      try{
        $res = DB::Query($sql);
      }
      catch (Exception $e) {
        TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
      }
      if(DB::AffectedRows()==0) return false;//TObject2::_Error($t,ER_SQL,Array('e'=>$e,'sql'=>$sql));
      else{
        TObject2::_PreInit($t,DB::InsertId());
        
        //~ if( isset( $A['MoreFields'] ) ){
          //~ self::ActionForMoreFields($t,$A);
        //~ }
  	
        foreach($multy_add as $iMulty){
          $iField = $iMulty['iField'];
          $kField = $iMulty['kField'];
          eval("\$FInit = {$iField['multy']}::\$FInit;");
          foreach( $FInit as $kF => $iF)
            if( $iF['type']=='object' and $iF['object']==$t->ClassName ){
              $LF = $kF;
              $M[$kF.'Id'] = $t->_F[$t->_ID]['value'];
            }
          $P = Array('Filter'=>Array($LF=>$t->_F[$t->_ID]['value']));
          eval("\$L = {$iField['multy']}::Filter(\$P);");
          $L->DeleteAll();
          if( isset($A[$kField.'Id']) )foreach($A[$kField.'Id'] as $id){
            $M[$iField['multylink']]=$id;
            eval("{$iField['multy']}::AddByArray(\$M);");
          }
        }
      }
    }
    if( is_callable( array($t,'OnAfterSqlInsert') ) )
      $t->OnAfterSqlInsert( $A );
      
    if( property_exists( $t, 'NeedDoUserLog' ) && $t->NeedDoUserLog ){
          
      $old_value = array();
      
      $class = get_class( $t );
      $Filter = array( 
        'Filter' => array( 
          'Id' => $t->Id
        )
      );
      
      $new_value = DB::Fetch( DB::Select( $class::Filter( $Filter )->Sql ) );
      $new_diff = array();
      $old_diff = array();
      
      if( is_array($new_value) ){
        foreach( array_diff_assoc( $new_value , $old_value ) as $key =>$val ){
          
          foreach( $class::Id(0)->_F as $Ident => $attrs ){
            if( isset($attrs['sql']) && $attrs['type'] != "fltcnt" ){
              if( $attrs['sql'] == $key ){
                $new_diff[ $Ident ] = $new_value[ $key ];
              }
            }
          }
        }
      }
      userlog::AddByArray(array(
        'UserId' => Self()->Id,
        'Object' => $class,
        'ObjectId' => $t->Id,
        'Property' => "Add",
        'Action' => json_encode( array('new' => $new_diff , 'old' => $old_diff) )
      ));
      
    }
    
    
    return true;
  }

  static protected function _getHelpMeth(&$t) {
    $help = get_class_methods($t);
    $meth = Array();
    if( property_exists( $t, 'FInit' )  )
      foreach( $t->FInit as $kField => $iField) $meth[$kField] = Array(1,1);
    for ($i=0; $i<sizeof($help); $i++) {
      $name = $help[$i];
      $sname = substr($name,0,3);
      if(($name<>'Help')and(substr($name,0,1) <> '_')){
        if($sname == 'Set'){
          $meth[substr($name,3)][0] = 1;
        }elseif($sname == 'Get'){
          $meth[substr($name,3)][1] = 1;
        }else{
          $meth[$name][2] = 1;
        }
      }
    }
    return $meth;
  }

  static function ValueInRule($t,$n,$value) {
    return $value;
  	//~ if( Self()->Rules( get_class($t) , $t->Id , "View" . $n ) ){
  		//~ return $value;
  	//~ }
  	//~ return "";
  }


  static public function _getProps(&$t) {
    $meth = $t->_getHelpMeth($t);
    $props = Array();
    foreach ($meth as $key => $value){
      if( !isset($rwf[2]) ) $props[] = $key;
    }
    return implode("\r\n", $props);
  }

  static protected function _get_id(&$t,&$p) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return $p['value'];
  }

  static protected function _get_int(&$t,&$p,$n='') {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return self::ValueInRule($t,$n,$p['value']);
  }

  static protected function _setvalue(&$t,&$p,$v,$n='') {
    if( $p['value'] != $v ){
      $p['oldvalue'] = $p['value'];
      $p['value'] = $v;
      $p['ready'] = true;
      $t->_Update = true;
    }
  }

  static protected function _set_int(&$t,&$p,$v,$n) {
    $v = intval($v);
    TObject2::_setvalue($t,$p,$v,$n);
  }

  static protected function _get_int_abs(&$t,&$p) {
    return TObject2::_get_int($t,$p);
  }

  static protected function _set_int_abs(&$t,&$p,$v,$n) {
    $v = intval($v);
    if($v<0) $v=0;
    TObject2::_setvalue($t,$p,$v,$n);
  }

  static protected function _get_float(&$t,&$p) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return $p['value'];
  }

  static protected function _set_float(&$t,&$p,$v,$n) {
  	$v = str_replace(',','.',$v);
    $v = floatval($v);
    TObject2::_setvalue($t,$p,$v,$n);
  }

  static protected function _get_float_abs(&$t,&$p) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return self::ValueInRule($t,$n,$p['value']);
  }

  static protected function _set_float_abs(&$t,&$p,$v,$n) {
    $v = floatval($v);
    if($v<0) $v=0;
    TObject2::_setvalue($t,$p,$v,$n);
  }

  static protected function _get_bool(&$t,&$p) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return (bool)($p['value']=='1');
  }

  static protected function _set_bool(&$t,&$p,$v,$n) {
    TObject2::_setvalue($t,$p,(int) $v,$n);
  }

  static protected function _get_string(&$t,&$p,$n) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return self::ValueInRule($t,$n,$p['value']);
  }

  static protected function _set_string(&$t,&$p,$v,$n) {
     TObject2::_setvalue($t,$p,$v,$n);
  }

  static protected function _get_text(&$t,&$p,$n) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    return self::ValueInRule($t,$n,$p['value']);
  }

  static protected function _set_text(&$t,&$p,$v,$n) {
    TObject2::_setvalue($t,$p,$v,$n);
  }

  static protected function _get_ts(&$t,&$p,$n) {
    return TObject2::_get_int($t,$p);
  }

  static protected function _set_ts(&$t,&$p,$v,$n) {
    TObject2::_set_int($t,$p,$v,$n);
  }

  static protected function _get_its(&$t,&$p,$n) {
    return TObject2::_get_int($t,$p);
  }

  static protected function _get_uts(&$t,&$p,$n) {
    return TObject2::_get_int($t,$p);
  }

  static protected function _get_ip(&$t,&$p,$n) {
    return long2ip(TObject2::_get_int($t,$p));
  }

  static protected function _get_iip(&$t,&$p,$n) {
    return long2ip(TObject2::_get_int($t,$p));
  }

  static protected function _get_uip(&$t,&$p,$n) {
    return long2ip(TObject2::_get_int($t,$p));
  }

  static protected function _set_ip(&$t,&$p,$v,$n) {
    TObject2::_set_int($t,$p,ip2long($v),$n);
  }

  static protected function _set_object(&$t,&$p,$v,$n){
    if($p['type']=='object' and is_object($v) and get_class($v)==$p['object']){
      TObject2::_setvalue($t,$p,$v->Id,$n);
      $p['ready'] = true;
      $p['obj'] = $v;
      if( !isset($p['oldvalue']) ) $p['oldvalue'] = 0;
    }elseif( $p['type']=='object' and is_object($v) ) {
    	echo get_class($v)," !== {$p['object']}" ; die();
    }else{
    	echo "is_not_object ";  die();
    }
  }
  
  static protected function DeleteAutoLink($ParentObject,$ChildsObject){
    foreach( $ChildsObject->Elements as $iChild ){
      $Filter = array(
        'Filter' => array(
          'Whyid' => $iChild->Id,
          'Objectrule' => $iChild->MyTypeObject,
          'Auto' => 1
        )
      );
      link::Filter($Filter)->DeleteAll();
    }
    $Filter = array(
      'Filter' => array(
        'Whyid' => $ParentObject->Id,
        'Objectrule' => $ParentObject->MyTypeObject,
      )
    );
    link::Filter($Filter)->DeleteAll();
  }

  static protected function _get_object(&$t,&$p) {
    if(!$p['ready']) TObject2::_DataLoadSql($t);
    if(!isset($p['obj'])){
      $eval = "\$p['obj'] = {$p['object']}::Id(\$p['value']);";
      eval($eval);
    }
    return $p['obj'];
  }

  static protected function _get__Is(&$t) {
    if ($t->_State == OBJECT_NO ) return false;
    if ($t->_State == OBJECT_INITED) {
      TObject2::_DataLoadSql($t);
    }
    # task 11797
    # task 11893
    if( isset($t->_F['Interprise']) && !$t->_F['Interprise']['ready'] ){
      TObject2::_DataLoadSql($t);
    }
    if( 
      $t->_F['Id']['value'] > 0 && 
      isset( $t::$FInit['Interprise'] ) &&
      !Site()->FullRules
    ){
      TObject2::_get_object($t,$t->_F['Interprise']);
      return $t->_F['Interprise']['value'] == Self()->_F['Interprise']['value'];
    }

    return (bool) $t->Id;
  }

  static protected function _get_FId(&$t){
    return $t->Id;
  }

  static protected function _get_Title(&$t){
    return $t->Is ? 'Объект:'.get_class($t).' Код:'.$t->Id : '';
  }

  static protected function _get__LinkEdit(&$t){
    return ($t->Is) ? "/back/{$t->ClassName}/{$t->Id}/edit/": '';
  }

  static protected function _get_Link(&$t){
    return "#";
  }

  static protected function _get_LinkBackList(&$t){
    return ($t->Is) ? "/back/{$t->ClassName}/": '';
  }

  static protected function _get__LinkClass(&$t){
    return "";
  }

	static protected function _get__toCSV( &$t ) {
		TObject2::_DataLoadSql( $t );
		$Result = '';
		foreach ( $t->_F as $kField=>$iField ) {
			if( !empty($Result) ) {
				$Result .= ",";
			}
			$Result .= '"' . str_replace("\"", "\"\"", $iField['value'])  .'"';
		}	
		return "".$Result."\n";
	}
	static protected function _get__toCSVHead( &$t ) {
		TObject2::_DataLoadSql($t);
		$Result = '';
		foreach ( $t->_F as $kField=>$iField ) {
			if( !empty($Result) ) {
				$Result .= ",";
			}
			$Result .= '"' . str_replace("\"", "\"\"", $kField)  .'"';
		}	
		return "\n".$Result."\n";
	}

  public function GetClassObjectId(){
    return ($this->Is) ? objectid::Ident($this->ClassName, $this->Id) : die('GetClassObjectId');
  }

}
?>
