<?php
// ver 0.1.9
// md5=0541ccffc4990a7d37e6b5aaa5610d6e
class TSession {
	static protected $FId = 0;
	static protected $FSessionData = null;
  static public $SqlTable = '`user_session`';
  static public $SqlTableData = '`user_session_data`';
	const TableName = 'user_session';
  static protected $_ID = 'Id';
  static public $FInit = Array(
     'Id'=>Array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0)
    ,'UserId'=>Array('type'=>'int','ready'=>false,'sql'=>'user_id','value'=>'')
    ,'Timestamp'=>Array('type'=>'int','ready'=>false,'sql'=>'timestamp','value'=>'')
    ,'IpInt'=>Array('type'=>'int','int'=>false,'sql'=>'ipint','value'=>'')
    ,'sid'=>Array('type'=>'string','ready'=>false,'sql'=>'sid','value'=>0)
    ,'url'=>Array('type'=>'string','ready'=>false,'sql'=>'url','value'=>'')
    ,'Agent'=>Array('type'=>'string','ready'=>false,'sql'=>'agent','value'=>'')
  );
  static public $FInitData = Array(
    'Id'=>Array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0),
    'UserSessionId'=>Array('type'=>'int','ready'=>false,'sql'=>'user_session_id','value'=>''),
    'Var'=>Array('type'=>'string','ready'=>false,'sql'=>'var','value'=>0),
    'Value'=>Array('type'=>'string','ready'=>false,'sql'=>'value','value'=>''),
  );

  static function open($save_path, $session_name){
    return(true);
  }

  static function close(){
  	//Log::Write("session-close");
    return true;
  }
  static function GUEST_ID(){
    if( !isset($GLOBALS['CONFIG'],$GLOBALS['CONFIG']['ACCESS'],$GLOBALS['CONFIG']['ACCESS']['GUESTID']))
      throw new exception(' Нет настройки для id Гостя');
    return  $GLOBALS['CONFIG']['ACCESS']['GUESTID'];
  }

  static function FESes($sql,$e){
      return TObject2::_Error(new TSession(), ER_SQL, Array('e'=>$e, 'sql'=>$sql,'SqlTable'=>TSession::$SqlTable,'FInit'=>TSession::$FInit,'_ID'=>TSession::$_ID) );
  }
  static function FESesData($sql,$e){
      return TObject2::_Error(new TSession(), ER_SQL, Array('e'=>$e, 'sql'=>$sql,'SqlTable'=>TSession::$SqlTableData,'FInit'=>TSession::$FInitData,'_ID'=>TSession::$_ID) );
  }

	static function DelOld() {
		$timestamp1 = time() - 60*60; //1200=20 minut для гостей
		$timestamp2 = time() - 60*60; //1800=30 minut для зарегистрированных
		$GUEST_ID = TSession::GUEST_ID();
		// delete old session info for guest
		$sql = "SELECT FROM `".self::TableName."` WHERE (`timestamp` > 0)";
		$res = DB::Select($sql);
    while( $row = DB::Fetch( $res ) ){
      userlog::AddByArray(array(
        'UserId' => 0,
        'Object' => 'user',
        'ObjectId' => $row['user_id'],
        'Property' => "Out",
        'Action' => "Закончилось время сессии"
      ));
    } 
    $sql = "DELETE FROM `".self::TableName."` WHERE (`timestamp` < $timestamp1) AND (`user_id` <= {$GUEST_ID})";
    $res = DB::Select($sql);
	}

  static function read($sid){
  	//Log::Write("session-read($sid)");
  	$GUEST_ID = TSession::GUEST_ID();
    $rez = DB::Select( "SELECT `id`, `user_id` FROM `".self::TableName."` WHERE `sid`='$sid' LIMIT 1");
    $_res = DB::Fetch($rez);
    if( isset( $_res['id'] ) ){
    	$id = $_res['id'];
    }else{
    	$id = 0;
    }
    if( isset( $_res['user_id'] ) ){
    	$user_id = $_res['user_id'];
    }else{
    	$user_id = 0;
    }
    //list($id, $user_id) = $_res;
  	$time = time();
  	$ip_int = ip2long( isset($_SERVER,$_SERVER['REMOTE_ADDR'])?$_SERVER['REMOTE_ADDR']:'127.0.0.1');
  	$url = Utils::addslashes('http://'.$_SERVER['SERVER_NAME'].$_SERVER['REQUEST_URI']);
  	$user_agent = isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : 'none';
  	$login_error = false;
    
		if( isset($_REQUEST['login'], $_REQUEST['password']) && !Site()->IsAjax() ){
  		$pass_md5 = user::GenPass($_REQUEST['password']);
      //~ var_dump($pass_md5);
  		$login2 = Utils::addslashes($_REQUEST['login']);
  		$sqlq = "SELECT `id` FROM `user` WHERE (`login`='{$login2}') AND (`pass`='{$pass_md5}') AND (`pass` IS NOT NULL)";
  		//~ echo $sqlq;
  		$rez2 = DB::Select($sqlq);
//      var_dump( mysql_fetch_array($rez2));
      if( DB::RowCount($rez2) > 0 )
      {
				$_id = DB::Fetch($rez2);
				$new_user_id = $_id['id'];
      }else{
      	$new_user_id = TSession::GUEST_ID();
      	$login_error = true;
      }
      
		}elseif( isset($user_id) ){
			$new_user_id = $user_id;
		}else $new_user_id = $GUEST_ID;
    
    if( DB::RowCount($rez) > 0 ){
    	$sql = "UPDATE `".self::TableName."` SET `user_id`={$new_user_id}, `timestamp`={$time}, `ipint`={$ip_int}, `sid`='{$sid}', `url`='{$url}', `agent`='{$user_agent}' WHERE `id`={$id}";
      DB::Query($sql,false);
      self::$FId = $id;
    }else{
    	$sql = "INSERT INTO `".self::TableName."` (`user_id`, `timestamp`, `ipint`, `sid`, `url`, `agent`) VALUES ({$new_user_id}, {$time}, {$ip_int}, '{$sid}', '{$url}', '{$user_agent}')";
    	DB::Query($sql,false);
      self::$FId = DB::InsertId($rez);
    }
		$GLOBALS['Self'] = user::Id($new_user_id);
  	$user_id = Self()->Id;
    if( !$user_id ){
      $user_id = TSession::GUEST_ID();
    }
  	if ($login_error){
//  		header( "Location: /user/loginerror/?ref=".(isset($_REQUEST['ref'])?$_REQUEST['ref']:$_SERVER['REQUEST_URI']) );
//  		die;
    }
  	$sql = "SELECT `value` FROM `user_session_data` WHERE `user_session_id`=".self::$FId;
    try{ $sql_rez = DB::Select($sql); }
    catch (Exception $e) {
      $sql_rez = TSession::FESesData($sql,$e);
    }
    
    $_value = DB::Fetch($sql_rez);
  	self::$FSessionData = $_value['value'];
  	return stripslashes(self::$FSessionData);
  }

  static function write($sid, $sess_data){
  	if(self::$FId > 0){
      if(self::$FSessionData !== $sess_data){
        $sess_data = Utils::addslashes($sess_data);
        $sql="UPDATE `".self::TableName."_data` SET `value`='".$sess_data."' WHERE `user_session_id`=".self::$FId;
        DB::Query($sql,false);
        if(!DB::AffectedRows()){
        	$sql="INSERT INTO `".self::TableName."_data`(`user_session_id`, `var`, `value`) VALUES(".self::$FId.",'all','".$sess_data."')";
        	DB::Query($sql,false);
        }
      }
  	}
    return true;
  }

  static function destroy($sid)
  {
  	//Log::Write ("session-destroy($sid)");
  	$sql = "DELETE FROM `".self::TableName."` WHERE `SID`='{$sid}'";
    DB::Query($sql,false);
    return true;
  }

  /*********************************************
   * WARNING - You will need to implement some *
   * sort of garbage collection routine here.  *
   *********************************************/
  static function gc($maxlifetime){
    return true;
  }

  static function Init(){
  	//Log::Write("session-Init");
//    session_set_cookie_params(0,'/');
    if( isset($_SERVER["REMOTE_ADDR"])) session_set_save_handler("TSession::open", "TSession::close", "TSession::read", "TSession::write", "TSession::destroy", "TSession::gc");
    //~ if (session_id() == '' && isset($_SERVER['REQUEST_URI'])) 
    try{
        session_start();
    }catch(Exception $e){
      var_dump($e);
        smarty()->display('error/session.tpl');
    }
  }

  public function __get($VarName)
  {
//    die($VarName);
  	DB::Select("SELECT `value` FROM `".self::TableName."_data` WHERE (`user_session_id`={$this->FId}) AND (`var`='{$VarName}')");
  	if( DB::RowCount()>0)
  	{
  	  list($value) = DB::FetchArray();
  	  return unserialize($value);
    }
    else
    {
    	return false;
    }
  }
  public function __set($VarName, $VarValue)
  {
  	$VarValue = serialize($VarValue);
  	$sql = "UDPATE `".self::TableName."_data` SET `value`='{$VarValue}' WHERE (`user_session_id`={$this->FId}) AND (`var`='{$VarName}')";
  	DB::Query($sql,false);
  	if (DB::AffectedRows() == 0)
  	{
  		$sql = "INSERT INTO `".self::TableName."_data` (`user_session_id`, `var`, `value`) VALUES ({$this->FId}, '{$VarName}', '{$VarValue}')";
    	DB::Query($sql,false);
    }
  }

}


?>
