<?php
// md5=00000000000000000000000000000000
class archivemetercustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`archivemeter`';
  static public $SqlFields = '`archivemeter`.`id`,`archivemeter`.`archive_id`,`archivemeter`.`meter_id`,`archivemeter`.`count`,`archivemeter`.`ready`,`archivemeter`.`status`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Archive'=>array('type'=>'object','object'=>'archive','ready'=>false,'sql'=>'archive_id','value'=>null, 'rus'=>'Архивы'),
    'Meter'=>array('type'=>'object','object'=>'meter','ready'=>false,'sql'=>'meter_id','value'=>null, 'rus'=>'Прибор учета'),
    'Count'=>array('type'=>'int','ready'=>false,'sql'=>'count','value'=>0, 'rus'=>'Кол-во данных'),
    'Ready'=>array('type'=>'int','ready'=>false,'sql'=>'ready','value'=>0, 'rus'=>'Кол-во загруженных данных', 'enter'=>53),
    'Status'=>array('type'=>'int','ready'=>false,'sql'=>'status','value'=>0, 'rus'=>'Статус выполнения'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      archivemeter::$_R['All']
    ))
      archivemeter::$_R['All'] 
      = TObject2::Filter( new archivemeter());
    return archivemeter::$_R['All'];
  }


  public function GetFInit() {
    return archivemeter::$FInit;
  }

  public function GetClassName(){
    return 'archivemeter'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Archivemeter';
  }
  public function GetNameRus(){
    return 'Архивы приборов учета';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(archivemeter::$_O[$id]) ){
      archivemeter::$_O[$id] = archivemeter::Id($id);
      TObject2::_DataSetAll(archivemeter::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(archivemeter::$_O[$id]) ){
      archivemeter::$_O[$id] = new archivemeter();
      TObject2::_PreInit( archivemeter::$_O[$id], $id);
    }
    return archivemeter::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = archivemeter::$SqlTable;
    $arField = Array();
    foreach( archivemeter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return archivemeter::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = archivemeter::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = archivemeter::$FInit[$this->_ID]['sql'];
    foreach( archivemeter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new archivemeter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new archivemeter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new archivemeter();
    return TObject2::Filter($t,$aParams);
  }
}
?>
