<?php
// md5=00000000000000000000000000000000
class configcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`config`';
  static public $SqlFields = '`config`.`id`,`config`.`parametr`,`config`.`value`,`config`.`about`,`config`.`system`,`config`.`input_type`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Parametr'=>array('type'=>'string','ready'=>false,'sql'=>'parametr','value'=>'','notnull'=>1, 'rus'=>'Параметр'),
    'Value'=>array('type'=>'text','ready'=>false,'sql'=>'value','value'=>'', 'rus'=>'Значение', 'enter'=>3),
    'About'=>array('type'=>'string','ready'=>false,'sql'=>'about','value'=>'', 'rus'=>'Описание', 'enter'=>3),
    'System'=>array('type'=>'bool','ready'=>false,'sql'=>'system','value'=>'', 'rus'=>'Системные'),
    'InputType'=>array('type'=>'int','ready'=>false,'sql'=>'input_type','value'=>0, 'rus'=>'Тип поля'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      config::$_R['All']
    ))
      config::$_R['All'] 
      = TObject2::Filter( new config());
    return config::$_R['All'];
  }


  public function GetFInit() {
    return config::$FInit;
  }

  public function GetClassName(){
    return 'config'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Config';
  }
  public function GetNameRus(){
    return 'Настройки';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(config::$_O[$id]) ){
      config::$_O[$id] = config::Id($id);
      TObject2::_DataSetAll(config::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(config::$_O[$id]) ){
      config::$_O[$id] = new config();
      TObject2::_PreInit( config::$_O[$id], $id);
    }
    return config::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = config::$SqlTable;
    $arField = Array();
    foreach( config::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return config::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = config::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = config::$FInit[$this->_ID]['sql'];
    foreach( config::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new config();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new config();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = array() , $etc = array()){
    $t=new config();
    return TObject2::Filter($t,$aParams);
  }
}
?>
