<?php
/*
Имя класса conversion
Имя файла conversion.class.php ( conversioncustom.class.php )
Поля класса:
Id : id
Title : string
Divider : string
Round : int
Interprise : object
*/
class conversion extends conversioncustom{

  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Title'             => 'title',
    'Divider'           => 'divider',
    'Round'             => 'round',
  );  
  
  
  
  public $NeedDoUserLog = true;
  
  
  /*
    Является ли конвертация системной или нет
    @return Bool
  */
  function GetIsSys(){
    return $this->Interprise->Id == 0;
  }
  
  
  
  
  
  
  static public function AddByArray($A){
    
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    if( isset($A['Divider']) && $A['Divider'] == 0 ){
      $A['Divider'] = 1;
    }
    
    $t = new conversion();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }
  
  
  
  
  static public function AddByRequest(){
    $t = new conversion();
    if( !isset( $_REQUEST['InterpriseId'] ) ){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new conversion();
    if( !isset( $aParams['Filter']['Interprise'] ) ){
      $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    }
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  static public function All( $c=-1 )
  {
    if( !isset( 
      conversion::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Interprise' => Self()->Interprise->Id
        )
      );
      conversion::$_R['All'] 
      = TObject2::Filter( new conversion() , $Filter);
    }
    return conversion::$_R['All'];
  }
  
  
  
  
  
  public function UpdateByArray($A){
    
    if( isset($A['Divider']) && $A['Divider'] == 0 ){
      $A['Divider'] = 1;
    }
    
    TObject2::StaticUpdateByArray($this,$A);
  }
  

}
