<?php
// md5=00000000000000000000000000000000
class conversioncustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`conversion`';
  static public $SqlFields = '`conversion`.`id`,`conversion`.`title`,`conversion`.`divider`,`conversion`.`round`,`conversion`.`interprise_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'Divider'=>array('type'=>'string','ready'=>false,'sql'=>'divider','value'=>'', 'rus'=>'Делитель', 'enter'=>2),
    'Round'=>array('type'=>'int','ready'=>false,'sql'=>'round','value'=>0, 'rus'=>'Кол-во знаков после точки', 'enter'=>2),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      conversion::$_R['All']
    ))
      conversion::$_R['All'] 
      = TObject2::Filter( new conversion());
    return conversion::$_R['All'];
  }


  public function GetFInit() {
    return conversion::$FInit;
  }

  public function GetClassName(){
    return 'conversion'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Conversion';
  }
  public function GetNameRus(){
    return 'Конвертация';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(conversion::$_O[$id]) ){
      conversion::$_O[$id] = conversion::Id($id);
      TObject2::_DataSetAll(conversion::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(conversion::$_O[$id]) ){
      conversion::$_O[$id] = new conversion();
      TObject2::_PreInit( conversion::$_O[$id], $id);
    }
    return conversion::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = conversion::$SqlTable;
    $arField = Array();
    foreach( conversion::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return conversion::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = conversion::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = conversion::$FInit[$this->_ID]['sql'];
    foreach( conversion::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new conversion();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new conversion();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new conversion();
    return TObject2::Filter($t,$aParams);
  }
}
?>
