<?php
// md5=00000000000000000000000000000000
class converterhelperscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`converterhelpers`';
  static public $SqlFields = '`converterhelpers`.`id`,`converterhelpers`.`convertertype_id`,`converterhelpers`.`text`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Convertertype'=>array('type'=>'object','object'=>'convertertype','ready'=>false,'sql'=>'convertertype_id','value'=>null, 'rus'=>'Тип точки опроса'),
    'Text'=>array('type'=>'text','ready'=>false,'sql'=>'text','value'=>'', 'rus'=>'Текст', 'enter'=>31),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      converterhelpers::$_R['All']
    ))
      converterhelpers::$_R['All'] 
      = TObject2::Filter( new converterhelpers());
    return converterhelpers::$_R['All'];
  }


  public function GetFInit() {
    return converterhelpers::$FInit;
  }

  public function GetClassName(){
    return 'converterhelpers'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Converterhelpers';
  }
  public function GetNameRus(){
    return 'Помощник при добавлении конверторов';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(converterhelpers::$_O[$id]) ){
      converterhelpers::$_O[$id] = converterhelpers::Id($id);
      TObject2::_DataSetAll(converterhelpers::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(converterhelpers::$_O[$id]) ){
      converterhelpers::$_O[$id] = new converterhelpers();
      TObject2::_PreInit( converterhelpers::$_O[$id], $id);
    }
    return converterhelpers::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = converterhelpers::$SqlTable;
    $arField = Array();
    foreach( converterhelpers::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return converterhelpers::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = converterhelpers::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = converterhelpers::$FInit[$this->_ID]['sql'];
    foreach( converterhelpers::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new converterhelpers();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new converterhelpers();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new converterhelpers();
    return TObject2::Filter($t,$aParams);
  }
}
?>
