<?php
// md5=00000000000000000000000000000000
class convertertypecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`converter_type`';
  static public $SqlFields = '`converter_type`.`id`,`converter_type`.`title`,`converter_type`.`dll_id`,`converter_type`.`converter_appointment_id`,`converter_type`.`protocol`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'DllId'=>array('type'=>'string','ready'=>false,'sql'=>'dll_id','value'=>'','notnull'=>1, 'rus'=>'Идентификатор Библиотеки', 'enter'=>2),
    'Converter_appointment'=>array('type'=>'object','object'=>'converter_appointment','ready'=>false,'sql'=>'converter_appointment_id','value'=>null, 'rus'=>'Тип конвертора по его назначению'),
    'Protocol'=>array('type'=>'int','ready'=>false,'sql'=>'protocol','value'=>0, 'rus'=>'Протокол передачи данных'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      convertertype::$_R['All']
    ))
      convertertype::$_R['All'] 
      = TObject2::Filter( new convertertype());
    return convertertype::$_R['All'];
  }


  public function GetFInit() {
    return convertertype::$FInit;
  }

  public function GetClassName(){
    return 'convertertype'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Convertertype';
  }
  public function GetNameRus(){
    return 'Тип точки опроса';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(convertertype::$_O[$id]) ){
      convertertype::$_O[$id] = convertertype::Id($id);
      TObject2::_DataSetAll(convertertype::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(convertertype::$_O[$id]) ){
      convertertype::$_O[$id] = new convertertype();
      TObject2::_PreInit( convertertype::$_O[$id], $id);
    }
    return convertertype::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = convertertype::$SqlTable;
    $arField = Array();
    foreach( convertertype::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return convertertype::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = convertertype::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = convertertype::$FInit[$this->_ID]['sql'];
    foreach( convertertype::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new convertertype();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new convertertype();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new convertertype();
    return TObject2::Filter($t,$aParams);
  }
}
?>
