<?php
// md5=00000000000000000000000000000000
class crontaskcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`crontask`';
  static public $SqlFields = '`crontask`.`id`,`crontask`.`title`,`crontask`.`description`,`crontask`.`filename`,`crontask`.`key`,`crontask`.`hour`,`crontask`.`minute`,`crontask`.`is_log`,`crontask`.`is_enabled`,`crontask`.`is_locked`,`crontask`.`next_run`,`crontask`.`timelimit`,`crontask`.`memorylimit`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'Description'=>array('type'=>'text','ready'=>false,'sql'=>'description','value'=>'', 'rus'=>'Описание', 'enter'=>3),
    'Filename'=>array('type'=>'string','ready'=>false,'sql'=>'filename','value'=>'', 'rus'=>'Название файла', 'enter'=>2),
    'Key'=>array('type'=>'string','ready'=>false,'sql'=>'key','value'=>'','notnull'=>1, 'rus'=>'Ключ', 'enter'=>2),
    'Hour'=>array('type'=>'int','ready'=>false,'sql'=>'hour','value'=>0, 'rus'=>'Часы', 'enter'=>2),
    'Minute'=>array('type'=>'int','ready'=>false,'sql'=>'minute','value'=>0, 'rus'=>'Минуты', 'enter'=>2),
    'IsLog'=>array('type'=>'bool','ready'=>false,'sql'=>'is_log','value'=>'', 'rus'=>'Записывать лог', 'enter'=>7),
    'IsEnabled'=>array('type'=>'bool','ready'=>false,'sql'=>'is_enabled','value'=>'', 'rus'=>'Включено', 'enter'=>7),
    'IsLocked'=>array('type'=>'ts','ready'=>false,'sql'=>'is_locked','value'=>'', 'rus'=>'Заблокировано', 'enter'=>26),
    'NextRun'=>array('type'=>'ts','ready'=>false,'sql'=>'next_run','value'=>'', 'rus'=>'Следующий запуск', 'enter'=>26),
    'Timelimit'=>array('type'=>'int','ready'=>false,'sql'=>'timelimit','value'=>0, 'rus'=>'Время выполнения'),
    'Memorylimit'=>array('type'=>'string','ready'=>false,'sql'=>'memorylimit','value'=>'', 'rus'=>'Лимит памяти ( формат 2Mb , 3B , 6Gb )'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      crontask::$_R['All']
    ))
      crontask::$_R['All'] 
      = TObject2::Filter( new crontask());
    return crontask::$_R['All'];
  }


  public function GetFInit() {
    return crontask::$FInit;
  }

  public function GetClassName(){
    return 'crontask'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Crontask';
  }
  public function GetNameRus(){
    return 'Задания по расписанию';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(crontask::$_O[$id]) ){
      crontask::$_O[$id] = crontask::Id($id);
      TObject2::_DataSetAll(crontask::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(crontask::$_O[$id]) ){
      crontask::$_O[$id] = new crontask();
      TObject2::_PreInit( crontask::$_O[$id], $id);
    }
    return crontask::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = crontask::$SqlTable;
    $arField = Array();
    foreach( crontask::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return crontask::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = crontask::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = crontask::$FInit[$this->_ID]['sql'];
    foreach( crontask::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new crontask();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new crontask();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new crontask();
    return TObject2::Filter($t,$aParams);
  }
}
?>
