<?php
/*
Имя класса fieldsobject
Имя файла fieldsobject.class.php ( fieldsobjectcustom.class.php )
Поля класса:
Id : id
Fields : object
Object : string
*/
class fieldsobject extends fieldsobjectcustom{
  
  
  # к каким объектам могут применяться дополнительные поля
  static function GetObjects(){
    return array(
      'converter' => 'Точки попроса',
      'meter' => 'Приборы учета',
      'user' => 'Пользователи',
      'place' => 'Места'
    );
  }
  
  # Есть ли глобальная возможность добавлять на объект дополнительные поля?
  static function IsAssignedMoreFields( $key ){
    $ar = self::GetObjects();
    return isset($ar[$key]);
  }
  
  
  
  
  /**
   * Получение списка полей на объекте
   * 
   * @param class $object Объект чьи поля надо получить
   * @return TListGroup
   */
  static function GetFieldsForObject( $object ){
    $t=new fields();
    $sql = "select fields.* from fieldsobject left join fields on fields.id = fieldsobject.fields_id where fieldsobject.object = '". get_class($object) ."' AND fields.id IS NOT NULL";
		return TListGroup::Prepare( $sql, $t );
  }

}
