<?php
/*
Имя класса filterparamname
Имя файла filterparamname.class.php ( filterparamnamecustom.class.php )
Поля класса:
Id : id
Name : string
Sufix : string
Object : string
ObjectId : string
Interprise : object
*/
class filterparamname extends filterparamnamecustom{
  
  
  /*
    Флаг логирования
  */
  public $NeedDoUserLog = true;




  
  /*
    Получение параметров из фильтра
    @return TListGroup
  */
  function GetParameters(){
    return filterparamis::ParametersByIdFilter( $this->Id );
  }
  
  
  
  
  
  /*
    Кеш параметров для фильтра
  */
  protected $CacheParameters = null;
  
  
  
  
  
  
  
  /*
    Наполнение кеша параметрами
    @return Bool
  */
  function SetCacheParameters(){
    foreach( $this->Parameters->Elements as $Filterparamis ){
      $this->CacheParameters[ $Filterparamis->Parameter->Id ] = 1;
    }
  }
  
  
  
  
  /*
    Проверка использует ли фильтра этот параметр
    @param parameter
    @return Bool
  */
  function IsUsed( $oParameter ){
    if( $this->CacheParameters === null ){
      $this->SetCacheParameters();
    }
    return isset( $this->CacheParameters[ $oParameter->Id ] );
  }
  
  
  
  
  static public function AddByArray($A){
    $t = new filterparamname();
    if( !isset( $A['InterpriseId'] ) ){
      $A['InterpriseId'] = Self()->Interprise->Id;
    }
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new filterparamname();
    if( !isset( $_REQUEST['InterpriseId'] ) ){
      $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    }
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new filterparamname();
    $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  

  static public function All( $c=-1 )
  {
    if( !isset( 
      filterparamname::$_R['All']
    )){
      $Filter = array( 
        'Filter' => array( 
          'Interprise' => Self()->Interprise->Id
        )
      );
      filterparamname::$_R['All'] 
      = TObject2::Filter( new filterparamname() , $Filter);
    }
    return filterparamname::$_R['All'];
  }
  
  

}
