<?php
/*
Имя класса group
Имя файла group.class.php ( groupcustom.class.php )
Поля класса:
Id : id
Fio : string
Interprise : object
*/
class group extends groupcustom{

  
  public $FieldsToJSON = array(
    'Id'                => 'id',
    'Fio'               => 'fio',
    'Active'            => 'active',
  ); 
  
  
  
  public $NeedDoUserLog = true;
  
  
  
  
  
  static public function &All( $c=-1 )
  {
    
    if( !isset( 
      group::$_R['All']
    )){
      
      $Filter = array( 
        'Filter' => array( 
          'Type' => 1,
          'Interprise' => Self()->Interprise->Id
        )
      );
      
      group::$_R['All'] 
      = TObject2::Filter( new group() , $Filter );
    }
    return group::$_R['All'];
  }
  
  
  
  
  
  static public function Filter($aParams = null , $etc = array()){
    $t=new group();
    $aParams['Filter']['Type'] = 1;
    $aParams['Filter']['Interprise'] = Self()->Interprise->Id;
    return TObject2::Filter($t,$aParams);
  }
  
  
  
  
  
  
  
  static public function &AddByArray($A){
    $t = new group();
    $A['Type'] = 1;
    $A['InterpriseId'] = Self()->Interprise->Id;
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function &AddByRequest(){
    $t = new group();
    $_REQUEST['Type'] = 1;
    $_REQUEST['InterpriseId'] = Self()->Interprise->Id;
    TObject2::StaticAddByRequest($t);
    return $t;
  }
  
  
  
  
  
  
  /*
    Все уникальные роли пользователя
    @return TListGroup
  */
  function GetRule(){
    $Filter = array( 
      'Filter' => array( 
        'User' => $this->Id,
      ),
      'GroupBy' => array(
        'Rule'
      )
    );
    return link::Filter( $Filter );
  }
  
  
  
  
  function GetTitle(){
    return $this->Fio;
  }
  
  
  
  
  
  /*
    ССылка на группу
    @return String
  */
  function GetLink(){
    return "/group/{$this->Id}/";
  }
  
  
  /*
    ССылка на лог группы
    @return String
  */
  function GetLinkLog(){
    return "{$this->Link}log/";
  }
  
  
  /*
    Ссылка на удаление
    @return String
  */
  function GetLinkDel(){
    return "{$this->Link}delete/";
  }
  
  /*
    Ссылка на редактирование
    @return String
  */
  function GetLinkEdit(){
    return "{$this->Link}edit/";
  }
  
  
  
  
  
  
  
  
  /*
    Возвращает всех пользователей в группе
    @return TListGroup
  */
  function GetUsers(){
    $Filter = array( 
      'Filter' => array( 
        'Group' => $this->Id
      ),
    );
    return groupusers::Filter( $Filter );
  }
  



}
