<?php
/*
Имя класса interprise
Имя файла interprise.class.php ( interprisecustom.class.php )
Поля класса:
Id : id
Name : string
Timezone : object
Limitmeters : int
*/

class interprise extends interprisecustom{

  
  function GetTitle(){
    return $this->Name;
  }
  
  
  
  static public function AddByArray($A){
    $t = new interprise();
    $A['Limitmeters'] = 10;
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }
  
  
  public $NeedDoUserLog = true;
  
  
  /*
   * Название файла логотипа
   * */
  function GetLogoName( $type = "" ){
    
    switch( $type ){
      case "image/gif" :
        $type = "gif";
      break;
      case "image/png" :
        $type = "png";
      break;
      default :
        $type = "jpg";
      break;
    }
    
    $file = "logo_" . $this->Id.".{$type}";
    
    if ($handle = @opendir( $this->GetPatchLogo() )) {
        while (false !== ($entry = readdir($handle))) {
            if ($entry != "." && $entry != "..") {
                if( preg_match('/^logo_([0-9]*)\.(gif|jpg|png)$/' , $entry) ){
                  $file = $entry;
                  break;
                }
            }
        }
        closedir($handle);
    }
    return $file;
  }
  
  
  /*
   *  Путь до папки с логотипом
   * @return String
   * */
  function GetPatchLogo(){
    
    $folder = realpath( $_SERVER['DOCUMENT_ROOT'] ). $this->GetPublicPatchLogo();
    
    if( !file_exists( $folder ) ){
      $res = @mkdir( $folder , 0777, true );
    }
    return $folder;
  }
  
  
  
  /*
   * Получение ссылки на картинку для публичного использования
   * @return String
   * */
  function GetPublicPatchLogo(){
    $logo = "/images/interprises/" . Self()->Interprise->Id."/";
    if( !file_exists($logo) ){
      return "";
    }  
    return $logo;
  }
  
  
  
  
  /*
   * Проверка является ли картинка пользовательской
   * */
  function GetLogoCustom(){
    return $this->GetLogo() == $this->GetPublicPatchLogo() . $this->GetLogoName();
  }
  
  
  
  /*
   * Получение логотипа компании если он есть
   * @return String
   * */
  function GetLogo(){
    if( file_exists( $this->GetPatchLogo() . $this->GetLogoName() ) ){
      return $this->GetPublicPatchLogo() . $this->GetLogoName();
    }
    if(!file_exists($_SERVER['DOCUMENT_ROOT'] . "/img/logonag.png") ){
      return "";
    }
    return "/img/logonag.png";
  }


}
