<?php
// md5=00000000000000000000000000000000
class interprisecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`interprise`';
  static public $SqlFields = '`interprise`.`id`,`interprise`.`name`,`interprise`.`timezone_id`,`interprise`.`limitmeters`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Name'=>array('type'=>'string','ready'=>false,'sql'=>'name','value'=>'', 'rus'=>'Название предприятия', 'enter'=>2),
    'Timezone'=>array('type'=>'object','object'=>'timezone','ready'=>false,'sql'=>'timezone_id','value'=>null, 'rus'=>'Часовой пояс'),
    'Limitmeters'=>array('type'=>'int','ready'=>false,'sql'=>'limitmeters','value'=>0, 'rus'=>'Лимит приборов на предприятие'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      interprise::$_R['All']
    ))
      interprise::$_R['All'] 
      = TObject2::Filter( new interprise());
    return interprise::$_R['All'];
  }


  public function GetFInit() {
    return interprise::$FInit;
  }

  public function GetClassName(){
    return 'interprise'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Interprise';
  }
  public function GetNameRus(){
    return 'Компании';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(interprise::$_O[$id]) ){
      interprise::$_O[$id] = interprise::Id($id);
      TObject2::_DataSetAll(interprise::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(interprise::$_O[$id]) ){
      interprise::$_O[$id] = new interprise();
      TObject2::_PreInit( interprise::$_O[$id], $id);
    }
    return interprise::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = $this->SqlTable;
    $arField = Array();
    foreach( interprise::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return '`interprise`';
  }

  protected function GetSqlTableJoin() {
    $table = $this->SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = interprise::$FInit[$this->_ID]['sql'];
    foreach( interprise::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new interprise();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new interprise();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new interprise();
    return TObject2::Filter($t,$aParams);
  }
}
?>
