<?php
// md5=00000000000000000000000000000000
class linkobjectcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`link`';
  static public $SqlFields = '`link`.`id`,`link`.`user_id`,`link`.`interprise_id`,`link`.`rule_id`,`link`.`objectrule_id`,`link`.`whyid`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'User'=>array('type'=>'object','object'=>'user','ready'=>false,'sql'=>'user_id','value'=>null, 'rus'=>'Пользователь', 'enter'=>4),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании', 'enter'=>4),
    'Rule'=>array('type'=>'object','object'=>'rule','ready'=>false,'sql'=>'rule_id','value'=>null, 'rus'=>'Права', 'enter'=>4),
    'Objectrule'=>array('type'=>'object','object'=>'objectrule','ready'=>false,'sql'=>'objectrule_id','value'=>null, 'rus'=>'Обьекты', 'enter'=>4),
    'Whyid'=>array('type'=>'int','ready'=>false,'sql'=>'whyid','value'=>0, 'enter'=>2),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      linkobject::$_R['All']
    ))
      linkobject::$_R['All'] 
      = TObject2::Filter( new linkobject());
    return linkobject::$_R['All'];
  }

  static public function ByUser( $c=-1 )
  {
    if( !isset( 
      linkobject::$_R['ByUser']
    ))
      linkobject::$_R['ByUser'] 
      = TObject2::Filter( new linkobject());
    return linkobject::$_R['ByUser'];
  }

  static public function ByInterprise( $c=-1 )
  {
    if( !isset( 
      linkobject::$_R['ByInterprise']
    ))
      linkobject::$_R['ByInterprise'] 
      = TObject2::Filter( new linkobject());
    return linkobject::$_R['ByInterprise'];
  }

  static public function ByRule( $c=-1 )
  {
    if( !isset( 
      linkobject::$_R['ByRule']
    ))
      linkobject::$_R['ByRule'] 
      = TObject2::Filter( new linkobject());
    return linkobject::$_R['ByRule'];
  }


  public function GetFInit() {
    return linkobject::$FInit;
  }

  public function GetClassName(){
    return 'linkobject'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Linkobject';
  }
  public function GetNameRus(){
    return 'Связи пользователей с правами';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(linkobject::$_O[$id]) ){
      linkobject::$_O[$id] = linkobject::Id($id);
      TObject2::_DataSetAll(linkobject::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(linkobject::$_O[$id]) ){
      linkobject::$_O[$id] = new linkobject();
      TObject2::_PreInit( linkobject::$_O[$id], $id);
    }
    return linkobject::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = linkobject::$SqlTable;
    $arField = Array();
    foreach( linkobject::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return linkobject::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = linkobject::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = linkobject::$FInit[$this->_ID]['sql'];
    foreach( linkobject::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new linkobject();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new linkobject();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new linkobject();
    return TObject2::Filter($t,$aParams);
  }
}
?>
