<?php
// md5=00000000000000000000000000000000
class metereventcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`meterevent`';
  static public $SqlFields = '`meterevent`.`id`,`meterevent`.`meter_id`,`meterevent`.`metertype_id`,`meterevent`.`parameter_id`,`meterevent`.`metereventtype_id`,`meterevent`.`datetime`,`meterevent`.`event_code`,`meterevent`.`year`,`meterevent`.`month`,`meterevent`.`day`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Meter'=>array('type'=>'object','object'=>'meter','ready'=>false,'sql'=>'meter_id','value'=>null, 'rus'=>'Прибор учета'),
    'Metertype'=>array('type'=>'object','object'=>'metertype','ready'=>false,'sql'=>'metertype_id','value'=>null, 'rus'=>'Тип прибора опроса'),
    'Parameter'=>array('type'=>'object','object'=>'parameter','ready'=>false,'sql'=>'parameter_id','value'=>null, 'rus'=>'Параметр'),
    'Metereventtype'=>array('type'=>'object','object'=>'metereventtype','ready'=>false,'sql'=>'metereventtype_id','value'=>null, 'rus'=>'Тип события журнала'),
    'Datetime'=>array('type'=>'string','ready'=>false,'sql'=>'datetime','value'=>'', 'rus'=>'Датавремя'),
    'EventCode'=>array('type'=>'int','ready'=>false,'sql'=>'event_code','value'=>0, 'rus'=>'Код события'),
    'Year'=>array('type'=>'int','ready'=>false,'sql'=>'year','value'=>0, 'rus'=>'Год'),
    'Month'=>array('type'=>'int','ready'=>false,'sql'=>'month','value'=>0, 'rus'=>'Месяц'),
    'Day'=>array('type'=>'int','ready'=>false,'sql'=>'day','value'=>0, 'rus'=>'День'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      meterevent::$_R['All']
    ))
      meterevent::$_R['All'] 
      = TObject2::Filter( new meterevent());
    return meterevent::$_R['All'];
  }

  static public function ByMeter( $Meter, $c=-1 )
  {
    if( !isset( 
      meterevent::$_R['ByMeter']
      ,meterevent::$_R['ByMeter']['_'.$Meter]

    ))
      meterevent::$_R['ByMeter']['_'.$Meter] 
      = TObject2::Filter( new meterevent(), Array( 
        'Filter' => Array(
            'Meter'=>$Meter
        ), 
        'Order'=>Array('Datetime'=>'DESC'),
        'Limit'=>$c
      ));
    return meterevent::$_R['ByMeter']['_'.$Meter];
  }


  public function GetFInit() {
    return meterevent::$FInit;
  }

  public function GetClassName(){
    return 'meterevent'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Meterevent';
  }
  public function GetNameRus(){
    return 'Событие журнала';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(meterevent::$_O[$id]) ){
      meterevent::$_O[$id] = meterevent::Id($id);
      TObject2::_DataSetAll(meterevent::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(meterevent::$_O[$id]) ){
      meterevent::$_O[$id] = new meterevent();
      TObject2::_PreInit( meterevent::$_O[$id], $id);
    }
    return meterevent::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = meterevent::$SqlTable;
    $arField = Array();
    foreach( meterevent::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return meterevent::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = meterevent::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = meterevent::$FInit[$this->_ID]['sql'];
    foreach( meterevent::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new meterevent();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new meterevent();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new meterevent();
    return TObject2::Filter($t,$aParams);
  }
}
?>
