<?php












interface meterexportI{
	
	// проверка файловой структуры приложения
	function getfolder_export();
	
	// Добавление приборов для экспорта
	function appendMeter();
	
	// Создание даты старта экспорта
	function setDateStart();
	
	// Создание даты окончания экспорта
	function setDateStop();
	
	// Проверяет все ли хорошо
	function IsGood();
	
	// непосредственно сама выгрузка в файл
	function export();
	
	// вывод ошибок
	function getError();
	
	// вывод предупреждений
	function getWarning();
	
	// вывод удачных действий
	function getSuccess();
	
	// Идет ли выгрузка в данный момент
	function isRun();
	
	// Сколько процентов загрузка
	function getProgress();
	
}








// Класс для отделения переменных.
class meterexportV{
	
	// приборы учета с которых собираем данные
	public $MeterId 	= array();
	
	// ошибки, избежание ошибки, выполнено
	protected $error 		= array();
	protected $warning  = array();
	protected $success  = array();
	
	// date start
	// [y]ear_[s]tar[t]
	protected $y_st  		= 0;
	protected $m_st  		= 0;
	protected $d_st  		= 0;
	protected $h_st  		= 0;
	
	// date stop
	// [y]ear_[s]to[p]
	protected $y_sp  		= 0;
	protected $m_sp  		= 0;
	protected $d_sp  		= 0;
	protected $h_sp  		= 0;
	
	// date to string
	protected $st_string = '';
	protected $sp_string = '';
	
	// дата сейчас
	protected $now = '';
	
	// ваше предприятие
	protected $interprise = null;
	
	// пользователь, делающий выгрузку
	protected $user = null;
	
	// главная папка куда все должно выгружаться
	protected $folder_main = '';
	// папка предприятия
	protected $folderE = '';
	// папка экспортов
	protected $folder_export = '';
	// файл экспорта
	protected $file_export = '';
	
	// временная метка сейчас
	protected $time = 0;
	// время выполнения скрипта
	protected $time_run = 0;
	// временная метка сейчас
	protected $mctime = 0;
	// память требуемая для выполнения скрипта
	protected $memory = 0;
	// память на начало выполнения скрипта
	protected $memory_start = 0;
	// сколько строк записано
	public $count_str_write = 0;
	// предполагаемое кол-во записей
	public $rows_count = 1;
	// какие данные показал прогресс в процентах
	protected $cache_progress = array();
	// последний процент выполнения который показал скрипт
	public $last_proc = 0;
	// прогресс выполнения экспорта
	protected $progress = 0;
	// последний счетчик, который был затронут
	protected $RId = 0;
	// первый прибор в списке или нет? необходимо для закр.тега
	protected $startMeter = false;
	// массив пройденых приборов. Считает данные для занесения в шапку.
	protected $Meters = array();
	// кол-во данных на итериацию.
	protected $count_in_rows = 200;
	
	
	// Название файла для записи процентного соотношения выполненной работы
	protected $name_f_to_proc = 'progress.txt';
	
	// cache
	protected $cache_writing = '';
	// кол-во кешированных данных
	protected $cache_writing_count = 0;
}











final class meterexport extends meterexportV implements meterexportI{
  
  
  
  
  
  static function All(){
    
    $Export = new meterexport();
    
    $G_results = array();

    $result = array();

    $cdir = scandir($Export->getfolder_export()); 
    foreach ($cdir as $key => $value) { 
      
      $_name = smarty()->compile_dir."/cached_archive_".md5($value).".tpl.php";
      if( file_exists( $_name ) ){
        $G_results[$value] = json_decode(file_get_contents($_name),TRUE);
        continue;
      }
      
      if (!in_array($value,array(".","..","progress.txt"))){ 
         if (!is_dir($Export->getfolder_export() . DIRECTORY_SEPARATOR . $value)){
            if(filesize($Export->getfolder_export() . DIRECTORY_SEPARATOR . $value)){
              $G_results[$value] = array(
                'meters' => array(),
                'size' => filesize($Export->getfolder_export() . DIRECTORY_SEPARATOR . $value)
              );
              $domtree = new DOMDocument('1.0', 'UTF-8');
              $domtree->load($Export->getfolder_export() . DIRECTORY_SEPARATOR . $value);
              $xsdpath = new DOMXPath($domtree);
              
              //meterhead
              $attributeNodes = $xsdpath->query('//head/meterhead'); 
              if($attributeNodes){
                for( $i = 0 ; $i < $attributeNodes->length ; $i++ ){
                  $info = array();
                  if($attributeNodes->item( $i ) && $attributeNodes->item( $i )->attributes){
                    for( $_i = 0 ; $_i <= $attributeNodes->item( $i )->attributes->length ; $_i++ ){
                      if( $attributeNodes->item( $i )->attributes->item($_i) && $attributeNodes->item( $i )->attributes->item($_i)->nodeName ){
                        $info[$attributeNodes->item( $i )->attributes->item($_i)->nodeName] = $attributeNodes->item( $i )->attributes->item($_i)->value;
                      }
                    }
                    $G_results[$value]['meters'][] = $info;
                  }
                }
              }
              
              $attributeNodes = $xsdpath->query('//head');
              if( $attributeNodes->item(0)->attributes ){
                for( $i = 0 ; $i < $attributeNodes->item(0)->attributes->length ; $i++ ){
                  $G_results[$value][ $attributeNodes->item(0)->attributes->item($i)->name ] = $attributeNodes->item(0)->attributes->item($i)->value;
                }
              }
              
              file_put_contents($_name , json_encode( $G_results[$value] ));
            }
            
            unset($xsdpath);
         } 
      } 
    } 

    foreach( $G_results as $name_file => $attrs ){
      $G_results[$name_file]['picks_date_start'] = preg_replace( '/^(.*) ([0-9]*)$/' , '${1} ${2}:00:00' , $G_results[$name_file]['picks_date_start']);
      $G_results[$name_file]['picks_date_stop'] = preg_replace( '/^(.*) ([0-9]*)$/' , '${1} ${2}:00:00' , $G_results[$name_file]['picks_date_stop']);
    }
    
    return $G_results;
  }
  
  
  
  
  
  
  
  
  
  
	
	function __construct(){
		$this->now = date("Y-m-d H:i:s");
		$this->interprise = Self()->Interprise;
		$this->user = Self();
		$this->mctime = microtime(true);
		$this->memory_start = memory_get_usage();
		
		$this->time 						= time();
		
		$this->folder_main 			= Site()->Config( 'meterexport.path' , realpath( realpath( $_SERVER['DOCUMENT_ROOT'] . "/../user-data" ) ) );
		$this->folderE 					= $this->folder_main . '/u' . Self()->Interprise->Id;
		$this->folder_export 		= $this->folderE . '/export';
		
		if( !file_exists( $this->folder_main ) ){
			$this->setWarning('Папка : ' . $this->folder_main . ' не существует');
			if( @!mkdir($this->folder_main , 0777) ){
				$this->setError('Папка : ' . $this->folder_main . ' не создалась');
			}
		}else{
			$this->setSuccess('Папка : ' . $this->folder_main . ' exists');
		}
		
		if( !file_exists( $this->folderE ) ){
			$this->setWarning('Папка : ' . $this->folderE . ' не существует');
			if( @!mkdir($this->folderE , 0777) ){
				$this->setError('Папка : ' . $this->folderE . ' не создалась');
			}
		}else{
			$this->setSuccess('Папка : ' . $this->folderE . ' создана');
		}
		if( @!file_exists( $this->folder_export ) ){
			$this->setWarning('Папка : ' . $this->folder_export . ' не существует');
			if( @!mkdir($this->folder_export , 0777) ){
				$this->setError('Папка : ' . $this->folder_export . ' не создалась');
			}
		}else{
			$this->setSuccess('Папка : ' . $this->folder_export . ' создана');
		}
	}
	



	
	
	
	
	// Добавление приборов для экспорта
	public function appendMeter( $id = array() ){
		if( is_array( $id ) ){
			foreach( $id as $_id ){
				$this->MeterId[(int) $_id] = (int) $_id;
			}
		}else{
			$this->MeterId[(int) $id] = (int) $id;
		}
		
		return $this;
	}
	
	
	
	
	// Создание даты старта экспорта
	public function setDateStart( $year = 0 , $month = 0 , $day = 0 , $hour = 0 ){
		$this->y_st = $year;
		$this->m_st = $month;
		$this->d_st = $day;
		$this->h_st = $hour;
		
		$this->st_string = "{$this->y_st}-{$this->m_st}-{$this->d_st} {$this->h_st}";
		return $this;
	}
	
	
	
	
	// Создание даты окончания экспорта
	public function setDateStop( $year = 0 , $month = 0 , $day = 0 , $hour = 0 ){
		$this->y_sp = $year;
		$this->m_sp = $month;
		$this->d_sp = $day;
		$this->h_sp = $hour;
		
		$this->sp_string = "{$this->y_sp}-{$this->m_sp}-{$this->d_sp} {$this->h_sp}";
		return $this;
	}
	
	
	
	
	public function IsGood(){
		$this->createFolder();
		
		if( empty($this->MeterId) ){
			$this->setError('Вы не выбрали ни одного прибора');
		}

		if( $this->y_st <= 0 ){
			$this->setError('Указан не верный год начала импорта.');
		}
		
		if( $this->y_sp <= 0 ){
			$this->setError('Указан не верный год окончания импорта.');
		}
		
		if( count( $this->getError() ) > 0 ){
			$this->setWarning('У вас есть ошибки.Экспорт не возможен.');
			return $this;
		}
		
		return $this;
	}
	
	
	
	public function IsExists(){
    
    $NameFile = 'Export_' . md5(serialize(array($this->sp_string , $this->st_string , md5(serialize($this->MeterId)))) ) .'.xml';
		
		$this->file_export 			= $this->folder_export . '/'.$NameFile ;
    
    return file_exists($this->file_export);
  }
	
	public function export(){
    
    $NameFile = 'Export_' . md5(serialize(array($this->sp_string , $this->st_string , md5(serialize($this->MeterId)))) ) .'.xml';
		
		$this->file_export 			= $this->folder_export . '/'.$NameFile ;
    
		if( !file_put_contents($this->file_export , '') ){
			$this->setError('File : ' . $this->file_export . ' not create');
		}else{
			$this->setSuccess('File : ' . $this->file_export . ' run');
		}
    
    $Info = array(
      'name' => $NameFile,
      'start' => $this->st_string,
      'stop' => $this->sp_string,
      'time' => $this->mctime,
      'meters' => array(),
      'proc' => 0,
      'meterrun' => '',
      'counts' => array(),
    );
    
    
    $LoginfoAr = array();
    $ParameterAr = array();
    $MeterAr = array();
    $MdhAr = array();
    
    $AllCountIteration = 0;
    
    
    file_put_contents($this->folder_export . "/" . $this->name_f_to_proc, json_encode($Info) );
    
    foreach( $this->MeterId as $mid ){
      $SQL = preg_replace( '/[\r\n\t]+/', ' ', "
                SELECT Count(*) as c
                FROM meterdatahour
                WHERE meter_id
                 = {$mid}
                AND DATE( CONCAT( meterdatahour.year,  '-', meterdatahour.month,  '-', meterdatahour.day,  ' ', meterdatahour.hour ) ) 
                BETWEEN  '{$this->st_string}'
                AND  '{$this->sp_string}'");
      $res = DB::Fetch(DB::MMQ($SQL));
      $AllCountIteration = $AllCountIteration + $res['c'];
      $Info['meters'][$mid] = meter::Id($mid)->Title;
      $Info['counts'][$mid] = $res['c'];
    }
    
    $this->rows_count = $AllCountIteration;
    
    $Iteration = 0;
    
    $domtree = new DOMDocument('1.0', 'UTF-8');
    
    $domtree->preserveWhiteSpace = false;
    $domtree->formatOutput = false;
    $domtree->xmlStandalone = false;
    
      $objects = $domtree->createElement("objects");
      
        $data = $domtree->createElement('data');
        
          $Filter = array(
            'Filter' => array(
              'Id' => $this->MeterId
            )
          );
          foreach( meter::Filter($Filter)->Elements as $iMeter ){
            $meter = $domtree->createElement("meter");
            $meter->setAttribute('about' , $iMeter->About );
            $meter->setAttribute('num_485' , $iMeter->Num485 );
            $meter->setAttribute('num_serial' , $iMeter->NumSerial );
            $meter->setAttribute('meter_type' , $iMeter->Type->DllId );
            $meter->setAttribute('password' , $iMeter->Password );
            $meter->setAttribute('coef' , $iMeter->Coef );
            $meter->setAttribute('Cip' , $iMeter->Converter->Ip );
            $meter->setAttribute('Cport' , $iMeter->Converter->Port );
            $meter->setAttribute('Ctype' , $iMeter->Converter->Type->DllId );
            $meter->setAttribute('Clogin' , $iMeter->Converter->Login );
            $meter->setAttribute('Cpassword' , $iMeter->Converter->Password );
            $meter->setAttribute('Cabout' , $iMeter->Converter->About );
            $data->appendChild($meter);
            
            $MeterAr[$iMeter->Id] = $iMeter;
            $MdhAr[$iMeter->Id] = 0;
            
            
            $SQL = preg_replace( '/[\r\n\t]+/', ' ', "
              SELECT * 
              FROM meterdatahour
              WHERE meter_id
              IN (" . implode( ',' , $this->MeterId ) . ")
              AND DATE( CONCAT( meterdatahour.year,  '-', meterdatahour.month,  '-', meterdatahour.day,  ' ', meterdatahour.hour ) ) 
              BETWEEN  '{$this->st_string}'
              AND  '{$this->sp_string}'");
              
            parameter::All()->Elements;
            loginfo::All()->Elements;
            
            $Info['meterrun'] = $iMeter->Title;
              
            $RES = DB::UBSelect($SQL);
              while( $row = DB::Fetch($RES) ){
                
                set_time_limit(30);
                
                $value = $domtree->createElement("value");
                
                $iParameter = parameter::Id($row['parameter_id']);
                $iLoginfo = loginfo::Id($row['loginfo_id']);
                
                $value->setAttribute('parameter' , $iParameter->Ident );
                $value->setAttribute('year' , $row['year'] );
                $value->setAttribute('month' , $row['month'] );
                $value->setAttribute('day' , $row['day'] );
                $value->setAttribute('hour' , $row['hour'] );
                $value->setAttribute('value' , $row['value'] );
                $value->setAttribute('loginfo' , $iLoginfo->Logtext );
                $value->setAttribute('add_time' , $row['add_time'] );
                
                $this->count_str_write++;
                
                $Info['proc'] = ceil(100 / $this->rows_count * ($this->count_str_write / count($this->MeterId)));
                
                if( $this->last_proc != $Info['proc'] ){
                  file_put_contents($this->folder_export . "/" . $this->name_f_to_proc, json_encode($Info) );
                }
                
                $meter->appendChild($value);
                $ParameterAr[$iParameter->Id] = $iParameter;
                $LoginfoAr[$iLoginfo->Id] = $iLoginfo;
                $MdhAr[$iMeter->Id]++;
            }
            
          }
          
          $head = $domtree->createElement("head");
          
          $head->setAttribute('picks_date_start' , $this->st_string );
          $head->setAttribute('picks_date_stop' , $this->sp_string );
          $head->setAttribute('picks_date' , $this->now );
          $head->setAttribute('interprise' , $this->interprise->title );
          $head->setAttribute('user' , $this->user->Login );
          
          foreach( $MeterAr as $iMeter ){
            $meterhead = $domtree->createElement("meterhead");
            $meterhead->setAttribute('numserial' , $iMeter->NumSerial );
            $meterhead->setAttribute('countdate' , $MdhAr[$iMeter->Id] );
            $meterhead->setAttribute('type' , $iMeter->Type->DllId );
            $head->appendChild($meterhead);
          }
          
          
          foreach( $ParameterAr as $iParameter ){
            $parameter = $domtree->createElement("parameter");
            $parameter->setAttribute('ident' , $iParameter->Ident );
            $parameter->setAttribute('title' , $iParameter->Title );
            $head->appendChild($parameter);
          }
          
          
          foreach( $LoginfoAr as $iLoginfo ){
            $loginfo = $domtree->createElement("loginfo");
            $loginfo->setAttribute('logtext' , $iLoginfo->Logtext );
            $loginfo->setAttribute('title' , $iLoginfo->Title );
            $head->appendChild($loginfo);
          }
          
      $objects->appendChild($data);
      $objects->insertBefore($head,$data);
          
    $domtree->appendChild($objects);
    //~ echo $domtree->saveXml();
    $domtree->save($this->file_export,LIBXML_COMPACT);
    
    unlink($this->folder_export . "/" . $this->name_f_to_proc);
    return false;
	}
	
	private function appendExport( $string = '' , $caching = false ){
		$string = str_replace( array( "\n" , "\t" ) , '' , $string );
		
		if( $caching == false ){
			
			// cache
			if( $this->cache_writing !== '' && !file_put_contents( $this->file_export , $this->cache_writing . "\n" , FILE_APPEND ) ){
				$this->setError( "Строка : << " . $string . " >> не добавлена" );
			}
			
			$this->cache_writing_count = 0;
			$this->cache_writing = '';
			
			// now
			if( !file_put_contents( $this->file_export , $string . "\n" , FILE_APPEND ) ){
				$this->setError( "Строка : << " . $string . " >> не добавлена" );
			}
			
		}else{
			$this->cache_writing_count++;
			$this->cache_writing .= $string;
			if( $this->cache_writing_count > 100 ){
				$this->cache_writing_count = 0;
				$this->cache_writing = '';
			}
		}
		
		
		$this->time_run = sprintf('%0.6f', (microtime(true) - $this->mctime));
		$this->memory = sprintf('%0.6f', ( memory_get_usage() - $this->memory ) / 1024 / 1024 ) ;
		$this->count_str_write++;
		
		$procent = intval( ( 100 / $this->rows_count ) * $this->count_str_write );
		
		if( $this->last_proc != $procent ){
			$this->cache_progress[] = $procent;
			file_put_contents($this->folder_export . "/" . $this->name_f_to_proc , $procent );
			$this->last_proc = $procent;
		}
	}
	
	
	
	private function createFolder(){
		return $this;
	}
	
	private function setError( $msg = null ){
		$this->error[] = $msg;
	}
	
	private function setWarning( $msg = null ){
		$this->warning[] = $msg;
	}
	
	private function setSuccess( $msg = null ){
		$this->success[] = $msg;
	}
	
	public function getError(){
		return $this->error;
	}
	
	public function getWarning(){
		return $this->warning;
	}
	
	public function getSuccess(){
		return $this->success;
	}
	
	public function getfolder_export(){
		return $this->folder_export;
	} 
	
	public function isRun(){
		return file_exists( $this->folder_export . "/" . $this->name_f_to_proc );
	}
  
  public function getFileProgress(){
		return $this->folder_export . "/" . $this->name_f_to_proc;
	}
	
	public function getProgress(){
		return file_get_contents($this->folder_export . "/" . $this->name_f_to_proc);
	}
	
}