<?php
// md5=00000000000000000000000000000000
class modelcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`model`';
  static public $SqlFields = '`model`.`id`,`model`.`title`,`model`.`mark_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'Mark'=>array('type'=>'object','object'=>'mark','ready'=>false,'sql'=>'mark_id','value'=>null, 'rus'=>'Марки приборов'),
    'Type'=>array('type'=>'object','object'=>'metertype','ready'=>false,'sql'=>'type_id','value'=>null, 'rus'=>'Библиотека'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      model::$_R['All']
    ))
      model::$_R['All'] 
      = TObject2::Filter( new model());
    return model::$_R['All'];
  }


  public function GetFInit() {
    return model::$FInit;
  }

  public function GetClassName(){
    return 'model'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Model';
  }
  public function GetNameRus(){
    return 'Модель прибора';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(model::$_O[$id]) ){
      model::$_O[$id] = model::Id($id);
      TObject2::_DataSetAll(model::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(model::$_O[$id]) ){
      model::$_O[$id] = new model();
      TObject2::_PreInit( model::$_O[$id], $id);
    }
    return model::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = model::$SqlTable;
    $arField = Array();
    foreach( model::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return model::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = model::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = model::$FInit[$this->_ID]['sql'];
    foreach( model::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new model();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new model();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new model();
    return TObject2::Filter($t,$aParams);
  }
}
?>