<?php
// md5=00000000000000000000000000000000
class placecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`place`';
  static public $SqlFields = '`place`.`id`,`place`.`title`,`place`.`place_id`,`place`.`sort`,`place`.`interprise`,`place`.`lft`,`place`.`rgt`,`place`.`map`,`place`.`isgraphic`,`place`.`placetype_id`,`place`.`places_count`,`place`.`placessort_count`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'Place'=>array('type'=>'object','object'=>'place','ready'=>false,'sql'=>'place_id','value'=>null, 'rus'=>'Местоположение'),
    'Meters'=>array('type'=>'multy','multy'=>'meterplace','objectlink'=>'meter','multylink'=>'MeterId','ready'=>false,'value'=>'', 'rus'=>'Прибор учета', 'enter'=>17),
    'Sort'=>array('type'=>'int','ready'=>false,'sql'=>'sort','value'=>0, 'rus'=>'Сортировка'),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise','value'=>null, 'rus'=>'Компании'),
    'Lft'=>array('type'=>'int','ready'=>false,'sql'=>'lft','value'=>0, 'rus'=>'Левый указатель'),
    'Rgt'=>array('type'=>'int','ready'=>false,'sql'=>'rgt','value'=>0, 'rus'=>'Правый указатель'),
    'Map'=>array('type'=>'string','ready'=>false,'sql'=>'map','value'=>'', 'rus'=>'Карта', 'enter'=>2),
    'Isgraphic'=>array('type'=>'bool','ready'=>false,'sql'=>'isgraphic','value'=>'', 'rus'=>'Графический интерфейс', 'enter'=>33),
    'Placetype'=>array('type'=>'object','object'=>'placetype','ready'=>false,'sql'=>'placetype_id','value'=>null, 'rus'=>'Тип места'),
    'Places' => array('type'=>'fltcnt','ready'=>false,'sql'=>'places_count','value'=>-1),
    'PlacesSort' => array('type'=>'fltcnt','ready'=>false,'sql'=>'placessort_count','value'=>-1),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      place::$_R['All']
    ))
      place::$_R['All'] 
      = TObject2::Filter( new place());
    return place::$_R['All'];
  }

  static public function Tree( $c=-1 )
  {
    if( !isset( 
      place::$_R['Tree']
    ))
      place::$_R['Tree'] 
      = TObject2::Filter( new place(), Array( 
        'Filter' => Array(
            'Place'=>'0'
        ),
        'Limit'=>$c
      ));
    return place::$_R['Tree'];
  }

  static public function ByPlace( $Place, $c=-1 )
  {
    if( !isset( 
      place::$_R['ByPlace']
      ,place::$_R['ByPlace']['_'.$Place]

    ))
      place::$_R['ByPlace']['_'.$Place] 
      = TObject2::Filter( new place(), Array( 
        'Filter' => Array(
            'Place'=>$Place
        ),
        'Limit'=>$c
      ));
    return place::$_R['ByPlace']['_'.$Place];
  }

  static public function ByPlaceSort( $Place, $c=-1 )
  {
    if( !isset( 
      place::$_R['ByPlaceSort']
      ,place::$_R['ByPlaceSort']['_'.$Place]

    ))
      place::$_R['ByPlaceSort']['_'.$Place] 
      = TObject2::Filter( new place(), Array( 
        'Filter' => Array(
            'Place'=>$Place
        ), 
        'Order'=>Array('Sort'=>'ASC'),
        'Limit'=>$c
      ));
    return place::$_R['ByPlaceSort']['_'.$Place];
  }

  protected function _LoadRelateMeters() {
    if( !isset(place::$_R['RelateMeters'],place::$_R['RelateMeters'][$this->Id]) ) {
      $Meterplace = meterplace::Id(0);
      place::$_R['RelateMeters'][$this->Id] = TObject2::Filter($Meterplace,Array('Filter'=>Array('Place'=>$this->Id)));
    }
  }

  protected function _LoadMeters() {
    $this->_LoadRelateMeters();
    if( !isset( place::$_R['Meters'],place::$_R['Meters'][$this->Id] ) ){
      place::$_R['Meters'][$this->Id] = TListGroup::Init();
      foreach(place::$_R['RelateMeters'][$this->Id]->Elements as $iMeterplace) place::$_R['Meters'][$this->Id]->Add($iMeterplace->Meter);
    }
  }

  function GetRelateMeters() {
    if($this->Is){
      $this->_LoadRelateMeters();
      return place::$_R['RelateMeters'][$this->Id];
    }
    return TListGroup::Init();
  }

  function GetMeters() {
    if( !$this->Is ) return TListGroup::Init();
    $this->_LoadMeters();
    return place::$_R['Meters'][$this->Id];
  }

  function GetMetersIdIs() {
    if( !$this->Is ) return Array();
    $this->_LoadMeters();
    if( !isset(place::$_R['MetersIs'],place::$_R['MetersIs'][$this->Id]) ){
      place::$_R['MetersIs'][$this->Id] = Array();
      foreach(place::$_R['Meters'][$this->Id]->Elements as $i) place::$_R['MetersIs'][$this->Id][$i->Id] = 1;
    }
    return place::$_R['MetersIs'][$this->Id];
  }

  function AddMeters() {
    $_REQUEST['PlaceId'] = $this->Id;
    $max = 0;
    if(isset($_REQUEST['MetersIdMeterId'])) $max = max($max,count($_REQUEST['MetersIdMeterId']));
    for($i=0;$i<$max;$i++){
      if(isset($_REQUEST['MetersIdMeterId'],$_REQUEST['MetersIdMeterId'][$i]))$_REQUEST['MeterId'] = $_REQUEST['MetersIdMeterId'][$i];
      meterplace::AddByRequest();
    }
  }


  public function GetFInit() {
    return place::$FInit;
  }

  public function GetClassName(){
    return 'place'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Place';
  }
  public function GetNameRus(){
    return 'Местоположение';
  }
  

  protected function GetPlaces(){
    if($this->Is){
      if( !isset(place::$_R['Places'][$this->_F[$this->_ID]['value']])){
        place::$_R['Places'][$this->_F[$this->_ID]['value']] = place::ByPlace($this->_F[$this->_ID]['value'],-1);
        //$this->SetPlacesCount(place::$_R['Places'][$this->_F[$this->_ID]['value']]->Count);
      }
      return place::$_R['Places'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function GetPlacesSort(){
    if($this->Is){
      if( !isset(place::$_R['PlacesSort'][$this->_F[$this->_ID]['value']])){
        place::$_R['PlacesSort'][$this->_F[$this->_ID]['value']] = place::ByPlaceSort($this->_F[$this->_ID]['value'],-1);
        //$this->SetPlacesSortCount(place::$_R['PlacesSort'][$this->_F[$this->_ID]['value']]->Count);
      }
      return place::$_R['PlacesSort'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(place::$_O[$id]) ){
      place::$_O[$id] = place::Id($id);
      TObject2::_DataSetAll(place::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(place::$_O[$id]) ){
      place::$_O[$id] = new place();
      TObject2::_PreInit( place::$_O[$id], $id);
    }
    return place::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = place::$SqlTable;
    $arField = Array();
    foreach( place::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return place::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = place::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = place::$FInit[$this->_ID]['sql'];
    foreach( place::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    $this->RelateMeters->DeleteAll();
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new place();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new place();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new place();
    return TObject2::Filter($t,$aParams);
  }
}
?>
