<?php
// md5=00000000000000000000000000000000
class placemappointscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`placemappoints`';
  static public $SqlFields = '`placemappoints`.`id`,`placemappoints`.`place_id`,`placemappoints`.`type`,`placemappoints`.`description`,`placemappoints`.`byplace`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Place'=>array('type'=>'object','object'=>'place','ready'=>false,'sql'=>'place_id','value'=>null, 'enter'=>4),
    'Type'=>array('type'=>'string','ready'=>false,'sql'=>'type','value'=>'', 'rus'=>'Тип точки'),
    'Description'=>array('type'=>'text','ready'=>false,'sql'=>'description','value'=>'', 'rus'=>'Описание точки', 'enter'=>3),
    'Byplace'=>array('type'=>'int','ready'=>false,'sql'=>'byplace','value'=>0, 'rus'=>'Местоположение'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      placemappoints::$_R['All']
    ))
      placemappoints::$_R['All'] 
      = TObject2::Filter( new placemappoints());
    return placemappoints::$_R['All'];
  }


  public function GetFInit() {
    return placemappoints::$FInit;
  }

  public function GetClassName(){
    return 'placemappoints'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Placemappoints';
  }
  public function GetNameRus(){
    return 'Торчки на карте сети';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(placemappoints::$_O[$id]) ){
      placemappoints::$_O[$id] = placemappoints::Id($id);
      TObject2::_DataSetAll(placemappoints::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(placemappoints::$_O[$id]) ){
      placemappoints::$_O[$id] = new placemappoints();
      TObject2::_PreInit( placemappoints::$_O[$id], $id);
    }
    return placemappoints::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = placemappoints::$SqlTable;
    $arField = Array();
    foreach( placemappoints::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return placemappoints::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = placemappoints::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = placemappoints::$FInit[$this->_ID]['sql'];
    foreach( placemappoints::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new placemappoints();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new placemappoints();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new placemappoints();
    return TObject2::Filter($t,$aParams);
  }
}
?>
