<?php
// md5=00000000000000000000000000000000
class readwavecustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`readwave`';
  static public $SqlFields = '`readwave`.`id`,`readwave`.`date_start`,`readwave`.`date_end`,`readwave`.`all_count`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'DateStart'=>array('type'=>'string','ready'=>false,'sql'=>'date_start','value'=>'','notnull'=>1, 'rus'=>'Дата начала опроса', 'enter'=>2),
    'DateEnd'=>array('type'=>'string','ready'=>false,'sql'=>'date_end','value'=>'','notnull'=>1, 'rus'=>'Дата окончания опроса', 'enter'=>2),
    'Meters'=>array('type'=>'int','ready'=>false,'sql'=>'all_count','value'=>0, 'rus'=>'Количество приборов', 'enter'=>26),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      readwave::$_R['All']
    ))
      readwave::$_R['All'] 
      = TObject2::Filter( new readwave());
    return readwave::$_R['All'];
  }


  public function GetFInit() {
    return readwave::$FInit;
  }

  public function GetClassName(){
    return 'readwave'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Readwave';
  }
  public function GetNameRus(){
    return 'Опрос';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(readwave::$_O[$id]) ){
      readwave::$_O[$id] = readwave::Id($id);
      TObject2::_DataSetAll(readwave::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(readwave::$_O[$id]) ){
      readwave::$_O[$id] = new readwave();
      TObject2::_PreInit( readwave::$_O[$id], $id);
    }
    return readwave::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = readwave::$SqlTable;
    $arField = Array();
    foreach( readwave::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return readwave::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = readwave::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = readwave::$FInit[$this->_ID]['sql'];
    foreach( readwave::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new readwave();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new readwave();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new readwave();
    return TObject2::Filter($t,$aParams);
  }
}
?>
