<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

/**
 * Smarty {assign} compiler function plugin
 *
 * Type:     compiler function<br>
 * Name:     assign<br>
 * Purpose:  assign a value to a template variable
 * @link http://smarty.php.net/manual/en/language.custom.functions.php#LANGUAGE.FUNCTION.ASSIGN {assign}
 *       (Smarty online manual)
 * @author Monte Ohrt <monte at ohrt dot com> (initial author)
 * @auther messju mohr <messju at lammfellpuschen dot de> (conversion to compiler function)
 * @param string containing var-attribute and value-attribute
 * @param Smarty_Compiler
 */
function smarty_compiler_source_seek($tag_attrs, &$compiler )
{
  $_params = $compiler->_parse_attrs($tag_attrs);
  
  $str = "
  
  DB::DataSeek({$_params['source']} , {$_params['iterator_source']});
  
  \$ROW = DB::Fetch({$_params['source']});
  
  \$MDH = \$ROW ? meterdatahour::SetFieldsFromObject(\$ROW) : meterdatahour::Id(0);
  if(\$MDH->Parameter->Id == {$_params['parameter']} && \$MDH->Meter->Id == {$_params['meter']}->Id){
    echo \$MDH->HtmlValue;
    {$_params['iterator_source']}++;
    \$MDH->Des;
  }";
  
  return $str;
  
}

/* vim: set expandtab: */

?>
