<?php

function smarty_modifier_timeago($timestamp)
{
    $time = time()-$timestamp;
    if($time < 0){
      return "";
    }
    elseif($time < 61){
      return "минуту назад";
    }
    elseif( ($time < 3600) and (floor($time/60)%10 <5) and (floor($time/60)%10 >0)){
      return ceil($time/60)." минуты назад";
    }
    elseif($time < 3600){
      return ceil($time/60)." минут назад";
    }
    elseif( date("Ymd",$timestamp) == date("Ymd") ){
      return "Сегодня, ".date("H:i",$timestamp);
    }
    elseif( date("Ymd",$timestamp+86400) == date("Ymd") ){
      return "Вчера, ".date("H:i",$timestamp);
    }
    else{
      return date("d.m.Y, H:i",$timestamp);
    }
}

/* vim: set expandtab: */

?>
