<?php
// md5=00000000000000000000000000000000
class taskcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`task`';
  static public $SqlFields = '`task`.`id`,`task`.`meter_id`,`task`.`parameter_id`,`task`.`tarif_id`,`task`.`year`,`task`.`month`,`task`.`day`,`task`.`hour`,`task`.`taskstatus_id`,`task`.`is_temp`,`task`.`ts_start`,`task`.`ts_end`,`task`.`ts_add`,`task`.`retry`,`task`.`retry_max`,`task`.`user_id`,`task`.`interprise_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Meter'=>array('type'=>'object','object'=>'meter','ready'=>false,'sql'=>'meter_id','value'=>null,'notnull'=>1, 'rus'=>'Прибор учета', 'enter'=>4),
    'Parameter'=>array('type'=>'object','object'=>'parameter','ready'=>false,'sql'=>'parameter_id','value'=>null,'notnull'=>1, 'rus'=>'Параметр'),
    'Tarif'=>array('type'=>'object','object'=>'tarif','ready'=>false,'sql'=>'tarif_id','value'=>null, 'rus'=>'Тариф'),
    'Year'=>array('type'=>'int','ready'=>false,'sql'=>'year','value'=>0, 'rus'=>'Год'),
    'Month'=>array('type'=>'int','ready'=>false,'sql'=>'month','value'=>0, 'rus'=>'Месяц'),
    'Day'=>array('type'=>'int','ready'=>false,'sql'=>'day','value'=>0, 'rus'=>'День'),
    'Hour'=>array('type'=>'int','ready'=>false,'sql'=>'hour','value'=>0, 'rus'=>'Час'),
    'Taskstatus'=>array('type'=>'object','object'=>'taskstatus','ready'=>false,'sql'=>'taskstatus_id','value'=>null, 'rus'=>'Статус задания', 'enter'=>22),
    'IsTemp'=>array('type'=>'bool','ready'=>false,'sql'=>'is_temp','value'=>'', 'rus'=>'Временное задание', 'enter'=>7),
    'TsStart'=>array('type'=>'ts','ready'=>false,'sql'=>'ts_start','value'=>'', 'rus'=>'Время старта'),
    'TsEnd'=>array('type'=>'ts','ready'=>false,'sql'=>'ts_end','value'=>'', 'rus'=>'Время завершения'),
    'TsAdd'=>array('type'=>'its','ready'=>false,'sql'=>'ts_add','value'=>'', 'rus'=>'Время добавления'),
    'Retry'=>array('type'=>'int','ready'=>false,'sql'=>'retry','value'=>0, 'rus'=>'Попытка'),
    'Retrymax'=>array('type'=>'int','ready'=>false,'sql'=>'retry_max','value'=>0, 'rus'=>'Максимальное кол-во попыток'),
    'User'=>array('type'=>'object','object'=>'user','ready'=>false,'sql'=>'user_id','value'=>null, 'rus'=>'Пользователь', 'enter'=>4),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise_id','value'=>null, 'rus'=>'Компании', 'enter'=>4),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      task::$_R['All']
    ))
      task::$_R['All'] 
      = TObject2::Filter( new task());
    return task::$_R['All'];
  }

  static public function ByMeter( $Meter, $c=-1 )
  {
    if( !isset( 
      task::$_R['ByMeter']
      ,task::$_R['ByMeter']['_'.$Meter]

    ))
      task::$_R['ByMeter']['_'.$Meter] 
      = TObject2::Filter( new task(), Array( 
        'Filter' => Array(
            'Meter'=>$Meter
        ),
        'Limit'=>$c
      ));
    return task::$_R['ByMeter']['_'.$Meter];
  }

  static public function ByTaskstatus( $Taskstatus, $c=-1 )
  {
    if( !isset( 
      task::$_R['ByTaskstatus']
      ,task::$_R['ByTaskstatus']['_'.$Taskstatus]

    ))
      task::$_R['ByTaskstatus']['_'.$Taskstatus] 
      = TObject2::Filter( new task(), Array( 
        'Filter' => Array(
            'Taskstatus'=>$Taskstatus
        ),
        'Limit'=>$c
      ));
    return task::$_R['ByTaskstatus']['_'.$Taskstatus];
  }


  public function GetFInit() {
    return task::$FInit;
  }

  public function GetClassName(){
    return 'task'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Task';
  }
  public function GetNameRus(){
    return 'Задание';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(task::$_O[$id]) ){
      task::$_O[$id] = task::Id($id);
      TObject2::_DataSetAll(task::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(task::$_O[$id]) ){
      task::$_O[$id] = new task();
      TObject2::_PreInit( task::$_O[$id], $id);
    }
    return task::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = task::$SqlTable;
    $arField = Array();
    foreach( task::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return task::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = task::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = task::$FInit[$this->_ID]['sql'];
    foreach( task::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new task();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new task();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = array() , $etc = array()){
    $t=new task();
    return TObject2::Filter($t,$aParams);
  }
}
?>
