<?php
// md5=00000000000000000000000000000000
class taskstatuscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`taskstatus`';
  static public $SqlFields = '`taskstatus`.`id`,`taskstatus`.`title`,`taskstatus`.`ident`,`taskstatus`.`tasks_count`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Title'=>array('type'=>'string','ready'=>false,'sql'=>'title','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>2),
    'Ident'=>array('type'=>'string','ready'=>false,'sql'=>'ident','value'=>'', 'rus'=>'Идентификатор', 'enter'=>2),
    'Tasks' => array('type'=>'fltcnt','ready'=>false,'sql'=>'tasks_count','value'=>-1),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      taskstatus::$_R['All']
    ))
      taskstatus::$_R['All'] 
      = TObject2::Filter( new taskstatus());
    return taskstatus::$_R['All'];
  }


  public function GetFInit() {
    return taskstatus::$FInit;
  }

  public function GetClassName(){
    return 'taskstatus'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Taskstatus';
  }
  public function GetNameRus(){
    return 'Статус задания';
  }
  

  protected function GetTasks(){
    if($this->Is){
      if( !isset(taskstatus::$_R['Tasks'][$this->_F[$this->_ID]['value']])){
        taskstatus::$_R['Tasks'][$this->_F[$this->_ID]['value']] = task::ByTaskstatus($this->_F[$this->_ID]['value'],-1);
        //$this->SetTasksCount(taskstatus::$_R['Tasks'][$this->_F[$this->_ID]['value']]->Count);
      }
      return taskstatus::$_R['Tasks'][$this->_F[$this->_ID]['value']];
    }
    else return TListGroup::Init();
  }

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(taskstatus::$_O[$id]) ){
      taskstatus::$_O[$id] = taskstatus::Id($id);
      TObject2::_DataSetAll(taskstatus::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(taskstatus::$_O[$id]) ){
      taskstatus::$_O[$id] = new taskstatus();
      TObject2::_PreInit( taskstatus::$_O[$id], $id);
    }
    return taskstatus::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = taskstatus::$SqlTable;
    $arField = Array();
    foreach( taskstatus::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return taskstatus::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = taskstatus::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = taskstatus::$FInit[$this->_ID]['sql'];
    foreach( taskstatus::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new taskstatus();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new taskstatus();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new taskstatus();
    return TObject2::Filter($t,$aParams);
  }
}
?>
