<?php
// md5=00000000000000000000000000000000
class typefieldscustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`typefields`';
  static public $SqlFields = '`typefields`.`id`,`typefields`.`ident`,`typefields`.`name`,`typefields`.`isoptions`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Ident'=>array('type'=>'string','ready'=>false,'sql'=>'ident','value'=>'', 'rus'=>'Идентификатор'),
    'Name'=>array('type'=>'string','ready'=>false,'sql'=>'name','value'=>'', 'rus'=>'Название'),
    'Isoptions'=>array('type'=>'bool','ready'=>false,'sql'=>'isoptions','value'=>'', 'rus'=>'Множественный выбор', 'enter'=>7),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      typefields::$_R['All']
    ))
      typefields::$_R['All'] 
      = TObject2::Filter( new typefields());
    return typefields::$_R['All'];
  }


  public function GetFInit() {
    return typefields::$FInit;
  }

  public function GetClassName(){
    return 'typefields'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Typefields';
  }
  public function GetNameRus(){
    return 'Типы полей';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(typefields::$_O[$id]) ){
      typefields::$_O[$id] = typefields::Id($id);
      TObject2::_DataSetAll(typefields::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(typefields::$_O[$id]) ){
      typefields::$_O[$id] = new typefields();
      TObject2::_PreInit( typefields::$_O[$id], $id);
    }
    return typefields::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = typefields::$SqlTable;
    $arField = Array();
    foreach( typefields::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return typefields::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = typefields::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = typefields::$FInit[$this->_ID]['sql'];
    foreach( typefields::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new typefields();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new typefields();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new typefields();
    return TObject2::Filter($t,$aParams);
  }
}
?>
