<?php
// md5=00000000000000000000000000000000
class user_sessioncustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`user_session`';
  static public $SqlFields = '`user_session`.`id`,`user_session`.`user_id`,`user_session`.`timestamp`,`user_session`.`ipint`,`user_session`.`sid`,`user_session`.`url`,`user_session`.`agent`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'User'=>array('type'=>'object','object'=>'user','ready'=>false,'sql'=>'user_id','value'=>null, 'rus'=>'Пользователь'),
    'Timestamp'=>array('type'=>'its','ready'=>false,'sql'=>'timestamp','value'=>'', 'rus'=>'Дата добавления', 'enter'=>26),
    'Ipint'=>array('type'=>'int','ready'=>false,'sql'=>'ipint','value'=>'', 'rus'=>'IP Адрес'),
    'Sid'=>array('type'=>'string','ready'=>false,'sql'=>'sid','value'=>''),
    'Url'=>array('type'=>'string','ready'=>false,'sql'=>'url','value'=>''),
    'Agent'=>array('type'=>'string','ready'=>false,'sql'=>'agent','value'=>''),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      user_session::$_R['All']
    ))
      user_session::$_R['All'] 
      = TObject2::Filter( new user_session());
    return user_session::$_R['All'];
  }


  public function GetFInit() {
    return user_session::$FInit;
  }

  public function GetClassName(){
    return 'user_session'; //get_class($this);
  }
  public function GetNameBig(){
    return 'UserSession';
  }
  public function GetNameRus(){
    return 'Сессии';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(user_session::$_O[$id]) ){
      user_session::$_O[$id] = user_session::Id($id);
      TObject2::_DataSetAll(user_session::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(user_session::$_O[$id]) ){
      user_session::$_O[$id] = new user_session();
      TObject2::_PreInit( user_session::$_O[$id], $id);
    }
    return user_session::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = user_session::$SqlTable;
    $arField = Array();
    foreach( user_session::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return user_session::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = user_session::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = user_session::$FInit[$this->_ID]['sql'];
    foreach( user_session::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = user_session::Id(0);
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new user_session();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new user_session();
    return TObject2::Filter($t,$aParams);
  }
}
?>
