<?php
/*
Имя класса userlog
Имя файла userlog.class.php ( userlogcustom.class.php )
Поля класса:
Id : id
User : object
Object : string
Property : string
ObjectId : int
Action : text
Its : its
Iip : iip
*/
class userlog extends userlogcustom{
  
  
	//~ static function SetLog( $t , $oldvalue=array() , $newvalue=array() , $field='' ){
    
    //~ $file = smarty()->template_dir[0]."log/tpl/".get_class($t)."/".$field.".tpl";
    
    //~ smarty()->assign('t' , $t);
    //~ smarty()->assign('oldvalue' , $oldvalue);
    //~ smarty()->assign('newvalue' , $newvalue);
    //~ smarty()->assign('field' , $field);
    
    //~ if( !file_exists( $file ) ){
      //~ $file = smarty()->template_dir[0]."log/tpl/index.tpl";
    //~ }
    
    //~ return userlog::AddByArray(
      //~ array(
        //~ 'Object'	 => get_class( $t),
        //~ 'ObjectId' =>  $t->Id,
        //~ 'Property' => $field,
        //~ 'UserId'	 => Self()->Id,
        //~ 'Action'	 => smarty()->fetch( $file ),
      //~ )
    //~ );
    
	//~ }
  
  
  
  
  
  
  
  /*
    Получение по полям объекта
    @return object
  */
  function GetObjecttoObj(){
    $class = $this->Object;
    return $class::Id($this->ObjectId);
  }
  
  
  
  
  
  
  
  /*
    Получение шаблона действия для отображения в логах
    @return html
  */
  function GetActionToTpl(){
    
    
    $class = $this->Object;
    $id = $this->ObjectId;
    
    $diff = (array) json_decode( $this->Action );
    
    if( json_last_error() != JSON_ERROR_NONE ){
      smarty()->assign('Action' , $this->Action);
      return smarty()->fetch('log/other.tpl');
    }
    
    $old = array();
      if( isset($diff['old']) ){
      foreach( $diff['old'] as $Ident => $value ){
        if( is_object( $class::Id( $id )->$Ident ) ){
          $c = get_class($class::Id( $id )->$Ident);
          $old[ $Ident ] = $c::Id( $value )->Title;
        }else{
          $old[ $Ident ] = $value;
        }
      }
    }
    
    $new = array();
    if( isset($diff['new']) ){
      foreach( $diff['new'] as $Ident => $value ){
        $new[ $Ident ] = $class::Id( $id )->$Ident;
      }
    }
    
    
    $oObject = $class::Id( $id );
    
    smarty()->assign( 'old' , $old );
    smarty()->assign( 'new' , $new );
    smarty()->assign( 'oObject' , $oObject );
    smarty()->assign( 'valid_object' , class_exists(get_class($oObject))."custom" );
    smarty()->assign( 'class' , $class );
    smarty()->assign( 'varname' , "o".ucfirst($class) );
    
    
    
    return smarty()->fetch('log/each_update.tpl');
  }
  
  
  /*
    Указывает с какой стороны будет панель в логе
    @return String
  */
  function GetCssClassPane(){
    if( $this->Property == "Add" ){
      return "badge";
    }
    if( $this->Property == "Delete" ){
      return "badge";
    }
    if( $this->Property == "In" ){
      return "inverted";
    }
    if( $this->Property == "Out" ){
      return "inverted";
    }
    return "badge";
  }
  
  
  
  /*
    Указывает иконку на панели в истории
    @return String
  */
  function GetCssClassIcon(){
    
    if( $this->Property == "Add" ){
      return "fa fa-plus";
    }
    if( $this->Property == "Delete" ){
      return "fa fa-times";
    }
    if( $this->Property == "In" ){
      return "glyphicon glyphicon-log-in";
    }
    if( $this->Property == "Out" ){
      return "glyphicon glyphicon-log-out";
    }
    if( $this->Property == "ON" || $this->Property == "OFF" ){
      return "fa fa-power-off";
    }
    return "fa fa-pencil";
    
  }
  
  
  
  
  /*
    Указывает цвет в панельке
    @return String
  */
  function GetCssColor(){
    if( $this->Property == "Add" ){
      return "success";
    }
    if( $this->Property == "Delete" ){
      return "danger";
    }
    if( $this->Property == "In" ){
      return "info";
    }
    if( $this->Property == "Out" ){
      return "default";
    }
    if( $this->Property == "ON"){
      return "success";
    }
    if( $this->Property == "OFF"){
      return "danger";
    }
    return "warning";
  }
  
  
  
  /*
    Преобразует в объект над которым проводились изменения
    @return Object
  */
  function GetConverterObject(){
    $class = $this->Object;
    if( !class_exists($class) ){
      return user::Id(0);
    }
    $Object = $class::Id( $this->ObjectId );
    if( !$Object->Is ) return user::Id(0);
    return $Object;
  }
  
  
  /*
    Удобное для пользователя свойство
    @return String
  */
  function GetPropertyTitle(){
    $class = $this->Object;
    if( !class_exists($class) ){
      return "";
    }
    if( !isset( $class::$FInit[ $this->Property ] ) ){
      return $this->Property;
    }
    $Prop = $class::$FInit[ $this->Property ];
    return isset( $Prop['rus'] ) ? $Prop['rus'] : "";
  }

}
