<?php
/*
Имя класса verification
Имя файла verification.class.php ( verificationcustom.class.php )
Поля класса:
Id : id
Hash : string
Email : string
Password : string
Name : string
Phone : string
Timezone : object
Create : its
*/
class verification extends verificationcustom{
  
  
  public $NeedDoUserLog = true;

  static function FindByHash( $hash ){
    $Filter = array(
      'Filter'=> array(
        'Hash' => $hash
      )
    );
    if( verification::Filter($Filter)->Count ){
      return verification::Filter($Filter)->First;
    }
    return verification::Id(0);
  }
  



  function GetIsActual(){
    $Date = new DateTime("now");
    $Mail = clone $Date;
    $Mail->setTimestamp( $this->Create);
    $Mail->modify("+1 hour");
    return $Date->getTimestamp() < $Mail->getTimestamp();
  }






  
  function SaveToDataBase(){
    
    $GLOBALS['FullRules'] = true;
    
    $Interprise = interprise::AddByArray(array(
      'Name' => $this->Name
    ));
    
    $Timezone = $this->Timezone;
    
    $oUser = user::AddByArray(array(
      'InterpriseId'  => $Interprise->Id,
      'Login'         => $this->Email,
      'Pass'          => $this->Password,
      'EMail'         => $this->Email,
      'Active'        => 1,
      'TimezoneidId'  => $Timezone->Id,
      'Type'          => 102
    ));
    
    $GLOBALS['Self'] = $oUser;
    
    place::$AddByNotReplaceLftRgt = true;
    
    include( $_SERVER['DOCUMENT_ROOT'] . "/install/helpers/place.php");
    
    self::globalReplacePointer( Self()->Interprise->Id );
    
    $this->Delete();
    
    $GLOBALS['FullRules'] = false;
    
    return $oUser;
  }
  
  
  function GetUser(){
    $Filter = array(
      'Filter' => array(
        'Login' => $this->Email
      )
    );
    if( user::Filter($Filter)->Count ){
      return user::Filter($Filter)->First;
    }
    return user::Id(0);
  }
  
  
  
  
  
  
  
  
  static public function &AddByArray($A){
    
    $GLOBALS['FullRules'] = true;
    $t = verification::Id(0);
    $A['Hash'] = md5( $A['Email'] . md5( $A['Password'] . md5( $A[( empty( $A['Enterprise'] ) ? 'Email' : 'Enterprise' )] ) ) );
    
    include( $_SERVER['DOCUMENT_ROOT'] . '/include/SwiftMailer/swift_required.php' );
    
    TObject2::StaticAddByArray($t,$A);
    
    
    $url = defined( "__PHPUNIT_PHAR__" ) ? "localhost" : "epn.nag.ru";
    $transport         = Swift_SmtpTransport::newInstance($url, 25);
    $mailer            = Swift_Mailer::newInstance($transport);
    
    
    $Filter = array(
        'Filter' => array(
            'Hash' => $A['Hash']
        )
    );
    
    $Res = verification::Filter( $Filter );
    
    smarty()->assign( 'oVerification' , $Res->First );
    
    
    $mailto = defined( "__PHPUNIT_PHAR__" ) ? "writer@local.ru" : $A['Email'];
    
    $message = (new Swift_Message('Подтверждение регистрации личного кабинета'))
      ->setContentType("text/html")
      ->setFrom(['nagruzka@nag.ru' => 'Nagruzka'])
      ->setTo([$mailto])
      ->setBody( smarty()->fetch('auth/demo/verification.tpl') )
      ;

    $result = $mailer->send($message);
    
    
    $GLOBALS['FullRules'] = false;
    
    return $t;
  }


}