<?php
// md5=00000000000000000000000000000000
class verificationcustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`verification`';
  static public $SqlFields = '`verification`.`id`,`verification`.`hash`,`verification`.`email`,`verification`.`password`,`verification`.`name`,`verification`.`phone`,`verification`.`timezone_id`,`verification`.`create`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Hash'=>array('type'=>'string','ready'=>false,'sql'=>'hash','value'=>'', 'rus'=>'Хеш'),
    'Email'=>array('type'=>'string','ready'=>false,'sql'=>'email','value'=>'', 'rus'=>'Email'),
    'Password'=>array('type'=>'string','ready'=>false,'sql'=>'password','value'=>'', 'rus'=>'Пароль'),
    'Name'=>array('type'=>'string','ready'=>false,'sql'=>'name','value'=>'', 'rus'=>'Назвение предприятия'),
    'Phone'=>array('type'=>'string','ready'=>false,'sql'=>'phone','value'=>'', 'rus'=>'Телефон'),
    'Timezone'=>array('type'=>'object','object'=>'timezone','ready'=>false,'sql'=>'timezone_id','value'=>null, 'rus'=>'Часовой пояс'),
    'Create'=>array('type'=>'its','ready'=>false,'sql'=>'create','value'=>'', 'rus'=>'Время создания'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      verification::$_R['All']
    ))
      verification::$_R['All'] 
      = TObject2::Filter( new verification());
    return verification::$_R['All'];
  }


  public function GetFInit() {
    return verification::$FInit;
  }

  public function GetClassName(){
    return 'verification'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Verification';
  }
  public function GetNameRus(){
    return 'Подтверждение действия по почте';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(verification::$_O[$id]) ){
      verification::$_O[$id] = verification::Id($id);
      TObject2::_DataSetAll(verification::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(verification::$_O[$id]) ){
      verification::$_O[$id] = new verification();
      TObject2::_PreInit( verification::$_O[$id], $id);
    }
    return verification::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = verification::$SqlTable;
    $arField = Array();
    foreach( verification::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return verification::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = verification::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = verification::$FInit[$this->_ID]['sql'];
    foreach( verification::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}
  public function __call($n,$args){return TObject2::_call($this,$n,$args);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new verification();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new verification();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new verification();
    return TObject2::Filter($t,$aParams);
  }
}
?>
