<?php
// md5=00000000000000000000000000000000
class vmetercustom extends TObject2{
  const AccessId = user::TesterAccessId;
  protected $_F = array();
  static protected $_R = array();
  protected $_State=OBJECT_NO;
  protected $_Update = false;

  static protected $_O = array();
  static public $SqlTable = '`meter`';
  static public $SqlFields = '`meter`.`id`,`meter`.`interprise`,`meter`.`converter_id`,`meter`.`type_id`,`meter`.`is_ok`,`meter`.`num_serial`,`meter`.`about`,`meter`.`timezone_id`,`meter`.`meter_extra_type_id`';
  protected $_ID = 'Id';
  static public $FInit = array(
    'Id'=>array('type'=>'id','ready'=>false,'sql'=>'id','value'=>0, 'rus'=>'Код'),
    'Interprise'=>array('type'=>'object','object'=>'interprise','ready'=>false,'sql'=>'interprise','value'=>null, 'rus'=>'Компании'),
    'Converter'=>array('type'=>'object','object'=>'vconverter','ready'=>false,'sql'=>'converter_id','value'=>null,'notnull'=>1, 'rus'=>'Виртуальные конверторы'),
    'Type'=>array('type'=>'object','object'=>'metertype','ready'=>false,'sql'=>'type_id','value'=>null,'notnull'=>1, 'rus'=>'Тип прибора опроса'),
    'IsOk'=>array('type'=>'string','ready'=>false,'sql'=>'is_ok','value'=>'', 'rus'=>'Опрашивается нормально'),
    'NumSerial'=>array('type'=>'string','ready'=>false,'sql'=>'num_serial','value'=>'','notnull'=>1, 'rus'=>'Серийный номер устройства', 'enter'=>53),
    'About'=>array('type'=>'string','ready'=>false,'sql'=>'about','value'=>'','notnull'=>1, 'rus'=>'Название', 'enter'=>53),
    'Timezone'=>array('type'=>'object','object'=>'timezone','ready'=>false,'sql'=>'timezone_id','value'=>null, 'rus'=>'Часовой пояс', 'enter'=>56),
    'Meter_extra_type'=>array('type'=>'object','object'=>'meter_extra_type','ready'=>false,'sql'=>'meter_extra_type_id','value'=>null, 'rus'=>'Дополнительные типы приборов'),
  );

  static public function All( $c=-1 )
  {
    if( !isset( 
      vmeter::$_R['All']
    ))
      vmeter::$_R['All'] 
      = TObject2::Filter( new vmeter());
    return vmeter::$_R['All'];
  }


  public function GetFInit() {
    return vmeter::$FInit;
  }

  public function GetClassName(){
    return 'vmeter'; //get_class($this);
  }
  public function GetNameBig(){
    return 'Vmeter';
  }
  public function GetNameRus(){
    return 'Виртуальные приборы учета';
  }
  

  protected function &Init(&$t,&$aValues){
    $id = $aValues[$t->FInit[$t->_ID]['sql']];
    if( !isset(vmeter::$_O[$id]) ){
      vmeter::$_O[$id] = vmeter::Id($id);
      TObject2::_DataSetAll(vmeter::$_O[$id],$aValues);
      //self::$_O[$id]->_DataSetAll($aValues);
    }
    return self::$_O[$id];
  }

  public static function Id($id) {
    $id = intval($id);
    if( !isset(vmeter::$_O[$id]) ){
      vmeter::$_O[$id] = new vmeter();
      TObject2::_PreInit( vmeter::$_O[$id], $id);
    }
    return vmeter::$_O[$id];
  }

  protected function GetSqlFields() {
    $table = vmeter::$SqlTable;
    $arField = Array();
    foreach( vmeter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang){
            $arField[] = "IF(`{$fname}_{$iLang->Code}`.`is_string`, `{$fname}_{$iLang->Code}`.`string`, `{$fname}_{$iLang->Code}`.`text`) as `{$fname}_{$iLang->Code}`";
          }
        }else{
          $arField[] = "{$table}.`{$fname}`";
        }
      }
    }
    return implode(',',$arField);
  }

  
  protected function GetSqlTable() {
    return vmeter::$SqlTable;
  }

  protected function GetSqlTableJoin() {
    $table = vmeter::$SqlTable;
    $arJoin = Array();
    //$oid = $this->_F[$this->_ID]['value'];
    $oid_sql = vmeter::$FInit[$this->_ID]['sql'];
    foreach( vmeter::$FInit as $kField => $iField){
      if( isset($iField['sql']) ){
        $fname = $iField['sql'];
        if( in_array($iField['type'],Array('string_mlang','text_mlang') ) and method_exists(Site(), 'GetLang') ){
          foreach( Site()->Languages->Elements as $iLang)
          {
            $arJoin[] = " LEFT JOIN `fields_lang` as `{$fname}_{$iLang->Code}` ON `{$fname}_{$iLang->Code}`.`object_name`='{$this->ClassName}' AND `{$fname}_{$iLang->Code}`.`language_id`='{$iLang->Code}' AND `{$fname}_{$iLang->Code}`.`object_id`={$table}.`{$oid_sql}` AND `{$fname}_{$iLang->Code}`.`object_field`='{$fname}'";
          }
        }
      }
    }
    return implode("",$arJoin);
  }
  
  function Delete() {
    TObject2::StaticDelete($this);
  }
/*== from tobject == */

  public function __get($p){return TObject2::_get($this, $p);}
  public function __set($p,$v){TObject2::_set($this,$p,$v);}

  public function UpdateByRequest(){TObject2::StaticUpdateByRequest($this);}
  public function UpdateByArray($A){TObject2::StaticUpdateByArray($this,$A);}

  static public function AddByArray($A){
    $t = new vmeter();
    TObject2::StaticAddByArray($t,$A);
    return $t;
  }

  static public function AddByRequest(){
    $t = new vmeter();
    TObject2::StaticAddByRequest($t);
    return $t;
  }

  static public function Filter($aParams = null , $etc = array()){
    $t=new vmeter();
    return TObject2::Filter($t,$aParams);
  }
}