<?php

// Очистка таблицы после наполения
if( !isset( $is_truncate_action ) ){
  $is_truncate_action = false;
}

$result = array();

$CacheActuion = array();

$ArrayObject = array();
foreach(objectrule::All()->Elements as $iObject){
	$ArrayObject[] = $iObject;
}

$ArrayAction = array(
	'Add',
	'Edit',
	'View',
	'Delete',
);

$arActionTypeValues = array();
foreach( action::All()->Elements as $iAction ){
	$CacheActuion[$iAction->Id] = $iAction;
	$arActionTypeValues[$iAction->Name][$iAction->Action][$iAction->Property] = true;
}

foreach( $ArrayObject as $iObject ){
	foreach( $ArrayAction as $action ){
		if( $iObject->Ident == 'Range' ) continue;
		$class = mb_strtolower($iObject->Ident);
		
		if( !isset( $arActionTypeValues[$iObject->Ident][$action][''] ) ){
			$Add = array(
				'Name'=>$iObject->Ident,
				'Action'=>$action,
				'Property' => '',
			);
			$Add = action::AddByArray($Add);
			$CacheActuion[$Add->Id] = $Add;
			$result[] = "Добавлен {$action}[{$Add->Id}]";
		}
		
		if($action != 'Delete') {
			foreach($class::Id(0)->FInit as $F=>$f) {
				if( isset($f['enter']) && $f['enter']) {
				
					if( isset( $arActionTypeValues[$iObject->Ident][$action][$F] ) ) continue;
				
					$ru = (isset($f['rus']) && $f['rus']!='') ? $f['rus'] : $F;
					$Add = array(
						'Name'=>$iObject->Ident,
						'Action'=>$action,
						'Property' => $F,
						'Ident' => $ru
					);
					$Add = action::AddByArray($Add);
					$CacheActuion[$Add->Id] = $Add;
					$result[] = "Добавлен {$ru}[{$Add->Id}]";
				}
			}
		}
	}
}


$Add = array(
	'Name'=>'Meter',
	'Action'=>'View',
	'Property' => 'Task',
	'Ident' => 'Задания'
);
$Filter['Filter'] = $Add;
if(!action::Filter($Filter)->Count) {
	$Add = action::AddByArray($Add);
	$CacheActuion[$Add->Id] = $Add;
	$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
}

$Add = array(
	'Name'=>'Meter',
	'Action'=>'View',
	'Property' => 'Archive',
	'Ident' => 'Архивация'
);
$Filter['Filter'] = $Add;
if(!action::Filter($Filter)->Count) {
	$Add = action::AddByArray($Add);
	$CacheActuion[$Add->Id] = $Add;
	$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
}

$Add = array(
	'Name'=>'Converter',
	'Action'=>'View',
	'Property' => 'Portcontrol',
	'Ident' => 'Web-порт'
);
$Filter['Filter'] = $Add;
if(!action::Filter($Filter)->Count) {
	$Add = action::AddByArray($Add);
	$CacheActuion[$Add->Id] = $Add;
	$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
}

$Add = array(
	'Name'=>'Converter',
	'Action'=>'Edit',
	'Property' => 'Portcontrol',
	'Ident' => 'Web-порт'
);
$Filter['Filter'] = $Add;
if(!action::Filter($Filter)->Count) {
	$Add = action::AddByArray($Add);
	$CacheActuion[$Add->Id] = $Add;
	$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
}


# task 12261
$Add = array(
	'Name'=>'Place',
	'Action'=>'Edit',
	'Property' => 'Maps',
	'Ident' => 'Карта'
);
$Filter['Filter'] = $Add;
if(!action::Filter($Filter)->Count) {
	$Add = action::AddByArray($Add);
	$CacheActuion[$Add->Id] = $Add;
	$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
}




$Add = array(
	'Name'=>'Meter',
	'Action'=>'Edit',
	'Property' => 'LimitEnergy',
	'Ident' => 'Включение/Выключение приборов'
);
$Filter['Filter'] = $Add;
if(!action::Filter($Filter)->Count) {
	$Add = action::AddByArray($Add);
	$CacheActuion[$Add->Id] = $Add;
	$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
}






$Filter = array(
	'Filter' => array(
		'Name' => array(
			'Action','Interprise'
		)
	)
);
foreach(action::Filter($Filter)->Elements as $iAction){
	$result[] = "Удален {$iAction->Title}[{$iAction->Id}]";
	$iAction->Delete();
}


smarty()->append('install_blocks' , array( 'action' => "Действия" ) , true );
smarty()->assign('resultAction' , $result);


if( $is_truncate_action ){
  TObject2::CleanAllObjectsByClass( 'action' );
  action::All()->DeleteAll();
}