<?php

// Очистка таблицы после наполения
if( !isset( $is_truncate_user ) ){
  $is_truncate_user = false;
}



$result = array();

$Users = array(
  array( 
    'Login'     => 'Guest' , 
    'Pass'  => user::GenPass('') ,
    'Type'      => '100' ,
  ),        
  array( 
    'Login'     => 'admin' , 
    'Pass'  => user::GenPass('admin') ,
    'Type'      => '0' ,
    'InterpriseId'  => 100
  ),              
  array( 
    'Login'     => 'root' , 
    'Pass'  => user::GenPass('rootnag') ,
    'Type'      => '101' 
  ),              
);

foreach( $Users as $settings ){
  $Filter = array(
    'Filter' => $settings
  );
  $FilterUsers = user::Filter( $Filter );
  
  if( !$FilterUsers->Count ){
    
    /*
      Если есть пользователи но нет администратора то видимо его удалили
      Восстанавливать не надо
    */
    if( user::All()->Count && $settings['Login'] == 'admin' ){
      continue;
    }
    
    $Add = user::AddByArray( $settings );
    if( $Add->Id ){
      $result[] = "Пользователь {$Add->Id}:{$Add->Login} добавлен.";
    }
    if( isset($settings['Id']) && $Add->Id != $settings['Id'] ){
      $IssetUser = user::Id( $settings['Id'] );
      if( $IssetUser->Login != $Add->Login ){
        $result[] = smarty()->fetch( 'install/base_user_replace_id.tpl' , array(
          "IssetUser" => $IssetUser,                                                                        
          "Add" => $Add,                                                                        
        ));
        continue;
      }
    }
  }elseif( $FilterUsers->Count > 1 ){
    $result[] = smarty()->fetch( 'install/base_user_multy_login.tpl' , array(
      "FilterUsers" => $FilterUsers,                                                                        
      "TrueLogin" => $settings['Login'],                                                                        
    ));
  }
}

smarty()->append('install_blocks' , array( 'base_user' => "Базовые пользователи" ) , true );
smarty()->assign('resultBaseUser' , $result);

if( $is_truncate_user ){
  TObject2::CleanAllObjectsByClass( 'user' );
  user::All()->DeleteAll();
}