<?php

$result = array();
$error = array();

$ArrayIssetTask = array();
foreach( crontask::All()->Elements as $iTask ){
	$ArrayIssetTask[ $iTask->Filename ] = $iTask;
}

$Add = crontask::Id(0);

$SysId = 1;

foreach( crontask::ListTaskFiles() as $key => $resfiles ){

	$Filter = array(
		'Filter' => array(
			'Login' => $key . '@job'
		)
	);
	if( !user::Filter( $Filter )->Count ){
		$oUser = user::AddByArray(
			array(
				'Login' => $key . '@job'
			)
		);
		DB::Query( "UPDATE `user` SET  `id` =  '{$SysId}' WHERE  `user`.`id` ={$oUser->Id}" );
		$SysId++;
	}
	
	if( !isset( $ArrayIssetTask[ $key ] ) ){
		
		if( !file_exists(  $resfiles['file'] ) ) continue;
		include_once( $resfiles['file']);
		$JOB = new $resfiles['cl'];
		
		$Add = crontask::AddByArray(
			array(
				'Title'       => $resfiles['f_title'] ? $JOB->getTitle() : $resfiles['cl'],
				'Description' => $resfiles['f_des'] ? $JOB->getDescription() : $resfiles['cl'],
				'Filename'    => $key,
				'Hour'        => -1,
				'Minute'      => -1,
				'IsLog'       => 0,
				'IsEnabled'   => 1,
				'IsLocked'    => 0,
				'NextRun'     => 0,
				'Key'         => $resfiles['key'],
			)
		);
		
	}else{
		$result[] = "Задача [<b>{$key}</b>] существует ID[{$resfiles['id']}].";
		continue;
	}
	
	if( $Add->Is ){
		$result[] = "Задача [<b>{$key}</b>] была успешно добавлена.";
	}else{
		$result[] = "Задача [<b>{$key}</b>] НЕ была добавлена.";
	}
}


$Res = DB::Select("SELECT DISTINCT ( crontasklog.crontask_id ) as id FROM  `crontasklog`  WHERE crontask_id NOT  IN ( SELECT id FROM crontask )");

while( $row = DB::Fetch( $Res )){
	$error[] = "У вас есть лишние логи. ID:{$row['id']}";
}


smarty()->append('install_blocks' , array( 'crontask' => "Фоновые задачи" ) , true );
smarty()->assign('resultCrontask' , $result);