<?php
include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );


/*
  Функции для инстала
  task #28090
*/


define('LOG_PATH' , "./log.log");


function cleanLog(){
  file_put_contents( LOG_PATH , "" );
}


function setLog( $msg= "error_empty_line" ){
  $d = new DateTime('now' , new DateTimeZone("Asia/Yekaterinburg"));
  file_put_contents( LOG_PATH , sprintf( "[%-19s] %s\n" , $d->format('Y-m-d H:i:s') , $msg ) , FILE_APPEND );
}


function replaceVal( $class_name , $property , $old , $new ){
  setLog( sprintf( "%s:%-20s `%s` -> `%s`" , $class_name , $property , $old , $new ) );
}


cleanLog();





/*
  @param TListGroup TListGroup Фильтр того из чего нужно сделать дамп
  @param patern Array массив вида
    Property_class => array(
      iskey     => Bool,
      isreplace => Bool,
    )
    
  Не работает
  @param options Array Различные опции дампа
    last    - Брать только последние совпадения
    first   - Только первые
    unique  - Только уникальные
*/
function dump( $TListGroup , $patern , $options = array() ){
  
  $output = array(
    'class' => get_class($TListGroup->First),
    'elements' => array()
  );
  
  $count_keys = 0;
  
  foreach( $TListGroup->GroupBy(100)->Elements as $iGroup ){
    foreach( $iGroup->Elements as $iElem ){
      $patern_elem = array();
      foreach( $patern as $Field => $attributes ){
        
        if( isset( $attributes['iskey'] ) && $attributes['iskey'] ){
          $count_keys++;
        }
        
        $attributes['value'] = $iElem->$Field;
        if( is_object( $iElem->$Field ) ){
          $attributes['value'] = $iElem->$Field->Id;
        }
        $patern_elem[ $Field ] = $attributes;
      }
      
      $output['elements'][] = $patern_elem;
    }
    $iGroup->ElementsFreeMem;
  }
  
  if( !$count_keys ) return 'not_keys';
  
  return $output;
}



# Преобразует дамп в строку для записи
function ToStr( $Dump ){
  return "<?php \$Dump = " . var_export($Dump , true ) . ";";
}







/* 
  Загрузка на сервер
  @param dump Array
  @return Bool
*/
function backup( $dump ){
  $class_name = $dump['class'];
  
  if( !count($dump['elements']) ) return false;
  
  foreach( $dump['elements'] as $attributes ){
    
    $Filter = array(
      'Filter' => array()
    );
    
    // Массив который служит для вставки
    $ArrayByAdd = array();
    
    foreach( $attributes as $Ident => $options ){
      
      if( !isset( $options['value'] ) ){
        $options['value'] = 0;
      }
      
      if( $options['iskey'] ){
        $Filter[ 'Filter' ][ $Ident ] = $options['value'];
      }
      
      $IdentP = isset( $class_name::$FInit[ $Ident ]['object'] )
                ? $Ident."Id"
                : $Ident ;
      
      $ArrayByAdd[ $IdentP ] = $options['value'];
    }
    
    // Нет ни одного ключа для поиска
    if( empty( $Filter['Filter'] ) ){
      continue;;
    }
    
    $res = $class_name::Filter( $Filter );
    
    // Баз раздумий добавляем
    if( !$res->Count ){
      //~ $Add = $class_name::AddByArray( $ArrayByAdd );
      if( $Add->Is ){
        echo "+";
      }
    
    // Если уже есть то надо смотреть какие поля переписывать
    }elseif( $res->Count == 1 ){
      foreach( $attributes as $Ident => $options ){
      
        if( !isset( $options['value'] ) ){
          $options['value'] = 0;
        }
        
        if( isset( $class_name::$FInit[ $Ident ]['object'] ) ){
          $cl = $class_name::$FInit[ $Ident ]['object'];
          $options['value'] = $cl::Id($options['value']);
        }
        
        if( $options['isreplace'] ){
          if( isset( $class_name::$FInit[ $Ident ]['object'] ) ){
            $Obj = $options['value'];
            $old_value = $res->First->$Ident->Id;
            replaceVal( $class_name , $Ident , $old_value , $Obj->Id );
          }else{
            replaceVal( $class_name , $Ident , $res->First->$Ident , $options['value'] );
          }
        }
        
      }
    }else{
      
    
        // ...
        // Если их много то надо думать что делать
        
      
    }
    
  }
  
  
}




/*
  Представления
*/


# Пользователи
$paternUser = array( 
    'Login'     => array(
      'iskey'       => true,
      'isreplace'   => true,
    ), 
    'Pass'     => array(
      'iskey'       => true,
      'isreplace'   => true,
    ), 
    'Type'     => array(
      'iskey'       => true,
      'isreplace'   => true,
    ),
    'Interprise'     => array(
      'iskey'       => false,
      'isreplace'   => true,
    ),
);


# Конфиг
$paternConfig = array( 
    'Parametr'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'Value'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'About'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    )
);

$paternIcons = $paternConfig;


# Типы конверторов
$paternConvertertype = array( 
    'Title'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'DllId'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Converter_appointment'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# Типы приборов учета
$paternMetertype = array( 
    'Title'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'Title'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'DllId'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);


# Объекты ролей
$paternObjectrule = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Ident'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# Действия
$paternAction = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'Ident'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Action'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Property'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);


# Роли
$paternRule = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ), 
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Interprise'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);


# Патерны ролей
$paternPatern = array( 
    'Action'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Rule'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# Предприятия
$paternInterprise = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Timezone'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Limitmeters'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# Связи
$paternLink = array( 
    'User'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Interprise'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Rule'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Objectrule'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Whyid'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Auto'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# mime
$paternMime = array( 
    'Id'     => array(
      'iskey'       => true,
      'isreplace'   => false,
    ),
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Output'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# extension
$paternExtension = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);


# typesvalues
$paternTypesvalues = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Ident'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);


# typefields
$paternTypefields = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Ident'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Isoptions'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);





# fields
$paternFields = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Name'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Typefields'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Public'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Options'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Ident'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);





# fieldsobject
$paternFieldsobject = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Fields'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Fields'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# report
$paternReports = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Title'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'IsShow'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Namelink'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Mime'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Extension'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Interprise'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Objectrule'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);




# graphics
$paternGraphics = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Interprise'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Metertype'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Graphicstype'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Parameter'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Number'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);



# parameter
$paternParameter = array( 
    'Id'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Title'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Ident'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Parameterdatatype'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Tarif'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Lvl1'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Lvl2'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Lvl3'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Lvl4'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Conversion'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
    'Enterprise'     => array(
      'iskey'       => false,
      'isreplace'   => false,
    ),
);

















/*
  по какому принципу делать дамп
*/

# Пользователи
$FilterUser = array(
  'Filter' => array(
    'Login'       => array(
      'Guest',
      'admin'
    ),
    'Interprise'  => array(0,100),
    'Type >'      => 0
  ),
);



# Всякие названия
$FilterConfig = array(
  'Filter' => array(
    'Parametr LIKE'  => '%ru.%',
  ),
);


# Иконки
$FilterIcons = array(
  'Filter' => array(
    'Parametr LIKE'  => '%icon.%',
  ),
);



# Типы приборов учета
$FilterMetertype = array(
  'Filter' => array(
    'Interprise'  => '0',
  ),
);




# Роли
$FilterRule = array(
  'Filter' => array(
    'Id <'  => '5',
  ),
);



# Патерны ролей
$FilterPatern = array(
  'Filter' => array(
    'Rule <'  => '5',
  ),
  'GroupBy' => array(
    'Action','Rule'
  )
);




# Патерны ролей
$FilterInterprise = array(
  'Filter' => array(
    'Id'  => '100',
  ),
);





# Связи
$_F = array(
  'Filter' => array(
    'Login' => 'admin'
  )
);
$FilterLink = array(
  'Filter' => array(
    'User'  => user::Filter($_F)->First->Id,
    'Interprise'  => 100,
  ),
);




# Отчеты
$FilterInterprise = array(
  'Filter' => array(
    'Interpeise'  => '0',
  ),
);



# Отчеты
$FilterGraphics = array(
  'Filter' => array(
    'Interprise'  => '0',
  ),
);



# параметры
$FilterParameter = array(
  'Filter' => array(
    'Enterprise'  => '0',
  ),
);



foreach( array(
  
  'user'            => user::Filter( $FilterUser ),
  'config'          => config::Filter( $FilterConfig ),
  'icons'           => config::Filter( $FilterIcons ),
  'convertertype'   => convertertype::All(),
  'metertype'       => metertype::Filter( $FilterMetertype ),
  'objectrule'      => objectrule::All(),
  'action'          => action::All(),
  'rule'            => rule::Filter( $FilterRule ),
  'patern'          => patern::Filter( $FilterPatern ),
  'interprise'      => interprise::Filter( $FilterInterprise ),
  'link'            => link::Filter( $FilterLink ),
  'mime'            => mime::All(),
  'extension'       => extension::All(),
  'typesvalues'     => typesvalues::All(),
  'typefields'      => typefields::All(),
  'fields'          => fields::All(),
  'fieldsobject'    => fieldsobject::All(),
  'reports'         => reports::Filter($FilterInterprise),
  'graphics'        => graphics::Filter($FilterGraphics),
  'parameter'       => parameter::Filter($FilterParameter),

) as $c_el => $elems ){
  $name_Patern = "patern" . ucfirst( $c_el );
  $Dump = dump( $elems , $$name_Patern );
  
  $error_mgs = "";
  
  switch( $Dump ){
    case "not_keys" : 
      $error_mgs = sprintf( "%-20s Нет ни одного ключа." , $c_el);
    break;
  }
  
  if( $error_mgs ){
    setLog( $error_mgs );
    continue;
  }
  
  file_put_contents( "./dump/base_{$c_el}.php", ToStr( $Dump ) );
}


include("./dump/base_user.php");

backup($Dump);



echo file_get_contents( LOG_PATH );