<?php


$arLoginfoTypeValues = array(
	'CONVERTER_SETUP_ERROR' 	=> array( 
    'Logtext' => 'CONVERTER_SETUP_ERROR',
    'Title' => 'Ошибка параметров связи',
  ),
	'NO_CONNECTION' 					=> array(
    'Logtext' => 'NO_CONNECTION',
    'Title' => 'Нет связи',
    'About' => 'Нет связи до точки опроса(конвертера) - может быть вызвано неисправностью самого устройства или канала связи'
  ),
	'OK' 											=> array(
    'Logtext' => 'OK',
    'Title' => 'Готово',
    'About' => 'Стандартные данные в системе, все в полном порядке'
  ),
	'OK_CULC' 								=> array(
    'Logtext' => 'OK_CULC',
    'Title' => 'Вычисляется',
    'About' => 'Появились новые данные на прибора. Значение поставлено в очередь на пересчет и будет обновлено в ближайшее время. т.е. скорее всего будет изменено '
  ),
	'TIME_OUT' 								=> array(
    'Logtext' => 'TIME_OUT',
    'Title' => 'Нет ответа',
    'About' => 'Связь с точной опроса установлена верно, но с прибором связь установить не удалось'
  ),
	'WRONG_SERIAL' 						=> array(
    'Logtext' => 'WRONG_SERIAL',
    'Title' => 'Неверный Серийный Номер',
    'About' => 'Опрос прибора выполнен, но на этапе сверки серийного номера обнаружилось несовпадение.<br>
Возможные причины:<br>
* Прибор занесен в базу неверное, или прибор поменяли.<br>
* У прибора есть двойник по опросному номеру, и происходит конфликт запросов/ответов<br>'
  ),
	'ERROR' 									=> array(
    'Logtext' => 'ERROR',
    'Title' => 'Ошибка',
    'About' => ' 	Ошибка опроса, а так же любая другая ошибка значение которой не описано. Возможно проблемы с каналом связи, получена часть данных получена, получены в неверном формате'
  ),
	'NODATA' 									=> array(
    'Logtext' => 'NODATA',
    'Title' => 'Отсутствуют',
    'About' => 'Данные за запрашиваемую дату отсутствуют на приборе. Возможные причины:<br>
* Прибор не работал в данный промежуток времени.<br>
* Данные уже затерты новыми<br>'
  ),
	'OK_NOTFULL' 							=> array(
    'Logtext' => 'OK_NOTFULL',
    'Title' => 'Неполное',
    'About' => 'Применяется только для расчета группированных значений. Может возникать когда часть значений отсутствует. И не может быть восстановлена
Например за сутках присутствует менее 24 часовых значения.'
  ),
	'NOT_SUPPORTED' 					=> array(
    'Logtext' => 'NOT_SUPPORTED',
    'Title' => '',
    'About' => 'Прибор опрос данного параметра не поддерживает, из-за особенностей данной модификации прибора '
  ),
	'UNKNOWN(0) need update' 	=> array( 'Logtext' => 'UNKNOWN(0) need update', 	'Title' => '' 												),
);


$LogoArIsset = array();

$result = array();

foreach( loginfo::All()->Elements as $iLoginfo ) {
	if(isset($LogoArIsset[$iLoginfo->Logtext])){
		DB::Query("UPDATE `meterdatahour` SET `loginfo_id` = '{$LogoArIsset[$iLoginfo->Logtext]->Id}' WHERE `loginfo_id` = {$iLoginfo->Id}");
		$iLoginfo->Delete();
		continue;
	}
	$LogoArIsset[$iLoginfo->Logtext] = $iLoginfo;
  if( !isset( $arLoginfoTypeValues[$iLoginfo->Logtext]['About'] ) ){
    $arLoginfoTypeValues[$iLoginfo->Logtext]['About'] = "";
  }
  if( $iLoginfo->About != $arLoginfoTypeValues[$iLoginfo->Logtext]['About'] ){
    $iLoginfo->About = $arLoginfoTypeValues[$iLoginfo->Logtext]['About'];
    $result[] = "Измененео описание {$iLoginfo->Title}[{$iLoginfo->Id}] {$iLoginfo->About}";
  }
	unset ($arLoginfoTypeValues[$iLoginfo->Logtext]);
}
foreach( $arLoginfoTypeValues as $iValue ) {
	if(isset($LogoArIsset[$iValue['Logtext']])){
		continue;
	}
	$Add = loginfo::AddByArray( $iValue );
	if( $Add->Is )	{
		$result[] = "Добавлен {$Add->Title}[{$Add->Id}]";
	}
}

smarty()->append('install_blocks' , array( 'loginfo' => "Описание статусов значений" ) , true );
smarty()->assign('resultLoginfo' , $result);