Backbone.emulateJSON = true;
    Backbone.emulateHTTP = true;

var config = Backbone.Model.extend({
  defaults : {
    Value : "",
    About : "",
    id : 0,
  },
  url : function(){
    return '/api/?object=config&filter=id:' + this.id
  }
})


var View = Backbone.View.extend({
  initialize : function( block ){
    this.$el = $(block)
  },
  events : {
    'click .fa.fa-pencil' : function( e ){
      var tr = $(e.target).closest('tr')
      
      var tds = $(tr).find('td')
      
      var id = $(tr).attr('id').replace('config_id_','')
      
      var Value = $(tds).eq(2).text()
      var About = $(tds).eq(3).text()
      
      $(tds).eq(2).empty().append(
        $('<input/>').addClass('form-control').attr({
          name : 'Value',
          value : Value,
        })
      )
      $(tds).eq(3).empty().append(
        $('<input/>').addClass('form-control').attr({
          name : 'About',
          value : About,
        })
      )
      
      $(e.target).removeClass('fa-pencil').addClass('fa-save')
      
    },
    'click .fa.fa-save' : function( e ){
      var tr = $(e.target).closest('tr')
      
      var tds = $(tr).find('td')
      
      var id = $(tr).attr('id').replace('config_id_','')
      
      var Value  = $(tds).find('[name="Value"]').val()
      var About  = $(tds).find('[name="About"]').val()
      
      var a = new config({
        id : id,
        Value : Value,
        About : About,
      })
      
      a.save(null,{
        success : function(d){
          $(tds).eq(2).text( d.get('value') )
          $(tds).eq(3).text( d.get('about') )
        }
      })
      
      $(e.target).addClass('fa-pencil').removeClass('fa-save')
      
    }
  }
})


var f = []
$(document).ready(function(){
  $('.col-lg-6').each(function(i,div){
    new View( $(div) )
  })
})