define([
  "backbone",
  "converter"
] , function(
  Backbone,
  converter
){
  
  if( typeof Backbone.collection_converters == 'undefined'  ){
    Backbone.collection_converters  =  Backbone.Collection.extend({
      model : converter,
      url : function(){
        
        var count = getParameterByName('count') || 10
        var page  = getParameterByName('page') || 1
        
        let a = count * page - count
        let b = count
        
        return '/api/?object=converter&limit[]='+a+'&limit[]='+b+''
      }
      
    })
    Backbone.collection_converters = new Backbone.collection_converters()
  }
  
  return Backbone.collection_converters;
  
})
