define([
  "backbone",
  "place"
] , function(
  Backbone,
  place
){
  if( typeof Backbone.collection_places == 'undefined'  ){
    Backbone.collection_places = Backbone.Collection.extend({
      model : place,
      url : function(){
        
        var count = getParameterByName('count') || 10
        var page  = getParameterByName('page') || 1
        
        let a = count * page - count
        let b = count
        
        return '/api/?object=place&limit[]='+a+'&limit[]='+b+''
      }
    })
    Backbone.collection_places = new Backbone.collection_places();
  }
  return Backbone.collection_places;
})
