define([
  "backbone",
  "converterhelpers",
  "ckeditor",
  "ckeditor_conf"
],function(
  Backbone,
  converterhelpers,
  CKEDITOR
){

  return Backbone.View.extend({
  
  
    initialize : function(){
    },
  
  
    render : function(){
  
    },
  
  
    events : {
      
      'click .view_more' : function( e ){
        $( e.target ).next().slideDown(300)
        $( e.target ).removeClass('view_more').addClass('hide_more')
        $( e.target ).closest('a').find('i').addClass('fa-angle-up').removeClass('fa-angle-down')
        $( e.target ).closest('td').find('button').show()
        
        CKEDITOR.replace( $( e.target ).closest('td').find('textarea').attr('id') );
        
      },
      
      'click .hide_more' : function( e ){
        $( e.target ).next().slideUp(300)
        $( e.target ).addClass('view_more').removeClass('hide_more')
        $( e.target ).closest('a').find('i').removeClass('fa-angle-up').addClass('fa-angle-down')
        CKEDITOR.instances[ $( e.target ).closest('td').find('textarea').attr('id') ].destroy();
        
        $( e.target ).closest('td').find('button').hide()
        $( e.target ).closest('td').find('textarea').hide()
        
      },
      
      
      
      'click .save' : function( e ){
        var id = $(e.target).closest('tr').attr('id').replace('ct_','')
        
        var s = new converterhelpers.model({
          convertertype : id,
          text : CKEDITOR.instances['convertertype_' + id].getData()
        })
        
        s.save().then(function(){
          $(e.target).closest('tr').find('.hide_more').trigger('click')
        })
        
      }
      
      
      
      
    },
  
    el : '#list_settings_add',

  
  });

});