ISSUE = Backbone.Model.extend
  defaults : 
    ident     : null # идентификатор запроса
    # Назыать идентификаторы надо по правилу
    cmd_1     : null # команда
    cmd_2     : null # блок
    ta        : null # содержимое команды
    tp        : null # пароль
    tpu       : null # Использовать пароль или нет
    use_pass  : null # использование пароля или нет
    chanel    : null # На какой номер канала применяется
    status    : null # статус запроса
    data      : null # содержимое команды
    name      : ""   # Название каоманды
    

  # Выполнение запроса
  run : ( callback = ()-> )->

    # Выставляем у команды статус ВЫПОЛНЕНИЕ
    @.set 'status' : RUNNING

    if window.location.hostname == "rsconfig.nagruzka.net"
      path_to_sript = "./send.php"
    else 
      path_to_sript = '/rsconfig/send/'

    data = 
      act   : 'do'
      ip    : counter.get 'ip'
      port  : counter.get 'port'
      mac   : counter.get 'mac'
      cmd_1 : @.get 'cmd_1'
      cmd_2 : @.get 'cmd_2'
      
    if @.get("use_pass")
      data["tpu"] = 1
      data["tp"] = counter.get "pass"

    if @.get("ta") != @.defaults.ta
      data["ta"] = @.get "ta"
      
    $.ajax(
      url         : path_to_sript,
      dataType    : 'script',
      contentType : 'application/javascript',
      data        : data,
      cache       : false,
      async       : true,
      success     : ( response )->
        if callback
          callback response

    ).fail( ( a,b,c)->
      if callback
        callback a,b,c
        DoLog("ERROR")
    )
