ISSUES = Backbone.Collection.extend
  model : ISSUE

issues = new ISSUES [
  # данные с прибора по каналу
  ident : "get_values_chanel"
  cmd_1 : 28
  cmd_2 : 10
  name  : "Получение данных с канала"
,
  # Запись данных по каналу
  ident     : "set_values_chanel"
  cmd_1     : 28
  cmd_2     : 11
  use_pass  : true
  name      : "Запись данных на канал"
,
  # Запрос текущих данных
  ident : "get_values"
  cmd_1 : 21
  cmd_2 : 1
  name      : "Получение текущих значений"
,
  # Запрос срезов
  ident : "get_slice"
  cmd_1 : 21
  cmd_2 : 10
  name      : "Получение срезов"
,
  # Запрос идентификатора устроуйства
  ident : "get_ident"
  cmd_1 : 20,
  cmd_2 : 2
  name      : "Получение идентификатора устройства"
,
  # Запрос версии прошивки
  ident : "get_version"
  cmd_1 : 20
  cmd_2 : 3
  name      : "Получение версии устройства"
,
  # Запрос времени сервера
  ident : "get_time"
  cmd_1 : 20
  cmd_2 : 20
  name      : "Получение времени с устройства"
,
  # Установка времени
  ident     : "set_time"
  cmd_1     : 20
  cmd_2     : 21
  use_pass  : true
  name      : "Установка времени на устройство"
,
  # Установка нового пароля
  ident     : "set_pass"
  cmd_1     : 20
  cmd_2     : 10
  use_pass  : true
  name      : "Установка пароля на устройство"
]