<script id="list_converter_tpl"  type="text/x-jquery-tmpl">
  {{if converters.length}}
    <thead>
      <tr>
        <th class="action"></th>
        <th class="action"></th>
        <th>Название</th>
        <th>Тип конвертора</th>
        <th>Ip</th>
        <th>Port</th>
        <th>Приборов учета</th>
        <th>С ошибками</th>
        <th>Исключен</th>
      </tr>
    </thead>
  {{/if}}
        
<tbody>
              
  
  {{each(i,converter) converters}}
    <tr class="${converter.classRow()}" title="Есть проблемы" id="converter_${converter.get('id')}">
      <td class="action delete_converter">
        <span 
          title="Нельзя удалить - есть дочерние элементы" 
          class="fa fa-times" 
          {{if converter.get('meters_count')}}
            style="cursor:not-allowed;color:#bfbfbf;"
          {{/if}}></span>
                          
      </td>
      <td class="action edit_converter">
        <a class="fa fa-pencil" alt="edit">
        </a>
      </td>
      <td>
        <a href="${converter.get_link()}">
        <img src="/img/converter/default.png" alt="icon">
        ${converter.title()}
        </a>

      </td>
      <td>
        ${converter.type().get('title')}
      </td>
      <td>
        ${converter.get('ip')}
      </td>
      <td>
        ${converter.get('port')}
      </td>
      <td>
        ${converter.get('meters_count')}
        <a href="/converter/3/addmeter/" class="add_meter_to_converter">
          <span 
            class="text-primary fa fa-plus-circle info" 
            title="Добавить" 
            style="cursor:pointer;">
            </span>
        </a>
      </td>
      <td>
        ${converter.get('meters_error_count')}
      </td>
      <td>
        <div class="btn-group" role="group" aria-label="...">
          <form method="post" action="/converter/3/excluded_edit/" class="has-validation-callback">
            <button value="3" name="disabled" type="submit" class="btn-xs btn btn-default">Да</button>
            <button value="3" name="enabled" type="submit" class="btn-xs btn btn-success">Нет</button>
          </form>
        </div>
      </td>
    </tr>
  {{/each}}
  
  {{if !converters.length}}
    <tr>
      <td>Нет узлов учета</td>
    </tr>
  {{/if}}
  
              
  

<tr>
  <td class="action" id="add_converter_modal">
    <a class="fa fa-plus-circle"></a>
  </td>
</tr>
</tbody>
</script>