<script id="place_children_tpl"  type="text/x-jquery-tmpl">
  <table class="table table-striped table-bordered table-hover">
    <thead>
    {{if places.length }}
      <tr>
        <th class="action"></th>
        <th class="action"></th>
        <th>Название</th>
        <th>Мест</th>
        <th>Приборов</th>
      </tr>
    {{/if}}
    </thead>
    <tbody>
      
      
      {{each(i,place) places }}
        <tr id="children_place_${place.get('id')}">
          <td class="action delete_children_place" 
            data-href="/place/${place.get('id')}/delete/"
           >
              <a 
                class="fa fa-times {{if place.get('places')}}text-muted{{/if}}"
              ></a>
          </td>
          <td class="action edit_children_place">
            <a data-href="/place/${place.get('id')}/edit/" class="fa fa-pencil"></a>
          </td>
          <td>
              <a href="/place/${place.get('id')}/" class="link_to_place">
              <i class="fa fa-map-marker"></i>
                ${place.get('title')}
              </a>

          </td>
          <td>
            <a href="/place/${place.get('id')}/add/" class="short_add_place">
              <span class="text-primary fa fa-plus-circle info" title="Добавить" style="cursor:pointer;"></span>

            </a>
            ${place.get('places')}
          </td>
          <td class="short_add_meter_to_place">
            <span class="text-primary fa fa-plus-circle info" title="Добавить" style="cursor:pointer;"></span>
              ${place.get('meters')}
          </td>
        </tr>
      {{/each}}
      
      {{if !places.length }}
        <tr>
          <td>Нет дочерних элементов</td>
        </tr>
      {{/if}}
                  
      <tr>
        <td class="action" id="add_place_modal">
          <a href="/place/0/add/" class="fa fa-plus-circle"></a>
        </td>
      </tr>
    </tbody>
  </table>
</script>