define([
  "backbone",
  "cconverter_modal_add",
  "cconverter_modal_delete",
  "cconverter_modal_edit",
  "cconverters"
],function(
  Backbone,
  cconverter_modal_add,
  cconverter_modal_delete,
  cconverter_modal_edit,
  cconverters
){

  return Backbone.View.extend({
    
    
    initialize : function( model ){
      this.model = model
    },
  
  
  
    events : {
      
      'click #converter_edit_modal' : function( e ){
        
        $(e.target).closest('th').addClass( DIS_DIV )
        new cconverter_modal_edit( function(){
          $(e.target).closest('th').removeClass( DIS_DIV )
        } , this.model )
        return false;
      }
    },
    
    
    
  
    el : '#page-wrapper',
  
  
  });

});