define([
  "backbone",
  "cmeters",
  "cconverters",
  "validator"
],function(
  Backbone,
  cmeters,
  cconverters
){
  
  
  return Backbone.View.extend({
  
  
    initialize : function( converter , callback ){
      this.model = converter
      
      var data = { data : [ this.model.get('id') ] }
      
      var self = this
      
      $.get(
        '/tpl/?tpl=cmeter_modal_add',
        data,
        function( data ){
          var data = $(data)
          
          if( callback ) callback()
          
          $(data).find('[type="submit"]').remove()
          
          $(data).modal('show').on('click' , '#save_vmeter' , function(){
            if( $(data).isValid() ){
              var model = new cmeters.model({
                about : $('[name="About"]').val(),
                num_serial : $('[name="NumSerial"]').val(),
                converter : self.model.get('id'),
              })
              
              model.save().then(function(){
                cconverters.trigger('add_model' , model)
                $(data).modal('hide')
              })
            }
          }).on('hidden.bs.modal' , function(){
            $(data).remove()
          })
          
          $.validate()
          
        }
      )
      
    },
  
  
    events : {
  
    },
  
    el : 'div',
  
  
  });
  
});
