define([
  "backbone",
  "cmeters",
  "cconverters"
],function(
  Backbone,
  cmeters,
  cconverters
){
  
  
  
  return Backbone.View.extend({

    initialize : function( model , callback ){
    
      this.model = model
      this.render( callback )
      
    },
    render : function( callback ){
      
      var self = this
      
      let data = { data : [ this.model.get('id') ] }
      
      $.get(
        '/tpl/?tpl=cmeter_edit_form' , 
        data , 
        function(data){
          
          if( callback ) callback()
          
          
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).appendTo('body')
        
        if( $('#myModal').length ){
          $('#myModal').modal('show').on('hidden.bs.modal', function () {
            $('#myModal').remove()
          })
        }
        
        
        $('#save_vmeter').click(function(){
          
          if( $('#myModal').isValid() ){
            
            
            var o = {
              type          : $("#myModal").find('[name="TypeId"]').val(),
              num_serial    : $("#myModal").find('[name="NumSerial"]').val(),
              num485        : $("#myModal").find('[name="Num485"]').val(),
              about         : $("#myModal").find('[name="About"]').val(),
              timezone      : $("#myModal").find('[name="TimezoneId"]').val()
            }

            self.model.set( o )
            
            self.model.save().then(function(m){
              cmeters.trigger('sync' , self.model)
              cmeters.trigger('change_model' , self.model)
              
              $('#myModal').modal('hide')
              
            })
            
          }
          
        })

        $.validate()
        
      })
      
    }
  })
  
  
  
})