define([
  "backbone",
  "groups"
],function(
  Backbone,
  groups
){

  return Backbone.View.extend({
  
  
    initialize : function( model , callback ){
      this.model = model
      let data = {data : [ this.model.get('id') ] } 
      
      let self = this
      
      $.get(
        '/tpl/?tpl=group_delete_form' , 
        data, 
        function(data){
          
          var data = $(data)
          
          $(data).modal('show').on('click' , '#delete_user' , function(){
            
            self.model.destroy({ dataType : "text" , success : function(model,res){
              if( res == 'droped' ){
                groups.trigger('drop_model' , model)
                $(data).modal('hide')
              }
            }})
            
          }).on('hidden.bs.modal', function() {
              $(data).remove()
          })
          
          if( callback )  callback(this)
      })
      
      
    },
  
  
    tagName : 'div',
  
  });

});