define([
  'backbone',
  'meters',
  'converters'
],function(
  Backbone,
  meters,
  converters
){
  return Backbone.View.extend({
    tagName : 'div',
    initialize : function( model , callback ){
      this.model = model
      this.render( callback )
    },
    render : function( callback ){
      
      var self = this
      
      
      let data = { data : [ this.model.get('id') ]  }
      
      $.get(
      '/tpl/?tpl=meter_delete_form' , 
      data , 
      function(data){
        
        var data = $(data)
        
        $(data).find('[type="submit"]').remove()
        
        $(data).appendTo('body')
        
        $(data).modal('show').on('hidden.bs.modal', function () {
          $(data).remove()
        }).on('click' , '.more_settings_controller' , function(){
          $('.more_settings').toggleClass('hide')
          $(this).find('i').toggleClass('fa-chevron-circle-down')
          $(this).find('i').toggleClass('fa-chevron-circle-up')
        }).on('click' , '#delete_meter' , function(){
          
          self.model.destroy({
            dataType : "text",
            success : function( model , res){
              if( res == "droped" ){
                converters.trigger('delete_meter' , self.model)
              }
            }
          })
          
          $(data).modal('hide')
          
        })
        
        if( callback ) callback()
        
      })
      
      return false;
    }
  })
})  