define([
  "backbone",
  "meter_charts"
],function(
  Backbone,
  meter_charts
){

  return Backbone.View.extend({
  
  
    initialize : function(){
      
    },
    
    
    setmodel : function( model ){
      this.model = model
    },
  
  
    render : function(){
  
    },
  
  
    events : {
      'click #action_setting_graphs' : function( e ){
        $( e.target ).addClass( DIS_DIV )
        
        var self = this
        
        var data = { data : [this.model.get('id')] }  
        
        $.get(
          '/tpl/?tpl=meter_modal_grahs_parameter',
          data,
          function( tpl ){
            
            $( e.target ).removeClass( DIS_DIV )
            
            var tpl = $(tpl)
            
            $(tpl).modal('show').on('click' , '.change_parameter' , function(){
              $(this).closest('a').toggleClass('active')
            }).on('click' , '#save_meter' , function(){
              
              $.post(
                '/meter/' + self.model.get('id') + '/sg/',
                {ids:$('.modal-body').find('a.change_parameter.active').toArray().reduce(function(res,item){
                          res.push( $(item).attr('id').replace('parameter_','') );
                          return res;
                        } , [])},
                function( res ){
                  if( res == "ok" ){
                    $(tpl).modal('hide')
                  }
                }
              )
              
              
            }).on('hidden.bs.modal' , function(){
              $(tpl).remove()
              
              var data = { data : [ self.model.get('id') ] }
              
              $.get(
                '/tpl/?tpl=meter_list_parameter_graph',
                data , function(tpl){
                  $( '#block_parameters' ).replaceWith( $(tpl).find('#block_parameters') )
                }
              )
            })
          }
        )
        
        
      },
      
    },
    

  
    el : '#container_grahs'
  
  
  });

});