define([
  "backbone"
],function(
  Backbone
){
  return Backbone.View.extend({
    tagName : 'div',
    initialize : function(){
      $(this.$el).append(
      
        $('<div/>').addClass('form-group').append(
          $('<label/>').text('Название')
        ).append(
          $('<input/>').addClass('form-control').attr({
            id : 'name_filter'
          })
        )
      ).append(
        $('<div/>').jstree({
          core : {
            data : {
              url : '/api/?object=converter&tree'
            }
          },
          themes: {
            name : 'proton',
            responsive : true,
          },
          check_callback : function(operation, node, node_parent, node_position, more){
            return true;
          },
          plugins : [ "themes" , "json_data" , "ui" , "checkbox" ]
        })
      ).dialogYesNo({
        title : 'Добавление фильтра'
      })
    }
  })
})
