define([
  "backbone",
  "parameters"
],function(
  Backbone,
  parameters
){

  return Backbone.View.extend({
  
  
    initialize : function( model , callback ){
      this.model = model
      this.render( callback )
    },
  
  
    tagName : 'div',
  
  
    render : function( callback ){
      var self = this
      
      let data = { data : [ this.model.get('id') ] }
      
      $.get(
        '/tpl/?tpl=parameter_delete' , 
        data , 
        function(data){
      
          if( callback ) callback()
          
          var data = $(data)
          
          $(data).modal('show').on('hidden.bs.modal', function () {
            $('#add_parameter').remove()
          }).on('hidden.bs.modal', function () {
            $('#add_parameter').remove()
          }).on('click' , '#modal_delete_param' , function(){
            self.model.destroy({ dataType: "text", success: function(model, response) {
              if( response == 'droped' ){
                parameters.trigger('remove' , model)
                $(data).modal('hide')
              }
            }})
            return false;
          })
        
        }
      )
      
      
      
      //~ $(this.$el).append(
        //~ 'Вы действиетльно хотите удалить ' + self.model.get('title') + '?'
      //~ ).dialogYesNo({
        //~ title : 'Удаление',
        //~ isOk : function(t){
          
          //~ self.model.destroy({ dataType: "text", success: function(model, response) {
            //~ if( response == 'droped' ){
              //~ parameters.trigger('remove' , model)
            //~ }
          //~ }})
          
          //~ $(t).dialog('destroy')
        //~ }
      //~ })
    },
  
  
  
  });

});