define([
  "backbone",
  "place_modal_edit",
  "place_modal_children",
  "place_pareameter_data",
  "place_modal_to_tree"
],function(
  Backbone,
  place_modal_edit,
  place_modal_children,
  place_pareameter_data,
  place_modal_to_tree
){
  
  

  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
    },
  
  
    events : {
      
      'click #controller_edit_place' : function(){
        new place_modal_edit( this.model )
        return false;
      },
      
      
      'click #controll_child_places' : function(){
        new place_modal_children( this.model )
        return false;
      },
  
      
      
      'click #view_to_tree' : function(){
        new place_modal_to_tree( this.model )
        return false;
      },
  
      
      'click #place_edit_parameter' : function(){
        var a = new place_pareameter_data()
        a.setmodel( this.model )
        return false;
      }
  
    },
  
    el : '#block_action_place',
  
  
  });

});