define([
  "backbone",
  "places",
  "validator"
],function(
  Backbone,
  places
){
  return Backbone.View.extend({
    
    /*
      @param int Идентификатор того плейса на котором мы сейчас находимся
      @param int Идентификатор плейса куда мы хотим добавлять
      @param Backbone.Model
    */
    initialize : function( model ){
      this.model = model
      this.render()
    },
    
    /*
      @param int Идентификатор того плейса на котором мы сейчас находимся
      @param int Идентификатор плейса куда мы хотим добавлять
    */
    render : function(){
      
      let data = { data : [ 0 ] , parent : this.model.get('id') }
      
      var self = this

      $.get(
      '/tpl/?tpl=place_edit_form' , 
      data , 
      function(tpl){
        
        var tpl = $(tpl)
        
        $(tpl).find('[type="submit"]').remove()
        
        $(tpl).modal('show').on('click' , '#add_children' , function(){
          
          var place = places.model
          
          place = new place({
            title : $('[name="Title"]').val(),
            place : self.model.get('id'),
            type : $('[name="PlacetypeId"]').val()
          })
          
          place.save().then(function(  ){
            places.trigger('add' , place)
            $(tpl).modal('hide')
          })
          
        })
        
        
        $.validate()
        
      })
      
      
    }
  })
})