define([
  "backbone",
  "parameter_filter"
],function(
  Backbone,
  parameter_filter
){  
  
  return Backbone.View.extend({
  
  
    initialize : function( model ){
      
      if( !(model instanceof Backbone.Model) ) return false;
  
      this.model = model
  
    },
  
  
    events : {
      'click' : function(){
        new parameter_filter( this.model , 'place' )
        return false;
      }
    },
  
    el : '#place_edit_parameter',
  
  
  
  });

});