define([
  "backbone",
  "places",
  //~ "tmpl",
  "validator"
],function(
  Backbone,
  places
){
  return Backbone.View.extend({
    el : '#modal_add_children',
    //~ template : '#modal_add_children',

    
    /*
      @param int Идентификатор того плейса на котором мы сейчас находимся
      @param int Идентификатор плейса куда мы хотим добавлять
      @param Backbone.Model
    */
    
    events : {
      'click #add_children' : function(){
        
        var self = this
        
        if( $(self.$el).isValid() ){
          
          var a = new places.model({ 
            title : $(self.$el).find('input[name="Title"]').val(),
            type  : $(self.$el).find('select[name="PlacetypeId"]').val(),
            place : self.place_id
          })
          
          if( $(self.$el).find('input[name="BankBook"]').length ){
            a.set({
              bankbook : $(self.$el).find('input[name="BankBook"]').val()
            })
          }

          a.save().then(function(a){
            
            var model = self.model
            if( self.get_id == self.place_id ){
              var m = places.model
              model = new m(a)
            }
            places.trigger('change_model' , self.model )
          })
          $(self.$el).modal('hide')
          
          places.fetch({
            reset : true,
            data : {
              filter : "place:"+self.get_id
            }
          })
        }
        return false;
      }
    },
    
    
    /*
      @param int Идентификатор того плейса на котором мы сейчас находимся
      @param int Идентификатор плейса куда мы хотим добавлять
    */
    render : function( get_id , place_id ){
      
      this.get_id   = get_id;
      this.place_id = place_id;
      
      if( !$(this.$el).length ){
        console.error(this.$el,'. Template not in page.')
        return false;
      }
      
      var self = this
      
      places.fetch({
        data : {
          filter : "id:"+this.place_id
        },
        success : function(data){
          self.model = data.last()
          $(self.$el).modal('show')
          $(self.$el).find('[type="submit"]').remove()
        }
      })
      
      
      
      $.validate()
      
    }
  })
})