define([
  "backbone",
  "places_pages",
  "places",
  'text!/js/tpl/place/pages.tpl'
],function(
  Backbone , 
  places_pages,
  places,
  tpl
){
  
  places_pages.url = places_pages.url + window.location.search
  
  $('body').append( $(tpl) )
  
  
  return Backbone.View.extend({
    el : '.pagination.paginator_pages',
    template : '#place_hildren_pages_tpl',
    collection : places_pages,
    initialize : function( id ){
      
      var id = id || 0
      
      places_pages.fetch({
        id : id
      })
      
      this.listenTo( this.collection , 'all' , this.render )
      this.listenTo( places , 'sync' , function(){
        places_pages.fetch({
          id : id
        })
      })
      
    },
    render : function(){
      $(this.$el).empty().append(
        $(this.template).tmpl({
          pages : this.collection.toArray()
        })
      )
    }
  })
})