define([
  "backbone",
  "rules",
  "validator"
],function(
  Backbone,
  rules
){

  return Backbone.View.extend({
  
  
    initialize : function( model ){
      this.model = model
      
      var self = this
      
      let data = { data : [ this.model.get('id') ] }
      
      $.get(
        '/tpl/?tpl=rule_modal_edit',
        data,
        function( data ){
          
          var data = $(data)
          
          $(data).find('[type="submit"]').remove()
          
          $(data).modal('show').on('click' , '#save_rule' , function(){
            
            if( $(data).isValid() ){
              self.model.set({
                name : $('[name="Name"]').val()
              })
              self.model.save().then(function(){
                rules.trigger('change_model' , self.model)
                $(data).modal('hide')
              })
            }
          }).on('hidden.bs.modal' , function(){
            $(data).remove()
          })
          
          
          $.validate()
          
        }
      )
      
    },
  
  
    events : {
  
    },
  
  
  });

});