define([
  "backbone",
  "users"
],function(
  Backbone,
  users
){
  
  
  
  /*
    Иконки состояния
  */
  const ICON_UNCHECK  = 'glyphicon-unchecked'
  const ICON_CHECK    = 'glyphicon-check'
  
  
  /*
    Классы состояния
  */
  const BTN_HOVER     = 'btn-default'
  const BTN_UNCHECK   = 'btn-danger'
  const BTN_CHECK     = 'btn-success'
  
  
  
  return Backbone.View.extend({
    
    
    collection : users,
  
  
    initialize : function( model , callback ){
      
      // Все группы
      var all_group;
      
      // Группы в которых есть пользователь
      var user_group;
      
      this.model = model
      
      var self = this
      
      users.fetch({
        data : {
          filter : "type:1"
        },
        success : function( data ){
          
          all_group = data
          
          
          users.fetch({
            data : {
              filter : "id:" + self.model.get('id'),
              list_use_group : true
            },
            success : function( _data ){
              
              console.log(_data)
              
            }
          })
          
          
          if( callback ) callback(this)
          
        }
      })
      
    },
  
  
    tagName : 'div',
  
  
    events : {
  
    },
  
  
  });

});