define([
  "backbone",
  "vconverters",
  "meters",
  "vconverter",
  "vconverter_modal_delete",
  "vconverter_modal_add",
  "vmeter_modal_add",
  "vconverter_modal_edit"
],function(
  Backbone,
  vconverters,
  meters,
  vconverter,
  vconverter_modal_delete,
  vconverter_modal_add,
  vmeter_modal_add,
  vconverter_modal_edit
){
  
  
  const PREFIX_CONVERTER = 'converter_'
 

  return Backbone.View.extend({

    el : "#container_vconverter_list",

    events : {


      "click .converter_edit_item" : function ( e ){
        var e = e;
        var id = $( e.target ).closest('tr').attr('id').replace( PREFIX_CONVERTER , '' );
        var VCONVERTER = new vconverter({ id : id });
        VCONVERTER.fetch();
        new vconverter_modal_edit( id , function( new_value ){
          VCONVERTER.set({ about : new_value });
          VCONVERTER.save( ).then(function(){
            $( e.target ).closest('tr').find('td').eq(2).find('a').text(new_value);
          });
        });
        return false;
      },



      'click .delete_converter_list' : function( e ){
        var e = e;
        var id = $( e.target ).closest('tr').attr('id').replace( PREFIX_CONVERTER , '' );
        var VCONVERTER = new vconverter({ id : id });
        VCONVERTER.fetch();
        new vconverter_modal_delete( id , function( ){
          VCONVERTER.destroy({
            dataType : "text",
            success : function ( m , resp ) {
                if( resp === "droped" ){
                  $( e.target ).closest('tr').remove();
                }
            }
          })
        });
        return false;
      },



      'click #block_add_vconverter' : function( e ){
        var e = e;
        new vconverter_modal_add( function( data ){
          var VCONVERTER = new vconverter( data );
          VCONVERTER.save().then(function( resp ){
            let data = { data : [ resp.id ] };
            var url = '/tpl/?tpl=vconverter_list_item';
            $.get( url , data , function(data){
              $(e.target).closest('table').find('tbody').append($(data))
            });
          });
        });
        return false;
      }



    }
  });
});