define([
  'backbone',
  'vconverters',
  'converter_modal_edit'
],function(
  Backbone,
  converters,
  converter_modal_edit
){
  

  return Backbone.View.extend({

    initialize : function( id , callback ){

      let data = {data : [ id ] };

      var url = '/tpl/?tpl=vconverter_edit_form';

      $.get( url , data , function(data){

        var data = $(data);

        $(data).find('[type="submit"]').remove();
        
        var modal = $(data).modal('show');


        $(modal).on('click' , '#save_vconverter' , function(){

          if( $('#myModal').isValid() ){
            callback( $('[name="About"]').val() );
            $(modal).modal('hide');
          }
          $.validate();
        }).on('hidden.bs.modal', function () {
          $(modal).remove()
        });
        
      });
    }

  });
  
});