define([
  'backbone',
  'vconverter_modal_edit'
],function(
  Backbone,
  vconverter_modal_edit
){
  
  return Backbone.View.extend({
    
    
    el : '#block_converter_item_info',
    
    /*
      Назначение модели на вид
      @param model converter
    */
    setmodel : function( model ){
      this.model = model
      $(this.$el).removeClass('disable_div_mini')
      
      let self = this
      
      this.listenTo( this.model , 'change' , function(){
        $.get(
          '/tpl/?tpl=vconverter_one' , 
          {data : [ this.model.get('id') ] } , function(data){
          $(self.$el).find('tbody').replaceWith( $(data).find( 'tbody' ) )
        })
      })
      
    },
    
    
    initialize : function(){
      $(this.$el).addClass('disable_div_mini')
    },


    events : {
      'click #converter_edit_modal' : function( e ){
        
        var self = this;
        
        new vconverter_modal_edit( this.model.get('id') , function( new_value ){
          self.model.set({ about : new_value });
          self.model.save( );
        });
        return false;
      },
      
      
    }
  })
  
  
})