define([
  "backbone",
  "vmeter",
  "vmeters"
],function(
  Backbone,
  vmeter,
  vmeters
){
  
  
  return Backbone.View.extend({
    //~ tagName : 'div',
    initialize : function( converter_id , callback ){
      
      let data = { data : [ converter_id ] }

      var url = '/tpl/?tpl=vmeter_add_form';

      var callback = callback;

      $.get( url , data , function( resp ){

        var resp = $(resp);

        $(resp).find('[type="submit"]').remove();

        var modal = $(resp).modal('show');


        $(modal).on('hidden.bs.modal', function () {
          $( modal ).remove();
        }).on('click' , '#save_vmeter' , function(){
          callback({
            type          : $( modal ).find('[name="TypeId"]').val(),
            num_serial    : $( modal ).find('[name="NumSerial"]').val(),
            num_485       : $( modal ).find('[name="Num485"]').val(),
            id            : 0,
            number_plomb  : $( modal ).find('[name="NumberPlomb"]').val(),
            about         : $( modal ).find('[name="About"]').val(),
            converter     : $( modal ).find('[name="ConverterId"]').val(),
            timezone      : $( modal ).find('[name="TimezoneId"]').val(),
            extra_type    : $( modal ).find('[name="Meter_extra_typeId"]').val()
          });
          $(modal).modal('hide');
        });

      })

      return false;
    }
  })
  
})