# Тело модального окна
# Будет показано если был выбран какой то тип отличныйй от си13
# По умолчанию так же он
CONVERTER_MODAL_BODY = Backbone.View.extend
  el  : "#converter_modal_body"

  template : "#converter_modal_body_main_tpl"

  model : new CONVERTER

  parent_view : null

  # Смена поведения главного окна
  __set_btn_save_parent_view : ()->
    if @.model.isValid()
      @.parent_view.enabled_save()
    else
      @.parent_view.disabled_save()

  initialize : ( converter , parent_view )->
    @model = converter.clone()
    @parent_view = parent_view
    @render()

  render : ()->
    tpl_c = _.template( $(this.template).html() )
    $(this.$el).empty().append tpl_c( converter : @model )

    # Самый первый элемент списка сразу назначем на
    f_converter_types = converter_types.first()
    if typeof f_converter_types == "undefined"
      return
    @.model.set("type" , f_converter_types.get('id'))


  __set_port : ( e )->
    @.model.set( "port" , Number $(e.target).val() )
    if @.model.__set_about()
      $('#about').val( @.model.get('about') )
    @.__set_btn_save_parent_view()

  events : 
    
    "keyup #ip" : ( e )->
      @model.set( "ip" , $(e.target).val() )
      if @model.__set_about()
        $('#about').val( @.model.get('about') )
      @.__set_btn_save_parent_view()

    "keyup #port" : ( e )->
      @.__set_port( e )

    "mouseup #port" : ( e )->
      @.__set_port( e )

    "change #type" : ( e )->
      id = $(e.target).find(':selected').val()
      @.model.set( "type" , id )
      @.__set_btn_save_parent_view()

    "keyup #login" : ( e )->
      @.model.set( "login" , $(e.target).val())
      @.__set_btn_save_parent_view()

    "keyup #pass" : ( e )->
      @.model.set( "pass" , $(e.target).val() )
      @.__set_btn_save_parent_view()

    "keyup #about" : ( e )->
      @.model.set( "about" , $(e.target).val())
      @.model.empty_about = !$(e.target).val()
      @.__set_btn_save_parent_view()

    "keyup #timeoutconnect" : ( e )->
      @.model.set( "timeoutconnect" , Number $(e.target).val())
      @._setter_class_action_btn()
      @.__set_btn_save_parent_view()

    "keyup #timeoutreceive" : ( e )->
      @.model.set( "timeoutreceive" , Number $(e.target).val())
      @._setter_class_action_btn()
      @.__set_btn_save_parent_view()

    "keyup #portcontrol" : ( e )->
      @.model.set( "portcontrol" , Number $(e.target).val() )
      @.__set_btn_save_parent_view()

    "change #IsExcluded" : ( e )->
      @.model.set( "excluded" , if $('#IsExcluded').prop('checked') then true else false )
      $('#excluded_alert')[ if self.model.get('excluded') then "slideDown" else "slideUp" ](300)
      @.__set_btn_save_parent_view()

