
/* global Backbone */

/**
 * Вид отвечающий за правильность заполнения полей формы
 * 
 * @type Backbone.View
 */
var AUTH_DEMO = Backbone.View.extend({
  
  template : "#registration_tpl",
  
  
  initialize : function(){
    
    var tpl_c = _.template( $( this.template ).html() );
    
    $( tpl_c() ).modal('show').on('shown.bs.modal' , function(){
      new AUTH_DEMO_FORM();
    })
    
  }
  
});


var AUTH_DEMO_FORM = Backbone.View.extend({
  
  el : '#body',
  
  template : '#registration_form_tpl',
  
  
  model : new DEMO(),
  
  
  initialize : function(){
    this.render();
  },
  
  
  render : function(){
    
    var tpl_c = _.template( $( this.template ).html() );
    
    var tpl_c = tpl_c({
      demo : this.model
    });
    
    $( this.$el ).empty().append( $(tpl_c) );
    
  }
  
})




$(document).ready(function(){
  //new AUTH_DEMO();
});