/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


/* global _, Backbone */

var GROUP_LIST_USER_NOT_GROUP = Backbone.View.extend({
  
  template : "#group_list_user_tpl",
  
  collection : new USERS(),
  
  initialize : function( group ){
    this.model = group;
    
    var self = this;
    
    this.collection.fetch({
      success : function(){
        self.render();
      }
    });
    return this;
  },
  
  
  render : function(){
    
    var tpl_c = _.template( $( this.template ).html() );
    
    var modal = $( tpl_c({
      users : this.collection.toArray(),
      group : this.model
    }) );
    
    var self = this;
    
    $(modal).modal('show').on('click' , '.list-group-item' , function( e ){
      
      var data = {};
      
      var _e = e;
      
      var user_id = $(e.target).attr('id').replace('user_','');
      
      data[ !$(_e.target).hasClass('active') ? 'add_user' : 'remove_user' ] = user_id;
      
      self.model.fetch({
        data : data,
        success : function(){
          $(_e.target).toggleClass('active');
          self.model.trigger('change');
        }
      });
    }).on('hidden.bs.modal' , function(){
      $(modal).remove();
    });
    
  }
  
});