/* global Backbone, _ */

var VIEW_PERMISSION_ADD = Backbone.View.extend({
  
  template : "#permission_add_tpl",
  
  
  model : meter,
  
  
  initialize : function(){
    
    var self = this;
    
    this.collection.fetch({
      data : {
        all       : 1,
        perm_id   : meter.get('id'),
        perm_obj  : 'meter'
      },
      success : function(){
        self.render();
      }
    });
  },
  
  
  collection : new USERS(),
  
  
  render : function(){
    
    var self = this;
    
    if( !$(this.template).length ){
      console.error("undefined template #permission_add_tpl");
      return this;
    }
    
    var tpl_c = _.template( $(this.template).html() );
    
    var modal = $( tpl_c({
      users : this.collection.toArray()
    }) ).modal('show');
    
    $(modal).on('click' , 'a' , function( e ){
      var cid = $(e.target).closest('a').attr('id');
      
      var user = self.collection.get( cid );
      
      console.log( user );
      
      return false;
    });
    
  }
  
});