var IMETER_MODAL_EDIT_ADD = Backbone.View.extend({

	template  : "#meter_edit_add",
	
	initialize : function( model ){

		this.model = model

		this.render() 
	},

	render : function(){

		if( $( this.template ).length ){
			var tpl_c = _.template( $( this.template ).html() )
			var tpl_ready = tpl_c( { meter : this.model } )
			this.$el = $( tpl_ready ).modal('show')


			$(this.$el).on('hidden.bs.modal' , function(){
				$(this).remove()
			})
		}

	},



	events : {

		"keyup #meter_type" : function(e){
			this.model.set('type' , $(e.target).val() )
		},

		"change #fate_first_verification" : function( e ){
			this.model.set('date_first_verification' , $(e.target).val() )
		},

		"keyup #num_serial_form" : function(e){
			this.model.set('num_serial' , $(e.target).val() )
		},

		"keyup #about_meter" : function(e){
			this.model.set('about' , $(e.target).val() )
		},

		"change #timezone_id" : function(e){
			this.model.set('about' , $(e.target).val() )
		},
		
		"keyup #date_verification_interval" : function(e){
			this.model.set('date_verification_interval' , $(e.target).val() )
		},

		"keyup #number_plomb" : function(e){
			this.model.set('number_plomb' , $(e.target).val() )
		},


		"click #save_meter" : function(){
			
			var self = this

			this.model.save( null , {

				success : function(){

					$(self.$el).modal('hide')

				}

			})
		}

	}

})