imeters_collection = new IMETER_COLLECTION()
meters_collection = new METER_COLLECTION();
extra_meter_types_collection = new METER_EXTRA_TYPE_COLLECTION();


/*

	Главный список

*/
var IMETERS_LIST_VIEW = Backbone.View.extend({

	el : "#meters",

	template : "#meters_tpl",

	collection : imeters_collection,


	initialize : function(){
		this.listenTo( this.collection , "sync" , this.render )
		this.render()
	},

	render : function(){
		var tpl_c = _.template( $( this.template ).html() )
		$( this.$el ).empty().append( tpl_c({ 
			imeters : this.collection.toArray(),
			real_meters_collection : meters_collection,
			meter_extra_types : extra_meter_types_collection
		}) )
	},

	events : {

		"click .fa-pencil" : function( e ){
			var cid = $( e.target ).closest('tr').attr('id')
			new IMETER_MODAL_EDIT_ADD( thos.collection.get( cid ) )
			return false
		}

	}


})


$(document).ready(function(){
	
	meters_collection.filter = {
		type : "lorawan"
	}
	meters_collection.fetch({ success : function(){

		extra_meter_types_collection.fetch( {success : function(){

			imeters_collection.fetch()
			new IMETERS_LIST_VIEW()
			
		}} )


	} })
})
