$('#select_place').jstree({
  "core" : {
    "check_callback" : function () {
      return true;
    },
    'themes': {
        'name': 'proton',
        'responsive': true
    },
    'data' : {
      'url' : function (node) {
        if( node.id === '#' ){
          return '/api/place/?jstree&all';
        }else{
          return '/api/place/?jstree&all&place=' + node.id;
        }
      }
    }
  },
  "checkbox": {
      "three_state": false
  },
  "plugins" : [
    "json","types","checkbox"
  ]

}).bind('select_node.jstree' , function( e,core ){
  $('#selected_place').val( core.selected.join(",") ) 
  return false;
}).bind('deselect_node.jstree' , function( e,core ){
  $('#selected_place').val( core.selected.join(",") ) 
  return false;
})

$('[name="Type"]').on('change' , function(e){
  $('.selected_place')[ $(e.target).closest('select').val() == 0 ? "show" : "hide" ]()
})