<?php

if( !function_exists('js_out_param') ){
  
  /**
   * 
   * @global type $out_param_count
   * @global type $OkStatus
   * @param string $line Строка ответа от системы учета
   * @return boolean
   */
  function js_out_param( $line ){
    global $out_param_count;
    global $OkStatus;

    if( $num = preg_match( '/([\S\s]+)\t([\S\s]+)\t([\S\s]+)/u', $line, $match ) ){

      list( ,$param_name, $value, $status ) = $match;
      $param = Utils::rus2eng($param_name);

      // Убираем дубликаты параметров
      if( isset( $GLOBALS['print_parameters'][ $param ] ) ){
        return true;
      }

      $GLOBALS['print_parameters'][ $param ] = 1;

      $param = preg_replace( '/[^a-zA-Z0-9_]/','_', $param );
      if( 'OK' == $status ){
        $OkStatus = true;
      }

      echo "top.force_data.values( '{$param}','{$value}','{$status}' );\n";
      $oMeter = meter::id( isset( $_GET['id'] ) ? $_GET['id'] : 0 );

      # Выставление meterlast в 0 ==-
      $Filter = array(
        'Filter' => array(
          'Meter' => $oMeter->Id,
        )
      );

      $MeterlastList = meterlast::Filter($Filter);
      if($MeterlastList->Count){
        $MeterlastList->First->IsDone = 0;
      }
      # Выставление meterlast в 0 -==

      $out_param_count++;
      //~ echo $Ret; 
      if( !defined( '__PHPUNIT_PHAR__' ) ) {
        ob_flush();        flush();
      }
      return true;
    }
    // Вариант старой системы, разделитель пробел
    else if( $num = preg_match( '/(\S+)\s(\S+)\s(\S+)/u', $line, $match ) ){
      list( ,$param, $value, $status ) = $match;

      $param_d = Utils::rus2eng($param);

      // Убираем дубликаты параметров
      if( isset( $GLOBALS['print_parameters'][ $param_d ] ) ){
        return true;
      }

      $GLOBALS['print_parameters'][ $param_d ] = 1;

      if( 'OK' == $status ){
        $OkStatus = true;
      }
      $out_param_count++;
      echo "top.force_data.values_2( '{$param}','{$value}','{$status}' );\n";
      if( !defined( '__PHPUNIT_PHAR__' ) ) {
        ob_flush();        flush();
      }
      return true;
    }
    return false;
  }
}