<?php
  include( $_SERVER['DOCUMENT_ROOT']."/include/inc.php" );
  $smarty->config_load(Self()->Lang . "_lang.conf", "Reports");


  ini_set('memory_limit', Site()->Config('memmory_reports' , 5*1024) . 'M');

  if( !defined( '__PHPUNIT_PHAR__' ) ) {
    @header( $oReport->Mime->Name );
    @header( 'Content-Disposition: attachment;filename="'. $oPlace->GetNameReport() .'.'.$oReport->Extension->Name.'"' );
  }
  
  error_reporting(E_ALL);
  ini_set("display_errors", 1);


  require_once( $_SERVER['DOCUMENT_ROOT'].'/include/PHPExcel.php' );
  $cacheSettings = array( 'memoryCacheSize' => Site()->Config('memmory_reports')."M");
  
  

  PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp,$cacheSettings);

  $objPHPExcel = new PHPExcel();

  $Worksheet = $objPHPExcel->getActiveSheet();
  $WorksheetLine = 1;
  $ColumnNum = 0;

  $Size = array(
    ( 12 * 1.3),
    ( 10 * 1.3),
    ( 8  * 1.3),
    ( 18 * 1.3),
  );

  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('location') );
  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('converter') );
  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('serial_number') );
  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('rate_coef') );


  foreach($oPlace->ActiveParametersData->Elements as $iParam){
    $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iParam->Title );
    $Size[] = strlen($iParam->Title);
    
    if($iParam->Ident == "ENERGY"){
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iParam->Title."*" );
      $Size[] = strlen( $iParam->Title."*" );
    }
  }
  $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('date') );
  $Size[] = strlen( smarty()->get_config_vars('date') );
  $WorksheetLine++;


  $ColumnNum = 0;

  $constSTRING = PHPExcel_Cell_DataType::TYPE_STRING;

  for( $i = 1 ; $i <= ceil($oPlace->GetMetersAll()->Count / Site()->GetCountInPage()) ; $i++){
    $_GET['page'] = $i;
    
    foreach( $oPlace->GetMeterPlaceByPage()->Elements as $iMeterPlace ){
      
//      echo memory_get_usage() / 1024 / 1024 ."<br>\n";
      
      $iMeter = $iMeterPlace['Meter'];
      $iPlace = $iMeterPlace['Place'];
      $ColumnNum = 0;
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iPlace->PathToUpString( " / " ) );
      $Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->Title , $constSTRING );
      $Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->NumSerial , $constSTRING );
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->Coef );

      $date = "";

      foreach( $oPlace->ActiveParametersData->Elements as $iParameter ){
        $MDH = $oPlace->GetArchive($iParameter,$iMeter);

        smarty()->assign('oMDH' , $MDH);
        smarty()->assign('usingCoef' , false);

        if( $iParameter->UseCoef ){
          smarty()->assign('usingCoef' , true);
          $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, trim( smarty()->fetch('meterdatahour/helpers/report.tpl') ) );
        }else{
          $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, trim( smarty()->fetch('meterdatahour/helpers/report.tpl') ) );
        }
        $date = $MDH->AddTime;
        $MDH->__destruct();
      }
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $date );
      $WorksheetLine++;
    }
  }
//  echo DB::Status();

  $objPHPExcel->getDefaultStyle()->getBorders()->getTop()   ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getBorders()->getBottom()->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getBorders()->getLeft()  ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getBorders()->getRight() ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
  $objPHPExcel->getDefaultStyle()->getFont()->setName( 'Arial' );
  $objPHPExcel->getDefaultStyle()->getFont()->setSize( 8 ); 

  foreach (range('A', 'Z') as $char) {
      $objPHPExcel->getActiveSheet()->getColumnDimension($char)->setAutoSize(true);
  }

  foreach (range('A', 'Z') as $char) {
    foreach (range('A', 'Z') as $char2) {
        $objPHPExcel->getActiveSheet()->getColumnDimension($char.$char2)->setAutoSize(true);
    }
  }


  if( ( isset($_GET['Type']) && $_GET['Type'] == "CSV" )){
	  $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'CSV' );
    $objWriter->setDelimiter(";"); 
	}else{
	  @header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
	  @header( 'Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT' );
	  @header( "Cache-Control: no-store, no-cache, must-revalidate" );
	  @header( 'Pragma: public' );
    $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5' );
  }
  

  $objWriter->save('php://output');


