<?php

include($_SERVER['DOCUMENT_ROOT'].'/include/inc.php');

$format='Y-m-d H:00:00';

$arParams = Array(
  'Filter' => Array(
    'DateStart' => '0000-00-00 00:00:00',
  ),
);
$arMeters = meter::Filter( $arParams );
if( !$arMeters->Count )
{
  echo "Нет приборов с необходимостью восстановления";
}
foreach( $arMeters->Elements as $oMeter )
{
  echo <<<EOL
<pre>
Код : {$oMeter->Id}
DateStart: {$oMeter->DateStart}
DateLast: {$oMeter->DateLast}
</pre>
EOL;
  if($oMeter->DateStart == '0000-00-00 00:00:00')
  {
    echo "Нужно восстановить дату старта опроса<br />";
    $arParams = Array(
      'Filter' => Array(
        'Meter'   => $oMeter->Id,
        'Year >'  => '0',
        'Month >' => '0',
        'Day >'   => '0',
        'Hour >'  => '0',
      ),
      'Order'  => Array(
        'Year'    => 'ASC',
        'Month'   => 'ASC',
        'Day'     => 'ASC',
        'Hour'    => 'ASC',
      ),
      'Limit'  => 1,
    );
    $DataHour = meterdatahour::Filter( $arParams ); 
    if( isset($DataHour->Elements[0] ) )
    {
      $DataHourFirst = $DataHour->First;
      echo "Id данных ". $DataHourFirst->Id;
      $Date = new DateTime();
      $Date->setDate(
        $DataHourFirst->Year,
        $DataHourFirst->Month,
        $DataHourFirst->Day
      );
      $Date->setTime(
        $DataHourFirst->Hour-1,
        0,0
      );
      $oMeter->DateStart = $Date->format('Y-m-d H:00:00'); 
      echo "Дата добавления {$oMeter->DateStart}";
      echo $Date->format('Y-m-d H:00:00');
    }
    else
    {
      echo "Нет архивных опросов<br/>";
    }
  }
  if( $oMeter->DateLast == '0000-00-00 00:00:00' and $oMeter->DateStart != '0000-00-00 00:00:00' )
  {
    $oMeter->DateLast = $oMeter->DateStart;
    echo "Первый опрос {$oMeter->DateStart}";
  }
}


$arParams = Array(
  'Filter' => Array(
    'DateStart !=' => '',
  ),
);


/*
==================================================================================
*/
function QueryTymes( $FromDatetime, $ToDatetime ) {
  $FromDatetime
    ->setTime( $FromDatetime->format('H'), 0, 0 );
  $ToDatetime
    ->setTime( $ToDatetime->format('H'), 0, 0 );
  $IntervalToNow = $ToDatetime->diff( $FromDatetime );
  return intval(
    $IntervalToNow->format('%Y%M%D%H')
  );
}

$arMeters = meter::Filter( $arParams );
echo "Количество приборов со старыми датами опроса: $arMeters->Count<br/>";
foreach( $arMeters->Elements as $oMeter )
{
  $Step = 10;
//  $oMeter->DateLast = '2013-07-01 10:00:00'; die();
  echo "Прибор ИД:$oMeter->Id<br/> Дата последнего опроса $oMeter->DateLast <br/>";
  if( $oMeter->IsExcluded or $oMeter->Converter->IsExcluded )
  {
    echo "Исключен из опроса<br />";
    continue;
  }
  $DateNeed = $DateLast = DateTime::createFromFormat( $format, $oMeter->DateLast );
  $DateNow = new DateTime();
  //$DateNow->setTime( $Date->format('H'), 0, 0 );
  $IntervalToNow = $DateNow->diff( $DateNeed );
  while( QueryTymes( $DateNow, $DateNeed ) )
  {
    if( $Step-- < 1)
    {
      break;
    }

    $DateNeed = $DateNeed->add( new DateInterval('PT1H') );
    echo $DateNeed->format('Y-m-d H:00:00')." ";
    // Поиск существующих данных
    $arDataLook = array(
      'Filter' => array(
        'Meter'     => $oMeter->Id,
        'Year'      => $DateNeed->format( 'Y'),
        'Month'     => $DateNeed->format( 'm'),
        'Day'       => $DateNeed->format( 'd'),
        'Hour'      => $DateNeed->format( 'H')+1,
        'Tarif'     => 0,
        'Parameter' => 1,
      )
    );    
    $MDHS = meterdatahour::filter( $arDataLook );
    // Если найдены данные и оны актуальны сдвигаем DateLast
    $NeedTask = true;
    if( $MDHS->Count )
    {
      echo " count=".$MDHS->Count." value=".$MDHS->First->Value." status=".$MDHS->First->Loginfo->Logtext;
      if( in_array( $MDHS->First->Loginfo->Logtext, Array( 'OK', 'NODATA' ) ) )
      {
        $NeedTask = false;
      }
    }
    if( !$NeedTask )
    {
      if( 1 == QueryTymes( DateTime::createFromFormat( $format, $oMeter->DateLast ), $DateNeed ) )
      {
        $oMeter->DateLast = $DateNeed->format($format);
        echo "Установлено ".$DateNeed->format($format)." QueryTymes =".QueryTymes( DateTime::createFromFormat( $format, $oMeter->DateLast ), $DateNeed )." ";
      }
      else
      {
        echo "EXIT??";
      }
    }
    else
    {
      // Поиск задания если уже существует
      $arTaskLook = array(
        'Filter' => array(
          'Meter'     => $oMeter->Id,
          'Year'      => $DateNeed->format( 'Y'),
          'Month'     => $DateNeed->format( 'm'),
          'Day'       => $DateNeed->format( 'd'),
          'Hour'      => $DateNeed->format( 'H')+1,
          'Tarif'     => 0,
          'Parameter' => 1,
        )
      );
      $Task = task::filter($arTaskLook);
      if( $Task->Count )
      {
        echo "task = ". $Task->Count;
        echo " id=".$Task->First->Taskstatus->Id;
        if( $Task->First->Taskstatus->Id == 3 )
        {
          $Task->First->Taskstatus = Taskstatus::Id(1);
          $Task->First->Retry   = 0;
          $Task->First->TsStart = 0;
          $Task->First->TsEnd   = 0;
          echo " Обновлено";
          
        }
        else
        {
          echo 'Задение '.$Task->First->Taskstatus->Title;
//          if( $Task->First->Retry )
          {
            echo " Попытка {$Task->First->Retry}";
          }
        }
        //die();
      }
      else
      {
        $Add = task::AddByArray( array(
          'MeterId'     => $oMeter->Id,
          'ParameterId' => 1,
          'TarifId'     => 0,
          'Year'        => $DateNeed->format( 'Y'),
          'Month'       => $DateNeed->format( 'm'),
          'Day'         => $DateNeed->format( 'd'),
          'Hour'        => $DateNeed->format( 'H')+1,
          'TaskstatusId'=> 1,
          'TsStart'     => 0,
          'TsEnd'       => 0,
        ) );
        if( $Add->Is )
        {
          echo "Добавлено";
        }
        else
        {
          echo "Ошибка";
        }
      }
      
      
    }
  }
  
}


