<?php


/*

    Почему считает только первый вообще а не все?

*/

class job_group_days extends Jobs
{
  function getTitle()
  {
    return "Суточные архивы";
  }
  
  function getDescription()
  {
    return "Подсчет суточных данных по приборам учета";
  }

	function GetTasksCount() {
    $arLook = array(
      'Filter' => array(
      	'Year >'  => 0,
      	'Month >' => 0,
        'Day >'   => 0,
        'Hour'    => 0,
        'Loginfo' => loginfo::ByIdent('OK_CULC')->Id,
      )
    );
		return  meterdatahour::Filter( $arLook )->Count;
	}





  function Start()
  {
  
  	$LogoArIsset = array();

		foreach(loginfo::All()->Elements as $iElem){
			if( isset( $LogoArIsset[$iElem->Logtext] ) ){
				$iElem->Delete();
			}else{
				$LogoArIsset[$iElem->Logtext] = $iElem;
			}
		}

    $arLog = array();
    foreach( loginfo::All()->Elements as $iLog )
    {
      $arLog[$iLog->Logtext] = $iLog;
    }
    echo "Значения статусов в системе:\n";
    foreach($arLog as $key=>$iLog )
    {
      echo " - [{$iLog->Id}]{$key}\t| {$iLog->Title}\n";
    }
    $arLook = array(
      'Filter' => array(
      	'Year >'  => 0,
      	'Month >' => 0,
        'Day >'   => 0,
        'Hour'    => 0,
        'Loginfo' => $arLog['OK_CULC']->Id,
      ),
      'AddWhere' => ' ORDER BY RAND()'
    );
    echo "\n";
    $AllCount = meterdatahour::Filter( $arLook )->Count;
    $arLook['Limit'] = 2000;
    $MDHs = meterdatahour::Filter( $arLook );
    echo  "SQL: {$MDHs->Sql}\n";
    echo "Суточные параметры, которые необходимо обновить: {$MDHs->Count} из {$AllCount} шт\n";
    $max_start = 2000;
    $max = $max_start;
    
    
    $Step=0;
	DB::Select( '/* start main */' );
	//DB::Select( 'START TRANSACTION' );
    foreach( $MDHs->Elements as $iMDH )
    {
    	$Step++;
    	if( $Step%200 == 0 ){
			//DB::Select( "COMMIT" );
			echo "DB COMMIT\n";
			//DB::Select( 'START TRANSACTION' );
    	}
      echo "$Step [meter:{$iMDH->Meter->Id}]{$iMDH->Meter->Title}\t{$iMDH->Day}.{$iMDH->Month}.{$iMDH->Year}\t"
        ."{$iMDH->Parameter->Title}={$iMDH->Value}[{$iMDH->Loginfo->Title}]\n";
      flush();
      if( !$iMDH->Parameter->UseGrouping )
      {
        echo "Параметр {$iMDH->Parameter->Ident} не поддерживает обработку, удален {$iMDH->Id}\n";
        echo $iMDH->Delete();
        
        
        
        continue;
      }
      if( $iMDH->Parameter->IsEventLog )
      	continue;
      
      $arDataLook = array(
        'Filter' => array(
          'Meter'     => $iMDH->Meter->Id,
          'Parameter' => $iMDH->Parameter->Id,
          'Year'      => $iMDH->Year,
          'Month'     => $iMDH->Month,
          'Day'       => $iMDH->Day,
          'Hour >'    => 0,
          'Loginfo'   => array(
          	$arLog['OK']->Id,
	          $arLog['NODATA']->Id,
					),
        ),
        'Order' => array(
          'Hour'  => 'ASC',
        ),
      );
      $DayMDHs = meterdatahour::Filter( $arDataLook );
      if( $DayMDHs->Count>24 ) {
      	echo " SQL: {$DayMDHs->Sql}\n";
	      echo " Значений на час: {$DayMDHs->Count}\n";
      }
//      $DataOk = true;
      // Заполнение Количества часов в сутка для обработки
//      $arNeedHours = array_fill( 1, 24, 0 );
//      $SUM = 0; $NODATA = false;
      $arCulc = array(
      	'HOURS' => array(),
      	'SUM'   => 0,
      	'MIN'   => false,
      	'MAX'   => false,
      	'AVG'   => false,
      	'FIRST' => false,
      	'LAST'  => false,
      	'NODATA' => 0,
      );
      //echo $iMDH->Parameter->Parameterdatatype->Ident;
//      unset( $MIN );
      // Перебираем все значения
      //echo "  Найдено {$DayMDHs->Count} значений:\n";
     	$CountMax = 24;
      foreach( $DayMDHs->Elements as $iDayMDH )
      {
      	$this->AddIteration();
//      	echo "    {$iDayMDH->Hour} = {$iDayMDH->Value}[{$iDayMDH->Loginfo->Title}]\n";
      	if( isset( $arCulc['HOURS'][$iDayMDH->Hour] ) ){
      		echo "!!!! Дубль {$iDayMDH->Id}";
      		$iDayMDH->Delete();
      		
      		continue;
      	}
      	if( $iDayMDH->Hour<1 or $iDayMDH->Hour>$CountMax ){
      		echo "!!!! Значение часа за рамками допустимых {$iDayMDH->Id}";
      		$iDayMDH->Delete();
      		
      		continue;
      	}
      	if( $iDayMDH->Loginfo->Id == $arLog['NODATA']->Id )
      	{
      		$arCulc['NODATA']++;
      		continue;
      	}
      	$arCulc['HOURS'][$iDayMDH->Hour] = $iDayMDH->Hour;
      	$arCulc['SUM'] += $iDayMDH->Value;
      	$arCulc['MIN'] = $arCulc['MIN']
      		? min( $iDayMDH->Value, $arCulc['MIN'] )
      		: $iDayMDH->Value;
      	$arCulc['MAX'] = $arCulc['MAX']
      		? max( $iDayMDH->Value, $arCulc['MAX'] )
      		: $iDayMDH->Value;
      	if( $arCulc['FIRST'] === false ) {
      		$arCulc['FIRST'] = clone $iDayMDH;
      	}elseif( $iDayMDH->Hour < $arCulc['FIRST']->Hour ) {
      		$arCulc['FIRST'] = clone $iDayMDH;
      	}

      	if( $arCulc['LAST'] === false ) {
      		$arCulc['LAST'] = clone $iDayMDH;
      	}elseif( $iDayMDH->Hour > $arCulc['LAST']->Hour ) {
      		$arCulc['LAST'] = clone $iDayMDH;
      	}

      
        flush();
				if( $this->GetMemoryRun() ) {
			  		break 2; //return true;
				}
				if( $this->GetTimeRun() ) {
			  		break 2; //return true;
				}
				
      }
      
      
      
			// Если есть какие-то данные
			if( count( $arCulc['HOURS'] ) )
			{
				$arCulc['AVG'] = round( $arCulc['SUM'] / count($arCulc['HOURS']) );

				if( $iMDH->Parameter->UseSum ){
//					$iMDH->Value;
					echo "    SUM: {$iMDH->Value}->{$arCulc['SUM']} ";
					$iMDH->Value = $arCulc['SUM'];
					if( count( $arCulc['HOURS'] )==$CountMax ){
						echo "    OK_FULL\n";
						$iMDH->Loginfo = $arLog['OK'];
					}else{
						echo "    OK_NOTFULL\n";
						$iMDH->Loginfo = $arLog['OK_NOTFULL'];
					}
				}elseif( $iMDH->Parameter->UseFirst ){
					if( $arCulc['FIRST'] !== false ){
						echo "    FIRST: {$iMDH->Value}->{$arCulc['FIRST']->Value} ";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['FIRST']->Value;
						$iMDH->Loginfo = $arLog['OK'];
						$iMDH->AddTime = $arCulc['FIRST']->AddTime;
					}
				}elseif( $iMDH->Parameter->UseLast ){
					if( $arCulc['LAST']!== false ){
						echo "    LAST: {$iMDH->Value}->{$arCulc['LAST']->Value} ";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['LAST']->Value;
						$iMDH->Loginfo = $arLog['OK'];
						$iMDH->AddTime = $arCulc['LAST']->AddTime;
					}
				}elseif( $iMDH->Parameter->UseMin ){
					if( $arCulc['MIN']!== false ){
						echo "    MIN: {$iMDH->Value}->{$arCulc['MIN']} ";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['MIN'];
						$iMDH->Loginfo = $arLog['OK'];
					}
				}elseif( $iMDH->Parameter->UseMax ){
					if( $arCulc['MAX']!== false ){
						echo "    MAX: {$iMDH->Value}->{$arCulc['MAX']}\n";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['MAX'];
						$iMDH->Loginfo = $arLog['OK'];
					}
				}elseif( $iMDH->Parameter->UseAverage ){
					if( $arCulc['AVG']!== false ){
						echo "    AVG: {$iMDH->Value}->{$arCulc['AVG']}\n";
						echo "    AVG: {$iMDH->Value}->{$arCulc['AVG']}\n";
						echo "    OK\n";
						$iMDH->Value   = $arCulc['AVG'];
						$iMDH->Loginfo = $arLog['OK'];
						
					}
				}
				$iMDH->save();
			}else{
				$iMDH->Value   = 0;
				$iMDH->Loginfo   = $arLog['NODATA'];
				echo "    NODATA\n";
			}
			
			
			
			
			
			flush();
		  if( $this->GetMemoryRun() ) {
	  		break; //return true;
		  }
	  	if( $this->GetTimeRun() ) {
	  		break; //return true;
	  	}
      
      //var_dump( $arCulc );
       //die( 'stop' );
      
      // Если остались неопрошеные часы
      
      
      if( 0 and count( $arNeedHours ) )
      {

        echo "  Нужны данные за часы: ".implode( ',', array_flip($arNeedHours) ) ;
        if( !$iMDH->Meter->IsOk )
        {
          echo " - Отказ: Прибор имеет негативный статус.\n";
          continue;
        }
        if( $iMDH->Meter->IsExcluded )
        {
          echo " - Отказ: Прибор исключен из работы. {$iMDH->Meter->Title}\n";
          continue;
        }
        if( $iMDH->Meter->Converter->IsExcluded )
        {
          echo " - Отказ: Конвертер исключен из работы. {$iMDH->Meter->Converter->Title}\n";
          continue;
        }
        /*
        Неучитывается работа с временными зонами на счетчике
        Данные могу восстановить вперед.
        */
        /*
        $arNeedHoursDo = array();
        foreach( $arNeedHours as $Hour=>$info )
        {
          $do = task::RetryMeterParameter( $iMDH->Meter, $iMDH->Parameter, $iMDH->Year, $iMDH->Month, $iMDH->Day, $Hour);
          if( $do )
          {
            $arNeedHoursDo[$Hour] = $info;
          }
        }
        if( count($arNeedHoursDo) )
        echo "Запрошены данные за часы: ".implode( ', ', array_keys($arNeedHours) )."\n";
        */
      }


      if( 0 and $iMDH->Parameter->UseSum and count( $arNeedHours )==0 )
      {
        if( $NODATA )
        {
          echo "UPDATE !!! {$iMDH->Value}=>{$SUM} [{$NODATA}]\n";
          $iMDH->Value = $SUM;
          if(empty($iMDH->Loginfo))
          {
            $iMDH->Loginfo = $arLog['OK_NOTFULL'];
          }
        }
        else
        {
          echo "UPDATE !!! {$iMDH->Value}->{$SUM} [{$NODATA}]\n";
          $iMDH->Value = $SUM;
          $iMDH->Loginfo = $arLog['OK'];
        }
      }
      elseif( 0 and $iMDH->Parameter->UseSum )
      {
        $iMDH->Value = $SUM;
      }
      
      
      
      // min value
      if( 0 and $iMDH->Parameter->UseMin )
      {
        if( count( $arNeedHours )>0 or $NODATA )
        {
          echo "!!!! UPDATE !!! {$iMDH->Value}->{$SUM} [{$NODATA}]\n";
          $iMDH->Value = $MIN;

        /*
          if(empty($iMDH->Value) && empty($iMDH->Loginfo))
          {
            $iMDH->Loginfo = $arLog['OK_NOTFULL'];
          }
          
          Проверяем на наличие значения. Если больше  0 то вроде работает так как надо
          
          */
          
          if($iMDH->Value < 1)
          {
            $iMDH->Loginfo = $arLog['OK_NOTFULL'];
          }
          else
          {
            $iMDH->Loginfo = $arLog['OK'];
          }
        }
        elseif( count( $arNeedHours )==0 )
        {
          $iMDH->Value = $MIN;
          $iMDH->Loginfo = $arLog['OK'];
          echo "!!!! UPDATE !!! {$iMDH->Value}->{$MIN} [{$NODATA}]\n";
        }
      }
      
      
      
      
      flush();
		  if( $this->GetMemoryRun() ) {
	  		break; //return true;
		  }
	  	if( $this->GetTimeRun() ) {
	  		break; //return true;
	  	}
      
      if( !$max-- )
      {
        echo "Достигнуто ограничение в {$max_start} шагов. ( Всего {$MDHs->Count} ) ";
        break;
      }
    }
	//DB::Select( "COMMIT" );
	echo "DB COMMIT\n";
    
    
    return true;
    
  }
}

