<?php


/*

    Почему считает только первый вообще а не все?

*/

class job_group_months_v2 extends Jobs
{
  function getTitle()
  {
    return "Группировка данных месяц v2";
  }
  
  function getDescription()
  {
    return "Подсчет месячных данных по приборам учета";
  }

	function GetTasksCount() {
		return  meterdatahour::NeedCulcJoinMonth()->Count;
	}


  function Start()
  {
  
  	//DB::Select( 'START TRANSACTION' );
  	$LogoArIsset = array();

		foreach(loginfo::All()->Elements as $iElem){
			if( isset( $LogoArIsset[$iElem->Logtext] ) ){
				$iElem->Delete();
			}else{
				$LogoArIsset[$iElem->Logtext] = $iElem;
			}
		}

    $arLog = array();
    foreach( loginfo::All()->Elements as $iLog ) {
      $arLog[$iLog->Logtext] = $iLog;
    }
    echo "Значения статусов в системе:\n";
    foreach($arLog as $key=>$iLog ) {
      echo " - [{$iLog->Id}]{$key}\t| {$iLog->Title}\n";
    }
    
		foreach( meterdatahour::NeedCulcJoinMonth()->GroupBy(200)->Elements as $iMDHUG ) {
    
    	foreach( $iMDHUG->Elements as $iMDH){
    	
    		$Filter = array(
    			'Filter' => array(
    				'Meterdatahour' => $iMDH->Id,
    				'Type' => 2
    			)
    		);
    		$res = need_culc::Filter($Filter);
    		# Удаление лишних
    		if( $res->Count > 1 ){
    			echo "Кол-во ссылок на MDH > 1. Удаление:\n";
    			foreach( $res->Elements as $k => $v ){
    				if( $k ) {
    					echo $v->Id . ".";
    					$v->Delete();
    				}else{
    					$iMDHU = $v;
    				}
    			}
    		}else{
    			$iMDHU = $res->First;
    		}
		  
		  	# Если мы получили идентификатор, который не дневной
		  	if($iMDH->Hour != 0 && $iMDH->Day != 0 && $iMDH->Month < 1 ){
		  		$str = "ERROR : Попали данные не для суммирования.";
		  		$str .= "Удаляем ссылку.id:{$iMDH->Id}|Y:{$iMDH->Year}|m:{$iMDH->Month}|d:{$iMDH->Day}|H:{$iMDH->Hour}\n";
					$iMDHU->Delete();
					$iMDH->Des;
					echo $str;
					continue;
				}
				
				
				# Ищем дубликаты за день
				$ArHours = array();
		  	$Filter = array(
		  		'Filter' => array(
		  			'Meter'     => $iMDH->Meter->Id,
		        'Parameter' => $iMDH->Parameter->Id,
		        'Year'      => $iMDH->Year,
		        'Month'     => $iMDH->Month,
		        'Hour'     	=> 0,
		  		),
		  		'Order' => array(
		        'Day'  => 'ASC',
		      ),
		  	);
		  	if($iMDH->Meter->Is) echo "\n[M:{$iMDH->Meter->Id}]\n{$iMDH->Parameter->Ident}:\n";
		  	foreach( meterdatahour::Filter( $Filter )->Elements as $_iMDH ){
		  	
		  		$this->AddIteration();
		  		
		  		$date = new DateTime();
		  		$date->setDate($_iMDH->Year,$_iMDH->Month,$_iMDH->Day)->setTime($_iMDH->Hour,0,0);
		  		if( $date->format("t") < count( $ArHours ) ) {
		  			echo "Лишние данные [{$_iMDH->Id}]{$_iMDH->Year}-{$_iMDH->Month}-{$_iMDH->Day} {$_iMDH->Hour}\n";
		  			continue;
		  		}
		  	
		  		$issetMDH = meterdatahour::Id(0);
		  		if( isset( $ArHours[ $_iMDH->Day ] ) ){
		  			$issetMDH = $ArHours[ $_iMDH->Day ];
		  		}
		  		
		  		$isDeletethis = false;
		  		
		  		$isDeleteisset = false;
		  		
		  		switch( $_iMDH->Loginfo->Logtext ){
		  			case 'NODATA':
		  				if( $issetMDH->Loginfo->Logtext == 'OK' ){
		  					if($issetMDH->Is) {
		  						$isDeletethis = true;
		  					}
		  				}else{
		  					$isDeleteisset = true;
		  				}
		  			break;
		  			case 'OK':
		  				$isDeleteisset = true;
		  			break;
		  			default:
		  				if($issetMDH->Is) {
								$isDeletethis = true;
							}
		  			break;
		  		}
		  		
		  		# Оставить текущее. Удалить новое
		  		if( $isDeletethis ){
		  			if($issetMDH->Is) {
		  				echo "[isset] id:{$issetMDH->Id}:data:{$issetMDH->Year}-{$issetMDH->Month}-{$issetMDH->Day} {$issetMDH->Hour}:stat:{$issetMDH->Loginfo->Logtext} ";
		  			}else{
		  				echo "[isset] N/A ";
		  			}
						echo "[this] id:{$_iMDH->Id}:data:{$_iMDH->Year}-{$_iMDH->Month}-{$_iMDH->Day} {$_iMDH->Hour}:stat:{$_iMDH->Loginfo->Logtext} ";
						echo "[replace to] isset\n";
		  			if( $issetMDH->Is && $issetMDH->Hour == $_iMDH->Hour ){
							echo "Дубликат:Удаляем [this]\n";
							$_iMDH->Delete();
						}
		  			$_iMDH->Des;
		  		}
		  		
		  		# Удалить существующее. Записать новое
		  		if( $isDeleteisset ){
		  			if($issetMDH->Is) {
		  				echo "[isset] id:{$issetMDH->Id}:data:{$issetMDH->Year}-{$issetMDH->Month}-{$issetMDH->Day} {$issetMDH->Hour}:stat:{$issetMDH->Loginfo->Logtext} ";
		  			}else{
		  				echo "[isset] N/A ";
		  			}
						echo "[this] id:{$_iMDH->Id}:data:{$_iMDH->Year}-{$_iMDH->Month}-{$_iMDH->Day} {$_iMDH->Hour}:stat:{$_iMDH->Loginfo->Logtext} ";
						echo "[replace to] this\n";;
		  			if( $issetMDH->Is && $issetMDH->Hour == $_iMDH->Hour ){
							echo "Дубликат:Удаляем [isset]\n";
							$issetMDH->Delete();
						}
		  			$issetMDH->Des;
		  		}
		  		
		  		if( $_iMDH->Loginfo->Logtext == 'OK' || $_iMDH->Loginfo->Logtext == 'NODATA' || !$issetMDH->Is ) $ArHours[ $_iMDH->Day ] = $_iMDH;
		  		
		  		$_iMDH->Des;
		  		
		  	}
		  	
		  	
		  	$arCulc = array();
		  	
		  	# Подсчет
		  	unset($ArHours[0]);
		  	
		  	if($iMDH->Parameter->UseFirst) {
		  		ksort($ArHours);
		  	}elseif($iMDH->Parameter->UseLast){
		  		krsort($ArHours);
		  	}
		  	
		  	foreach( $ArHours as $hour => $_iMDH ){
		  	
		  		$this->AddIteration();
		  	
		  		if( $hour == 0 ) continue;
		  		
		  		if( $_iMDH->Loginfo->Logtext != 'OK' && $_iMDH->Loginfo->Logtext != 'NODATA' ) continue;
		  		
					if( count( $ArHours ) ) {
					
						if( $iMDH->Parameter->UseSum ){
							if( !isset($arCulc['SUM']) ) $arCulc['SUM'] = 0;
							$arCulc['SUM'] = $arCulc['SUM'] + $_iMDH->Value;
							echo "    SUM: {$iMDH->Value}->{$arCulc['SUM']} \n";
							$iMDH->Value = $arCulc['SUM'];
						}elseif( $iMDH->Parameter->UseFirst ){
							echo "    FIRST: {$iMDH->Value}->{$_iMDH->Value} ";
							echo "    OK\n";
							$iMDH->Value   = $_iMDH->Value;
							$iMDH->AddTime = $_iMDH->AddTime;
							break;
						}elseif( $iMDH->Parameter->UseLast ){
							echo "    LAST: {$iMDH->Value}->{$arCulc['LAST']->Value} ";
							echo "    OK\n";
							$iMDH->Value   = $_iMDH->Value;
							$iMDH->AddTime = $_iMDH->AddTime;
							break;
						}elseif( $iMDH->Parameter->UseMin ){
							if(!isset($arCulc['MIN'])) $arCulc['MIN'] = $_iMDH->Value;
							$arCulc['MIN'] = min($arCulc['MIN'],$_iMDH->Value);
							$iMDH->Value   = $arCulc['MIN'];
							$iMDH->Loginfo = $arLog['OK'];
							echo "    MIN: {$_iMDH->Value}->{$arCulc['MIN']} ";
							echo "    OK\n";
						}elseif( $iMDH->Parameter->UseMax ){
							if(!isset($arCulc['MAX'])) $arCulc['MAX'] = $_iMDH->Value;
							$arCulc['MAX'] = max($arCulc['MAX'],$_iMDH->Value);
							$iMDH->Value   = $arCulc['MAX'];
							$iMDH->Loginfo = $arLog['OK'];
							echo "    MAX: {$_iMDH->Value}->{$arCulc['MAX']}\n";
							echo "    OK\n";
						}elseif( $iMDH->Parameter->UseAverage ){
							if(!isset($arCulc['AVG'])) {
								$arCulc['AVG'] = 0;
							}
							$arCulc['AVG'] = $arCulc['AVG'] + $_iMDH->Value;
							echo "    AVG: {$_iMDH->Value}->{$arCulc['AVG']}\n";
							echo "    OK\n";
						}
					}else{
						$iMDH->Value   = 0;
						$iMDH->Loginfo   = $arLog['NODATA'];
						echo "    NODATA\n";
					}
					
					$_iMDH->Des;
				}
				
				if( $iMDH->Parameter->UseAverage ){
					$iMDH->Value   = round( $arCulc['AVG'] / count($ArHours) );
					$iMDH->Loginfo = $arLog['OK'];
				}
				
				if( $iMDH->Parameter->UseSum ){
					if( count( $ArHours ) == $iMDH->Meter->Datetime->format("t") ){
				 		echo "    OK_FULL\n";
						$iMDH->Loginfo = $arLog['OK'];
					}else{
						echo "    OK_NOTFULL\n";
						$iMDH->Loginfo = $arLog['OK_NOTFULL'];
					}
				}else{
					if( count( $ArHours ) ){
						$iMDH->Loginfo = $arLog['OK'];
					}
				}
			
				$iMDH->Save();
				$iMDH->Des;
			
		  	# Удаляем текущую метку как пересчитанную
		  	$iMDHU->Delete();
		  	
				flush();
				if( $this->GetMemoryRun() ) {
					break 2; //return true;
				}
				if( $this->GetTimeRun() ) {
					break 2; //return true;
				}
				
			}
			$iMDHUG->ElementsFreeMem;
    }
    
		//DB::Select( "COMMIT" );
		echo "DB COMMIT\n";
    return true;
    
  }
}

