<?php

class job_mdh_need_calc  extends Jobs{
	function getStatus()
	{
		return array(
			'run' => 'auto'
		);
	}

  function getTitle()
  {
    return "Нужен пересчет v2";
  }
  
  function getDescription()
  {
    return "Отслеживание всех результатов работы, и в случае нахождения удачных данных выставления статуса на пересчет группированных данных #new";
  }

	function GetTasksCount()
	{
    $MDHLastId = Site()->Config( 'MeterDataHour.LastUseId.group', 0 );
    $MDH = meterdatahour::Id( $MDHLastId );
    if( !$MDH->Is ) {
	    $arParams = array(
		    'Order' => array(
		      'Id'   => 'ASC',
	      ),
  	    'Limit' => 1,
  	  );
	    $MDH = meterdatahour::Filter( $arParams )->First;
    	if( !$MDH->Is ){
    		$MDHLastId = $MDH->Id;
    		//echo ".";
    	}
    }
    //$MDHLastId = 300000;
    $arParams = Array(
      'Filter' => Array(
        'Id >'   => $MDHLastId,
        'Id <'   => $MDHLastId + 1000000,
      ),
      'Order' => array(
        'Id'   => 'ASC'
      ),
//      'Limit'  => 1000,
    );
    $MDHs = meterdatahour::Filter( $arParams );
    return $MDHs->Count;
	}

	function meterdatahour__AddOrUpdateDay( array $Up, array $arLog )
	{
		static $Points = 0;

		if( $Up['MDHId']>0 ){
			$Filter = array(
				'Filter' => array(
					'Meterdatahour' => $Up['MDHId'],
					'Type'          => !$Up['Day'] ? 2 : 1
				)
			);
			$res = need_culc::Filter( $Filter );
			if( !$res->Count ){
				need_culc::AddByArray(
					array(
						'MeterdatahourId' => $Up['MDHId'],
						'Type'            => !$Up['Day'] ? 2 : 1
					)
				);
			}
			#$iMDH->Loginfo = $arLog['OK_CULC'];
			$FirstRecord = true;
			$PointsInLine = 100;
			if( $Points >= $PointsInLine )
			{
				echo "\n"; $Points=0;
			}
			echo ($Up['Day']==0)
				? "."
				: "*"; 
				
			$Points++;


			return;
		}
		// Поиск уже существующего значения
		$arLook = array(
			'Filter' => array(
				'Meter'     => $Up['Meter'],
				'Parameter' => $Up['Parameter'],
				'Year'      => $Up['Year'],
				'Month'     => $Up['Month'],
				'Day'       => $Up['Day'],
				'Hour'      => 0,
			)
		);
		global $Manual;
		if( 0 && $this->Time_Run==120 ) {
			$DMHs = meterdatahourmemory::Filter( $arLook );
		}else {
			$DMHs = meterdatahour::Filter( $arLook );
		}
		if( $DMHs->Count == 0 )
		{
			// Не найдено нужно добавить
			$Add = false;
			echo "\n[meter:{$Up['Meter']}] параметр {$Up['Parameter']}, {$Up['Year']}-{$Up['Month']}-{$Up['Day']} ";

			$d = new DateTime();
			//	DB::Select( '/* step 4.3 */' );
			$Add = meterdatahour::AddByArray(
				array(
					'MeterId'     => $Up['Meter'],
					'ParameterId' => $Up['Parameter'],
					'Year'        => $Up['Year'],
					'Month'       => $Up['Month'],
					'Day'         => $Up['Day'],
					'Hour'        => 0,
					'Value'       => $Up['Value'],
					'LoginfoId'   => $arLog['OK']->Id,
					'AddTime'     => $d->format("Y-m-d H:00:00")
				)
			);
			$Filter = array(
				'Filter' => array(
					'Meterdatahour' => $Add->Id,
					'Type'					=> !$Up['Day'] ? 2 : 1
				)
			);
			if( !need_culc::Filter($Filter)->Count ){
				need_culc::AddByArray(
					array(
						'MeterdatahourId' => $Add->Id,
						'Type'					=> !$Up['Day'] ? 2 : 1
					)
				);
			}
			
			

			//  	DB::Select( '/* step 4.4 */' );
		   if( $Add and $Add->Is )
		   {
		   	echo "Добавлен:{$Add->Id}\n";
		   }
		   else
		   {
		   	echo "Недобавлен\n";
		   }
		}
		else
		{
		 	// Найдено одновляем на пересчет
		 	if( $DMHs->Count>1 )
		 	{
				echo "Найдено более 1 записи\n";
				//echo "SQL:{$DMHs->Sql}\n";
		 	}
		 	$FirstRecord = false;
			foreach( $DMHs->Elements as $iMDH )
			{
				if( !$FirstRecord )
				{
					$Filter = array(
						'Filter' => array(
							'Meterdatahour' => $iMDH->Id,
							'Type'					=> !$Up['Day'] ? 2 : 1
						)
					);
					$res = need_culc::Filter( $Filter );
					if( !$res->Count ){
						need_culc::AddByArray(
							array(
								'MeterdatahourId' => $iMDH->Id,
								'Type'					=> !$Up['Day'] ? 2 : 1
							)
						);
					}
					#$iMDH->Loginfo = $arLog['OK_CULC'];
					$FirstRecord = true;
					$PointsInLine = 100;
					if( $Points >= $PointsInLine )
					{
						echo "\n"; $Points=0;
					}
					echo ($Up['Day']==0)
						? "."
						: "*"; 
						
					$Points++;
				}
				else
				{
					$iMDH->Delete();
					
					
					echo "Удален дубликат\n";
				}
			}
		}
	}
	
	function Start()
	{
		//return true;
		error_reporting( E_ALL );
		global $Manual;
#		$ExecTime = getmicrotime();
		$MaxExecTime = $this->Time_Run;
		$MAXDO = Site()->Config( "count.task.need_culc", 1000 );
		echo "Максимальное время работы {$MaxExecTime} сек.\n";
		echo "Максимальное количество обрабатываемых данных {$MAXDO}\n";
		if( isset($Manual) and $Manual )
			echo "Ручной запуск задачи.\n";
		else
			$Manual = false;
		
			
		$MDHLastId = Site()->Config( 'MeterDataHour.LastUseId.group', 0 );
		if( $Manual )
		{
			$MDHLastId -= 1000;
//			$MDHLastId = 131092717-10;
//			$MDHLastId = 1;
			//$MDHLastId = 5847200;
			//$MAXDO = 1000000;
			echo "Присвоение \$MDHLastId={$MDHLastId}. line: ".__LINE__."\n";
		}
		$MDH = meterdatahour::Id( $MDHLastId );
		if( !$MDH->Is && $MDHLastId)
		{	
			echo "Указанный MDH не существует, исполуем следующий после указанного\n";
			$arParams = array
			(
				'Filter' => array(
					'Id >' => $MDHLastId,
				),
				'Order' => array
				(
					'Id'   => 'ASC',
				),
				'Limit' => 1,
			);
			$MDHs = meterdatahour::Filter( $arParams );
			$MDH = $MDHs->First;
			if( $Manual )
			{
				echo "SQL: {$MDHs->Sql}\n";
			}
			if( $MDH->Is )
			{
				$MDHLastId = $MDH->Id;
			}
		}
			echo "\$MDHLastId = $MDHLastId {$MDH->Year}.{$MDH->Month}.{$MDH->Day}\n";
			$MDHLastIdStart = $MDHLastId;
		if( 0 and $Manual )
		{
			echo "Выполение прервано. line: ".__LINE__."\n";
			return true;
		}
    //$MDHLastId = 300000;
    //$MDHLastId = 951334463;
		$arParams = array
		(
			'Filter' => array
			(
				'Id >'   => $MDHLastId,
			),
			'Order' => array
			(
				'Id'   => 'ASC'
			),
			      'Limit'  => 1000000,
		);
		
		$SqlExecCount = array( 'Month'=>0, 'Day'=>0, 'Meter'=>array() );

		$MDHs = meterdatahour::Filter( $arParams );

		//echo "{$MDHs->Sql}\n"; 
		flush();
// ini_set("memory_limit","1024M");
		$arMDHUpdate = array();
		if( !$MDHs->Count )
		{
			echo "Нет данных для обработки\n";
			return true;
		}
		echo "Данных для обработки максимум {$MAXDO} из {$MDHs->Count}\n";

		$Step = 0;
		$arLog = array();
		foreach( loginfo::All()->Elements as $iLog )
		{
			$arLog[$iLog->Logtext] = $iLog;
		}

		$MAXDO = min( $MDHs->Count, $MAXDO );

		if( 1  ) {
		$SQL = "SELECT SQL_NO_CACHE `h`.`id`,`h`.`meter_id`,`h`.`parameter_id`,`h`.`tarif_id`,`h`.`year`,`h`.`month`,`h`.`day`,`h`.`hour`,`h`.`value`,`h`.`loginfo_id`,`h`.`add_time`"
			.", d.id as mdh_day_id, count(d.id) as mdh_day_count"
			.", m.id as mdh_month_id, count(m.id) as mdh_month_count"
			." FROM `meterdatahour` as `h`"
			." LEFT JOIN `meterdatahour` as `d`"
			."  ON `h`.`meter_id`=`d`.`meter_id`"
			." AND `h`.`parameter_id`=`d`.`parameter_id`"
			." AND `h`.`year`=`d`.`year`"
			." AND `h`.`month`=`d`.`month`"
			." AND `h`.`day`=`d`.`day`"
			." AND `d`.`hour`=0"
			." LEFT JOIN `meterdatahour` as `m`"
			." ON  `h`.`meter_id`=`m`.`meter_id`"
			." AND `h`.`parameter_id`=`m`.`parameter_id`"
			." AND `h`.`year`=`m`.`year`" 
			." AND `h`.`month`=`m`.`month`"
			." AND `m`.`day` =0"
			." AND `m`.`hour`=0"
			." WHERE `h`.`id` > {$MDHLastId} and `h`.`id` < ". ($MDHLastId+1000000) ." AND `h`.`hour`>0 GROUP BY `h`.id ORDER BY `h`.`id` ASC LIMIT 0,{$MAXDO}";
				echo "{$SQL}\n"; 
				$Elements = TListGroup::Prepare( $SQL, meterdatahour::Id(0) );
		}
		else
		{
			$Elements = $MDHs->GroupBy($MAXDO)->First;
		}

		//$Elements = $MDHs;

//		$Elements = $MDHs->GroupBy($MAXDO)->First;
//		if( $Manual )
		{
//			$MAXDO = 100;
//			$Elements = $MDHs->GroupBy($MAXDO)->First;
		}
		echo "start\n";
    	DB::Select( '/* start main */' );
    	$UseCommit = false;
    	$GroupByNum = 500;
    	$GroupByNumStep = 0;
		foreach( $Elements->GroupBy($GroupByNum)->Elements as $ElementsBy100 )
		{
	    	echo "Обработка порциями по {$GroupByNum} шт.\n";
			echo "Шаг: ".++$GroupByNumStep."\n";
		//	DB::Select( 'START TRANSACTION' );
			foreach( $ElementsBy100->Elements as $iMDH )
			{
				//echo "\n iMDH: $iMDH->Id ";
				$this->AddIteration();
				flush();
				if( $iMDH->Hour == 0 ) {
					// Пропустить суточные данные
					echo "c";
					$MDHLastId = $iMDH->Id;
					continue;
				}
				$Step++;
				if( $iMDH->Loginfo->Logtext == 'OK' and !$iMDH->Parameter->IsEventLog )
				{
					if( !isset($SqlExecCount['Meter'][$iMDH->Meter->Id]) )
					{
						$SqlExecCount['Meter'][$iMDH->Meter->Id] = 0;
					}
					$IdentDay   = "{$iMDH->Meter->Id}-{$iMDH->Parameter->Id}-{$iMDH->Year}-{$iMDH->Month}-{$iMDH->Day}";
					$IdentMonth = "{$iMDH->Meter->Id}-{$iMDH->Parameter->Id}-{$iMDH->Year}-{$iMDH->Month}-0";
					if( !isset($arMDHUpdate[$IdentDay]) )
					{
						$arMDHUpdate[$IdentDay] = true;
						self::meterdatahour__AddOrUpdateDay(
							array(
								'Meter'     => $iMDH->Meter->Id,
								'Parameter' => $iMDH->Parameter->Id,
								'Year'      => $iMDH->Year,
								'Month'     => $iMDH->Month,
								'Day'       => $iMDH->Day, 
								'Value'     => $iMDH->Value, 
								'MDHId'     => $iMDH->MDH_Day, 
							), 
							$arLog 
						);
						$SqlExecCount['Meter'][$iMDH->Meter->Id]++;
						$SqlExecCount['Day']++;
					}
					if( !isset( $arMDHUpdate[$IdentMonth] ) )
					{
						$arMDHUpdate[$IdentMonth] = true;
						self::meterdatahour__AddOrUpdateDay(
							array(
								'Meter'     => $iMDH->Meter->Id,
								'Parameter' => $iMDH->Parameter->Id,
								'Year'      => $iMDH->Year,
								'Month'     => $iMDH->Month,
								'Day'       => 0, 
								'Value'     => $iMDH->Value, 
								'MDHId'     => $iMDH->MDH_Month, 
							), 
							$arLog
						);
						$SqlExecCount['Meter'][$iMDH->Meter->Id]++;
						$SqlExecCount['Month']++;
					}
				}else{
					// scip
					echo ">";
				}
//				echo "-{$iMDH->Id}";
				$MDHLastId = $iMDH->Id;
				
				flush();
				if( $this->GetMemoryRun() ) {
					echo "\n\nПревышено ограничение по потреблению памяти. ( ".memory_get_usage()." )\n";
					break 2; //return true;
				}
				if( $this->GetTimeRun() ) {
					echo "Выход по времени выполнения";
					//return true;
					break 2;
				}

			}
			$ElementsBy100->ElementsFreeMem;
			$sql = "update config set value={$MDHLastId} where parametr='MeterDataHour.LastUseId.group' and value <= {$MDHLastIdStart}\n";
			DB::Select($sql);

			echo "\n+DB COMMIT \$MDHLastId= $MDHLastIdStart-> $MDHLastId\n";
			$MDHLastIdStart = $MDHLastId;
			echo "\n";
		}
		echo "\n";
		echo "Обновлено суточных:{$SqlExecCount['Day']} месячных:{$SqlExecCount['Month']}\n";
		if( count($SqlExecCount['Meter'])<50 ){
			foreach( $SqlExecCount['Meter'] as $MeterId => $Count )
			{
				echo "[meter:{$MeterId}] Обновлено {$Count}\n";
	/*			flush();
				if( $this->GetMemoryRun() ) {
					echo "\n\nПревышено ограничение по потреблению памяти. ( ".memory_get_usage()." )\n";
					$this->SetResult( 'MEMORY_LIMIT');
					// return true;
					break;
				}
				if( $this->GetTimeRun() ) {
					echo "\n\nПревышено ограничение по времени работы. ({$this->Time_Run} сек)\n";
					$this->SetResult( 'TIME_LIMIT' , $this->Time_Run);
					//return true;
					break;
				}
	*/
			}
		}
		echo "\$MDHLastId = $MDHLastId \n";
		$MDHLastIdStart = $MDHLastId;
		if( 0 and $Manual )
		{
			echo "Выполение прервано. line: ".__LINE__."\n";
			return true;
		}
		Site()->SetConfig( 'MeterDataHour.LastUseId.group', $MDHLastId );
		$sql = "update config set value={$MDHLastId} where parametr='MeterDataHour.LastUseId.group' and value <= {$MDHLastIdStart}\n";
		DB::Select($sql);
		
		
		
		return true;
		
	}
}