<?php
#ini_set('memory_limit', '1G' );
class job_meter_ok  extends Jobs
{
  function getTitle()
  {
    return "Восстановление статуса прибора";
  }
  
  function getDescription()
  {
    return "Отслеживание всех результатов работы и в случае нахождения удачных данных выставления статуса прибора в положительное состояние";
  }

	function GetTasksCount() {
    return $this->GetTasks()->Count;
	}
	
	function GetTasks() {
    $arParams = $this->GetFilterMdh();
    return meterdatahour::Filter( $arParams );
	}
	
	
	function GetFilterMdh(){
	  $MDHLastId = Site()->Config( 'MeterDataHour.LastUseId', 0 );
    $arParams = array(
      'Filter' => array(
        'Id >'   => $MDHLastId,
        'Id <'   => $MDHLastId + 99999999999999999,
      ),
      'Order' => array(
        'Id'   => 'ASC'
      ),
    );
    return $arParams;
	}
	
	
	
	
	
	
	
	
	
	function Start()
	{	
		
		
		global $Manual;
		if( isset($Manual) and $Manual )
			echo "Ручной запуск задачи.\n";
		else
			$Manual = false;
		$MDHLastId = Site()->Config( 'MeterDataHour.LastUseId', 0 );
		if( $Manual )
		{
			$MDHLastId -= 200;
			//$MDHLastId = 5847200;
			//$MAXDO = 1000000;
			echo "Присвоение \$MDHLastId={$MDHLastId}. line: ".__LINE__."\n";
		}
		$MDH = meterdatahour::Id( $MDHLastId );
    if( !$MDH->Is )
    {
	    $arParams = array(
		    'Order' => array(
		      'Id'   => 'DESC',
	      ),
  	    'Limit' => 1,
  	  );
	    $MDH = meterdatahour::Filter( $arParams )->First;
    	if( !$MDH->Is )
    		$MDHLastId = $MDH->Id;
    }
    
    $arParams = $this->GetFilterMdh();
    if( $this->GetTasksCount() > 25000 ){
      $arParams['Limit'] = 25000;
    }
    
    $MDHs = meterdatahour::Filter($arParams);
#    echo $MDHs->Sql; die();
    $MAXDO = min( $MDHs->Count, 100 );
    echo $MDHs->Sql;
    if( !$MDHs->Count ) {
      echo "Нет данных для обработки\n";
      return true;
    }
    
    
    echo "Данных для обработки максимум {$MAXDO} из {$MDHs->Count}<br/>\n";
    
//    flush();
    foreach( $MDHs->GroupBy($MAXDO)->Elements as $iGroup ) {
    
    //DB::Select("START TRANSACTION");
    
    	
    foreach( $iGroup->Elements as $iMDH )
    {
    	$this->AddIteration();
    
      echo "\n{$iMDH->Year}-{$iMDH->Month}-{$iMDH->Day} {$iMDH->Hour}\n\n";
//    	flush(); Sleep(2); die();
      $MDHLastId = $iMDH->Id;
        $iMeter = $iMDH->Meter;
      if( in_array($iMDH->Loginfo->Logtext , array("OK","NODATA")) )
      {
      	echo "[mdh:$iMDH->Id] [meter:{$iMDH->Meter->Id}] {$iMDH->Meter->Title}]\n";
        if( !$iMeter->IsOk ) {
        
        	$LogText = "С прибором появилась связь ({$iMDH->Parameter->Title} {$iMDH->Year}-{$iMDH->Month}-{$iMDH->Day}:{$iMDH->Hour})";
	        echo "$LogText\n";
          
          $iMeter->IsOk = array( true , $LogText );
        }else{
          $iConverter = $iMeter->Converter;
          # Если с прибором все хорошо, а у конвертора какой либо другой статус
          # Перепроверяем
          if( $iConverter->MeterOk != 1 ){
            $iConverter->UpdateMeterOk();
          }
        }
        
        $arLookMeterLast = array(
          'Filter' => array(
            'Meter'     => $iMeter->Id,
            'Parameter' => $iMDH->Parameter->Id,
          ),
        );
//        echo meterlast::Filter( $arLookMeterLast )->Sql;
        $arMeterlasts = meterlast::Filter( $arLookMeterLast );
        // Добавление meterlast если отсутствует
        $isMDH = false;
        
        $oMeterlasts = meterlast::Id(0);
        if( $arMeterlasts->Count==0 )
        {
          $arData = array(
            'MeterId'             => $iMeter->Id,
            'ParameterId'         => $iMDH->Parameter->Id,
            'MeterdatahourId'     => $iMDH->Id,
            'MeterdatahourSkipId' => $iMDH->Id,
            'IsDone'              => 0,
            'Year'                => $iMDH->Year,
            'Month'               => $iMDH->Month,
            'Day'                 => $iMDH->Day,
            'Hour'                => $iMDH->Hour,
          );
          
          $Add = meterlast::AddByArray( $arData );
          
          if( $Add->Is )
          {
            echo " [Added]";
          }
          $isMDH = $iMDH;
        } else {
          $oMeterlasts = $arMeterlasts->First;
          switch( $oMeterlasts->IsDone ){
          	case 1: 
          		break; 
          	case 2: 
          		$oMeterlasts->IsDone = 0; 
					echo "IsDone set= 0\n";
          		break;
          	case 3: 
          	default:
					$oMeterlasts->IsDone = 0;
					echo "IsDone set= 0\n";
          }
        }
    	  
        $oMeterlasts->Save();
        $oMeterlasts->__destruct();
        unset($oMeterlasts);
        
        
        echo "MDH:{$iMDH->Id} Meter:{$iMeter->Id} Logtext:{$iMDH->Loginfo->Logtext}\n";
      }
      else
      {
        echo "Ошибки:  MDH:{$iMDH->Id}: Meter:{$iMeter->Id} Logtext:{$iMDH->Loginfo->Logtext}<br/>\n";
      }
				$iMDH->__destruct();
				unset($iMDH);
				
			  flush();
				if( $this->GetMemoryRun() ) {
		    		//DB::Select('COMMIT');
					break 2;
				}
				if( $this->GetTimeRun() ) {
		    		//DB::Select('COMMIT');
					break 2;
				}
				
		  }
    		
    	
	  	$iGroup->ElementsFreeMem;
	  	
			}
    		Site()->SetConfig( 'MeterDataHour.LastUseId', $MDHLastId );
			
			echo "\n\nПроверено {$this->ReturnIteration()} строк.\n";
			
			//DB::Select('COMMIT');
			
    return true;
    
  }
}

