<?php

class job_meterlast extends Jobs
{

	protected $Meters = array();

	function getStatus()
	{
		return array(
			'run' => 'auto'
		);
	}

	function getTitle()
	{
		return "Последние данные";
	}

	function getDescription()
	{
		return "Поиск и выставление последних данных по параметрам учета для приборов";
	}

	function QueryTymes( $FromDatetime, $ToDatetime )
	{
		$FromDatetime
			->setTime( $FromDatetime->format('H'), 0, 0 );
		$ToDatetime
			->setTime( $ToDatetime->format('H'), 0, 0 );
		$IntervalToNow = $ToDatetime->diff( $FromDatetime );
		return intval(
			$IntervalToNow->format('%Y%M%D%H')
		);
	}

	function GetTasks( $LastId = 0 ) {
		$arLook = array(
			'Filter' => array(
				'IsDone'	=> 0,
//				'Id >'		=> $LastId,
			),
			'Order' => array(
				'Year'  => 'DESC',
				'Month' => 'DESC',
				'Day'   => 'DESC',
//				'Id' => 'ASC',
			),
			//'AddWhere' => 'AND `meter_id` IN ( SELECT `id` from `meter` WHERE `is_ok`=1 )',
		);
		return meterlast::Filter( $arLook );
	}

	function GetTasksCount() {
		return $this->GetTasks()->Count;
	}

	function Start() {
		$this->StartNew();
	}

	function IssetMeter($meter)
	{
		$this->Meters[$meter] = true;
		return $This->Meters;
	}

	protected $Meterlastsstatus = array();

	function StartNew() {

		echo "\n- LOG ---\n";
		$MyTz = date_default_timezone_get();
		date_default_timezone_set( 'UTC' );

		$DateNow = new DateTime();
		$format='Y-m-d H:00:00';
		$UpdateCount = 0;
		$HourLookCount = 0;
		
		$LastId = Site()->Config( 'Meterlast.LastId', 0 );
		echo " Стартуем с : {$LastId}\n";
		
		$Meterlasts = $this->GetTasks($LastId);
		// echo $Meterlasts->Sql; return true;
		# Если нету счетчиков для перебора и последний не равен 0, то считаем это окончанием и скидываем на 0
		if($Meterlasts->Count == 0 && $LastId > 0){
			$Meterlasts = $this->GetTasks(0);
		}
		
		$Filter = array(
			'Filter' => array(
				'Logtext' => 'OK'
			)
		);

		$LoginfoTODO = loginfo::Filter($Filter)->First;
    
		echo " Количество последних данных для обработки : {$Meterlasts->Count}\n";
		foreach( $Meterlasts->GroupBy(100)->Elements as $_I => $iGroup ) {
		   DB::Select( '/* start main */' );
			//DB::Select( 'START TRANSACTION' );

			foreach( $iGroup->Elements as $iMeterlast ) {
				$this->AddIteration();
				$UpdateCount++;

				
				if($iMeterlast->Meter->Type->DllId == "SNR_RS_COUNTER_8I"){
        	$FilterMDH = array(
        		'Filter' => array(
        			'Meter' => $iMeterlast->Meter->Id,
        			'Parameter' => $iMeterlast->Parameter->Id,
        			'Loginfo' => 3
        		),
        		'Order' => array(
        			'Year' => "DESC",
        			'Month' => "DESC",
        			'Day' => "DESC",
        			'Hour' => "DESC"
        		)
        	);
        	$iMeterlast->UpdateByArray(array(
        		'MeterdatahourId' => meterdatahour::Filter($FilterMDH)->First->Id
        	));
        }




				# Проверка на то что meterdatahourscip не отстает
				$MDH_clone	= $iMeterlast->Meterdatahour;
				$MDHS_clone	= $iMeterlast->MeterdatahourSkip;

				$MDH_clone_T	= new DateTime();
				$MDHS_clone_T	= new DateTime();

				$MDH_clone_T->setDate(
					$MDH_clone->Year,
					$MDH_clone->Month,
					$MDH_clone->Day
				)->setTime( $MDH_clone->Hour, 0, 0 );

				$MDHS_clone_T->setDate(
					$MDHS_clone->Year,
					$MDHS_clone->Month,
					$MDHS_clone->Day
				)->setTime( $MDHS_clone->Hour, 0, 0 );
				
				if( $MDH_clone_T->getTimestamp() > $MDHS_clone_T->getTimestamp() ){
					$iMeterlast->MeterdatahourSkip = $MDH_clone;
					echo "Приравниваем meterdatahour === meterdatahour\n";
				}

				# task 11377 9667
				# Должен существовать, но быть на каких то нулевых значениях
				if(
						$MDH_clone->Is
							&&
						(
							$MDH_clone->Year 	== 0
								or
							$MDH_clone->Month == 0
								or
							$MDH_clone->Day 	== 0
								or
							$MDH_clone->Hour 	== 0
						)
					){
					echo "Получение последнего удачного данного\n";
					$LAST = $iMeterlast->Meterdatahour->LastOKMDH;
					$iMeterlast->Meterdatahour = $LAST;
					echo "Последним данным будет : Y {$LAST->Year} M {$LAST->Month} D {$LAST->Day} H {$LAST->Hour}\n";
				}


				# END

				# task 2043
				# Если ссылка не дествительна
				
				# Если не найдено значение
				if( is_object($iMeterlast) && is_object($iMeterlast->Meterdatahour) && !$iMeterlast->Meterdatahour->Is) {
					echo "DOTO: update link Part 1\n";

					$_First_Filter = array(
						'Filter' => array(
							'Parameter' => $iMeterlast->Parameter->Id,
							'Meter'			=> $iMeterlast->Meter->Id,
							'Loginfo'		=> $LoginfoTODO->Id,
						),
					);
					
					# Если существует метка времени с которой можно отталкиваться
					echo "Пробуем работать с YMDH полями.\n";
					if( $iMeterlast->Year ){
						$_First_Filter['Filter']['Year'] = $iMeterlast->Year;
					}
					if( $iMeterlast->Month ){
						$_First_Filter['Filter']['Month'] = $iMeterlast->Month;
					}
					if( $iMeterlast->Day ){
						$_First_Filter['Filter']['Day'] = $iMeterlast->Day;
					}
					if( $iMeterlast->Hour ){
						$_First_Filter['Filter']['Hour'] = $iMeterlast->Hour;
					}
					
					$IsIssetLast = meterdatahour::Filter($_First_Filter);
					
					#task 15491
					if(!$IsIssetLast->Count){
					  if( $iMeterlast->Is ){
					    $iMeterlast->Delete();
					    echo "Ссылка битая. Удаляем meterlast.\n";
					  }
					  continue;
					}
				}






				# task 2043
				# Если ссылка не дествительна
				if( !$iMeterlast->MeterdatahourSkip->Is ){
					$iMeterlast->MeterdatahourSkip = $iMeterlast->Meterdatahour;
				}
        
				if( !$iMeterlast->Meter->Is ) {
					echo "DOTO: update link Part 2 delete {$iMeterlast->Id}\n";
					$iMeterlast->Delete();
					continue;
				}

				$iMeter = $iMeterlast->Meter;
				$MaxTaskForMeter = 2;

				echo "\n - Прибор:\t";
				echo "  Id: {$iMeter->Id}";
				echo "  Тип: {$iMeter->Type->DllId}";
				echo "  About: {$iMeter->Title}";
				echo "  Converter: {$iMeter->Converter->Title}";

				if( $iMeter->Timezone->Is ) {
					$MeterTzIdent = $iMeter->Datetime->getTimezone()->getName();
				} else {
					$MeterTzIdent = $MyTz;
				}
				echo "  Часовой пояс: {$MeterTzIdent}";

				$oTimeZoneMtr =	new DateTimeZone( $MeterTzIdent );
				$oTimeZoneUTC =	new DateTimeZone( 'UTC' );


				$MeterParameterUse = array();
				echo " Параметров {$iMeter->Parameters->Count}\n";

				foreach( $iMeter->Meterparameters->Elements as $iParameter )
				{

#					$U = $iParameter->IsUse ? "Y" : "N";
#					$E = $iParameter->Parameter->IsEventLog ? "Y" : "N";
#
#
#					echo "   use:{$U}; event:{$E} ; {$iParameter->Parameter->Ident}\n";
					if( $iParameter->IsUse && !$iParameter->Parameter->IsEventLog ) {
						$MeterParameterUse[$iParameter->Parameter->Ident] = $iParameter->Parameter;
					}
				}

				if( !isset( $MeterParameterUse[$iMeterlast->Parameter->Ident] ) ) {
					echo "TODO: Исключение параметра не поддерживается\n";
				}

//			$iMeterlast = $arMeterlasts->First; if( $iMeterlast->Is ){

				echo "\n - Lastdata ---\n";
				echo "  Id: {$iMeterlast->Meterdatahour->Id}\n";
				echo "  Ident: {$iMeterlast->Parameter->Ident}\n";
				echo "  Value: {$iMeterlast->Meterdatahour->Value}\n";
				echo "  Log: {$iMeterlast->Meterdatahour->Loginfo->Logtext}\n";

				if( $iMeterlast->Meterdatahour->Id == 0 )
				{
					// если данных, на которые идет ссылка нет. Удалить для восстановления
					$iMeterlast->Delete();

					echo "TODO: Ссыла не действительна. Удалена {$iMeterlast->Id}\n";
					continue;
				}
//				die();
				if( $iMeterlast->MeterdatahourSkip->Id == 0 )
				{
					$iMeterlast->MeterdatahourSkip = $iMeterlast->Meterdatahour;
					echo "MeterdatahourSkip=Meterdatahour\n";
				}

				$DateLast = new DateTime();
				$DateLast->setTimezone( $oTimeZoneMtr );
				$DateLast->setDate(
					$iMeterlast->Meterdatahour->Year,
					$iMeterlast->Meterdatahour->Month,
					$iMeterlast->Meterdatahour->Day
				);
				$DateLast->setTime( $iMeterlast->Meterdatahour->Hour, 0, 0 );

				$DateLast_S = new DateTime();
				$DateLast_S->setTimezone( $oTimeZoneMtr );
				$DateLast_S->setDate(
					$iMeterlast->MeterdatahourSkip->Year,
					$iMeterlast->MeterdatahourSkip->Month,
					$iMeterlast->MeterdatahourSkip->Day
				);
				$DateLast_S->setTime( $iMeterlast->MeterdatahourSkip->Hour, 0, 0 );

				echo "  Date: {$DateLast->format($format)}\n";
				$DateLast->setTimeZone( $oTimeZoneUTC );
				echo "  UTC: {$DateLast->format($format)}\n";



				$DateNeed = clone $DateLast;
				$DateNeed_S = clone $DateLast;
				$DateLast_Sd = clone $DateLast_S;

				$QT = $this->QueryTymes( $DateNow, $DateNeed );
				$QT_S = $this->QueryTymes( $DateNow, $DateNeed_S );
				$LimitByParam = Site()->Config('Meterlast.LimitByParam' , 10);
				$LimitByParam = 100;

				echo "\n - Пер.окруж. ---\$QT:{$QT} \$QT_S:{$QT_S}\n";

				$Q = $QT > 10 ? ">10" : $QT;
				$QS = $QT_S > 10 ? ">10" : $QT_S;

				echo "  QT MDH: {$Q}\n";
				echo "  QT MDH S: {$QS}\n";
				echo "  LBP: {$LimitByParam}\n";


				echo "\n - Результат ---\n";

				if( !$QT ) {
					echo "  Актуальные данные\n";
					$iMeterlast->IsDone = 3;
				}

				while(	$LimitByParam-- && $QT_S ){

					flush();
					if( $this->GetMemoryRun() ) {
						break; //return true;
					}
					if( $this->GetTimeRun() ) {
						break; //return true;
					}

					$This = $iMeter->MeterlastThisHour(clone $DateLast_Sd);
					$Next = $iMeter->MeterlastNextHour(clone $DateLast_Sd);
					
					# task 16153
					# task 19023
					if( !$this->QueryTymes( $DateNow , $DateLast_Sd ) ){
					  echo "Все данные получены\n";
					  $iMeterlast->IsDone = 3;
						$iMeterlast->Save();
					  break;
					}

					$DateLast_Sd->modify("+1 hour");

					printf( "%04d-%02d-%02d %02d -> ", $This['Year'], $This['Month'], $This['Day'], $This['Hour'] );

					$arTaskLook = array(
						'Filter' => array(
							'Meter'			=> $iMeterlast->Meter->Id,
							'Parameter'	=> $iMeterlast->Parameter->Id,
							'Year'			=> $Next['Year'],
							'Month'			=> $Next['Month'],
							'Day'				=> $Next['Day'],
							'Hour'			=> $Next['Hour'],
						),
					);

					printf( "%04d-%02d-%02d %02d\t", $Next['Year'], $Next['Month'], $Next['Day'], $Next['Hour'] );

					$MDHs_S = meterdatahour::Filter( $arTaskLook );
					$HourLookCount++;
					$ValidMDH = meterdatahour::Id(0);

					if( $MDHs_S->Count > 1 ) {
					
					
						echo "  Данных больше чем нужно:{$MDHs_S->Count} SQL: {$MDHs_S->Sql}\n";
						$arStatus = array();
						foreach( $MDHs_S->GroupBy1000->Elements as $iMDHGroup ){
							
							if( $ValidMDH->Loginfo->Logtext == 'OK' ) break;
							
							foreach( $iMDHGroup->Elements as $iMDH ) {
							
								echo "  MDH: {$iMDH->Value} {$iMDH->Loginfo->Title} {$iMDH->Loginfo->Logtext} [id:{$iMDH->Id}] ";
								
								$IsNew 		= false;
								$IsValid 	= false;
								$IsBreak 	= false;
								
								if( !in_array( $iMDH->Loginfo->Logtext , $iMDH->OkStatuses ) ) break;
								
								switch( $iMDH->Loginfo->Logtext ){
									case 'OK':
										$IsNew 		= true;
										$IsValid 	= true;
										$IsBreak 	= true;
									break;
									case 'NODATA':
										$IsNew = true;
										if($ValidMDH->Loginfo->Logtext != 'OK'){
											$IsValid = true;
										}
										break;
									break;
									case 'ERROR':
										$IsNew = true;
										if($ValidMDH->Loginfo->Logtext != 'OK' && $ValidMDH->Loginfo->Logtext != 'NODATA') {
											$IsValid = true;
										}
										break;
									break;
									default :
										echo "  Delete\n";
										$iMDH->Delete();
									break;
								}
								
								if( $IsNew ) echo "  Нашли значение {$iMDH->Loginfo->Logtext}\n";
								if( $IsValid ){
									echo "  Заменили по приоритету {$ValidMDH->Loginfo->Logtext}->{$iMDH->Loginfo->Logtext}\n";
									if( $ValidMDH->Is ) echo "   Удалили {$ValidMDH->Id} старое значение\n";
									$ValidMDH->Delete();
									$ValidMDH = $iMDH;
								}
								if( $IsBreak ) break;
								
								flush();
								if( $this->GetMemoryRun() ) {
									break; //return true;
								}
								if( $this->GetTimeRun() ) {
									break; //return true;
								}
							}
							$iMDHGroup->ElementsFreeMem;
						}
					}

					$MDH_S = !$ValidMDH->Is ? $MDHs_S->First : $ValidMDH ;
					
					if(!$MDH_S->Is) {
						echo "Ссылка не действиетльна IsDone = 1\n";
						# task 13031
						$iMeterlast->IsDone = 1;
						$iMeterlast->Save();
						$MDH_S->__destruct();
						unset($MDH_S);
						break;
					}


					# task 9667
					# Если ссылатся на данные сутоные и тд
					if(
						$MDH_S->Year 	== 0
							or
						$MDH_S->Month == 0
							or
						$MDH_S->Day 	== 0
							or
						$MDH_S->Hour 	== 0
					) {
						echo "Как то попали данные из выборки с нудевыми значениями : {$MDH_S->Year}-{$MDH_S->Month}-{$MDH_S->Day} {$MDH_S->Hour}\n";
						continue;
					}

					if(!$MDH_S->Is) {
						echo "  BREAK!!! нет данных.\n";
						$iMeterlast->IsDone = 1;
						break;
					}

					if( $MDH_S->Loginfo->Logtext == 'OK' ) {
						echo "   -> [MDHSCIP] [MDH] #{$MDH_S->Id} OK #{$MDH_S->Loginfo->Title}\n";

						$iMeterlast->Meterdatahour = $MDH_S;
						$iMeterlast->MeterdatahourSkip = $MDH_S;
						$iMeterlast->Year = $MDH_S->Year;
						$iMeterlast->Month = $MDH_S->Month;
						$iMeterlast->Day = $MDH_S->Day;
						$iMeterlast->Hour = $MDH_S->Hour;


					}elseif( $MDH_S->Loginfo->Logtext == 'NODATA' ) {
						$iMeterlast->MeterdatahourSkip 	= $MDH_S;
						$iMeterlast->Year = $MDH_S->Year;
						$iMeterlast->Month = $MDH_S->Month;
						$iMeterlast->Day = $MDH_S->Day;
						$iMeterlast->Hour = $MDH_S->Hour;
						echo "   -> [SCIP] #{$MDH_S->Id} NODATA #{$MDH_S->Loginfo->Title}\n";
					}elseif( $MDH_S->Loginfo->Logtext == 'ERROR' ) {
						$iMeterlast->MeterdatahourSkip 	= $MDH_S;
						echo "   -> [SCIP] #{$MDH_S->Id} ERROR #{$MDH_S->Loginfo->Title}\n";
					}else{
						echo "   Ничего нужного не нашли\n";
						echo "   -> #{$MDH_S->Id} ?? #{$MDH_S->Loginfo->Title}\n";
						echo "     Meterlast->IsDone = 1\n";
						$iMeterlast->IsDone = 1;
						break;
					}

				}
				$iMeterlast->Save();

				flush();
				if( $this->GetMemoryRun() ) {
					break; //return true;
				}
				if( $this->GetTimeRun() ) {
					break; //return true;
//					return true;
				}
				echo "\n\n";

			}
				if( $this->GetMemoryRun() ) {
					break; //return true;
				}
				if( $this->GetTimeRun() ) {
					break; //return true;
//					return true;
				}
				
			$iGroup->ElementsFreeMem;
			Site()->SetConfig( 'Meterlast.LastId', $iMeterlast->Id );
			//DB::Select( "COMMIT" );
			echo "DB COMMIT\n";
	 	}
		date_default_timezone_set( $MyTz );
		echo "  Обновлено: {$UpdateCount}, Просмотрено часов:{$HourLookCount}\n";
		return true;
	}

}


