{extends file="layout/archive.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">{$smarty.config.archives|default:"Архивы"}</h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$smarty.config.archives|default:"Архивы"}</li>
          </ol>
          
      </div>
  </div>
  
  
  
  <div class="row">
    
    <div class="col-lg-12" id="container_archive_list">
        
      <button type="button" class="btn btn-default" id="load_to_server" style="position: relative;">
        {$smarty.config.upload_to_server_button|default:"Загрузить на сервер"}
        
        <input type="file" id="fileupload" style="position: absolute;
    top: 0;
    left: 0;
    width: 100%;
    display: inline-block !important;
    height: 100%;
    cursor: pointer;
    opacity: 0;"/>
      </button>
      
      
      <div id="progress" style="display:none;">
        <div class="progress-bar progress-bar-success"></div>
    </div>
      
      <br>
      <br>
      
      <div class="panel-group" id="accordion">
        {foreach from=$Site->ArchivesFromLoad item=iArchive key=i}
          {include file="archive/helpers/list_item_from_load.tpl" i=$i}
        {/foreach}
        {foreach from=$Site->ArchivesByPages->Elements item=iArchive}
          {include file="archive/helpers/list_item.tpl"}
        {/foreach}
        
      </div>
      <button class="btn btn-success" id="add_new_archive">{$smarty.config.add_button|default:"Добавить"}</button>
      
      
    </div>
    
  </div>
  
  {include file="helpers/pagination.tpl" Pages=$Site->GetArchivesPages()}
  
{/block}