<div class="container">
  <div style="margin:0 auto; max-width:600px;">
    <img src="/img/logo_nag_1.png" class="logonagauth">
  </div>
  <div class="row">
    <div class="col-md-4 col-md-offset-4">
      <div class="panel panel-default">
        <div class="panel-heading">
          <h3 class="panel-title">{$smarty.config.login_header|default:"Вход"}</h3>
        </div>
        <div class="panel-body">
          <form id="login-form" role="form" method="post" action="/auth/">
            <input type="hidden" name="ref" value="{$smarty.get.ref|default:"/place/"}"/>
            <fieldset>
              <label>{$smarty.config.user_name_field|default:"Логин"}</label>
              <div class="form-group">
                <input 
                  class="form-control" 
                  name="login" 
                  type="text" 
                  autofocus="">
              </div>
              <div class="form-group">
                <label>{$smarty.config.user_password_field|default:"Пароль"}</label>
                <input class="form-control" name="password" type="password" value="">
              </div>
              <button type="submit" class="btn btn-success">{$smarty.config.login_button|default:"Войти"}</button>
              {if $Site->Config("is_forgot" , 0)}
                <a href="/auth/forgot/" id="forgot_btn">
                  <button class="btn btn-warning" type="button">{$Site->Config("ru.sys.forgot" , "Восстановить пароль")}</button>
                </a>
              {/if}
            </fieldset>
          </form>
          {if $Site->Config("is_demo" , 0)}
            <hr>
            <a href="/auth/demo/" id="demo_btn">
              <button class="btn btn-info">
                {$Site->Config("ru.sys.demo" , "Демо доступ")}
              </button>
            </a>
          {/if}
        </div>
        <div class="panel-footer">
          v {$Site->GetVersionTxt()}
        </div>
      </div>
    </div>
  </div>
</div>

<script type="text/template" id="registration_tpl">
  <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
      <div class="modal-dialog">
          <div class="modal-content">
              <div class="modal-header">
                  <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                  <h4 class="modal-title" id="myModalLabel">{$Site->Config("ru.sys.demo" , "Демо доступ")}</h4>
              </div>
              <div class="modal-body" id="body">
              </div>
              <div class="modal-footer">
                  <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                  <button type="button" class="btn btn-primary">Save changes</button>
              </div>
          </div>
      </div>
  </div>
</script>



<script type="text/template" id="registration_form_tpl">
  <label>Пароль</label>
  <div class="form-group input-group">
      <input type="text" class="form-control">
      <span class="input-group-addon <% if( demo.invalidPass() ){ %>alert-danger<% } %>">
        <i class="fa fa-times"></i>
      </span>
  </div>
  <label>Подверждение пароля</label>
  <div class="form-group input-group">
      <input type="text" class="form-control">
      <span class="input-group-addon alert-<% if( demo.invalidPass2() ){ %>danger<% }else{ %>success<% } %>">
        <i class="fa fa-<% if( demo.invalidPass2() ){ %>times<% }else{ %>check<% } %>"></i>
      </span>
  </div>
</script>
