<div 
  class="form-group {*{if isset( $error.ConverterId )}has-error{/if}*} converter_item"
>

{if !isset($EMPTY)}
  {assign var=EMPTY value=0}
{/if}

    <label>{$Site->Config('ru.converter')} *</label>
    
    {if isset( $oConverter )}
      {if isset($oMeter)}
        {assign var=oConverter value=$oMeter->Converter}
      {/if}
      <br>{include file="converter/helpers/block_name.tpl" oConverter=$oConverter}
      <input type="hidden" name="ConverterId" value="{$oConverter->GetId()}"/>
    {else}
    
      <select 
        name="ConverterId" 
        class="form-control">
        {if !$EMPTY}
          {foreach from=$Site->GetConverters()->Elements item="iConverter"}
            <option value="{$iConverter->GetId()}" 
              {if isset($oMeter)}
                {if $iConverter->Id == $oMeter->Converter->Id}
                  selected
                {/if}
              {/if}
              {if isset($oConverter)}
                {if $iConverter->Id == $oConverter->Id}
                  selected
                {/if}
              {/if}
            >{$iConverter->Title|escape}</option>
          {/foreach}
        {/if}
      </select>
    {/if}
</div>
        
        
  <div class="form-group {if isset( $error.TypeId )}has-error{/if}">
      <label>{$Site->Config('ru.meter.type')} *</label>
      <select name="TypeId" class="form-control">
        {if !$EMPTY}
          {foreach from=$Site->Metertypes->Elements item="iMetertype"}
          
            {assign var="valueType" value=""}
            
            {if isset($oMeter)}
              {if $iMetertype->Id == $oMeter->Type->Id}
                {assign var="valueType" value="selected"}
              {/if}
            {/if}
            {if isset($smarty.post.TypeId)}
              {if $iMetertype->Id == $smarty.post.TypeId}
                {assign var="valueType" value="selected"}
              {/if}
            {/if}
          
            <option value="{$iMetertype->GetId()}" {$valueType}>{$iMetertype->Title|escape}</option>
          {/foreach}
        {/if}
      </select>
  </div>
        
        
        
  <div class="form-group {if isset( $error.NumSerial )}has-error{/if}">
      <label>{$Site->Config('ru.meter.serial_number')} *</label>
      
      {assign var="valueNumSerial" value=""}
      
      {if isset($oMeter)}
        {assign var="valueNumSerial" value=$oMeter->GetNumSerial()}
      {/if}
      {if isset($smarty.post.NumSerial)}
        {assign var="valueNumSerial" value=$smarty.post.NumSerial}
      {/if}
      
      <input 
        class="form-control" 
        type="text" 
        name="NumSerial" 
        value="{$valueNumSerial}"
        data-validation="length" 
        data-validation-length="1-255"
        data-validation-error-msg="{$Site->Config('ru.meter.invalid_numserial')}"/>
  </div>
        
       
        
        <div class="form-group {if isset( $error.Num485 )}has-error{/if}">
            <label>{$Site->Config('ru.meter.num485')} *</label>
            
              {assign var="valueNum485" value=""}
              
              {if isset($oMeter)}
                {assign var="valueNum485" value=$oMeter->GetNum485()}
              {/if}
              {if isset($smarty.post.Num485)}
                {assign var="valueNum485" value=$smarty.post.Num485}
              {/if}
            
            <input 
              class="form-control" 
              type="text" 
              name="Num485" 
              data-validation="number" 
              data-validation-allowing="positive"
              data-validation-error-msg="{$Site->Config('ru.meter.invalid_num485')}"
              value="{$valueNum485}"/>
        </div>
        
         
        <div class="form-group">
            <label>{$Site->Config('ru.meter.about')}</label>
            
            {assign var="valueAbout" value=""}
              
            {if isset($oMeter)}
              {assign var="valueAbout" value=$oMeter->GetAbout()}
            {/if}
            {if isset($smarty.post.About)}
              {assign var="valueAbout" value=$smarty.post.About}
            {/if}
            
            <input class="form-control" type="text" name="About" 
              value="{$valueAbout}"/>
        </div>

        <div class="form-group">
            <label>{$Site->Config('ru.meter.coef')}</label>
            
            {assign var="valueCoef" value=""}
              
            {if isset($oMeter)}
              {assign var="valueCoef" value=$oMeter->GetCoef()}
            {/if}
            {if isset($smarty.post.Coef)}
              {assign var="valueCoef" value=$smarty.post.Coef}
            {/if}
            
            <input class="form-control" type="text" name="Coef" 
              value="{$valueCoef}"/>
        </div>
        
        
        <div class="form-group">
          <div class="checkbox">
              <label>
                
                {assign var="valueIsExcluded" value=""}
                  
                {if isset($oMeter)}
                  {if $oMeter->GetIsExcluded()}
                    {assign var="valueIsExcluded" value='checked'}
                  {/if}
                {/if}
                {if isset($smarty.post.IsExcluded)}
                  {if $smarty.post.IsExcluded}
                    {assign var="valueIsExcluded" value='checked'}
                  {/if}
                {/if}
                
                  <input type="checkbox" value="1" 
                  name="IsExcluded" {$valueIsExcluded}>{$Site->Config('ru.is_excluded')}
              </label>
          </div>
        </div>
        
        
        <div class="form-group">
            <label>{$Site->Config('ru.timezone')}</label>
            <select name="TimezoneId" class="form-control">
              {if !$EMPTY}
                {foreach from=$Site->Timezones->Elements item="iTimezone"}
                
                  {assign var="TimeZoneSelected" value=""}
                
                  {if isset($oMeter)}
                    {if $iTimezone->Id == $oMeter->Timezone->Id}
                      {assign var="TimeZoneSelected" value="selected"}
                    {/if}
                  {/if}
                  {if isset($smarty.post.TimezoneId)}
                    {if isset($smarty.post.TimezoneId) == $iTimezone->GetId()}
                      {assign var="TimeZoneSelected" value="selected"}
                    {/if}
                  {/if}
                
                  <option value="{$iTimezone->Id}" {$TimeZoneSelected}>{$iTimezone->Title|escape}</option>
                {/foreach}
              {/if}
            </select>
        </div>
