<div class="panel panel-default" id="conversion_list">
    <div class="panel-heading">
        {$Site->Config('ru.conversion')}
    </div>
    <div class="panel-body">
      
      
      <div class="table-responsive">
        <table class="table table-striped table-hover" id="converter_list">
          <thead>
            <tr>
              {if $Self->IsAdmin}
              <td class="action"></td>
              <td class="action"></td>
              {/if}
              <td>{$Site->Config('ru.conversion.title')}</td>
              <td>{$Site->Config('ru.conversion.divider')}</td>
              <td>{$Site->Config('ru.conversion.round')}</td>
              <td>{$Site->Config('ru.conversion.example')}</td>
            </tr>
          </thead>
          <tbody>
            {foreach from=$Site->Conversion->Elements item=iConversion}
              {include file="conversion/helpers/list_item.tpl" oConversion=$iConversion}
            {foreachelse}
              <tr>
                <td colspan="100">{$Site->Config('ru.conversion.null')}</td>
              </tr>
            {/foreach}
          <tbody>
      
        </table>
      </div>
      
    </div>
    {if $Self->IsAdmin}
    <div class="panel-footer">
        <button class="btn btn-success" id="block_add_conversion">{$Site->Config('ru.sys.add')}</button>
    </div>
    {/if}
</div>