{extends file="layout/converter.layout.tpl"}
{block name="content"}
  {include file="converter/helpers/converter_h1.tpl"}
  <div class="row">
    <div class="col-lg-7 table-responsive">
      <div class="panel panel-default"  id="block_converter_item_info">
        <div class="panel-heading">
          {$smarty.config.device_settings|default:"Параметры устройства"}
          {if $Self->IsAdmin}
            <span class="pull-right " id="converter_edit_modal" style="cursor: pointer;">
              <span href="{$oConverter->LinkEdit}" class="fa fa-pencil"></span>
            </span>
          {/if}
        </div>
        <div class="panel-body">
          {include file="converter/helpers/info.tpl"}
        </div>
      </div>
    </div>
    <div class="col-lg-5 table-responsive">
      {include file="converter/helpers/sys_info.tpl"}
    </div>
  </div>
  <div class="row" id="converter_meters">
    <div class="col-lg-12">
      <div class="panel panel-default"  id="block_converter_item_info">
        <div class="panel-heading">
          {$smarty.config.meter_meters|default:""}
        </div>
        <div class="panel-body">
          {include file="converter/helpers/meters.tpl"}
        </div>
      </div>
    </div>
  </div>
{/block}
