<div class="row">
  <div class="col-lg-12">
    <div class="table-responsive">
      <table class="table table-striped table-bordered table-hover" id="converter_list">
          {if $Site->GetRealConvertersByPages()->Count}
            <thead>
              <tr>
                {if $Self->IsAdmin}
                <th class="action"></th>
                <th class="action"></th>
                {/if}
                <th>{$Site->Config('ru.converter.title')}</th>
                <th>{$Site->Config('ru.converter.type')}</th>
                <th>{$Site->Config('ru.converter.ip')}</th>
                <th>{$Site->Config('ru.converter.port')}</th>
                <th colspan="3">{$Site->Config('ru.converter.meters')}</th>
              </tr>
            </thead>
          {/if}
          
          <tbody>
            {foreach from=$Site->RealConvertersByPages->Elements item=iConverter}
              {include file="converter/helpers/list_item.tpl" iObject=$iConverter}
            {foreachelse}
              <tr>
                <td>
                  {$Site->Config('ru.converter.null')}
                </td>
              </tr>
            {/foreach}
          </tbody>
          {if $Self->IsAdmin}
          <tfoot>
            <tr>
              <td class="action" id="add_converter_modal">
                <a href="/converter/add/" class="fa fa-plus-circle "></a>
              </td>
            </tr>
          </tfoot>
          {/if}
        </table>
      </div>
  </div>
</div>