{assign var="not_require" value=true}
{extends file="layout/filter.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">{$smarty.config.reports|default:"Отчеты"}</h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$smarty.config.reports|default:"Отчеты"}</li>
          </ol>
          
      </div>
  </div>
          
          {include file="filter/helpers/tabs.tpl" active='f80000'}
  
          <br>
          <div class="panel panel-default">
  <div class="panel-heading">
      {$smarty.config.parameter_formation|default:"Формирование параметров"}
    </div>
    
    <div class="panel-body">
  
  <div class="row" id="filter_panel">
    <div class="col-lg-12">
      
              
              <div class="form-group">
                  <label>{$smarty.config.report_objects|default:"Объекты отчета"}</label>
                  <select id="type_object" class="form-control">
                    <option value="place">{$smarty.config.select_place|default:"Объекты"}</option>
                    <option value="meter">{$smarty.config.select_meter|default:"Приборы учета"}</option>
                  </select>
              </div>
      
              
              <div class="form-group">
                <div id="tree_map" style="    background: #fff;
                margin: 0 0 23px;
                overflow: auto;"></div>
              </div>
                
                 <div class="row">
              <div class="col-lg-12">
              
              <button type="button" class="btn btn-success" id="send">{$smarty.config.upload_report|default:"Выгрузить отчет"}</button>
              
              </div>
            </div>
      
    </div>
    </div>
    </div>
    
    
    
  </div>
                    
  <div id="hidden_form" style="display: none;"></div>
  
  <script type="text/template" id="hidden_form_tpl">
    <form action="/reports/80000/" type="POST">
      <input name="object" style="display:none;" value="<%= res.type %>"/>
      <input name="ids" style="display:none;" value="<%= res.ids %>"/>
    </form>
  </script>
                    
  <script src="/js2/core/jstree.js" type="text/javascript"></script>
  <script src="/js2/core/underscore.js" type="text/javascript"></script>
  <script src="/js2/core/backbone.js" type="text/javascript"></script>
  <script src="/js2/core/bootstrap.js" type="text/javascript"></script>
  <script>
    var error_invalid_place = "{$smarty.config.error_invalid_place|default:'Неверно выбран объект'}"
    var error_no_places = "{$smarty.config.error_no_places|default:'Не выбраны объекты'}"
    var report_by_places = "{$smarty.config.report_by_places|default:'Отчет по местам'}"
    var report_by_converters = "{$smarty.config.report_by_converters|default:'Отчет по приборам учета'}"
  </script>
  <script src="/js2/views/filter/80000.js" type="text/javascript"></script>
{/block}
