{assign var="not_require" value=true}
{extends file="layout/filter.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">{$smarty.config.reports|default:"Отчеты"}</h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$smarty.config.reports|default:"Отчеты"}</li>
          </ol>
          
      </div>
  </div>
          
          {include file="filter/helpers/tabs.tpl" active='summ'}
  
          <br>
          
  <div class="panel panel-default">
    
    <div class="panel-heading">
      {$smarty.config.parameter_formation|default:"Формирование параметров"}
    </div>
    
    <div class="panel-body">
  
    <div class="row" id="filter_panel">

      <div class="col-lg-6">


                <div class="form-group">
                    <label>{$smarty.config.report_objects|default:"Объекты отчета"}</label>
                    <select id="type_object" class="form-control">
                      <option value="place">{$smarty.config.select_place|default:"Объекты"}</option>
                      <option value="meter">{$smarty.config.select_meter|default:"Приборы учета"}</option>
                    </select>
                </div>

                <div class="form-group">
                  <div id="tree_map" style="    background: #fff;
                  margin: 0 0 23px;
                  overflow: auto;"></div>
                </div>

      </div>
    
    
    
    
      <div class="col-lg-6">


              <div class="row">
                <div class="col-lg-12">
                  <div class="form-group">
                      <label>{$smarty.config.report_from|default:"Отчет с"}</label>
                      <input class="form-control" type="date" id="date_start" value="{$Site->GetTimeServerMonthDown()->format("Y-m-d")}"/> 
                  </div>
                </div>
              </div>
              <div class="row">
                <div class="col-lg-12">
                  <div class="form-group">
                      <label>{$smarty.config.report_to|default:"По"}</label>
                      <input class="form-control" type="date" id="date_stop" value="{$Site->GetDateServer()->format("Y-m-d")}"/>
                  </div>
                </div>
              </div>
              <div class="row hide">
                <div class="col-lg-12">
                  <div class="form-group">
                      <label>{$Site->Config('ru.filter.splice')}</label>
                      <select class="form-control" id="type_data">
                          {*<option>{$Site->Config('ru.filter.hours')}</option>*}
                          <option value="days">{$Site->Config('ru.filter.days')}</option>
                          {*<option>{$Site->Config('ru.filter.mounths')}</option>
                          <option>{$Site->Config('ru.filter.years')}</option>*}
                      </select>
                  </div>
                </div>
              </div>
                      <div class="row">
                        <div class="col-lg-12">
                          <div class="form-group">
                              <label>{$smarty.config.file_format|default:"Формат файла"}</label>
                              <select class="form-control"  id="extension">
                                {foreach from=$Site->GetExtensions()->Elements item=iExtension}
                                  <option value="{$iExtension->Name}">{$iExtension->Name}</option>
                                {/foreach}
                              </select>
                          </div>
                        </div>
                      </div>
              <div class="row">
                <div class="col-lg-12">

                <button type="button" class="btn btn-success" id="send">{$smarty.config.generate_report|default:"Сформировать отчет"}</button>

                </div>
              </div>
        </div>
      </div>
    </div>
    
  </div>
                    
  <div id="hidden_form" style="display: none;"></div>
  
  <script type="text/template" id="hidden_form_tpl">
    <form action="/reports/?save" type="POST">
      <input name="object" style="display:none;" value="<%= res.type %>"/>
      <input name="ids" style="display:none;" value="<%= res.ids %>"/>
      <input name="start_date" style="display:none;" value="<%= res.date_start %>"/>
      <input name="stop_date" style="display:none;" value="<%= res.date_stop %>"/>
      <input name="type_data" style="display:none;" value="<%= res.type_data %>"/>
      <input name="extension" style="display:none;" value="<%= res.extension %>"/>
    </form>
  </script>
  <script>
    var error_invalid_place = "{$smarty.config.error_invalid_place|default:'Неверно выбран объект'}"
    var error_no_places = "{$smarty.config.error_no_places|default:'Не выбраны объекты'}"
    var error_no_start_date = "{$smarty.config.error_no_start_date|default:'Не выбрана дата начала'}"
    var error_no_end_date = "{$smarty.config.error_no_end_date|default:'Не выбрана дата окончания'}"
    var error_invalid_date_type = "{$smarty.config.error_invalid_date_type|default:'Неверный тип данных'}"
    var error_unknown_file_format = "{$smarty.config.error_unknown_file_format|default:'Неизвестный формат файла'}"
  </script>
  <script src="/js2/core/jstree.js" type="text/javascript"></script>
  <script src="/js2/views/filter/index.js" type="text/javascript"></script>
{/block}
