{assign var="not_require" value=true}
{extends file="layout/group.layout.tpl"}
{block name="content"}
  
  
  <script src="/js2/models/group.js"></script>
  <script src="/js2/collections/group.js"></script>
  <script src="/js2/models/user.js"></script>
  <script src="/js2/collections/user.js"></script>
  <script src="/js2/models/groupuser.js"></script>
  <script src="/js2/collections/groupuser.js"></script>
  <script src="/js2/core/sweetalert.js"></script>
  
  <script>
    var group = new GROUP({ id : {$oGroup->Id} });
  </script>
  
  <script src="/js2/views/group/group.js"></script>
  <script src="/js2/views/group/modal_add_to_group.js"></script>
  <script src="/js2/views/group/delete_groupuser.js"></script>
  
  <div id="group_container">
  
    <div class="row">
        <div class="col-lg-12">
            <h1 class="page-header">
              {$Site->Config('ru.group.one')} {$oGroup->Title|escape}
            </h1>

            <ol class="breadcrumb">
              <li><a href="/">{$Site->Config('ru.main_page')}</a></li>
              <li><a href="/group/">{$Site->Config('ru.group')}</a></li>
              <li class="active">{$oGroup->Title|escape}</li>
            </ol>

        </div>
    </div>

    <div class="row">
      <div class="col-lg-12">
        {include file="group/helpers/info.tpl"}
      </div>
    </div>

    <div class="row">
      <div class="col-lg-3 table-responsive">
        {include file="group/helpers/users_in_group.tpl"}
      </div>
    </div>
        
  </div>
        
  <script type="text/template" id="group_list_user_tpl">
    <div class="modal fade" id="group_list_user" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h4 class="modal-title" id="myModalLabel">
              Пользователи
            </h4>
          </div>
          <div class="modal-body">
            <div class="list-group">
              <% _.each( users , function( user ){ %>
                      <a id="user_<%= user.get('id') %>" href="#" class="list-group-item<% if( user.is_isset_in_group( group ) ){ %> active <% } %>">
                          <i class="fa {$Site->Config('icon.user')} fa-fw"></i> <%= user.escape('title') %>
                      </a>
              <% }) %>
            </div>
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">
              Закрыть
            </button>
          </div>
        </div>
      </div>
    </div>
  </script>
        
  <script type="text/template" id="modal_delete_group_user_tpl">
    <div class="modal fade" id="modal_delete" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-body modal-header-danger">
                  <i class="fa  fa-question"></i> Вы уверены что хотите удалить пользователя из группы?
                </div>
                <div class="modal-footer">
                  <div class="main_buttons">
                    <button type="button" class="btn btn-default" data-dismiss="modal">
                      Закрыть
                    </button>
                    <button type="button" class="btn btn-danger" id="delete_object">
                      Удалить
                    </button>
                  </div>
                  <div class="preloader" style="text-align: center;display:none;">
                    <img src="/img/loader.gif" style="height: 10px;">
                  </div>
                </div>
            </div>
        </div>
    </div>
  </script>
        
        
{/block}
