<div class="row">
  <div class="col-lg-12 table-responsive" id="permissions_list">
    
    <table class="table table-striped table-bordered table-hover">
      {if $oMeter->Permisson->Count}
      <thead>
        <tr>
          <th class="action"></th>
        <th class="action"></th>
        <th>{$Site->Config('ru.user')}</th>
        <th>{$Site->Config('ru.rule')}</th>
        </tr>
      </thead>
      {/if}
      <tbody>
        {foreach from=$oMeter->GetPermisson()->Elements item="iLink"}
          <tr>
            <td class="action">
              <a href="{$iLink->LinkDelete}"  class="fa fa-times"></a>
            </td>
            <td class="action">
              <a href="{$iLink->LinkEdit}"  class="fa fa-pencil"></a>
            </td>
            <td>
              <a href="{$iLink->User->Link}">
                {$iLink->User->Title|escape}
              </a>
            </td>
            <td>
              <a href="{$iLink->Rule->Link}">
                {$iLink->Rule->Title|escape}
              </a>
              {if $iLink->Auto}
                <small class="text-warning">Отнаследовано</small>
              {/if}
            </td>
          </tr>
        {foreachelse}
          <tr>
            <td>{$Site->Config('ru.link.null')}</td>
          </tr>
        {/foreach}
        <tr>
          <td class="action" id="add_converter_modal">
            <a href="/converter/add/" class="fa fa-plus-circle "></a>
          </td>
        </tr>
      </tbody>
    </table>

  </div>
</div>
        
      
      
  <script type="text/template" id="permission_add_tpl">
    
    
    <div class="modal fade" id="myModalLabel" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
            <h4 class="modal-title" id="myModalLabel">
              Принулительное добавление прав пользователю на этот прибор учета.
            </h4>
          </div>
          <div class="modal-body">
          
          
          <form name="mf" action="" method="post" enctype="multipart/form-data">
            <input name="REF" type="hidden" value="{$smarty.server.HTTP_REFERER|default:"/"}" />
            <input name="form" type="hidden" value="link" />


                <div class="form-group {if isset($RETRY.UserId)}has-error{/if}">
                    <label class="control-label">
                      {$Site->Config('ru.link.userid','Пользователь')}          </label>

                                <br />
          <select size="1" name="UserId"  class="form-control">
            <option value="0">- Выбор -</option>
          {foreach item=iUser from=$Site->GetAllUser()->Elements}
            <option value="{$iUser->Id}"{if $oLink->User->Id==$iUser->Id or (isset($oTopUser) and $oTopUser->Id==$iUser->Id)} selected="selected"{/if}>{$iUser->Title}</option>
          {/foreach}
          </select><br />
                          </div>  




                <div class="form-group {if isset($RETRY.RuleId)}has-error{/if}">
                    <label class="control-label">
                      {$Site->Config('ru.link.ruleid','Права')}          </label>

                                <br />
          <select size="1" name="RuleId"  class="form-control">
            <option value="0">- Выбор -</option>
          {foreach item=iRule from=$Site->GetRules()->Elements}
            <option value="{$iRule->Id}"{if $oLink->Rule->Id==$iRule->Id or (isset($oTopRule) and $oTopRule->Id==$iRule->Id)} selected="selected"{/if}>{$iRule->Title}</option>
          {/foreach}
          </select><br />
                          </div>  



                <input type="hidden" value="{$oMeter->GetObjectruleObj()->Id}" name="ObjectruleId"/> 
                <input class="all" name="Whyid" type="hidden" value="{$oMeter->Id}" title="" maxlength="150" />
                <input id="Auto" name="Auto" type="hidden" value="0"/>


          </form>
          
            
          </div>
          <div class="modal-footer">
            <button type="button" class="btn btn-success" data-dismiss="modal" onClick="document.getElementsByTagName('form')[0].submit();">
              Сохранить
            </button>
            <button type="button" class="btn btn-default" data-dismiss="modal">
              Закрыть
            </button>
          </div>
        </div>
      </div>
    </div>
  </script>