<!doctype html> 
<html> 
  <head>
    {assign var=not_require value=true}
    {include file="static.head.tpl"}
  </head> 
  <body>
    
    
    <div class="container">
        <div class="row">
          <div class="col-md-4 col-md-offset-4">
            <div class="login-panel panel panel-default">
              <div class="panel-heading">
                  <h3 class="panel-title">Настройка базы данных</h3>
              </div>
              <div class="panel-body">
                <form role="form" method="post">
                  <fieldset>
                    <div class="form-group">
                    <label>IP сервера</label>
                      <input 
                        class="form-control" 
                        name="ip" 
                        type="text" 
                        autofocus="">
                    </div>
                    <div class="form-group">
                      <label>База данных</label>
                      <input class="form-control" name="name" value="">
                    </div>
                    <div class="form-group">
                    <label>Логин</label>
                      <input 
                        class="form-control" 
                        name="login" 
                        type="text" 
                        autofocus="">
                    </div>
                    <div class="form-group">
                      <label>Пароль</label>
                      <input class="form-control" name="password" type="password" value="">
                    </div>
                    
                    
                    <div class="spoiler">
                        <div class="spoiler-btn">
                          <i class="fa fa-arrow-down"></i>
                          Расщиренные настройки
                        </div>
                        <div class="spoiler-body collapse">
                          <fieldset>
                            <legend>Пользователь фоновых задач</legend>
                            <div class="form-group">
                            <label>Логин</label>
                              <input 
                                class="form-control" 
                                name="login_cron" 
                                type="text" 
                                autofocus="">
                            </div>
                            <div class="form-group">
                              <label>Пароль</label>
                              <input class="form-control" name="password_cron" type="password" value="">
                            </div>
                          </fieldset>
                          
                          
                          
                          <fieldset>
                            <legend>Пользователь системы опроса</legend>
                            <div class="form-group">
                            <label>Логин</label>
                              <input 
                                class="form-control" 
                                name="login_so" 
                                type="text" 
                                autofocus="">
                            </div>
                            <div class="form-group">
                              <label>Пароль</label>
                              <input class="form-control" name="password_so" type="password" value="">
                            </div>
                          </fieldset>
                        </div>
                    </div>
                    
                    <br>
                    
                    
                    
                    
                    <button type="submit" class="btn btn-success">Сохранить</button>
                  </fieldset>

                </form>
              </div>
            </div>
          </div>
        </div>
    </div>
    
    {literal}
      <script>
        $(document).ready(function(){
          $('.spoiler-btn').on('click' , function(){
            $(this).find('i').toggleClass('fa-arrow-down').toggleClass('fa-arrow-up');
            $(this).parent().children('.spoiler-body').collapse('toggle')
          })
        })
      </script>
      <style>
        .spoiler {
            position: relative;

        }

        .spoiler-btn {
          cursor: pointer;
        }

        .spoiler-body {
          padding: 6px;
        }
      </style>
    {/literal}
    
  </body> 
</html>
