{extends file="layout/meter.layout.tpl"}
{block name="content"}


  <h1 class="page-header">Привязка параметров к типам приборов</h1>

  <table class="table">
    
    <thead>
      <tr>
        <th>Тип прибора</th>
        <th>Лог</th>
      </tr>
    </thead>

    {foreach from=$res_output item=rows key=meter_type_ident}
        
        {assign var="is_write_type" value=false}
        
        {assign var="danger" value=0}
        
        {foreach from=$rows item=col}
          {if $col.type == 'danger'}
            {assign var="danger" value=$danger+1}
          {/if}
        {/foreach}
        
        {foreach from=$rows item=col}
        
          <tr class="{if  !$is_write_type}active{else}panel-collapse collapse out{/if} {$meter_type_ident}">
              <td>{if !$is_write_type}{$meter_type_ident}{/if}</td>
              <td class="{$col.type} {if !$is_write_type}{if $danger}danger{else}success{/if}{/if}">{$col.msg}
              {if  !$is_write_type}
                <button class="btn btn-default btn-xs pull-right fa fa-angle-down more"></button>
              {/if}
              </td>
          </tr>
          
          {if !$is_write_type}
            {assign var="is_write_type" value=true}
          {/if}
          
        {/foreach}

    {/foreach}
  
  </table>
  
  {literal}
    <style>
      .spoler_tr{
        display:none;
      }
    </style>
    <script>
      $(".more").click(function() {
        
        var classes = $(this).closest('tr').attr('class').split(/\s+/)
        
        var type = classes.filter(function(item){
          return item != "active"
        }).shift()
        
        $('.collapse.' + type ).collapse('toggle')
        
        
        $(this).toggleClass('fa-angle-up').toggleClass('fa-angle-down');
      });
    </script>
  {/literal}

{/block}