{literal}const PATHApp = "/"

requirejs.config({
    waitSeconds : 300, // Сколько ждать ответа от модулей
    paths:{
      
	/*
	  Ядро
	*/
        jquery                  : './js/core/jquery'                ,
        underscore              : './js/core/underscore'            ,
        backbone                : './js/core/backbone'              ,
        tmpl                    : './js/core/tmpl'                  ,
        text                    : './js/core/text'                  ,
        ui                      : './js/core/ui'                    ,
        jstree                  : './js/core/jstree'                ,
        validator               : './js/core/validator'             ,
        cache                   : './js/core/cache'                 ,
        ui_nag                  : './js/core/ui_nag'                ,
        upload                  : './js/core/upload'                ,
        iframe                  : './js/core/iframe'                ,
        uiwidget                : './js/core/uiwidget'              ,
        bootstrap               : './js/core/bootstrap'              ,
        jtouch                  : './js/core/jtouch'              ,
        exporting               : './js/core/exporting'              ,
        highcharts              : './js/core/highcharts'              ,
        hightstock              : './js/core/hightstock'              ,
        daterangepicker         : './js/core/daterangepicker'              ,
        moment                  : './js/core/moment'              ,
        clockpicker             : './js/core/clockpicker'              ,
        datepicker              : './js/core/bootstrap-datepicker.min'              ,
        ckeditor                : './js/ckeditor/ckeditor'              ,
        ckeditor_conf           : './js/ckeditor/config'              ,
        force_data              : './js/force_data'              ,


        filter                  : './js/core/model/filter'          ,
        filters                 : './js/core/collection/filters'    ,
        
        
        parameter               : './js/core/model/parameter'       ,
        parameters              : './js/core/collection/parameters' ,
        
        
        
        
        
        meterformula            : './js/core/model/meterformula'       ,
        meterformuls            : './js/core/collection/meterformuls' ,
        
        
        
        
        
        conversion              : './js/core/model/conversion'       ,
        conversions             : './js/core/collection/conversions' ,
        
        
        meterhelper             : './js/core/model/meterhelper'       ,
        meterhelpers            : './js/core/collection/meterhelpers' ,
        
        
        converterhelper         : './js/core/model/converterhelper'       ,
        converterhelpers        : './js/core/collection/converterhelpers' ,
        
        
        
        
        
        
        
        meterdatahour            : './js/core/model/meterdatahour'       ,
        meterdatahours           : './js/core/collection/meterdatahours' ,
        
        
        
        
        meter                   : './js/core/model/meter'           ,
        meters                  : './js/core/collection/meters'     ,
        
        
        
        
        vmeter                  : './js/core/model/vmeter'           ,
        vmeters                 : './js/core/collection/vmeters'     ,
        
        
        archive                  : './js/core/model/archive'           ,
        archives                 : './js/core/collection/archives'     ,
        
        
        
        
        archivemeter                  : './js/core/model/archivemeter'           ,
        archivemeters                 : './js/core/collection/archivemeters'     ,
        
        
        
        
        
        cmeter                  : './js/core/model/cmeter'           ,
        cmeters                 : './js/core/collection/cmeters'     ,
        
        
        
        meterparameter          : './js/core/model/meterparameter'  ,
        meterparameters         : './js/core/collection/meterparameters',
        
        
        
        meter_type              : './js/core/model/meter_type'      ,
        meter_types             : './js/core/collection/meter_types',
        
        
        
        
        meter_place             : './js/core/model/meter_place'      ,
        meter_places            : './js/core/collection/meter_places',
        
        
        
        timezone                : './js/core/model/timezone'      ,
        timezones               : './js/core/collection/timezones',
        
        
        
        place                   : './js/core/model/place'           ,
        places                  : './js/core/collection/places'     ,
        
        
        
        converter               : './js/core/model/converter'       ,
        converters              : './js/core/collection/converters' ,
        
        
        
        
        
        
        user                    : './js/core/model/user'       ,
        users                   : './js/core/collection/users' ,
        
        
        
        
        
        
        
        
        rule                    : './js/core/model/rule'       ,
        rules                   : './js/core/collection/rules' ,
        
        
        
        
        
        
        
        
        
        group                    : './js/core/model/group'       ,
        groups                   : './js/core/collection/groups' ,
        
        
        
        
        
        
        
        mail                     : './js/core/model/mail'       ,
        mails                    : './js/core/collection/mails' ,
        
        
        
        
        
        vconverter              : './js/core/model/vconverter'       ,
        vconverters             : './js/core/collection/vconverters' ,
        
        
        
        
        cconverter              : './js/core/model/cconverter'       ,
        cconverters             : './js/core/collection/cconverters' ,
        
        
        
        converter_type          : './js/core/model/converter_type'  ,
        converter_types         : './js/core/collection/converter_types',

        
        
        
        meterparameter          : './js/core/model/meterparameter'  ,
        meterparameters         : './js/core/collection/meterparameters',






        place_modal_add         : './js/view/place/place_modal_add',
        place_modal_edit        : './js/view/place/place_modal_edit',
        place_modal_delete      : './js/view/place/place_modal_delete',
        place_children          : './js/view/place/children',
        place_short_edit        : './js/view/place/short_edit',
        place_breadcrumb        : './js/view/place/breadcrumb',
        place_h1                : './js/view/place/h1',
        place_children_h1       : './js/view/place/children_h1',
        place_tree              : './js/view/place/tree',
        place_add_file          : './js/view/place/add_file',
        place_edit_parameter    : './js/view/place/edit_parameter',
        place_view_tree         : './js/view/place/view_tree',
        place_view_children     : './js/view/place/children',
        place_action            : './js/view/place/action',
        place_block_info        : './js/view/place/block_info',
        place_modal_children    : './js/view/place/modal_children',
        place_modal_child_ctrl  : './js/view/place/modal_child_ctrl',
        place_add_child         : './js/view/place/add_child',
        place_meters            : './js/view/place/meters',
        place_pareameter_data   : './js/view/place/parameter_data',
        place_modal_to_tree     : './js/view/place/modal_to_tree',
        
        vconverter_list         : './js/view/vconverter/list',
        
        converter_list          : './js/view/converter/list',
        converter_edit          : './js/view/converter/edit',
        converter_one           : './js/view/converter/one',
        converter_modal_edit    : './js/view/converter/modal_edit',
        converter_h1            : './js/view/converter/h1',
        converter_breadcrumb    : './js/view/converter/breadcrumb',
        converter_children      : './js/view/converter/children',
        converter_modal_delete  : './js/view/converter/modal_delete',
        
        
        
        vmeter_modal_add        : './js/view/vmeter/add_modal',
        vmeter_modal_edit       : './js/view/vmeter/modal_edit',
        vmeter_modal_delete     : './js/view/vmeter/modal_delete',
        vmeter_one              : './js/view/vmeter/one',
        vmeter_h1               : './js/view/vmeter/h1',
        vmeter_breadcrumb       : './js/view/vmeter/breadcrumb',
        vmeter_modal_add        : './js/view/vmeter/modal_add',
        vmeter_charts           : './js/view/vmeter/charts',
        
        
        
        meter_modal_add         : './js/view/meter/add_modal',
        meter_modal_edit        : './js/view/meter/modal_edit',
        meter_modal_delete      : './js/view/meter/modal_delete',
        meter_one               : './js/view/meter/one',
        meter_h1                : './js/view/meter/h1',
        meter_breadcrumb        : './js/view/meter/breadcrumb',
        meter_data              : './js/view/meter/data',
        meter_charts            : './js/view/meter/charts',
        meter_parameter_data    : './js/view/meter/parameter_data',
        meter_last_parameters   : './js/view/meter/parameter_last',
        meter_action            : './js/view/meter/action',
        meter_datapicker        : './js/view/meter/datapicker',
        meter_settings_chart    : './js/view/meter/settings_chart',
        
        
        vconverter_modal_delete : './js/view/vconverter/modal_delete',
        vconverter_modal_add    : './js/view/vconverter/modal_add',
        vconverter_children     : './js/view/vconverter/children',
        vconverter_one          : './js/view/vconverter/one',
        vconverter_modal_edit   : './js/view/vconverter/modal_edit',
        
        
        
        
        
        
        parameter_filter        : './js/view/parameter/filter',
        parameters_correction_table        : './js/view/parameter/correction_table',
        parameter_list          : './js/view/parameter/list',
        parameter_modal_edit    : './js/view/parameter/modal_edit',
        parameter_modal_delete  : './js/view/parameter/modal_delete',
        
        
        conversion_list         : './js/view/conversion/list',
        conversion_modal_delete : './js/view/conversion/modal_delete',
        conversion_modal_edit   : './js/view/conversion/modal_edit',
        
        
        
        
        archive_list            : './js/view/archive/list',
        archive_add_modal       : './js/view/archive/add_modal',
        archive_add_meter_modal : './js/view/archive/meter_modal',
        archive_delete_modal    : './js/view/archive/delete_modal',
        
        
        
        meterparameter_list     : './js/view/meterparameter/list',
        meterparameter_modal_edit : './js/view/meterparameter/modal_edit',
        meterparameter_modal_delete : './js/view/meterparameter/modal_delete',
        
        
        
        
        
        user_list               : './js/view/user/list',
        user_modal_edit         : './js/view/user/modal_edit',
        user_modal_delete       : './js/view/user/modal_delete',
        user_add_to_group       : './js/view/user/add_to_group',
        
        
        
        group_list              : './js/view/group/list',
        group_modal_edit        : './js/view/group/modal_edit',
        group_modal_delete      : './js/view/group/modal_delete',
        group_add_to_group      : './js/view/group/add_to_group',
        
        
        
        cmeter_one              : './js/view/cmeter/one',
        cmeter_modal_edit       : './js/view/cmeter/modal_edit',
        cmeter_h1               : './js/view/cmeter/h1',
        cmeter_breadcrumb       : './js/view/cmeter/breadcrumb',
        cmeter_formula          : './js/view/cmeter/formula',
        cmeter_remove_formula   : './js/view/cmeter/remove_formula',
        cmeter_edit_formula     : './js/view/cmeter/edit_formula',
        cmeter_formula_add_btn  : './js/view/cmeter/formula_add_btn',
        cmeter_block_formula    : './js/view/cmeter/block_formula',
        cmeter_formula_modal    : './js/view/cmeter/formula_modal',
        cmeter_modal_add        : './js/view/cmeter/modal_add',
        cmeter_modal_delete     : './js/view/cmeter/modal_delete',
        
        
        
        
        
        
        main_menu               : './js/view/main_menu',
        
        
        
        rule_list               : './js/view/rule/list',
        rule_modal_edit         : './js/view/rule/modal_edit',
        rule_modal_delete       : './js/view/rule/modal_delete',
        
        
        
        
        
        
        cconverter_list         : './js/view/cconverter/list',
        cconverter_modal_add    : './js/view/cconverter/modal_add',
        cconverter_modal_delete : './js/view/cconverter/modal_delete',
        cconverter_modal_edit   : './js/view/cconverter/modal_edit',
        cconverter_one          : './js/view/cconverter/one',
        cconverter_h1           : './js/view/cconverter/h1',
        cconverter_info         : './js/view/cconverter/info',
        cconverter_breadcrumb   : './js/view/cconverter/breadcrumb',
        cconverter_meters       : './js/view/cconverter/meters',
        
        
        
        
        
        
        
        mail_list               : './js/view/mail/list',
        mail_edit               : './js/view/mail/edit',
        mail_delete             : './js/view/mail/delete',
        
        
        
    {/literal}
      {if $Self->IsRoot}
        "rootpanel_meter_settings_add"            :                 "./js/rootpanel/meter/settings_add",
        "rootpanel_converter_settings_add"        :                 "./js/rootpanel/converter/settings_add",
      {/if}
    {literal}

    },
    shim: {
        jquery: {
          exports: '$',
        },
        ckeditor_conf: {
          deps: ['ckeditor'],
        },
        ckeditor: {
          exports: 'CKEDITOR',
        },
        tmpl: {
          deps:["backbone"],
          exports: 'tmpl',
        },
        underscore: {
          exports: '_'
        },
        backbone: {
          deps: ["underscore", /*"jquery" ,*/ "validator",'ui','ui_nag'],
          exports: "Backbone"
        },
        highcharts: {
          //~ deps: ["jquery"],
          exports: "Highcharts"
        },
        exporting: {
          deps: ["highcharts"],
          exports: "Highcharts"
        },
        cache: {
          deps: ["backbone"]
        },
        bootstrap: {
          exports: "$"
        },
    },
    baseUrl : PATHApp
})


var Backbone;
var $;
var _;

require([
  'jquery',
  'underscore',
  'backbone',
  'jstree',
  'bootstrap'],function(aaa,_,Backbone,abc,$){

    Backbone = Backbone

    Backbone.emulateJSON = true;
    Backbone.emulateHTTP = true;
    
    var AppRouter = Backbone.Router.extend({

      routes: {
        //"place/"                                  :                 "place",
        "place/:id/"                              :                 "place_one",
        "place/:id/heat/"                         :                 "place_one",
        "place/:id/water/"                        :                 "place_one",
        "place/:id/tree/"                         :                 "place_page_tree",
        "place/:id/files/"                        :                 "place_files",
        "place/:id/reports/"                      :                 "place_reports",
        "place/:id/archive/:year/:month/:day/"    :                 "place_one",
        "place/:id/archive/:year/:month/"         :                 "place_one",
        "place/:id/archive/:year/"                :                 "place_one",
        "place/:id/water/archive/:year/:month/:day/"    :                 "place_one",
        "place/:id/water/archive/:year/:month/"         :                 "place_one",
        "place/:id/water/archive/:year/"                :                 "place_one",
        "place/:id/heat/archive/:year/:month/:day/"    :                 "place_one",
        "place/:id/heat/archive/:year/:month/"         :                 "place_one",
        "place/:id/heat/archive/:year/"                :                 "place_one",
        
        "vconverter/"                             :                 "vconverter",
        "vconverter/:id/"                         :                 "vconverter_one",
        
        "vmeter/:id/"                             :                 "vmeter_one",
        "vmeter/:id/archive/:year/:month/:day/"   :                 "vmeter_one",
        "vmeter/:id/archive/:year/:month/"        :                 "vmeter_one",
        "vmeter/:id/archive/:year/"               :                 "vmeter_one",
        "vmeter/:id/graphs/"                      :                 "vmeter_graphs",
        "vmeter/:id/graphs/:year/:month/:day/"    :                 "vmeter_graphs",
        "vmeter/:id/graphs/:year/:month/"         :                 "vmeter_graphs",
        "vmeter/:id/graphs/:year/"                :                 "vmeter_graphs",
        
        "converter/"                              :                 "converter",
        "converter/:id/"                          :                 "converter_one",
        
        "meter/:id/"                              :                 "meter_one",
        "meter/:id/archive/:year/:month/:day/"    :                 "meter_one",
        "meter/:id/archive/:year/:month/"         :                 "meter_one",
        "meter/:id/archive/:year/"                :                 "meter_one",
        // "meter/:id/graphs/"                       :                 "meter_graphs",
        "meter/:id/graphs/:year/:month/:day/"     :                 "meter_graphs",
        "meter/:id/graphs/:year/:month/"          :                 "meter_graphs",
        "meter/:id/graphs/:year/"                 :                 "meter_graphs",
        "meter/:id/lastdata/"                     :                 "meter_last",
        "meter/:id/exports/"                      :                 "meter_one",
        "meter/:id/statuses/"                     :                 "meter_one",
        
        
        
        "cmeter/:id/"                             :                 "cmeter_one",
        "cmeter/:id/graphs/"                      :                 "cmeter_graphs",
        "cmeter/:id/graphs/:year/:month/:day/"    :                 "cmeter_graphs",
        "cmeter/:id/graphs/:year/:month/"         :                 "cmeter_graphs",
        "cmeter/:id/graphs/:year/"                :                 "cmeter_graphs",
        "cmeter/:id/formula/"                     :                 "cmeter_formula",
        "cmeter/:id/archive/:year/:month/:day/"    :                "cmeter_one",
        "cmeter/:id/archive/:year/:month/"         :                "cmeter_one",
        "cmeter/:id/archive/:year/"                :                "cmeter_one",
        
        
        "archive/"                                :                 "archive",
        
        
        "user/"                                   :                 "users",
        
        
        
        "group/"                                  :                 "group",
        
        
        "rule/"                                   :                 "rule",
        
        
        
        
        
        "cconverter/"                             :                 "cconverter",
        "cconverter/:id/"                         :                 "cconverter_one",
        
        
        "mail/"                                   :                 "mail",
        
        
    {/literal}
      {if $Self->IsRoot}
        "rootpanel/meter/settings_add.:any"       :                 "rootpanel_meter_settings_add",
        "rootpanel/converter/settings_add.:any"   :                 "rootpanel_converter_settings_add",
      {/if}
    {literal}
        
        
      },
      
      
      {/literal}
        {if $Self->IsRoot}
        rootpanel_meter_settings_add : function(){
          require([
            'rootpanel_meter_settings_add',
          ],function(
            rootpanel_meter_settings_add
          ){
            $(document).ready(function(){
              new rootpanel_meter_settings_add()
            })
          })
        }, 
        
        rootpanel_converter_settings_add : function(){
          require([
            'rootpanel_converter_settings_add',
          ],function(
            rootpanel_converter_settings_add
          ){
            $(document).ready(function(){
              new rootpanel_converter_settings_add()
            })
          })
        }, 
      {/if}
    {literal}
      
      
      
      archive : function(){
        require(['archive_list'],function(archive_list){
          $(document).ready(function(){
            new archive_list()
          })
        })
      },
      
      
      
      vconverter : function(){
        require(['vconverter_list'],function(vconverter_list){
          $(document).ready(function(){
            new vconverter_list()
          })
        })
      },
      
      
      
      users : function(){
        require(['user_list'],function(user_list){
          $(document).ready(function(){
            new user_list()
          })
        })
      },
      
      
      
      rule : function(){
        require(['rule_list'],function(rule_list){
          $(document).ready(function(){
            new rule_list()
          })
        })
      },
      
      
      
      group : function(){
        require(['group_list'],function(group_list){
          $(document).ready(function(){
            new group_list()
          })
        })
      },
      
      
      
      mail : function(){
        require(['mail_list'],function(mail_list){
          $(document).ready(function(){
            new mail_list()
          })
        })
      },
      
      
      
      vconverter_one : function( id ){
        require([
          "vconverters",
          "vconverter_one",
          "converter_h1",
          "converter_breadcrumb",
          "vconverter_children"
        ],function(
          vconverters,
          vconverter_one,
          converter_h1,
          converter_breadcrumb,
          vconverter_children
        ){
        
          let one_exemplar        = new vconverter_one
          let h1_exemplar         = new converter_h1
          let breadcrumb_exemplar = new converter_breadcrumb
          let children_exemplar   = new vconverter_children
          
          vconverters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let converter_model = res.last()
              
              $(document).ready(function(){
                
                one_exemplar.setmodel(converter_model)
                h1_exemplar.setmodel(converter_model)
                breadcrumb_exemplar.setmodel(converter_model)
                children_exemplar.setmodel(converter_model)
                
              })
            }
          })
          
        })
      },
      
      
      meter_one : function( id ){
        require([
          'meters',
          'meter_one',
          'meter_action',
          'meter_h1',
          'meter_breadcrumb',
          'meter_data',
          'meter_datapicker',
          'meter_parameter_data'
        ],function(
          meters,
          meter_one,
          meter_action,
          meter_h1,
          meter_breadcrumb,
          meter_data,
          meter_datapicker,
          meter_parameter_data
        ){
          
          let one_exemplar        = new meter_one
          let action_exemplar        = new meter_action
          let h1_exemplar         = new meter_h1
          let breadcrumb_exemplar = new meter_breadcrumb
          let meter_parameter_data_exemplar = new meter_parameter_data
          
          meters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
              
              $(document).ready(function(){
                
                new meter_datapicker();
                
                one_exemplar.setmodel(meter_model)
                h1_exemplar.setmodel(meter_model)
                breadcrumb_exemplar.setmodel(meter_model)
                meter_parameter_data_exemplar.setmodel(meter_model)
                action_exemplar.setmodel(meter_model)
                
                new meter_data( id )
                
              })
            }
          })
          
          
        })
      },
      
      
      meter_graphs : function( id ){
        
        require([
          "meter_charts",
          'meters',
          'meter_one',
          'meter_h1',
          'meter_breadcrumb',
          'meter_settings_chart',
          'meter_action'
        ],function(
          meter_charts,
          meters,
          meter_one,
          meter_h1,
          meter_breadcrumb,
          meter_settings_chart,
          meter_action
        ){
        
          meters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
          
              let one_exemplar          = new meter_one
              let h1_exemplar           = new meter_h1
              let breadcrumb_exemplar   = new meter_breadcrumb
              let meter_settings_chart_e  = new meter_settings_chart
              let action_exemplar        = new meter_action
              
              $(document).ready(function(){
                new meter_charts( id )
                one_exemplar.setmodel(meter_model)
                h1_exemplar.setmodel(meter_model)
                breadcrumb_exemplar.setmodel(meter_model)
                meter_settings_chart_e.setmodel( meter_model )
                action_exemplar.setmodel( meter_model )
              })
            }
          })
        })
        
      },
      
      vmeter_graphs : function( id ){
        
        require([
          "vmeter_charts",
          'vmeters',
          'vmeter_one',
          'vmeter_h1',
          'vmeter_breadcrumb'
        ],function(
          meter_charts,
          vmeters,
          vmeter_one,
          vmeter_h1,
          vmeter_breadcrumb
        ){
          
          vmeters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
          
              let one_exemplar        = new vmeter_one
              let h1_exemplar         = new vmeter_h1
              let breadcrumb_exemplar = new vmeter_breadcrumb
              
              $(document).ready(function(){
                new meter_charts( id )
                one_exemplar.setmodel(meter_model)
                h1_exemplar.setmodel(meter_model)
                breadcrumb_exemplar.setmodel(meter_model)
              })
            }
          })
        })
        
      },
      
      
      
      meter_last : function( id ){
        
        require([
          "meter_last_parameters",
          'meters',
          'meter_one',
          'meter_h1',
          'meter_breadcrumb',
          'meter_action'
        ],function(
          meter_last_parameters,
          meters,
          meter_one,
          meter_h1,
          meter_breadcrumb,
          meter_action
        ){
          
          meters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
          
              let one_exemplar        = new meter_one
              let h1_exemplar         = new meter_h1
              let breadcrumb_exemplar = new meter_breadcrumb
              let meter_last_p        = new meter_last_parameters
              let action_exemplar        = new meter_action
              
              $(document).ready(function(){
                one_exemplar.setmodel(meter_model)
                h1_exemplar.setmodel(meter_model)
                breadcrumb_exemplar.setmodel(meter_model)
                meter_last_p.setmodel(meter_model)
                action_exemplar.setmodel(meter_model)
              })
            }
          })
        })
        
      },
      
      
      
      
      
      
      cmeter_one : function( id ){
        require([
          'cmeters',
          'cmeter_one',
          'cmeter_h1',
          'meter_datapicker',
          'cmeter_breadcrumb'
        ],function(
          cmeters,
          cmeter_one,
          cmeter_h1,
          meter_datapicker,
          cmeter_breadcrumb
        ){
          
          let one_exemplar        = new cmeter_one
          let cmeter_h1_exemplar  = new cmeter_h1
          let cmeter_breadcrumb_exemplar  = new cmeter_breadcrumb

          cmeters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
              
              $(document).ready(function(){
                new meter_datapicker();
                one_exemplar.setmodel(meter_model)
                cmeter_h1_exemplar.setmodel(meter_model)
                cmeter_breadcrumb_exemplar.setmodel(meter_model)
                
              })
            }
          })
          
          
        })
      },
      
      
      
      cmeter_formula : function( id ){
        require([
          'cmeters',
          'cmeter_formula'
        ],function(
          cmeters,
          cmeter_formula
        ){
          
          var cmeter_formula_e = new cmeter_formula
          
          cmeters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
              
              $(document).ready(function(){
                
                cmeter_formula_e.setmodel(meter_model)
                
              })
            }
          })
          
          
        })
      },
      
      
      cmeter_graphs : function( id ){
        require([
          "meter_charts",
          'cmeters',
          'cmeter_one',
          'cmeter_h1',
          'cmeter_breadcrumb'
        ],function(
          meter_charts,
          meters,
          meter_one,
          meter_h1,
          meter_breadcrumb
        ){
          
          meters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let meter_model = res.last()
          
              let one_exemplar        = new meter_one
              let h1_exemplar         = new meter_h1
              let breadcrumb_exemplar = new meter_breadcrumb
              
              $(document).ready(function(){
                new meter_charts( id )
                one_exemplar.setmodel(meter_model)
                h1_exemplar.setmodel(meter_model)
                breadcrumb_exemplar.setmodel(meter_model)
              })
            }
          })
        })
      },
      
      
      
      
      
      
      
      vmeter_one : function( id ){
        require([
          'vmeters',
          'vmeter_one',
          'vmeter_h1',
          'vmeter_breadcrumb',
          'parameter_list',
          'conversion_list',
          'meter_datapicker',
          'meterparameter_list'
        ],function(
          vmeters,
          vmeter_one,
          vmeter_h1,
          vmeter_breadcrumb,
          parameter_list,
          conversion_list,
          meter_datapicker,
          meterparameter_list
        ){
          
          let one_exemplar        = new vmeter_one
          let h1_exemplar         = new vmeter_h1
          let breadcrumb_exemplar = new vmeter_breadcrumb
          
          vmeters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let vmeter_model = res.last()
              
              $(document).ready(function(){
                
                one_exemplar.setmodel(vmeter_model)
                h1_exemplar.setmodel(vmeter_model)
                breadcrumb_exemplar.setmodel(vmeter_model)
                
                new parameter_list()
                new conversion_list()
                new meterparameter_list(vmeter_model)
                new meter_datapicker()
                
              })
            }
          })
          
        })
      },
      
      
      
      converter : function(){
        require(['converter_list'],function(converter_list){
        })
      },
      
      
      converter_one : function( id ){
        require([
          'converters',
          'converter_one',
          'converter_h1',
          'converter_breadcrumb',
          'converter_children'
        ],function(
          converters,
          converter_one,
          converter_h1,
          converter_breadcrumb,
          converter_children
        ){
          
          let one_exemplar        = new converter_one
          let h1_exemplar         = new converter_h1
          let breadcrumb_exemplar = new converter_breadcrumb
          let children_exemplar   = new converter_children
          
          converters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( res ){
              
              let converter_model = res.last()
              
              $(document).ready(function(){
                
                one_exemplar.setmodel(converter_model)
                h1_exemplar.setmodel(converter_model)
                breadcrumb_exemplar.setmodel(converter_model)
                children_exemplar.setmodel(converter_model)
                
              })
            }
          })
          
        })
      },







      place: function() {
        this.place_one(0)
      },
      
      
      
      
      
      
      
      
      place_one: function(id) {
        
        var id = id || 0
        
        require([
          "places",
          "place_action",
          'place_h1',
          'place_breadcrumb',
          'place_block_info',
          "place_children",
          "place_meters"
        ],function(
          places,
          place_action,
          place_h1,
          place_breadcrumb,
          place_block_info,
          place_children,
          place_meters
        ){
          
          var skeleton = function( model ){
            $(document).ready(function(){
              new place_action( model )
              new place_h1( model )
              new place_breadcrumb( model )
              new place_block_info( model )
              new place_children( model )
              new place_meters( model )
            })
          }
          
          
          if( id ){
            places.fetch({
              data : {
                filter : "id:" + id
              },
              success : function( data ){
                var model = data.last()
                skeleton( model )
              }
            })
          }else{
            skeleton( new places.model )
          }
          
          
        })
        $(document).ready(function(){
          $('.short_add_place').removeAttr('href')
        })
      },
      
      
      
      
      
      
      place_files: function(id) {
        
        var id = id || 0
        
        require([
          'place_short_edit',
          'place_breadcrumb',
          'place_h1',
          'place_add_file',
          'places'
        ],function(
          place_short_edit,
          place_breadcrumb,
          place_h1,
          place_add_file,
          places
        ){
          
          places.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( data ){
              
              let model = data.last()
              
              $(document).ready(function(){
                new place_short_edit(model)
                new place_breadcrumb(model)
                new place_h1(model)
                new place_add_file(model)
              })
            }
          })
          
        })
        $(document).ready(function(){
          $('.short_add_place').removeAttr('href')
        })
      },
      
      
      
      
      
      
      
      
      
      place_reports: function(id) {
        
        var id = id || 0
        
        require([
          'place_short_edit',
          'place_breadcrumb',
          'place_h1',
          'places'
        ],function(
          place_short_edit,
          place_breadcrumb,
          place_h1,
          places
        ){
          
          places.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( data ){
              
              let model = data.last()
              
              $(document).ready(function(){
                new place_short_edit(model)
                new place_breadcrumb(model)
                new place_h1(model)
              })
            }
          })
          
        })
        $(document).ready(function(){
          $('.short_add_place').removeAttr('href')
        })
      },
      
      
      
      
      
      
      cconverter: function() {
        
        require([
          'cconverter_list'
        ],function(
          cconverter_list
        ){
          
          new cconverter_list();
          
        })
      },
      
      
      cconverter_one: function( id ) {
        
        require([
          'cconverter_one',
          'cconverter_h1',
          "cconverter_info",
          "cconverter_breadcrumb",
          "cconverters",
          "cconverter_meters"
        ],function(
          cconverter_one,
          cconverter_h1,
          cconverter_info,
          cconverter_breadcrumb,
          cconverters,
          cconverter_meters
        ){
          cconverters.fetch({
            data : {
              filter : "id:" + id
            },
            success : function( data ){
              new cconverter_one( data.last() );
              new cconverter_h1( data.last() );
              new cconverter_info( data.last() );
              new cconverter_breadcrumb( data.last() );
              new cconverter_meters( data.last() );
            }
          })
        })
      },
      
      
      
      
      
      
      
      place_page_tree : function( id ){
        require([
        'place_tree',
        'places'
        ],function(
        place_tree,
        places
        ){
          $(document).ready(function(){
            new place_tree( id )
            
          // Убираем все модальные окна если они есть
          // Это обработчик если клик был за пределами модального окна
          }).on('click' , '*' , function( e ){
            if( $('.modal_tree').length && !$(e.target).closest('.modal_tree').length ){
              $('.modal_tree').remove()
            }
          })
        })
      }


    });
    
    $('#CAPNAG, #CAPNAG_back').remove()
    
    var app_router = new AppRouter;
    Backbone.history.start({ root : '/' , pushState: true});
    
    
    requirejs([
      'main_menu'
    ] , function( 
      main_menu
    ){
      new main_menu()
    })

})
{/literal}