<div class="modal fade" 
      id="modal_children" 
      tabindex="-1" 
      role="dialog" 
      aria-labelledby="myModalLabel" 
      aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button 
                  type="button" 
                  class="close" 
                  data-dismiss="modal" 
                  aria-hidden="true">×</button>
                <h4 class="modal-title" id="myModalLabel">
                  Редактирование дочерних элементов
                </h4>
            </div>
            <div class="modal-body">
            </div>
            <div class="modal-footer">
                <button class="btn btn-success" id="add_child">Добавить</button>
                <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                <button type="button" class="btn btn-primary">Save changes</button>
            </div>
        </div>
    </div>
</div>


<!--
Контейнер для отображения всех дочерних элементов места
-->
<script type="text/template" id="block_children_item_place">
  <ul class="tree">
    <% _.each( children , function( item ){ %>
    <li class="tree_child" id="place_tree_item_<%= item.get('id') %>">
      
      <div class="btn-group">
          <button type="button" class="btn btn-default btn-xs dropdown-toggle" data-toggle="dropdown">
              <i class="fa fa-gear"></i>
              <span class="caret"></span>
          </button>
          <ul class="dropdown-menu" role="menu">
              <li>
                <a href="#" class="controller_add_child">
                  <i class="fa fa-plus"></i>
                  Добавить дочерний элемент
                </a>
              </li>
              <li>
                <a href="#" class="controller_edit_child">
                  <i class="fa fa-pencil"></i>
                  Редактировать
                </a>
              </li>
              <li class="divider"></li>
              <li>
                <a href="#" class="controller_delete">
                  <i class="fa fa-trash-o"></i> 
                  Удалить
                </a>
              </li>
          </ul>
      </div>
      
      <span><%= item.get('title') %></span>

      
      <% if( item.get('places_count') ){ %>
        <% view.renderChildren( item ); %>
      <% } %>
      
    </li>
    <% }) %>
  </ul>
  
</script>
