{extends file='layout/rule.layout.tpl'}
{block name='content'}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            Роль <a href="{$oLink->Rule->Link}">{$oLink->Rule->Title|escape}</a>
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">Главная</a></li>
            <li><a href="/rule/">{#rules#}</a></li>
            <li>
              {include file="rule/helpers/block_name.tpl" oRule=$oLink->Rule}
            </li>
            <li class="active">Удаление 
              {if $oLink->User->Type == 1}
                группы
              {else}
                пользователя
              {/if} 
              {include file="user/helpers/block_name.tpl" oUser=$oLink->User} из роли
            </li>
          </ol>
          
      </div>
  </div>
  
  <div class="row">
    <div class="col-lg-12">
      <h3 class="text-danger">
        Вы действительно хотите удалить 
        {include file="user/helpers/block_name.tpl" oUser=$oLink->User}
         из роли 
        {include file="rule/helpers/block_name.tpl" oRule=$oLink->Rule}
        ?</h3>
      
      <form method="post">
        <button type="button" class="btn btn-default">
          <a href="{$oLink->Rule->Link}">{#no#}</a>
        </button>
        <button type="submit" name="droped" value="{$oLink->Id}" class="btn btn-danger">{#yes#}</button>
      </form>
    </div>
  </div>
  
{/block}