{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Log"}
{else}
  {config_load file="ru_lang.conf" section="Log"}
{/if}
{extends file="layout/group.layout.tpl"}
{block name="content"}
  <div class="container-fluid">
    <div class="row">
      <div class="col-lg-12">
          
          {if $Site->SysLogByPage->Count}

            {include file="helpers/pagination.tpl" Pages=$Site->SysLogByPagePages}
            
            <ul class="milestones">
              {foreach from=$Site->SysLogByPage->Elements item="iLog"}
                  <li>
                    <i class="milestone-info fa fa-comment"></i>
                    <p>
                      {include file="converter/helpers/block_name.tpl" oConverter=$iLog->ObjecttoObj->Converter}<br>
                      {include file="meter/helpers/block_name.tpl" oMeter=$iLog->ObjecttoObj}
                      <span class="pull-right text-muted small">
                        <em>
                          {$iLog->Its|date_format:"%Y-%m-%d %H:%I:%S (%A)"}  #{$iLog->Id}
                        </em>
                      </span>
                    </p>
                    <p>
                      <pre>{$iLog->Action}</pre>
                    <p>
                  </li>
              {/foreach}
            </ul>

            {include file="helpers/pagination.tpl" Pages=$Site->SysLogByPagePages}

          {else}
            <h3>{$smarty.config.no_logs|default:"Еще ничего не происходило."}</h3>
          {/if}
          
      </div>
    </div>
  </div>
  
  
  
{literal}
  <script>
    $.document.ready(function(){
      $(".spoiler-trigger").click(function() {
        $(this).next().collapse('toggle');
      });
    })
  </script>
{/literal}

{/block}