<div class="panel-body">
          
  <div class="table-responsive">

      <table class="container_converter_meters table table-striped table-bordered table-hover" id="converter_meters_3">
        <thead>
          <% if( my_meters.length == 0 ){ %>
          <tr>
            <td>
              {$smarty.config.table_child_no_items|default:"Нет приборов учета"}
            </td>
          </tr>
          <% }else{ %>
            <tr>
              {if $Self->IsAdmin}
                <th></th>
                <th></th>
              {/if}
              <th>{$smarty.config.table_child_title|default:"Название"}</th>
              <th>{$smarty.config.table_child_serial|default:"Серийный номер"}</th>
              <th>{$smarty.config.table_child_type|default:"Тип прибора"}</th>
            </tr>
          <% } %>
        </thead>
        <tbody>
          <% _.each( my_meters , function( device ){ %> 
            <tr id="<%= device.cid %>">
              {if $Self->IsAdmin}
                <td class="action converter_meter_delete">
                  <a href="" class="fa fa-times"></a>
                </td>
                <td class="action converter_meter_edit">
                  <a href="" class="fa fa-pencil"></a>
                </td>
              {/if}
              <td>
                <a href="<%= device.get('link') %>"><%= device.escape('about') %></a>
              </td>
              <td>
                <%= device.get('num_serial') %>
              </td>
              <td>
                <% if( typeof types.find({ id : Number( device.get('type') ) }) != "undefined" ){ %>
                  <%= types.find({ id : Number( device.get('type') ) }).get('title') %>
                <% } %>
              </td>
            </tr>
          <% }) %>
        </tbody>
        {if $Self->IsAdmin}
          <tfoot>
            <tr>
              <td class="action" colspan="100" id="lora_add_meter">
                <a href="/converter/3/addmeter/"  class="fa fa-plus-circle"></a>
              </td>
            </tr>
          </tfoot>
        {/if}
      </table>
  </div>
  <div class="row">
    <div class="col-lg-12">
      <ul class="pagination paginator_counter pull-right">
        <li class="disabled">
          <a>{$smarty.config.view_by|default:"Показывать по"} :</a>
        </li>
        <li class="active">
          <a href="?count=10">10</a>
        </li>
        <li>
          <a href="?count=50">50</a>
        </li>
        <li>
          <a href="?count=100">100</a>
        </li>
        <li>
          <a href="?count=500">500</a>
        </li>
        <li>
          <a href="?count=1000">1000</a>
        </li>
        <li>
          <a href="?count=all">{$smarty.config.all|default:"Все"}</a>
        </li>

      </ul>
    </div>
  </div>

</div>