{extends file="layout/mail.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.mail|default:"Письма"}
          </h1>
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$smarty.config.mail|default:"Письма"}</li>
          </ol>
      </div>
  </div>
            
  <div class="row">
      <div class="col-lg-12">
        
        <div class="panel panel-default">
          
          <div class="panel-heading">
            {$smarty.config.table_mail_templates_head|default:"Список шаблонов для отправки почтовых уведомлений"}
          </div>
          <div class="panel-body">
  
            <table class="table table-striped table-bordered table-hover" id="mail_list">
              <thead>
              {include file="mail/helpers/list_head.tpl"}
              </thead>
              <tbody>
                {foreach from=$Site->MailsByPage->Elements item=iMail}
                    {include file="mail/helpers/list_item.tpl"}
                {/foreach}
              </tbody>
              {if $Self->IsAdmin}
              <tfoot>
                <tr>
                  <td class="action" id="add_mail_modal">
                    <a href="/mail/add/" class="fa fa-plus-circle "></a>
                  </td>
                </tr>
              </tfoot>
              {/if}
            </table>

            {include file="helpers/pagination.tpl" Pages=$Site->GetPagesMail()}
          </div>
        </div>
      </div>
  </div>
  
{/block}