{if $user_lang eq 'ru'}
  {config_load file="ru_lang.conf" section="Menu"}
{else}
  {config_load file="en_lang.conf" section="Menu"}
{/if}
<nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
  <div class="navbar-header">
      {*
      <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
          <span class="sr-only">Toggle navigation</span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
          <span class="icon-bar"></span>
      </button>
      *}
        <a href="/place/">
          <img class="navbar-brand" src="{$Self->Interprise->GetLogo()}" style="padding: 5px 15px"/>
        </a>
  </div>
  
  <ul class="nav navbar-top-links navbar-right">
    
    <li>{$Self->Title|default:"Гость"}
      {if $Self->IsRoot && $Self->IsMask}
        [<i class="glyphicon glyphicon-sunglasses"></i>
        {$Self->MaskUser->Title}]
      {/if}
    </li>
    
    {if $Self->IsRoot}
    <li>
      <a class="dropdown-toggle" data-toggle="dropdown">
        <i class="fa fa-cog fa-fw"></i> 
        {$smarty.config.admin_panel|default:"Админка"}
      </a>
      <ul class="dropdown-menu dropdown-tasks">
        <li>
          <a>{$smarty.config.admin_global_settings|default:"Глобальные настройки"}</a>
          <ul>
            <li>
              <a>
                <button class="btn 
                btn-{if $Site->Config('is_demo')}danger{else}success{/if} btn-xs is_demo" 
                id="config_{$Site->ConfigFind("is_demo")->Id}">
                {if $Site->Config('is_demo')}                  
                  {$smarty.config.admin_turn_off|default:"Выкл"}.
                {else}
                  {$smarty.config.admin_turn_on|default:"Вкл"}.
                {/if}
                </button></a> {$smarty.config.admin_demo_access|default:"Демо доступ"}
            </li>
            <li>
              <a>
                <button class="btn 
                  btn-{if $Site->Config('is_forgot')}danger{else}success{/if} btn-xs is_forgot" 
                  id="config_{$Site->ConfigFind("is_forgot")->Id}">
                  {if $Site->Config('is_forgot')}
                    {$smarty.config.admin_turn_off|default:"Выкл"}.
                  {else}
                    {$smarty.config.admin_turn_on|default:"Вкл"}.
                  {/if}</button></a> {$smarty.config.admin_remind_password|default:"Напомнить пароль"}
              
            </li>
            {*
            <li>
              <a>
                Постраницная навигация
              </a>
            </li>
            *}
            <li>
              <a href="/config/">
                {$smarty.config.admin_titles|default:"Названия"}
              </a>
            </li>
            <li>
              <a href="/config/icon/">
                {$smarty.config.admin_icons|default:"Иконки"}
              </a>
            </li>
          </ul>
        </li>
        <li>
          <a>{$smarty.config.admin_meters|default:"Приборы учета"}</a>
          <ul>
            <li>
              <a href="/config/settings_energy.php">
                {$smarty.config.admin_voltage_settings|default:"Настройка включения напряжения"}
              </a>
            </li>
            <li>
              <a href="/rootpanel/meter/settings_add.php">
                {$smarty.config.admin_tips_settings|default:"Настройка подсказок"}
              </a>
            </li>
          </ul>
        </li>
        <li>
          <a>{$smarty.config.admin_converters|default:"Конверторы"}</a>
          <ul>
            <li>
              <a href="/rootpanel/converter/settings_add.php">
                {$smarty.config.admin_tips_settings|default:"Настройка подсказок"}
              </a>
            </li>
          </ul>
        </li>
        <li>
          <a>{$smarty.config.admin_system|default:"Система"}</a>
          <ul>
            {*
            <li>
              <a href="">
                Ошибки
              </a>
            </li>
            *}
            <li>
              <a id="admin_mask{if $Self->IsMask}_disable{/if}" data-config-id="{$Site->ConfigFind('root.mask')->Id}">
                <i class="glyphicon glyphicon-sunglasses"></i>
                {if $Self->IsMask}
                  {$smarty.config.admin_mask_off|default:"Размаскироваться"}
                {else}
                  {$smarty.config.admin_mask_on|default:"Замаскироваться"}
                {/if}
              </a>
            </li>
            {*
            <li>
              <a href="/dump/">
                <i class="fa fa-database"></i> 
                Дамп
              </a>
            </li>
            <li>
              <a href="/install/">
                <i class="fa fa-database"></i> 
                Залить дамп
              </a>
            </li>
            *}
            <li>
              <a href="/timediff/">
                <i class="glyphicon glyphicon-time"></i> 
                {$smarty.config.admin_time_diff|default:"Разница хода часов"}
              </a>
            </li>
            <li title="{$smarty.config.system_tasks|default:"Задания системы"}">
              <a href="/tasks/">
                <i class="fa fa-tasks"></i> 
                {$smarty.config.system_tasks|default:"Задания системы"}
              </a>
            </li>
            <li>
              <a href="/install/libso/">
                <i class="fa fa-link"></i> 
                {$smarty.config.admin_devices_param|default:"Параметры у приборов"}
              </a>
            </li>
          </ul>
        </li>
      </ul>
    </li>
    
    {/if}
    
    
    <!-- /.dropdown -->
    <li class="dropdown"  title="{$smarty.config.system_tasks|default:"Задания системы"}">
        <a class="dropdown-toggle" data-toggle="dropdown" id="tasks_menu_toogle">
            <i class="fa fa-tasks fa-fw"></i> <i class="fa fa-caret-down"></i>
        </a>
        <ul class="dropdown-menu dropdown-tasks">
            <li>
                <a href="#">
                    <div>
                      
                      
                      {assign var="TaskWaiting" value=$Site->TaskWaiting->Count }
                      {assign var="TaskRunning" value=$Site->TaskRunning->Count }
                      {assign var="TaskArchived" value=$Site->TaskArchived->Count }
                      
                      {math   
                        equation="x + y + z" 
                        x=$TaskWaiting
                        y=$TaskRunning
                        z=$TaskArchived
                        assign="totalTask"}
                        
                        
                        <p>
                            <strong>{$smarty.config.system_tasks|default:"Задания системы"}</strong>
                              
                            
                            {if !$totalTask}
                              {assign var=procWaiting value=0}
                              {assign var=procArchived value=0}
                              {assign var=procRunning value=0}
                            {else}
                            {math   
                                equation="100/y*x" 
                                x=$TaskWaiting 
                                y=$totalTask 
                                assign="procWaiting"}
                              {math   
                                equation="100/y*x" 
                                x=$TaskRunning
                                y=$totalTask 
                                assign="procArchived"}
                                {assign var=procArchived value=$procArchived|intval}
                              {assign var=procWaiting value=$procWaiting|intval}
                              {math   
                                equation="100-x-z" 
                                x=$procWaiting  
                                z=$procArchived  
                                assign="procRunning"}
                            {/if}
                              
                            
                            <p class="text-primary">{$procWaiting}% {$smarty.config.waiting|default:"Ожидает"}</p>
                            <p class="text-warning">{$procRunning}% {$smarty.config.running|default:"Выполняется"}</p>
                            <p class="text-success">{$procArchived}% {$smarty.config.created|default:"Выполнено"}</p>
                        </p>
                        <div class="progress progress-striped active">
                          
                            <div 
                              class="progress-bar progress-bar" 
                              role="progressbar" 
                              aria-valuenow="{$procWaiting}" 
                              aria-valuemin="0" 
                              aria-valuemax="100" 
                              style="width: {$procWaiting}%">
                            </div>
                            <div 
                              class="progress-bar progress-bar-warning" 
                              role="progressbar" 
                              aria-valuenow="{$procRunning}" 
                              aria-valuemin="0" 
                              aria-valuemax="100" 
                              style="width: {$procRunning}%">
                            </div>
                            <div 
                              class="progress-bar progress-bar-success" 
                              role="progressbar" 
                              aria-valuenow="{$procArchived}" 
                              aria-valuemin="0" 
                              aria-valuemax="100" 
                              style="width: {$procArchived}%">
                            </div>
                        </div>
                        <p>{$smarty.config.created|default:"Выполнено"} : {$totalTask}</p>
                    </div>
                </a>
            </li>
            <li class="divider"></li>
            <li>
                <a class="text-center" href="/task/">
                    <strong>{$smarty.config.show_details|default:"Посмотреть детально"}</strong>
                    <i class="fa fa-angle-right"></i>
                </a>
            </li>
        </ul>
        <!-- /.dropdown-tasks -->
    </li>
    
    
    
    
    
    
    
    <li class="dropdown 
      {if isset( $Menu ) && $ActiveMenu != null && $ActiveMenu == $Menu.index} 
        active
      {/if}">
        <a class="dropdown-toggle" data-toggle="dropdown" id="settings_menu_toogle">
            <i class="fa fa-cog fa-fw"></i> <i class="fa fa-caret-down"></i>
        </a>
        <ul class="dropdown-menu dropdown-tasks">
            <li>
              <a href="/settings/logo/">
                <i class="fa fa-cog fa-fw"></i> 
                {$smarty.config.logs_settings|default:"Настройка логотипов"}
              </a>
            </li>
            <li>
              <a href="/rsconfig/">
                <i class="fa fa-cog fa-fw"></i> 
                {$smarty.config.rsc_configurator|default:"Конфигуратор RScounter"}
              </a>
            </li>
            <li>
              <a class="dropdown-toggle" href="/mail/">
                  <i class="{$Site->Config('icon.mail')} fa-fw"></i>
                  {$smarty.config.mail_notif|default:"Почтовые уведомления"}
              </a>
            </li>
            <li>
              <a href="/archive/" id="menu_item_archive">
                <i class="fa fa-archive fa-fw"></i>{$smarty.config.archives|default:"Архивы"}
              </a>
            </li>
            {if $Self->IsAdmin}
              <li>
                <a href="/user/">
                  <i class="{$Site->Config('icon.user')} fa-fw"></i> 
                  {$smarty.config.users|default:"Пользователи"}
                </a>
              </li>
            {/if}
        </ul>
    </li>
    
    <!-- /.set language -->
    <li class="dropdown">
        <a class="dropdown-toggle" data-toggle="dropdown" id="settings_menu_toogle">
            <i class="glyphicon glyphicon-globe"></i> <i class="fa fa-caret-down"></i>
        </a>
        <ul class="dropdown-menu dropdown-tasks">
            <li>
              <a href="/set_lang?lang=ru" id="set_lang_ru">
                RU {$smarty.config.ru_lang|default:"Русский"}
              </a>
            </li>
            <li>
              <a href="/set_lang?lang=en" id="set_lang_en">
                EN {$smarty.config.en_lang|default:"Английский"}
              </a>
            </li>
        </ul>
    </li>
    <!-- /.set language -->
    
    
    <!-- /.dropdown -->
    <li class="dropdown">
        <a class="dropdown-toggle" data-toggle="dropdown" id="user_menu_toogle">
            <i class="fa fa-user fa-fw"></i> <i class="fa fa-caret-down"></i>
        </a>
        <ul class="dropdown-menu dropdown-user">
            <li>
              <a href="{$Self->LinkEdit}">
                <i class="fa fa-cog fa-fw"></i> 
                {$smarty.config.user_settings|default:"Настройки пользователя"}
              </a>
            </li>
            <li>
              <a href="{$Self->LinkLog}">
                <i class="fa fa-history fa-fw"></i> 
                {$smarty.config.history|default:"История"}
              </a>
            </li>
            {*
            <li>
              <a href="/group/">
                <i class="{$Site->Config('icon.group')} fa-fw"></i> 
                {$Site->Config('ru.group')}
              </a>
            </li>
            <li>
              <a href="/rule/">
                <i class="{$Site->Config('icon.rule')} fa-fw"></i> 
                {$Site->Config('ru.rule')}
              </a>
            </li>
            *}
            <li class="divider"></li>
            <li>
              <a href="/logout/">
                <i class="{$Site->Config('icon.sys.logout')} fa-fw"></i> 
                {$smarty.config.logout|default:"Выход"}
              </a>
            </li>
        </ul>
        <!-- /.dropdown-user -->
    </li>
    <!-- /.dropdown -->
</ul>
  <div class="navbar-default sidebar" role="navigation">
    <div class="sidebar-nav navbar-collapse">
      <ul class="nav" id="side-menu">
        {include file="menu_item/index.tpl"}
      </ul>
      <br>
      <p class="text-center">
        v {$Site->GetVersionTxt()}
      </p>
    </div>
  </div>
</nav>
