{extends file="layout/meter.layout.tpl"}
{block name="content"}
  
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {if isset( $oMeter )}
              {$smarty.config.modal_head_edit|default:"Редактирование"} {include file="meter/helpers/block_name.tpl" oMeter=$oMeter}
            {elseif isset($oConverter)}
              {$smarty.config.add_meter_into|default:"Добавление прибора учета в"} {include file="converter/helpers/block_name.tpl" oConverter=$oConverter}
            {/if}
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            {if isset($oConverter)}
              <li><a href="/converter/">{#converter#}</a></li>
              <li>
                {include file="converter/helpers/block_name.tpl" oConverter=$oConverter}
              </li>
            {elseif isset($oMeter)}
              <li><a href="{$oMeter->Converter->Link}">{$oMeter->Converter->Title|escape}</a></li>
            {/if}
            <li class="active">
              {if isset( $oMeter )}
                {$smarty.config.modal_head_edit|default:"Редактирование"} {$oMeter->Title|escape}
              {else}
                {$smarty.config.modal_head_add|default:"Добавление прибора учета"}
              {/if}
            </li>
          </ol>
          
      </div>
  </div>
  
  
  <div class="row">
    <div class="col-lg-12">
      <form method="post" role="form">
        {include file="meter/helpers/add_edit_form.tpl"}
        <button type="submit" class="btn btn-default">{$smarty.config.add_button|default:"Добавить"}</button>
      </form>
    </div>
</div>
{/block}
