{if $oMeter->ActiveParametersData->Elements|@count}
  
  <br>
  {include file="meter/helpers/export_list.tpl" step="hours"}
  

  <div class="table-responsive" id="meter_data">
    <table class="table table-striped table-bordered table-hover" id="tablesorter">

      <thead>
        {include file="parameter/head.tpl" HeadRows=$ParameterHead}
      </thead>
      <tbody>
        {foreach from=$oMeter->GetDateHoursList() item=iDate}
          {if $iDate->format('H') == "00"}
            <tr>
              
              <td colspan='100' class="text-center">
                {$iDate->getTimestamp()|date_format:"%d %B"}
              </td>
              
            </tr>
          {/if}


          <tr>
            {if $Self->IsAdmin}
            <td class="action"></td>
            {/if}

            <td style="white-space:nowrap;">
              {$iDate->getTimestamp()|date_format:"%custom_hour"}
            </td>

            {foreach from=$oMeter->ActiveParametersData->Elements item="iParameter"}
                {assign var=oMDH value=$oMeter->GetMDHHours($iParameter,$iDate)}
              {if $iParameter->UseCoef && $oMeter->Coef > 1}
              <td>
                {if is_object($oMDH)}
                  {include file="meterdatahour/helpers/meter_format.tpl" oMDH=$oMDH usingCoef=true}
                {else}
                  {$oMDH}
                {/if}
              </td>
              {else}
              <td style="white-space:nowrap;">
                {if is_object($oMDH)}
                  {include file="meterdatahour/helpers/meter_format.tpl" oMDH=$oMDH}
                {else}
                  {$oMDH}
                {/if}
              </td>
              {/if}
            {/foreach}
          </tr>
        {/foreach}
      </tbody>
    </table>
    </div>
  {else}
    <div class="alert alert-warning">Нет парнаметров</div>
  {/if}