<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
        <h4 class="modal-title" id="myModalLabel">
          <% if( meter.get('id') ){ %>
            Редактирование прибора учета
          <% }else{ %>
            Добавление приборпа учета
          <% } %>
        </h4>
      </div>
      <div class="modal-body">


        <div class="form-group">
          <label class="control-label">
           Конвертер<sup>*</sup>
          </label>
          <% if( meter.get('converter') ){ %>
            <a href="/converter/<%= meter.get('converter') %>/">
              <%= meter.get('converter_about') %>
            </a>
          <% }else{ %>
            <select class="form-control" id="converter" <% if(meter.get('id')){ %>disabled<% } %>>
             <% _.each( converters.toArray() , function( converter ){ %>
              <option value="<%= converter.get('id') %>" <% if( meter.get('converter') == converter.get('id') ){ %>selected<% } %>><%= converter.get('title') %></option>
            <% }) %>
          </select>
          <% } %>
        </div>

        <div class="form-group">
          <label class="control-label">
            Марка прибора<sup>*</sup>
          </label>
          <select class="form-control" id="meter_type" <% if(meter.get('id')){ %>disabled<% } %>>
            <% _.each( marks.toArray() , function( mark ){ %>
              <option value="<%= mark.get('id') %>" <% if( change_mark.get('id') == mark.get('id') ){ %>selected<% } %>><%= mark.get('title') %></option>
            <% }) %>
          </select>
        </div>    


         <div class="form-group">
          <label class="control-label">
            Модель<sup>*</sup>
          </label>
          <select class="form-control" id="models_select"></select>
        </div>

        <div class="form-group">
          <label class="control-label">
            Название<sup>*</sup>          
          </label>

          <input class="form-control" type="text" id="about" value="<%= meter.get('about') %>" />
        </div>

        <div class="form-group">
          <label class="control-label">
            Серийный номер устройства<sup>*</sup>          
          </label>

          <input class="form-control" type="text" id="num_serial"/>
        </div>

        <div class="form-group">
          <label class="control-label">
            Номер на шине<sup>*</sup>          
          </label>

          <input class="form-control" type="text" id="num_485" value="<%= meter.get('num_485') %>"/>
        </div>

        <br>

        <a class="more_settings_controller">
          Расширенные настройки <i class="fa-chevron-circle-down fa fa-wf"></i> 
        </a>


        <div class="more_settings hide">

          <div class="form-group">
            <label class="control-label">
              Пароль для доступа          
            </label>

            <input class="form-control" id="password" type="text" value="<%= meter.get('password') %>" >
          </div>  



          <div class="form-group">
            <label class="control-label">
              Коэффициент учета          
            </label>

            <input class="form-control" id="coef" type="text" value="<%= meter.get('coef') %>">
          </div>  



          <div class="form-group">
            <label class="control-label">
              Часовой пояс          
            </label>

            <select size="1" class="form-control" id="timezone_id">
              <option value="0">- Выбор -</option>
              <option value="1">UTC+00:00</option>
              <option value="2">UTC+01:00</option>
              <option value="3">UTC+02:00</option>
              <option value="4">UTC+03:00</option>
              <option value="5">UTC+04:00</option>
              <option value="6" selected="selected">UTC+05:00</option>
              <option value="7">UTC+06:00</option>
              <option value="8">UTC+07:00</option>
              <option value="9">UTC+08:00</option>
              <option value="10">UTC+10:00</option>
              <option value="11">UTC+11:00</option>
              <option value="12">UTC+11:00</option>
              <option value="13">UTC+12:00</option>

            </select>
          </div>  


          <label class="control-label">Дата первичной поверки</label>
          <div class="form-group">
            <input type="date" class="form-control" id="first_date_verification" value="<%= meter.get('first_date_verification') %>" >
          </div>

          <label class="control-label">Интервал поверок (мес)</label>
          <div class="form-group">
            <input type="number"  class="form-control" id="interval_verification" value="<%= meter.get('interval_verification') %>">
          </div>



          <label class="control-label">Номер пломбы</label>
          <div class="form-group">
            <input type="text" class="form-control" id="number_plomb" value="<%= meter.get('number_plomb') %>">
          </div>


          <div class=" form-group ">

            <label class="control-label">
              Исключено из опроса          
            </label>
            <label class="label toggle">
              <input type="checkbox" class="toggle_input" id="is_excluded">
              <div class="toggle-control"></div>
            </label>
          </div>  



        </div>


      </div>
      <div class="modal-footer">
        <button type="button" class="btn btn-default" data-dismiss="modal">
          {$Site->Config('ru.sys.close')}
        </button>
        <button type="button" class="btn btn-disabled" id="save_meter">
          {$Site->Config('ru.sys.save')}
        </button>
      </div>
    </div>
    <!-- /.modal-content -->
  </div>
  <!-- /.modal-dialog -->
</div>