{if $oMeter->IsLora}
  {assign var=layout value="layout/lora.layout.tpl"}
{else}
  {assign var=layout value="layout/meter.layout.tpl"}
{/if}
{extends file=$layout}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.meter_device|default:"Прибор учета"} <span class="container_h1_meter">{$oMeter->Title|escape}</span> 
            {include file="helpers/log_btn.tpl" oObject=$oMeter}
          </h1>
          
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li>
              {include file="converter/helpers/block_name.tpl" oConverter=$oMeter->Converter}
            </li>
            <li class="active">{$oMeter->Title|escape}</li>
          </ol>
          
      </div>
  </div>
  
  {include file="meter/helpers/main_info.tpl"}
  <script>
    var data_picker_per_month = "{$smarty.config.data_picker_per_month|default:'За месяц'}";
    var data_picker_per_year = "{$smarty.config.data_picker_per_year|default:'За год'}";
    var data_picker_manual = "{$smarty.config.data_picker_manual|default:'Вручную'}";
    var data_picker_apply = "{$smarty.config.data_picker_apply|default:'Применить'}";
    var data_picker_close = "{$smarty.config.data_picker_close|default:'Закрыть'}";
    var data_picker_from = "{$smarty.config.data_picker_from|default:'От'}";
    var data_picker_to = "{$smarty.config.data_picker_to|default:'До'}";
    var data_picker_day = [
      "{$smarty.config.data_picker_day_7|default:'Вс'}",
      "{$smarty.config.data_picker_day_1|default:'Пн'}",
      "{$smarty.config.data_picker_day_2|default:'Вт'}",
      "{$smarty.config.data_picker_day_3|default:'Ср'}",
      "{$smarty.config.data_picker_day_4|default:'Чт'}",
      "{$smarty.config.data_picker_day_5|default:'Пт'}",
      "{$smarty.config.data_picker_day_6|default:'Сб'}"      
    ];
    var data_picker_month = [
      "{$smarty.config.data_picker_month_1|default:'Январь'}",
      "{$smarty.config.data_picker_month_2|default:'Февраль'}",
      "{$smarty.config.data_picker_month_3|default:'Март'}",
      "{$smarty.config.data_picker_month_4|default:'Апрель'}",
      "{$smarty.config.data_picker_month_5|default:'Май'}",
      "{$smarty.config.data_picker_month_6|default:'Июнь'}",
      "{$smarty.config.data_picker_month_7|default:'Июль'}",
      "{$smarty.config.data_picker_month_8|default:'Август'}",
      "{$smarty.config.data_picker_month_9|default:'Сентябрь'}",
      "{$smarty.config.data_picker_month_10|default:'Октябрь'}",
      "{$smarty.config.data_picker_month_11|default:'Ноябрь'}",
      "{$smarty.config.data_picker_month_12|default:'Декабрь'}"
    ];
  </script>
  {include file="meter/helpers/tabs.tpl" Active_tab="values"}
  
  <br>
  <div class="row">
    <div class="col-lg-12">
      {include file="meter/helpers/navigation_date.tpl"}
      <div class="panel panel-default">
        <div class="panel-heading">
          {$smarty.config.meter_tabs_data|default:"Данные"}
          {if $Self->isAdmin}
            {include file="meter/helpers/edit_table_data_parameters.tpl"}
          {/if}
        </div>
        <div class="panel-body" id="meter_data">
          {include file="meter/helpers/data.tpl"}
        </div>
      </div>
    </div>
  </div>
{/block}
