{function name=children_tr}
  {include file="place/helpers/children_item.tpl" iObject=$iPlace}
{/function}


{function name=children_null}
  <tr>
    <td>{$Site->Config('ru.place.not_children','Нет дочерних элементов')}</td>
  </tr>
{/function}

{function name=children_add}
  {if $oPlace|gettype == 'NULL'}
    {assign var=oPlace value=$Site->GetEmpty('place')}
  {/if}
  <tr>
    <td class="action" id="add_place_modal">
      <a href="{$oPlace->LinkAdd}" class=" fa fa-plus-circle"></a>
    </td>
  </tr>
{/function}

<div class="panel panel-default">
  <div class="panel-heading">
    {$smarty.config.accounting_objects|default:"Объекты учета"}
  </div>
  <div class="panel-body">

    <div class="dataTables_wrapper form-inline dt-bootstrap no-footer" id="place_children_container">

      <div class="table-responsive" id="place_children_table">

        {* !!!!! *}
        {if $Self->Interprise->Id != 124}

          <table class="table table-striped">
            {include file="place/helpers/children_thead.tpl" oPlace=$oPlace}
            <tbody>
              {foreach from=$oPlace->GetChildrenByPage()->Elements item="iPlace" key=i}
                {children_tr $iPlace}
              {/foreach}
            </tbody>
            {if $Self->IsAdmin}
              <tfoot>
                <tr>
                  <td class="action add_child">
                    <a href="{$oPlace->Link}add/" class="fa fa-plus-circle "></a>
                  </td>
                </tr>
              </tfoot>
            {/if}
          </table>


        {/if}
        {* !!!!! *}

      </div>
    </div>
    {if $Self->Interprise->Id == 124}
    <div class="children_pagination">
        <div class="row">
        <div class="col-lg-12" id="pagination_children_place"></div>
      </div>
    </div>
    {else}
      {include file="place/helpers/children_pagination.tpl"}
    {/if}
  </div>
</div>