{function name=children_tr}
  {include file="place/helpers/children_item.tpl" iObject=$iPlace}
{/function}


{function name=children_null}
  <tr>
    <td>{$Site->Config('ru.place.not_children','Нет дочерних элементов')}</td>
  </tr>
{/function}

{function name=children_add}
  {if $oPlace|gettype == 'NULL'}
    {assign var=oPlace value=$Site->GetEmpty('place')}
  {/if}
  <tr>
    <td class="action" id="add_place_modal">
      <a href="{$oPlace->LinkAdd}" class=" fa fa-plus-circle"></a>
    </td>
  </tr>
{/function}

<div class="panel panel-default">
  <div class="panel-heading">
    {$Site->Config('ru.place.children')}
  </div>
  <div class="panel-body">
    <div class="dataTables_wrapper form-inline dt-bootstrap no-footer" id="place_children_table"></div>
    <div class="children_pagination">
      {include file="place/helpers/children_pagination.tpl"}
    </div>
  </div>
</div>

<script type="text/template" id="table_children_v2">
  <div class="table-responsive">
    <table class="table table-striped">

      <thead>
        <% if( places.length == 0 ){ %> 
          <tr>
            <td>{$Site->Config('ru.place.not_children','Нет дочерних элементов')}</td>
          </tr>
        <% }else{ %>
          {if $Self->IsAdmin}
            <th class="action"></th>
            <th class="action"></th>
          {/if}
          <th>{$Site->Config('ru.place.title')}</th>
          <th>{$Site->Config('ru.place.children')}</th>
          <th colspan="3">{$Site->Config('ru.place.meters')}</th>
        <% } %>
      </thead>
      <tbody>
        {literal}
        <% _.each( places , function( place ){ %>
          <tr>
            <tr id="<%= place.cid %>">
                <td class="action children_delete">
                <a class="<%= class_del(place) %> fa fa-times " alt="delete"></a>
              </td>
              <td class="action children_edit">
                <a class="fa fa-pencil " alt="edit"></a>
              </td>
                <td>
                <a href="/place/<%= place.get('id') %>/" class="link_to_place">
                  <i class="fa fa-map-marker"></i>
                <span><%= place.get('title') %></span>
            </a>

              </td>
              <td>
                <i class="fa fa-map-marker"></i>
                <span class="counter_places"><%= place.get('places_all') %></span>
              </td>
              <td class="short_add_meter_to_place">
                <i class="fa fa-flash"></i>
                <span class="counter_meters">
                  <%= place.get('device_all') %>
                </span>
              </td>
              <td title="С ошибками">
                <i class="text-danger fa fa-flash"></i>
                <span><%= place.get('device_err') %></span>
              </td>
              <td title="Исключенные">
                <i class="text-muted fa fa-flash"></i>
                <span><%= place.get('device_excluded') %></span>
              </td>
            </tr>
          </tr>
        <% }) %>
        {/literal}
      </tbody>
      {if $Self->IsAdmin}
        <tfoot>
          <tr>
            <td class="action add_child">
              <a href="{$oPlace->Link}add/" class="fa fa-plus-circle "></a>
            </td>
          </tr>
        </tfoot>
      {/if}
    </table>
  </div>
</script>