{include file="place/helpers/filter_by_type.tpl"}

<br>

<div class="panel panel-default">
    <div class="panel-heading">
      {$smarty.config.data|default:"Данные"}
    </div>
    <div class="panel-body">
      
        {if $oPlace->MeterPlaceByPage->Elements|count}
          {include file="place/helpers/navigation_date.tpl"}
        {/if}
        
        
        <div class="table-responsive">
          {assign var="LastPlaceId" value=0}
          {assign var="LastMeterId" value=0}

          <table class="table table-striped table-bordered table-hover" id="tableplacelist">
              {include file="parameter/head.tpl" HeadRows=$ParameterHead}
            <tbody>
              
              
              {foreach from=$oPlace->MeterPlaceByPage->Elements item=iMeterPlace}
              
              
              
                {if $LastPlaceId != $iMeterPlace.Place->Id}
                  {assign var="LastPlaceId" value=$iMeterPlace.Place->Id}
                
                  <tr class="info">
                    <td colspan="1000">
                      {foreach from=$iMeterPlace.Place->ParentAll->Elements item=iPlace}
                        {include file="place/helpers/block_name.tpl" oPlace=$iPlace} / 
                      {/foreach}
                      {include file="place/helpers/block_name.tpl" oPlace=$iMeterPlace.Place}
                    </td>
                  </tr>
                {/if}
              
                <tr>
                  <td>
                    
                    {assign var="Meter" value=$iMeterPlace.Meter}
                    {assign var="prefix" value=""}
                    {if $Meter->IsVirtual}
                      {assign var="prefix" value="v"}
                    {elseif $Meter->IsCalc}
                      {assign var="prefix" value="c"}
                    {/if}
                    {assign var="file" value=$prefix|cat:"meter/helpers/block_name.tpl"}
                    {include file=$file oMeter=$Meter}
                  </td>
                  <td>
                    {$Meter->NumSerial}
                  </td>
                  
                  {foreach from=$oPlace->ActiveParametersData->Elements item=iParameter}
                  
                    {assign var="MDH" value=$oPlace->GetArchive($iParameter,$iMeterPlace.Meter)}
                    {if $iParameter->UseCoef}
                    <td>
                      {include file="meterdatahour/helpers/place_format.tpl" oMDH=$MDH usingCoef=true}
                    </td>
                    {else}
                    <td>
                      {include file="meterdatahour/helpers/place_format.tpl" oMDH=$MDH}
                    </td>
                    {/if}
                    
                  {/foreach}
                  
                </tr>
              {foreachelse}
                <tr>
                  <td>
                    {$smarty.config.empty_meters|default:"Нет приборов учета"}
                  </td>
                </tr>
              {/foreach}
              
            </tbody>
          </table>
        </div>
        {if $oPlace->MeterPlaceByPage->Elements|count}
          {include file="helpers/pagination.tpl" Pages=$oPlace->PaginatorArchive}
        {/if}
        
    </div>
</div>