<div class="panel panel-default">
    <div class="panel-heading">
        {$smarty.config.common_info_table|default:"Общая информация"}
    </div>
    <div class="panel-body">
      <table class="table table-striped table-hover" id="place_item_info">
        <tbody>
            <tr>
                <td>{$smarty.config.place_name|default:"Название"}</td>
                <td class="container_place_name">{$oPlace->Title|default:$Self->Interprise->Title|escape}</td>
            </tr>
            <tr>
                <td>{$smarty.config.count_places|default:"Объектов"}</td>
                <td>
                  {if !$oPlace->Id}
                    {$Site->GetPlaces()->Count}
                  {else}
                    {$oPlace->GetPlaceChildrenAll()->Count}
                  {/if}
                </td>
            </tr>
            <tr>
                <td>{$smarty.config.metering_devices|default:"Приборов учета"}</td>
                <td>
                  {if !$oPlace->Id}
                    {assign var=count_m value=0}
                    {foreach from=$oPlace->Children->Elements item=iPlace}
                      {assign var=count_m value=$count_m+$iPlace->GetMetersAll()->Count}
                    {/foreach}
                    {$count_m}
                  {else}
                    {$oPlace->GetMetersAll()->Count}
                  {/if}
                </td>
            </tr>
            {if $oPlace->IsBank}
              <tr>
                  <td>{$smarty.config.bank_book|default:"Номер лицевого счета"}</td>
                  <td>{$smarty.config.empty_bankbook|default:"Не указан"}</td>
              </tr>
              <tr>
                  <td>{$smarty.config.files|default:"Файлы"}</td>
                  <td>
                    {include 
                      file="place/helpers/files_list.tpl" 
                      read=true
                      count_in_row=2}
                  </td>
              </tr>
            {/if}
        </tbody>
    </table>
    </div>
</div>