{assign var=not_require value=1}
{extends file='layout/place.layout.tpl'}
{block name='content'}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">

            <div id="title_view">
              <span id="span_name_interprise">{$Self->Interprise->Title|escape}</span> 
              {if $Self->IsAdmin}
                <button id="edit_main_name" class="btn btx-xs btn-default"><span class="fa fa-pencil"></span></button>
              {/if}
            </div>
            {if $Self->IsAdmin}
              <div class="form-group input-group" style="display: none;" id="title_edit">
                <input type="text" class="form-control" value="{$Self->Interprise->Title|escape}" id="name_interprise">
                <a href="" class="input-group-addon bg-success" id="main_title">
                  <span class="fa fa-save"></span>
                </a>
              </div>
            {/if}

          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li class="active">{$Self->Interprise->Title|escape}</li>
          </ol>
          
      </div>
  </div>
  
  {include file="place/helpers/main_info.tpl"}
  
  
  <script src="/js2/core/jstree.js"></script>
  <script src="/js2/core/sweetalert.js"></script>
  <script src="/js/core/cookie.js"></script>
  <script src="/js/core/ui.js"></script>
  <script>
    var id = {$oPlace->Id};
  </script>

  <script type="text/javascript" src="/js2/place_v2.js"></script>
  <script type="text/javascript" src="/js2/views/place/view_tree.js"></script>
  
  {* Модальное для добавления нового места, редактирования *}
  <script type="text/template" id="place_modal_children_tpl">
    {include file="place/js/modal_children.tpl"}
  </script>
  
  {* Модальное окно удачного действия *}
  <script type="text/template" id="modal_success_tpl">
    {include file="helpers/modal_success.tpl"}
  </script>
  
  {* Модальное окно безуспешного действия *}
  <script type="text/template" id="modal_error_tpl">
    {include file="helpers/modal_error.tpl"}
  </script>
  
  {* Модальное окно удаления места *}
  <script type="text/template" id="modal_delete_tpl">
    {include file="helpers/modal_delete.tpl"}
  </script>
  
  {* Модальное окно показа в виде дерева *}
  <script type="text/template" id="place_modal_tree_tpl">
    {include file="place/js/modal_tree.tpl"}
  </script>

  <script type="text/template" id="list_children_tpl">
    {include file="place/js/list_children.tpl"}
  </script>
  <script type="text/template" id="pagination_children_place_tpl">
    {include file="place/js/children_pagination.tpl"}
  </script>
  
  
  
{/block}