<table class="table table-striped">
  <thead>
    <tr>
      {if $Self->IsAdmin}
        <th class="action"></th>
        <th class="action"></th>
      {/if}
      <th>{$smarty.config.objects_table_field_name|default:"Название"}</th>
      <th>{$smarty.config.objects_table_field_nested_places|default:"Вложенные объекты"}</th>
      <th colspan="3">{$smarty.config.objects_table_field_metering_devices|default:"Приборов учета"}</th>
    </tr>
  </thead>

  <tbody>

    <% _.each( _.sortBy( places, function(o) { return o.get('title'); }) , function( place ){ %>

    <tr id="<%= place.cid %>" data-droped="true">
      {if $Self->IsAdmin}
        <td class="action children_delete">
          {literal}
            <a <% if( place.__is_delete() ){%> href="/place/<%= place.get('id') %>/delete/" <% } %> 
              class="<% if( !place.__is_delete() ){%>text-muted<% } %> fa fa-times " alt="delete"></a>
          {/literal}
        </td>
        <td class="action children_edit">
          <a href="/place/<%= place.get('id') %>/edit/" class="fa fa-pencil " alt="edit"></a>
        </td>
      {/if}
      <td>
        <a href="/place/<%= place.get('id') %>/" class="link_to_place">
          <i class="fa fa-map-marker"></i>
          <span><%= place.escape('title') %></span>
        </a>
      </td>
      <td>
        <i class="{$Site->Config('icon.place')}"></i>
        <span class="counter_places">
          <%= place.get('places') %>
        </span>
      </td>
      <td class="short_add_meter_to_place">
        <i class="{$Site->Config('icon.meter')}"></i>
        <span class="counter_meters">
          <%= place.get('meter_all') %>
        </span>
      </td>
      <td title="{$smarty.config.meters_error|default:'С ошибками'}">
        <i class="text-danger {$Site->Config('icon.meter')}"></i>
        <span>
          <%= place.get('meter_error') %>
        </span>
      </td>
      <td title="{$smarty.config.meters_excluded|default:'Исключенные'}">
        <i class="text-muted {$Site->Config('icon.meter')}"></i>
        <span>
          <%= place.get('meter_excluded') %>
        </span>
      </td>
    </tr>

    <% }) %>

  </tbody>
  <tfoot>
    <tr>
      <td class="action add_child">
        <a href="/place/0/add/" class="fa fa-plus-circle "></a>
      </td>
    </tr>
  </tfoot>
</table>
