{assign var=not_require value=1}
{extends file="layout/place.layout.tpl"}
{block name='content'}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {$smarty.config.place|default:"Объект"} :
            <span class="container_h1_place">{$oPlace->Title|escape}</span>
          </h1>

          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li><a href="/place/">{$Self->Interprise->Title|escape}</a></li>
            {foreach from=$oPlace->ParentAll->Elements item=iPlace}
              <li>
                {include file="place/helpers/block_name.tpl" oPlace=$iPlace}
              </li>
            {/foreach}
            {*<li class="active">{$oPlace->Title|escape}</li>*}
          </ol>

      </div>
  </div>


  {include file="place/helpers/main_info.tpl"}

  <script src="/js2/core/jstree.js"></script>
  <script src="/js2/core/sweetalert.js"></script>
  <script src="/js/core/cookie.js"></script>
  <script src="/js/core/ui.js"></script>
  <script>
    var id = {$oPlace->Id};
  </script>
  <script type="text/javascript" src="/js2/place_v2.js"></script>
  <script type="text/javascript" src="/js2/views/place/view_tree.js"></script>
  
  {* Модальное для добавления нового места, редактирования *}
  <script type="text/template" id="place_modal_children_tpl">
    {include file="place/js/modal_children.tpl"}
  </script>
  
  
  {* Модальное окно удачного действия *}
  <script type="text/template" id="modal_success_tpl">
    {include file="helpers/modal_success.tpl"}
  </script>
  
  {* Модальное окно безуспешного действия *}
  <script type="text/template" id="modal_error_tpl">
    {include file="helpers/modal_error.tpl"}
  </script>
  
  {* Модальное окно удаления места *}
  <script type="text/template" id="modal_delete_tpl">
    {include file="helpers/modal_delete.tpl"}
  </script>
  
  {* Модальное окно показа в виде дерева *}
  <script type="text/template" id="place_modal_tree_tpl">
    {include file="place/js/modal_tree.tpl"}
  </script>

  <script type="text/template" id="list_children_tpl">
    {include file="place/js/list_children.tpl"}
  </script>
  <script type="text/template" id="pagination_children_place_tpl">
    {include file="place/js/children_pagination.tpl"}
  </script>


{/block}
