{extends file="layout/place.layout.tpl"}
{block name='content'}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            
            {$oPlace->ConfigOneTitle} : 
            <span class="container_h1_place">{$oPlace->Title|escape}</span>
            
            <div class="btn-group">
              <a href="{$oPlace->GetLinkTree()}" title="{$Site->Config('ru.place.view_tree')}">
                <button type="button" class="btn btn-default">
                  <span class="fa fa-sitemap"></span>
                </button>
              </a>
            </div>
            
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$Site->Config('ru.sys.main_page')}</a></li>
            <li><a href="/place/">{$Site->Config('ru.place')}</a></li>
            {foreach from=$oPlace->ParentAll->Elements item=iPlace}
              <li>
                {include file="place/helpers/block_name.tpl" oPlace=$iPlace}
              </li>
            {/foreach}
            <li class="active">{$oPlace->Title|escape}</li>
          </ol>
          
      </div>
  </div>
  {include file="place/helpers/info.tpl"}
  
  {if !$oPlace->IsBank}
    {include file="place/helpers/children.tpl"}
  {/if}
  {include file="place/helpers/tabs.tpl" active_tab="export"}
  {include file="place/helpers/import_list.tpl"}
{/block}
