{extends file="layout/place.layout.tpl"}
{block name='content'}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            
            {$smarty.config.places|default:"Объекты"} : 
            <span class="container_h1_place">{$oPlace->Title|escape}</span>
            
            <div class="btn-group">
              <a href="{$oPlace->GetLinkTree()}" title="{$smarty.config.view_to_tree|default:'Посмотреть в виде дерева'}">
                <button type="button" class="btn btn-default">
                  <span class="fa fa-sitemap"></span>
                </button>
              </a>
            </div>
            
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:"Главная"}</a></li>
            <li><a href="/place/">{$smarty.config.places|default:"Объекты"}</a></li>
            {foreach from=$oPlace->ParentAll->Elements item=iPlace}
              <li>
                {include file="place/helpers/block_name.tpl" oPlace=$iPlace}
              </li>
            {/foreach}
            <li class="active">{$oPlace->Title|escape}</li>
          </ol>
          
      </div>
  </div>
  {include file="place/helpers/info.tpl"}
  
  {if !$oPlace->IsBank}
    {include file="place/helpers/children.tpl"}
  {/if}
  {include file="place/helpers/tabs.tpl" active_tab="rule"}
  
    <table class="table table-bordered">
      <thead>
        <tr>
          <th></th>
          <th></th>
          <th>{$smarty.config.rules_user|default:"Пользователь"}</th>
          <th>{$smarty.config.rules_role|default:"Роль"}</th>
        </tr>
      </thead>
      {foreach from=$oPlace->UserLinks->Elements item="iLink"}
        <tr>
          <td class="action">
            <a href="{$iLink->LinkDelete}" class=" fa fa-times"></a>
          </td>
          <td class="action">
            <a href="{$iLink->LinkEdit}" class="fa fa-pencil"></a>
          </td>
          <td>
            {include file="user/helpers/block_name.tpl" oUser=$iLink->User}
          </td>
          <td>
            {include file="rule/helpers/block_name.tpl" oRule=$iLink->Rule}
          </td>
        </tr>
      {/foreach}
    </table>
  
{/block}
