<?php
  
  ini_set('memory_limit', Site()->Config('memmory_reports' , 1024) . 'M');

  
  $ViewPageIsset = 9999999999999;
  $ThisPage = 1;
  
  $GLOBALS['Report'] = true;
  $GLOBALS['IsNumberFormat'] = false;

  require_once( $_SERVER['DOCUMENT_ROOT'].'/include/PHPExcel.php' );
  

  $cacheSettings = array( 'memoryCacheSize' => "1024M");

  
  PHPExcel_Settings::setCacheStorageMethod(PHPExcel_CachedObjectStorageFactory::cache_to_phpTemp,$cacheSettings);

  $objPHPExcel = new PHPExcel();
	
	$Worksheet = $objPHPExcel->getActiveSheet();
	$WorksheetLine = 1;
	$ColumnNum = 0;
	
	$Size = array(
	  ( 12 * 1.3),
	  ( 10 * 1.3),
	  ( 8  * 1.3),
	  ( 18 * 1.3),
	);
	
	$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('location') );
  
  foreach($parameters->Elements as $iParam){
		$Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $iParam->Title );
		$Size[] = strlen($iParam->Title);
	}
	$WorksheetLine++;
  



///////// BODY ////////////////
  
  
  $constSTRING = PHPExcel_Cell_DataType::TYPE_STRING;
  
  foreach( $Places->Elements as $iMeter){
    $ColumnNum = 0;
    $Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, $iMeter->GetBreadcrumbsParentToThisReports().$iMeter->Title , $constSTRING );

    foreach( $parameters->Elements as $iParameter ){
      $MDH = $iMeter->GetMDHGroupByParameterRangeDate($iParameter,$start_date,$stop_date);
      
      smarty()->assign('oMDH' , $MDH);
      smarty()->assign('usingCoef' , false);
      $value = trim( smarty()->fetch('meterdatahour/helpers/report_full.tpl') );
      
      $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $value );
      $Groups[ $iParameter->Id ] = $Groups[ $iParameter->Id ] + $value;
    }
    $WorksheetLine++;
  }

  
  $ColumnNum = 0;
  $Worksheet->setCellValueExplicitByColumnAndRow( $ColumnNum++, $WorksheetLine, smarty()->get_config_vars('sum') , $constSTRING );
  foreach( $parameters->Elements as $iParameter){
    $Worksheet->setCellValueByColumnAndRow( $ColumnNum++, $WorksheetLine, $Groups[ $iParameter->Id ] );
  }
  
  
  
  ////////// FOOTER //////////////
  
  
  
  
  
  
  
  $objPHPExcel->getDefaultStyle()->getBorders()->getTop()   ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getBorders()->getBottom()->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getBorders()->getLeft()  ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getBorders()->getRight() ->setBorderStyle( PHPExcel_Style_Border::BORDER_MEDIUM );
	$objPHPExcel->getDefaultStyle()->getFont()->setName( 'Arial' );
	$objPHPExcel->getDefaultStyle()->getFont()->setSize( 8 ); 
	
	foreach (range('A', 'Z') as $char) {
      $objPHPExcel->getActiveSheet()->getColumnDimension($char)->setAutoSize(true);
  }
  
  foreach (range('A', 'Z') as $char) {
    foreach (range('A', 'Z') as $char2) {
        $objPHPExcel->getActiveSheet()->getColumnDimension($char.$char2)->setAutoSize(true);
    }
  }
	@header( 'Expires: Mon, 26 Jul 1997 05:00:00 GMT' );
  @header( 'Last-Modified: '.gmdate('D, d M Y H:i:s').' GMT' );
  @header( "Cache-Control: no-store, no-cache, must-revalidate" );
  @header( 'Pragma: public' );
  $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel5' );
  
  $objWriter->save('php://output');