<div id="app"></div>
{if $user_lang eq 'en'}
	{config_load file="en_lang.conf" section="Rsconfig"}
{else}
  {config_load file="ru_lang.conf" section="Rsconfig"}
{/if}
<script type="text/template" id="counter">

  <% if( model.get_issues_run_w() ){ %>
  <div class="progress">
    <div class="progress-bar" role="progressbar" aria-valuenow="70"
    aria-valuemin="0" aria-valuemax="100" style="width:<%= 100/model.get('issues').length*model.get('issues').where({ status : "SUCCESS" }).length %>%">
      <span class="sr-only"><%= 100/model.get('issues').length*model.get('issues').where({ status : "SUCCESS" }).length %>% Complete</span>
    </div>
  </div>
  <% } %>
  
  <% if( model.get('is_edit') ){ %>

  <div class="wrapper">
    <p class="h2 page-header">
      {$smarty.config.rsconfig_header|default:"Страница конфигурации импульсных входов SNR-RScounter-8I"}
    </p>
          <div class="form-group">
      <label for="ip" class="control-label">{$smarty.config.ip|default:"Ip адрес"}: *</label>
      <input id="ip" value="<%= model.get('ip') %>" class="form-control" placeholder="127.0.0.1">
    </div>
      <div class="form-group">
      <label for="port" class="control-label">{$smarty.config.port|default:"Порт"}: *</label>
      <input id="port" value="<%= model.get('port') %>" class="form-control" placeholder="50">
    </div>
      <div class="form-group">
      <label for="mac" class="control-label">{$smarty.config.mac|default:"Mac(hex)"}: *</label>
      <input id="mac" value="<%= model.get('mac') %>" class="form-control" placeholder="01:02:03:04:05:06:07:08:09:FF"/>
      <span class="small text-muted">{$smarty.config.example|default:"Пример"}: 01:02:03:04:05:06:07:08:09:FF</span>
    </div>
      <div class="form-group">
      <label for="pass" class="control-label">{$smarty.config.password|default:"Пароль"}: *</label>
      <input id="pass" value="<%= model.get('pass') %>" class="form-control" placeholder="01:02:03:04:05:06:07:08:09:FF"/>
      <span class="small text-muted">{$smarty.config.example|default:"Пример"}: 01:02:03:04:05:06:07:08:09:FF</span>
    </div>  
    <button id="send" class="btn btn-disabled">{$smarty.config.continue_button|default:"Продолжить"}</button>
  </div>
  
  <% }else{ %>
          
    <% _.each( model.get('log').where({ type : "main" }) , function( log ){ %>
        <div class="alert alert-danger"><%= log.get('msg') %></div>
     <% }) %>
  
    <div class="row">
      <div class="col-lg-6">
      <br>
      <div id="parameters" style="display: block;">

        <div class="panel panel-default">
          <div class="panel-heading">
            {$smarty.config.device_info|default:"Информация о устройстве"}
          </div>
          <div class="panel-body">
            <table class="table table-responsive">
              <tbody>
                <tr>
                  <td>{$smarty.config.ip|default:"Ip адрес"}</td>
                  <td><%= model.get('ip') %></td>
                </tr>
                <tr>
                  <td>{$smarty.config.port|default:"Порт"}</td>
                  <td><%= model.get('port') %></td>
                </tr>
                <tr>
                  <td>{$smarty.config.mac|default:"Mac(hex)"}:</td>
                  <td><%= model.get('mac') %></td>
                </tr>
                <tr>
                  <td>{$smarty.config.password|default:"Пароль"}:</td>
                  <td><%= model.get('pass') %></td>
                </tr>
              </tbody>
            </table>
          </div>
          <div class="panel-footer">
            <button id="edit" class="btn btn-info" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>{$smarty.config.change_button|default:"Изменить"}</button>
            <button id="reset_value" class="btn btn-info" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>{$smarty.config.refresh_button|default:"Обновить"}</button>
          </div>
        </div>

      </div>
      
    </div>
        <div class="col-lg-6">
        <br>
          <div class="panel panel-default">
            <div class="panel-heading">
            {$smarty.config.device_properties|default:"Свойства устройства"}
            </div>
            <div class="panel-body">
              <table class="table table-responsive">
                <tbody>
                  <tr>
                    <td>{$smarty.config.device_id|default:"Идентификатор устройства"}</td>
                    <td id="ident_res">
                      <%= model.get('ident') %>
                      </td>
                  </tr>
                  <tr>
                    <td>{$smarty.config.firmware_version|default:"Версия прошивки"}</td>
                    <td id="version">
                      <%= model.get('version') %>
                    </td>
                  </tr>
                  <tr>
                    <td>{$smarty.config.server_time|default:"Время на сервере"}</td>
                    <td id="server_time">
                      <%= model.get('time_server') %>
                    </td>
                  </tr>
                  <tr>
                    <td>{$smarty.config.device_time|default:"Время на устройстве"}</td>
                    <td id="device_time">
                      <%= model.get('time_device') %>
                    </td>
                  </tr>
                </tbody>
              </table>
          </div>
          <div class="panel-footer">
            <button id="set_pass" class="btn btn-primary" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>{$smarty.config.set_password_button|default:"Установить Пароль"}</button> 
              <button id="set_time" class="btn btn-primary" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>{$smarty.config.set_time_button|default:"Установка времени"}</button>
          </div>
        </div>

        </div>
      </div>
      
      <div class="row">
        <div class="col-lg-12">

          <div class="panel panel-default">
            <div class="panel-heading">
              {$smarty.config.editing_properties|default:"Редактирование параметров"}
              <div class="pull-right">
                <button class="btn btn-xs btn-info" id="advanced_mode" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>
                  <% if( !model.get('advanced_mode') ){ %>
                          {$smarty.config.advanced_mode_button|default:"Расширенный режим"}
                  <% }else{ %>
                          {$smarty.config.hide_advanced_mode_button|default:"Убрать расширенный режим"}
                  <% } %>
                  </button>
              </div>
            </div>
            <div class="panel-body  table-responsive">
              <table id="coefs_block" class="table">
              <thead>
                <tr>
                <td class="h"></td>
                <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                  <th class="h edit_chan" data-chanel="<%= chanel.cid %>">
                    <% if( chanel.is_error() ) { %>
                            {$smarty.config.table_error|default:"Ошибка"}
                    <% }else if( chanel.is_waiting() ){ %>
                            {$smarty.config.table_await|default:"Ожидает"}
                    <% }else if( chanel.is_running() ){ %>
                            {$smarty.config.table_working|default:"Выполняется"}
                    <% }else{ %>
                      <button class="btn btn-xs" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>Изменить</button>
                    <% } %>
                  </th>
                <% }) %>
                </tr>
                <tr>
                <td></td>
                <% _.each( model.get('chanels').toArray() , function( chanel , i ){ %>
                  <td>
                    DI<%= i+1 %>
                  </td>
                <% }) %>
                </tr>
              </thead>
              <tbody>
                <!-- <tr>
                  <td>
                    Показания прибора на момент фиксации срезов
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td data-chanel="<%= chanel.cid %>">
                      <% if( chanel.get('data_counter') ){ %> <%= chanel.get('data_counter') %> <% } %>
                    </td>
                  <% }) %>
                </tr> -->
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    {$smarty.config.rising_edge_slice|default:"Срезы в импульсах"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_section_imp">
                      <%= chanel.get('section_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.cuts|default:"Срезы"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_section_user_v">
                      <%= chanel.get('section_user_v') %>
                    </td>
                  <% }) %>
                </tr>
                <tr>
                  <td>
                    {$smarty.config.pulse_multiplier|default:"Множитель импульса"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td data-chanel="<%= chanel.cid %>">
                      <%= chanel.get('math') %>
                    </td>
                  <% }) %>
                </tr>
                <tr>
                  <td>
                    {$smarty.config.pulse_divider|default:"Делитель импульса"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td data-chanel="<%= chanel.cid %>">
                      <%= chanel.get('divider') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.device_delta|default:"Дельта с прибора"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_delta_imp">
                      <%= chanel.get('delta_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.pulse_value|default:"Цена импульса"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_price_imp">
                      <%= chanel.get('price_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr>
                  <td >
                    {$smarty.config.current_readings|default:"Текущие показания"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td id="t_cid<%= chanel.cid %>_value_now">
                      <%= chanel.get('value_now') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.custom_delta_values|default:"Дельта в пользовательских величинах"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_delta_user_v">
                      <%= chanel.get('delta_user_v') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.pulse_delta|default:"Дельта в импульсах"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active" id="t_cid<%= chanel.cid %>_delta_imp">
                      <%= chanel.get('delta_imp') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    {$smarty.config.must_be|default:"Должно быть"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active"   id="t_cid<%= chanel.cid %>_res_user_v">
                      <%= chanel.get('res_user_v') %>
                    </td>
                  <% }) %>
                </tr>
                <tr <% if( !model.get('advanced_mode') ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.must_be_pulses|default:"Должно быть в импульсах"}
                  </td>
                  <% _.each( model.get('chanels').toArray() , function( chanel ){ %>
                    <td class="active"  id="t_cid<%= chanel.cid %>_res_imp">
                      <%= chanel.get('res_imp') %>
                    </td>
                  <% }) %>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
        </div>
      </div>
      <div class="container_debug">
        <button class="btn btn-default" id="view_log" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>{$smarty.config.show_log_button|default:"Показать лог"}</button>
        <button class="btn btn-default" id="clear_log" <% if( model.get_issues_run_w() ){ %>disabled<% } %>>{$smarty.config.clear_log_button|default:"Очистить лог"}</button>
      </div>
      <% if( model.get('is_view_log') ){ %>
        <div id="debug" class="panel-body">
          <% _.each( model.get('log')._sort_by_issues() , function( log_group ){ %>
            <% var log_last = log_group[log_group.length-1]; %>
            <b><%= log_last.get("reason") %> <%= log_last.get("chanel") %></b><br>
            <% _.each( log_group , function( log ){ %>
              <% if( log.get("is_in") === true ){ %>
                <i class="date">&gt;&gt; <%= log_last.get("time") %></i>
              <% }else if( log.get("is_in") === false ){ %>
                <i class="date">&lt;&lt; <%= log_last.get("time") %></i>
              <% } %>
              <%= log.get("msg") %><br>
            <% }) %>
            <hr>
          <% }) %>
        </div>
      <% } %>
  <% } %>
  
</script>
          
          
<script type="text/template" id="modal_pass_tpl">
  <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          <h4 class="modal-title" id="myModalLabel">
            {$smarty.config.set_password_modal_head|default:"Установка пароля"}
          </h4>
        </div>
        <div class="modal-body">
          <div class="form-group">
            <label for="pwd">{$smarty.config.set_password_modal_new_pass|default:"Новый пароль (HEX)"}:</label>
            <input class="form-control" id="new_pass" placeholder="01:02:03:04:05:06:07:08:09:FF" value="<%= counter.get('pass') %>">
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">{$smarty.config.modal_save_button|default:"Закрыть"}</button>
          <button type="button" class="btn btn-primary" id="save_new_pass">{$smarty.config.modal_close_button|default:"Сохранить"}</button>
        </div>
      </div>
    </div>
  </div>
</script>

          
          
<script type="text/template" id="set_date_tpl">
  <div class="modal fade" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
    <div class="modal-dialog" role="document">
      <div class="modal-content">
        <div class="modal-header">
          <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
          <h4 class="modal-title" id="myModalLabel">
          {$smarty.config.set_time_modal_head|default:"Установка времени"}
          </h4>
        </div>
        <div class="modal-body">
          <div class="form-group">
            <label for="pwd">{$smarty.config.set_time_modal_date|default:"Дата"}:</label>
            <input class="form-control" type="date" value="<%= date %>" id="input_date"/>
          </div>
          <div class="form-group">
            <label for="pwd">{$smarty.config.set_time_modal_time|default:"Время"}:</label>
            <input class="form-control" type="time" value="<%= time %>" id="input_time"/>
          </div>
        </div>
        <div class="modal-footer">
          <button type="button" class="btn btn-default" data-dismiss="modal">{$smarty.config.modal_save_button|default:"Закрыть"}</button>
          <button type="button" class="btn btn-primary" id="save_new_date">{$smarty.config.modal_close_button|default:"Сохранить"}</button>
        </div>
      </div>
    </div>
  </div>
</script>


<script type="text/template" id="modal_tpl">
      <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel">
        <div class="modal-dialog" role="document">
          <div class="modal-content">
            <div class="modal-header">
              <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
              <h4 class="modal-title" id="myModalLabel">
                  
                  {$smarty.config.modal_channel_head|default:"Канал"} : <%= chanel.collection.indexOf(chanel)+1 %>

              </h4>
            </div>
            <div class="modal-body">
              
                <table id="coefs_block" class="table table-responsive">
              <tbody>
                <tr>
                  <td>
                    {$smarty.config.modal_channel_device_readings|default:"Показания прибора на момент фиксации срезов"} *
                  </td>
                    <td data-chanel="<%= chanel.cid %>">
                      <input type="text" class="data_counter form-control" value="<%= chanel.get('data_counter') %>" 
                      <% if( chanel.get('math') === null ){ %>disabled<% } %>/>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    {$smarty.config.rising_edge_slice|default:"Срезы в импульсах"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_section_imp">
                      <%= chanel.get('section_imp') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.cuts|default:"Срезы"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_section_user_v">
                      <%= chanel.get('section_user_v') %>
                    </td>
                </tr>
                <tr>
                  <td>
                    {$smarty.config.pulse_multiplier|default:"Множитель импульса"} *
                  </td>
                    <td data-chanel="<%= chanel.cid %>">
                      <input type="text" class="math form-control" value="<%= chanel.get('math') %>" 
                      <% if( chanel.get('math') === null ){ %>disabled<% } %>/>
                    </td>
                </tr>
                <tr>
                  <td>
                    {$smarty.config.pulse_divider|default:"Делитель импульса"} *
                  </td>
                    <td data-chanel="<%= chanel.cid %>">
                      <input type="text" class="divider form-control" value="<%= chanel.get('divider') %>" 
                      <% if( chanel.get('math') === null ){ %>disabled<% } %>/>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.device_delta|default:"Дельта с прибора"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_delta_counter">
                      <%= chanel.get('delta_counter') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.pulse_value|default:"Цена импульса"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_price_imp">
                      <%= chanel.get('price_imp') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.current_readings|default:"Текущие показания"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_value_now">
                      <%= chanel.get('value_now') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.custom_delta_values|default:"Дельта в пользовательских величинах"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_delta_user_v">
                      <%= chanel.get('delta_user_v') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                    {$smarty.config.pulse_delta|default:"Дельта в импульсах"}
                  </td>
                    <td class="active" id="cid<%= chanel.cid %>_delta_imp">
                      <%= chanel.get('delta_imp') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active">
                    {$smarty.config.must_be|default:"Должно быть"}
                  </td>
                    <td class="active"   id="cid<%= chanel.cid %>_res_user_v">
                      <%= chanel.get('res_user_v') %>
                    </td>
                </tr>
                <tr <% if( !advanced_mode ){ %>style="display: none;"<% } %>>
                  <td class="active" >
                  {$smarty.config.must_be_pulses|default:"Должно быть в импульсах"}
                  </td>
                    <td class="active"  id="cid<%= chanel.cid %>_res_imp">
                      <%= chanel.get('res_imp') %>
                    </td>
                </tr>
              </tbody>
            </table>




            </div>
            <div class="modal-footer">
              <button type="button" class="btn btn-default" data-dismiss="modal">{$smarty.config.modal_save_button|default:"Закрыть"}</button>
              <button type="button" class="btn btn-primary" id="save">{$smarty.config.modal_close_button|default:"Сохранить"}</button>
            </div>
          </div>
        </div>
      </div>
    </script>


{literal}
<style>
    i.date {
    font-size: x-small;
    color: grey;
    
}
</style>
{/literal}