<h3>Пользователи</h3>
<table class="table table-striped table-bordered table-hover" id="list_user_in_rule">
  {if $oRule->Users->Count}
    <thead>
      <tr>
        <th class="action"></th>
        <th>Название</th>
      </tr>
    </thead>
  {/if}
  {foreach from=$oRule->Users->Elements item="iLink"}
    <tr>
      <td class="action">
        <a href="{$iLink->LinkDelete}"  class="fa fa-times"></a>
      </td>
      <td>
        {include file="user/helpers/block_name.tpl" oUser=$iLink->User}
      </td>
    </tr>
  {foreachelse}
    <tr>
      <td>
        Нет ни одного пользователя
      </td>
    </tr>
  {/foreach}
  <tr>
    <td class="action" id="append_user">
      <a href="{$oRule->LinkAddUser}">
        {include file="helpers/add_icon_table.tpl"}
      </a>
    </td>
  </tr>
</table>
</div>
<div class="col-lg-6 table-responsive">
<h3>Группы</h3>
<table class="table table-striped table-bordered table-hover">
  {if $oRule->Group->Count}
    <thead>
      <tr>
        <th class="action"></th>
        <th>Название</th>
      </tr>
    </thead>
  {/if}
  {foreach from=$oRule->Group->Elements item="iLink"}
    <tr>
      <td class="action">
        <a href="{$iLink->LinkDelete}"  class="fa fa-times"></a>
      </td>
      <td>
        {include file="group/helpers/block_name.tpl" oUser=$iLink->User}
      </td>
    </tr>
  {foreachelse}
    <tr>
      <td>
        Нет ни одной группы 
      </td>
    </tr>
  {/foreach}
  <tr>
    <td class="action">
      <a href="{$oRule->LinkAddGroup}">
        {include file="helpers/add_icon_table.tpl"}
      </a>
    </td>
  </tr>
</table>

      
      <script id="modal_user_list_tpl" type="text/template">
          <div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel" aria-hidden="true">
            <div class="modal-dialog">
                <div class="modal-content">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                        <h4 class="modal-title" id="myModalLabel">
                        </h4>
                    </div>
                    <div class="modal-body">

                      <div class="list-group">
                          <% _.each( users , function( user ){ %>
                                  <a href="#" class="list-group-item<% if( user.is_isset_in_rule( rule ) ){ %> active<% } %>">
                                      <i class="fa {$Site->Config('icon.user')} fa-fw"></i> <%= user.escape('title') %>
                                  </a>
                          <% }) %>
                      </div>

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-default" data-dismiss="modal">
                        {$Site->Config('ru.sys.close')}
                        </button>
                        <button type="button" class="btn btn-success" id="save_rule">
                        </button>
                    </div>
                </div>
                <!-- /.modal-content -->
            </div>
            <!-- /.modal-dialog -->
        </div>
      </script>