{extends file="layout/meter.layout.tpl"}
{block name="content"}

  <h1 class="page-header">Задания системы</h1>
  
  <table class="table">
    
    <thead>
      <tr>
        <th class="action"></th>
        <th>Название</th>
        <th>Час</th>
        <th>Мин</th>
        <th>След. запуск</th>
        <th>Лог</th>
        <th>Включено</th>
        <th>Заблкировано</th>
        <th>Заданий ожидает</th>
        <th></th>
      </tr>
    </thead>
    
    {foreach from=$Site->Crontask->Elements item=iTask}
      <tr {if $iTask->IsLocked}class="danger"{/if}>
        <td>
          <i class="fa fa-pencil"></i>
        </td>
        <td>
          {$iTask->Title}
        </td>
        <td>
          {$iTask->Hour}
        </td>
        <td>
          {$iTask->Minute}
        </td>
        <td>
          {$iTask->NextRun|date_format:"%Y-%m-%d %H:%M:%S"}
        </td>
        <td>
          {if $iTask->IsLocked}Да{else}Нет{/if}
        </td>
        <td>
          {if $iTask->IsEnabled}Да{else}Нет{/if}
        </td>
        <td>
          {if $iTask->IsLocked}Да{else}Нет{/if}
        </td>
        <td>
          {$iTask->TaskWaiting}
        </td>
        <td>
          <a href="{$iTask->Id}/">
            <button class="btn btn-info btn-xs">Лог</button>
          </a>
        </td>
      </tr>
    {/foreach}
  </table>


{/block}
