{extends file="layout/vconverter.layout.tpl"}
{block name="content"}
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {include file="vconverter/helpers/block_name.tpl"}
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$Site->Config('ru.sys.main_page')}</a></li>
            <li><a href="/vconverter/">{$smarty.config.vconverters|default:"Виртуальные узлы учета"}</a></li>
            <li>
              <a href="{$oConverter->Link}">
                {include file="vconverter/helpers/block_name.tpl"}
              </a>
            </li>
            <li class="active">{$smarty.config.modal_delete|default:"Удаление"}</li>
          </ol>
          
      </div>
      <!-- /.col-lg-12 -->
  </div>
  
  <div class="row">
      <div class="col-lg-12">
        <h3 class="text-danger">{$smarty.config.modal_delete_msg|default:"Вы действительно хотите удалить"} {$oConverter->Title|escape}?</h3>
        
        <form method="post">
          <button type="button" class="btn btn-default">
            <a href="{$oConverter->Link}">{$Site->Config('ru.sys.no')}</a>
          </button>
          <button type="submit" name="droped" value="{$oConverter->Id}" class="btn btn-danger">{$smarty.config.modal_delete_button|default:"Удалить"}</button>
        </form>
      </div>
    </div>
  
{/block}