{extends file="layout/vconverter.layout.tpl"}
{block name="content"}
  
  
  {*
  
      Если пользователь обозначил какой то прибор учета то это редактирование
      Если нет то это добавление
      
  *}
  
  
  <div class="row">
      <div class="col-lg-12">
          <h1 class="page-header">
            {if isset( $oMeter )}
              Редактирование <a href="{$oMeter->Link}">{$oMeter->Title|escape}</a>
            {elseif isset($oConverter)}
              {$smarty.config.add_meter_into|default:"Добавление прибора учета в"} <a href="{$oConverter->Link}">{$oConverter->Title|escape}</a>
            {/if}
          </h1>
          
          <ol class="breadcrumb">
            <li><a href="/">{$smarty.config.breadcrumbs_main|default:'Главная'}</a></li>
            {if isset($oConverter)}
              <li><a href="/converter/">{$smarty.config.converters|default:'Узлы учета'}</a></li>
              <li>
                {include file="converter/helpers/block_name.tpl" oConverter=$oConverter}
              </li>
            {elseif isset($oMeter)}
              <li><a href="{$oMeter->Converter->Link}">{$oMeter->Converter->Title|escape}</a></li>
            {/if}
            <li class="active">
              {if isset( $oMeter )}
                {$smarty.config.modal_header_edit|default:'Редактирование'} {$oMeter->Title|escape}
              {else}
                {$smarty.config.add_meter|default:'Добавление прибора учета'}
              {/if}
            </li>
          </ol>
          
      </div>
  </div>
  
  
  <div class="row">
    <div class="col-lg-12">
      {include file="vmeter/helpers/form_edit_add.tpl"}
    </div>
</div>
{/block}


