<div class="panel panel-default" id="meterparameter_list">
    <div class="panel-heading">
        {$Site->Config('ru.parameter')}
    </div>
    <div class="panel-body">
      <div class="table-responsive" id="meterparameter_table">
        
        {if $oMeter->MeterParameter->Count}
        
        <table class="table table-striped table-hover">
          <thead>
            <tr>
              {if $Self->IsAdmin}
              <td class="action"></td>
              <td class="action"></td>
              {/if}
              <td>{$Site->Config('ru.meterparameter.meter')}</td>
              <td>{$Site->Config('ru.meterparameter.parameter')}</td>
              <td>{$Site->Config('ru.meterparameter.virtparameter')}</td>
              <td>{$Site->Config('ru.parameter.conversion')}</td>
            </tr>
          </thead>
          <tbody>
            {foreach from=$oMeter->MeterParameter->Elements item=iMeterParameter}

            {*assign var=isClone value=$oMeter->FindCloneMeterparameter($iMeterParameter)*}
            {assign var=isClone value=false}
          
            <tr 
              id="meterparameter_{$iMeterParameter->Id}" 
              class="{if $isClone || !$iMeterParameter->Virtualparameter->Is}Clone{/if}">
              {if $Self->IsAdmin}
              <td class="action converter_delete_item">
                <a href="" class="fa fa-times" alt="edit"></a>
              </td>
              <td class="action converter_edit_item">
                <a href="" class="fa fa-pencil" alt="delete"></a>
              </td>
              {/if}
              <td>
                {include file="meter/helpers/block_name.tpl" oMeter=$iMeterParameter->Meter}
              </td>
              <td>
                {include file="parameter/helpers/block_name.tpl" oParameter=$iMeterParameter->Parameter}
              <td>
                {include file="parameter/helpers/block_name.tpl" oParameter=$iMeterParameter->Virtualparameter}
              </td>
              <td>
                {include file="conversion/helpers/block_name.tpl" oConversion=$iMeterParameter->Virtualparameter->Conversion}
              </td>
              {if $isClone}
                <td><b>Дубликат! <span style="cursor:help;" title="У вас есть точно такой же параметр.
    Измените представление параметра.">[?]</span></b></td>
              {/if}
              {if !$iMeterParameter->Virtualparameter->Is}
                <td><b>Ошибка! <span style="cursor:help;" title="Не выбрано представление параметра">[?]</span></b></td>
              {/if}
            </tr>
          {foreachelse}
            <tr>
              <td colspan="100">{$Site->Config('ru.meterparameter.null')}</td>
            </tr>
          {/foreach}
          <tbody>
      
        </table>
        
        {else}
          
          {include 
              file="alerts/warning.tpl" 
              msg=$Site->Config('ru.meter.parameter_null','Нет ни одного параметра')
          }
        
        {/if}
        
      </div>
      
    </div>
    {if $Self->IsAdmin}
    <div class="panel-footer">
        <button class="btn btn-success" id="block_add_meterparameter">{$Site->Config('ru.sys.add')}</button>
    </div>
    {/if}
</div>
